#pragma TextEncoding = "Windows-1252"
#pragma rtGlobals=3		// Use modern global access method.
//#pragma version=1.17d// decided to not use pragma but a string constant 

// HROrgCheck Panel Functions for High ToF-AMS analysis Toolkit
// Peak Integration by Key Analysis (PIKA)
//Copyright (C) 2005, 2006, 2007,2008, 2009,2010,2011, 2012, 2013, 2014, 2015, 2016, 2017
// Pete DeCarlo, Allison Aiken, Jose Jimenez, Donna Sueper University of Colorado
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
		//1.20C
STRCONSTANT HR_FRAGCO2AIR = "0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]"  //1.20C
STRCONSTANT UMR_FRAGCO2AIR = "0.00037*1.36*1.28*1.14*frag_air[28]"      //1.20C

///////////////////////////////////////////////////////////////////////////////
// CURRENT STATUS
// see HR read me file for details.

Function HROrgCheck_globals()

	NewDataFolder/o root:elementalAnalysis
	string/g root:elementalAnalysis:EAformulaStr="H/C = (H/C^)*(1.07 + 1.07*fCHO)\rO/C = (O/C^)*(1.26 - 0.63*fCO2 + 2.28*fCHO)\rX/C^ are ratios calculated from the Aiken et al formulation."
//	sq_initializeGlobalNVar(" root:ElementalAnalysis:DLscalar",  1)
	sq_initializeGlobalNVar("root:ElementalAnalysis:smoothingVal",  0)		//1.19 E
	sq_initializeGlobalNVar("root:ElementalAnalysis:IA_AA_correlation",  1)

	sq_initializeGlobalNVar("root:ElementalAnalysis:ShowCO2Tables",  0)
	sq_initializeGlobalNVar("root:ElementalAnalysis:Showj15NNTables",  0)

	HR_FD_Check_batchHROrgCheck()
 
 End


//1.15O
Function HROrgCheck_Panel_make(ctrlName) : ButtonControl
	String ctrlName

	sq_GetIndexNotDoneYet()
	DoWindow/F HROrgCheck_Panel
	if (V_flag)
		strswitch(ctrlName)
			case "HRTodoFit_butt_Tj15NN":
				HROrgCheck_TabProc("HROrgCheckTab",0)
				TabControl HRCheckTab,value= 0
				break
			case "HRResultsD_HROrgCheckPanel":
				HROrgCheck_TabProc("HROrgCheckTab",1)
				TabControl HRCheckTab,value= 1
				break
			case "HRResultsE_HROrgCheckPanel":
				HROrgCheck_TabProc("HROrgCheckTab",2)
				TabControl HRCheckTab,value= 2
			break
		endswitch
		return 0
	endif
	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
 	HROrgCheck_globals()
 
	svar sq_toDoWvNm= root:panel:sq_toDoWvNm

	PauseUpdate; Silent 1		// building window...
	NewPanel/N=HROrgCheck_Panel /W=(476,105,977,783) as "HROrgCheck_Panel"
	ModifyPanel fixedSize=1		//1.57L
	SetDrawLayer UserBack
	SetDrawEnv fsize= 16,fstyle= 1
	DrawText 7,21,"HROrg Check v"+PKVERSION
	TabControl HRCheckTab,pos={5,30},size={490,645},proc=HROrgCheck_TabProc
	TabControl HRCheckTab,tabLabel(0)="j15NN, CHO Determination"
	TabControl HRCheckTab,tabLabel(1)="HROrgCO2 frag"
	TabControl HRCheckTab,tabLabel(2)="Improved Ambient Elem. Anal.",value=0
	Button HRCheck_gotopika,pos={389,4},size={100,20},fsize=10,proc=HROrgCheck_GoToPika,title="Go to pika panel"
	PopupMenu HRCheck_todolist_pop,pos={210,4},size={168,21},bodyWidth=140,proc=sq_pop_toDoList,title="Todo"
	PopupMenu HRCheck_todolist_pop,fSize=10
	PopupMenu HRCheck_todolist_pop,mode=13,popvalue=sq_toDoWvNm,value= #"root:panel:sq_toDoList+\"Get List;\"\t"

	CheckBox j15NN_checkUMR,pos={13,125},size={43,14},disable=1,proc=HROrgCheck_UMRorHRj15NN,title="UMR"
	CheckBox j15NN_checkUMR,value= 1,mode=1
	CheckBox j15NN_checkHR,pos={62,125},size={34,14},disable=1,proc=HROrgCheck_UMRorHRj15NN,title="HR"
	CheckBox j15NN_checkHR,value= 0,mode=1
	CheckBox j15NNx_showDetails,pos={14,391},size={50,14},fsize=10,disable=1,proc=PK_ShowDetails_j15NNcheck,title="Details"
	CheckBox j15NNx_showDetails,variable=root:elementalAnalysis:Showj15NNTables

	SetVariable j15NNscalar_setvar,pos={33,163},size={134,16},bodyWidth=50,proc=HROrgCheck_j15NNSetVar,title="frag_air[29] = "
	SetVariable j15NNscalar_setvar,fStyle=1,limits={0,100,0.01},value= _NUM:1
	Button j15NN_Calc,pos={104,124},size={300,20},disable=1,proc=HROrgCheck_calcj15NNCheck,title="Step 0. Calc. Org29 and Org43 for current todo"
	Button j15NN_Calc,fColor=(65280,43520,0)

	Button j15NN_Revert,pos={351,160},size={140,20},fsize=10,proc=HROrgCheck_j15NNRevert_butt,title="Revert to previous value"
	Button j15NN_declare,pos={10,183},size={380,20},proc=HROrgCheck_j15NNSetIsotope,title="Step 2. Declare isotope value for j15NN in HR and frag_air[29] in UMR"
	Button j15NN_declare,fColor=(65280,43520,0)
	Button j15NN_Step2_UMR,pos={75,501},size={320,20},fsize=10,proc=HROrgCheck_j15NNStep2,title="Declare value for frag_air29 in UMR table (Step 2 only for UMR)"
	Button j15NN_Step2_HR,pos={75,391},size={320,20},fsize=10,proc=HROrgCheck_j15NNStep2,title="Declare value for j15NN in HR table (Step 2 only for HR)"
	Button j15NN_gotopikaFitGraph,pos={415,125},size={70,20},fsize=10,proc=HR_butt_ShowPkHtsGr,title="Pika fitting gr"
	Button j15NNx_pk_Org29_v_Org43Graph,pos={416,181},size={70,20},fsize=10,proc=sq_butt_popThis,title="Pop Graph"
	Button j15NNx_PK_j15NNAllMassesTable,pos={396,391},size={90,20},proc=sq_butt_popThis,title="Pop HR Table"
	Button j15NNx_pk_j15NNUMRFragTable,pos={396,501},size={90,20},proc=sq_butt_popThis,title="Pop UMR Table"
	TitleBox j15NN_step1a,pos={58,145},size={430,13},fsize=10,title="Adjust the j15NN scalar to get data clustering the orign (filters) or fit intercept near the origin."
	TitleBox j15NN_step1a,frame=0
	TitleBox j15NN_title1,pos={15,57},size={428,16},title="Determine CHO abundance by by modifying j15NN abundance"
	TitleBox j15NN_title1,fSize=12,fstyle=1,frame=0
	TitleBox j15NN_step1Title,pos={14,145},size={41,13},title="Step 1.",frame=0
	TitleBox j15NN_step1Title,fStyle=1
	TitleBox j15NN_step3Title,pos={10,610},size={419,13},title="Step 3. Perform HR fits using this j15NN isotopic abundance (Pika step 5)"
	TitleBox j15NN_step3Title,fSize=10,frame=0,fStyle=1
	TitleBox j15NN_step1b1,pos={10,72},size={402,13},fsize=10,title="CHO and j15NN are <0.001 m/z apart.These ions are resolved by constraining j15NN by N2; remaining"
	TitleBox j15NN_step1b1,frame=0
	TitleBox j15NN_step1b2,pos={10,88},size={362,13},fsize=10,title="signal at this peak is fit to CHO. Use filters or low Org periods to adjust the isotopic scalar to"
	TitleBox j15NN_step1b2,frame=0
	TitleBox j15NN_step1b3,pos={10,105},size={400,13},fsize=10,title="get Org29 = 0 at these periods. Use the UMR option if HR data has not been fit; else use HR."
	TitleBox j15NN_step1b3,frame=0
	TitleBox j15NN_step1bScalar,pos={172,164},size={135,13},fsize=10,title="*0.0073066*frag_air[28]"
	TitleBox j15NN_step1bScalar,frame=0,fStyle=1
	
	SetVariable HRCO2scalar_setvar,pos={11,178},size={179,16},bodyWidth=50,disable=1,proc=HROrgCheck_HRCO2SetVarProc,title="HR_frag_air[{CO2}] = "
	SetVariable HRCO2scalar_setvar,limits={0,100,0.01},value= _NUM:1
	Button HRCO2_Calc,pos={11,87},size={370,20},disable=1,proc=HROrgCheck_calcHROrgCO2Check,title="Step 0. Calculate HROrgCO2 and HROrgC2H3O for current todo"
	Button HRCO2_Calc,fColor=(65280,43520,0)
	Button HRCO2_Revert,pos={350,145},size={140,20},fsize=10,disable=1,proc=HROrgCheck_CO2Revert,title="Revert to previous value"
	Button HRCO2_Step2,pos={10,200},size={400,20},disable=1,proc=HROrgCheck_HRCO2_declare,title="Step 2. Declare value above for CO2 in HR_frag_air and frag_CO2 in UMR"
	Button HRCO2_Step2,fColor=(65280,43520,0)
	Button HRCO2_Step2_HR,pos={100,421},size={290,20},fsize=10,disable=1,proc=HROrgCheck_HRCO2_declareStep2,title="Declare value for air CO2 in HR table (Step 2 only for HR)"
	Button HRCO2_Step2_UMR,pos={90,537},size={300,20},fsize=10,disable=1,proc=HROrgCheck_HRCO2_declareStep2,title="Declare value for air CO2 in UMR table (Step 2 only for UMR)"
	Button HRCO2x_pk_Org44_v_Org43Graph,pos={426,200},size={60,20},fsize=10,disable=1,proc=sq_butt_popThis,title="Pop Graph"
	Button HRCO2x_PK_HROrgCO2Table,pos={396,421},size={90,20},fsize=10,disable=1,proc=sq_butt_popThis,title="Pop HR Table"
	Button HRCO2x_pk_air44UMRFragTable,pos={396,537},fsize=10,size={90,20},disable=1,proc=sq_butt_popThis,title="Pop UMR Table"

	TitleBox HRCO2_title,pos={15,57},size={466,16},disable=1,title="Determine gas & aerosol phase CO2 (can be done *after* HR fitting)"
	TitleBox HRCO2_title,fSize=12,frame=0,fStyle=1
	TitleBox HRCO2_step1a,pos={59,112},size={419,13},fsize=10,disable=1,title="Adjust entry below to get data clustering at the origin (filters) or fit intercept near the origin."
	TitleBox HRCO2_step1a,frame=0
	TitleBox HRCO2_step1b,pos={11,126},size={466,13},fsize=10,disable=1,title="Use of an HR time-dependent frag wave is allowed. Enter the wave name just as in the UMR case."
	TitleBox HRCO2_step1b,frame=0
	TitleBox HRCO2_step1Title,pos={14,112},size={41,13},disable=1,title="Step 1."
	TitleBox HRCO2_step1Title,frame=0
//	TitleBox HRCO2_step1b1,pos={196,178},size={248,13},fsize=10,disable=1,title="*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]"
//	TitleBox HRCO2_step1b1,frame=0
	TitleBox HRCO2_step1,pos={11,72},size={459,13},fsize=10,disable=1,title="Use filters or known low Org periods to adjust the fractional amount of CO2 that is in the gas phase."
	TitleBox HRCO2_step1,frame=0

	CheckBox HRCO2_timeScalar,pos={38,141},size={86,14},fsize=10,disable=1,proc=HROrgCheck_CO2TimeDep,title="numeric scalar"
	CheckBox HRCO2_timeScalar,value= 1,mode=1
	CheckBox HRCO2_timeDependent,pos={38,158},size={120,14},fsize=10,disable=1,proc=HROrgCheck_CO2TimeDep,title="time dependent wave"
	CheckBox HRCO2_timeDependent,value= 0,mode=1
	CheckBox HRCO2_showDetails,pos={14,422},size={50,14},fsize=10,disable=1,proc=PK_ShowDetails_HRrgCO2check,title="Details"
	CheckBox HRCO2_showDetails,variable=root:elementalAnalysis:ShowCO2Tables
	SetVariable HRCO2_timeDepStr,pos={195.00,181.00},size={68.00,15.00},bodyWidth=60,title="*"
	SetVariable HRCO2_timeDepStr,fSize=10,value= _STR:""

	TitleBox HRCO2_step1bNoTimeDep,pos={192.00,182.00},size={178.00,20.00},title=""
	TitleBox HRCO2_step1bNoTimeDep,fSize=10,frame=0
	TitleBox HRCO2_step1bTimeDep,pos={269.00,182.00},size={155.00,20.00},title=""
	TitleBox HRCO2_step1bTimeDep,fSize=10,frame=0

	TitleBox ImpAm_title,pos={10,57},size={323,16},disable=1,title="Smoooth fCHO, fCO2 to prevent noisy EA ratios"
	TitleBox ImpAm_title,frame=0, fSize=12,fstyle=1
	Button ImpAm_Calc,pos={15,74},size={280,35},proc=HROrgCheck_calcfCO2fCHO,title="Step 0. Calculate fCO2, fCHO for todo\r(surrogates for acid and alcohol functional groups)"
	Button ImpAm_Calc,fColor=(65280,43520,0)
	Button ImpAm_PaperRef1,pos={325,75},size={150,20},fsize=10,proc=SQ_URLButton,title="Anal. Chem. 2007 Aiken et al"		//1.16M
	Button ImpAm_PaperRef,pos={325,96},size={150,20},fsize=10,proc=SQ_URLButton,title="ACP 2015 Canagaratna et al"
	Button ImpAmx_PK_HROrgCheckTSGraph,pos={440,220},size={40,20},fsize=10,proc=sq_butt_popthis,title="pop"

	//1.19E

	Display/W=(10,204,475,387)/HOST=#
	RenameWindow #,j15NN_Org29_v_Org43Graph
	pk_populate_org29_v_org43Graph()
	SetActiveSubwindow ##

	Edit/W=(10,414,475,498)/HOST=#
	RenameWindow #,j15NNAllMassesTable
	PK_populate_j15NNAllMassesTable()	
	SetActiveSubwindow ##

	Edit/W=(10,523,475,606)/HOST=#
	RenameWindow #,j15NNUMRFragTable
	pk_populate_j15NNUMRFragTable()
	SetActiveSubwindow ##

//	elseif(tabNum==1)	//CO2
	Display/W=(10,225,475,415)/HOST=#
	RenameWindow #,HRCO2_Org44_v_Org43Graph
	pk_populate_org44_v_org43Graph()
	SetActiveSubwindow ##
	
	Edit/W=(10,445,475,530)/HOST=#
	RenameWindow #,HRfragCO2Table
	PK_populate_HROrgCO2Table()	
	SetActiveSubwindow ##

	Edit/W=(10,560,475,645)/HOST=#
	RenameWindow #,air44UMRFragTable
	pk_populate_air44UMRFragTable()
	SetActiveSubwindow ##

	ControlInfo HRCO2_timeScalar
	HROrgCheck_CO2TimeDep("HRCO2_timeScalar",V_Value)

//	elseif(tabNum==2)		//EA

	Display/W=(10,285,485,670)/HOST=#
	RenameWindow #,ImpAm_EA_TseriesGraph
	PK_populate_HROrgCheckTSGraph()
	SetActiveSubwindow ##

	HROrgCheck_ImpAmbControls(110)	

	strswitch(ctrlName)
		case "HRTodoFit_butt_Tj15NN":
			HROrgCheck_TabProc("HROrgCheckTab",0)
			TabControl HRCheckTab,value= 0
			break
		case "HRResultsD_HROrgCheckPanel":
			HROrgCheck_TabProc("HROrgCheckTab",1)
			TabControl HRCheckTab,value= 1
			break
		case "HRResultsE_HROrgCheckPanel":
			HROrgCheck_TabProc("HROrgCheckTab",2)
			TabControl HRCheckTab,value= 2
		break
	endswitch

End


//1.15O
//Helper for controls for ImprovedAmbient panel
Function HROrgCheck_ImpAmbControls(yoffset)
variable yoffset

	Button ImpAm_Step3_TS,pos={10,85+yoffset},size={235.00,35.00},proc=HROrgCheck_CalcEA_ImprovedAmb,title="Step 2. Use modified fCHO, fCO2 to recalc\r 'Improved-Ambient' H/C, O/C, OSc"
	Button ImpAm_Step3_TS,fColor=(65280,43520,0)
	Button ImpAm_Step3Diurnal,pos={248,85+yoffset},size={105.00,35.00},proc=HROrgCheck_CalcEADiurnal_ImpAmb,title="Step 2A. (opt.) IA\rDiurnal H/C, O/C, OSc"
	Button ImpAm_Step3Diurnal,fSize=10
	TitleBox ImpAm_step1Title,pos={10,47+yoffset},size={41,13},title="Step 1.",frame=0
	TitleBox ImpAm_step1Title,fStyle=1
	TitleBox ImpAmb_step1a,pos={55,47+yoffset},size={135,13},title="Set the smoothing parameter"
	TitleBox ImpAmb_step1a,frame=0
	TitleBox ImpAmb_formula,pos={10,0+yoffset},size={282,47},frame=5
	TitleBox ImpAmb_formula,variable= root:elementalAnalysis:EAformulaStr, fsize=10		//1.19C
//	TitleBox ImpAm_step2,pos={10,80+yoffset},size={41,13},title="Step 2.",frame=0,fStyle=1
//	TitleBox ImpAmb_step2a,pos={53,80+yoffset},size={261,13},title="(optional) Set the detection limit (DL) muliplicative scalar"
//	TitleBox ImpAmb_step2a,frame=0
	TitleBox ImpAmb_step3a,pos={10,125+yoffset},size={351,13},title="Data output settings (such as 'Plot single') from the Pika panel will be used."
	TitleBox ImpAmb_step3a,frame=0
//	CheckBox ImpAm_EACorrelation,pos={11,120+yoffset},size={169,26},title="Also, display Aiken-Ambient\rvs Improved Ambient correlation"
//	CheckBox ImpAm_EACorrelation,fSize=10,fStyle=0, variable= root:elementalAnalysis:IA_AA_correlation
//	SetVariable ImpAm_setvarDetLim,pos={39,95+yoffset},size={209,16},bodyWidth=45,proc=HROrgCheck_smoothingDLScalar,title="Detection limit multiplicative scalar"
//	SetVariable ImpAm_setvarDetLim,limits={0,10000,1},value= root:elementalAnalysis:DLscalar
	SetVariable ImpAm_setvarSmooth,pos={39,60+yoffset},size={227,16},bodyWidth=45,proc=HROrgCheck_smoothingScalar,title="Num. of consecutive points to smooth"
	SetVariable ImpAm_setvarSmooth,limits={0,10000,1},value= root:elementalAnalysis:smoothingVal	//1.19E
	
	CheckBox ImpAm_checkCO2,fSize=10,pos={362,39+yoffset},size={91,14},proc=HROrgCheck_EATSgraph,title="Show only CO2"
	CheckBox ImpAm_checkCO2,value= 0,mode=1
	CheckBox ImpAm_checkCHO,fSize=10,pos={362,23+yoffset},size={93,14},proc=HROrgCheck_EATSgraph,title="Show only CHO"
	CheckBox ImpAm_checkCHO,value= 1,mode=1
	CheckBox ImpAm_checkHROrg,fSize=10,pos={362,57+yoffset},size={131,14},proc=HROrgCheck_EATSgraph,title="Show loading (HROrgX)"
	CheckBox ImpAm_checkHROrg,value= 0,mode=1
	CheckBox ImpAm_checkAll,fSize=10,pos={362,91+yoffset},size={58,14},proc=HROrgCheck_EATSgraph,title="Show all"
	CheckBox ImpAm_checkAll,value= 0,mode=1
	CheckBox ImpAm_checkfHROrg,fSize=10,pos={362,73+yoffset},size={108,14},proc=HROrgCheck_EATSgraph,title="Show fraction ( fX )"
	CheckBox ImpAm_checkfHROrg,value= 0,mode=1
	GroupBox ImpAm_group,pos={355,8+yoffset},size={134,104},title="Graph controls"
	
End


//1.15O
// tab control for HROrgCheck_Panel
Function HROrgCheck_TabProc(ctrlName,tabNum) : TabControl
	String ctrlName
	Variable tabNum
	
	variable cont_disp,idex,nCont, num
	string cont_list, cont_item, myWInList, winStr

	cont_list=controlnamelist("")
	nCont=itemsinlist(cont_list)
	
	for (idex=0;idex<nCont;idex+=1)
		cont_item=stringfromlist(idex,cont_list)
		strswitch (cont_item[0,4])
			case "HRChe":		// outside of tabs	  HRCheck
				cont_disp=0
				break
			case "j15NN":	
				cont_disp=tabNum!=0
				break
			case "HRCO2":	
				cont_disp=tabNum!=1
				break
			case "ImpAm":		// improved ambient
				cont_disp=tabNum!=2
				break
		endswitch
		controlinfo /w=HROrgCheck_Panel $cont_item
		switch (abs(v_flag))
			case 1:
				button $cont_item disable=cont_disp
				break
			case 2:
				checkbox  $cont_item disable=cont_disp
				break
			case 3:
				popupmenu $cont_item disable=cont_disp
				break
			case 4:
				valdisplay $cont_item disable=cont_disp
				break
			case 5:
				setvariable $cont_item disable=cont_disp
				break
			case 6:
				chart $cont_item disable=cont_disp
				break
			case 7:
				slider $cont_item disable=cont_disp
				break
			case 8:
				tabcontrol $cont_item disable=cont_disp
				break
			case 9:
				groupbox $cont_item disable=cont_disp
				break
			case 10:
				titlebox $cont_item disable=cont_disp
				break
			case 11:
				listbox $cont_item disable=cont_disp
				break
		endswitch
	endfor
	
	//1.19E
 //1 = hides, 0 is visible
	SetWindow HROrgCheck_Panel#HRCO2_Org44_v_Org43Graph, Hide=(tabNum!=1)
	SetWindow HROrgCheck_Panel#j15NN_Org29_v_Org43Graph, Hide=(tabNum!=0)	
	SetWindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph, Hide=(tabNum!=2)

 	SetWindow HROrgCheck_Panel#air44UMRFragTable, Hide=(tabNum!=1) 
	SetWindow HROrgCheck_Panel#HRfragCO2Table, Hide=(tabNum!=1)

	SetWindow HROrgCheck_Panel#j15NNUMRFragTable, Hide=(tabNum!=0)
	SetWindow HROrgCheck_Panel#j15NNAllMassesTable, Hide=(tabNum!=0)

	nvar ShowCO2Tables = root:ElementalAnalysis:ShowCO2Tables
	nvar Showj15NNTables = root:ElementalAnalysis:Showj15NNTables

	if (tabNum==0)
		PK_ShowDetails_j15NNcheck("HRj15NN_showDetails",Showj15NNTables)
		HROrgCheck_j15NNRevert_butt("")   //1.20C
	elseif(tabNum==1)
		HROrgCheck_CO2Revert("")  //1.20C
		ControlInfo HRCO2_timeScalar
		HROrgCheck_CO2TimeDep("HRCO2_timeScalar",V_Value)		//1.20B
		PK_ShowDetails_HRrgCO2check("HRCO2_showDetails",ShowCO2Tables)
	endif
End


//1.15O
Function HROrgCheck_GoToPika(ctrlName) : ButtonControl
	String ctrlName
	HR_getHRwin()
End


//1.15O
Function pk_populate_org29_v_org43Graph()

	ControlInfo/W=HROrgCheck_Panel j15NN_checkHR
	variable UMR = !(V_flag==2 && V_Value) 
	
	gen_removeTracesFromGraph("")
	
	if (UMR)
		wave/z mz29 = root:ElementalAnalysis:mz29 
		wave/z mz28 = root:ElementalAnalysis:mz28 
		wave/z org29 = root:ElementalAnalysis:org29 
		wave/z org43 = root:ElementalAnalysis:org43 
		if (!WaveExists(org29) || !WaveExists(org43)  || !WaveExists(mz29)  || !WaveExists(mz28))
			return 0
		endif
		AppendToGraph org29 vs org43
		ModifyGraph mode(org29)=2,lsize(org29)=2, zero=1, standoff=0
		ModifyGraph zColor(org29)={root:index:t_series,*,*,Rainbow}
		ModifyGraph font="Arial"
		SetAxis/A/E=3 left		//1.51A
		SetAxis/A/E=3 bottom	//1.51A		//1.56F
		ModifyGraph grid=2,gridRGB=(34816,34816,34816)  //1.56E

		ControlInfo/w=HROrgCheck_Panel j15NNscalar_setvar
		HROrgCheck_j15NNSetVar("j15NNscalar_setvar",V_value,"","")
		wave Org29Fit = root:ElementalAnalysis:Org29Fit
		Appendtograph  Org29Fit
		ModifyGraph lsize=2,rgb(Org29Fit)=(34816,34816,34816)
		Label left "\\Z12UMR Org 29"
		Label bottom "\\Z12UMR Org 43"
	else
		wave/z N2 = $"root:ElementalAnalysis:N2"
		wave/z CHO = $"root:ElementalAnalysis:CHO"
		wave/z HROrgCHO =  $"root:ElementalAnalysis:HROrgCHO"
		wave/z HROrg29=  $"root:ElementalAnalysis:HROrg29"
		wave/z HROrgC2H3O =  $"root:ElementalAnalysis:HROrgC2H3O"
		if (!WaveExists(N2) || !WaveExists(CHO)  || !WaveExists(HROrgCHO)  || !WaveExists(HROrg29)  || !WaveExists(HROrgC2H3O)  )
			return 0
		endif
		AppendToGraph HROrgCHO vs HROrgC2H3O
		ModifyGraph mode(HROrgCHO)=2,lsize(HROrgCHO)=2,  zero=1, standoff=0
		ModifyGraph zColor(HROrgCHO)={root:index:t_series,*,*,Rainbow}
		ModifyGraph font="Arial"
		SetAxis/A/E=3 left		//1.51A
		SetAxis/A/E=3 bottom	//1.51A		//1.56F
		ModifyGraph grid=2,gridRGB=(34816,34816,34816)  //1.56E
		
		ControlInfo/w=HROrgCheck_Panel j15NNscalar_setvar
		HROrgCheck_j15NNSetVar("j15NNscalar_setvar",V_value,"","")
		wave HROrg29Fit = root:ElementalAnalysis:HROrg29Fit
		Appendtograph  HROrg29Fit
		ModifyGraph lsize=2,rgb(HROrg29Fit)=(34816,34816,34816)
		Label left "\\Z12HROrgCHO"
		Label bottom "\\Z12HROrgC2H3O"
		ModifyGraph fSize=10
		ModifyGraph minor=1
		ModifyGraph margin(bottom)=50
		ModifyGraph margin(left)=50	
	endif
End

//1.15O
// created waves and globals are put into the root:ElementalAnalysis data folder
Function HROrgCheck_calcj15NNCheck(ctrlName) : ButtonControl
string ctrlName

	ControlInfo j15NN_checkUMR
	variable UMR =V_Value

	HROrgCheck_j15NNRevert_butt("")
	
	string paramStr="", speclistStr, dummyStr, destList
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$"root:"+todoStr			//1.44B
	nvar fDiag_UseAirbeam=root:panel:fDiag_UseAirbeam
			
	wave/z corr_fact=root:diagnostics:corr_fact
	if (!WaveExists(corr_fact))
		abort "Please calculate the airbeam correction before proceeding.  aborting from  HROrgCheck_calcj15NNCheck"
	endif

	if (UMR)
	 	FD_modifyBatch("Org29", "Org29", "frag_organic[29]","1.4", "1", "" )	//1.56E //1.49E
	 	FD_modifyBatch("Org43", "Org43", "frag_organic[43]","1.4", "1", "" )	//1.56E //1.49E
		
		sq_CheckBatchAandB("Org29", "Org43", "RIE")
		sq_CheckBatchAandB("Org29", "Org43", "CE")
		sq_CheckBatchAandB("Org29", "Org43", "CEfac_List")
		sq_CheckBatchAandB("Org29", "Org43", "speccorr_List")
			
		speclistStr = "Org29,Org43,29,28"
		destList = "root:ElementalAnalysis:Org29/root:ElementalAnalysis:Org43/root:ElementalAnalysis:mz29/root:ElementalAnalysis:mz28/"
		// for now we will calculate all species in the text wave list except 
	
		SQ_GetParamStr(paramstr,speclistStr,0,dummyStr)
		paramStr+="filter_op:0;"
		paramStr+="corr_op:"+num2str(fDiag_UseAirbeam)+";"
		paramstr+="ug_op:"+num2str(1)+";"		// always do in units of g/m3
		paramstr+="cache_op:"+num2str(0)+";"
		paramstr+="product_type:1;"
		paramstr+="destlist:"+destList+";"
		squirrel_fetch(todo,sq_MS_concentration,paramstr,"MSSDiff_p")		
		
		variable/g root:ElementalAnalysis:RIE_Org29  = str2num(stringFromList(0, StringByKey("rie_list", paramstr,  ":", ";") , "/" ) )
		variable/g root:ElementalAnalysis:CE_Org29  = str2num(stringFromList(0, StringByKey("ce_list", paramstr,  ":", ";") , "/" ) )
		string/g root:ElementalAnalysis:specCorr_Org29  = stringFromList(0, StringByKey("spec_corr", paramstr,  ":", ";")  , "/" )
		string/g root:ElementalAnalysis:CECorr_Org29 = stringFromList(0, StringByKey("CE_corr", paramstr,  ":", ";") , "/" )
	
	else	
		nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0		//1.17c
		svar HRResults_ionList = root:HR_panel:HRResults_ionList
		HRResults_ionList = "j15NN,N2,CHO,HROrgCHO,HROrg29,HROrgC2H3O"
		speclistStr = HRResults_ionList
//		destList = "root:ElementalAnalysis:N2/root:ElementalAnalysis:CHO/root:ElementalAnalysis:HRCHO/root:ElementalAnalysis:HROrgC2H3O/"
		// for now we will calculate all species in the text wave list except 
	
		HR_GetParamStr(paramstr,speclistStr,0,3)
		paramstr+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"		//1.17c
		paramStr+="filter_op:0;"
		paramStr+="corr_op:"+num2str(fDiag_UseAirbeam)+";"
		paramstr+="ug_op:"+num2str(1)+";"		// always do in units of g/m3
		paramstr+="cache_op:"+num2str(0)+";"
		paramstr+="product_type:1;"
		paramstr+="destlist:"+"j15NN/N2/CHO/HROrgCHO/HROrg29/HROrgC2H3O/"+";"//destList+";"
		nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0
		paramstr+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"			//Donna 12/14/2016
		HR_calc_MSVsTime("temp", "HROMinusCStick", "M", paramstr, "")
	
		wave j15NN_M_temp = root:j15NN_M_temp
		wave N2_M_temp = root:N2_M_temp
		wave CHO_M_temp = root:CHO_M_temp
		wave HROrgCHO_M_temp = root:HROrgCHO_M_temp
		wave HROrg29_M_temp = root:HROrg29_M_temp
		wave HROrgC2H3O_M_temp = root:HROrgC2H3O_M_temp
		
		duplicate/o j15NN_M_temp $"root:ElementalAnalysis:j15NN"
		duplicate/o N2_M_temp $"root:ElementalAnalysis:N2"
		duplicate/o CHO_M_temp $"root:ElementalAnalysis:CHO"
		duplicate/o HROrgCHO_M_temp $"root:ElementalAnalysis:HROrgCHO"
		duplicate/o HROrgCHO_M_temp $"root:ElementalAnalysis:HROrgCHO_orig"
		duplicate/o HROrg29_M_temp $"root:ElementalAnalysis:HROrg29"
		duplicate/o HROrg29_M_temp $"root:ElementalAnalysis:HROrg29_orig"
		duplicate/o HROrgC2H3O_M_temp $"root:ElementalAnalysis:HROrgC2H3O"
		killwaves/z j15NN_M_temp, N2_M_temp, CHO_M_temp, HRCHO_M_temp, HROrg29_M_temp, HROrgC2H3O_M_temp

		variable/g root:ElementalAnalysis:RIE_HROrgCHO  = str2num(stringFromList(3, StringByKey("rie_list", paramstr,  ":", ";") , "/" ) )
		variable/g root:ElementalAnalysis:CE_HROrgCHO  = str2num(stringFromList(3, StringByKey("ce_list", paramstr,  ":", ";") , "/" ) )
		string/g root:ElementalAnalysis:specCorr_HROrgCHO  = stringFromList(3, StringByKey("spec_corr", paramstr,  ":", ";")  , "/" )
		string/g root:ElementalAnalysis:CECorr_HROrgCHO = stringFromList(3, StringByKey("CE_corr", paramstr,  ":", ";") , "/" )
	endif	

	SetActiveSubwindow $"HROrgCheck_Panel#j15NN_Org29_v_Org43Graph"
	pk_populate_org29_v_org43Graph()
	SetActiveSubwindow ##

End


//1.15O
Function HROrgCheck_UMRorHRj15NN(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	variable UMR = strsearch(ctrlName, "UMR",0)>=0
	if (UMR)
		Button j15NN_Calc title ="Step 0. Calc. Org29 and Org43 for current todo"
		SetVariable j15NNscalar_setvar title ="frag_air[29] = "
		TitleBox j15NN_step1bScalar title="*0.0073066*frag_air[28]"
		Variable/g root:elementalAnalysis:j15NNDeclaredHR = 0
	else
		Button j15NN_Calc title ="Step 0. Calc. HROrgCHO and HROrgC2H3O for current todo"
		SetVariable j15NNscalar_setvar title ="j15NN = "
		TitleBox j15NN_step1bScalar title="*0.0073066*{N2}"
		Variable/g root:elementalAnalysis:j15NNDeclaredHR = 1
	endif
	Checkbox j15NN_checkUMR value = UMR
	Checkbox j15NN_checkHR value = !UMR

	ControlInfo j15NNscalar_setvar
	HROrgCheck_j15NNSetVar("",V_Value,"","")
End


//1.15O
Function HROrgCheck_j15NNRevert_butt(ctrlName) : ButtonControl
	String ctrlName

	string frag, prefix
	variable pos, val
	ControlInfo j15NN_checkHR

	if( !V_Value )		// use UMR
		wave/t frag_air = root:frag:frag_air
		frag = frag_air[28]
		frag = ReplaceString(" ", frag,"")
		frag = ReplaceString("*frag_air[28]", frag,"")
		prefix = frag[0, strsearch(frag, ".0073", 0)-2 ]
		if (strlen(prefix)==0)
			frag="1"
		elseif(stringmatch("*", prefix[strlen(prefix)-1]) )
			frag = ReplaceString("*", prefix,"")
		endif		
		val = str2num(prefix)
		if (Numtype(val) != 0)
			val = 1
		endif
	else
		wave/t exactMassText_all = root:HR:exactMassText_all
		wave mask_isotope_abundance = root:HR:mask_isotope_abundance
		pos = sq_findStr(exactMassText_all,"j15NN",1)
		val =mask_isotope_abundance[pos]/0.0073066
	endif
	SetVariable j15NNscalar_setvar value=_Num:val, win = HROrgCheck_Panel
	HROrgCheck_j15NNSetVar("j15NNscalar_setvar",val,"","")
End


//1.15O
Function HROrgCheck_j15NNSetVar(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	variable Xmin, Xmax, UMRflag
	ControlInfo j15NN_checkUMR
	UMRflag = V_Value
	if (UMRflag)		// UMR

		wave/z Org29 = root:ElementalAnalysis:Org29
		wave/z Org43 = root:ElementalAnalysis:Org43
		wave/z mz28 = root:ElementalAnalysis:mz28
		wave/z mz29 = root:ElementalAnalysis:mz29
		
		nvar/z RIE_Org29 = root:ElementalAnalysis:RIE_Org29		// created in  PK_j15NNCheck()
		nvar/z CE_Org29 = root:ElementalAnalysis:CE_Org29
		svar/z specCorr_Org29 = root:ElementalAnalysis:specCorr_Org29
		svar/z CECorr_Org29 = root:ElementalAnalysis:CECorr_Org29
			
		if ( WaveExists(mz29) && WaveExists(mz28) && WaveExists(Org43) && WaveExists(Org29) && Nvar_exists(RIE_Org29) )

			nvar/z RIE_Org29 = root:ElementalAnalysis:RIE_Org29		// created in  PK_j15NNCheck()
			nvar/z CE_Org29 = root:ElementalAnalysis:CE_Org29
			svar/z specCorr_Org29 = root:ElementalAnalysis:specCorr_Org29
			svar/z CECorr_Org29 = root:ElementalAnalysis:CECorr_Org29
			
			wave/z CECorr_Org29wave = $CECorr_Org29
			wave/z specCorr_Org29wave = $specCorr_Org29
			if (!WaveExists(CECorr_Org29wave))
				make/free/n=(numpnts(Org29)) CEwave = CE_Org29
				wave CECorr_Org29wave = CEwave	//  1.16M
			else					//1.17c
				wave CEwave = CECorr_Org29wave
			endif
			if (!WaveExists(specCorr_Org29wave))
				make/free/n=(numpnts(Org29)) specCorrwave = 1
				wave specCorr_Org29wave = specCorrwave  //  1.16M
			else		//1.17c
				wave specCorrwave = specCorr_Org29wave
			endif
				
			Org29 =(mz29 - varNum*j15NN_THEORY*mz28)/(RIE_Org29*CEwave)/specCorrwave
			
			CurveFit/Q/X=1/NTHR=0/ODR=2 line  :ElementalAnalysis:Org29 /X=:ElementalAnalysis:Org43
			wave W_coef
			Xmin = min(0, WaveMin(Org43))
			Xmax = WaveMax(Org43)
	//		make/o/n=2 root:ElementalAnalysis:Org29FitCoeffs = W_coef
			make/o/n=2 root:ElementalAnalysis:Org29Fit/wave = Org29Fit
			Org29Fit[0] =  W_coef[0]+W_coef[1]*Xmin
			Org29Fit[1] = W_coef[0]+W_coef[1]*Xmax
			SetScale/P x Xmin, abs(Xmin) + Xmax,"", Org29Fit
		endif // do nothing
	else			// HR
		wave/z CHO = $"root:ElementalAnalysis:CHO"		//_orig
		wave/z j15NN = $"root:ElementalAnalysis:j15NN"	//_orig
		wave/z N2 = $"root:ElementalAnalysis:N2"	//_orig
		wave/z HROrgCHO = $"root:ElementalAnalysis:HROrgCHO"
		wave/z HROrgCHO_orig = $"root:ElementalAnalysis:HROrgCHO_orig"	//_orig
		wave/z HROrg29 = $"root:ElementalAnalysis:HROrg29"
		wave/z HROrg29_orig = $"root:ElementalAnalysis:HROrg29_orig"
		wave/z HROrgC2H3O = $"root:ElementalAnalysis:HROrgC2H3O"

		if ( WaveExists(CHO) && WaveExists(j15NN) && WaveExists(N2) && WaveExists(HROrgCHO) && WaveExists(HROrg29)  && WaveExists(HROrg29_orig) && WaveExists(HROrgC2H3O))
			nvar RIE_HROrgCHO = root:ElementalAnalysis:RIE_HROrgCHO
			nvar CE_HROrgCHO = root:ElementalAnalysis:CE_HROrgCHO 
			svar specCorr_HROrgCHO = root:ElementalAnalysis:specCorr_HROrgCHO 
			svar CECorr_HROrgCHO = root:ElementalAnalysis:CECorr_HROrgCHO
		
			wave/z CECorr_HRCHOwave = $CECorr_HROrgCHO
			wave/z specCorr_HRCHOwave = $specCorr_HROrgCHO
			if (!WaveExists(CECorr_HRCHOwave))
				make/free/n=(numpnts(HROrgCHO)) CEwave = CE_HROrgCHO
			endif
			if (!WaveExists(specCorr_HRCHOwave))
				make/free/n=(numpnts(HROrgCHO)) specCorrwave = 1
			endif
		
			duplicate/free HROrgCHO  HROrgCHO_temp
			make/o/free/n=(numpnts(CHO)) totalpeak = CHO + j15NN
			HROrgCHO =(totalpeak - varNum*j15NN_THEORY*N2)/(RIE_HROrgCHO*CEwave)/specCorrwave
			HROrg29 = HROrg29_orig -HROrgCHO_orig+HROrgCHO
			CurveFit/Q/X=1/NTHR=0/ODR=2 line  root:ElementalAnalysis:HROrgCHO /X=root:ElementalAnalysis:HROrgC2H3O
			wave W_coef
			Xmin = min(0, WaveMin(HROrgC2H3O))
			Xmax = WaveMax(HROrgC2H3O)
			make/o/n=2 root:ElementalAnalysis:HROrg29Fit/wave = HROrg29Fit
			HROrg29Fit[0] =  W_coef[0]+W_coef[1]*Xmin
			HROrg29Fit[1] = W_coef[0]+W_coef[1]*Xmax
			SetScale/P x Xmin, abs(Xmin) + Xmax,"", HROrg29Fit
		endif
	endif
	
	TitleBox j15NN_step3Title fcolor = (0,0,0),frame=0, title="Step 3. Perform HR fits using this j15NN isotopic abundance (Pika step 5)", win=HROrgCheck_Panel

End


//1.15O
Function HROrgCheck_j15NNSetIsotope(ctrlName) : ButtonControl
	String ctrlName

	HROrgCheck_j15NNStep2( "j15NN_Step2_HR")
	HROrgCheck_j15NNStep2( "j15NN_Step2_UMR")

End


//1.15O
Function HROrgCheck_j15NNStep2(ctrlName) : ButtonControl
	String ctrlName

// for HR
	variable pos
	if (stringmatch (ctrlName, "j15NN_Step2_HR") )
		wave/t ExactMassComments = root:HR:ExactMassComments
		wave/t ExactMassText_all = root:HR:ExactMassText_all
		wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance	
		
		FindValue/TEXT="j15NN"/TXOP=4  ExactMassText_all
		pos = V_Value
		
		ControlInfo j15NNscalar_setvar		
		variable/g root:HR_frag:j15NNisotopeScalar = V_Value
	
		Mask_Isotope_abundance[pos] = j15NN_THEORY*V_Value
		ExactMassComments[pos] = num2str(V_Value)+"*"+num2str(j15NN_THEORY) + " is default"
		
		HR_MakeIntegrationMaskWave()		// resets other waves in anticipation of fitting.
		HR_ExtractIsotopicValues() 	// resets other waves in anticipation of fitting.
	
		print "// The user declared the j15NN scalar for HR fitting to be "+num2str(V_Value)+ " at "+date() + " " + time()
		TitleBox j15NN_step3Title fsize = 24, fcolor = (65280,0,0),frame=0, title="Step 3. Perform HR peak fitting with\r this j15NN isotopic abundance", win = HROrgCheck_Panel
	elseif (stringmatch (ctrlName, "j15NN_Step2_UMR") )
// for UMR
		ControlInfo j15NNscalar_setvar		
		variable/g root:HR_frag:j15NNisotopeScalar = V_Value
		wave/t frag_air = root:frag:frag_air
		frag_air[28] = num2str(V_Value)+"*0.00730666*frag_air[28]"
		print "// The user declared the frag_air[29] scalar for UMR fitting to be "+num2str(V_Value)+ " at "+date() + " " + time()
	endif
	
End


//1.15O
Function PK_populate_j15NNAllMassesTable()	

	HR_populate_AllMassesTable()
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	FindValue/Text = "j15NN"/TXop = 4  ExactMassText_all
	variable pos = V_Value
	ModifyTable selection=(pos , 0 ,pos,5,pos,5), topLeftCell=(pos, 0)	
End


//1.15O
Function PK_populate_j15NNUMRFragTable()	

	sq_populateFragTable()
	
	ModifyTable/Z selection=(28, 0 ,28,5,28,5), topLeftCell=(28, 0)		//1.59D
	ModifyTable/Z width(root:frag:frag_air)=190
	ModifyTable/Z width(root:frag:frag_CO2)=20,width(root:frag:frag_O16)=20
	ModifyTable/Z width(root:frag:frag_water)=20,width(root:frag:frag_RH)=20

End


//1.15O
Function PK_populate_org44_v_org43Graph()

	wave/z HROrgCO2 = root:elementalAnalysis:HROrgCO2 
	wave/z HROrgC2H3O = root:elementalAnalysis:HROrgC2H3O 
	if (!WaveExists(HROrgCO2) || !WaveExists(HROrgC2H3O) )
		return 0
	endif
	string plotted = TraceNameList("", ";", 1 )
	if (WhichListItem("HROrgCO2",plotted)>=0 || WhichListItem("HROrgCO2Fit",plotted)>=0 )
		return 0
	endif
		
	wave/z HROrgCO2Fit = root:elementalAnalysis:HROrgCO2Fit 
	if ( !WaveExists(HROrgCO2Fit) )
		make/n=2/o root:elementalAnalysis:HROrgCO2Fit /wave = HROrgCO2Fit
	endif
	
	variable Xmin, Xmax
	SetDataFolder root:elementalAnalysis:
	AppendToGraph HROrgCO2 vs HROrgC2H3O
	AppendToGraph HROrgCO2Fit
	SetDataFolder root:

	ModifyGraph mode(HROrgCO2Fit)=0
	ModifyGraph mode(HROrgCO2)=2
	ModifyGraph rgb(HROrgCO2Fit)=(34816,34816,34816)
	ModifyGraph lsize=2
	ModifyGraph zColor(HROrgCO2)={root:index:t_series,*,*,Rainbow}
	ModifyGraph zero=1
	ModifyGraph font="Arial"
	ModifyGraph standoff=0
	
	ModifyGraph msize(HROrgCO2)=1.5
	ModifyGraph marker(HROrgCO2)=8
	Label left "\\Z12HROrgCO2, ug/m3"
	Label bottom "\\Z12HROrgC2H3O, ug/m3"
	ModifyGraph fSize=10
	ModifyGraph minor=1
	ModifyGraph margin(bottom)=50
	ModifyGraph margin(left)=50
	ModifyGraph grid=2,gridRGB=(34816,34816,34816) 

 	ControlInfo /W=HROrgCheck_panel HRCO2scalar_setvar
 	HROrgCheck_HRCO2SetVarProc("",V_Value,"","") 
 
End


Function HROrgCheck_calcHROrgCO2Check(ctrlName) : ButtonControl
string ctrlName
	
	HROrgCheck_CO2Revert("")
	
	nvar HR_checkUseAB = root:HR_panel:HR_checkUseAB
	nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0		//1.17c
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$"root:"+todoStr			//1.44B

	string paramStr="", speclistStr, dummyStr, destList
	variable num
		
	svar HRResults_ionList = root:HR_panel:HRResults_ionList
	HRResults_ionList = "N2,CO2,HROrgC2H3O,HROrgCO2"
	speclistStr = HRResults_ionList
	destList = "N2/CO2/HROrgCO2/HROrgCO2/"
	// for now we will calculate all species in the text wave list except 

	HR_GetParamStr(paramstr,speclistStr,0,3)
	paramStr+="filter_op:0;"
	paramStr+="corr_op:"+num2str(HR_checkUseAB)+";"
	paramstr+="ug_op:"+num2str(1)+";"		// always do in units of g/m3
	paramstr+="cache_op:"+num2str(0)+";"
	paramstr+="product_type:1;"
	paramstr+="destlist:"+destList+";"
	paramstr+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"		//1.17c
	HR_calc_MSVsTime("temp", "HROMinusCStick", "M", paramstr, "")

	wave N2_M_temp = root:N2_M_temp
	wave CO2_M_temp = root:CO2_M_temp
	wave HROrgCO2_M_temp = root:HROrgCO2_M_temp
	wave HROrgC2H3O_M_temp = root:HROrgC2H3O_M_temp
	
	duplicate/o N2_M_temp $"root:elementalAnalysis:N2"
	duplicate/o CO2_M_temp $"root:elementalAnalysis:CO2"
	duplicate/o HROrgCO2_M_temp $"root:elementalAnalysis:HROrgCO2"
	duplicate/o HROrgC2H3O_M_temp $"root:elementalAnalysis:HROrgC2H3O"

	killwaves/z N2_M_temp, CO2_M_temp, HROrgCO2_M_temp, HROrgC2H3O_M_temp
		
	num = itemsInList(HRResults_ionList, ",")
	variable/g root:elementalAnalysis:RIE_HROrgCO2  = str2num(stringFromList(num-1, StringByKey("rie_list", paramstr,  ":", ";") , "/" ) )

	variable/g root:elementalAnalysis:CE_HROrgCO2  = str2num(stringFromList(num-1, StringByKey("ce_list", paramstr,  ":", ";") , "/" ) )
	string/g root:elementalAnalysis:specCorr_HROrgCO2  = stringFromList(num-1, StringByKey("spec_corr", paramstr,  ":", ";")  , "/" )
	string/g root:elementalAnalysis:CECorr_HROrgCO2 = stringFromList(num-1, StringByKey("CE_corr", paramstr,  ":", ";") , "/" )
	
	SetActiveSubwindow HROrgCheck_Panel#HRCO2_Org44_v_Org43Graph
	pk_populate_org44_v_org43Graph()
	SetActiveSubwindow ##

End


//1.15O
Function PK_populate_HROrgCO2Table()	

	HR_populate_HRFragTable()
	wave/t HR_specMassAlgebra = root:HR_frag:HR_specMassAlgebra
	FindValue/Text = "CO2"/TXop = 4  HR_specMassAlgebra
	variable pos = V_Value
	ModifyTable selection=(pos , 0 ,pos,5,pos,5), topLeftCell=(pos, 0)	
	ModifyTable width(root:HR_frag:HR_frag_air)=260
End


//1.15O
Function PK_populate_air44UMRFragTable()	

	sq_populateFragTable()
	string wStr = WinName(0, 66) 
	if (stringmatch(wStr, "HROrgCheck_Panel") )	  //1.22A
		ModifyTable/Z/W=HROrgCheck_Panel#air44UMRFragTable selection=(43, 0 ,43,5,43,5), topLeftCell=(43, 0)
		ModifyTable/Z/W=HROrgCheck_Panel#air44UMRFragTable width(root:frag:frag_CO2)=240
	else
		ModifyTable/Z/W=$wStr selection=(43, 0 ,43,5,43,5), topLeftCell=(43, 0)
		ModifyTable/Z/W=$wStr width(root:frag:frag_CO2)=240
	endif
	
End


//1.15O
Function HROrgCheck_HRCO2SetVarProc(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	wave/z CO2 = root:elementalAnalysis:CO2
	wave/z N2 = root:elementalAnalysis:N2
	wave/z HROrgCO2 = root:elementalAnalysis:HROrgCO2
	wave/z HROrgC2H3O = root:elementalAnalysis:HROrgC2H3O

	if (!WaveExists(CO2) || !WaveExists(N2) || !WaveExists(HROrgCO2) || !WaveExists(HROrgC2H3O)  )
		return 0
	endif
	
	nvar RIE_HROrgCO2 = root:elementalAnalysis:RIE_HROrgCO2		// created in  HROrgCheck_calcHROrgCO2Check()
	nvar CE_HROrgCO2 = root:elementalAnalysis:CE_HROrgCO2
	svar specCorr_HROrgCO2 = root:elementalAnalysis:specCorr_HROrgCO2
	svar CECorr_HROrgCO2 = root:elementalAnalysis:CECorr_HROrgCO2
	
	wave/z CECorr_HROrgCO2wave = $CECorr_HROrgCO2
	wave/z specCorr_HROrgCO2wave = $specCorr_HROrgCO2
	if (!WaveExists(specCorr_HROrgCO2wave))
		make/free/n=(numpnts(HROrgC2H3O)) CEwave = CE_HROrgCO2
	endif
	if (!WaveExists(specCorr_HROrgCO2wave))
		make/free/n=(numpnts(HROrgC2H3O)) specCorrwave = 1
	endif
	if (numpnts(specCorrwave) != numpnts(HROrgC2H3O) || numpnts(CEwave) != numpnts(HROrgC2H3O)  )
		abort "The wave "+NameOfWave(specCorr_HROrgCO2wave)+" or "+NameOfWave(CECorr_HROrgCO2wave) +" has the wrong number of points.  Aborting from HROrgCheck_HRCO2SetVarProc"
	endif
		
	duplicate/o/free HROrgCO2 gasCO2
	
	string str1, str2
	variable PrefixVal, flag, Xmin, Xmax
	
	ControlInfo /W=HROrgCheck_panel HRCO2_timeScalar
	variable scalarFlag = V_Value
	
	ControlInfo /W=HROrgCheck_panel  HRCO2scalar_setvar
	variable scalarValue = numtype(V_Value) == 0 ?  V_Value : 1

	if (!scalarFlag)		// time dependent
		ControlInfo/W=HROrgCheck_Panel HRCO2_timeDepStr
		wave/z CO2Wave = $"root:"+S_Value
		if (!WaveExists(CO2Wave) || numpnts(N2)!=numpnts(CO2Wave))
			abort "The wave root:"+S_Value+" does not exist or has the wrong number of points.  Cannot proceed. The syntax for using a time dependent todo wave for this function is to simply enter the name of the time dependent wave. Aborting from HROrgCheck_HRCO2SetVarProc"	
		endif
		gasCO2 = scalarValue*CO2Wave[p]*1.36*1.28*1.14*N2[p] 
	else
		gasCO2 = scalarValue* 0.00037*1.36*1.28*1.14*N2[p] 
 	endif	
	
	HROrgCO2 =CO2 - gasCO2
	HROrgCO2 = HROrgCO2/(RIE_HROrgCO2*CEwave[p]*specCorrwave[p])

	CurveFit/Q/NTHR=0/ODR=2 line  root:elementalAnalysis:HROrgCO2 /X=root:elementalAnalysis:HROrgC2H3O 
	wave W_coef
	make/o/n=2 root:ElementalAnalysis:HROrgCO2Fit/wave = HROrgCO2Fit
	Xmin = min(0, WaveMin(HROrgC2H3O))
	Xmax = WaveMax(HROrgC2H3O)
	HROrgCO2Fit[0] =  W_coef[0]+W_coef[1]*Xmin
	HROrgCO2Fit[1] = W_coef[0]+W_coef[1]*Xmax
	SetScale/P x Xmin, abs(Xmin) + Xmax,"", HROrgCO2Fit

	Killwaves/z W_coef, W_sigma,M_Jacobian  //1.21E

End


//1.15O
Function HROrgCheck_HRCO2_declareStep2(ctrlName) : ButtonControl
	String ctrlName

	variable scalarFlag, scalarVal
	string TimeDepStr="", formulaTimeDep, formulaTimeNoDep

	ControlInfo/W=HROrgCheck_Panel HRCO2_step1bNoTimeDep		//1.19E
	formulaTimeNoDep = S_Value // S_title

	ControlInfo/W=HROrgCheck_Panel HRCO2_step1bTimeDep		//1.19E
	formulaTimeDep = S_Value // S_title

	ControlInfo/W=HROrgCheck_Panel HRCO2_timeDepStr
	TimeDepStr = S_Value
	wave/z TimeDepWave = $"root:"+TimeDepStr
	
	ControlInfo/W=HROrgCheck_Panel HRCO2_timeScalar
	scalarFlag = V_Value

	ControlInfo/W=HROrgCheck_Panel HRCO2scalar_setvar
	scalarVal = V_Value
// for HR
	if (!scalarFlag && !WaveExists(TimeDepWave))
		abort "CO2 time dependent wave "+TimeDepStr+" does not exist in the root file. Please create it or deselect time dependent wave.  Aborting from HROrgCheck_HRCO2_declareStep2"
	endif

	if (stringmatch (ctrlName, "HRCO2_Step2_HR") )
		variable pos
		wave/t HR_specMassAlgebra = root:HR_frag:HR_specMassAlgebra
		wave/t HR_frag_air = root:HR_frag:HR_frag_air
		
		FindValue/TEXT="CO2"/TXOP=4  HR_specMassAlgebra
		pos = V_Value
		
		if (scalarFlag)
			HR_frag_air[pos] = num2str(scalarVal)+"*"+HR_FRAGCO2AIR // formulaTimeNoDep //"*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]"   //1.19E
		else
			HR_frag_air[pos] = num2str(scalarVal)+"*"+TimeDepStr+ReplaceString("0.00037", HR_FRAGCO2AIR, "") //"*1.36*1.28*1.14*HR_frag_air[{N2}]" 
		endif		
		print "// The user declared a CO2 scalar value of "+ num2str(scalarVal)+"*"+TimeDepStr+" for the HR frag wave at "+time() + " "+ date() 
	elseif (stringmatch (ctrlName, "HRCO2_Step2_UMR") )
// for UMR
		wave/t frag_CO2 = root:frag:frag_CO2
		if (scalarFlag)
			frag_CO2[43] = num2str(scalarVal)+"*"+UMR_FRAGCO2AIR // formulaTimeNoDep // "*0.00037*1.36*1.28*1.14*frag_air[28]" 
		else  //bug of extra * fixed in 1.20O
			frag_CO2[43] = num2str(scalarVal)+"*"+TimeDepStr+ReplaceString("0.00037", UMR_FRAGCO2AIR, "") // "*1.36*1.28*1.14*frag_air[28]" 
		endif		
		print "// The user declared a CO2 scalar value of "+ num2str(scalarVal)+"*"+TimeDepStr+" for the UMR frag wave at "+time() + " "+ date() 
	endif
	
End


//1.15O
Function HROrgCHeck_HRCO2_declare(ctrlName) : ButtonControl
	String ctrlName
	HROrgCheck_HRCO2_declareStep2( "HRCO2_Step2_HR")
	HROrgCheck_HRCO2_declareStep2( "HRCO2_Step2_UMR")
End


/////////////////////////////////////////////////////////////////////


//Function pk_BrowseCanagartna(ctrlName) : ButtonControl		// 1.16Z
//	String ctrlName
//	BrowseURL "http://www.atmos-chem-phys.net/15/253/2015/acp-15-253-2015.pdf"
//End


//Function SQ_URLButton(ctrlName) : ButtonControl		//1.16M	  1.16Z	
//	String ctrlName
//
//	BrowseURL "http://cires1.colorado.edu/jimenez/Papers/ac071150w_published_complete.pdf"
//End


// When HROrg < HROrg_DL no EA will be calculated (fCHO and fCO2 = nan )
// When HROrgCHO_smoothed < HROrgCHO_DL but HROrg > HROrg_DL HROrgCHO_smoothed gets nanned then linearly interpolated (fCHO not nan)
// When HROrgCHO_smoothed < HROrgCO2_DL but HROrg > HROrg_DL HROrgCO2 _smoothed gets nanned then linearly interpolated  (fCO2 not nan)
Function HROrgCheck_smoothingScalar(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	nvar smoothingVal = root:elementalAnalysis:smoothingVal
//	nvar DLScalar = root:elementalAnalysis:DLScalar
	wave/z HROrg = root:elementalAnalysis:HROrg
	wave/z HROrgCHO = root:elementalAnalysis:HROrgCHO
	wave/z HROrgCO2 = root:elementalAnalysis:HROrgCO2
//	wave HROrgCO2_DL = root:elementalAnalysis:HROrgCO2_DL
//	wave HROrgCHO_DL = root:elementalAnalysis:HROrgCHO_DL
//	wave HROrg_DL = root:elementalAnalysis:HROrg_DL

	if (!WaveExists(HROrgCHO) ||  !WaveExists(HROrgCO2) ||  !WaveExists(HROrg) ) 
		return 0
	endif
	
//	HROrgCheck_UpdateDLscalar()
	
//	make/u/o/n=(numpnts(HROrg)) root:elementalAnalysis:ImpAmb_EAKey/wave=ImpAmb_EAKey
//	ImpAmb_EAKey=0		//0 means all is good

	duplicate/o/free HROrg todoWaveMask
	todoWaveMask = numtype(HROrg[p]) == 0 ? 1 : nan

	// todo mask is 1s (good) and nans
	// detection limit mask  is 1s (good) and non 1s (bad)
		
	// HROrg and ImpAmb_EAKey
	Duplicate/O HROrg, root:elementalAnalysis:HROrg_smoothed/wave = HROrg_smoothed
	gen_InterpolateAcrossTime(root:index:t_series,HROrg_smoothed)	
	if (smoothingVal>0)			//1.19E
		sq_smooth_nans(HROrg_smoothed, smoothingVal)
	endif
//	ImpAmb_EAKey += HROrg_smoothed[p]<HROrg_DL*DLScalar ? 1 : 0   // 2 means HROrg< DL
//	HROrg_smoothed = ImpAmb_EAKey[p] !=0 ? nan : HROrg_smoothed[p] 
	HROrg_smoothed *= todoWaveMask

	// HROrgCHO and ImpAmb_EAKey
	// smooth
	Duplicate/O HROrgCHO, root:elementalAnalysis:HROrgCHO_smoothed/wave = HROrgCHO_smoothed
	gen_InterpolateAcrossTime(root:index:t_series,HROrgCHO_smoothed)	
	if (smoothingVal>0) 	//1.19E
		sq_smooth_nans(HROrgCHO_smoothed, smoothingVal)
	endif

	// HROrgCHO get rid of bad points
//	ImpAmb_EAKey +=   HROrgCHO_smoothed[p]<HROrgCHO_DL*DLScalar ? 2 : 0    // 4 means HROrgCHO< DL
//	HROrgCHO_smoothed[p] = mod(ImpAmb_EAKey[p], 3)==0 ? nan : HROrgCHO_smoothed[p]
	gen_InterpolateAcrossTime(root:index:t_series,HROrgCHO_smoothed)	
//	HROrgCHO_smoothed = ImpAmb_EAKey[p] !=0 ? nan : HROrgCHO_smoothed[p] 
	HROrgCHO_smoothed *= todoWaveMask
	
	// HROrgCO2 and ImpAmb_EAKey
	// smooth
	Duplicate/O HROrgCO2, root:elementalAnalysis:HROrgCO2_smoothed/wave = HROrgCO2_smoothed
	gen_InterpolateAcrossTime(root:index:t_series,HROrgCO2_smoothed)	
	if (smoothingVal>0) 	//1.19E
		sq_smooth_nans(HROrgCO2_smoothed, smoothingVal)
	endif

	// HROrgCO2 get rid of bad points
//	ImpAmb_EAKey +=   HROrgCO2_smoothed[p]<HROrgCO2_DL*DLScalar ? 4 : 0  // 8 means HROrgCO2< DL
//	HROrgCO2_smoothed[p] = mod(ImpAmb_EAKey[p], 5)==0 ? nan : HROrgCO2_smoothed[p]
	gen_InterpolateAcrossTime(root:index:t_series,HROrgCO2_smoothed)	
//	HROrgCO2_smoothed = ImpAmb_EAKey[p] !=0 ? nan : HROrgCO2_smoothed[p] 
	HROrgCO2_smoothed *= todoWaveMask
	
	Duplicate/O HROrgCHO, root:elementalAnalysis:fCHO/wave=fCHO
	Duplicate/O HROrgCO2, root:elementalAnalysis:fCO2/wave=fCO2

	fCHO = HROrgCHO_smoothed/HROrg_smoothed
	fCHO = limit(fCHO[p],0, 1)

	fCO2 = HROrgCO2_smoothed/HROrg_smoothed
	fCO2 = limit(fCO2[p],0, 1)

//	fCHO *= ImpAmb_EAKey[p] == 0 ? 1 : nan
//	fCO2 *= ImpAmb_EAKey[p] == 0 ? 1 : nan

End


//1.15O
//Function HROrgCheck_UpdateDLscalar()
//
//	nvar DLScalar = root:elementalAnalysis:DLScalar
//	string TopWname = WinName(0, 65)
//	variable PopWinExists = strlen(winList("PK_HROrgCheckTSGraph", ";", ""))>0
//
//	if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
// 		DOWindow/F HROrgCheck_Panel
//	  	SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
//	 	ModifyGraph muloffset(HROrgCO2_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrgCHO_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrg_DL)={0,DLScalar}	
//		SetActiveSubwindow ##
// 		DOWindow/F PK_HROrgCheckTSGraph
// 		ModifyGraph muloffset(HROrgCO2_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrgCHO_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrg_DL)={0,DLScalar}		
//	else
// 		if (PopWinExists)
// 			DOWindow/F PK_HROrgCheckTSGraph
//	 		ModifyGraph muloffset(HROrgCO2_DL)={0,DLScalar}
//			ModifyGraph muloffset(HROrgCHO_DL)={0,DLScalar}
//			ModifyGraph muloffset(HROrg_DL)={0,DLScalar}	
//	  	endif
//	  	DOWindow/F HROrgCheck_panel
//	  	SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
// 		ModifyGraph muloffset(HROrgCO2_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrgCHO_DL)={0,DLScalar}
//		ModifyGraph muloffset(HROrg_DL)={0,DLScalar}		
//		SetActiveSubwindow ##
//	endif
//
//End	

// 1.15O
Function PK_populate_HROrgCheckTSGraph()

	wave/z HROrg= root:elementalAnalysis:HROrg	
	wave/z HROrgCHO = root:elementalAnalysis:HROrgCHO
	wave/z HROrgCO2 = root:elementalAnalysis:HROrgCO2	
//	wave/z HROrg_DL= root:elementalAnalysis:HROrg_DL	
//	wave/z HROrgCHO_DL = root:elementalAnalysis:HROrgCHO_DL
//	wave/z HROrgCO2_DL = root:elementalAnalysis:HROrgCO2_DL	
	wave/z HROrg_smoothed= root:elementalAnalysis:HROrg_smoothed	
	wave/z HROrgCHO_smoothed = root:elementalAnalysis:HROrgCHO_smoothed	
	wave/z HROrgCO2_smoothed = root:elementalAnalysis:HROrgCO2_smoothed	
	wave/z fCHO = root:elementalAnalysis:fCHO
	wave/z fCO2 = root:elementalAnalysis:fCO2
//	wave/z ImpAmb_EAKey = root:elementalAnalysis:ImpAmb_EAKey
		
	if (!WaveExists(HROrgCHO_smoothed) || !WaveExists(HROrgCO2_smoothed) )		// assume that if these two exist, they all do.
		return 0
	endif
	
	if (strlen(TraceNameList("", ";", 1) )>0 )
		return 0
	endif

	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:elementalAnalysis:
//	AppendToGraph/R=EAKey ImpAmb_EAKey  vs ::index:t_series
	AppendToGraph HROrg, HROrg_smoothed vs ::index:t_series
	AppendToGraph HROrgCHO, HROrgCO2 vs ::index:t_series
	AppendToGraph HROrgCHO_smoothed,HROrgCO2_smoothed vs ::index:t_series
//	AppendToGraph HROrgCHO_DL,HROrgCO2_DL,HROrg_DL vs ::index:t_series
	AppendToGraph/R fCHO,fCO2 vs ::index:t_series
	SetDataFolder fldrSav0
	
	ModifyGraph mode=4
	ModifyGraph marker(HROrgCHO)=19,marker(HROrgCO2)=19,marker(fCO2)=5,marker(fCHO)=5
	ModifyGraph marker(HROrg)=19
	ModifyGraph rgb(HROrgCHO)=(39168,26112,0),rgb(HROrgCO2)=(0,39168,19712),rgb(fCO2)=(0,24576,65280)
	ModifyGraph rgb(fCHO)=(65280,0,0),rgb(HROrg)=(0,0,0),rgb(HROrgCHO_smoothed)=(65280,43520,0)
	ModifyGraph rgb(HROrgCO2_smoothed)=(0,65280,65280)
//	ModifyGraph rgb(HROrgCO2_DL)=(32768,40704,65280), rgb(HROrgCHO_DL)=(39168,39168,0), rgb(HROrg_DL)=(30464,30464,30464)

	ModifyGraph msize(HROrgCHO)=2,msize(HROrgCO2)=2,msize(fCO2)=2,msize(fCHO)=2
	ModifyGraph msize(HROrg)=1,msize(HROrgCHO_smoothed)=2,msize(HROrgCO2_smoothed)=2
	ModifyGraph gaps(HROrgCHO)=0,gaps(HROrgCO2)=0,gaps(fCO2)=0,gaps(fCHO)=0
	ModifyGraph marker(HROrgCHO_smoothed)=29, marker(HROrgCO2_smoothed)=29, marker(HROrg_smoothed)=29
	ModifyGraph rgb(HROrg_smoothed)=(39168,39168,39168)
	ModifyGraph msize(HROrg_smoothed)=2

//	ModifyGraph mode(HROrgCHO_DL)=0,lsize(HROrgCHO_DL)=2,mode(HROrgCO2_DL)=0
//	ModifyGraph lsize(HROrgCO2_DL)=2,mode(HROrg_DL)=0,lsize(HROrg_DL)=2
//	ModifyGraph gaps(HROrgCHO_DL)=0,gaps(HROrgCO2_DL)=0,gaps(HROrg_DL)=0

	ModifyGraph grid(bottom)=2,grid(right)=2
	ModifyGraph zero(left)=1,zero(right)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(bottom)=(34816,34816,34816),gridRGB(right)=(34816,34816,34816)
	ModifyGraph dateInfo(bottom)={0,1,0}
//	ModifyGraph freePos(EAKey)=-50
//	ModifyGraph tick(EAKey)=3,nticks(EAKey)=0,axThick(EAKey)=0
//	ModifyGraph lSize(ImpAmb_EAKey)=2, mode(ImpAmb_EAKey)=1
//	ModifyGraph zColor(ImpAmb_EAKey)={:ElementalAnalysis:ImpAmb_EAKey,1,30,Geo32,1}
	
	Label left "HROrgX, g/m3"
	Label bottom " "
	Label right "f\\BCHO\\M, f\\BCO2"
//	SetAxis EAKey 1,2
	SetAxis/A/E=3  left 		// -0.1,0.3		//1.16F
	SetAxis/A/E=3 right 		// -0.1,0.3	//1.16F
	legend

	if ( stringmatch(WinName(0, 65),"PK_HROrgCheckTSGraph") )
		ControlBar 150
		HROrgCheck_ImpAmbControls(0)
		HROrgCheck_EATSgraph("ImpAm_checkAll",1)
	endif
	PK_ImprAmb_SetTracesFor()
End


//1.15O
Function HROrgCheck_calcfCO2fCHO(ctrlName) : ButtonControl
string ctrlName

	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$"root:"+todoStr			//1.44B
	nvar HR_checkUseAB = root:HR_panel:HR_checkUseAB
	svar HRResults_ionList = root:HR_panel:HRResults_ionList
	nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0		//1.17c
	
	nvar ams_time_interval=root:panel:ams_time_interval
	nvar ams_time_custom=root:panel:ams_time_custom
	nvar ams_time_saved=root:panel:ams_time_saved
	ams_time_interval=(strsearch(ctrlname,"time_interval",0)>=0)			//1.59E
	ams_time_custom=(strsearch(ctrlname,"time_custom",0)>=0)
	ams_time_saved=(strsearch(ctrlname,"time_saved",0)>=0)
	
	if (ams_time_interval!=1)
		sq_timebase_check("HRResults_time_saved",1)
		sq_timebase_check("ams_time_saved",1)
	endif

	string paramStr="", speclistStr, dummyStr, destList, WList, spectraType, specTypeInitial
	string OrigHRResults_ionList= HRResults_ionList

 	ControlInfo/W=HR_Analysis_Panel HRResults_pop_dataSet
	if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Get List") ) // 1.19E || !(stringMatch(S_Value, "HRDiffStick") || stringMatch(S_Value, "HROMinusCStick") ))
		abort "Please select the data type from the Pika  HR results drop down menu to be HRDiffStick or HROMinusCStick."
	else
		spectraType=S_Value
	endif
//	if (!stringmatch(spectraType[0,1], "HR"))		//PToF		//1.19E
//		abort "This is not yet possible. - Aborting from HROrgCheck_calcfCO2fCHO"
//	else			//MS
		if (   strsearch(spectraType, "OMinusC", 0)   >=0	) 
			specTypeInitial="M"
		else 
			specTypeInitial=spectraType[2]		//i.e. HROpenStick
		endif
//	endif

 	HROrgCheck_CO2Revert("")		// make sure that the value are updated

	HRResults_ionList = "HROrgCHO,HROrgCO2,HROrg"

	speclistStr = HRResults_ionList
	
	// for now we will calculate all species in the text wave list except 
	HR_GetParamStr(paramstr,speclistStr,0,3)
	paramStr+="filter_op:0;"
	paramStr+="corr_op:"+num2str(HR_checkUseAB)+";"
	paramstr+="ug_op:"+num2str(1)+";"		// always do in units of g/m3
	paramstr+="cache_op:"+num2str(0)+";"
	paramstr+="product_type:1;"
	paramstr+="destlist:"+"HROrgCHO/HROrgCO2/HROrg/;"
	paramstr+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"		//1.17c
	
	PK_saveReinstateHROrgfrag(1)   //1.15E
	
	WList = HR_calc_MSVsTime("temp", spectraType,specTypeInitial, paramstr, "")

	PK_saveReinstateHROrgfrag(0)   //1.15E

	wave HROrgCHO_M_temp = $"root:HROrgCHO_"+specTypeInitial+"_temp"
	wave HROrgCO2_M_temp =  $"root:HROrgCO2_"+specTypeInitial+"_temp"
	wave HROrg_M_temp = $"root:HROrg_"+specTypeInitial+"_temp"
	duplicate/o HROrgCHO_M_temp $"root:elementalAnalysis:HROrgCHO"
	duplicate/o HROrgCO2_M_temp $"root:elementalAnalysis:HROrgCO2"
	duplicate/o HROrg_M_temp $"root:elementalAnalysis:HROrg"
	duplicate/o HROrgCHO_M_temp $"root:elementalAnalysis:HROrgCHO_smoothed"
	duplicate/o HROrgCO2_M_temp $"root:elementalAnalysis:HROrgCO2_smoothed"
	duplicate/o HROrg_M_temp $"root:elementalAnalysis:HROrg_smoothed"
//	duplicate/o HROrg_M_temp $"root:elementalAnalysis:ImpAmb_EAKey"/wave=ImpAmb_EAKey
	duplicate/o HROrg_M_temp $"root:elementalAnalysis:fCO2"/wave=fCO2
	duplicate/o HROrg_M_temp $"root:elementalAnalysis:fCHO"/wave=fCHO
	fastop fCO2=(nan)
	fastop fCHO=(nan)
//	fastop ImpAmb_EAKey=1
	killwaves/z HROrgCHO_M_temp, HROrgCO2_M_temp, HROrg_M_temp
		
// now for closed
//	PK_saveReinstateHROrgfrag(1)   //1.15E
//	
//	WList = HR_calc_MSVsTime("temp", "HRClosedStick", "C", paramstr, "HRCTotSigErr")
//
//	PK_saveReinstateHROrgfrag(0)   //1.15E
//
//	wave HROrgCHO_C_temp = root:HROrgCHO_C_temp
//	wave HROrgCO2_C_temp = root:HROrgCO2_C_temp
//	wave HROrg_C_temp = root:HROrg_C_temp	
//	duplicate/o HROrgCHO_C_temp $"root:elementalAnalysis:HROrgCHO_C"
//	duplicate/o HROrgCO2_C_temp $"root:elementalAnalysis:HROrgCO2_C"
//	duplicate/o HROrg_C_temp $"root:elementalAnalysis:HROrg_C"
//	killwaves/z HROrgCHO_C_temp, HROrgCO2_C_temp, HROrg_C_temp
//
//	wave HROrgCHO_C_temp_err = root:HROrgCHO_C_temp_err
//	wave HROrgCO2_C_temp_err = root:HROrgCO2_C_temp_err
//	wave HROrg_C_temp_err = root:HROrg_C_temp_err
//	duplicate/o HROrgCHO_C_temp_err $"root:elementalAnalysis:HROrgCHO_DL"/wave = HROrgCHO_DL
//	duplicate/o HROrgCO2_C_temp_err $"root:elementalAnalysis:HROrgCO2_DL"/wave = HROrgCO2_DL
//	duplicate/o HROrg_C_temp_err $"root:elementalAnalysis:HROrg_DL"/wave = HROrg_DL
//	killwaves/z HROrgCHO_C_temp_err, HROrgCO2_C_temp_err, HROrg_C_temp_err
//	HROrgCHO_DL*=3*sqrt(2)
//	HROrgCO2_DL*=3*sqrt(2)
//	HROrg_DL*=3*sqrt(2)
//	HROrgCHO_DL = HROrgCHO_DL[p] == 0 ? nan :HROrgCHO_DL[p]
//	HROrgCO2_DL = HROrgCO2_DL[p] == 0 ? nan :HROrgCO2_DL[p]
//	HROrg_DL = HROrg_DL[p] == 0 ? nan :HROrg_DL[p]
	
	HRResults_ionList =OrigHRResults_ionList

 	if (stringmatch(WinName(0,64), "HROrgCheck_Panel"))
 		ControlInfo/w=HROrgCheck_Panel ImpAm_setvarSmooth
  		SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
 		PK_populate_HROrgCheckTSGraph()
		HROrgCheck_smoothingScalar("ImpAm_setvarSmooth",V_Value,"","")
//	 	SetActiveSubwindow ##
	endif
End


Function PK_ImprAmb_SetTracesFor()

	string cStr=""
	ControlInfo ImpAm_checkCHO
	if (V_value)
		cstr = "ImpAm_checkCHO"
	else
		ControlInfo ImpAm_checkCO2
		if (V_value)
			cstr = "ImpAm_checkCO2"
		else
			ControlInfo ImpAm_checkHROrg
			if (V_value)
				cstr = "ImpAm_checkHROrg"
			else	
				ControlInfo ImpAm_checkfHROrg
				if (V_value)
					cstr = "ImpAm_checkHROrg"
				else
					ControlInfo ImpAm_checkall
					if (V_value)
						cstr = "ImpAm_checkall"
					endif
				endif
			endif
		endif
	endif

	HROrgCheck_EATSgraph(cStr,1)

End

//1.15O
//Function sq_CheckBatchAandB(strA, strB, strType)
//string strA, strB, strType
//
//	wave/t spec_list = root:frag:spec_list
//	variable val_A, val_B, posA, posB
//	FindValue/Text = strA/TXOP = 4 spec_list
//	posA = V_value
//	FindValue/Text = strB/TXOP = 4 spec_list
//	posB = V_value
//	if (posA<0 || posB < 0)
//		abort "Could not find the species in the root:frag:spec_list wave.  Aborting from sq_CheckBatchAandB"
//	endif
//
//	string s_A, s_B
//	strswitch (strType)
//		case "RIE" :
//			wave IEfac_list = root:frag:IEfac_List
//			val_A = IEfac_list[posA]
//			val_B = IEfac_list[posB]
//			if (val_A != val_B)
//				sq_butt_reviewBatch("")
//				abort "The "+strType+" for "+strA+" and "+strB+" do not match.  Aborting from sq_CheckBatchAandB"
//			endif
//		break
//		case "CE":
//			wave CEfac_List = root:frag:CEfac_List
//			val_A = CEfac_List[posA]
//			val_B = CEfac_List[posB]
//			if (val_A != val_B)
//				sq_butt_reviewBatch("")
//				abort "The "+strType+" for "+strA+" and "+strB+" do not match.  Aborting from sq_CheckBatchAandB"
//			endif
//		break
//		case "CEWave_list" :
//			wave/t CEWave_list = root:frag:CEWave_list
//			s_A = CEWave_list[posA]
//			s_B = CEWave_list[posB]
//			if (!stringmatch(s_A, s_B))
//				sq_butt_reviewBatch("")
//				abort "The "+strType+" for "+strA+" and "+strB+" do not match.  Aborting from sq_CheckBatchAandB"
//			endif
//		break
//		case "speccorr_List" :
//			wave/t speccorr_List = root:frag:speccorr_List
//			s_A = speccorr_List[posA]
//			s_B = speccorr_List[posB]
//			if (!stringmatch(s_A, s_B))
//				sq_butt_reviewBatch("")
//				abort "The "+strType+" for "+strA+" and "+strB+" do not match.  Aborting from sq_CheckBatchAandB"
//			endif
//		break
//	endswitch
//	
//End
//
//
//1.15O
//Function PK_saveReinstateHROrgfrag(copyOrReinstate)
//variable copyOrReinstate
//	
//	wave/t HR_frag_organic = root:HR_frag:HR_frag_organic
//	if (copyOrReinstate) // make a copy and then fill in with values from original Aiken at al paper
//		duplicate/o/t root:HR_frag:HR_frag_organic,  root:HR_frag:HR_frag_organic_ORIG
//
//		wave/t HR_specMassAlgebra= root:HR_frag:HR_specMassAlgebra
//		variable CO_pos, H2O_pos, HO_pos, O_pos	
//		FindValue/TEXT="CO"/TXOP=4 HR_specMassAlgebra
//		CO_pos	=V_Value
//		FindValue/TEXT="H2O"/TXOP=4 HR_specMassAlgebra
//		H2O_pos =V_Value
//		FindValue/TEXT="OH"/TXOP=4 HR_specMassAlgebra
//		HO_pos	=V_Value
//		FindValue/TEXT="O"/TXOP=4 HR_specMassAlgebra
//		O_pos	=V_Value
//		
//		HR_frag_organic[O_pos]= "0.04*HR_frag_organic[{H2O}]"
//		HR_frag_organic[HO_pos]= "0.25*HR_frag_organic[{H2O}]"
//		HR_frag_organic[H2O_pos]= "0.225*HR_frag_organic[{CO2}]"
//		HR_frag_organic[CO_pos]= "HR_frag_organic[{CO2}]"
//	else
//		duplicate/o root:HR_frag:HR_frag_organic_ORIG, root:HR_frag:HR_frag_organic
//	endif
//
//End

//1.15O
Function PK_ShowDetails_j15NNcheck(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
	nvar Showj15NNTables=root:elementalAnalysis:Showj15NNTables
	Button j15NN_Step2_HR disable=!Showj15NNTables
	Button j15NNx_PK_j15NNAllMassesTable disable=!Showj15NNTables
	Button j15NN_Step2_UMR disable=!Showj15NNTables
	Button j15NNx_pk_j15NNUMRFragTable disable=!Showj15NNTables
	
	SetWindow HROrgCheck_Panel#j15NNUMRFragTable, Hide=(!Showj15NNTables)
	SetWindow HROrgCheck_Panel#j15NNAllMassesTable, Hide=(!Showj15NNTables)
End


//1.15O
Function PK_ShowDetails_HRrgCO2check(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar ShowCO2Tables=root:elementalAnalysis:ShowCO2Tables
	Button HRCO2_Step2_HR disable=!ShowCO2Tables
	Button HRCO2x_PK_HROrgCO2Table disable=!ShowCO2Tables
	Button HRCO2_Step2_UMR disable=!ShowCO2Tables
	Button HRCO2x_pk_air44UMRFragTable disable=!ShowCO2Tables
		
 	SetWindow HROrgCheck_Panel#air44UMRFragTable, Hide=(!ShowCO2Tables) 
	SetWindow HROrgCheck_Panel#HRfragCO2Table, Hide=(!ShowCO2Tables)

End


//1.15O
Function HROrgCheck_CO2TimeDep(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	variable scalar = strsearch(ctrlName, "calar",0)>=0
	if (scalar)
		SetVariable HRCO2_timeDepStr disable = checked
		scalar = checked
	else
		SetVariable HRCO2_timeDepStr disable = !checked
		scalar = !checked
	endif
	CheckBox HRCO2_timeScalar value = scalar
	Checkbox HRCO2_timeDependent value = !scalar

	TitleBox HRCO2_step1bTimeDep disable = scalar, title =ReplaceString("0.00037", HR_FRAGCO2AIR, "")
	TitleBox HRCO2_step1bNoTimeDep disable =!scalar, title ="*"+HR_FRAGCO2AIR

End


//1.15O
// entries can look like
// 1*CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]			//A time wave dependent with scalar
// CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]			//B time wave dependent withOUT scalar
// 1*CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//C time wave dependent,0.00037
// CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//D time wave dependent,0.00037

// 0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]		//E default
// 0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]			//F user mod CO2 constant
// 1*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]		//G default with scalar
// 1*0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]		//H user mod CO2 constant with scalar
Function HROrgCheck_CO2Revert(ctrlName) : ButtonControl
	String ctrlName

	string frag, co2name
	variable pos,scalarVal, scalarFlag

	wave/t HR_frag_air = root:HR_frag:HR_frag_air
	wave/t HR_specMassAlgebra = root:HR_frag:HR_specMassAlgebra
	FindValue/Text = "CO2"/TXop = 4  HR_specMassAlgebra
	pos = V_Value
	frag =HR_frag_air[pos]
	frag = ReplaceString(" ", frag,"")
	frag = ReplaceString("*1.36*1.28*1.14*HR_frag_air[{N2}]", frag,"")
//	frag = ReplaceString(HRFRAGCO2AIR, frag,"")
	if (strsearch(frag,"0.00037",0) >=0)  // C D or E or G
		// can be
		// 1*CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//C time wave dependent with scalar
		// CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//D time wave dependent
		// 0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]				//E default
		// 1*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]				//G default with scalar

		frag = ReplaceString("*0.00037", frag,"")
		// 1*CO2AdjWave	//C time wave dependent with scalar
		// CO2AdjWave	//D time wave dependent
		// 0.00037		//E default
		// 1				//G default with scalar
		wave/z CO2TimeDepWave = $"root:"+frag
		if (WaveExists(CO2TimeDepWave))			// CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//D time wave dependent
			scalarFlag=0
			co2name=frag
			scalarVal = 1				
			SetVariable HRCO2_timeDepStr value = _STR:co2name
			TitleBox HRCO2_step1bNoTimeDep title=""
			TitleBox HRCO2_step1bTimeDep title="*"+HR_FRAGCO2AIR
		elseif (stringmatch(frag, "0.00037")>0)	// 0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]				//E default
			scalarFlag=1
			scalarVal = 1				
			SetVariable HRCO2_timeDepStr value = _STR:""
			TitleBox HRCO2_step1bNoTimeDep title="*"+HR_FRAGCO2AIR
			TitleBox HRCO2_step1bTimeDep title=""
		elseif(numtype(str2num(frag))==0)					// 1*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]				//G default with scalar
			scalarFlag=1
			scalarVal = str2num(frag)				
			SetVariable HRCO2_timeDepStr value = _STR:""
			TitleBox HRCO2_step1bNoTimeDep title="*"+HR_FRAGCO2AIR
			TitleBox HRCO2_step1bTimeDep title=""
		elseif(itemsInLIst(frag, "*")==2)				// 1*CO2AdjWave*0.00037*1.36*1.28*1.14*HR_frag_air[{N2}]	//C time wave dependent with scalar
			scalarVal = str2num(stringFromList(0, frag, "*"))
			co2name=stringFromList(1, frag, "*")
			wave/z CO2TimeDepWave = $"root:"+co2name
			if (Numtype(scalarVal)==0 && WaveExists(CO2TimeDepWave))		// just handle any remaining case like this... maybe the user entered a typo??
				scalarFlag = 0
				SetVariable HRCO2_timeDepStr value = _STR:co2name
				TitleBox HRCO2_step1bNoTimeDep title=""
				TitleBox HRCO2_step1bTimeDep title="*"+HR_FRAGCO2AIR
			else
				scalarFlag = 1
				scalarVal=0
				SetVariable HRCO2_timeDepStr value = _STR:""
				TitleBox HRCO2_step1bNoTimeDep title="Please re-enter the coefficients for the HR CO2 frag"
				TitleBox HRCO2_step1bTimeDep title=""
			endif
			
		else		//itemsInLIst(frag)!=2  a wierd form... has 0.00037 but I'm not sure what else 
			scalarFlag = 1
			scalarVal=0
			SetVariable HRCO2_timeDepStr value = _STR:""
			TitleBox HRCO2_step1bNoTimeDep title="Please re-enter the coefficients for the HR CO2 frag"
			TitleBox HRCO2_step1bTimeDep title=""
		endif
	else			// A B or F
		// can be
		// 1*CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]		//A time wave dependent with scalar
		// CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]		//B time wave dependent withOUT scalar
		// 0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]			//F user mod CO2 constant
		// 1*0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]		//H user mod CO2 constant with scalar
		if (itemsInList(frag, "*") == 2)				//A time wave dependent with scalar or //H user mod CO2 constant with scalar
			co2name = stringFromList(1, frag, "*")
			scalarVal = str2num(stringFromList(0, frag, "*"))
			wave/z CO2TimeDepWave = $"root:"+co2name
			if (WaveExists(CO2TimeDepWave))  // 1*CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]		//A time wave dependent with scalar
				scalarFlag=0
				SetVariable HRCO2_timeDepStr value = _STR:co2name
				TitleBox HRCO2_step1bNoTimeDep title=""
				TitleBox HRCO2_step1bTimeDep title= ReplaceString("0.00037", HR_FRAGCO2AIR, "")// "*1.36*1.28*1.14*HR_frag_air[{N2}]"
			else									// 1*0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]		//H user mod CO2 constant with scalar			
				scalarFlag=1
				SetVariable HRCO2_timeDepStr value = _STR:""
				TitleBox HRCO2_step1bNoTimeDep title="*"+co2name+ ReplaceString("0.00037", HR_FRAGCO2AIR, "") // "*1.36*1.28*1.14*HR_frag_air[{N2}]"
				TitleBox HRCO2_step1bTimeDep title=""
			endif
		else				//B time wave dependent withOUT scalar or 	//F user mod CO2 constant
			co2name = stringFromList(0, frag, "*")
			wave/z CO2TimeDepWave = $"root:"+co2name
			if (WaveExists(CO2TimeDepWave))  // CO2Wave*1.36*1.28*1.14*HR_frag_air[{N2}]		//B time wave dependent withOUT scalar
				scalarFlag=0
				scalarVal = 1		
				SetVariable HRCO2_timeDepStr value = _STR:co2name
				TitleBox HRCO2_step1bNoTimeDep title=""
				TitleBox HRCO2_step1bTimeDep title= ReplaceString("0.00037", HR_FRAGCO2AIR, "") // "*1.36*1.28*1.14*HR_frag_air[{N2}]"
			else  			// 0.0004*1.36*1.28*1.14*HR_frag_air[{N2}]			//F user mod CO2 constant
				scalarFlag = 1		
				scalarVal = 1		
				SetVariable HRCO2_timeDepStr value = _STR:""
				TitleBox HRCO2_step1bNoTimeDep title="*"+co2name+ ReplaceString("0.00037", HR_FRAGCO2AIR, "")  //"*1.36*1.28*1.14*HR_frag_air[{N2}]"
				TitleBox HRCO2_step1bTimeDep title=""
			endif
		endif
		
	endif

	CheckBox HRCO2_timeDependent value= !scalarFlag
	CheckBox HRCO2_timeScalar value= scalarFlag

	SetVariable HRCO2_timeDepStr disable = scalarFlag
	SetVariable HRCO2scalar_setvar value = _Num:scalarVal	

	ControlInfo/W=HROrgCheck_panel HRCheckTab
	if (V_Value==1)		//1.20N
		HROrgCheck_CO2TimeDep("HRCO2_timeScalar",scalarFlag)
	endif
	
	HROrgCheck_HRCO2SetVarProc("HRCO2scalar_setvar",scalarVal,"","")

//	TitleBox HRCO2_step1bTimeDep disable = scalarFlag  //, title ="*"+ReplaceString("0.00037", HRFRAGCO2AIR, "")
//	TitleBox HRCO2_step1bNoTimeDep disable =!scalarFlag  // , title ="*"+HRFRAGCO2AIR
End


//1.15O
Function HROrgCheck_ShowCHO(which)
variable which

	ModifyGraph hideTrace=1
	ModifyGraph hideTrace(HROrgCHO)=0
//	ModifyGraph hideTrace(HROrgCHO_DL)=0
	ModifyGraph hideTrace(HROrgCHO_smoothed)=0
	ModifyGraph hideTrace(fCHO)=0
////	modifygraph mask(ImpAmb_EAKey) ={root:elementalAnalysis:ImpAmb_EAKey, 2, 2}
//	ModifyGraph hideTrace(ImpAmb_EAKey)=0
	HROrgCheck_UpdateRadio(which)

End


//1.15O
Function HROrgCheck_ShowCO2(which)
variable which

	ModifyGraph hideTrace=1
	ModifyGraph hideTrace(HROrgCO2)=0
//	ModifyGraph hideTrace(HROrgCO2_DL)=0
	ModifyGraph hideTrace(HROrgCO2_smoothed)=0
	ModifyGraph hideTrace(fCO2)=0
//	modifygraph mask(ImpAmb_EAKey) ={root:elementalAnalysis:ImpAmb_EAKey, 2, 4}
//	ModifyGraph hideTrace(ImpAmb_EAKey)=0
	HROrgCheck_UpdateRadio(which)
End


//1.15O
Function HROrgCheck_ShowHROrg(which)
variable which

	ModifyGraph hideTrace=1
	ModifyGraph hideTrace(HROrgCO2)=0
	ModifyGraph hideTrace(HROrgCHO)=0
	ModifyGraph hideTrace(HROrgCO2_smoothed)=0
	ModifyGraph hideTrace(HROrgCHO_smoothed)=0
//	ModifyGraph hideTrace(HROrgCO2_DL)=0
//	ModifyGraph hideTrace(HROrgCHO_DL)=0
	ModifyGraph hideTrace(HROrg)=0
	ModifyGraph hideTrace(HROrg_smoothed)=0
//	modifygraph mask(ImpAmb_EAKey) ={root:elementalAnalysis:ImpAmb_EAKey, 2, 7}
//	ModifyGraph hideTrace(ImpAmb_EAKey)=0
	HROrgCheck_UpdateRadio(which)
End


//1.15O
Function HROrgCheck_ShowfX(which)
variable which
	ModifyGraph hideTrace=1
	ModifyGraph hideTrace(fCO2)=0
	ModifyGraph hideTrace(fCHO)=0
//	modifygraph mask(ImpAmb_EAKey) ={root:elementalAnalysis:ImpAmb_EAKey, 2, 7}
//	ModifyGraph hideTrace(ImpAmb_EAKey)=0
	HROrgCheck_UpdateRadio(which)
End


//1.15O
Function HROrgCheck_ShowAll(which)
variable which

	ModifyGraph hideTrace=0
//	modifygraph mask(ImpAmb_EAKey) ={root:elementalAnalysis:ImpAmb_EAKey, 2, 7}
//	ModifyGraph hideTrace(ImpAmb_EAKey)=0
	HROrgCheck_UpdateRadio(which)
End


//1.15O
Function HROrgCheck_UpdateRadio(which)
variable which

	CheckBox ImpAm_checkCHO  value = which ==1
	CheckBox ImpAm_checkCO2  value = which ==2
	CheckBox ImpAm_checkHROrg  value = which ==3
	CheckBox ImpAm_checkfHROrg  value = which ==4
	CheckBox ImpAm_checkAll  value = which ==5
End


//1.15O
Function HROrgCheck_populate_EA_AAvsIA(HC,OC,OM_OC, waveNameSuffix, Correlstr )
wave HC,OC, OM_OC
string waveNameSuffix, Correlstr

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	if(HRResults_graphOutputType==1)		// new graph
		Display/W=(80,80,550,400) /N=$Correlstr as Correlstr
	elseif(HRResults_graphOutputType==4)
		DoWindow/F $Correlstr
	endif
	
	string waveNameSuffixLess_IA = waveNameSuffix[0, strlen(waveNameSuffix)-4]
	wave OM_OC_AA = $"root:elementalAnalysis:"+ReplaceString(waveNameSuffix,  NameofWave(OM_OC), waveNameSuffixLess_IA)
	wave H_C_AA = $"root:elementalAnalysis:"+ReplaceString(waveNameSuffix,  NameofWave(HC), waveNameSuffixLess_IA)
	wave O_C_AA = $"root:elementalAnalysis:"+ReplaceString(waveNameSuffix,  NameofWave(OC), waveNameSuffixLess_IA)

	AppendToGraph OM_OC vs OM_OC_AA
	AppendToGraph HC vs H_C_AA
	AppendToGraph OC vs O_C_AA
	ModifyGraph mode=2
	ModifyGraph lSize=2
	ModifyGraph rgb($NameOfWave(OC))=(39168,13056,0),rgb($NameOfWave(HC))=(65280,0,0)
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	ModifyGraph mode($NameOfWave(OM_OC))=3,marker($NameOfWave(OM_OC))=8
	ModifyGraph rgb($NameOfWave(OM_OC))=(0,0,0)
	Label left "Improved-Ambient H/C, O/C"
	Label bottom "Aiken-Ambient H/C, O/C"		//1.16M
	ShowTools/A

	variable myMin = min(min(WaveMin(OM_OC_AA), WaveMin(H_C_AA) ),  WaveMin(O_C_AA) )
	variable myMax = max(max(Wavemax(OM_OC_AA), Wavemax(H_C_AA) ),  Wavemax(O_C_AA) )
	SetAxis/E=3 bottom max(0, myMin), mymax
	SetAxis/E=3 left max(0, myMin), mymax

	SetDrawEnv xcoord= bottom,ycoord= left,linefgc= (1,1,1)
	DrawLine 0,0, mymax, mymax		// 1 to 1
	SetDrawEnv xcoord= bottom,ycoord= left, linethick= 1.5,linefgc= (65280,32768,58880)
	DrawLine 0,0, mymax*(1), mymax*(1.11)			// 	1.11 line
	SetDrawEnv  xcoord= bottom,ycoord= left, linethick= 1.5,linefgc= (52224,52224,0)
	DrawLine 0,0, mymax*(1), 	mymax*(1.27) 	  	// 	1.27 line

	Legend/C/N=text1/A=RB "\\s("+NameofWave(OM_OC)+") "+NameofWave(OM_OC)
	AppendText "\\s("+NameofWave(HC)+") "+NameofWave(HC)
	AppendText "\\s("+NameofWave(OC)+") "+NameofWave(OC)
	AppendText "\\f01\\K(52224,52224,0)1.27 line\r\\K(65280,32768,58880)1.11 line"
End 


//1.15O
Function HROrgCheck_CalcEA_ImprovedAmb(ctrlName) : ButtonControl
	String ctrlName

	nvar HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal		// be sure this remains checked
	svar HRResults_ionList = root:HR_panel:HRResults_ionList	
	HR_elementalImprovedCal=1
	HRResults_ionList = "HROrg"
	HR_butt_MS_Calc("HRResultsE_button_EARatios")

End


//1.15O
Function HROrgCheck_CalcEADiurnal_ImpAmb(ctrlName) : ButtonControl
	String ctrlName

	nvar HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal		// be sure this remains checked
	svar HRResults_ionList = root:HR_panel:HRResults_ionList	
	HR_elementalImprovedCal=1
	HRResults_ionList = "HROrg"
	HR_butt_MS_Calc("HRResultsE_button_EARatioDiurn")

End	


//1.15O
Function HROrgCheck_EATSgraph(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	variable which = 0	
	variable PanelFlag
	
	string TopWname = WinName(0, 65)
	variable PopWinExists = strlen(winList("PK_HROrgCheckTSGraph", ";", ""))>0
	
//	wave/z HROrgCHO_DL = root:ElementalAnalysis:HROrgCHO_DL
//	wave/z HROrgCO2_DL = root:ElementalAnalysis:HROrgCO2_DL
//	if ( !WaveExists(HROrgCO2_DL) || !WaveExists(HROrgCHO_DL))		// we haven't calced these yet
//		which=1+WhichListItem(ctrlName,"ImpAm_checkCHO;ImpAm_checkCO2;ImpAm_checkHROrg;ImpAm_checkfHROrg;ImpAm_checkAll")
//		HROrgCheck_UpdateRadio(which)
//	else	
		strswitch(ctrlName) 
		case "ImpAm_checkCHO":		
			which=1
			if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowCHO(which)
				SetActiveSubwindow ##
				DOWindow/F PK_HROrgCheckTSGraph
				HROrgCheck_ShowCHO(which)
			else
 				if (PopWinExists)
					DOWindow/F PK_HROrgCheckTSGraph
					HROrgCheck_ShowCHO(which)
		  		endif
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowCHO(which)
				SetActiveSubwindow ##
			endif
			break	
		case "ImpAm_checkCO2":
			which=2
			if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowCO2(which)
				SetActiveSubwindow ##
				DOWindow/F PK_HROrgCheckTSGraph
				HROrgCheck_ShowCO2(which)
			else
 				if (PopWinExists)
					DOWindow/F PK_HROrgCheckTSGraph
					HROrgCheck_ShowCO2(which)
		  		endif
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowCO2(which)
				SetActiveSubwindow ##
			endif
			break	
		case "ImpAm_checkHROrg":
			which=3
			if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowHROrg(which)
				SetActiveSubwindow ##
				DOWindow/F PK_HROrgCheckTSGraph
				HROrgCheck_ShowHROrg(which)
			else
 				if (PopWinExists)
					DOWindow/F PK_HROrgCheckTSGraph
					HROrgCheck_ShowHROrg(which)
		  		endif
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowHROrg(which)
				SetActiveSubwindow ##
			endif
			break	
		case "ImpAm_checkfHROrg":
			which=4
			if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowfX(which)
				SetActiveSubwindow ##
				DOWindow/F PK_HROrgCheckTSGraph
				HROrgCheck_ShowfX(which)
			else
 				if (PopWinExists)
					DOWindow/F PK_HROrgCheckTSGraph
					HROrgCheck_ShowfX(which)
		  		endif
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowfX(which)
				SetActiveSubwindow ##
			endif
			break	
		case "ImpAm_checkAll":
			which=5
			if (stringmatch("PK_HROrgCheckTSGraph",TopWname ))
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowAll(which)
				SetActiveSubwindow ##
				DOWindow/F PK_HROrgCheckTSGraph
				HROrgCheck_ShowAll(which)
			else
 				if (PopWinExists)
					DOWindow/F PK_HROrgCheckTSGraph
					HROrgCheck_ShowAll(which)
		  		endif
	  			DOWindow/F HROrgCheck_panel
	  			SetActiveSubwindow HROrgCheck_Panel#ImpAm_EA_TseriesGraph
				HROrgCheck_ShowAll(which)
				SetActiveSubwindow ##
			endif	
			break		
		endswitch
//	endif

	if (PanelFlag)
		SetActiveSubwindow ##	
	endif
End


Function EA_showHideAiken(ctrlName,checked) : CheckBoxControl		//1.16M
	String ctrlName
	Variable checked

	string wstr, wlist = TraceNameList("", ";", 1 )
	variable idex, num
	wave t_series = root:index:t_series
	
	if (checked)		// add traces
		for(idex=0;idex<itemsInList(wlist);idex+=1)
			wave EAtrace_IA = traceNameToWaveRef("", stringFromList(idex, wlist))
			wstr = NameofWave(EAtrace_IA)
			wave/z EAtrace =$("root:elementalAnalysis:"+wstr[0,strlen(wstr)-4])
			if (WaveExists(EAtrace))
				appendTograph	EAtrace vs t_series
				ModifyGraph mode($NameofWave(EAtrace))=2,lsize($NameofWave(EAtrace))=2,rgb($NameofWave(EAtrace)) =(51456,44032,58880)	
			endif
		endfor
	else // remove traces
		for(idex=0;idex<itemsInList(wlist);idex+=1)
			wave/z EAtrace_IA = traceNameToWaveRef("", stringFromList(idex, wlist))
			if (WaveExists(EAtrace_IA))
				wstr = NameofWave(EAtrace_IA)
				wave/z EAtrace =$("root:elementalAnalysis:"+wstr[0,strlen(wstr)-4])
				if (WaveExists(EAtrace))
					RemoveFromGraph $NameofWave(EAtrace)
				endif
			endif
		endfor
	endif
End


// possibly add entries to the waves in the batch table in anticipation of generating time series.
Function HR_FD_Check_batchHROrgCheck()

	//^ first make frag_m31 wave if it doesn't exist
	wave/t/z HR_frag_organic = root:HR_frag:HR_frag_organic	// we only need this wave for the number of points it has
	if (waveExists(HR_frag_organic)==0)	
		abort "Cannot find wave HR_frag_organic  aborting from HR_FD_Check_batchHROrgCheck"
	endif
	wave/t HR_specName_list = root:HR_frag:HR_specName_list
	wave/t HR_spec_list = root:HR_frag:HR_specName_list
	wave/t HR_specFrag_list = root:HR_frag:HR_specName_list
	wave/t HR_specFamilyBase = root:HR_frag:HR_specName_list
//	wave/t HR_specFamilyException = root:HR_frag:HR_specFamilyException
	wave HR_specIEFac_list = root:HR_frag:HR_specIEFac_list
//	wave HR_spec_CalFac_list = root:HR_frag:HR_spec_CalFac_list
	wave HR_specCEFac_list = root:HR_frag:HR_specCEFac_list 
//	wave HR_specCEwave_list = root:HR_frag:HR_specCEwave_list
	wave/t HR_speccorr_list = root:HR_frag:HR_speccorr_list
	
	variable pos = sq_findStr(HR_specName_list,"HRorganic",1)
	
	//^ add these entries to the batch waves if they are not already there
	// for FD_modifyBatch params are: spec_listStr, specname_listStr,frag_listStr, iefac_listStr, cefac_listStr, speccorr_listStr

 	HR_FD_modifyBatch("HROrgCHO", "HROrgCHO", "HR_frag_organic[CHO]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	
 	HR_FD_modifyBatch("HROrgCO2", "HROrgCO2", "HR_frag_organic[CO2]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	
  	HR_FD_modifyBatch("HROrgC2H3O", "HROrgC2H3O", "HR_frag_organic[C2H3O]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	
	HR_FD_modifyBatch("HROrg43", "HROrg43", "HR_frag_organic[43]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	
 	HR_FD_modifyBatch("HROrg44", "HROrg44", "HR_frag_organic[44]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	
 	HR_FD_modifyBatch("HROrg29", "HROrg29", "HR_frag_organic[29]",num2str(HR_specIEFac_list[pos]), num2str(HR_specCEFac_list[pos]), HR_speccorr_list[pos] )	

End
