#pragma rtGlobals=3		// Use modern global access method and strict wave access.

strconstant TWF ="root:TWEPToF"
strconstant TWgr ="TWEPToF_gr"		// main graph
strconstant TWParamMzgr ="TWParamMz_gr"  // params for current deconvolution as a function of Mz 
strconstant TWParamTimegr ="TWParamTime_gr"  // params for preprocessed deconvolution as a function of time, (mz)
strconstant TWMzVsMzgr ="TWMzVsMz_gr"  // params for preprocessed deconvolution as a function of time, (mz)
strconstant TWMassSpecgr ="TWMassSpec_gr"

// SetIgorOption IndependentModuleDev=1


// easy way to start 'er up from pull down menu above
Menu "AMS"		// change in 1.41B, was "Panels" previously

	Submenu "Misc"
	Submenu "Tofwerk ePToF Deconvolution"
	"Details of TW EPToF Single PToF Matrix Deconvolution", TWEPToF_displayGr()
//	"TW EPToF ParmsAsFncMz", TWDeconvParamMz_displayGr()	//1.59F  Decided it was too confusing to have these as separate from main TW graph
//	"TW EPToF Mz vs Mz", TWMzVsMz_displaygr()
//	"TW EPToF Mass Spec, ePToFSumDiff, Decon Integrated", TWMassSpec_displaygr()
	"TW EPToF ParmsAsFncTime for preprocessed with TW deconvolution", TWParamTime_displayGr()
	End
	End
End


Function TWEPToF_globals([OS])
variable OS

	if (ParamISdefault(OS)	)
		OS = 2
	endif 
	
	variable numBins=OS*127		// defaults to 254
	
	string df = GetDataFolder(1)
	NewDataFolder/o/s $TWF
	make/o/n=(numBins,1) unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
	make/o/n=(numBins) unDecon1D, newDecon1D,matDecon1D,demux1D, unDeconSmooth1D, matDeconSmooth1D,  noise1D, baselineRegion
	make/o/n=(numBins) PToFtime, twPToFtime, DVaSize
	make/o/n=(4,1) NewDeconParams
	make/o/n=1 SmMxInvBkgd,MxInvBkgd, Bkgd  //1.59D
	nvar PToF_ePToF_TestRegion = root:panel:PToF_ePToF_TestRegion
//	make/o/n=(1) dtdlogdp		// will be redimensioned
	TWEPToF_SetDimLabels(NewDeconParams, 0)
	variable/g runNum, SingleRunTodoCk
	string/g runInfo
	baselineRegion=1; baselineRegion[0,round((1-PToF_ePToF_TestRegion) * numBins)]=0
	SetDataFolder $df

	sq_initializeGlobalNVar("root:TWEPToF:mz",28)		//1.59D
End


Function TWEPToF_SetDimLabels(NewDeconParams, dim)
wave NewDeconParams
variable dim

	SetDimLabel dim,0, noise, NewDeconParams
	SetDimLabel dim,1, bsl, NewDeconParams
	SetDimLabel dim,2, boxW, NewDeconParams
	SetDimLabel dim,3, scalar, NewDeconParams		//1.59D
End


Function TWEPToF_displayGr()
	DoWindow/F $TWgr
	if (V_flag)
		return 0
	endif
	
	duplicate/o/free root:diagnostics:eptof_oversampling goodEPTOF		//1.60Z
	wave eptoF_enabled = root:diagnostics:eptoF_enabled
	goodEPTOF*=eptoF_enabled
	variable OSVal = wavemax(goodEPTOF)
	
	TWEPToF_globals(os=OSVal)

	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder $TWF+":"
	wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
	wave unDecon1D, newDecon1D,matDecon1D,demux1D, unDeconSmooth1D, matDeconSmooth1D, noise1D, baselineRegion
	wave twPToFtime,PToFtime, DVaSize	// , dtdlogdp
	Display/N=$TWgr /W=(654.75,126.5,1202.25,566.75)/R baselineRegion vs PToFtime as TWgr
	
	AppendToGraph/R=size DVaSize vs PToFtime
	AppendToGraph/L=demuxed demux1D,newDecon1D vs twPToFtime
	AppendToGraph/L=demuxed matDecon1D vs PToFtime
	AppendToGraph/L=undecon unDeconSmooth1D,unDecon1D vs PToFtime
	AppendToGraph/L=demuxed matDeconSmooth1D vs PToFtime
	AppendToGraph/L=demuxed noise1D vs PToFtime
//	AppendToGraph/R=dtdlog dtdlogdp vs PToFtime
	SetDataFolder fldrSav0
	ModifyGraph mode(baselineRegion)=7,mode(DVaSize)=1,mode(demux1D)=4,mode(matDecon1D)=4
	ModifyGraph mode(newDecon1D)=4,mode(unDeconSmooth1D)=4,mode(unDecon1D)=4,mode(matDeconSmooth1D)=4
	ModifyGraph marker(demux1D)=8,marker(matDecon1D)=28,marker(unDeconSmooth1D)=8,marker(matDeconSmooth1D)=5
	ModifyGraph lSize(DVaSize)=2
	ModifyGraph rgb(baselineRegion)=(43520,43520,43520),rgb(DVaSize)=(0,0,0),rgb(demux1D)=(44032,29440,58880)
	ModifyGraph rgb(matDecon1D)=(0,52224,26368),rgb(newDecon1D)=(0,0,0),rgb(unDeconSmooth1D)=(0,15872,65280)
	ModifyGraph rgb(matDeconSmooth1D)=(39168,39168,0),rgb(noise1D)=(0,0,0)
	ModifyGraph msize(demux1D)=2,msize(matDecon1D)=2,msize(newDecon1D)=2,msize(unDeconSmooth1D)=2
	ModifyGraph msize(unDecon1D)=2,msize(matDeconSmooth1D)=1
	ModifyGraph hbFill(baselineRegion)=5
	ModifyGraph hideTrace(baselineRegion)=1,hideTrace(demux1D)=1,hideTrace(matDecon1D)=1
	ModifyGraph hideTrace(matDeconSmooth1D)=1
	ModifyGraph hideTrace(unDeconSmooth1D)=1
	ModifyGraph grid(bottom)=2
	ModifyGraph zero(demuxed)=1,zero(undecon)=1
	ModifyGraph nticks(size)=0,axisEnab(size)={0,0.8},freePos(size)={0,bottom}
//	ModifyGraph nticks(dtdlog)=0,axisEnab(dtdlog)={0,0.8}		// ,freePos(dtdlog)={0,bottom}
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(bottom)=(34816,34816,34816)
	ModifyGraph lblPos(demuxed)=89,lblPos(undecon)=89
	ModifyGraph lblLatPos(demuxed)=7,lblLatPos(undecon)=21
	ModifyGraph freePos(demuxed)={0,kwFraction}
	ModifyGraph freePos(undecon)={0,kwFraction}
	ModifyGraph axisEnab(demuxed)={0,0.79}
	ModifyGraph axisEnab(undecon)={0.81,1}
	Label bottom "PToF time, s"
	Label demuxed "Deconvolved, dS/dPToF (Hz), UNSCALED\rChopper ignored"
	Label undecon"Undecon. (bits/extraction)"
	ModifyGraph lblPos(demuxed)=85,lblLatPos(demuxed)=55
	ModifyGraph nticks(right)=0
	ModifyGraph nticks(bottom)=9
	SetAxis/A/E=3 undecon
	
	ShowInfo
	ControlBar 130
	GroupBox TWEPToF_output,pos={340.00,54.00},size={174.00,72.00}
	GroupBox TWEPToF_RUnGrp,pos={5.00,49.00},size={334.00,76.00},title="Info for current run or first run in todo"
	TitleBox TWEPToF_RunInfo,pos={154.00,10.00},size={26.00,12.00},fSize=10,frame=0
	TitleBox TWEPToF_RunInfo,variable= root:TWEPToF:runInfo
	SetVariable TWEPToF_runNumber,pos={22.00,8.00},size={130.00,15.00},proc=TWEPToF_runSetVar,title="Run number"
	SetVariable TWEPToF_runNumber,fSize=10,format="%g",value= root:TWEPToF:runNum
	PopupMenu ams_todolist_pop,pos={25.00,28.00},size={145.00,19.00},bodyWidth=120,proc=TWEPToF_PopMenu,title="Todo"
	PopupMenu ams_todolist_pop,fSize=10
	PopupMenu ams_todolist_pop,mode=20,popvalue="Get List",value= #"root:panel:sq_toDoList+\"Get List;\"\t"
	Button TWEPToF_prev,pos={186.00,5.00},size={60.00,20.00},proc=TWEPToF_PrevNextButt,title="Quick prev"
	Button TWEPToF_prev,fSize=10
	Button TWEPToF_next,pos={186.00,26.00},size={60.00,20.00},proc=TWEPToF_PrevNextButt,title="Quick next"
	Button TWEPToF_next,fSize=10
	CheckBox TWEPToF_SingleRun,pos={4.00,9.00},size={13.00,13.00},proc=TWEPToF_SingleRunTodoCheck,title=""
	CheckBox TWEPToF_SingleRun,value= 1,mode=1
	CheckBox TWEPToF_todo,pos={4.00,30.00},size={13.00,13.00},proc=TWEPToF_SingleRunTodoCheck,title=""
	CheckBox TWEPToF_todo,value= 0,mode=1
	SetVariable TWePToF_TestRegion_setvar,pos={250.00,24.00},size={90.00,33.00},bodyWidth=45,title="Noise\rfraction"
	SetVariable TWePToF_TestRegion_setvar,limits={0,1,0.01},value= root:panel:PToF_ePToF_TestRegion
	ValDisplay TWEPToF_tstep,pos={10.00,104.00},size={125.00,14.00},bodyWidth=60,disable=2,title="PToF t step (s)"
	ValDisplay TWEPToF_tstep,fSize=10,format="%1.4e",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_tstep,value= _NUM:nan
	ValDisplay TWEPToF_numBins,pos={216.00,85.00},size={100.00,14.00},disable=2,title="# of PToF bins"
	ValDisplay TWEPToF_numBins,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_numBins,value= _NUM:nan
	ValDisplay TWEPToF_minMz,pos={138.00,85.00},size={75.00,14.00},disable=2,title="Min m/z"
	ValDisplay TWEPToF_minMz,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_minMz,value= _NUM:nan
	ValDisplay TWEPToF_maxMz,pos={138.00,104.00},size={75.00,14.00},disable=2,title="Max m/z"
	ValDisplay TWEPToF_maxMz,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_maxMz,value= _NUM:nan
	ValDisplay TWEPToF_duration,pos={214.00,103.00},size={120.00,14.00},disable=2,title="PToF duration (s)"
	ValDisplay TWEPToF_duration,fSize=10,format="%0.3f",fStyle=0
	ValDisplay TWEPToF_duration,limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_duration,value= _NUM:nan
	ValDisplay TWEPToF_OS,pos={10.00,67.00},size={230.00,14.00},title="ePToF oversampling (nan for non ePToF)"
	ValDisplay TWEPToF_OS,fSize=10,limits={0,0,0},barmisc={0,1000},value= _NUM:nan
	ValDisplay TWEPToF_t0,pos={10.00,85.00},size={114.00,14.00},bodyWidth=65,disable=2,title="PToF t0 (s)"
	ValDisplay TWEPToF_t0,fSize=10,format="%1.4e",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_t0,value= _NUM:nan
	Button TWEPToF_goButt,pos={259.00,2.00},size={60.00,20.00},proc=TWEPToF_goButt,title="Go"
	Button TWEPToF_goButt,fStyle=1,fColor=(65280,43520,0)
	CheckBox check_MatDecon1D,pos={519.00,32.00},size={136.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show matrix deconvolution"
	CheckBox check_MatDecon1D,fSize=10,fColor=(0,52224,26368),value= 0
	CheckBox check_unDeconSmooth1D,pos={519.00,16.00},size={193.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show filtered, smoothed undeconvolved"
	CheckBox check_unDeconSmooth1D,fSize=10,fColor=(0,15872,65280),value= 0
	CheckBox check_Noise1D,pos={519.00,62.00},size={65.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show est. noise"
	CheckBox check_Noise1D,fSize=10,value= 0
	CheckBox check_DVaSize,pos={519.00,77.00},size={130.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show DVa 10, 100 1000nm"
	CheckBox check_DVaSize,fSize=10,value= 0
	CheckBox check_baselineRegion,pos={519.00,92.00},size={118.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show baseline calc. region"
	CheckBox check_baselineRegion,fSize=10,value= 0
	CheckBox check_MatDeconSmooth1D,pos={519.00,47.00},size={181.00,13.00},proc=TWEPToF_ShowHideCheck,title="Show matrix deconv. w/ filter, smooth"
	CheckBox check_MatDeconSmooth1D,fSize=10,fColor=(39168,39168,0),value= 0
	ValDisplay TWEPToF_BoxW,pos={343.00,59.00},size={63.00,14.00},bodyWidth=15,disable=2,title="Box width"
	ValDisplay TWEPToF_BoxW,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_BoxW,value= _NUM:nan
	ValDisplay TWEPToF_noise,pos={343.00,79.00},size={80.00,14.00},disable=2,title="Est. noise"
	ValDisplay TWEPToF_noise,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_noise,value= _NUM:nan
	ValDisplay TWEPToF_bsl,pos={343.00,95.00},size={120.00,24.00},disable=2,title="Bsl (not easy\rto interpret)"
	ValDisplay TWEPToF_bsl,fSize=10,format="%g",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_bsl,value= _NUM:nan
	GroupBox TWEPToF_display,pos={515.00,1.00},size={205.00,126.00},title="Display options"
	ValDisplay TWEPToF_SumDiff,pos={353.00,2.00},size={99.00,14.00},bodyWidth=60,disable=2,title="SumDiff"
	ValDisplay TWEPToF_SumDiff,fSize=10,format="%1.1f"
	ValDisplay TWEPToF_SumDiff,limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_SumDiff,value= _NUM:nan
	ValDisplay TWEPToF_DeconIntegrated,pos={354.00,19.00},size={131.00,14.00},bodyWidth=50,disable=2,title="Decon Integrated"
	ValDisplay TWEPToF_DeconIntegrated,fSize=10,format="%1.1f"
	ValDisplay TWEPToF_DeconIntegrated,limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_DeconIntegrated,value= _NUM:nan
	ValDisplay TWEPToF_Norm,pos={354.00,37.00},size={95.00,14.00},bodyWidth=60,disable=2,title="Scaling"
	ValDisplay TWEPToF_Norm,fSize=10,format="%1.4f",limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_Norm,value= _NUM:nan
	SetVariable TWEPToF_mz,pos={539.00,107.00},size={81.00,18.00},bodyWidth=55,proc=TWEPToF_mzSetVar,title="m/z"
	SetVariable TWEPToF_mz,fSize=12,format="%g",fStyle=1,value= root:TWEPToF:mz
	ValDisplay TWEPToF_MxInvBkgd,pos={434.00,79.00},size={77.00,14.00},bodyWidth=45,disable=2,title="Mx BL"
	ValDisplay TWEPToF_MxInvBkgd,fSize=10,format="%1.1f"
	ValDisplay TWEPToF_MxInvBkgd,limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_MxInvBkgd,value= _NUM:nan
	ValDisplay TWEPToF_SmMxInvBkgd,pos={417.00,59.00},size={94.00,14.00},bodyWidth=45,disable=2,title="Sm Mx BL"
	ValDisplay TWEPToF_SmMxInvBkgd,fSize=10,format="%1.1f"
	ValDisplay TWEPToF_SmMxInvBkgd,limits={0,0,0},barmisc={0,1000}
	ValDisplay TWEPToF_SmMxInvBkgd,value= _NUM:nan
	Button TWbutt_TWMzVsMz_gr,pos={652.00,81.00},size={65.00,18.00},proc=TW_grButtonProc,title="Mz vs Mz Gr"
	Button TWbutt_TWMzVsMz_gr,fSize=10,fColor=(65280,43520,0)
	Button TWbutt_TWDeconvParamMz_Gr,pos={637.00,61.00},size={80.00,18.00},proc=TW_grButtonProc,title="Param vs mz Gr"
	Button TWbutt_TWDeconvParamMz_Gr,fSize=10,fColor=(65280,43520,0)
	Button TWbutt_TWMassSpec_Gr,pos={647.00,101.00},size={70.00,18.00},proc=TW_grButtonProc,title="Mass Spec Gr"
	Button TWbutt_TWMassSpec_Gr,fSize=10,fColor=(65280,43520,0)

	TWEPTOF_initialzeValDisplay()

	STRUCT WMCheckboxAction cba
	cba.checked = 1;cba.ctrlname="SingleRun";cba.eventCode=2
	TWEPToF_SingleRunTodoCheck(cba)
	
End


Function TWEPTOF_initialzeValDisplay()

	ValDisplay TWEPToF_BoxW,value= _NUM:nan
	ValDisplay TWEPToF_noise,value= _NUM:nan
	ValDisplay TWEPToF_bsl,value= _NUM:nan
	ValDisplay TWEPToF_SumDiff,value= _NUM:nan
	ValDisplay TWEPToF_DeconIntegrated,value= _NUM:nan
	ValDisplay TWEPToF_Norm,value= _NUM:nan

	ValDisplay TWEPToF_SmMxInvBkgd,value= _NUM:nan		//1.59D
	ValDisplay TWEPToF_MxInvBkgd,value= _NUM:nan  	//1.59D
End


// calculates DVa and PToF time for run at pos, puts 0 everywhere except at 10, 100, 1000nm
Function TWEPToF_setDva(pos, DVa_wave)
variable pos
wave DVa_wave

	wave twPToFtime = $TWF+":twPToFtime"
	wave PToFtime = $TWF+":PToFtime"
	wave DVaSize = $TWF+":DVaSize"
	wave twPToFtime = $TWF+":twPToFtime"
	wave twPToFtime = $TWF+":twPToFtime"	
	nvar lc = root:panel:cor3_chamber

	variable DVa_NumPToFBins, pos10, pos100, pos1000
	
	DVa_NumPToFBins=DVa_wave[%NumPToFBins]
	Redimension/n=(DVa_NumPToFBins) DVaSize, PToFtime, twPToFtime
	PToFtime = DVa_wave[%t0] + p*DVa_wave[%step]
	sq_CorrectPToFTimeForTWDecon(DVa_wave, twPToFTime)
	DVaSize = sq_ptof2dva(lc,DVa_wave[%vl],DVa_wave[%vg],DVa_wave[%b],DVa_wave[%dx],PToFtime[p])  // use PToFtime, not twPToFtime

	pos10 = round(binarySearchInterp(DVaSize, 10))
	pos100 = round(binarySearchInterp(DVaSize, 100))
	pos1000 = round(binarySearchInterp(DVaSize, 1000))

	DVaSize = 0
	DVaSize[pos10]=1
	DVaSize[pos100]=1
	DVaSize[pos1000]=1
	
End


Function TWEPToF_goButt(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			string runStr =TWEPToF_GetThisMatrix()
			if (strlen(WinList("TWParamMz_gr*", ";", "WIN:1"))>0)		//1.59F
				TitleBox titleTWDeconv title="TW deconvolution for "+runStr, win=TWParamMz_gr
			endif
			if (strlen(WinList("TWMzVsMz_gr*", ";", "WIN:1"))>0)
				TitleBox titleTWDeconv title="TW deconvolution for "+runStr, win=TWMzVsMz_gr
			endif
			if (strlen(WinList("TWMassSpec_gr*", ";", "WIN:1"))>0)
				TitleBox titleTWDeconv title="TW deconvolution for "+runStr, win=TWMassSpec_gr
			endif 
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_mzSetVar(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			Variable dval = sva.dval
			String sval = sva.sval

			string df = GetDataFolder(1)
			SetDataFolder root:TWEPToF
			wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
			wave unDecon1D, newDecon1D,matDecon1D,demux1D, unDeconSmooth1D, matDeconSmooth1D,  noise1D

			wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D
			wave unDecon1D, newDecon1D,matDecon1D,demux1D, unDeconSmooth1D, noise1D
			wave NewDeconParams	
			wave SmMxInvBkgd, MxInvBkgd			//1.59D	
			nvar mz = root:TWEPToF:mz
						
			if (dimsize(unDecon2D,1)==1 &&strlen(sva.ctrlName)>0 )
				doAlert, 0, "Please either reselect the todo wave or press the go button again."	
			endif
			mz = limit(mz, 1, dimsize(unDecon2D,1) )   //  prevent mz from going out of bounds
			
			// update displays
			ValDisplay TWEPToF_noise win=$TWgr, value=_Num:NewDeconParams[%noise][mz-1]
			ValDisplay TWEPToF_BoxW win=$TWgr, value=_Num:NewDeconParams[%boxW][mz-1]
			ValDisplay TWEPToF_bsl win=$TWgr, value=_Num:NewDeconParams[%bsl][mz-1]
//			ValDisplay TWEPToF_Scal win=$TWgr, value=_Num:NewDeconParams[%scalar][mz-1]
			
			// update waves
			unDecon1D = unDecon2D[p][mz-1]
			newDecon1D = newDecon2D[p][mz-1]
			matDecon1D = matDecon2D[p][mz-1]
			matDeconSmooth1D = matDeconSmooth2D[p][mz-1]
			demux1D = demux2D[p][mz-1]
			unDeconSmooth1D = unDeconSmooth2D[p][mz-1]
			noise1D =NewDeconParams[%noise][mz-1]
//			TWSetNormalizationDisplay()
			
			wave DeconIntegrated	, EPToFSumDiffMS, ScalarMS
			ValDisplay TWEPToF_DeconIntegrated win=TWEPTOF_gr, value=_Num:DeconIntegrated[mz-1]
			ValDisplay TWEPToF_SumDiff  win=TWEPTOF_gr,  value=_Num:EPToFSumDiffMS[mz-1]
			ValDisplay TWEPToF_Norm  win=TWEPTOF_gr,      value=_Num:ScalarMS[mz-1]

			ValDisplay TWEPToF_SmMxInvBkgd,win=TWEPTOF_gr,      value= _NUM:SmMxInvBkgd[mz-1]	//1.59D
			ValDisplay TWEPToF_MxInvBkgd,win=TWEPTOF_gr,      value= _NUM:MxInvBkgd[mz-1]  	//1.59D

			SetDataFolder $df
			break
		case 3: // Live update
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_PrevNextButt(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			svar sq_toDoWvNm = root:panel:sq_toDoWvNm
			wave/z todo = $"root:"+sq_toDoWvNm
			nvar runNum = root:TWEPToF:runNum
			variable pos = sq_findRun(todo,runNum)
			variable numInTodo = numpnts(todo)
		
			string ctrlName=StringFromList(2, ba.ctrlName, "_")	// i.e. butt_bk_currentRunNum becomes bk_currentRunNum				
			ControlInfo ams_todolist_pop
			if (V_flag==3	 && !stringmatch(S_Value, sq_toDoWvNm) || !WaveExists(todo) || numpnts(todo)==0 )
				abort "Please reselect the todo wave in this panel.  Right now it does not match the todo wave in the main ams panel.  Aborting from TWEPToF_PrevNextButt"
			endif
				
			variable nextFlag = strsearch(ba.ctrlName "next",0)>=0
			variable runLocation = binarysearch(todo, runNum)
			
			if (runLocation==-1) 
				runNum = todo[0]
			elseif(runLocation ==-2)
				runNum = todo[numInTodo-1]
			elseif(runLocation ==0)
				if (nextFlag)
					runNum = todo[min(runLocation+1, numInTodo-1)]
				else
					runNum = todo[0]
				endif
			else		// (runLocation >0)
				if (nextFlag)
					runNum = todo[min(runLocation+1, numInTodo-1)]
				else
					runNum = todo[runLocation-1]
				endif
			endif	
			
			STRUCT WMSetVariableAction sva
			sva.eventCode=3;sva.dVal=runNum
			TWEPToF_runSetVar(sva) 
		
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_SingleRunTodoCheck(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
		Variable checked = cba.checked
	
		nvar runNum = root:TWEPToF:runNum
		nvar SingleRunTodoCk = root:TWEPToF:SingleRunTodoCk
		svar RunInfo = root:TWEPToF:RunInfo
		
		SingleRunTodoCk = strsearch(cba.ctrlName, "SingleRun", 0)>=0
		Checkbox TWEPToF_Todo value = !SingleRunTodoCk, win=$TWgr
		Checkbox TWEPToF_SingleRun value = SingleRunTodoCk, win=$TWgr
		
		if (!SingleRunTodoCk)  // it is a todo
		// at this point it is important to know if different PToF runs have different DAQ settings.
			RunInfo=""
			svar sq_toDoWvNm = root:panel:sq_toDoWvNm
			wave/z todo = $"root:"+sq_toDoWvNm
			if (!WaveExists(todo) || numpnts(todo) == 0)
				abort "This todo wave has zero runs or doesn't exist.  Aborting from TWEPToF_SingleRunTodoCheck"
			endif
			sq_checkPToFparamsSameTodo(todo)		// will abort if not all runs are the same
			runNum=todo[0]
		else
		endif		// we have a single run
			
		STRUCT WMSetVariableAction sva
		sva.eventCode=3;  sva.dval=runNum
		TWEPToF_runSetVar(sva) 
	endswitch	
End


// updates displays of PToF info
Function TWEPToF_runSetVar(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			
			nvar runNum = root:TWEPToF:runNum
			wave rn_series = root:index:rn_series			
			svar RunInfo = root:TWEPToF:RunInfo
			nvar mz = root:TWEPToF:mz
			wave twPToFTime = root:TWEPToF:twPToFTime
			wave PToFTime = root:TWEPToF:PToFTime
			wave DVaSize = root:TWEPToF:DVaSize
				
			variable existVar, pos, mzSize, isEPToF
			string dataStr
		
			pos = sq_FindRun(rn_series, runNum)		//1.51Q
			existVar=sq_DoesPToFDataExist(runNum)		// should be unnecessary  1 means we have some type of PToF data (num secs >0), 0 means no PToF data, -1 means not a good run
			make/n=12/free DVA_wave
			sq_GetPToFParams(DVa_wave, Pos)		
			if (existVar<1)
				if (existVar<0)
					RunInfo="No run"		// run isn't valid
					DVaSize=nan	
				else 
					RunInfo="No PToF"
					DVaSize=nan
				endif
			else 
				make/o/i/n=1/free tempTodo = runNum
				isEPToF = sq_TodoHasPToF(tempTodo, PToFFlag=0)  //1.59C
				RunInfo=selectString(isEPToF, "PToF", "ePToF")
				killwaves/z tempTodo			
			endif	
			TWEPToF_updateVals(existVar, pos, DVa_wave)
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_updateVals(existVar, pos, DVa_wave)
variable existVar, pos
wave DVa_wave

	wave mFinish = root:diagnostics:mFinish
	wave mStart = root:diagnostics:mStart
	wave TimeAcquiringPToFInRun = root:diagnostics:TimeAcquiringPToFInRun
	nvar mz = root:TWEPToF:mz
		
	if (pos<0)		//1.20M
		return 0
	endif

	mz =limit(mz, mStart[pos], mFinish[pos] )
		 
	if (existVar!=0)	
		ValDisplay TWEPToF_maxMz win=$TWgr, value=_num:mFinish[pos]
		ValDisplay TWEPToF_minMz win=$TWgr, value=_num:mStart[pos]
		ValDisplay TWEPToF_t0 win=$TWgr, value=_num:DVa_wave[%t0]
		ValDisplay TWEPToF_tstep win=$TWgr, value=_num:DVa_wave[%step]
		ValDisplay TWEPToF_numBins win=$TWgr, value=_num:DVa_wave[%numPToFBins]
		ValDisplay TWEPToF_duration win=$TWgr, value=_num:TimeAcquiringPToFInRun[pos]
		ValDisplay TWEPToF_OS win=$TWgr, value=_num:DVa_wave[%ePToFOS]		//1.59D
		TWEPToF_initializeNonePToF()
	else
		ValDisplay TWEPToF_maxMz win=$TWgr, value=_num:nan
		ValDisplay TWEPToF_minMz win=$TWgr, value=_num:nan
		ValDisplay TWEPToF_t0 win=$TWgr, value=_num:nan
		ValDisplay TWEPToF_tstep win=$TWgr, value=_num:nan
		ValDisplay TWEPToF_numBins win=$TWgr, value=_num: nan
		ValDisplay TWEPToF_duration win=$TWgr, value=_num:nan
		ValDisplay TWEPToF_OS win=$TWgr, value=_num:nan
	endif
	
End	


// new in 1.52
// called within DCMarker_gr whenever new todo, run, DAQ/preprocessed Sticks or deconvolve/no deconvolve is selected in DCMarker_gr
//1.59F  Now returns the single run or name of the todo wave that was requested
Function/s TWEPToF_GetThisMatrix()

	nvar mz = root:TWEPToF:mz
	nvar runNum = root:TWEPToF:runNum
	nvar SingleRunTodoCk = root:TWEPToF:SingleRunTodoCk
	svar RunInfo = root:TWEPToF:RunInfo
	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
	nvar PToF_ePToF_TestRegion = root:panel:PToF_ePToF_TestRegion
	nvar PToF_ePToF_Mulitplier = root:panel:PToF_ePToF_Mulitplier		//1.60D

	nvar deconvolveJoel = root:panel:deconvolveJoel
	nvar deconvolveNone = root:panel:deconvolveNone
	nvar deconvolveMike = root:panel:deconvolveMike
	wave ChopperFreq= root:diagnostics:ChopperFreq

	wave/z blacklist
	wave rn_series = root:index:rn_series
	variable pos, CurrentChosenDecon = deconvolveNone+2*deconvolveJoel+3*deconvolveMike
	string returnStr = ""
	
	SetDataFolder root:
	if (strlen(WinList("PToFePTOF_Tool*", ";", "WIN:64"))>0)
		sq_DeconvolveCheckProc("ePToF_DeconvolveNone",1)
	endif
	
	if (!SingleRunTodoCk)		// do we have pre processed data for the requested run?  just check first run in todo
		wave/z todo = $"root:"+sq_toDoWvNm
		if (!WaveExists(todo)) 
			abort "Please reselect todo wave."
		endif
		pos = sq_findRun(rn_series,todo[0])
	else
		pos = sq_findRun(rn_series,runNum)
	endif
	if (pos<0)
		abort "This run doesn't exist. - aborting from TWEPToF_GetThisMatrix"	
	elseif (WaveExists(blacklist) && sq_findRun(blacklist,runNum)>=0 )
		abort "This run has been blacklisted - aborting from TWEPToF_GetThisMatrix"	
	endif

	svar MSStickList = root:panel:MSStickList
	if (WhichListItem("ePToFSumDiff",MSStickList)<0)
		abort "You must generate ePToFSum before you proceed.  Do this in the preprocess step."
	endif

// now get to work     make the a temporary todo wave that has the values we like
	if (SingleRunTodoCk)		// single run
		
		if (sq_DoesPToFDataExist(runNum)	<0 )
			abort "This run doesn't have good PToF data."
		endif
		make/o/free/n=12 DVA_wave
		sq_GetPToFParams(DVa_wave, pos) 
		TWEPToF_updateVals(1, pos, DVa_wave)
		ControlInfo/W=$TWgr TWEPToF_duration
		if ( ! (V_Value >0) )
			abort "The time spent in PToF for this run is 0, so there is no good data."
		endif
		
		make/o/i/n=1 root:todo_temp = runNum
		wave todo =root:todo_temp  
		
		sprintf returnStr, "%d", runNum  
	else		//todo	
		// first check that the currently viewed todo wave matches the one in the main squirrel panel
		ControlInfo ams_todolist_pop
		svar sq_toDoWvNm = root:panel:sq_toDoWvNm
		if (!stringmatch(S_value,sq_toDoWvNm) )
			abort "Please reselect the todo wave.  Aborting from TWEPToF_GetThisMatrix"
		endif
		sq_checkPToFparamsSameTodo(todo)		// will abort
		
		wave todo = $"root:"+sq_toDoWvNm
		wave/z allPToF = root:allPToF
		if (waveExists(allPToF))	// there are some runs without PToF data				
			sq_create_todo(sq_toDoWvNm+" and allPToF","todo_temp")
			wave todo = root:todo_temp
			if (numpnts(todo)==0)
				killwaves/z todo
				abort "The todo wave you chose has zero PToF runs in it."
			endif
		endif
		if (numpnts(todo)>100)
			DoAlert, 1, "The averaging of PToF sticks for many runs (>100) can take a very long time.  Press yes to continue, no to abort."
			if (V_flag==2)		// choser chose no
				abort "The user chose to abort"
			endif
		endif
		returnStr = " todo wave "+sq_toDoWvNm
	endif		// single run or todo
			
	runNum=todo[0]		// this is only really needed if user selected todo
	pos = sq_findRun(rn_series,runNum) 
	make/o/free/n=12 DVA_wave
	sq_GetPToFParams(DVa_wave, pos) 	
	TWEPToF_updateVals(1,pos, DVa_wave)
	TWEPToF_setDva(pos, DVa_wave)

	wave temp_PToFmatrix = TWEPToF_FetchMatrix(todo )		// 	sq_PToF_DCGr_FetchMatrix(todo, "PToF_stick" )		// found with ignoreChop =1

	wave baselineRegion =$TWF+":baselineRegion"
	baselineRegion=1; baselineRegion[0,round((1-PToF_ePToF_TestRegion) * dimsize(temp_PToFmatrix,0))]=0  //1.60X
	variable osVal = DVa_wave[%ePToFOS]
	
	if (sq_TodoHasPToF(todo, PToFFlag=0) )  //1.59C)
		variable sp, ep
		ep=PToF_ePToF_Mulitplier*ePToFSingleNUm -1
		sp = round(PToF_ePToF_Mulitplier*ePToFSingleNUm*(1-PToF_ePToF_testRegion))		//1.60 O
		TWEPToF_DoOtherDecon(temp_PToFmatrix, sp, ep, os=osVal)
		wave MSAvg = TWRetrieveEPToFSumDiff(todo)
		wave newDecon2D =root:TWEPToF:newDecon2D
		wave twPTOFTime =root:TWEPToF:twPTOFTime
//		wave PTOFTime =root:TWEPToF:PTOFTime
		make/o/n=(numpnts(MSAvg)) root:TWEPToF:ScalarMS/wave =ScalarMS
		make/o/n=(numpnts(MSAvg)) root:TWEPToF:DeconIntegrated/wave =DeconIntegrated
		duplicate/free newDecon2D newDecon2D_temp
		newDecon2D_temp*=1/(ePToFFractionOpen)*ChopperFreq[pos] 
		TWDoScaling(MSAvg, newDecon2D_temp, twPTOFTime,ScalarMS,DeconIntegrated, pos)
	else
		TWEPToF_NanMatr(temp_PToFmatrix)
	endif
	
	// update mz
	STRUCT WMSetVariableAction sva
	sva.eventCode =2;  sva.dval =mz
	TWEPToF_mzSetVar(sva) 

	make/o/n=(dimsize(temp_PToFmatrix,1)) root:TWEPToF:NewDeconMz=p+1	

//	TWSetNormalizationDisplay()
	killwaves/z temp_PToFmatrix
	killwaves/z todo_temp, MSAvg

	sq_DeconvolveCheckProc("ePToF_Deconvolve"+stringFromList(CurrentChosenDecon, "None;None;Joel;Mike"),1)

	return returnStr
End


Function/wave TWEPToF_FetchMatrix(todo)
wave todo
			
	variable isEPToF = sq_TodoHasPToF(todo, PToFFlag=0)  //1.59C
	variable isPToF = sq_TodoHasPToF(todo, PToFFlag=1)  //1.59C
	if (!isEPToF || isPToF)
		abort "Can only proceed on ePToF runs"
	endif
	
//	nvar testRegion = root:panel:PToF_ePToF_TestRegion
//	testRegion=0.25
	nvar ePToF_postmatrixInvDC = root:panel:ePToF_postmatrixInvDC
	ePToF_postmatrixInvDC=0  // we do DC marker separately
	nvar deconvolveNone = root:panel:deconvolveNone
	deconvolveNone=1
	sq_DeconvolveCheckProc("ePToF_DeconvolveNone",1)

	string paramInitial = "ePToF_flag:"+num2str(isEPToF)+";"
	
	squirrel_fetch(todo,sq_ePToFfromDAQ,paramInitial,"PToF_stick")
	ePToF_postmatrixInvDC=1  // we do DC marker separately
	
	wave temp_PToFmatrix = root:temp_PToFmatrix
	MatrixTranspose temp_PToFmatrix

	return temp_PToFmatrix
End


Function TWEPToF_NanMatr(temp_PToFmatrix)
wave temp_PToFmatrix

	string df = GetDataFolder(1)
	SetDataFolder $TWF
	wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D, noise1D, newDecon1D
	wave NewDeconParams
	wave SmMxInvBkgd	, MxInvBkgd,Bkgd		
	redimension /n=(dimsize(temp_PToFmatrix, 0),dimsize(temp_PToFmatrix, 1))  unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, unDeconSmooth2D
	redimension /n=(dimsize(temp_PToFmatrix, 0)) noise1D, newDecon1D
	redimension /n=(dimsize(temp_PToFmatrix, 0)) SmMxInvBkgd, MxInvBkgd,Bkgd //1.59D
	fastop unDecon2D=(nan)
	fastop newDecon2D=temp_PToFmatrix
	fastop matDecon2D=(nan)
	fastop matDeconSmooth2D=(nan)
	fastop demux2D=(nan)
	fastop unDeconSmooth2D=(nan)
	fastop noise1D=(nan)
	fastop NewDeconParams=(nan)
	fastop SmMxInvBkgd=(nan) //1.59D
	fastop MxInvBkgd=(nan)
	fastop Bkgd=(nan)
	SetDataFolder $df

End


Function TWEPToF_DoOtherDecon(temp_PToFmatrix, sp, ep, [os]) 	//1.60D
wave temp_PToFmatrix
	variable sp, ep, os	//1.60D

	string df = GetDataFolder(1)
	SetDataFolder $TWF
	wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
	wave NewDeconParams			
	wave SmMxInvBkgd,MxInvBkgd,Bkgd			

	if (ParamisDefault(os))
		os=2
	endif
	
	variable numMz = dimsize(temp_PToFmatrix,1)
	
	duplicate/o temp_PToFmatrix unDecon2D
	redimension/n=(os*127,numMz) newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
	redimension/n=(4,numMz) newDeconParams
	redimension/n=(numMz) SmMxInvBkgd,MxInvBkgd,Bkgd
	
	TWEPToF_SetDimLabels(NewDeconParams,1)
	
	variable FuncExists = Exists("tweptof#deconv2d")
	// newdeconv
	tweptof#deconv2d( undecon2D, newDecon2D, NewDeconParams,0, sp, ep)		//1.60D	//1.60A

	// smooth
	fastop  unDeconSmooth2D = undecon2D
	TWEPToF_SmoothUnDecon(unDeconSmooth2D, NewDeconParams)
	
	// matrix op of smoothed
	fastop matDeconSmooth2D = unDeconSmooth2D
	TWEPToF_matDecon(matDeconSmooth2D, os, smoothFlag=1)

	// simple matrix op
	fastop matDecon2D = undecon2D
	TWEPToF_matDecon(matDecon2D, os, smoothFlag=0)
	
	// old demux with 0,0
//	fastop demux2D = undecon2D
//	TWEPToF_demux2D(demux2D)
	
	SetDataFolder $df

End


//  using code from TW
Function TWEPToF_SmoothUnDecon(unDeconSmooth2D, NewDeconParams)
wave unDeconSmooth2D, NewDeconParams

	variable idex, multiplier, boxWidth, maxMz = dimsize(unDeconSmooth2D,1)

	for (idex=0;idex<maxMz;idex+=1)
		Matrixop/o/free rawdatawv = col(unDeconSmooth2D, idex)
		multiplier=2 //NewDeconParams[%scalar][idex]
		boxWidth=NewDeconParams[%boxW][idex]
		// filter out frequencies faster than the sequence
//		if (factor>0)
			filterfir/lo={0,min(0.5,1/multiplier),7} rawdatawv
//		endif
		// apply median smoothing
		if (boxWidth>1&&boxWidth<51)
			Smooth/M=0/MPCT=50 boxWidth,rawDataWv
			unDeconSmooth2D[][idex]=rawDataWv[p]
		endif
	endfor

End


Function/wave TWEPToF_matDecon(mat2D, os, [smoothflag])
wave mat2D
variable os, smoothflag

	Wave/z /I ePToF_Inv2Dseq = root:PToF:ePToF_Inv2Dseq	// 2D inverse sequence (created in sq_EPToFMake2DSequenceInv)
	if (!WaveExists(ePToF_Inv2Dseq) )
		sq_EPToFMake2DSequenceInv(osFactor =os )
		Wave /I ePToF_Inv2Dseq = root:PToF:ePToF_Inv2Dseq	// 2D inverse sequence (created in sq_EPToFMake2DSequenceInv)
	endif
	
	MatrixOp /O mat2D = ePToF_Inv2Dseq x mat2D
	
	if (!ParamisDefault(smoothflag))
		if (smoothflag==1)
			wave Bkgd=$TWF+":SmMxInvBkgd"
		elseif(smoothflag==0)
			wave Bkgd=$TWF+":MxInvBkgd"
		endif
	endif

	wave b = TWEPToF_subtractTest(mat2D)
	Bkgd=b
End


Function/wave TWEPToF_subtractTest(mat2D)		//1.59D
wave mat2D

	nvar PToF_ePToF_TestRegion = root:panel:PToF_ePToF_TestRegion
	variable idex, maxMz = dimsize(mat2D,1)			//1.59  do not assume anything
	variable numCol=dimsize(mat2D,0)
	variable startP=round( (1-PToF_ePToF_TestRegion)*numCol), stopP=numCol-1

	wave Bkgd=$TWF+":Bkgd"
	for (idex=0;idex<maxMz;idex+=1)
		MatrixOP/o/free oneDdata=col(mat2D,idex)   // oneDdata=twoDdata[p][idex]
		WaveStats/q/r=[startP,stopP]	oneDdata	//191 = round(.25*254)
		Bkgd[idex]=V_avg								
	endfor
	killwaves/z oneDdata
	mat2D[][]-= Bkgd[q]	
// 1.59D  Notes that we can't use ImageStats and /PCST for WaveStats is available for igor 7
	return Bkgd
	
End	


//Function TWEPToF_demux2D(demux2D)
//wave demux2D
//
//	FUNCREF eEPToF_protofunc demux_proto = $"demux"
//
//	Wave/z /I SeqOutExp = root:PToF:SeqOutExp	// 2D inverse sequence (created in sq_EPToFMake2DSequenceInv)
//	if (!WaveExists(SeqOutExp) )
//		sq_SeqExpand(2)
//		Wave /I SeqOutExp = root:PToF:SeqOutExp	// 2D inverse sequence (created in sq_EPToFMake2DSequenceInv)
//	endif
//
//	variable idex, maxMz = dimsize(demux2D,1)
//	make/o/free/n=(254) result
//	for (idex=0;idex<maxMz;idex+=1)
//		MatrixOP/o/free oneDdata=col(demux2D,idex)   // oneDdata=twoDdata[p][idex]
//		demux_proto(oneDdata, SeqOutExp, result,2,0,0,0.25)  
//		demux2D[][idex]=result[p]								
//	endfor
//	killwaves/z oneDdata
//
//End


Function TWEPToF_PopMenu(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			wave/z todo = $"root:"+popStr
			if (!WaveExists(todo))
				abort "Please select todo wave."
			endif
			sq_checkPToFparamsSameTodo(todo)		// will abort if todo has issues
			sq_pop_toDoList("ams_todolist_pop",nan,popStr)
			nvar runNum = root:TWEPToF:runNum
			runNum=todo[0]
			STRUCT WMSetVariableAction sva
			sva.eventCode=3; sva.dval=runNum
			TWEPToF_runSetVar(sva)
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWDeconvParamMz_displayGr()

	DoWindow/F $TWParamMzgr
	if (V_flag)
		return 0
	else
		wave/z ScalarMS = $TWF+":ScalarMS"
		if(!WaveExists(ScalarMS)	 )
			Abort "You must first choose to deconvolve ePToF data via the TWEPToF graph."
		endif
	endif
	
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder $TWF+":"
	wave NewDeconParams
	wave ScalarMS
	wave NewDeconMz

	Display/N=$TWParamMzgr /W=(136.5,108.5,721.5,522.5) as TWParamMzgr
	AppendToGraph/L=scal ScalarMS vs NewDeconMz
//	AppendToGraph NewDeconParams[%scalar][*] vs NewDeconMz
	AppendToGraph/L=boxW NewDeconParams[%BoxW][*] vs NewDeconMz
	AppendToGraph/L=noise NewDeconParams[%noise][*] vs NewDeconMz
	AppendToGraph/L=bsl NewDeconParams[%bsl][*] vs NewDeconMz
	SetDataFolder fldrSav0
	ModifyGraph mode=4
	ModifyGraph rgb(NewDeconParams)=(0,0,0),rgb(NewDeconParams#1)=(19456,39168,0),rgb(NewDeconParams#2)=(0,24576,65280)
	ModifyGraph msize=1
	ModifyGraph offset(NewDeconParams)={1,0},offset(NewDeconParams#1)={1,0},offset(NewDeconParams#2)={1,0}
	ModifyGraph offset(ScalarMS)={1,0}
	ModifyGraph grid(bottom)=2
	ModifyGraph log(noise)=1,log(bsl)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(bottom)=(34816,34816,34816)
	ModifyGraph lblPos(scal)=80,lblPos(boxW)=80,lblPos(noise)=80,lblPos(bsl)=80
	ModifyGraph lblLatPos(scal)=-3,lblLatPos(noise)=-4,lblLatPos(bsl)=-6
	ModifyGraph freePos(boxW)={0,bottom}
	ModifyGraph freePos(noise)={0,bottom}
	ModifyGraph freePos(bsl)={0,bottom}
	ModifyGraph axisEnab(scal)={0.75,1}
	ModifyGraph axisEnab(boxW)={0.5,0.73}
	ModifyGraph axisEnab(noise)={0.25,0.48}
	ModifyGraph axisEnab(bsl)={0,0.23}
	ModifyGraph freePos(scal)={0,bottom},  freePos(boxW)={0,bottom},  freePos(noise)={0,bottom},  freePos(bsl)={0,bottom}
	ModifyGraph lblPos(scal)=60,  lblPos(boxW)=60,  lblPos(noise)=60,  lblPos(bsl)=60
	ModifyGraph axisEnab(bottom)={0.05,1}
	Label scal "scalar"
	Label bottom "m/z"
	Label boxW "Box width"
	Label noise "noise"
	Label bsl "bsl"
	ModifyGraph zero(scal)=1
	ShowInfo
	ControlBar 20			//1.59F
	TitleBox titleTWDeconv title="TW deconvolution for current selection", frame=0,pos={2,2}
End


Function TWEPToF_ShowHideCheck(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			string type = ReplaceString("check_", cba.ctrlName,"")
			ModifyGraph/W=$TWgr HideTrace($type) = !checked
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_butt(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			TWEPToF_displayGr()
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWEPToF_mzTImeSetVar(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			Variable dval = sva.dval
			String sval = sva.sval
			wave EPToF_bsl= root:diagnostics:EPToF_bsl
			wave EPToF_noise= root:diagnostics:EPToF_noise
			wave EPToF_scalar= root:diagnostics:EPToF_scalar
			wave EPToF_boxW= root:diagnostics:EPToF_boxW
			wave OneMz_boxW = root:TWEPToF:OneMz_boxW
			wave OneMz_bsl = root:TWEPToF:OneMz_bsl
			wave OneMz_noise = root:TWEPToF:OneMz_noise
			wave OneMz_scalar = root:TWEPToF:OneMz_scalar
			OneMz_boxW = EPToF_boxW[p][dval-1]
			OneMz_bsl = EPToF_bsl[p][dval-1]
			OneMz_noise = EPToF_noise[p][dval-1]
			OneMz_scalar = EPToF_scalar[p][dval-1]

			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWParamTime_Calc()

	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
	wave/z todo = $"root:"+sq_toDoWvNm
	wave t_series = root:index:t_series

	variable/g   $TWF+":mzTseries"
	make/o/n=(numpnts(t_series)) $TWF+":OneMz_scalar"/wave=OneMz_scalar
	make/o/n=(numpnts(t_series)) $TWF+":OneMz_boxW"/wave=OneMz_boxW
	make/o/n=(numpnts(t_series)) $TWF+":OneMz_noise"/wave=OneMz_noise
	make/o/n=(numpnts(t_series)) $TWF+":OneMz_bsl"/wave=OneMz_bsl

End


Function TWParamTime_DisplayGr()

	DoWindow/F $TWParamTimegr
	if (V_flag)
		return 0
	endif
	
	wave/z deconvolveType = root:diagnostics:deconvolveType
	if (!WaveExists(deconvolveType))
		abort "You must first preprocess some EPTOF data with the TW deconvolution scheme."	
	endif
	FindValue/V=3 deconvolveType
	if (V_Value == -1)
		abort "You must first preprocess some EPTOF data with the TW deconvolution scheme."	
	endif
	
	TWParamTime_Calc()
	
	String fldrSav0= GetDataFolder(1)
	wave t_series = root:index:t_series
	SetDataFolder $TWF+":"
	wave OneMz_scalar,OneMz_boxW, OneMz_noise, OneMz_bsl
	Display/N=$TWParamTimegr /W=(30,50,480,300) as TWParamTimegr
	AppendToGraph/L OneMz_scalar vs t_series
	AppendToGraph/L=boxW OneMz_boxW vs t_series
	AppendToGraph/L=noise OneMz_noise vs t_series
	AppendToGraph/L=bsl OneMz_bsl vs t_series
	SetDataFolder fldrSav0
	ModifyGraph mode=4
	ModifyGraph rgb(OneMz_scalar)=(0,0,0),rgb(OneMz_boxW)=(19456,39168,0),rgb(OneMz_bsl)=(36864,14592,58880)
	ModifyGraph gaps=0
	ModifyGraph msize=1
	ModifyGraph grid(bottom)=2
	ModifyGraph log(noise)=1,log(bsl)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(bottom)=(34816,34816,34816)
	ModifyGraph lblPos(left)=80,lblPos(boxW)=80,lblPos(noise)=80,lblPos(bsl)=80
	ModifyGraph lblLatPos(left)=-3,lblLatPos(noise)=-4,lblLatPos(bsl)=-6
	ModifyGraph freePos(boxW)={0,bottom}
	ModifyGraph freePos(noise)={0,bottom}
	ModifyGraph freePos(bsl)={0,bottom}
	ModifyGraph axisEnab(left)={0.75,1}
	ModifyGraph axisEnab(boxW)={0.5,0.73}
	ModifyGraph axisEnab(noise)={0.25,0.48}
	ModifyGraph axisEnab(bsl)={0,0.23}
	ModifyGraph dateInfo(bottom)={0,1,0}
	Label left "scalar"
	Label bottom " "
	Label boxW "Box width"
	Label noise "noise"
	Label bsl "bsl"
	ShowInfo
	ControlBar 20
	SetVariable setvarmz pos={190,0},size={80,16}, title="m/z",value=$TWF+":mzTseries", proc=TWEPToF_mzTImeSetVar

	SetDataFolder $fldrSav0
	
	nvar mzTseries=$TWF+":mzTseries"
	if (mzTseries<12)
		mzTseries=28	
	endif
		
End


Function/wave TWRetrieveEPToFSumDiff(todo)
wave todo

	nvar ms0_ion2mass= root:panel:ms0_ion2mass
	nvar ms0_corr = root:panel:ms0_corr
	nvar ms0_msTseries_suffix_ck = root:panel:ms0_msTseries_suffix_ck
	nvar ms0_AppendErrorBars = root:panel:ms0_AppendErrorBars
	svar ms0_speclist = root:panel:ms0_speclist
	svar MSStickList = root:panel:MSStickList
	nvar ms0_dataType= root:panel:ms0_dataType
	nvar ms0_AvGraphType= root:panel:ms0_AvGraphType
	nvar ms0_graphOutputType= root:panel:ms0_graphOutputType
	svar sq_toDoList=root:panel:sq_toDoList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm

	variable ListNum = WhichListItem("ePToFSumDiff",MSStickList)
	if (ListNum<0)
		variable pos, maxMz=0
		pos = sq_findRun(root:index:rn_series,todo[0]) 
		make/o/n=(maxMz)  root:TWEPToF:EPToFSumDiffMS = nan
		abort "You must generate ePToFSum before you proceed.  Do this in the preprocess step."
	endif
	
	ms0_speclist=""
	ms0_ion2mass=0
	ms0_corr=0
	ms0_AppendErrorBars=0

	PopUpMenu ms0_dataType,  win =  AMS_panel, mode = ListNum+1
	ms0_dataType = ListNum+1
//	sq_pop_getVariable("ms0_dataType",ListNum,"ePToFSumDiff") 
	
	PopUpMenu ms0_AvGraphType,  win =  AMS_panel, mode =1
	ms0_AvGraphType = 1
//	sq_pop_getVariable("ms0_AvGraphType",1,"Sticks") 
	
	PopUpMenu ms0_graphOutputType,  win =  AMS_panel, mode=5
	ms0_graphOutputType=5
//	sq_pop_getVariable("ms0_graphOutputType",5,"Do Nothing") 

	string tempStr = sq_MSCalc_avgStick(NameofWave(todo), todoWave=todo) 		//1.47B
	string WaveListToPlotStick=stringFromList(0, tempStr, ",")
//	string WaveListToPlotFactors=stringFromList(1, tempStr,",")	

	// put results in TWEPTOF
	Wave MSAvg = $stringFromList(0,WaveListToPlotStick)
	duplicate/o MSAvg root:TWEPToF:EPToFSumDiffMS/wave =ePToFSumDiffMS

	return MSAvg
End


// Creates and fills in values for waves DeconIntegrated and ScalarMS.. does not change newDecon2D
//  DATA is NOT multiplied by scalar
Function/wave TWDoScaling(MSAvg, newDecon2D,twPTOFTime, ScalarMS, DeconIntegrated, pos)		// MSAvg is the ePToFSumDiff  mass spec 1D wave
wave MSAvg, newDecon2D, twPTOFTime, ScalarMS, DeconIntegrated
variable pos

	// we have retrieved MS from EPToFSum Diff
	variable SumVal, eSumVal, idex, Integsum
	wave ChopperFreq = root:diagnostics:ChopperFreq

	variable maxmz = dimsize(newDecon2D,1)
	redimension/n=(maxmz) ScalarMS
	redimension/n=(maxmz) DeconIntegrated

	for(idex=0;idex<maxmz;idex+=1)
		MatrixOp/o/free oneMz = col(newDecon2D,idex) 
		Integsum=areaXY(twPTOFTime, oneMz)		// * ChopperFreq[pos]/ePToFFractionOpen
		DeconIntegrated[idex] = Integsum
		ScalarMS[idex] =MSAvg[idex]/Integsum
	endfor

	ScalarMS= numtype(ScalarMS[p]) == 0 ? ScalarMS[p] : 0
	
End


Function TWMzVsMz_displaygr() 
	DoWindow/F $TWMzVsMzgr
	if (V_flag)
		return 0
	else
		wave/z EPToFSumDiffMS = $"root:TWEPToF:EPToFSumDiffMS"
		if(!WaveExists(EPToFSumDiffMS)	 )
			Abort "You must first choose to deconvolve ePToF data via the TWEPToF graph."
		endif
	endif
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:TWEPToF:
	wave DeconIntegrated,  EPToFSumDiffMS, NewDeconMz
	Display/N=$TWMzVsMzgr /W=(35.25,43.25,584.25,485.75) DeconIntegrated vs EPToFSumDiffMS as TWMzVsMzgr
	SetDataFolder fldrSav0
	ModifyGraph mode=3
	ModifyGraph textMarker(DeconIntegrated)={root:TWEPToF:NewDeconMz,"default",0,0,5,0.00,0.00}
	ModifyGraph grid=2
	ModifyGraph log=1
	ModifyGraph gridRGB=(34816,34816,34816)
	SetAxis left 0.001,500000
	SetAxis bottom 0.001,500000
	ShowTools/A
	SetDrawLayer UserFront
	SetDrawEnv xcoord= prel,ycoord= prel
	DrawLine 0,1,1,0

	Label left "Deconvoluted, Integrated ePToF, Unscaled, Hz"
	Label bottom "ePToFSumDiff, Hz"
	ControlBar 20			//1.59F
	TitleBox titleTWDeconv title="TW deconvolution for current selection", frame=0,pos={2,2}
End


Function TWEPToF_initializeNonePToF()

	string df = GetDataFolder(1)
	SetDataFolder $TWF

	wave unDecon2D, newDecon2D,matDecon2D,demux2D, unDeconSmooth2D, matDeconSmooth2D
	wave unDecon1D, newDecon1D,matDecon1D,demux1D, unDeconSmooth1D, matDeconSmooth1D, noise1D, baselineRegion
	wave twPToFTime, PToFtime, DVaSize	// , dtdlogdp

	unDecon2D=nan; newDecon2D=nan;matDecon2D=nan;demux2D=nan; unDeconSmooth2D=nan; matDeconSmooth2D=nan
	unDecon1D=nan; newDecon1D=nan;matDecon1D=nan;demux1D=nan; unDeconSmooth1D=nan; matDeconSmooth1D=nan
	DVaSize=nan		// don't do PToFtime so graph doesn't collapse

	SetDataFolder $df

	TWEPTOF_initialzeValDisplay()

End


Function TW_grButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			string grStr = ReplaceString("TWbutt_",  ReplaceString("TW_", ba.ctrlname, ""), "")
			DoWindow/F $grStr
			if (!V_flag)
				grStr =  ReplaceString("_gr", grStr, "_Displaygr")+"()"
				execute grStr
			endif
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


Function TWMassSpec_displaygr()
	DoWindow/F $TWMassSpecgr
	if (V_flag)
		return 0
	endif
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:TWEPToF:
	wave EPToFSumDiffMS,DeconIntegrated
	wave amus = root:diagnostics:amus
	Display/N=$TWMassSpecgr /W=(100,100,500,500) as TWMassSpecgr
	AppendToGraph EPToFSumDiffMS vs amus[0,numpnts(EPToFSumDiffMS)]
	AppendToGraph DeconIntegrated vs amus[0,numpnts(EPToFSumDiffMS)]
	SetDataFolder fldrSav0
	ModifyGraph mode=1
	ModifyGraph lSize=2
	ModifyGraph rgb(EPToFSumDiffMS)=(0,0,0)
	ModifyGraph offset(DeconIntegrated)={0.2,0}
	ModifyGraph log(left)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	Label left "Hz"
	Label bottom "m/z"
	SetAxis left 0.01,1000000
	Legend/C/N=text0/J "\\s(EPToFSumDiffMS) EPToFSumDiffMS\r\\s(DeconIntegrated) DeconIntegrated"
	ControlBar 20			//1.59F
	TitleBox titleTWDeconv title="TW deconvolution for current selection", frame=0,pos={2,2}
End

