#pragma TextEncoding = "Windows-1252"
#pragma rtGlobals=3		// Use modern global access method.
//#pragma version=1.17d// decided to not use pragma but a string constant 

// Main Panel Functions for High ToF-AMS analysis Toolkit
// Peak Integration by Key Analysis (PIKA)
//Copyright (C) 2005, 2006, 2007,2008, 2009,2010,2011, 2012, 2013, 2014, 2015, 2016, 2017
// Pete DeCarlo, Allison Aiken, Jose Jimenez, Donna Sueper University of Colorado
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
///////////////////////////////////////////////////////////////////////////////
// CURRENT STATUS
// see HR read me file for details.


//  These string constants were overhauled slightly in 1.09D
STRCONSTANT PKVERSION = "1.22A"

STRCONSTANT DOUG5GRAPH_MAINFAMLIST="familyCx/familyCH/familyCHO1/familyCHOgt1/familyCHO1N/familyCHOgt1N/familyCHN/familyNO/familyNH/familySO/familyCl/"
STRCONSTANT DOUG5GRAPH_MAINFAMAXISLIST="C/C/CHO/CHO/CHON/CHON/CHN/NONHSOCl/NONHSOCl/NONHSOCl/NONHSOCl/"
STRCONSTANT DOUG5GRAPH_HRSPECAXISLIST="C/C/CHO/CHO/CHON/CHON/CHN/Inorganics/Inorganics/Inorganics/Inorganics/"
STRCONSTANT DOUG5GRAPH_HRSPECLABELLIST="C(Hy)/C(Hy)/CHO(y)/CHO(y)/CHO(y)N/CHO(y)N/CH(y)N/Inorganics/Inorganics/Inorganics/Inorganics/"		//1.09E
STRCONSTANT DOUG5GRAPH_HRSPECLIST="HROrg/HROrg/HROrg/HROrg/HROrg/HROrg/HROrg/HRNO3/HRNH4/HRSO4/HRChl/"
STRCONSTANT DOUG5GRAPH_SPECDEFAXISLIST="HROrg:CHO;HRNO3:Inorganics;HRNH4:Inorganics;HRChl:Inorganics;HRSO4:Inorganics"	//place where extra families are plotted
		
STRCONSTANT DEFAULTHRSPECIES="HROrg,HRNO3,HRSO4,HRNH4,HRChl,"   //1.20H
STRCONSTANT DEFAULTHRFRAGS="organic;nitrate;sulphate;ammonium;chloride;"   //1.20H

Menu "AMS"
	"HR Analysis/2",  /q,HR_getHRwin()
End


Function HR_getHRwin()
	// first check to see that the squirrel window exists, because later we set the todo wave to the currently chosen one.
	DoWindow ams_panel		// added in 1.09L
	if (V_flag==0)
		sq_getAMSwin()
	endif
	string windows=winlist("HR_Analysis_Panel",";","WIN:64")
	if(strlen(windows)>0)
		dowindow/f HR_Analysis_Panel
	else
		HR_globals()
		HR_Analysis_Panel_Create()
	endif

End


Function HR_globals()

//	Presumes that the HR folder already exists, is populated.
	NewDataFolder/o root:HR_panel
	NewDataFolder/o root:Int_Sticks
	NewDataFolder/o root:HR_Sticks
	NewDataFolder/o root:HR_ms_mats		// added 1.07C

//	panel instructions, global strings	
	KillStrings/z root:HR_panel:Step0Astr, root:HR_panel:Step0Bstr, root:HR_panel:Step0Cstr, root:HR_panel:Step0Dstr
	sq_initializeGlobalSVar("root:HR_panel:Step0Astr", "Step 0A: Set up Squirrel by pressing the Get Index button.")
	sq_initializeGlobalSVar("root:HR_panel:Step0Bstr", "Step 0B: Get accurate m/z fitting parameters. Go to the m/z calibration button to view/change.")
//	sq_initializeGlobalSVar("root:HR_panel:Step0Cstr", "Step 0C: If using raw spectra with Squirrel baselines removed, press the Check baseline button.")
	sq_initializeGlobalSVar("root:HR_panel:Step0Cstr", "Step 0C: Get good baseline parameters. Go to the baseline button to view/change.")
	sq_initializeGlobalSVar("root:HR_panel:Step0Dstr", "Step 0D: Pre-process the raw and stick MS data. Keep the MS m/z duty cycle box checked.")

	KillStrings/z root:HR_panel:Step0Astr1, root:HR_panel:Step0Bstr2, root:HR_panel:Step0Cstr1, root:HR_panel:Step0Cstr2
	sq_initializeGlobalSVar("root:HR_panel:Step0Astr1", "If you have already pressed the 'Get Index' button in a squirrel experiment you don't have to do it again.")
	sq_initializeGlobalSVar("root:HR_panel:Step0Bstr2", "")
	svar Step0Bstr2 = root:HR_panel:Step0Bstr2
	Step0Bstr2 = "If you want to use different m/z fittting parameters for open and closed take care of this in the\r"
	Step0Bstr2 += "mz calibration panel."
	sq_initializeGlobalSVar("root:HR_panel:Step0Cstr2", "")
	svar Step0Cstr2 = root:HR_panel:Step0Cstr2
	Step0Cstr2 = "Set all of your baseline parameters to reflect good stick integration and baseline regions."

	KillStrings/z root:HR_panel:Step1str
	sq_initializeGlobalSVar("root:HR_panel:Step1str", "Step 1: Generate the raw difference spectra (MSDiff_p) and the raw spectra less baselines.")
	KillStrings/z root:HR_panel:Step1str
	sq_initializeGlobalSVar("root:HR_panel:Step1str", "Step 1: Prepare raw spectra for HR analysis.")
	KillStrings/z root:HR_panel:Step1str2
	sq_initializeGlobalSVar("root:HR_panel:Step1str2", "All calculations are done in Hz/ns. If you change your baseline parameters you must redo this step.")

	sq_initializeGlobalSVar("root:HR_panel:Step2str", "Step 2: Generate peak width and peak shape parameters.")
	
	sq_initializeGlobalSVar("root:HR_panel:Step3str", "Step 3: Choose HR masses to fit.")

//	sq_initializeGlobalSVar("root:HR_panel:Step3str1", "")
//	svar Step3str1 = root:HR_panel:Step3str1
//	Step3str1 = "Before you choose masses to fit, you can \r(1) update the complete list of all known masses\r(2) review or declare 'families' - a set of related masses.\rIf you define a new family, you must reselect your masses for it to take effect."
//	sq_initializeGlobalSVar("root:HR_panel:Step3str2", "")
//	svar Step3str2 = root:HR_panel:Step3str2
//	Step3str2 = "After you choose masses to fit, you can view all chosen masses or a family of chosen masses."
	
	sq_initializeGlobalSVar("root:HR_panel:Step3A", "Step 3A: (Optional and can be done after sticks fit) Modify family, HR species defaults.")

	killstrings/z root:HR_panel:Step4str
	sq_initializeGlobalSVar("root:HR_panel:Step4str", "Step 4: Calculate HR sticks and inspect HR fits for one set of spectra.")

	sq_initializeGlobalSVar("root:HR_panel:Step4str2", "")	
	sq_initializeGlobalSVar("root:HR_panel:HRFit_title_Step4OR", "OR")	
	svar Step4str2 = root:HR_Panel:Step4str2
	Step4str2 =  "The initial selection of HR ions to fit will (likely) never be optimal. Aside from the HR_PeakHeights_gr,\r"
	Step4str2 +=  "you can also use the diagnostic tools below to evaluate the appropriateness of your HR ion choices."

	killstrings/z root:HR_panel:Step4str3, root:HR_panel:Step4str4, root:HR_panel:Step4str5

	sq_initializeGlobalSVar("root:HR_panel:Step4str3", "Step Diagnostic 4A: View Mass Spectra\rgraph Squirrel sticks, Pika UMR sticks.")	
	sq_initializeGlobalSVar("root:HR_panel:Step4str6", "Step Diagnostic 4B: View 5 panel\rMass Spectra UMR graph")
	sq_initializeGlobalSVar("root:HR_panel:Step4str4", "Step Diagnostic 4C: Display raw spectra\rresidual (top trace in HR_PeakHeights_gr)." )	
	sq_initializeGlobalSVar("root:HR_panel:Step4str5", "Step Diagnostic 4D: Table of HR ions,\rpeak heights and peak areas.")	

	killstrings/z root:HR_panel:Step5str, root:HR_panel:Step5str2
	sq_initializeGlobalSVar("root:HR_panel:Step5str", "Step 5: Calculate HR sticks for each run in current todo wave.")
	sq_initializeGlobalSVar("root:HR_panel:Step5str2", "")
	svar Step5str2 = root:HR_Panel:Step5str2
	Step5str2+="This step is time consuming. All HR fit options in Step 4 will be used.\r"
	Step5str2+="It is recommended that users first perform this step on a todo wave with a small number of runs (<50)\r"
	Step5str2+="and then examine step 5 diagnostics before performing HR fits on a todo wave with a large number of runs."
	
	killstrings/z root:HR_panel:Step5iAstr, root:HR_panel:Step5iiAstr
//	sq_initializeGlobalSVar("root:HR_panel:Step5iAstr",  "Step 5i: (For HR sticks found previous to 1.09H)\rCalculate total ion count error in todo wave.")
//	sq_initializeGlobalSVar("root:HR_panel:Step5iiAstr", "Step 5ii: (For HR sticks found previous to 1.12N)\rCalculate total signal error in todo wave.")
	sq_initializeGlobalSVar("root:HR_panel:Step5iAstr",  "Step 5i: (For HR sticks found previous to 1.09H)\rCalculate signal count error in todo wave.")

	killstrings/z root:HR_panel:Step6str, root:HR_panel:Step7str, root:HR_panel:Step8str , root:HR_panel:Step6iistr
	sq_initializeGlobalSVar("root:HR_panel:Step6str", "Step 6i: Describe characteristics of HR results you want to generate.")

	sq_initializeGlobalSVar("root:HR_panel:Step6iistr", "Step 6ii: Select the type of result to generate.")
	
	sq_initializeGlobalSVar("root:HR_panel:Step7str", "Step 5 Diagnostic A: Plot summed residuals vs time.")

	killstrings/z root:HR_panel:Step8st
	sq_initializeGlobalSVar("root:HR_panel:Step8str", "Step 5 Diagnostic B: Plot 10 consecutive UMR diagnostics vs time.")

	// very general globals
	killstrings/z  root:HR_Panel:HR_CreditsInfo
	sq_initializeGlobalSVar("root:HR_Panel:HR_CreditsInfo", "")			// in Credits panel	
	svar HR_CreditsInfo = root:HR_Panel:HR_CreditsInfo
	HR_CreditsInfo = "High Resolution Analysis (Pika) code is based on algorithms described in:\r\r"	
	HR_CreditsInfo += "DeCarlo, et al., Field-Deployable, High-Resolution, Time-of-Flight Aerosol\r"
	HR_CreditsInfo += "Mass Spectrometer, Analytical Chemistry, 78: 8281-8289, 2006\r"
	HR_CreditsInfo += "\r\r\r"
	HR_CreditsInfo += "Elemental Anlaysis (APES) code is based on the algorithms described in:\r\r"	
	HR_CreditsInfo += "Aiken, DeCarlo, and Jimenez,  Elemental Analysis of Organic\r"
	HR_CreditsInfo += "Species with Electron Ionization High-Resolution Mass Spectrometry, \r"
	HR_CreditsInfo += "Analytical Chemistry, 79, 8350-8358, doi:10.1021/ac071150w, 2007\r"
	HR_CreditsInfo += "\r\r\r"
	HR_CreditsInfo += "Aiken, et al., O/C and OM/OC Ratios of Primary, Secondary, and Ambient\r"
	HR_CreditsInfo += "Organic Aerosols with High Resolution Time-of-Flight Aerosol Mass\r"
	HR_CreditsInfo += "Spectrometry,  Environmental Science and Technology, 42, 4478-4485,\r"
	HR_CreditsInfo += "doi: 10.1021/es703009q, 2008\r"
	 
	sq_initializeGlobalSVar("root:HR_Panel:HR_ugm3_str", "")			// 1.04J
	svar HR_ugm3_str = root:HR_Panel:HR_ugm3_str
	HR_ugm3_str = "* The RIE and CE for HR ions and HR families is 1 (Nitrate Equiv. g/m3)."

	sq_initializeGlobalNVar("root:HR_Sticks:HR_isW", Nan)					// not in any panel or graph, used in HR code
	sq_initializeGlobalNVar("root:HR_Sticks:HR_MaxNumGausFits", 100)		// not in panel or graph, used in HR code// changed in 1.16L
	variable/g root:HR_Sticks:HR_MaxNumGausFits=100
	
	// checkboxes, flags panel strings
	sq_initializeGlobalNVar("root:HR_Panel:HR_UsePeakShapeVar", 1)		// in HR panel, step 4
	sq_initializeGlobalNVar("root:HR_Panel:HR_UseVaryingPeakWidth", 0)		// in HR panel, step 4
	sq_initializeGlobalNVar("root:HR_Panel:HR_UseFixedIsotopicVals", 1)		// in HR panel, step 4
	sq_initializeGlobalNVar("root:HR_Panel:HR_UseOpenClosedMzParams", 0)	// in HR panel, step 4
	sq_initializeGlobalNVar("root:HR_Panel:HR_checkDoNotGrabRawSpectra", 0)// in HR panel, step 4 	// misnamed, should be single run or average todo
	sq_initializeGlobalNVar("root:HR_Panel:HR_RunVar", 0)					// in HR panel, run number, step 4	
	sq_initializeGlobalSVar("root:HR_Panel:HR_RunModeStr", "")				// in HR panel, string showing  v or w mode, step 4	

	sq_initializeGlobalNVar("root:HR_Panel:HR_IfFitNegConstrainToZero", 0)			// in HR panel, step 4		// added in 1.03C

	Killwaves/z root:HR_Sticks:HR_UsePeakShapeVar	
	Killwaves/z root:HR_Sticks:HR_UseVaryingPeakWidth			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_UseFixedIsotopicVals				// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_UseOpenClosedMzParams		// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_checkDoNotGrabRawSpectra			// misnamed, should be single run or average todo
	Killwaves/z root:HR_Sticks:HR_RunVar							// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_RunModeStr						// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_MakeStickSpectraPlot			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_MakeResidualPlot				// obsolete in 1.40A

//	Killvariables/z root:HR_Sticks:HR_CalcManyRunsOpenClosed				// obsolete in 1.40A
//	sq_initializeGlobalNVar("root:HR_Panel:HR_CalcManyRunsOpenClosed", 1)	// in HR panel, step 5
	
	sq_initializeGlobalNVar("root:HR_Panel:HR_MinimumPeakHeight", -1e-8)			// added in 103D

	Killwaves/z root:HR_Sticks:HR_CalcManyRunsOpenClosed		// obsolete in 1.40A

	sq_initializeGlobalSVar("root:HR_panel:HR_StickList", "")				// in HR panel, string showing  v or w mode, step 4	
	sq_initializeGlobalSVar("root:HR_panel:HR_StickListStr", "")				// in HR panel, string showing  v or w mode, step 4	

//	sq_initializeGlobalSVar("root:HR_Panel:HR_MassListVsTime", "")		// in HR panel, step 6
	sq_initializeGlobalNVar("root:HR_Panel:HR_ChosenMassesIntegerAMU", 40)	// in HR panel, step 6, amu value, some default value
	sq_initializeGlobalNVar("root:HR_Panel:HR_Check_newTimeGr", 1)		// in HR panel, step 6
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeSeriesClosed", 0)		// in HR panel, step 6
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeSeriesOpen", 0)			// in HR panel, step 6
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeSeriesDiff", 1)			// in HR panel, step 6

	Killwaves/z root:HR_Sticks:HR_MassListVsTime			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_ChosenMassesIntegerAMU	// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_Check_newTimeGr			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeSeriesClosed			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeSeriesOpen			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeSeriesDiff				// obsolete in 1.40A

	Killvariables/z root:HR_Panel:HR_checkNewResidSeriesGr				// obsolete in 1.40A
	sq_initializeGlobalNVar("root:HR_Panel:HR_checkNewResidSeriesGr", 1)		// in HR panel, step 7	
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeResidSeriesClosed", 0)		// in HR panel, step 7
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeResidSeriesOpen", 0)		// in HR panel, step 7
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeResidSeriesDiff", 1)			// in HR panel, step 7
	sq_initializeGlobalNVar("root:HR_Panel:HR_TimeResidSeriesMz", 40)			// in HR panel, step 7, amu value, some default value

	Killwaves/z root:HR_Sticks:HR_checkNewResidSeriesGr		// obsolete in 1.40A	
	Killwaves/z root:HR_Sticks:HR_TimeResidSeriesClosed			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeResidSeriesOpen			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeResidSeriesDiff			// obsolete in 1.40A
	Killwaves/z root:HR_Sticks:HR_TimeResidSeriesMz				// obsolete in 1.40A

	// for Step 4 Sticks_gr
	KillStrings/z root:HR_Sticks:HR_SticksGr_Title
	sq_initializeGlobalSVar("root:HR_Sticks:HR_SticksGr_Title", "Peak Heights "+PKVERSION)	// in Sticks_gr
	sq_initializeGlobalSVar("root:HR_Sticks:HR_SticksGr_RunInfo", "")		// in Sticks_gr, shows the run mode and run time
	sq_initializeGlobalNVar("root:HR_Sticks:HR_DisplayMz", 40)				// in Sticks_gr, the first default m/z value   //1.07A	
	sq_initializeGlobalNVar("root:HR_Sticks:HR_SetYaxisAbove0", 1)			// in Sticks_gr, checkbox
	sq_initializeGlobalNVar("root:HR_Sticks:HR_StickGr_amuWidth", 0.3)		// in Sticks_gr, set variable
	sq_initializeGlobalSVar("root:HR_Sticks:HR_DeltaValStr", "")				// in Sticks_gr, the delta (steps from mass 14)
//	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowInsets", 0)				// in Sticks_gr
	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowSQBaselineFits", 0)				// in Sticks_gr		// added in 103C

	sq_initializeGlobalSVar("root:HR_Sticks:SticksGr_newIonName", "")		// in Sticks_gr		// added in 103C
	sq_initializeGlobalNVar("root:HR_Sticks:SticksGr_newIonMass", 0)			// in Sticks_gr		// added in 103C
	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowHorGrids",1)				// in Sticks_gr		// added in 103C
	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowVerGrids", 1)			// in Sticks_gr		// added in 104J
	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowAllTags", 1)				// in Sticks_gr		// added in 103C

	sq_initializeGlobalSVar("root:HR_Panel:IsoChildTableInstruct", "Iso. child table below to show:")
	sq_initializeGlobalSVar("root:HR_Panel:MassCalcInstructions", "Enter the chemical formula for the HR ion to investigate.")
	sq_initializeGlobalSVar("root:HR_Panel:QueryInstructions",  "Choose the type of query and characteristics to search for.")

	sq_initializeGlobalSVar("root:HR_Sticks:HR_legendStr", "")				// in Sticks_gr	
	svar HR_legendStr = root:HR_sticks:HR_legendStr  
	HR_legendStr = "Black = raw data\r"
	HR_legendStr +="Orange = Open fits, resid\r"		//1.05A removed the word "gauss"
	HR_legendStr +="Brown = Closed fits, resid\r"
	HR_legendStr +="Red = Diff  fits, resid\r"
	HR_legendStr += "Gray Region = HR fit region, grids\r"
	HR_legendStr += "Dotted Blue = sum fits\r"
	HR_legendStr += "Thick red = SQ baseline fits\r"
	HR_legendStr += "Pink = Open - Closed stick\r"	
//	HR_legendStr += "Thick error bars from residuals\r"		  1.09H
	HR_legendStr += "Pink error bars from counting stat."

	// grid markers for the one run Sticks graph
	make/o/n=2  root:HR_sticks:gridMarks01 = 0.1
	make/o/n=2  root:HR_sticks:gridMarks1 = 1
	make/o/n=2  root:HR_sticks:gridMarks10 = 10
	make/o/n=2  root:HR_sticks:gridMarks100	 = 100
	make/o/n=2  root:HR_sticks:gridMarksX= {0, 200}	// go out to some arbitrary amu
	
	wave/z mask_CHOgt1N = root:Int_sticks:mask_CHOgt1N		// for now test the existence of only one of these waves.  Assume that if it does not exist, other new ones (1.05) don't either
	if (!WaveExists(mask_CHOgt1N))
		HR_MakeHRFamilyBatch()		//1.04P	unfortunately, folks who have declared existing families will have to redo
	endif
	
	// species family stuff	
//	HR_MakeIntegrationMaskWave() // 1.08E

	KillVariables/z root:HR_Sticks:HR_PeakCenterDeltaPpm		// obsolete as of 1.40A

	//  For HR Mass choosing panel
	KillStrings/z root:HR_Sticks:ChooseMassStr1		// to reset
	sq_initializeGlobalSVar("root:HR_Sticks:ChooseMassStr1","")
	svar ChooseMassStr1 =  root:HR_Sticks:ChooseMassStr1 
	ChooseMassStr1 = "Select the masses you wish to fit for all subsequent analyses by entering\r"
	ChooseMassStr1+="a 1 in the red HR Mask column in the All Masses Table.  Enter 0 if you \r" 
	ChooseMassStr1+="wish not to fit this mass.  If you would like to add a new mass, make sure\r"
	ChooseMassStr1+="that you add a row to all columns in the All Masses Table.\r"
	ChooseMassStr1+="If you wish to change an isotopic abundance value, do so in this table."
	
	KillStrings/z root:HR_Sticks:ChooseMassStr2		// to reset
	sq_initializeGlobalSVar("root:HR_Sticks:ChooseMassStr2", "")
	svar ChooseMassStr2 = root:HR_Sticks:ChooseMassStr2 	
	ChooseMassStr2 = "After you have chosen the HR masses to fit, isotopic masses will be shown\r"
	ChooseMassStr2+="below.  Select the isotopes you wish to constrain (to force the value to be\r"
	ChooseMassStr2+="equal to the isotopic abundance of its parent) by entering a 1 in the red\r"
	ChooseMassStr2+="Isotopic Mask column in the Isotopes Table.  Enter 0 if you wish not to\r"
	ChooseMassStr2+="constrain the fit of this mass.\r"
	ChooseMassStr2+="Users will have the option to perform HR fits with selected isotope values\r"
	ChooseMassStr2+="to be constrained (or not) the checkbox in step 4ii in the main HR panel.\r"
	ChooseMassStr2+="If you wish to change an isotopic abundance value, do it in the All Masses\r"
	ChooseMassStr2+="table, (to the left) *not* this table."

	KillStrings/z root:HR_Sticks:ChooseMassStr3		// to reset
	sq_initializeGlobalSVar("root:HR_Sticks:ChooseMassStr3","")
	svar ChooseMassStr3 =  root:HR_Sticks:ChooseMassStr3 

	ChooseMassStr3=""
	ChooseMassStr3+="Once you have chosen the HR masses to fit, you can view a subset of\r"
	ChooseMassStr3+="the masses that have certain common chemical elements. Select values\r"	
	ChooseMassStr3+="from the popup menus and press the 'Find masses' button to view a subset."

	wave/z IsotopicMassWave = root:HR_Sticks:IsotopicMassWave
	if(!WaveExists(IsotopicMassWave) )
		make/o/n=0 root:HR_Sticks:IsotopicMassWave, root:HR_Sticks:IsotopicAbund, root:HR_Sticks:IsotopicMask, root:HR_Sticks:IsotopicParentWave
		make/t/o/n=0 root:HR_Sticks:IsotopicMassText, root:HR_Sticks:IsotopicParentText
	endif

	sq_initializeGlobalNVar("root:HR_panel:HR_FitVerboseMode", 0)			//1.02

	make/o/t/n=(10,2) root:HR_Sticks:IntegerMz_FittingMasses		// 10 is arbitrary	//1.03C used for PeakHeights_gr
	make/o/n=(10,2) root:HR_Sticks:IntegerMz_FittingMassesSelect	// 10 is arbitrary	//1.03C used for PeakHeights_gr

	sq_initializeGlobalNVar("root:HR_panel:HR_UseSqBaseline", 1)		// 1.04B
	nvar HR_UseSqBaseline = root:HR_panel:HR_UseSqBaseline
	HR_UseSqBaseline=1			// should always be used.  functionality removed in 1.09H
	
	sq_initializeGlobalNVar("root:HR_Sticks:HRSticksDisplayXResolution", 3001)		// 1.04B
	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowResidOnRawAxes", 0)		// 1.04B

	sq_initializeGlobalNVar("root:HR_Sticks:RawYAxisMinMax", 0)		// 1.04B		radio button on PeakHeightGr
	sq_initializeGlobalNVar("root:HR_Sticks:RawYAxisMax", 1)		// 1.04B
	sq_initializeGlobalNVar("root:HR_Sticks:RawYAxisMin", -.1)		// 1.04B
//	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowOffsetPeakHts", 0)		// 1.04B		//1.09H

	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowDiffEqOMC", 0)		// 1.04B
	 	
	sq_initializeGlobalNVar("root:HR_panel:HR_checkUseAB", 0)		// 1.04J
	sq_initializeGlobalNVar("root:HR_panel:HR_checkConvertTougm3", 0)  // 1.04J
//	sq_initializeGlobalNVar("root:HR_panel:HR_checkSumMStoUMR", 0) // 1.04J
	sq_initializeGlobalNVar("root:HR_panel:HR_checkTruncMSto0", 0) // 1.04J

//	sq_initializeGlobalSVar("root:HR_panel:HR_MassListvsMS", "")		// 1.04J
	sq_initializeGlobalNVar("root:HR_panel:HR_checkAvgHRMS_UMR", 0)	// 1.04J

 	hr_initializeGlobalWave("root:HR_Sticks:ChemicalFormulaMass", "0", nan)	
	hr_initializeGlobalTextWave("root:HR_Sticks:ChemicalFormulaText", 0, "")	
 
	sq_initializeGlobalNVar("root:HR_panel:HRResults_dataType", 0) // 1.04J
	sq_initializeGlobalNVar("root:HR_panel:HRResults_graphOutputType", 1) // 1.04J
 
	sq_initializeGlobalSVar("root:HR_panel:EA_calcStr", "All calculations are done in Hz.")
// 	sq_initializeGlobalSVar("root:HR_panel:HRAvgMassSpecStrWarning", "Be aware that displays for HR average mass specs are such\rthat the colors may be wrong and sticks may not be stacked.")
 
	Killstrings/z root:HR_panel:HR_MassListvsMS, root:HR_Panel:HR_MassListVsTime
 	sq_initializeGlobalSVar("root:HR_panel:HRResults_ionList", "")		//1.06E

	// HR Results & EA globals
	sq_initializeGlobalNVar("root:HR_panel:HR_checkConvertNansTo0", 0)	//checkbox
	sq_initializeGlobalNVar("root:HR_panel:HR_checkConvertNegsTo0", 0)	//checkbox
	sq_initializeGlobalNVar("root:HR_panel:HR_checkCalcHRErrors", 0)	//checkbox
//	sq_initializeGlobalNVar("root:HR_panel:HRResults_ErrType", 0) // 1.04J
	sq_initializeGlobalNVar("root:HR_panel:HR_checkAskForSuffix", 0)	// checkbox like SQ MS
//	sq_initializeGlobalNVar("root:HR_panel:HR_checkStackSticks", 0)	// checkbox like SQ MS

	sq_initializeGlobalNVar("root:HR_panel:EA_CalFactor_H_C", 0.91)		// cal factor from Alison's paper
	sq_initializeGlobalNVar("root:HR_panel:EA_CalFactor_O_C", 0.75)		// cal factor from Alison's paper
	sq_initializeGlobalNVar("root:HR_panel:EA_CalFactor_N_C", 0.96)		// cal factor from Alison's paper
	sq_initializeGlobalNVar("root:HR_panel:EA_CalFactor_S_C", 1)		// unknown, leave as 1 for default

	//sq_initializeGlobalNVar("root:HR_panel:EA_MassSpecNorm", 1)			// obsolete in 1.09D
	sq_initializeGlobalNVar("root:HR_panel:EA_MassSpecSepYAxis", 1)	// radio button 1 means separate y axis per species

	sq_initializeGlobalNVar("root:HR_panel:HRResults_whisker", 0) // 1.04J

	sq_initializeGlobalSVar("root:HR_frag:HRMassesNotFitList","")		// list of HR species that are in HR_specMassAlgebra but were not fit
	sq_initializeGlobalSVar("root:HR_frag:HRMassesNotFitPosList", "") 	// reverse-sort list of positions in the exactMassWave where the HRMassesNotFitList are inserted
	sq_initializeGlobalSVar("root:HR_frag:HRMassesNotFitPosListinAll", "")	// reverse sort list of positions in the ExactMass_ALL where HR mass exists.

	sq_initializeGlobalSVar("root:HR_panel:SQvsPKInfo", "") // 1.04J

	make/o root:HR_panel:One2one={1e-9,1e9}		//1.07A
		
	sq_initializeGlobalNVar("root:HR_panel:HR_check_Step1DoGausFits", 1)		//1.47I

	sq_initializeGlobalNVar("root:HR_Sticks:HR_ShowPKplusSQBaselineFits", 1)//1.47I		// functionality removed in 1.09H
	nvar HR_ShowPKplusSQBaselineFits = root:HR_Sticks:HR_ShowPKplusSQBaselineFits
	HR_ShowPKplusSQBaselineFits=1		//1.09H  Should always be 1

	sq_initializeGlobalSVar("root:HR_panel:TableTitleIsotopes",  "Isotopes table")		//1.07
	sq_initializeGlobalSVar("root:HR_panel:TableTitleAll",  "All HR ions table")		//1.07
	sq_initializeGlobalSVar("root:HR_panel:TableTitleChosen",  "Chosen HR ions table")		//1.07
	sq_initializeGlobalSVar("root:HR_panel:QueryOR", "OR")
	sq_initializeGlobalNVar("root:HR_panel:SaveAfterTodoFits", 1)		//1.08E
	sq_initializeGlobalSVar("root:HR_panel:InfoOfLastTodoFits", "Last fit of a todo wave:")		//1.08E
	
//	sq_initializeGlobalNVar("root:HR_panel:DontFitDiff", 0)		//1.10M		 changed in 1.10N

//1.09H
//	sq_initializeGlobalNVar("root:HR_panel:HR_FitFailClosed", 0)		//1.08E
//	sq_initializeGlobalNVar("root:HR_panel:HR_FitFailOpen", 0)		//1.08E
//	sq_initializeGlobalNVar("root:HR_panel:HR_FitFailDiff", 1)		//1.08E

	sq_initializeGlobalNVar("root:HR_sticks:HR_numFail", 0)		//1.08E
	sq_initializeGlobalNVar("root:HR_sticks:HR_ShowResidErrors", 0)		//1.08E
	
	sq_initializeGlobalNVar("root:HR_panel:HRIonCheckAllMassLimit", 1e-4)		//1.09
//	sq_initializeGlobalSVar("root:HR_sticks:toDoWvNm_FitTodo", "")		//1.08G  // not needed?
	
	sq_initializeGlobalSVar("root:HR_panel:Step5DiagnosticC", "Step 5Diagnostic C: Plot where HR fits didn't converge (sticks are nan)")

	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryFindChosen", 1)		//1.09G

	sq_initializeGlobalNVar("root:HR_panel:CreateItxForPMF", 1)		//1.08E

	sq_initializeGlobalNVar("root:HR_panel:NormalizeSpectra", 1)		//1.09H  forgot to create in 1.09G

	sq_initializeGlobalSVar("root:HR_frag:HRMassesNotFitButInHRFrag", "")		//1.10Q
	sq_initializeGlobalNVar("root:HR_panel:HR_ShowAlerts", 1)		//1.10Q

	sq_initializeGlobalSVar("root:HR_panel:HR_PToFUnitsStr", "^PToF data is dMdlog10dva")		//1.10R

	sq_initializeGlobalNVar("root:HR_panel:HR_elementalImprovedCal", 1)		//1.15Z

//	sq_initializeGlobalNVar("root:HR_panel:HR_checkPToFDVa", 1)		//1.19E

	pk_CreateElementWaves()		//1.08E
	
	HR_MassCalcGlobals()

	// added in 1.10B
	wave HR_specCalFac_list = root:HR_frag:HR_specCalFac_list
	SetFormula root:HR_frag:HR_specCalFac_list, " 1/ (root:HR_frag:HR_specIEFac_list* root:HR_frag:HR_specCEfac_list)" 
	//^ users may inadvertantly remove the dependency when editing the table.	
	
	sq_initializeGlobalNVar("root:HR_panel:HR_singleSpectraMSorPToF", 1)		//1.10Q

	NewDataFolder/o root:PToF
	wave/t/z PToFDataSetNames=root:PToF:PToFDataSetNames
	if (!WaveExists(PToFDataSetNames))
		make/o/t/n=0 root:PToF:PToFDataSetNames
	else
		make/o/n=(numpnts(PToFDataSetNames)) root:PToF:PToFTodoFit=0			//1.15D
	endif
//	wave/t/z SPToFDataSetNames=root:PToF:SPToFDataSetNames		// for Stick... not used any more?
//	if (!WaveExists(SPToFDataSetNames))
//		make/o/t/n=0 root:PToF:SPToFDataSetNames
//	endif

	sq_initializeGlobalSVar("root:HR_panel:PToFInfo", "MS Diff will be set to 'MS Open' - 'MS Closed'")	
	sq_initializeGlobalNVar("root:HR_panel:HR_UseLLS", 1)		// 1.04B		radio button on PeakHeightGr	
	sq_initializeGlobalSVar("root:HR_panel:Step5iistr", "Name of the new HR PToF data set")
//	sq_initializeGlobalSVar("root:HR_panel:PToFMinusStr", "")		//1.12M  1.19E
	sq_initializeGlobalSVar("root:HR_panel:HRPToF_StickList", "") 			//1.14G
	sq_initializeGlobalNVar("root:HR_panel:FItEveryPToFGroup", 0)		//1.14G	
	sq_initializeGlobalNVar("root:HR_sticks:HR_ShowLinesBetweenRaw", 1)		//1.14I
	sq_initializeGlobalNVar("root:HR_panel:HRResultsT_whisker", 0)		//1.14M
	sq_initializeGlobalNVar("root:HR_panel:HRResultsT_whisker", 0)		//1.14M
	sq_initializeGlobalNVar("root:HR_panel:FItEveryPToFGroup", 0)		//1.15D
	sq_initializeGlobalSVar("root:panel:tof0_PToFePToFtitle","")		
	
	PToF_DataSet_globals()

	sq_initializeGlobalNVar("root:HR_frag:BCdata", 0)		// 1.20W from Tim O

End		
		
		
Function HR_Analysis_Panel_Create()

	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	HRResults_graphOutputType = 1

	PauseUpdate; Silent 1		// building window...
	NewPanel/N=HR_Analysis_Panel /W=(584,77,1156,666) as "HR_Analysis_Panel"
	ModifyPanel fixedSize=1
//	ShowTools/A
	SetDrawLayer UserBack
	DrawPICT 503,36,0.85,0.85,ProcGlobal#CUlogoNew
	DrawPICT 352,6,0.35,0.33,ProcGlobal#pikaLogo
	DrawPICT 501,2,0.35,0.35,ProcGlobal#ARIlogoNew
	SetDrawEnv fsize= 24,fstyle= 1
	DrawText 3,31,"ToF-AMS HR Analysis "+PKVERSION
	DrawText 5,45,"PIKA module for SQUIRREL"+SQVERSION+" or higher"
	GroupBox HRFit_group_MSorPToF1,pos={13,280},size={535,74},disable=1
	GroupBox HRFit_group_MSorPToF1,fColor=(1,1,1)
	GroupBox HRFit_group_MSorPToF,pos={13,361},size={535,74},disable=1
	GroupBox HRFit_group_MSorPToF,fColor=(1,1,1)
	PopupMenu HRGen_todolist_pop,pos={14,52},size={212,21},bodyWidth=150,proc=sq_pop_toDoList,title="Todo waves"
	PopupMenu HRGen_todolist_pop,mode=1,popvalue="all",value= #"root:panel:sq_toDoList+\"Get List;\""
	Button HRGen_butt_LatestVersion,pos={417,4},size={80,20},proc=sq_URLButton,title="Version Website"
	Button HRGen_butt_LatestVersion,fSize=10
	Button HRGen_butt_FAQs,pos={416,27},size={80,20},proc=sq_URLButton,title="FAQs, Website"
	Button HRGen_butt_FAQs,fSize=10
	Button HRGen_butt_Credits,pos={500,70},size={60,18},proc=HR_butt_Credits,title="Credits"
	Button HRGen_butt_Credits,fSize=10
//	Button HRGen_butt_Upgrade,pos={414,51},size={80,20},proc=sq_URLButton,title="Upgrade Pika"
//	Button HRGen_butt_Upgrade,fSize=10
	TabControl HRGen_tab,pos={3,100},size={560,480},proc=HR_tabProc
	TabControl HRGen_tab,tabLabel(0)="Set Up HR Fits",tabLabel(1)="HR Ion Groups"
	TabControl HRGen_tab,tabLabel(2)="HR Fits One Spectra"
	TabControl HRGen_tab,tabLabel(3)="HR Fits for Many Runs"
	TabControl HRGen_tab,tabLabel(4)="HR Results",value= 0

	GroupBox SetUp_group_RegSquirrel,pos={10,132},size={545,161},title="Steps to be done in Squirrel"
	GroupBox SetUp_group_RegSquirrel,fStyle=1,fColor=(43520,43520,0)
	TitleBox SetUp_title_Step0A,pos={15,151},size={330,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step0A,variable= root:HR_panel:Step0Astr
	TitleBox SetUp_title_Step0A1,pos={16,166},size={484,13},fSize=10,frame=0
	TitleBox SetUp_title_Step0A1,variable= root:HR_panel:Step0Astr1
	TitleBox SetUp_title_Step0B,pos={15,191},size={540,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step0B,variable= root:HR_panel:Step0Bstr
	TitleBox SetUp_title_Step0B2,pos={15,206},size={437,26},fSize=10,frame=0
	TitleBox SetUp_title_Step0B2,variable= root:HR_panel:Step0Bstr2
	TitleBox SetUp_title_Step0C,pos={15,241},size={471,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step0C,variable= root:HR_panel:Step0Cstr
	TitleBox SetUp_title_Step0C2,pos={15,256},size={412,13},fSize=10,frame=0
	TitleBox SetUp_title_Step0C2,variable= root:HR_panel:Step0Cstr2
	TitleBox SetUp_title_Step0D,pos={15,276},size={523,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step0D,variable= root:HR_panel:Step0Dstr
	TitleBox SetUp_title_Step1,pos={13,300},size={253,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step1,variable= root:HR_panel:Step1str
	TitleBox SetUp_title_Step11,pos={16,320},size={463,13},fSize=10,frame=0
	TitleBox SetUp_title_Step11,variable= root:HR_panel:Step1str2
	Button SetUp_butt_CreateMSDiffp,pos={12,356},size={270,20},proc=HR_butt_CreateMsDiffp,title="Prepare raw MS difference spectra for HR fitting"
	Button SetUp_butt_CreateMSDiffp,fColor=(65280,43520,0)
	TitleBox SetUp_title_Step2,pos={12,390},size={328,13},fSize=12,frame=0,fStyle=1
	TitleBox SetUp_title_Step2,variable= root:HR_panel:Step2str
	Button SetUp_butt_PeakShape,pos={12,410},size={270,20},proc=HR_butt_PeakShapePanel,title="Begin/view peak width, shape panel"
	Button SetUp_butt_PeakShape,fColor=(65280,43520,0)
	CheckBox SetUp_ck_step1DoGF,pos={15,337},size={447,14},title="Also perform gaussian fits of selected HR ions in preparation for peak width/shape analysis."
	CheckBox SetUp_ck_step1DoGF,variable= root:HR_panel:HR_check_Step1DoGausFits
	Button SetUp_butt_CreatePToFDataSet,pos={284,357},size={250,20}, fsize=10,proc=PToF_DataSetPanel,title="Define and prepare PToF raw spectra groups"

	TitleBox HRGrps_title_Step3,pos={10,130},size={188,13},disable=1,fSize=12
	TitleBox HRGrps_title_Step3,frame=0,fStyle=1,variable= root:HR_panel:Step3str
	Button HRGrps_butt_ImportNewAll,pos={142,168},size={240,20},disable=1,proc=HR_butt_UpdateNewExactMass,title="(Optional, rare) Import new waves of all HR ions"
	Button HRGrps_butt_ImportNewAll,fSize=10

	GroupBox HRGrps_groupFamilies,pos={7.00,483.00},size={346.00,70.00},title="HR Families"
	GroupBox HRGrps_groupFamilies,fColor=(1,1,1)
	PopupMenu HRGrps_popup_viewFamily,pos={186.00,499.00},size={80.00,19.00},bodyWidth=80,proc=HR_popMenu_FamilyList
	PopupMenu HRGrps_popup_viewFamily,mode=3,popvalue="Cx",value= #"sq_textwave2List(root:HR:HR_familyName) +\";Get List\""
	Button HRGrps_butt_familyTable,pos={186.00,524.00},size={160.00,20.00},proc=HR_butt_familyTable,title="^ View all HR ions in this family"
	Button HRGrps_butt_familyTable,fSize=10
	Button HRGrps_butt_ViewFamilyTable,pos={12.00,501.00},size={130.00,20.00},proc=HR_butt_ViewFamilyTable,title="HR family table (editable)"
	Button HRGrps_butt_ViewFamilyTable,fSize=10
	Button HRGrps_butt_ViewFamilyTableLeg,pos={11.00,527.00},size={140.00,20.00},proc=HR_butt_familyTableLegend,title="HR family color legend plot"
	Button HRGrps_butt_ViewFamilyTableLeg,fSize=10
	Button HRGrps_buttonSetMaskToDefault,pos={390,167},size={140,20},fSize=10,disable=1,proc=HR_butt_SetMaskToDefault,title="Set HR ions to fit to default"
	Button HRGrps_HR_ExportAllMassesTable,pos={533,283},size={16,90},fSize=10,disable=1,proc=pk_butt_ExportExactMassAll,title="E\rx\rp\ro\rr\rt"

	Button HRGrps_HR_AllMassesTable,pos={533,213},size={16,50},disable=1,fSize=10,proc=sq_butt_PopThis,title="P\ro\rp"
	Button HRGrps_buttonSelectTheseMasses,pos={15,379},size={235,20},disable=1,proc=HR_butt_MakeExactMassWaves,title="Choose HR ions to fit & assign to families"
	Button HRGrps_buttonSelectTheseMasses,fColor=(65280,43520,0)
	Button HRGrps_butt_batchTable,pos={360.00,498.00},size={140.00,20.00},fsize=10,proc=HR_butt_HRbatchTable,title="HR batch table (editable)"

	Button HRGrps_butt_fragTable,pos={360.00,521.00},size={140.00,20.00},fSize=10,proc=HR_butt_HRfragTable,title="HR frag table (editable)"

	Button HRGrps_HR_IsotopesTable,pos={16,437},size={250,20},fSize=10,disable=1,proc=sq_butt_popThis,title="Table of HR isotopes to fit, editable constraint flag"

	Button HRGrps_HR_ChosenMassesTable,pos={16,414},size={240,20},fSize=10,disable=1,proc=sq_butt_popThis,title="Table of HR ions currently chosen to fit"

	Button HRGrps_buttonSelectIsotopes,pos={269,437},size={100,20},fSize=10,disable=1,proc=HR_butt_CheckIsotopeMask,title="Check iso. parents"
	Button HRGrps_butt_MassCalc,pos={440,410},size={100,40},fSize=10,disable=1,proc=HR_butt_IonMassCalculator,title="Mass Calculator &\rHR Ion QueryTool"

	Button HRGrps_butt_SetHRIonsfromTodo,pos={255,379},size={185,20},fsize=10,disable=1,proc=HR_butt_SetHRChoices2Todo,title="Choose HR ions previously fit in todo  "
	TitleBox HRGrps_title_All,pos={17,177},size={78,13},disable=1,fSize=10,frame=0
	TitleBox HRGrps_title_All,fStyle=0,variable= root:HR_panel:TableTitleAll
	GroupBox HRGrps_groupAllHRIons,pos={9,148},size={545,318},disable=1,title="Modify/Choose HR Ions to fit by changing 1s, 0s in red column"
	GroupBox HRGrps_groupAllHRIons,fColor=(1,1,1)
//	Button HRGrps_butt_ChangeHRfrag4BC,pos={360,553},size={180,20},proc=HR_butt_ChangeHR4BC,title="Change HR frag, batch for SP-AMS"
//	Button HRGrps_butt_ChangeHRfrag4BC,fSize=10
// New in 1.20W
	GroupBox HRGrps_groupSpecies,pos={356.00,483.00},size={200.00,92.00},title="HR Species"
	GroupBox HRGrps_groupSpecies,fColor=(1,1,1)
	TitleBox HRGrps_Select_IonType,pos={363.00,545.00},size={72.00,24.00},title="Select Ionization\rfor HR frag:"
	TitleBox HRGrps_Select_IonType,fSize=10,frame=0,fStyle=0
	CheckBox HRGrps_butt_ChangeHRfrag_AMS,pos={445,553},size={35.00,12.00},proc=HR_Species_subpanel_check,title="AMS"
	CheckBox HRGrps_butt_ChangeHRfrag_AMS,fSize=10,value= 1,mode=1
	CheckBox HRGrps_butt_ChangeHRfrag_SPAMS,pos={495,553},size={51.00,12.00},proc=HR_Species_subpanel_check,title="SP-AMS"
	CheckBox HRGrps_butt_ChangeHRfrag_SPAMS,fSize=10,value= 0,mode=1

	GroupBox HRGrps_groupHRIonTools,pos={435,390},size={110,70},disable=1,title="HR Ion Tools"
	GroupBox HRGrps_groupHRIonTools,fColor=(1,1,1)

	TitleBox HRFit_title_Step4,pos={12,130},size={400,13},disable=1,frame=0
	TitleBox HRFit_title_Step4,fStyle=1,variable= root:HR_panel:Step4str
	GroupBox HRFit_group_OneRunFitOpt,pos={13,149},size={535,126},disable=1,title="HR Fit Options"
	GroupBox HRFit_group_OneRunFitOpt,fColor=(1,1,1)
	TitleBox HRGrps_title_Step4,pos={10.00,466.00},size={406.00,12.00},disable=1,fSize=10
	TitleBox HRGrps_title_Step4,frame=0,fStyle=1,variable= root:HR_panel:Step3A
	CheckBox HRFit_ck_UsePeakShape,pos={20,169},size={327,14},disable=1,title="i. Use peak shape in HR fits (else use gaussians for peak shapes)"
	CheckBox HRFit_ck_UsePeakShape,variable= root:HR_panel:HR_UsePeakShapeVar
	CheckBox HRFit_ck_fixIsotopes,pos={20,189},size={254,14},disable=1,title="ii. Constrain isotopic species by parent abundance"
	CheckBox HRFit_ck_fixIsotopes,variable= root:HR_panel:HR_UseFixedIsotopicVals
	CheckBox HRFit_ck_UseSeparateMz,pos={20,208},size={302,14},disable=1,proc=HR_check_UseOC_Mz,title="iii. Use separate m/z fitting params for open & closed spectra"
	CheckBox HRFit_ck_UseSeparateMz,variable= root:HR_panel:HR_UseOpenClosedMzParams
	CheckBox HRFit_ck_IfFitIsNegConstrToZero,pos={20,249},size={384,14},disable=1,title="v. If fit peak height <                       , constrain to 0 (for noisy raw spectra, rare)"
	CheckBox HRFit_ck_IfFitIsNegConstrToZero,variable= root:HR_panel:HR_IfFitNegConstrainToZero
	CheckBox HRFit_ck_UseLLS,pos={415,204},size={123,14},title="Use LLS (much faster)"			//1.11D
	CheckBox HRFit_ck_UseLLS,variable= root:HR_panel:HR_UseLLS,disable=1
	SetVariable HRFit_setvar_MinimPeakHeight,pos={147,249},size={60,16},disable=1,title=" "
	SetVariable HRFit_setvar_MinimPeakHeight,format="%1.e", fsize=10
	SetVariable HRFit_setvar_MinimPeakHeight,value= root:HR_panel:HR_MinimumPeakHeight
	CheckBox HRFit_ck_Verbose,pos={20,228},size={281,14},disable=1,title="iv. Print all fitting errors (nonconvergence of fit) to history"
	CheckBox HRFit_ck_Verbose,variable= root:HR_panel:HR_FitVerboseMode
	CheckBox HRFit_ck_NotOneRunRawSpectra,pos={18,283},size={172,14},disable=1,proc=HR_ck_oneRunOrAvg,title="Average spectra from todo wave"
	CheckBox HRFit_ck_NotOneRunRawSpectra,variable= root:HR_panel:HR_checkDoNotGrabRawSpectra,mode=1
	CheckBox HRFit_ck_OneRunRawSpectra,pos={18,317},size={56,14},disable=1,proc=HR_ck_oneRunOrAvg,title="One run"
	CheckBox HRFit_ck_OneRunRawSpectra,value= 0,mode=1
	TitleBox HRFit_title_Step52,pos={20,299},size={16,13},disable=1,fSize=10,frame=0
	TitleBox HRFit_title_Step52,variable= root:HR_panel:HRFit_title_Step4OR
	SetVariable HRFit_setvar_RunNum,pos={83,316},size={140,16},disable=1,proc=HR_SetVar_RunModeStr,title="Run Number"
	SetVariable HRFit_setvar_RunNum,format="%u",value= root:HR_panel:HR_RunVar
	TitleBox HRFit_title_runModeStr,pos={83,336},size={128,13},disable=1,frame=0
	TitleBox HRFit_title_runModeStr,variable= root:HR_panel:HR_runModeStr
	Button HRfit_butt_nextTodoRun,pos={240,327},size={110,20},disable=1,proc=sq_butt_FindRunInTodo,title="next run in todo"
	Button HRfit_butt_nextTodoRun,fSize=10
	Button HRfit_butt_previousTodoRun,pos={240,304},size={110,20},disable=1,proc=sq_butt_FindRunInTodo,title=" previous run in todo"
	Button HRfit_butt_previousTodoRun,fSize=10
	Button HRFit_butt_FitThisRun,pos={18,442},size={225,20},disable=1,proc=HR_butt_CalcSticksForThisRun,title="Calc HR sticks for one set of spectra"
	Button HRFit_butt_FitThisRun,fColor=(65280,43520,0)
	GroupBox HRFit_group_Diagnostics,pos={10,496},size={543,77},disable=1,title="Step 4A. View diagnostics of HR Fits for spectra chosen in step 4."
	GroupBox HRFit_group_Diagnostics,fStyle=1,fColor=(1,1,1)
	Button HRFit_butt_ViewHRSticksTable,pos={368,471},size={180,20},disable=1,proc=HR_butt_ViewHRSticksTable,title="Table of HR sticks from step 4 fit"
	Button HRFit_butt_ViewHRSticksTable,fSize=10
	Button HRFit_butt_ViewIntegerSpectra,pos={17,515},size={165,50},proc=HR_butt_ViewHRIntegerSpectra,title="Diagnostic 4a:\rOpen, closed, diff spectra of\rHR unit mass resolution (UMR) "
	Button HRFit_butt_ViewIntegerSpectra,fSize=10
	Button HRFit_butt_ViewResidualsGr,pos={187,515},size={100,50},proc=HR_butt_ViewResiduals,title="Diagnostic 4b:\rHR raw residuals\rspectra"
	Button HRFit_butt_ViewResidualsGr,fSize=10
	//1.15A
	Button HRFit_butt_VIEWPWPH_Diag,pos={291,515},size={135,50},fSize=10,proc=PK_butt_PWPH_diagGraph,title="Diagnostic 4c:\rTable & graph of ratioed\rpeak width, height"
	Button HRFit_butt_MassDefect,pos={435,515},size={100,50},fSize=10,proc=HR_butt_Step4MassDefect,title="Diagnostic 4d:\rOpen, closed, diff\rMass defect graph"
	Button HRFit_butt_ViewHRSticksTable1,pos={387,442},size={160,20},disable=1,proc=HR_butt_ShowPkHtsGr,title="Show (existing) pika fits graph"
	Button HRFit_butt_ViewHRSticksTable1,fSize=10

	CheckBox HRFit_ck_MS,pos={20,364},size={34,14},proc=HR_ck_OneSpectraMSorPToF,title="MS"
	CheckBox HRFit_ck_MS,value= 1,mode=1
	CheckBox HRFit_ck_PToF,pos={117,364},size={44,14},proc=HR_ck_OneSpectraMSorPToF,title="PToF"
	CheckBox HRFit_ck_PToF,value= 0,mode=1
	CheckBox HRFit_ck_ePToFSum,pos={251,364},size={71,14},proc=HR_ck_OneSpectraMSorPToF,title="ePToFSum"
	CheckBox HRFit_ck_ePToFSum,value= 0,mode=1

	PopupMenu HRFit_popup_PToFClosed,pos={72,411},size={148,21},disable=1,proc=HR_PToF_chooseDataSet,title="\"MS Closed\""
	PopupMenu HRFit_popup_PToFClosed,mode=2,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List\""
	PopupMenu HRFit_popup_PToFOpen,pos={72,387},size={142,21},disable=1,title="\"MS Open\"",proc=HR_PToF_chooseDataSet
	PopupMenu HRFit_popup_PToFOpen,mode=2,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List\""
	TitleBox HRFit_title_Step54,pos={223,365},size={16,13},fSize=10,frame=0
	TitleBox HRFit_title_Step54,variable= root:HR_panel:HRFit_title_Step4OR
	TitleBox HRFit_title_Step53,pos={67,364},size={16,13},fSize=10,frame=0
	TitleBox HRFit_title_Step53,variable= root:HR_panel:HRFit_title_Step4OR
	TitleBox HRFit_title_PToFInfo,pos={242,417},size={262,13},disable=1,fSize=10
	TitleBox HRFit_title_PToFInfo,frame=0,fStyle=0,variable= root:HR_panel:PToFInfo
	SetVariable HRFit_setvar_MatrixBin,pos={206.00,389.00},size={91.00,15.00},bodyWidth=40,title=" Matrix bin"
	SetVariable HRFit_setvar_MatrixBin,fSize=10,limits={0,inf,1},value= _NUM:0

	Button HRFit_butt_CopyHRSticks2Folder,pos={19,468},size={240,20},disable=1,proc=PK_Butt_CopySticksOneSpectra,title="Copy HR sticks to folder (for averged spectra)"
	Button HRFit_butt_CopyHRSticks2Folder,fSize=10,fStyle=0

//	Button HRFit_butt_ViewResidualsGr,pos={197,515},size={165,40},disable=1,proc=HR_butt_ViewResiduals,title="Diagnostic 4b:\rHR raw residuals spectra"
//	Button HRFit_butt_ViewResidualsGr,fSize=10
//	Button HRFit_butt_ViewIntegerSpectra,pos={17,515},size={165,50},disable=1,proc=HR_butt_ViewHRIntegerSpectra,title="Diagnostic 4a:\rOpen, closed, diff spectra of\rHR unit mass resolution (UMR) "
//	Button HRFit_butt_ViewIntegerSpectra,fSize=10
//	Button HRFit_butt_View5famUMRSpectra,pos={378,515},size={165,50},disable=1,proc=pk_butt_5FamilyMSGraph,title="Diagnostic 4c:\rMain families 5-axis UMR\rgraph (fitted HR ions only)"
//	Button HRFit_butt_View5famUMRSpectra,fSize=10
	TitleBox HRTodoFit_title_Step5,pos={10,130},size={355,13},fSize=12,frame=0
	TitleBox HRTodoFit_title_Step5,fStyle=1,variable= root:HR_panel:Step5str
	TitleBox HRTodoFit_title_Step51,pos={15,147},size={502,39},fSize=10,frame=0
	TitleBox HRTodoFit_title_Step51,variable= root:HR_panel:Step5str2
//	CheckBox HRTodoFit_ck_ManyRunsOpenClosed,pos={164,196},size={193,14},proc=HR_ck_OneSpectraMSorPToF,title="Find HR fits for PToF 'open & 'closed'"
//	CheckBox HRTodoFit_ck_ManyRunsOpenClosed,fSize=10
//	CheckBox HRTodoFit_ck_ManyRunsOpenClosed,variable= root:HR_panel:HR_CalcManyRunsOpenClosed
	CheckBox HRTodoFit_ck_SaveAfterFit,pos={15,230},size={175,14},title="Save experiment after completion"
	CheckBox HRTodoFit_ck_SaveAfterFit,fSize=10,variable= root:HR_panel:SaveAfterTodoFits

	CheckBox HRTodoFit_ck_FItThesePToF,pos={300,195},size={136,14},proc=HR_ck_PToFManyGroupFit,title="Fit PToF groups selected"		//1.15D
	CheckBox HRTodoFit_ck_FItThesePToF,fSize=10,variable= root:HR_panel:FItEveryPToFGroup
	TitleBox HRTodoFit_title_Step6MSorPToF,pos={290,215},size={35,13},fSize=10
	TitleBox HRTodoFit_title_Step6MSorPToF,frame=0,fStyle=0
	ListBox HRTodoFit_PToFRegionList,pos={428,188},size={124,75},proc=HRPToF_dataSetListBox
	ListBox HRTodoFit_PToFRegionList,listWave=root:PToF:PToFDataSetNames
	ListBox HRTodoFit_PToFRegionList,selWave=root:PToF:PToFTodoFit,row= 1,mode= 4

	Button HRTodoFit_butt_Tj15NN,pos={13,188},size={260,35},proc=HROrgCheck_Panel_make,title="Step 5A. j15NN isotope analysis using UMR data\r(HROrg Check Panel, 1st tab only)"
	Button HRTodoFit_butt_Tj15NN,fColor=(65280,43520,0)		//1.56F
//	Button HRTodoFit_butt_Showj15NN,pos={205,188},size={70,20},proc=HR_Checkj15NNIsotopePanel,title="Show panel"

	TitleBox HRTodoFit_title_lastFit,pos={17,287},size={233,91},fSize=10,frame=0
	TitleBox HRTodoFit_title_lastFit,fStyle=0
	TitleBox HRTodoFit_title_lastFit,variable= root:HR_panel:InfoOfLastTodoFits
	GroupBox HRTodoFits_groupLastTodo,pos={11,272},size={260,110},title="Info for last instance of Step 5"
	GroupBox HRTodoFits_groupLastTodo,fColor=(1,1,1)
	Button HRTodoFit_butt_CalcHRSticks2,pos={15,250},size={260,20},proc=HR_butt_CalcExactMassSticksTodo,title="Step 5B. Calc HR sticks for all runs in todo wave"
	Button HRTodoFit_butt_CalcHRSticks2,fColor=(65280,43520,0)
	GroupBox HRTodoFits_groupPToFdataset,pos={292,277},size={266,125},title="Step 5C (Optional) HR PToF stick subtraction"
	GroupBox HRTodoFits_groupPToFdataset,fColor=(1,1,1)
	PopupMenu HRTodoFit_pop_PToFOpen,pos={299,297},size={242,21},proc=HR_pop_getPToFStickDataSet,title="PToF HR data set 'Open'"
	PopupMenu HRTodoFit_pop_PToFOpen,help={"Source data to use."},fSize=10
	PopupMenu HRTodoFit_pop_PToFOpen,mode=5,popvalue="Get List",value= #"root:HR_panel:HRPToF_StickList+\"Get List;\""
//	PopupMenu HRTodoFit_pop_PToFOpen,mode=5,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List;Selected Above\""
//	SetVariable HRTodoFit_NewPToF,pos={299,333},size={180,16},fsize=10,title="PToF_"
//	SetVariable HRTodoFit_NewPToF,value= root:HR_panel:PToFMinusStr		//1.19E
	Button HRTodoFit_button_CalcPToFdiff,pos={300,375},size={200,21},fSize=10,proc=HR_buttPToFOMinusClosed,title="Calculate PToF 'Open' - PToF 'Closed'"

	PopupMenu HRTodoFit_pop_PToFClosed,pos={299,321},size={260,21},proc=HR_pop_getPToFStickDataSet,title="PToF HR data set 'Closed'"
	PopupMenu HRTodoFit_pop_PToFClosed,help={"Source data to use."},fSize=10
	PopupMenu HRTodoFit_pop_PToFClosed,mode=3,popvalue="Get List",value= #"root:HR_panel:HRPToF_StickList+\"Get List;\""
//	PopupMenu HRTodoFit_pop_PToFClosed,mode=3,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List\""
	TitleBox HRTodoFit_title_Step5ii,pos={300,348},size={170,13},fSize=9,frame=0
	TitleBox HRTodoFit_title_Step5ii,fStyle=0,variable= root:HR_panel:Step5iistr
//	Button HRTodoFit_butt_GraphHRFitFail,pos={21,524},size={240,35},disable=1,proc=HR_butt_HRFitFailTodo,title="Diagnostic 5b:\rGraph, table of runs, amus where HR fit failed"
//	Button HRTodoFit_butt_GraphHRFitFail,fSize=10  //1.16H
	GroupBox HRTodoFits_group,pos={11,452},size={533,118},fsize=10,disable=1,title="Step 5A. View diagnostics for HR fits of todo wave"
	GroupBox HRTodoFits_group,fStyle=1,fColor=(1,1,1)
	Button HRTodo_butt_manyResid,pos={21,478},size={240,35},fsize=10,disable=1,proc=UM_butt_ManyParam,title="Diagnostic 5a:\rTen UMR parameters time series panel"

//	TitleBox HRTodoFit_title_Step5i,pos={6,390},size={274,26},fSize=10,frame=0
//	TitleBox HRTodoFit_title_Step5i,fStyle=1,variable= root:HR_panel:Step5iAstr
//	Button HRTodoFit_butt_TotalOMinusCErr,pos={7,420},size={200,20},fSize=10,proc=HR_butt_totalIonCountErr,title="Find HRTotalOMinusCIonCountErr"
//	TitleBox HRTodoFit_title_Step5iii,pos={285,390},size={272,26},fSize=10,frame=0
//	TitleBox HRTodoFit_title_Step5iii,fStyle=1,variable= root:HR_panel:Step5iiAstr
//	Button HRTodoFit_butt_SigOMinusCEr,pos={284,420},size={200,20},fsize=10,proc=HR_butt_SigIonCountErr,title="Find HRTotalOMinusCSigErr"	
//1.21E
//	TitleBox HRTodoFit_title_Step5iii,pos={10,390},size={274,26},fSize=10,frame=0
//	TitleBox HRTodoFit_title_Step5iii,fStyle=1,variable= root:HR_panel:Step5iAstr
//	Button HRTodoFit_butt_SigOMinusCEr,pos={6,420},size={200,20},fsize=10,proc=HR_butt_SigIonCountErr,title="Find HRTotalOMinusCSigErr"	

	TitleBox HRResults_title_Step6,pos={11,130},size={391,13},disable=1,fsize=12, fstyle=1
	TitleBox HRResults_title_Step6,frame=0,variable= root:HR_panel:Step6str
	GroupBox HRResults_entity_group,pos={10,144},size={549,98},disable=1,title="List of entities to generate"
	GroupBox HRResults_entity_group,fColor=(1,1,1)
	SetVariable HRResults_setvar_TheseMasses,pos={13,159},size={540,16},disable=1,title="HR ions, families, and/or species (i.e. j15N,familyNH,HRair)"
	SetVariable HRResults_setvar_TheseMasses,value= root:HR_panel:HRResults_ionList
	
	Button HRResultsD_HROrgCheckPanel,pos={20,428},size={260,20},proc=HROrgCheck_Panel_make,title="HROrg Check Panel - HROrgCO2 frag, 2nd tab"
	Button HRResultsD_HROrgCheckPanel,fColor=(65280,43520,0)
	Button HRResultsD_button_HRCDCE,pos={20,457},size={60,35},proc=pk_CE_ButtonProc,title="HR CDCE\rpanel"
	Button HRResultsD_button_HRCDCE,fColor=(65280,43520,0)
	GroupBox HRResultsD_ChemSib_group,pos={20,498},size={350,64},title="Chemical Sibling Analysis (major HR ions in the same family)"
	GroupBox HRResultsD_ChemSib_group,fColor=(1,1,1)
	Button HRResultsD_button_calcChemSib,pos={31,515},size={160,35},fsize=10,proc=CS_butt_CalcSibCheckWaves,title="Calculate time series\r for chemical sibling panel"
	Button HRResultsD_button_ChemSibPanel,pos={218,522},size={110,20},fsize=10,proc=HR_butt_ChemSibPanel,title="HR sibling panel"
	Button HRResults_butt_allHRspecies,pos={11,219},size={140,20},fsize=10,disable=1,proc=HR_butt_setResultsList,title="Set list to all HR species"
	Button HRResults_butt_setListAerHRfams,pos={159,219},size={155,20},fsize=10,disable=1,proc=HR_butt_setResultsList,title="Set list to aerosol HR species"
	Button HRResults_butt_setListHRfams,pos={322,219},size={145,20},fsize=10,disable=1,proc=HR_butt_setResultsList,title="Set list to all HR families"
	Button HRResults_butt_clearList,pos={474,219},size={80,20},fsize=10,disable=1,proc=HR_butt_setResultsList,title="Clear list"
	Button HRResults_butt_removeIso,pos={386,175},size={160,20},proc=HR_butt_RemoveIsotopes,title="Remove isotopes from list above"
	Button HRResults_butt_removeIso,fSize=10,disable=1
	SetVariable HRResults_setvar_IntegerAmu,pos={11,197},size={95,16},disable=1,title="Integer m/z"
	SetVariable HRResults_setvar_IntegerAmu,fSize=10,format="%u"
	SetVariable HRResults_setvar_IntegerAmu,value= root:HR_panel:HR_ChosenMassesIntegerAMU
	Button HRResults_butt_EnterAllMassUMR,pos={108,196},size={160,20},disable=1,proc=HR_butt_setResultsList,title="< Add HR ion to list of entities"
	Button HRResults_butt_EnterAllMassUMR,fSize=10
	PopupMenu HRResults_pop_family,pos={280,197},size={70,21},disable=1,proc=HR_popMenu_FamilyList,title="family"
	PopupMenu HRResults_pop_family,help={"Choose the family of HR species to add."}
	PopupMenu HRResults_pop_family,fSize=10
	PopupMenu HRResults_pop_family,mode=1,popvalue="Air",value= #"sq_textwave2List(root:HR:HR_familyName) +\";Get List\"\t\t"
	Button HRResults_butt_appendFamMem,pos={395,197},size={160,20},disable=1,proc=HR_butt_setResultsList,title="< Add HR ions to list of entities"
	Button HRResults_butt_appendFamMem,fSize=10
//	GroupBox HRResults_Output_group,pos={8,244},size={549,67},disable=1,title="Data, Output Options"
//	GroupBox HRResults_Output_group,fColor=(1,1,1)
	PopupMenu HRResults_pop_dataSet,pos={10.00,260.00},size={84.00,19.00},proc=HR_pop_getStickDataSet,title="Data"
	PopupMenu HRResults_pop_dataSet,help={"Source data to use."},fSize=10
	PopupMenu HRResults_pop_dataSet,mode=3,popvalue="Get List",value= #"root:HR_panel:HR_StickList+\"Get List;\"\t"
	CheckBox HRResults_ck_calcErrs,pos={10.00,289.00},size={71.00,13.00},title="Calc, plot err."
	CheckBox HRResults_ck_calcErrs,fSize=10,fStyle=0
	CheckBox HRResults_ck_calcErrs,variable= root:HR_panel:HR_checkCalcHRErrors
	PopupMenu HRResults_pop_ErrType,pos={100,285},size={168,21},disable=1,proc=HR_pop_getStickErrSet
	PopupMenu HRResults_pop_ErrType,help={"Error data to use."},fSize=10
	PopupMenu HRResults_pop_ErrType,mode=1,popvalue="Get List",value= "Get List" 
	PopupMenu HRResults_pop_graphOutputType,pos={210,261},size={109,21},disable=1,proc=HR_pop_getVariable,title="Plot"
	PopupMenu HRResults_pop_graphOutputType,help={"The number of new or altered graphs."}
	PopupMenu HRResults_pop_graphOutputType,fSize=10
	PopupMenu HRResults_pop_graphOutputType,mode=1,popvalue="Single",value= #"\"Single;Multiple;Append;Update\""
	TitleBox HRResults_title_ugm3,pos={14,177},size={347,13},disable=1,fSize=10
	TitleBox HRResults_title_ugm3,frame=0,fStyle=4
	TitleBox HRResults_title_ugm3,variable= root:HR_panel:HR_ugm3_str
	CheckBox HRResults_ck_convert2ug,pos={300,259},size={108,14},disable=1,title="Convert to g/m3"
	CheckBox HRResults_ck_convert2ug,fSize=10
	CheckBox HRResults_ck_convert2ug,variable= root:HR_panel:HR_checkConvertTougm3
	CheckBox HRResults_ck_useAB,pos={300,276},size={123,14},disable=1,title="Use MS AB correction"
	CheckBox HRResults_ck_useAB,fSize=10,variable= root:HR_panel:HR_checkUseAB
	CheckBox HRResults_suffix_ck,pos={300,292},size={136,14},disable=1,title="Set wave name suffix"
	CheckBox HRResults_suffix_ck,help={"A prompt will appear requesting a string to append to the newly created species waves"}
	CheckBox HRResults_suffix_ck,fSize=10
	CheckBox HRResults_suffix_ck,variable= root:HR_panel:HR_checkAskForSuffix
	CheckBox HRResults_checkConvertNans,pos={426,258},size={127,14},fsize=10,disable=1,title="Convert nan sticks to 0"
	CheckBox HRResults_checkConvertNans,variable= root:HR_panel:HR_checkConvertNansTo0
	CheckBox HRResults_checkConvertNegs,pos={426,275},size={130,14},fsize=10,disable=1,title="Convert neg. sticks to 0"
	CheckBox HRResults_checkConvertNegs,variable= root:HR_panel:HR_checkConvertNegsTo0
//	CheckBox HRResults_HRPToF_Dva,pos={425.00,293.00},size={120.00,13.00},title="HRPToF: Convert log Da"		//1.19E
//	CheckBox HRResults_HRPToF_Dva,fSize=10,variable= root:HR_panel:HR_checkPToFDVa

	GroupBox HRResults_Output_group2,pos={16.00,310.00},size={538.00,23.00}
	GroupBox HRResults_Output_group2,fColor=(1,1,1)
	CheckBox HRResults_time_saved,pos={108.00,314.00},size={54.00,14.00},proc=sq_timebase_check,title="As saved"
	CheckBox HRResults_time_saved,fSize=10
	CheckBox HRResults_time_saved,variable= root:panel:ams_time_saved,mode=1
	CheckBox HRResults_time_interval,pos={184.00,314.00},size={91.00,14.00},proc=sq_timebase_check,title="Set interval (min):"
	CheckBox HRResults_time_interval,fSize=10
	CheckBox HRResults_time_interval,variable= root:panel:ams_time_interval,mode=1
	CheckBox HRResults_time_custom,pos={321.00,314.00},size={125.00,14.00},proc=sq_timebase_check,title="Custom wave (Igor secs):"
	CheckBox HRResults_time_custom,fSize=10
	CheckBox HRResults_time_custom,variable= root:panel:ams_time_custom,mode=1
	SetVariable HRResults_time_cus_val,pos={451.00,312.00},size={70.00,18.00},bodyWidth=70,title=" "
	SetVariable HRResults_time_cus_val,value= root:panel:ams_time_cus_val
	SetVariable HRResults_time_int_val,pos={281.00,312.00},size={30.00,18.00},bodyWidth=30,title=" "
	SetVariable HRResults_time_int_val,limits={0.0166667,inf,0},value= root:panel:ams_time_int_val
	TitleBox HRResults_title_timeaxis,pos={18.00,312.00},size={52.00,15.00},title="Time axis:"
	TitleBox HRResults_title_timeaxis,fSize=12,frame=0,fStyle=0
	GroupBox HRResults_Output_group,pos={8.00,244.00},size={551.00,92.00},title="Data, Output Options"
	GroupBox HRResults_Output_group,fColor=(1,1,1)

//	TitleBox HRResults_title_PToF,pos={423,291},size={134,13},fSize=8,frame=0		//1.19E
//	TitleBox HRResults_title_PToF,fStyle=4,variable= root:HR_panel:HR_PToFUnitsStr,disable=1

	TabControl HRResultsA,pos={6,333},size={552,240},proc=HRResults_TabProc
	TabControl HRResultsA,tabLabel(0)="Diag.",tabLabel(1)="Time Series"
	TabControl HRResultsA,tabLabel(2)="Avg. MS",tabLabel(3)="Elem. Anal."
	TabControl HRResultsA,tabLabel(4)="2-d Time Series MS",tabLabel(5)="HRPToF Matrix"

	GroupBox HRResultsD_SqVsPk_group,pos={17,362},size={115,56},title="Sq vs Pk Species"
	GroupBox HRResultsD_SqVsPk_group,fColor=(1,1,1)
	Button HRResultsD_butt_SqVsPk,pos={23,377},size={100,35},proc=HR_button_sqVsPk,title="Calc & display\r Sq vs Pk panel"
	Button HRResultsD_butt_SqVsPk,fColor=(65280,43520,0)
	GroupBox HRResultsD_UsefulTables_group,pos={140,357},size={193,64},title="Useful Tables for Current Todo"
	GroupBox HRResultsD_UsefulTables_group,fColor=(1,1,1)
	Button HRResultsD_button_viewAtomFrag,pos={145,394},size={130,20},fsize=10,proc=HR_butt_viewEAtable,title="HROrg atomic mass fract."
	Button HRResultsD_butt_HRionsFitTodo,pos={144,372},size={80,20},fsize=10,proc=HR_butt_TableHRIonsTodoFit,title="Fitted HR ions"
	Button HRResultsD_butt_HRSpecies,pos={228,371},size={100,20},fsize=10,proc=HR_butt_HRSpeciesFitTodoTable,title="HR ions for species"
	GroupBox HRResultsT_TS_group,pos={15,361},size={120,74},disable=1,title="Time Series"
	GroupBox HRResultsT_TS_group,fColor=(1,1,1)
	Button HRResultsT_button_HRVsTime,pos={20,375},size={110,20},disable=1,proc=HR_butt_MS_Calc,title="Calculate"
	Button HRResultsT_button_HRVsTime,fColor=(65280,43520,0)
	Button HRResultsT_butt_1SpecieFGroupTS,pos={20,398},size={110,33},disable=1,proc=HR_butt_MS_Calc,title="One HR specie\rfamily-colored"
	Button HRResultsT_butt_1SpecieFGroupTS,fColor=(65280,43520,0)
	GroupBox HRResultsT_TseriesDiurnal,pos={145,362},size={119,70},fsize=10,disable=1,title="Diurnal Time Series"
	GroupBox HRResultsT_TseriesDiurnal,fColor=(1,1,1)
	PopupMenu HRResultsT_pop_whisker,pos={150,378},size={108,21},fsize=10,disable=1,proc=HR_pop_getVariable,title="whiskers"
	PopupMenu HRResultsT_pop_whisker,help={"The whiskers to display in the diurnal box plot"}
	PopupMenu HRResultsT_pop_whisker,mode=2,popvalue="0-100%",value= #"\"0-100%;5-95%\""
	Button HRResultsT_button_diurnalCalc,pos={150,403},size={100,20},fSize=10,disable=1,proc=HR_butt_MS_Calc,title="Calc diurnal trends"
	Button HRResultsT_button_diurnalCalc,help={"Make diurnal box plots."},fSize=10

	//1.19E  1.21G
//	GroupBox HRResultsT_timegroup,pos={13.00,516.00},size={310.00,49.00},title="Time Base Selection"
//	GroupBox HRResultsT_timegroup,fColor=(1,1,1)
//	CheckBox HRResultsT_time_saved,pos={20.00,536.00},size={53.00,13.00},proc=sq_timebase_check,title="As saved"
//	CheckBox HRResultsT_time_saved,fSize=10
//	CheckBox HRResultsT_time_saved,variable= root:panel:ams_time_saved,mode=1
//	CheckBox HRResultsT_time_interval,pos={174.00,537.00},size={82.00,13.00},proc=sq_timebase_check,title="Set interval (m):"
//	CheckBox HRResultsT_time_interval,fSize=10
//	CheckBox HRResultsT_time_interval,variable= root:panel:ams_time_interval,mode=1
//	SetVariable HRResultsT_time_int_val,pos={269.00,538.00},size={50.00,18.00},title=" "
//	SetVariable HRResultsT_time_int_val,limits={0.0166667,inf,0},value= root:panel:ams_time_int_val

	GroupBox HRResultsM_MS_group,pos={16.00,365.00},size={140.00,90.00},title="Avg Mass Spectrum"
	GroupBox HRResultsM_MS_group,fSize=12,fColor=(1,1,1)
	CheckBox HRResultsM_SumSpectraUMR,pos={20.00,381.00},size={73.00,14.00},title="Sum to UMR"
	CheckBox HRResultsM_SumSpectraUMR,fSize=10,fStyle=0
	CheckBox HRResultsM_SumSpectraUMR,variable= root:HR_panel:HR_checkAvgHRMS_UMR
	Button HRResultsM_button_MassDefect,pos={20.00,472.00},size={200.00,30.00},proc=HR_butt_MS_Calc,title="Mass defect plot\rfamily colored & signal sized"
	Button HRResultsM_button_MassDefect,fSize=10
//	CheckBox HRResultsM_stackSticks,pos={20,400},size={117,14},fsize=10,disable=1,title="Stack sticks in graph"
//	CheckBox HRResultsM_stackSticks,fStyle=0
//	CheckBox HRResultsM_stackSticks,variable= root:HR_panel:HR_checkStackSticks
	Button HRResultsM_button_HRvsMz,pos={21.00,431.00},size={100.00,20.00},proc=HR_butt_MS_Calc,title="Calculate"
	Button HRResultsM_button_HRvsMz,fColor=(65280,43520,0)
	GroupBox HRResultsM_SpecialMS_group,pos={165.00,365.00},size={215.00,90.00},title="Specialty Average Mass Spectrum"
	GroupBox HRResultsM_SpecialMS_group,fColor=(1,1,1)
	CheckBox HRResultsM_NormalizeSpectra,pos={20.00,400.00},size={99.00,24.00},title="Normalize spectra\r(sum of spectra=1)"
	CheckBox HRResultsM_NormalizeSpectra,fSize=10,fStyle=0
	CheckBox HRResultsM_NormalizeSpectra,variable= root:HR_panel:NormalizeSpectra
	Button HRResultsM_button_AerSpeciesDug,pos={170.00,420.00},size={180.00,30.00},proc=HR_butt_MS_Calc,title="All aerosol HR species\r5-axis family-colored UMR graph"
	Button HRResultsM_button_AerSpeciesDug,fSize=10
	Button HRResultsM_button_1SpecieGroup,pos={170.00,383.00},size={130.00,30.00},proc=HR_butt_MS_Calc,title="Single HR specie\rfamily-colored UMR graph"
	Button HRResultsM_button_1SpecieGroup,fSize=10
	Button HRResultsM_butt_ExportForAMSDB,pos={21.00,520.00},size={200.00,20.00},proc=sq_butt_ExportDBPanel,title="Export for AMS HR database"
	Button HRResultsM_butt_ExportForAMSDB,fSize=10


	GroupBox HRResultsE_EATS_group,pos={13,360},size={340,191},title="Elemental Time Series Ratios, Van Krevlen"
	GroupBox HRResultsE_EATS_group,fColor=(1,1,1)
	SetVariable HRResultsE_SetVar_H_C,pos={33,391},size={60,16},title="H/C",fSize=10
	SetVariable HRResultsE_SetVar_H_C,format="%1.3f"
	SetVariable HRResultsE_SetVar_H_C,limits={0,inf,0},value= root:HR_panel:EA_CalFactor_H_C
	SetVariable HRResultsE_SetVar_O_C,pos={105,391},size={60,16},title="O/C"
	SetVariable HRResultsE_SetVar_O_C,fSize=10,format="%1.3f"
	SetVariable HRResultsE_SetVar_O_C,limits={0,inf,0},value= root:HR_panel:EA_CalFactor_O_C
	SetVariable HRResultsE_SetVar_N_C,pos={178,391},size={60,16},title="N/C"
	SetVariable HRResultsE_SetVar_N_C,fSize=10,format="%1.3f"
	SetVariable HRResultsE_SetVar_N_C,limits={0,inf,0},value= root:HR_panel:EA_CalFactor_N_C
	SetVariable HRResultsE_SetVar_S_C,pos={251,391},size={65,16},title="S/C**"
	SetVariable HRResultsE_SetVar_S_C,format="%1.3f"
	SetVariable HRResultsE_SetVar_S_C,limits={0,inf,0},value= root:HR_panel:EA_CalFactor_S_C
	CheckBox HRResultsE_ck_APESimproved,pos={21,425},size={302,14},title="Use ACP 2015 Canagratna et al 'Improved-Ambient' method:"
	CheckBox HRResultsE_ck_APESimproved,fSize=10,proc=HR_UseImprovedAmbientCheckProc
	CheckBox HRResultsE_ck_APESimproved,variable= root:HR_panel:HR_elementalImprovedCal
	Button HRResultsE_button_EARatios,pos={17,445},size={230,20},proc=HR_butt_MS_Calc,title="Calculate, plot time series, VanKrevelen graphs"
	Button HRResultsE_button_EARatios,fSize=10,fColor=(65280,43520,0)
	Button HRResultsE_button_EARatioDiurn,pos={249,445},size={100,20},proc=HR_butt_MS_Calc,title="Calculate Diurnal"
	Button HRResultsE_button_EARatioDiurn,help={"Make diurnal box plots."},fSize=10
	GroupBox HRResultsE_EAMS_group,pos={358,362},size={171,82},title="Elemental Mass Spectrum"
	GroupBox HRResultsE_EAMS_group,fColor=(1,1,1)
	Button HRResultsE_button_EAMassSpec,pos={383,406},size={130,35},proc=HR_butt_MS_Calc,title="Elem. avg mass spect. \r(blank=HROrg)"
	Button HRResultsE_button_EAMassSpec,fColor=(65280,43520,0)
	CheckBox HRResultsE_EASepY,pos={363,377},size={164,26},title="Separate y axes for each elem.\r(only for 'plot single' option)"
	CheckBox HRResultsE_EASepY,fSize=10,fStyle=0
	CheckBox HRResultsE_EASepY,variable= root:HR_panel:EA_MassSpecSepYAxis
	TitleBox HRResultsE_ACP2016,pos={28,375},size={137,13},title="Use these calibration factors:"
	TitleBox HRResultsE_ACP2016,fSize=10,frame=0
	TitleBox HRResultsE_title_SNwarning,pos={149,410},size={169,13},title="**Not measured/published. Caution!"
	TitleBox HRResultsE_title_SNwarning,fSize=10,frame=0
//	CheckBox HRResultsE_EAAddition,pos={29,470},size={282,14},title="Additionally, display Aiken-Ambient vs Improved Ambient"
//	CheckBox HRResultsE_EAAddition,fSize=10,fStyle=0
//	CheckBox HRResultsE_EAAddition,variable= root:HR_panel:EA_ACPTimeSeries
//	Button HRResultsE_button_oldVsNew,pos={30,487},size={270,20},proc=ButtonProc,title="Original vs ACP 2015 Improved Ambient correlation"
//	Button HRResultsE_button_oldVsNew,help={"Make diurnal box plots."},fSize=10
	Button HRResultsE_HROrgCheckPanel,pos={20,445},size={320,20},proc=HROrgCheck_Panel_make,title="HROrg Check Panel - Improved Ambient Analysis, 3rd tab"
	Button HRResultsE_HROrgCheckPanel,fColor=(65280,43520,0)

	GroupBox HRResults2_TSSpectra_group,pos={16.00,359.00},size={251.00,144.00},disable=1,title="2-d Time Series Mass Spectra (HR input for PMF)"
	GroupBox HRResults2_TSSpectra_group,fColor=(1,1,1)
	Button HRResults2_button_TseriesMass,pos={23.00,457.00},size={160.00,40.00},disable=1,proc=HR_butt_MS_Calc,title="Time series spectra (2d matrix, not\rplotted, no RIE applied\rleave list blank for all HR ions)"
	Button HRResults2_button_TseriesMass,help={"Creates a time series mass spectra (2-D) matrix."}
	Button HRResults2_button_TseriesMass,fSize=10
	CheckBox HRResults2_ItxForPMF,pos={24.00,376.00},size={64.00,14.00},disable=1,title="itx for PMF"
	CheckBox HRResults2_ItxForPMF,fSize=10,fStyle=0
	CheckBox HRResults2_ItxForPMF,variable= root:HR_panel:CreateItxForPMF
	CheckBox HRResults2_RemoveIsotopes,pos={25.00,438.00},size={91.00,14.00},disable=1,title="Remove isotopes"
	CheckBox HRResults2_RemoveIsotopes,fSize=10,fStyle=0
	CheckBox HRResults2_RemoveIsotopes,variable= root:HR_panel:HR_removeIsotopes
	CheckBox HRResults2_killMx,pos={52.00,415.00},size={121.00,14.00},disable=1,title="Kill waves when finished"
	CheckBox HRResults2_killMx,fSize=10,fStyle=0,value= 1
	CheckBox HRResults2_autoname,pos={52.00,395.00},size={188.00,14.00},title="Autoname itx with name of experiment"
	CheckBox HRResults2_autoname,fSize=10,fStyle=0,value= 1
	
//1.21G
	GroupBox HRResultsP_sizeGroup,pos={13.00,387.00},size={312.00,78.00},title="DVa Size and Time"
	GroupBox HRResultsP_sizeGroup,fColor=(1,1,1)
	PopupMenu HRResultsP_datatype,pos={15.00,365.00},size={195.00,19.00},proc=sq_pop_tof1_datatype,title="Diameter axis"
	PopupMenu HRResultsP_datatype,help={"Data to plot."},fSize=12
	PopupMenu HRResultsP_datatype,mode=1,popvalue="dXdlogDa vs logDa",value= #"\"dXdlogDa vs logDa;X vs PToF\""
	Button HRResultsP_avconc,pos={206.00,401.00},size={110.00,20.00},proc=HR_butt_MS_Calc,title="Calc. size distrib."
	Button HRResultsP_avconc,help={"Draw a size distribution plot of the species."}
	Button HRResultsP_avconc,fColor=(52224,34816,0)
	Button HRResultsP_imconc,pos={208.00,426.00},size={110.00,33.00},proc=HR_butt_MS_Calc,title="Calc. 2-d time, size\r(image plot)"
	Button HRResultsP_imconc,help={"Draw an image plot representation of the PToF data in memory."}
	Button HRResultsP_imconc,fColor=(52224,34816,0)
	Button HRResultsP_exco,pos={15.00,532.00},size={160.00,33.00},proc=HR_butt_MS_Calc,title="Calc time, size-resolved mass\rspectra (3-d matrix, not plotted)"
	Button HRResultsP_exco,help={"Export PToF data matricies."},fSize=10
	GroupBox HRResultsP_MSgroup,pos={15.00,467.00},size={306.00,61.00},title="Mass Spectra matrix (m/z x PToF bin)"
	GroupBox HRResultsP_MSgroup,fSize=12
	CheckBox HRResultsP_norm,pos={20.00,407.00},size={141.00,14.00},title="Scale (normalize) to MS data"
	CheckBox HRResultsP_norm,help={"Normalise the integrated PToF traces to the corresponding mass calculated in the MS batch."}
	CheckBox HRResultsP_norm,fSize=10,variable= root:panel:tof1_norm
	CheckBox HRResultsP_ShowStats,pos={20.00,427.00},size={159.00,14.00},title="Find, display mode, median stats"
	CheckBox HRResultsP_ShowStats,help={"Calculate PToF stats."},fSize=10
	CheckBox HRResultsP_ShowStats,variable= root:panel:tof_stats

	Button HRResultsP_butt_go2PToFDataSet,pos={379.00,397.00},size={170.00,30.00},proc=PToF_DataSetPanel,title="Review PToF spectra groups panel\r (from Pika step 1)"
	Button HRResultsP_butt_go2PToFDataSet,fSize=10
	Button HRResultsP_butt_ViewMxParams,pos={349.00,364.00},size={200.00,30.00},proc=HP_butt_PToFDataSet,title="Review this data matrix bin, PToF time,\rDVa edge points, centers "
	Button HRResultsP_butt_ViewMxParams,fSize=10
	Button HRResultsP_mscon,pos={19.00,502.00},size={250.00,20.00},proc=HR_butt_MS_Calc,title="Calc. size-resolved avgerage MS (not plotted)"
	Button HRResultsP_mscon,help={"Draw an image plot representation of the PToF data in memory."}
	Button HRResultsP_mscon,fColor=(52224,34816,0)
	CheckBox HRResultsP_SumSpectraUMR,pos={21.00,483.00},size={73.00,14.00},title="Sum to UMR"
	CheckBox HRResultsP_SumSpectraUMR,fSize=10,fStyle=0
	CheckBox HRResultsP_SumSpectraUMR,variable= root:HR_panel:HR_checkAvgHRMS_UMR

	Redimension/D root:HR_Sticks:ExactMassWave
	Redimension/D root:HR:ExactMassWave_All

	HR_InitializeHRtodowave()
	HR_initializePopupsPanel()  //1.11D
	HR_ck_oneRunOrAvg("",nan) 

	HR_tabProc("HRGen_tab",0)
	PW_SetDefaults()
 //	HRResults_TabProc("HR_Analysis_Panel",0) 		//1.14M
 	HR_ck_OneSpectraMSorPToF("HRFit_ck_MS",1)  // 1.6Z

	nvar/z BCdata = root:HR_frag:BCdata		//1.20X
	if (!NVar_exists(BCdata))
		variable/g  root:HR_frag:BCdata=0
		nvar BCdata = root:HR_frag:BCdata
	endif
	CheckBox HRGrps_butt_ChangeHRfrag_AMS, value=!BCdata
	CheckBox HRGrps_butt_ChangeHRfrag_SPAMS, value=BCdata
End


Function HR_initializePopupsPanel()		//1.11D

//	svar HRResults_pop_dataSet = root:HR_panel:HRResults_pop_dataSet
//	svar HRResults_pop_graphOutputType = root:HR_panel:HRResults_pop_graphOutputType
//	svar HRResults_pop_whisker = root:HR_panel:HRResults_pop_whisker
	
//	HR_pop_getStickDataSet("",1,"Get List")
	PopupMenu HRResults_pop_dataSet,popvalue="Get List", win=HR_Analysis_Panel
	
	PopupMenu HRResults_pop_graphOutputType popvalue = "Plot Single", win=HR_Analysis_Panel
//	HRResults_pop_graphOutputType= "Plot Single"
	
	PopupMenu HRResultsT_pop_whisker popvalue = "0-100%", win=HR_Analysis_Panel		//1.14M
//	HRResults_pop_whisker="0-100%"
//	HRResults_pop_family

End


// Added in 1.05A
Function HR_InitializeHRtodowave()

	svar sq_toDoList=root:panel:sq_toDoList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	variable tempVar

	tempVar = WhichListItem(sq_toDoWvNm,sq_toDoList )
	if (  !stringMatch(sq_toDoWvNm, "Get List") && tempVar> 0 ) 
		sq_pop_toDoList("",tempVar,sq_toDoWvNm)
	endif

End


//  HR panel button function for credits
Function HR_butt_Credits(ctrlName) : ButtonControl
	String ctrlName
	
	doWindow/F HR_credits
	if (V_flag==0)
		HR_panel_credits()
	endif

End


//  simple panel
Function HR_panel_credits()

	DOWindow/F HR_Credits
	if (V_flag)
		return 0
	endif
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(342,318,770,858) as "HR_Credits"
	SetDrawLayer UserBack
	DrawText 16,120,"Peter DeCarlo - now at Drexel University\rAllison Aiken - now at Los Alamos National Labs\rDonna Sueper * - donna@aerodyne.com\rJose Luis Jimenez - jose.jimenez@colorado.edu"
	DrawPICT 342,61,1,1,ProcGlobal#CUlogoNew
	DrawPICT 370,320,0.75,0.75,ProcGlobal#PkAPESlogo
	DrawText 8,146,"Donna Sueper is also affiliated with the University of Colorado Boulder"
	DrawText 8,165,"* Individual to whom questions about the software should be addressed."
	TitleBox cred_title,pos={10.00,6.00},size={349.00,31.00},title="HR AMS Analysis Software by:"
	TitleBox cred_title,font="Arial",fSize=26,frame=0
	GroupBox group1,pos={10.00,40.00},size={411.00,87.00},title="University of Colorado, Boulder"
	GroupBox group1,fSize=14,fColor=(1,1,1)
	TitleBox title0,pos={7.00,217.00},size={388.00,300.00},fSize=12,frame=0
	TitleBox title0,variable= root:HR_panel:HR_CreditsInfo
	Button ButtonDecarloPaper,pos={6.00,285.00},size={180.00,20.00},proc=sq_URLButton,title="Download pdf"
	Button ButtonDecarloPaper,fSize=10
	Button ButtonAiken1Paper,pos={6.00,400.00},size={180.00,20.00},proc=sq_URLButton,title="Download pdf"
	Button ButtonAiken1Paper,fSize=10
	Button ButtonAiken2Paper,pos={7.00,508.00},size={180.00,20.00},proc=sq_URLButton,title="Download pdf"
	Button ButtonAiken2Paper,fSize=10
	Button ButtonPaperListingWebSite,pos={9.00,173.00},size={380.00,20.00},proc=sq_URLButton,title="Go to web site listing major papers of High Resolution AMS"
	Button ButtonPaperListingWebSite,fSize=14
End


//Function  HR_butt_CreditsURLPetePaper(ctrlName) : ButtonControl
//	String ctrlName
//
//	BrowseURL "http://http://cires.colorado.edu/jimenez/Papers/DeCarlo_HRToFAMS_complete_published.pdf"
//
//End
//
//
//Function  HR_butt_CreditsURLAllison1Paper(ctrlName) : ButtonControl
//	String ctrlName
//
//	BrowseURL "http://cires.colorado.edu/jimenez/Papers/2008_EST_Aiken_Elemental_App_Pub_Complete.pdf"	  // es&t
//
//End
//
//Function  HR_butt_CreditsURLAllison2Paper(ctrlName) : ButtonControl
//	String ctrlName
//
//	BrowseURL "http://cires.colorado.edu/jimenez/Papers/ac071150w_published_complete.pdf"		// analytic chemistry
//	
//End

// Creates MSDiff_p wave.  Could possibly be called with a non-all todo wave
Function  HR_butt_CreateMSDiffp(ctrlName) : ButtonControl
	String ctrlName

	sq_GetIndexNotDoneYet()
//	nvar HR_UseSqBaseline = root:HR_panel:HR_UseSqBaseline
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$(todoStr)
	if ( !waveexists(todo)  || numpnts(todo)==0)
		Abort " Either the todo wave was not found or was of zero length - Aborting from HR_butt_CreateMSDiffp"
	endif

	nvar/z  HR_check_Step1DoGausFits = root:HR_panel:HR_check_Step1DoGausFits		//1.47I
	if (!NVAR_Exists(HR_check_Step1DoGausFits))
		variable/g root:HR_panel:HR_check_Step1DoGausFits = 1		//1.47I
		nvar HR_check_Step1DoGausFits = root:HR_panel:HR_check_Step1DoGausFits		//1.47I
	endif	

	wave squirrel_index = root:index:squirrel_index		//1.16I
	wave/z allFast = root:index:allFast		//1.16J

	// 1.10D
	string RawSpectraTodoList, paramStr="", GRParamStr=""
	variable idex, numRawList, ePToFFlag, pos
	wave/z ePToF_enabled=root:diagnostics:ePToF_enabled
	
	nvar isC = root:diagnostics:isC			//1.20X
	if (isC)
		nvar isV = root:diagnostics:isV			//1.20X
		wave ToFTypeVKey = root:diagnostics:ToFTypeVKey
		isV=1
		ToFTypeVKey=1
	endif
//	if (HR_UseSqBaseline)		// make sure we have good m/z calibrations for all runs in todo.  sanity check added in 1.05B
	sq_checkMzFittingWaves(todo, 1)		// returns a string, but we won't use it.  It will abort if there are nans in mz fitting waves.
	if (!DataFolderExists("root:baselineFitting")  )
		abort "You must first examine and set the baselines before you proceed - - Aborting from HR_butt_CreateMSDiffp"
	endif		
//	endif
		
	sq_makeRawSpectraGroups()		//1.51F creates todo waves raw spectraXX where XX is the number of points in the raw spectra
	RawSpectraTodoList = waveList("RawSpectra*", ";", "")
	numRawList = itemsInList(RawSpectraTodoList)
		
	if (HR_check_Step1DoGausFits)
		GF_createGlobals()
		GF_GausFitPrelims()
		wave GFMask=root:GaussFits:GFMask
		GRParamStr+="DoGausFit_Op:1;"
		GRParamStr+="GF_ParamStr:mzFolder=mzFitting/mz_Intercept=mz_FitIntercept/mz_Slope=mz_FitSlope/mz_Power=mz_FitPower/openAlso="+num2istr(WaveMax(GFMask)>2)+";"		
	endif
	print "// The calculation of MSDiff_p began at "+time()+" on the "+todoStr+" todo wave" 
				
	for(idex=0;idex<numRawList;idex+=1)
		wave/z allMS = root:allMS
		if (waveExists(allMS) )
			sq_create_todo("allMS and "+nameOfWave(todo)+ " and "+ stringFromList(idex,RawSpectraTodoList),"tempTodo")
		else
			sq_create_todo(nameOfWave(todo)+ " and "+ stringFromList(idex,RawSpectraTodoList),"tempTodo")
		endif
		wave/z tempTodo = root:tempTodo
		if (numpnts(TempTodo)==0)
			continue
		endif
		if (HR_check_Step1DoGausFits)
			wave GFMass=root:GaussFits:GFMass
			wave mFinish=root:diagnostics:mFinish
			variable m = sq_FindMaxMinMz(tempTodo,1,0)
			pos = BinarySearch(GFMass, m)
			if (pos>0)
				GFMask[pos+1,]=0// presumes HR ions are in increasing order
			endif
		endif

//		print "working with "+ stringFromList(idex,RawSpectraTodoList)+" with "+num2str(numpnts(tempTodo)) + " runs"
		//1.57C
		if (WaveExists(allFast))
//			sq_makeToDoallSlowMS() 
			wave/z allSlowMS = root:allSlowMS
			sq_create_todo(NameOfWave(tempTodo)+" and allSlowMS", "preproc_tmpSlow")
			wave preproc_tmpSlow=root:preproc_tmpSlow	
			if (numpnts(preproc_tmpSlow)>0)
				squirrel_fetch(preproc_tmpSlow, HR_MakeRawSpectra, GRParamStr+"dest:MSDiff_p", "MSOpen_p;MSClosed_p")
			endif
			sq_create_todo(NameOfWave(tempTodo)+" and allFastOpen", "preproc_tmpFast")
			wave preproc_tmpFast=preproc_tmpFast	
			if (numpnts(preproc_tmpFast)>0)
				squirrel_fetch(preproc_tmpFast, HR_MakeRawSpectra, GRParamStr+";dest:MSDiff_p", "MSOpen_p;MSClosed_p")
			endif
		else
			squirrel_fetch(tempTodo, HR_MakeRawSpectra, GRParamStr+";dest:MSDiff_p", "MSOpen_p;MSClosed_p")
		endif
	endfor
		
	if ( FindDimLabel(squirrel_index, 2, "MSePToFSum_p" )>=0)		//1.16H

		sq_makeRawSpectraGroupsePToFSum()
		RawSpectraTodoList = waveList("RawSpectra*", ";", "")
		numRawList = itemsInList(RawSpectraTodoList)
							
		for(idex=0;idex<numRawList;idex+=1)
			sq_create_todo(nameOfWave(todo)+ " and "+ stringFromList(idex,RawSpectraTodoList),"tempTodo")
			wave/z tempTodo = root:tempTodo
			if (numpnts(TempTodo)==0)
				continue
			endif
	//		print "working with "+ stringFromList(idex,RawSpectraTodoList)+" with "+num2str(numpnts(tempTodo)) + " runs"
			//1.57C
			pos = sq_findRun(root:index:rn_series,tempTodo[0])
			ePToFFlag = ePToF_enabled[pos]
			if(ePToFFlag)		// check should not be needed
				squirrel_fetch(tempTodo, HR_MakeRawSpectra, GRParamStr+";ePToFFlag:1;dest:MSePToFSumDiff_p", "MSePToFSum_p;MSClosed_p")
			endif
		endfor
	endif
	
//	if (HR_check_Step1DoGausFits)
//		if(! ePToFFlag)		// kill this option for now  1.57C
//			print "// The calculation of gauss fits for selected HR ions began at "+time()+" on the "+todoStr+" todo wave" 
//			GF_butt_GFsTodo("")
//		endif
//	endif
	print "// The calculation of MSDiff_p ended at "+time()+" on the "+todoStr+" todo wave" 

	killwaves/z tempTodo, preproc_tmpFast,preproc_tmpSlow, root:preproc_tmpSlow, root:oneRun_temp
	killwaves/z root:W_ExtractedRow,root:W_sigma
		
	sq_KillWavesInList(RawSpectraTodoList)		//1.51F change

End


// Control function on main HR panel
Function HR_butt_avgInfo(ctrlName) : ButtonControl
	String ctrlName

	 RA_Initialize()		// this calls the Rough Average panel
	
End


Function HR_populate_AllMassesTable()
	
	AppendToTable root:HR:ExactMassText_all,root:HR:ExactMassWave_all,root:HR:Mask_Stick_integration
	AppendToTable root:HR:ExactMassComments,root:HR:Mask_Stick_Integration_Default		
	AppendToTable root:HR:Mask_Isotope_abundance,root:HR:Mask_Isotope_reference
	ModifyTable format(root:HR:ExactMassWave_all)=3,digits(root:HR:ExactMassWave_all)=6
	ModifyTable style(root:HR:Mask_Stick_integration)=1, rgb(root:HR:Mask_Stick_integration)=(65280,0,0)	
	ModifyTable rgb(root:HR:Mask_Isotope_abundance)=(0,0,65280),  rgb(root:HR:Mask_Isotope_reference)=(0,0,65280)
	ModifyTable width(Point)=30
	ModifyTable width(root:HR:ExactMassText_All)=60,width(root:HR:ExactMassWave_All)=60, width(root:HR:Mask_Stick_Integration)=45
	ModifyTable title(root:HR:ExactMassText_All)="HR ion",title(root:HR:ExactMassWave_All)="Mass"
	ModifyTable title(root:HR:Mask_Stick_Integration)="Fit Mask",title(root:HR:ExactMassComments)="Comments"
	ModifyTable title(root:HR:Mask_Stick_Integration_default)="Fit Mask Default"
	ModifyTable title(root:HR:Mask_Isotope_abundance)="Isotope Abund."
	ModifyTable title(root:HR:Mask_Isotope_reference)="Isotope Parent"
	ModifyTable format(root:HR:ExactMassWave_All)=3,digits(root:HR:ExactMassWave_All)=5		//1.13A
	
End


// Button function in the ChooseMassesPanel
Function HR_butt_SetMaskToDefault(ctrlName) : ButtonControl
string ctrlName
	
	DoAlert 1, "Are you sure that you want to overwrite the Mask_Stick_Integration wave with the defaults?"
	
	if (V_flag==1)
		wave Mask_Stick_Integration = root:HR:Mask_Stick_Integration
		wave Mask_Stick_Integration_Default = root:HR:Mask_Stick_Integration_Default
		fastop Mask_Stick_Integration = Mask_Stick_Integration_Default
		print "// The Mask_Stick_Integration wave was set to the default on "+date() + " "+time()
	endif
	
End


// Control on main HR panel that displays v or w mode (or blank for a nonexistant run)
Function HR_SetVar_RunModeStr(ctrlName,varNum,varStr,varName) : SetVariableControl
string ctrlName
variable varNum
string varStr
string varName

	wave run_series = root:index:rn_series
	wave ToFTypeWKey = root:diagnostics:ToFTypeWKey
	wave ToFTypeVKey = root:diagnostics:ToFTypeVKey
	wave/z ionizationType = root:diagnostics:ionizationType
	wave t_series = root:index:t_series
	nvar HR_RunVar =  root:HR_Panel:HR_RunVar
	svar HR_runModeStr = root:HR_Panel:HR_runModeStr
	
	variable currentRunIndex =sq_FindRun(run_series, HR_RunVar)
	string mode, iontype
	
	if(currentRunIndex<0)
		 HR_runModeStr=""
		 return 0
	elseif(toftypeVKey[currentRunIndex]==1)
		mode = "v"
	elseif (toftypeWKey[currentRunIndex]==1)
		mode = "w"
	else
		mode = "c"
	endif

	if (waveExists(ionizationType) )		//1.06C
		iontype = StringFromList(ionizationType[currentRunIndex], IONIZATION_TYPE_LIST)
	else
		iontype=""
	endif
	
	HR_runModeStr =mode+ "  "+iontype+" "+secs2date(t_series[currentRunIndex],0)+"   "+secs2time(t_series[currentRunIndex],3)

	HR_ck_oneRunOrAvg("",1)		//1.08E

End


// "Multiplies" the mask wave to the "all" wave to generate the wave of masses to be used in this analysis 
// 1.08E  Should probably be renamed as it simply creates/updates the root:HR_stick:ExactMassWave etc. waves.
//  does not deal with family mask or any other kind of mask waves
Function HR_MakeIntegrationMaskWave()

	Wave/Z ExactMassWave_All = root:HR:ExactMassWave_All 
	Wave/Z ExactMassText_All = root:HR:ExactMassText_All 
	Wave/Z Mask_Stick_integration = root:HR:Mask_Stick_integration 
	
	variable idex, num
	
	if (WaveExists(ExactMassWave_all)==0)
		Abort "You must import the exact mass 'all' waves before proceeding - Aborting from HR_MakeIntegrationMaskWave"
	endif
		
	Duplicate/o root:HR:ExactMassWave_All  root:HR_Sticks:ExactMassWave
	Duplicate/o/t root:HR:ExactMassText_All  root:HR_Sticks:ExactMassText
	Duplicate/o/t root:HR:ExactMassTag_All  root:HR_Sticks:ExactMassTag
	Duplicate/o/t root:HR:Mask_Isotope_reference  root:HR_Sticks:ExactMassIsotopeRef
	Duplicate/o/t root:HR:Mask_Isotope_abundance  root:HR_Sticks:ExactMassIsotopeAbund
		
	Wave ExactMassWave = root:HR_Sticks:ExactMassWave
	Wave/T ExactMassText = root:HR_Sticks:ExactMassText
	Wave/T ExactMassTag= root:HR_Sticks:ExactMassTag
	Wave/T ExactMassIsotopeRef = root:HR_Sticks:ExactMassIsotopeRef
	Wave ExactMassIsotopeAbund = root:HR_Sticks:ExactMassIsotopeAbund 
	
	num = numpnts(ExactMassWave_All) 
	
	for(idex=num-1; idex>=0; idex-=1)		// count backwards to avoid probs from deleting points in wave
		if(Mask_Stick_integration[idex] == 0)
			deletepoints idex, 1, ExactMassWave, ExactMassText, ExactMassTag, ExactMassIsotopeRef, ExactMassIsotopeAbund
		endif
	endfor

	// 1.08E removed some code that sorted unneccessarily and dealt with OneRunDisplayVertGrid
End


// Calculates sticks for open, closed diff spectra for one run
// It calls function in the SQ_HR ipf
// Note that it is not a squirrel fetch function

Function HR_butt_CalcSticksForThisRun(ctrlName) : ButtonControl
string ctrlName
	
	sq_GetIndexNotDoneYet()			//1.16Z
	wave run_series = root:index:rn_series
 	nvar HR_RunVar = root:HR_Panel:HR_RunVar
 	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
 	
 	nvar HR_checkDoNotGrabRawSpectra = root:HR_panel:HR_checkDoNotGrabRawSpectra  	// misnamed, should be single run or average todo
 	nvar HR_UsePeakShapeVar = root:HR_panel:HR_UsePeakShapeVar		// added in 1.02
 	nvar HR_FinalPSScalar = root:HR_PeakShape:HR_FinalPSScalar		// this param for use, not display like HR_FinalPeakShapeScalar
 	
 	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF		//1.10Q
 	nvar HR_UseOpenClosedMzParams = root:HR_panel:HR_UseOpenClosedMzParams		//1.10Q

	wave t_series = root:index:t_series
	wave run_index = root:index:run_index

	nvar error_sigma=root:panel:error_sigma		//1.08A

 	variable currentRunIndex, currentTime, tempVar, isVmode, peakShapeScalar, lastHRmzPos
	string OneOrTodoFitStr, PToFOpenStr, PToFClosedStr
	
	if (HR_singleSpectraMSorPToF==0 && HR_UseOpenClosedMzParams ) 	//1.11A added !
		abort "Do not select to use different Open and Closed Mz parameters when fitting PToF spectra  aborting from HR_butt_CalcSticksForThisRun"	
	endif
		
	if (HR_checkDoNotGrabRawSpectra)  	// misnamed, should be single run or average todo
		HR_PeakWidthSanity(0)
		HR_PeakShapeSanity(0)
		OneOrTodoFitStr =" todo wave "+sq_toDoWvNm
		wave todo = $"root:"+sq_toDoWvNm
		if (sq_findRun(todo,HR_RunVar)<0 ) 		//1.03E
			HR_RunVar = todo[0]
		endif
	else
		HR_PeakWidthSanity(1)
		HR_PeakShapeSanity(1)
		sprintf OneOrTodoFitStr, " run %d", HR_RunVar
	endif
		
	if (HR_UsePeakShapeVar)		// sanity check added in 1.02A
		if ( (HR_FinalPSScalar > 3) || (HR_FinalPSScalar < 0.5))
			abort "You have chosen to use fit data with a peak shape scalar has a bad value of "+num2str(HR_FinalPSScalar)+" - aborting from HR_butt_CalcSticksForThisRun"
		else
			peakShapeScalar = HR_FinalPSScalar
		endif
	else 
		peakShapeScalar = 1
	endif
	
	currentRunIndex =sq_FindRun(run_series, HR_RunVar)
	if (currentRunIndex<0)
 		Abort "This run number doesn't show up in the index. - Aborting from HR_butt_CalcSticksForThisRun"
 	endif

	currentTime = t_series[currentRunIndex]		// for display in plot
 	sq_makeOneRunToDo(HR_RunVar)
	wave/u/i MyOneRunToDoWave = root:MyOneRunToDoWave

		// new in 1.04G
	wave/wave TimeWaves=sq_GetModifiedTimes()
	wave TimeMSOpen = TimeWaves[0]
	wave TimeMSClosed = TimeWaves[1]
	wave TimePToF = TimeWaves[2]

	variable TimeBaseOpenVal, TimeBaseClosedVal
	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF		//1.19F
	if (HR_singleSpectraMSorPToF==1)		// MS data
		TimeBaseOpenVal = TimeMSOpen[currentRunIndex]
		TimeBaseClosedVal = TimeMSClosed[currentRunIndex]
	elseif(HR_singleSpectraMSorPToF==0 || HR_singleSpectraMSorPToF==2)		// PToF  1.60K
		TimeBaseOpenVal = TimePToF[currentRunIndex]
		TimeBaseClosedVal = TimeMSClosed[currentRunIndex]
	endif	
	if (TimeBaseOpenVal==0 && !HR_checkDoNotGrabRawSpectra)
		wave/z FastKey = root:diagnostics:FastKey
		if (HR_singleSpectraMSorPToF==1 && WaveExists(FastKey) && FastKey[currentRunIndex]==2)
			abort "This is a fast closed run. Cannot perform Pika fits. Aborting from HR_butt_CalcSticksForThisRun"
		elseif (HR_singleSpectraMSorPToF==2)
			abort "The PToF time spent in this run is zero.  Cannot continue.  Aborting from HR_butt_CalcSticksForThisRun"
		else
			abort "Are you sure that it is valid to generate HR sticks for this run?  Time spent in 'open' mode is zero!  Aborting from HR_butt_CalcSticksForThisRun"
		endif
	endif
	
 	HR_butt_MakeExactMassWaves("")	// modified in 1.08E	
		//1.11A check added 
	pk_VerifyMzRange(currentRunIndex)

	print "// The HR Sticks calculations for "+OneOrTodoFitStr+" began at "+ time()		
		
	wave UnitMass = root:HR_Sticks:UnitMass		// for now we don't know which run we are going to use.... 		//1.11A
	// check added for PToF max mz
	if (HR_singleSpectraMSorPToF==0)	// PToF	  1.16Z
		wave/z/t PToFDataSetNames= root:PToF:PToFDataSetNames
		wave/z/i PToFDataSetMaxmz= root:PToF:PToFDataSetMaxmz
		if (!WaveExists(PToFDataSetNames) || numpnts(PToFDataSetNames)==0 || !WaveExists(PToFDataSetMaxmz) || numpnts(PToFDataSetMaxmz)==0)		//1.19F
			abort "You have not created PToF data sets yet.  Go to Pika step 1. and define PToF data sets. "
		endif
		ControlInfo/W=HR_Analysis_Panel HRFit_popup_PToFOpen
		PToFOpenStr = S_value
		ControlInfo/W=HR_Analysis_Panel HRFit_popup_PToFClosed
		PToFClosedStr = S_value
		
		HR_PToF_ChooseDataSet("HRFit_popup_PToFOpen",nan,PToFOpenStr)		// simulate selecting
		FindValue /Text = PToFOpenStr  PToFDataSetNames
		if (V_Value<0)
			abort "Please reselect the PToF 'open' data set. - Aborting from "
		elseif(PToFDataSetMaxmz[V_value] <  UnitMass[numpnts(UnitMass)-1]-1  )		//1.19C
			DoAlert 1, "For the data set "+PToFOpenStr+" the maximum HR ion chosen to fit is "+num2str( UnitMass[numpnts(UnitMass)-1])+" and the maximum mz of the PToF data set of "+num2str(PToFDataSetMaxmz[V_value]) +" Press yes to proceed - the code will modify the set of HR ions to fit to be <= max mz. Press no to quit."
			if (V_flag==2)
				sq_butt_popThis("HRGrps_HR_AllMassesTable")
//				abort "The user chose to quit."
			else // 1.19E
				Wave/d ExactMassWave_All = root:HR:ExactMassWave_All 
				Wave Mask_Stick_integration = root:HR:Mask_Stick_integration 
				lastHRmzPos = Ceil(BinarySearchInterp(ExactMassWave_All, PToFDataSetMaxmz[V_value]-0.5))
				Mask_Stick_integration[lastHRmzPos,]=0
			 	HR_butt_MakeExactMassWaves("")	// 1.19E
			endif			
		endif
		
		HR_PToF_ChooseDataSet("HRFit_popup_PToFClosed",nan,PToFClosedStr)// simulate selecting
		FindValue /Text = PToFClosedStr  PToFDataSetNames
		if (V_Value<0)
			abort "Please reselect the PToF 'open' data set. - Aborting from "
		elseif(PToFDataSetMaxmz[V_value] <  UnitMass[numpnts(UnitMass)-1]-1  )
			DoAlert 1, "For the data set "+PToFClosedStr+" the maximum HR ion chosen to fit is greater than the maximum mz of the PToF data set of "+num2str(PToFDataSetMaxmz[V_value]) +" Press yes to proceed - the code will modify the set of HR ions to fit to be <= max mz. Press no to quit."
			if (V_flag==2)
				sq_butt_popThis("HRGrps_HR_AllMassesTable")
//				abort "The user chose to quit."
			else
				Wave/d ExactMassWave_All = root:HR:ExactMassWave_All 
				Wave Mask_Stick_integration = root:HR:Mask_Stick_integration 
				lastHRmzPos = Ceil(BinarySearchInterp(ExactMassWave_All, PToFDataSetMaxmz[V_value]-0.5))
			 	HR_butt_MakeExactMassWaves("")	// 1.19E
			endif
		endif
		if (HR_UseOpenClosedMzParams)
			doAlert 1, "Using separate open and closed m/z parameters for PToF data doesn't make sense.  To unselect and continue press yes.  Else no to abort"
			if (V_flag==1)
				HR_UseOpenClosedMzParams=0
			endif
		endif
	endif	
	
	HR_butt_CheckIsotopeMask("")		//1.09K
 	HR_CalculateSticksSQ_prep()		//1.08E
	HR_SticksOneRun_prep(stringmatch("HR_PeakHeightsGr_butt_redoFits", ctrlName) )		//HR_PeakHeightsGr_butt_redoFits is the button on the peak heights graph
		
	wave dutyCycleCorr = root:Int_Sticks:dutyCycleCorr		// added in 1.02

	wave OneRunStickOpen = root:HR_sticks:OneRunStickOpen
	wave OneRunStickClosed = root:HR_sticks:OneRunStickClosed
	wave OneRunStickDiff = root:HR_sticks:OneRunStickDiff
	wave OneRunStick_temp = root:HR_sticks:OneRunStick_temp

	wave OneRunStick_temp = root:HR_sticks:OneRunStick_temp

	wave OneRunRawSpectraOpen =root:HR_sticks:OneRunRawSpectraOpen
	wave OneRunRawSpectraClosed =root:HR_sticks:OneRunRawSpectraClosed
	wave OneRunRawSpectraDiff =root:HR_sticks:OneRunRawSpectraDiff

//	wave HR_BkOneRunOpen = root:HR_sticks:HR_BkOneRunOpen
//	wave HR_BkOneRunClosed = root:HR_sticks:HR_BkOneRunClosed
//	wave HR_BkOneRunDiff = root:HR_sticks:HR_BkOneRunDiff		// will contain the results of the HR sticks fit
//	wave HR_BkOneRun_temp = root:HR_sticks:HR_BkOneRun_temp

	wave SigmaOneRunOpen = root:HR_sticks:SigmaOneRunOpen
	wave SigmaOneRunClosed = root:HR_sticks:SigmaOneRunClosed
	wave SigmaOneRunDiff = root:HR_sticks:SigmaOneRunDiff
	wave SigmaOneRun_temp = root:HR_sticks:SigmaOneRun_temp
	wave HR_FitFail_temp = root:HR_sticks:HR_FitFail_temp
	
	wave OneRunResidSpectraOpen =root:HR_sticks:OneRunResidSpectraOpen
	wave OneRunResidSpectraClosed =root:HR_sticks:OneRunResidSpectraClosed
	wave OneRunResidSpectraDiff =root:HR_sticks:OneRunResidSpectraDiff
	wave OneRunResidSpectra_temp =root:HR_sticks:OneRunResidSpectra_temp

	wave OneRunResidPerSpectraOpen =root:HR_sticks:OneRunResidPerSpectraOpen
	wave OneRunResidPerSpectraClosed =root:HR_sticks:OneRunResidPerSpectraClosed
	wave OneRunResidPerSpectraDiff =root:HR_sticks:OneRunResidPerSpectraDiff
	wave OneRunResidPerSpectra_temp =root:HR_sticks:OneRunResidPerSpectra_temp

	wave OneRunResidSumOpen =root:HR_sticks:OneRunResidSumOpen
	wave OneRunResidSumClosed =root:HR_sticks:OneRunResidSumClosed
	wave OneRunResidSumDiff =root:HR_sticks:OneRunResidSumDiff
	wave OneRunResidSum_temp =root:HR_sticks:OneRunResidSum_temp	
	
	wave OneRunResidNoiseOpen = root:HR_sticks:OneRunResidNoiseOpen
	wave OneRunResidNoiseClosed = root:HR_sticks:OneRunResidNoiseClosed
	wave OneRunResidNoiseDiff = root:HR_sticks:OneRunResidNoiseDiff
	wave OneRunResidNoise_temp = root:HR_sticks:OneRunResidNoise_temp
	
	wave HRFitChiSqOpen =  root:HR_Sticks:HRFitChiSqOpen			//1.04G
	wave HRFitChiSqClosed =  root:HR_Sticks:HRFitChiSqClosed			//1.04G
	wave HRFitChiSqDiff =  root:HR_Sticks:HRFitChiSqDiff			//1.04G
	wave HRFitChiSq_temp =  root:HR_Sticks:HRFitChiSq_temp			//1.04G

	wave OneRunSqBkStickOpen = root:HR_sticks:OneRunSqBkStickOpen		//1.09H baseline HR stick
	wave OneRunSqBkStickClosed = root:HR_sticks:OneRunSqBkStickClosed	//1.09H baseline HR stick
	wave OneRunSqBkStickDiff = root:HR_sticks:OneRunSqBkStickDiff			//1.09H baseline HR stick
	wave OneRunSqBkStick_temp = root:HR_sticks:OneRunSqBkStick_temp		//1.09H baseline HR stick

	wave OneRunDiffCountingError = root:HR_sticks:OneRunDiffCountingError
	wave todo = $sq_toDoWvNm
	
	wave/z nSecMSsamplingInterval =  root:diagnostics:nSecMSsamplingInterval		//1.14B
	if (!WaveExists(nSecMSsamplingInterval) || !waveMax(nSecMSsamplingInterval) >0 )
		make/o/n=(numpnts(t_series))  root:diagnostics:nSecMSsamplingInterval=1		// default - old card always at 1ns
		wave nSecMSsamplingInterval =  root:diagnostics:nSecMSsamplingInterval		//1.14B
	endif
		
	nvar HR_UseOpenClosedMzParams = root:HR_Panel:HR_UseOpenClosedMzParams
	
 	variable sigma = error_sigma^2
 	variable OneRunNumFail=0
 	
 	sq_makeOneRunToDo(HR_RunVar)
	wave/u/i MyOneRunToDoWave = root:MyOneRunToDoWave

	if (!HR_UseOpenClosedMzParams)		//1.03E
		sq_check_NansInWaveList(MyOneRunToDoWave, "root:mzFitting:mz_FitIntercept;root:mzFitting:mz_FitSlope;root:mzFitting:mz_FitPower")
	else
		sq_check_NansInWaveList(MyOneRunToDoWave, "root:mzFitting:mz_FitInterceptOpen;root:mzFitting:mz_FitSlopeOpen;root:mzFitting:mz_FitPowerOpen")
		sq_check_NansInWaveList(MyOneRunToDoWave, "root:mzFitting:mz_FitInterceptClosed;root:mzFitting:mz_FitSlopeClosed;root:mzFitting:mz_FitPowerClosed")
	endif
	killwaves/z MyOneRunToDoWave

	if (HR_UseOpenClosedMzParams)		//1.04J
		wave mz_FitInterceptOpen = root:mzFitting:mz_FitInterceptOpen
		wave mz_FitSlopeOpen = root:mzFitting:mz_FitSlopeOpen
		wave mz_FitPowerOpen = root:mzFitting:mz_FitPowerOpen
		wave mz_FitInterceptClosed = root:mzFitting:mz_FitInterceptClosed
		wave mz_FitSlopeClosed = root:mzFitting:mz_FitSlopeClosed
		wave mz_FitPowerClosed = root:mzFitting:mz_FitPowerClosed
	else
		wave mz_FitInterceptOpen = root:mzFitting:mz_FitIntercept
		wave mz_FitSlopeOpen = root:mzFitting:mz_FitSlope
		wave mz_FitPowerOpen = root:mzFitting:mz_FitPower
		wave mz_FitInterceptClosed = root:mzFitting:mz_FitIntercept
		wave mz_FitSlopeClosed = root:mzFitting:mz_FitSlope
		wave mz_FitPowerClosed = root:mzFitting:mz_FitPower
	endif
		
	//1.10Q
	if (HR_singleSpectraMSorPToF==0 && HR_UseOpenClosedMzParams)		// we deal with PToF and Use Open params
		DoAlert, 1, "You have selected PToF and Use separate Open and Closed m/z parameters.  If you  wish to use the MS Open m/z parameters for PToF, press yes, else no to quit."
		if (V_flag==2)
			abort "The user chose to quit."
		endif		
	endif
		
	// 1.02 addition
	duplicate/o OneRunStickOpen root:HR_Sticks:OneRunPeakHeightOpen, root:HR_Sticks:OneRunPeakHeightClosed, root:HR_Sticks:OneRunPeakHeightDiff, root:HR_Sticks:OneRunPeakHeightOpenMClosed
	wave OneRunPeakHeightOpen =root:HR_sticks:OneRunPeakHeightOpen
	wave OneRunPeakHeightClosed =root:HR_sticks:OneRunPeakHeightClosed
	wave OneRunPeakHeightDiff =root:HR_sticks:OneRunPeakHeightDiff
	wave OneRunPeakHeightOpenMClosed=root:HR_sticks:OneRunPeakHeightOpenMClosed
	
	// 1.08A addition
	duplicate/o OneRunStickOpen root:HR_Sticks:OneRunCountErrorClosed, root:HR_Sticks:OneRunCountErrorOpen
	wave OneRunCountErrorClosed =root:HR_sticks:OneRunCountErrorClosed
	wave OneRunCountErrorOpen =root:HR_sticks:OneRunCountErrorOpen

	PK_convertUnitSigmaToEachSpecie()

	wave ExactMassSigma = root:HR_Sticks:ExactMassSigma

	if (HR_checkDoNotGrabRawSpectra)
		HR_GetPointDeltaHistogram(todo)		//1.10K addition for averaging of todo blurring
	endif
	
	//1.07A fix
	HR_calcSticksOneRun(currentRunIndex, OneRunRawSpectraClosed, mz_FitInterceptClosed, mz_FitSlopeClosed, mz_FitPowerClosed)//, BkOneRunClosed, StartPtOneRun, EndPtOneRun)		
	OneRunStickClosed  = OneRunStick_temp* sqrt(pi) * ExactMassSigma* peakShapeScalar * dutyCycleCorr	// 1.02A fix	
	OneRunStickClosed*=nSecMSsamplingInterval[currentRunIndex]			//1.13D

	fastop OneRunPeakHeightClosed= OneRunStick_temp								// 1.02A fix
	fastop SigmaOneRunClosed = SigmaOneRun_temp
	fastop OneRunResidNoiseClosed = OneRunResidNoise_temp
	
//	HR_BkOneRunClosed = HR_BkOneRun_temp
	fastop OneRunResidSpectraClosed = OneRunResidSpectra_temp
	fastop OneRunResidPerSpectraClosed = OneRunResidPerSpectra_temp
	fastop OneRunResidSumClosed = OneRunResidSum_temp
//	OneRunCountErrorClosed =  sqrt(abs(OneRunStickClosed) * (sigma/TimeBaseClosedVal)*dutyCycleCorr )		// added in 1.08A
	OneRunCountErrorClosed =  sqrt(abs(OneRunStickClosed+OneRunSqBkStickClosed) * (sigma/TimeBaseClosedVal)*dutyCycleCorr )		//1.09H fix
	
	fastop HRFitChiSqClosed = HRFitChiSq_temp
	OneRunNumFail+=sum(HR_FitFail_temp)		//1.08E

	if(HR_UseOpenClosedMzParams)
		wave/z mz_FitIntercept = root:mzFitting:mz_FitInterceptOpen
		wave/z mz_FitSlope = root:mzFitting:mz_FitSlopeOpen
		wave/z mz_FitPower= root:mzFitting:mz_FitPowerOpen
		if (  WaveExists(mz_FitIntercept)==0 || WaveExists(mz_FitSlope)==0 || WaveExists(mz_FitPower)==0 )
			Abort " TheUse separate m/z parameters for Open, Closed Spectra was checked but no mz_Fit*Open waves were found. Aborting from HR_butt_CalcSticksForThisRun"
		endif
	endif

	HR_calcSticksOneRun(currentRunIndex, OneRunRawSpectraOpen, mz_FitInterceptOpen, mz_FitSlopeOpen, mz_FitPowerOpen)//, BkOneRunOpen, StartPtOneRun, EndPtOneRun)		
	OneRunStickOpen  = OneRunStick_temp* sqrt(pi) * ExactMassSigma* peakShapeScalar * dutyCycleCorr		// 1.02A fix
	OneRunStickOpen*=nSecMSsamplingInterval[currentRunIndex]			//1.13D

	fastop OneRunPeakHeightOpen = OneRunStick_temp								// 1.02A fix
	fastop SigmaOneRunOpen = SigmaOneRun_temp
	fastop OneRunResidNoiseOpen = OneRunResidNoise_temp

//	HR_BkOneRunOpen = HR_BkOneRun_temp
	fastop OneRunResidSpectraOpen = OneRunResidSpectra_temp
	fastop OneRunResidPerSpectraOpen = OneRunResidPerSpectra_temp
	fastop OneRunResidSumOpen = OneRunResidSum_temp
//	OneRunCountErrorOpen =  sqrt(abs(OneRunStickOpen) * (sigma/TimeBaseOpenVal)*dutyCycleCorr )			// added in 1.08A
	OneRunCountErrorOpen =  sqrt(abs(OneRunStickOpen+OneRunSqBkStickOpen) * (sigma/TimeBaseOpenVal)*dutyCycleCorr )			// 1.09H fix

	fastop HRFitChiSqOpen = HRFitChiSq_temp
	OneRunNumFail+=sum(HR_FitFail_temp)		//1.08E
	
	fastop OneRunPeakHeightOpenMClosed =  OneRunPeakHeightOpen - OneRunPeakHeightClosed	//1.04B
	
//	OneRunDiffCountingError =  1.2 *dutyCycleCorr * sqrt(abs(OneRunStickOpen/dutyCycleCorr)/TimeBaseOpenVal +abs(OneRunStickClosed/dutyCycleCorr)/timebaseClosedVal) bug found in 1.08A
	if (HR_checkDoNotGrabRawSpectra)  	// misnamed, should be single run or average todo
		OneRunCountErrorOpen/=sqrt(numpnts(todo))
		OneRunCountErrorClosed/=sqrt(numpnts(todo))
	endif
	OneRunDiffCountingError =  sqrt(OneRunCountErrorOpen^2 +OneRunCountErrorClosed^2)
	
	if(HR_UseOpenClosedMzParams)
		fastop OneRunStickDiff = OneRunStickOpen - OneRunStickClosed
		fastop OneRunPeakHeightDiff = OneRunPeakHeightOpenMClosed								// 1.02A fix
		
		fastop OneRunResidSpectraDiff = (nan)
		fastop SigmaOneRunDiff = (nan)
//		HR_BkOneRunDiff = nan

		HRFitChiSqDiff = sqrt(HRFitChiSqOpen^2+ HRFitChiSqClosed^2)
	
		OneRunResidNoiseDiff= sqrt(OneRunResidNoiseOpen^2 + OneRunResidNoiseClosed^2)		
		if (HR_checkDoNotGrabRawSpectra)  	// misnamed, should be single run or average todo
			OneRunResidNoiseDiff/=sqrt(numpnts(todo))
		endif
		
	else
		HR_calcSticksOneRun(currentRunIndex, OneRunRawSpectraDiff, mz_FitInterceptOpen, mz_FitSlopeOpen, mz_FitPowerOpen)    //, BkOneRunDiff, StartPtOneRun, EndPtOneRun)		
		OneRunStickDiff = OneRunStick_temp* sqrt(pi) * ExactMassSigma* peakShapeScalar	* dutyCycleCorr
		OneRunStickDiff*=nSecMSsamplingInterval[currentRunIndex]			//1.13D

		fastop OneRunPeakHeightDiff = OneRunStick_temp								// 1.02A fix
		fastop OneRunResidNoiseDiff = OneRunResidNoise_temp
		fastop SigmaOneRunDiff = SigmaOneRun_temp
//		HR_BkOneRunDiff = HR_BkOneRun_temp
		fastop OneRunResidSpectraDiff = OneRunResidSpectra_temp
		fastop OneRunResidPerSpectraDiff = OneRunResidPerSpectra_temp
		fastop OneRunResidSumDiff = OneRunResidSum_temp

		fastop HRFitChiSqDiff = HRFitChiSq_temp

		OneRunNumFail+=sum(HR_FitFail_temp)		//1.08E
	endif

	//set checkboxes

	svar HR_SticksGr_RunInfo = root:HR_Sticks:HR_SticksGr_RunInfo
	svar HR_RunModeStr = root:HR_Panel:HR_RunModeStr
	tempvar = strsearch(HR_RunModeStr, "/", 0)
	tempvar = strsearch(HR_RunModeStr, " ", tempvar, -1)
	
	if (!HR_checkDoNotGrabRawSpectra)  	// misnamed, should be single run or average todo
		sprintf  HR_SticksGr_RunInfo,  "Fitted Run: %d", HR_RunVar		//1.05A
		HR_SticksGr_RunInfo += "\r"+HR_RunModeStr[0, tempvar]+ " "+secs2date(currentTime,0)+" "+secs2time(currentTime,3)
	else
		HR_SticksGr_RunInfo = "Fitted Todo: "+sq_toDoWvNm//+ "with first run at "
		//HR_SticksGr_RunInfo += "\r"+secs2date(currentTime,0)+"   "+secs2time(currentTime,3)
	endif
		
	if (HR_singleSpectraMSorPToF==1)
		HR_SticksGr_RunInfo += "\rMS"
	elseif (HR_singleSpectraMSorPToF==0)

		HR_SticksGr_RunInfo += "\rPToF"
		HR_SticksGr_RunInfo += " Open="+PToFOpenStr+" Closed="+PToFClosedStr		//1.19C
	elseif (HR_singleSpectraMSorPToF==0)
		HR_SticksGr_RunInfo += "\rePToFSum"
	endif

//	PK_calcSQBaselineFit()
	
	HR_plotPeakHeightsOneRun()
 
 	UM_DoAllCalcsForIntMassSpectrum()	
 	
 	if (HR_singleSpectraMSorPToF ==1 )		// do not do for PToF HR  or ePToFSUm
 		UM_ExtractSQMassSpectra()		//1.03C
 	endif
 	
 	HR_CalcStep4MassDefect()		//1.11K addition
		 
	wave OneRunSqBkStickOpen = root:HR_Sticks:OneRunSqBkStickOpen		// updated in HR_plotPeakHeightsOneRun
	wave OneRunSqBkStickClosed = root:HR_Sticks:OneRunSqBkStickClosed		// updated in HR_plotPeakHeightsOneRun

	PK_CreatePHPW_Diagnostic("O", OneRunPeakHeightOpen, OneRunSqBkStickOpen)  		//1.15A addition
	PK_CreatePHPW_Diagnostic("C", OneRunPeakHeightClosed, OneRunSqBkStickClosed)  	//1.15A addition

	print "// The HR Sticks calculations for "+OneOrTodoFitStr+" ended at "+ time() + "\t\t The number of failed fits:"+num2str(oneRunNumFail)	
	
	Killwaves/z PeakHeights, PeakCenters, peakIndexWave, myTempWave,TimeWaves,MyOneRunToDoWave
End


// Creates exact mass sticks for diff spectra for all runs.
Function HR_butt_CalcExactMassSticksTodo(ctrlName) : ButtonControl
	String ctrlName

	sq_GetIndexNotDoneYet()
	svar todoStr=root:panel:sq_toDoWvNm		//^ 1.35 change
	wave/z todo=$(todoStr)

//	nvar HR_UseSqBaseline = root:HR_panel:HR_UseSqBaseline							// should always be on
//	nvar HR_CalcManyRunsOpenClosed = root:HR_Panel:HR_CalcManyRunsOpenClosed	// fit both open and closed.
	nvar HR_UseOpenClosedMzParams = root:HR_Panel:HR_UseOpenClosedMzParams	// use Mz params
	nvar HR_UsePeakShapeVar = root:HR_Panel:HR_UsePeakShapeVar
	nvar HR_UseVaryingPeakWidth = root:HR_Panel:HR_UseVaryingPeakWidth
	nvar HR_UseFixedIsotopicVals = root:HR_Panel:HR_UseFixedIsotopicVals	
	nvar HR_IfFitNegConstrainToZero = root:HR_Panel:HR_IfFitNegConstrainToZero	
	nvar HR_FitVerboseMode = root:HR_Panel:HR_FitVerboseMode
	svar InfoOfLastTodoFits = root:HR_panel:InfoOfLastTodoFits		//1.08E
	nvar SaveAfterTodoFits = root:HR_panel:SaveAfterTodoFits		//1.08E
	nvar HR_numFail = root:HR_sticks:HR_numFail		//1.08E
	nvar error_sigma=root:panel:error_sigma
	nvar error_noise=root:panel:error_noise
	nvar  AvgTodoFlag = root:HR_panel:AvgTodoFlag 

	nvar HR_singleSpectraMSorPToF=root:HR_panel:HR_singleSpectraMSorPToF		//1.10Q
//	nvar HR_CalcManyRunsOpenClosed=root:HR_panel:HR_CalcManyRunsOpenClosed		//1.11M  //1.14M commented out

	nvar FItEveryPToFGroup = root:HR_panel:FItEveryPToFGroup
	wave PToFTodoFit = root:PToF:PToFTodoFit

	wave /z corr_fact= root:diagnostics:corr_fact		//1.19
	wave mStart = root:diagnostics:mStart		//1/19E
	wave mFinish = root:diagnostics:mFinish		// for now we don't know which run we are going to use.... 		//1.11A
	wave UnitMass = root:HR_Sticks:UnitMass		// for now we don't know which run we are going to use.... 		//1.11A
	wave rn_series = root:index:rn_series

	string paramStr, paramStrOpen, paramStrClosed, OpenStr, PToFStr, TypeStr, ClosedStr, PList, param, dList
	variable idex, numPToFGrps
	
	setDataFolder root:  //1.08E

//	if ( HR_singleSpectraMSorPToF && !HR_CalcManyRunsOpenClosed)	//1.10M
//		abort " You can't not fit diff if you are also not fitting open an closed  - Aborting from HR_butt_CalcExactMassSticksTodo"
//	endif
	
	if ( !waveexists(todo)  || numpnts(todo)==0)	//^
		Abort " Either the todo wave was not found or was of zero length - Aborting from HR_butt_CalcExactMassSticksTodo"
	endif
		
	if (!waveexists(corr_fact))
		DoAlert 1, "You are attempting to generate HR sticks and thus HR stick errors, but the airbeam correction has not been calculated.  If you later gerenate an AB correction wave, these errors will be incorrect.  Proceed?"
		if (V_flag==2)
			return 0
		endif
	endif	

	if (!HR_UseOpenClosedMzParams)		//1.03E		// typo in 1.08E  should have a !
		sq_check_NansInWaveList(todo, "root:mzFitting:mz_FitIntercept;root:mzFitting:mz_FitSlope;root:mzFitting:mz_FitPower")
		paramStrClosed="MzSlope:root/mzFitting/mz_FitSlope;MzIntercept:root/mzFitting/mz_FitIntercept;MzPower:root/mzFitting/mz_FitPower;"
		paramStrOpen=paramStrClosed
	else
		sq_check_NansInWaveList(todo, "root:mzFitting:mz_FitInterceptOpen;root:mzFitting:mz_FitSlopeOpen;root:mzFitting:mz_FitPowerOpen")
		paramStrOpen="MzSlope:root/mzFitting/mz_FitSlopeOpen;MzIntercept:root/mzFitting/mz_FitInterceptOpen;MzPower:root/mzFitting/mz_FitPowerOpen;"
		if (HR_singleSpectraMSorPToF == 1 || HR_singleSpectraMSorPToF  == 2)		// MS
			sq_check_NansInWaveList(todo, "root:mzFitting:mz_FitInterceptClosed;root:mzFitting:mz_FitSlopeClosed;root:mzFitting:mz_FitPowerClosed")
			paramStrClosed="MzSlope:root/mzFitting/mz_FitSlopeClosed;MzIntercept:root/mzFitting/mz_FitInterceptClosed;MzPower:root/mzFitting/mz_FitPowerClosed;"
		else		// PToF
			paramStrClosed=paramStrOpen
		endif
	endif
	
	if (HR_singleSpectraMSorPToF==0)		// PToF
		if (FItEveryPToFGroup)
			OpenStr = stringFromLIst(0, HR_GetListOfSelPToFGroups(), "/")
			if (strlen(OpenStr)==0)
				abort "You must select at least one PToF group from the list box.  Aborting from HR_butt_CalcExactMassSticksTodo"
			endif
		else
			ControlInfo/W=HR_Analysis_Panel HRFit_popup_PToFOpen
			if (stringmatch(S_value, "Get List"))
				abort "If not fitting multiple PToF groups, you must select at a PToF group from the 'MS Open' list box in step 4.  Aborting from HR_butt_CalcExactMassSticksTodo"
			endif
			OpenStr = "PToF"+S_value
			ControlInfo/W=HR_Analysis_Panel HRFit_popup_PToFClosed
			ClosedStr = "PToF"+S_value
		endif
	endif
		
		//1.11A check added 
//	if (mFinish[currentRunIndex] < UnitMass[numpnts(UnitMass)-1] )		// we deal with PToF and Use Open params
//		abort "Some HR ions that you selected have a m/z value of "+num2str(mFinish[currentRunIndex])+", which is higher than the maximum m/z range in the raw spectra."
//	elseif (mStart[currentRunIndex] >= UnitMass[0] ) //1.19E
//		abort "Some HR ions that you selected have a m/z value of "+num2str(mStart[currentRunIndex])+", which is less than the minimum m/z range in the raw spectra."
//	endif

	if (HR_FitVerboseMode)	//^
		DoAlert 2, "You have chosen to print error messages to history when performing high resolution fits on a todo wave.  Press yes to continue, no to not print errors to history, cancel to abort"
		if (V_flag == 3)
			return 0		// user canceled
		elseif (V_flag==2)
			HR_FitVerboseMode = 0
		endif
	endif

	HR_PeakWidthSanity(0)
	HR_PeakShapeSanity(0)
	// simulate a choose masses button press to double check that the fit mask wave correctly identifies masses to fit.
	
	HR_butt_MakeExactMassWaves("")
	
	variable currentRunIndex = sq_findRun(rn_series, todo[0])  //  UnitMass[numpnts(	
	pk_VerifyMzRange(currentRunIndex)

	HR_CalculateSticksSQ_prep()
		
	if (HR_singleSpectraMSorPToF==0) // && FItEveryPToFGroup)		//1.20T
		
		wave/z allRawPToF = root:allRawPToF		
		if (!WaveExists(allRawPToF) || numpnts(allRawPToF)==0)
			wave allRawPToF = sq_makeRawPToFtodo()
		endif
		sq_create_todo("allRawPToF and "+todoStr,"RawPToFtemp")
		wave/z todo = root:RawPToFtemp		
		if (!WaveExists(allRawPToF) || numpnts(todo)==0)
			Killwaves/z root:RawPToFtemp
			abort "There are no raw PTOF spectra in this todo wave."
		endif
		currentRunIndex = sq_findRun(rn_series, todo[0])		
		string MxStr
		OpenStr = stringFromLIst(0, HR_GetListOfSelPToFGroups(), "/")
		if (strlen(OpenStr)==0)
			abort "You must select at least one PToF group from the list box.  Aborting from HR_butt_CalcExactMassSticksTodo"
		endif
		wave UnitMass = root:HR_Sticks:UnitMass
		for(idex=0;idex<itemsInList(OpenStr);idex+=1)		//1.20T
			MxStr=stringFromList(idex,OpenStr)
			wave Minfo = HR_RetrievePToFMxVals(MxStr)
			if (Minfo[%PToF_DSMaxMz] < WaveMax(UnitMass))
				DoAlert, 2,  "The maximum m/z you are attempting to fit is out of range for this PToF data set.  The maximum chosen to fit is "+num2istr(WaveMax(UnitMass))+" while the larges m/z in this data set is "+"  Press yes to change the m/z list to fit to match the max m/z in data."
				if (V_flag)
					wave/d ExactMassWave_All = root:HR:ExactMassWave_All
					wave Mask_Stick_Integration = root:HR:Mask_Stick_Integration
					variable maxpos = BinarySearch(ExactMassWave_All,Minfo[%PToF_DSMaxMz]-0.5)
					Mask_Stick_Integration[maxpos,]=0
					HR_butt_MakeExactMassWaves("")
					HR_CalculateSticksSQ_prep()
				else 
					killwaves/z Minfo
					Abort "The user chose to abort"
				endif					
			endif
		endfor
	endif

	killwaves/z Minfo
	// sanity checks are done.  Let's begin.
	print "// ** The calculation of HR sticks for todo wave "+todoStr+" began at "+date()+" "+time()+" using Pika version "+PKVERSION+" with the following settings:"
	print "// MS/PToF checkbox:  "+num2str(HR_UseOpenClosedMzParams)+ "  Use separate Open, Closed m/z params: "+num2str(HR_UseOpenClosedMzParams)+ "  Use peak shape: "+num2str(HR_UsePeakShapeVar) + "  Use fixed isotopic ratios: "+num2str(HR_UseFixedIsotopicVals)

	sq_initializeGlobalNVar("root:HR_panel:AvgTodoFlag",0)	// 1.10K
	AvgTodoFlag=0

	paramstr =""  // pk_EstimateItofMinMax(todo)

	wave/wave TimeWaves=sq_GetModifiedTimes()
	wave TimeMSOpen = TimeWaves[0]
	wave TimeMSClosed = TimeWaves[1]
	wave TimePToF = TimeWaves[2]

	if (HR_singleSpectraMSorPToF == 1)		// MS
 		sq_checkSamplingTimeVals(todo)   // 1.14F  //1.16A
		if(HR_UseOpenClosedMzParams)		// separate params for open and closed
			ValDisplay ams_sqprog value=0, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Open;intercept:mz_FitInterceptOpen;slope:mz_FitSlopeOpen;power:mz_FitPowerOpen", "MSOpenLessBaseL_p;")
			ValDisplay ams_sqprog value=30, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Closed;intercept:mz_FitInterceptClosed;slope:mz_FitSlopeClosed;power:mz_FitPowerClosed", "MSClosedLessBaseL_p;")
			ValDisplay ams_sqprog value=90, win = ams_panel
		else
			ValDisplay ams_sqprog value=0, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Open;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSOpenLessBaseL_p;")
			ValDisplay ams_sqprog value=33, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Closed;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSClosedLessBaseL_p;")
			ValDisplay ams_sqprog value=66, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Diff;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSDiffLessBaseL_p;")
			ValDisplay ams_sqprog value=90, win = ams_panel
		endif
		// no matter which m/z params we use, we want to find Open Minus Closed sticks and the counting errors		//1.06I
		squirrel_fetch(todo, PK_diffCalc, "putInMemFlag:0;dest:HROMinusCStick", "HROpenStick;HRClosedStick")		//1.04C
//		squirrel_fetch(todo, pk_TotalCountingErrors,"PreviousHRFit:0;"+ "sigma:"+num2str(error_sigma)+";noise:"+num2str(error_noise)+";UMRPeakWidthInNs:UnitSigma_temp;TotCountErrFlag:1;ExactMassWave:root:HR_Sticks:ExactMassWave;", "HROpenStick;HRClosedStick;MSSOpenBaseL_p;MSSClosedBaseL_p")		// paramStrOpen=paramStrClosed in this case	

		paramstr = ""
//		paramstr+="samptimeClosed:"+ReplaceString(":", GetWavesDataFolder(timeMSClosed,2),"/")+";"		//1.58E
//		paramstr+="samptimeOpen:"+ReplaceString(":", GetWavesDataFolder(timeMSOpen,2),"/")+";"  	//1.58E

 		pk_duplicate_FitTodoWaves("") 	//1.08Eqq  //1.15D  //1.20Y  moved to before pk_TotalCountingErrors
		pk_IndexHRResultsWavesFitTodo("") //1.08G   //1.15D

		PK_TotalCountErr_CheckFor(0)
//		squirrel_fetch(todo, pk_TotalCountingErrors,paramstr+"PreviousHRFit:0;"+ "sigma:"+num2str(error_sigma)+";noise:"+num2str(error_noise)+";UMRPeakWidthInNs:UnitSigma_temp;TotCountErrFlag:0;ExactMassWave:root:HR_Sticks:ExactMassWave;", "HRFitAreaO;HRFitAreaC;MSSOpenBaseL_p;MSSClosedBaseL_p")		// paramStrOpen=paramStrClosed in this case	
// 1.21E fix
		squirrel_fetch(todo, pk_TotalCountingErrors,"countSigErrFlag:1;"+paramstr+"PreviousHRFit:1;"+ "sigma:"+num2str(error_sigma)+";noise:"+num2str(error_noise)+";UMRPeakWidthInNs:UnitSigma_temp;TotCountErrFlag:0;ExactMassWave:root:HR_Sticks:ExactMassWave;", "HROpenStick;HRClosedStick;MSSOpenBaseL_p;MSSClosedBaseL_p")		// paramStrOpen=paramStrClosed in this case	
		killwaves/z expanded_temp, UMRColWave, UnitSigma_temp
// 		pk_duplicate_FitTodoWaves("") 	//1.08Eqq  //1.15D  1.21B
//		pk_IndexHRResultsWavesFitTodo("") //1.08G   //1.15D 1.21B
	elseif (HR_singleSpectraMSorPToF == 0)		//PToF

		ValDisplay ams_sqprog value=0, win = ams_panel
		if (FItEveryPToFGroup)		//1.14G
			wave/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag
			PList = stringFromLIst(0, HR_GetListOfSelPToFGroups(), "/")
			dList = stringFromLIst(1, HR_GetListOfSelPToFGroups(), "/")
			for(idex=0;idex<itemsInList(PList);idex+=1)
				ValDisplay ams_sqprog value =_NUM:(100*(idex/itemsInList(PList))), win = ams_panel
				PToFStr = "PToF"+StringFromList(idex, PList)
				typeStr = "type:"+selectString(PToFDataSetMatrixFlag[str2num(stringFromList(idex,dList))]>0, "PToF", "PToFM") +";"
				squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+typeStr+"PToFdataset:"+PToFStr+";intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", PToFStr)
		 		pk_duplicate_FitTodoWaves(PToFStr) 
				pk_IndexHRResultsWavesFitTodo(PToFStr)
			endfor
		else
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:PToF;PToFdataset:"+OpenStr+";intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", OpenStr)
			pk_duplicate_FitTodoWaves(OpenStr) 	//1.08E
			pk_IndexHRResultsWavesFitTodo(OpenStr) //1.08G
		endif

	elseif (HR_singleSpectraMSorPToF == 2)		// ePToFSum
// 		sq_checkSamplingTimeVals(todo)   // 1.14F  //1.16A
		if(HR_UseOpenClosedMzParams)		// separate params for open and closed
			ValDisplay ams_sqprog value=0, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:ePToFSum;intercept:mz_FitInterceptOpen;slope:mz_FitSlopeOpen;power:mz_FitPowerOpen", "MSePToFSumLessBaseL_p;")
			ValDisplay ams_sqprog value=30, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Closed;intercept:mz_FitInterceptClosed;slope:mz_FitSlopeClosed;power:mz_FitPowerClosed", "MSClosedLessBaseL_p;")
			ValDisplay ams_sqprog value=90, win = ams_panel
		else
			ValDisplay ams_sqprog value=0, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:ePToFSum;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSePToFSumLessBaseL_p;")
			ValDisplay ams_sqprog value=33, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:Closed;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSClosedLessBaseL_p;")
			ValDisplay ams_sqprog value=66, win = ams_panel
			squirrel_fetch(todo, HR_CalculateSticksSQ, paramstr+"type:ePToFSumDiff;intercept:mz_FitIntercept;slope:mz_FitSlope;power:mz_FitPower", "MSePToFSumDiffLessBaseL_p;")
			ValDisplay ams_sqprog value=90, win = ams_panel
		endif
		// no matter which m/z params we use, we want to find Open Minus Closed sticks and the counting errors		//1.06I
		squirrel_fetch(todo, pk_diffCalc, "multipleFactor:2;putInMemFlag:0;dest:HRePToFSumDiffStick", "HRePToFSumStick;HRClosedStick")		//1.04C
//		squirrel_fetch(todo, pk_TotalCountingErrors,"PreviousHRFit:0;"+ "sigma:"+num2str(error_sigma)+";noise:"+num2str(error_noise)+";UMRPeakWidthInNs:UnitSigma_temp;TotCountErrFlag:1;ExactMassWave:root:HR_Sticks:ExactMassWave;", "HRePToFSumStick;HRClosedStick;MSSePToFSumLessBaseL_p;MSSClosedBaseL_p")		// paramStrOpen=paramStrClosed in this case	
//		squirrel_fetch(todo, pk_TotalCountingErrors,"PreviousHRFit:0;"+ "sigma:"+num2str(error_sigma)+";noise:"+num2str(error_noise)+";UMRPeakWidthInNs:UnitSigma_temp;TotCountErrFlag:0;ExactMassWave:root:HR_Sticks:ExactMassWave;", "HRFitAreaO;HRFitAreaC;MSePToFSumLessBaseL_p;MSSClosedBaseL_p")		// paramStrOpen=paramStrClosed in this case	
		killwaves/z expanded_temp, UMRColWave, UnitSigma_temp
 		pk_duplicate_FitTodoWaves("") 	//1.08Eqq  //1.15D
		pk_IndexHRResultsWavesFitTodo("") //1.08G   //1.15D
	endif  //MS or PToF

	ValDisplay ams_sqprog value=100, win = ams_panel
	
	InfoOfLastTodoFits="Todo wave: "+todoStr+"\t\tNum. of HR ions: "+num2str(numpnts(root:HR_sticks:ExactMassWave_FitTodo))+"\r"
	InfoOfLastTodoFits+="Time Completed: "+Date()+" "+time()+"\r"
	InfoOfLastTodoFits+="Num. of failed fits: "+num2str(HR_numFail)+"\r"
	InfoOfLastTodoFits+="Use Peak Shape: "+num2str(HR_UsePeakShapeVar)+"\r"
	InfoOfLastTodoFits+="Constrain Isotopes: "+num2str(HR_UseFixedIsotopicVals)+" Let Peak Width Vary: "+num2str(HR_UseVaryingPeakWidth)+"\r"
	InfoOfLastTodoFits+="Use separate O,C m/z params: "+num2str(HR_UseOpenClosedMzParams)+"\r"		//+"  Set Peak Ht = 0 if neg: "+num2str(HR_IfFitNegConstrainToZero)	
	if (HR_singleSpectraMSorPToF==1)
		TypeStr= "MS "
	elseif (HR_singleSpectraMSorPToF==0)

		if (FItEveryPToFGroup)
			TypeStr= PToFStr
		else
			TypeStr= "PToF"+OpenStr
		endif
	elseif (HR_singleSpectraMSorPToF==2)
		TypeStr= "ePToF"
	endif
	InfoOfLastTodoFits+=TypeStr
 	
 	if (SaveAfterTodoFits)		//1.08E
		SaveExperiment
	endif
	
	Killwaves/z PeakHeights, PeakCenters, peakIndexWave, myTempWave,TimeWaves, root:RawPToFtemp

	HR_pop_getStickErrSet("",nan,"Get List")
//	PopupMenu HRResults_pop_ErrType, WIN =HR_Analysis_Panel , mode=1,popvalue="Get List",value= #"\"HRTotalOMinusCIonCountErr;HRCTotCountErr;HROTotCountErr;HROMinusCSigErr;HROTotSigErr;HRCTotSigErr\""

	print "// ** The calculation of HR sticks for todo wave "+todoStr+" ended at "+time()

	HR_pop_getStickDataSet("HRResults_pop_dataSet",nan,"Get List")

	if (HR_singleSpectraMSorPToF == 1)	  // for PToF user would have been required to choose 'open' and 'closed'
		sq_butt_FindRunInTodo("HRfit_butt_previousTodoRun")  // Added in 1.21D to reset pika graph, if exists
		HR_ck_oneRunOrAvg("HRFit_ck_OneRunRawSpectra",1)
		HR_butt_CalcSticksForThisRun("")
	endif
	HR_getHRwin()
End


Function/s PK_EstimateItofMinMax(todo)			//1.10M
wave todo

	wave UnitMass = root:HR_Sticks:UnitMass	
	wave numptsRawSpectra = root:diagnostics:numptsRawSpectra
	wave mz_FitSlope = root:mzFitting:mz_FitSlope	
	wave mz_FitIntercept = root:mzFitting:mz_FitIntercept	
	wave mz_FitPower = root:mzFitting:mz_FitPower	
	wave rn_series = root:index:rn_series
	
	string returnstr = ""
	variable min_cl, max_cl, firstRunPos, numRawPts
	
	firstRunPos = sq_findRun(rn_series,todo[0])
	numRawPts=numptsRawSpectra[firstRunPos]
	make/free/n=(numRawPts) tempMzAxis
	tempMzAxis = ((p - mz_FitIntercept[firstRunPos])/mz_FitSlope[firstRunPos])^(1/(mz_FitPower[firstRunPos]))

	if (mz_FitIntercept[firstRunPos]>0)		//1.14I
		tempMzAxis[0,ceil(mz_FitIntercept[firstRunPos])]=0
	 endif
	 
	Min_cl = round(WaveMin(UnitMass) )		// first in mz space
	Max_cl = round(WaveMax(UnitMass) )	
	//  we use the first point in our todo wave to estimate mz in itof space
	Min_cl = round(BinarySearch(tempMzAxis, Min_cl))	// next in itof space	
	Max_cl = round(BinarySearch(tempMzAxis, Max_cl))
	if (min_cl<0)		// first [eal tp fot os < our smallest value
		min_cl=0
	endif
	if (max_cl<0)		// the max value we want to fit is > our raw spectra range.
		max_cl = numRawPts
	endif
	//  go a tad outside our estimated region
	Min_cl = round(max( min_cl-100,0) )		
	Max_cl = round(min(max_cl+100, numptsRawSpectra[firstRunPos]-1 ) )

	returnstr += "min_cl:"+ num2str(Min_cl)+";"
	returnstr += "max_cl:"+ num2str(Max_cl)+";"
	return returnStr

End


Function HR_calcPlot_MSVsTime(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string Wave2PlotList
	Wave2PlotList = HR_calc_MSVsTime(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType) 
	if (stringmatch(specTypeInitial[0], "P"))
		variable/c thisHRPToFEdges = PToF_GetBinRanges(spectraType)	
		HR_plot_MSVsTime(Wave2PlotList, waveNameSuffix, specTypeInitial, myPlotName, HRPToFEdges=thisHRPToFEdges, HRPToF_BLsubtract=itemsInLIst(spectraType, "_")>0  )  //1.21G
	else
		HR_plot_MSVsTime(Wave2PlotList, waveNameSuffix, specTypeInitial, myPlotName) 
	endif
End


Function/c PToF_GetBinRanges(spectraType)
string spectraType

	wave/t PToFDataSetNames= root:PToF:PToFDataSetNames
	wave/i PToFDataSetStartPt= root:PToF:PToFDataSetStartPt
	wave/i PToFDataSetStopPt= root:PToF:PToFDataSetStopPt

	variable loEdge, hiEdge
	variable/c thisHRPToFEdges = 0
	
	spectraType = ReplaceString("PToF",  ReplaceString("stick", spectraType, ""), "")
	FindValue/Txop=4/Text=spectraType PToFDataSetNames
	if (V_Value>=0)
		loEdge = PToFDataSetStartPt[V_Value]
		hiEdge = PToFDataSetStopPt[V_Value]
		thisHRPToFEdges = cmplx(-loEdge, -hiEdge )
	endif

	return thisHRPToFEdges
end


// 1.06G function similar to the Squirrel MS time series button
Function/s HR_calc_MSVsTime(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$(todoStr)

	string paramStr, specList, tempStr, nonHRSpec,HRSpec, nonHRSpecDestList, HRSpecDestList
	variable idex, num, HRResultsType
	
	paramStrPartial+= "product_Type:1;"	
	
	nonHRSpecDestList=""
	HRSpecDestList=""
	// do only those not requiring more masses first
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families
	if (strlen(nonHRSpec)>0)
		paramStr=""	
	 	HR_getParamStr(paramstr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 		// slightly confusing notation. HR ions are 'species' in this context 	
		nonHRSpecDestList = ReplaceString("/", specList, "_"+specTypeInitial+"/")	
		nonHRSpecDestList = ReplaceString("/", nonHRSpecDestList, "_"+waveNameSuffix+"/")	
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+nonHRSpecDestList + ";"
		paramStr+="HRSpec_flag:0;"
		paramstr+=paramStrPartial
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+errorType)
	endif

	// do HRSpecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR spec it can look like   CombineAtEnd:HRTotal;HRNO3/HRNH4/
	if (strlen(HRSpec)>0)
		 	
	 	paramStr=""
	 	HR_getParamStr(paramstr,HRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
		HRSpecDestList = ReplaceString("/", specList, "_"+specTypeInitial+"/")	
		HRSpecDestList = ReplaceString("/", HRSpecDestList, "_"+waveNameSuffix+"/")	
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+HRSpecDestList + ";"	
		paramStr+="HRSpec_flag:1;"
		paramstr+=paramStrPartial
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)

	endif

	return replaceString("/", nonHRSpecDestList+ HRSpecDestList, ";")		// merge the two lists 

End


Function HR_plot_MSVsTime(Wave2PlotList, waveNameSuffix, specTypeInitial, NewPlotName, [HRPToFEdges,HRPToF_BLsubtract ]) 		//1.19E
string Wave2PlotList, waveNameSuffix, specTypeInitial, NewPlotName
variable/c HRPToFEdges
variable HRPToF_BLsubtract

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors

	nvar dontColorTraces = root:panel:dontColorTraces
	string labelAxis, destStr, t_base, paritalLabel
	variable idex, num //, HRPToF_BLsubtract
	
	if (stringmatch(specTypeInitial[0], "P"))		// MS
		HRPToFEdges = cmplx(round(real(HRPToFEdges)),round(imag(HRPToFEdges)) )
		if (real(HRPToFEdges) < 0 || imag(HRPToFEdges) )  // use bin numbers
			paritalLabel = "DAQ Bins "+num2str(-real(HRPToFEdges)) + "-"+num2str(-imag(HRPToFEdges))
		else
			paritalLabel = "DVa, nm ~ "+num2str(real(HRPToFEdges)) + "-"+num2str(imag(HRPToFEdges))
		endif
//		HRPToF_BLsubtract = strsearch(specTypeInitial, "L", 0)>0
		HRPToF_BLsubtract = strsearch(specTypeInitial, "_", 0)>0  //1.21G
		
		if(HRPToF_BLsubtract)		// is a PToF data set that has been subtracted
			labelAxis=paritalLabel+SelectString(HR_checkConvertTougm3, "signal, Hz", "g/m3")
		else
			labelAxis=paritalLabel+" without PToF DC subtraction," +SelectString(!HR_checkConvertTougm3, "signal, Hz" , "g/m3")
		endif
	else	
		labelAxis=SelectString(HR_checkConvertTougm3 , "signal, Hz", "g/m3")	
	endif		

	t_base=sq_tbase()	// we calc again... not ideal... it was calced once already in the HR_MS_concentration function

	num = itemsinlist(Wave2PlotList)
	if(HRResults_graphOutputType!=4)

		// get the x axis wave
		if(strlen(t_base)>0)
			wave x_wave=$("root:"+t_base)
		else
			wave x_wave=root:index:t_series
		endif

		// bring graph to front (for multiple graphs do nothing for now)
		if (HRResults_graphOutputType==3)
			DoWindow/F $NewPlotName
		endif

		for(idex=0;idex<num;idex+=1)
			destStr = stringfromlist(idex,Wave2PlotList,";")
			wave specitem=$("root:"+destStr)
			if((HRResults_graphOutputType==1 && idex==0) || HRResults_graphOutputType==2)
				NewPlotName = "TseriesHRGr_"+destStr[0,min(15, strlen(destStr)-1)]
				DoWindow/K $NewPlotName
				display/N=$NewPlotName as NewPlotName
			endif
			appendtograph/W=$NewPlotName specitem vs x_wave
			if (HR_checkCalcHRErrors)
				wave erritem=$("root:"+destStr+"_err")
				ErrorBars/W=$NewPlotName $NameofWave(specitem) Y,wave=(erritem,erritem)
			endif
			if (HRResults_graphOutputType==2)
				Label left LabelAxis
			endif
		endfor		

		if (!dontColorTraces)
		 	kbcolorizetraces(.5,1,0)			// 6.03 fix
		endif
		
		if (HRResults_graphOutputType==1)		//1.19E	// graph already exists?
			Legend/C/W=$NewPlotName/N=sqLegend
			Label left LabelAxis
		endif
		
		Pk_graphTweaks()

	endif	// mess with graph 

End

//1.22A
Function/s PK_sumToUMR(specList, SpecDestList, specTypeInitial, waveNameSuffix, errorType)
string specList, SpecDestList, specTypeInitial, waveNameSuffix,errorType

	string tempStr
	variable idex, 	num = itemsInList(specList, "/")
	for(idex = 0;idex< num;idex+=1)
		tempStr = stringFromList(idex, specList, "/")
		wave ExactStickWave = $stringFromList(idex, SpecDestList, "/")
		make/o/n=0	$("root:UMR"+specTypeInitial+ "_"+waveNameSuffix+"_"+tempStr)/WAVE=resultWave// will be resized in UM_SumHRtoUMR
		UM_SumHRtoUMR(ExactStickWave,resultWave, 1)		
		if (strlen(errorType)>0)
			wave ErrWave = $stringFromList(idex, SpecDestList, "/")+"_err"		//i.e. MSSD_familyNH
			make/o/n=0	$("root:UMR"+SpecTypeInitial+ "_"+waveNameSuffix+"_"+tempStr+"_err")/wave=resultErrWave// will be resized in UM_SumHRtoUMR					
			UM_SumHRtoUMR(ErrWave,resultErrWave,1)		
		endif
		SpecDestList = RemoveFromList(nameofWave(ExactStickWave), SpecDestList, "/")
		SpecDestList = AddListItem("UMR"+SpecTypeInitial+ "_"+waveNameSuffix+"_"+tempStr, SpecDestList,"/", idex)
	endfor	
	return SpecDestList
end


Function HR_calcPlot_MSAvg(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string tempStr
	tempStr = HR_Calc_MSAvg(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType) 
	HR_plot_MSAvg(stringFromList(0, tempStr, ";"), stringFromList(1, tempStr, ";"), specTypeInitial, myPlotName, waveNameSuffix)

End


// 1.04J button function similar to the Squirrel MS spectra average button
Function/s HR_calc_MSAvg(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$(todoStr)
	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra

	string paramStr, specList, tempStr, nonHRSpec, HRSpec, nonHRSpecDestList, HRSpecDestList, timeWt
	variable idex, num
		
	paramStr=""	
	paramStrPartial+= "product_Type:2;"

	nonHRSpecDestList=""
	HRSpecDestList=""

	if (strlen(HRResults_ionList)==0)		//1.07C
		HRResults_ionList="all"		
	endif
		
	// Non HR Species First
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families
	if (strlen(nonHRSpec)>0)
 		paramStr=""
	 	HR_getParamStr(paramstr,nonHRSpec, 1, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
//		sq_dataDestStr(nonHRSpecDestList,prefix,"av_"+waveNameSuffix,nonHRSpec,0)
		nonHRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_")
		nonHRSpecDestList = RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",nonHRSpecDestList, "/") 	
		nonHRSpecDestList = ReplaceString("family", nonHRSpecDestList, "fam")	

		paramStr+=paramStrPartial+"HRSpec_flag:0;"
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+nonHRSpecDestList + ";"	
		
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)
		if (HR_checkAvgHRMS_UMR)		// we need to sum to unit mass
			nonHRSpecDestList =  PK_sumToUMR(specList, nonHRSpecDestList, specTypeInitial, waveNameSuffix, errorType)  //1.22A			
//			num = itemsInList(specList, "/")
//			for(idex = 0;idex< num;idex+=1)
//				tempStr = stringFromList(idex, specList, "/")
//				wave ExactStickWave = $stringFromList(idex, nonHRSpecDestList, "/")		//i.e. MSSD_familyNH
//				make/o/n=0	$("root:UMR"+SpecTypeInitial+"_"+waveNameSuffix+"_"+tempStr)/Wave=resultWave// will be resized in UM_SumHRtoUMR
//				UM_SumHRtoUMR(ExactStickWave,resultWave,0)		
//				if (strlen(errorType)>0)
//					wave ErrWave = $stringFromList(idex, nonHRSpecDestList, "/")+"_err"		//i.e. MSSD_familyNH
//					make/o/n=0	$("root:UMR"+SpecTypeInitial+ "_"+waveNameSuffix+"_"+tempStr+"_err")/Wave=resultErrWave// will be resized in UM_SumHRtoUMR
//					UM_SumHRtoUMR(ErrWave,resultErrWave, 0)		
//				endif
//				nonHRSpecDestList = RemoveFromList(nameofWave(ExactStickWave), nonHRSpecDestList, "/")
//				nonHRSpecDestList = AddListItem("UMR"+SpecTypeInitial+ "_"+waveNameSuffix+"_"+tempStr, nonHRSpecDestList,"/", idex)
//			endfor	
		endif
	endif

	// do HRSpecs 
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families
	if (strlen(HRSpec)>0)
	 	paramstr=""
	 	HR_getParamStr(paramstr,HRSpec, 1, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
		HRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_" +waveNameSuffix+"_")
		HRSpecDestList =  RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",HRSpecDestList, "/") 	

		paramStr+=paramStrPartial+"HRSpec_flag:1;"
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+HRSpecDestList + ";"	

		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)
//		wave SpeciesMassWave = root:HR_Frag:SpeciesMassWave		
		if (HR_checkAvgHRMS_UMR)		// we need to sum to unit mass
			HRSpecDestList = PK_sumToUMR(specList, HRSpecDestList, specTypeInitial, waveNameSuffix, errorType)  //1.22A
		endif
	endif

	if (NormalizeSpectra)
		if (ItemsInList(nonHRSpecDestList)==0)
			sq_NormalizeSpectra(ReplaceString("/", HRSpecDestList, ";"))		//1.13C
		else
			sq_NormalizeSpectra(ReplaceString("/", nonHRSpecDestList+ ";"+HRSpecDestList, ";"))
		endif
	endif

	return nonHRSpecDestList+ ";"+HRSpecDestList		// do NOT merge the two lists 

End


Function HR_plot_MSAvg(destListnonHRSpec, destListHRSpec, specTypeInitial, NewPlotName, waveNameSuffix)
string destListnonHRSpec, destListHRSpec, specTypeInitial, NewPlotName, waveNameSuffix

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
//	nvar HR_checkStackSticks=root:HR_panel:HR_checkStackSticks
	nvar HR_checkCalcHRErrors=root:HR_panel:HR_checkCalcHRErrors
	nvar NormalizeSpectra = root:HR_panel:NormalizeSpectra
	wave/z amu_HR = root:HR_Sticks:amu_HR			//1.08C
	wave/z SpeciesMassWave = root:HR_frag:SpeciesMassWave
	wave/z ExactMassWave_FitTodo = root:HR_Sticks:ExactMassWave_FitTodo
	if (!WaveExists(ExactMassWave_FitTodo))		// for the case of someone upgrading who has not yet done a fit for a todo wave
		wave ExactMassWave_FitTodo=root:HR_Sticks:ExactMassWave // 1.08E replaced with *_FitTodo
	endif

	variable idex, numHR, numNonHR

	destListnonHRSpec = replacestring("/", destListnonHRSpec, ";")
	destListHRSpec = replacestring("/", destListHRSpec, ";")
		
	if(HRResults_graphOutputType!=4)

		// bring graph to front (for multiple graphs do nothing for now)
		if (HRResults_graphOutputType==3)
			DoWindow/F $NewPlotName
		endif

		numNonHR = ItemsInList(destListnonHRSpec)

		for(idex=0;idex<numNonHR;idex+=1)
			wave specitem=$stringFromList(idex, destListnonHRSpec, ";")
			if((HRResults_graphOutputType==1 && idex==0) || HRResults_graphOutputType==2)
				display/N=$NewPlotName as NewPlotName
			endif
			if (HR_checkAvgHRMS_UMR)
				duplicate/o amu_HR $"root:amu_HR_"+waveNameSuffix/wave=AMUHR		
				appendtograph/W=$NewPlotName specitem vs AMUHR
			else
				duplicate/o ExactMassWave_FitTodo $"root:ExactMassWave_"+waveNameSuffix/wave=ExactMassWave		
				appendtograph/W=$NewPlotName specitem vs ExactMassWave
			endif
			ModifyGraph/W=$NewPlotName mode($NameofWave(specitem))=1
			ModifyGraph/W=$NewPlotName toMode($NameofWave(specitem))=HR_checkAvgHRMS_UMR*3
			if(HR_checkCalcHRErrors)
				wave specitemErr = $nameofWave(specitem)+"_err"
				ErrorBars/w=$NewPlotName $nameofWave(specitem) Y,wave=($nameofWave(specitemErr),$nameofWave(specitemErr))
			endif			
		endfor
		
		numHR = ItemsInList(destListHRSpec)
		for(idex=0;idex<numHR;idex+=1)
			wave specitem=$stringFromList(idex, destListHRSpec, ";")
			if((HRResults_graphOutputType==1 && idex==0 && numNonHR==0) || HRResults_graphOutputType==2)
				display/N=$NewPlotName as NewPlotName
			endif
			if (HR_checkAvgHRMS_UMR)
				duplicate/o amu_HR $"root:amu_HR_"+waveNameSuffix/wave=AMUHR		
				appendtograph/W=$NewPlotName specitem vs AMUHR
			else
				duplicate/o SpeciesMassWave $"root:SpeciesMassWave_"+waveNameSuffix/wave=SpeciesMassWave		
				appendtograph/W=$NewPlotName specitem vs SpeciesMassWave
			endif
			ModifyGraph/W=$NewPlotName mode($NameofWave(specitem))=1
			ModifyGraph/W=$NewPlotName toMode($NameofWave(specitem))=HR_checkAvgHRMS_UMR*3
			if(HR_checkCalcHRErrors)
				wave specitemErr = $nameofWave(specitem)+"_err"
				ErrorBars/w=$NewPlotName $nameofWave(specitem) Y,wave=($nameofWave(specitemErr),$nameofWave(specitemErr))
			endif
		endfor

		label/W=$NewPlotName bottom "m/z"
		if (HR_checkConvertTougm3)
			if (NormalizeSpectra)			//1.13C
				label/W=$NewPlotName left "Normalized spectra"
			else
				label/W=$NewPlotName left "Nitrate equivalent mass g/m3 *"
			endif
		else
			if (NormalizeSpectra)
				label/W=$NewPlotName left "Normalized spectra"
			else
				label/W=$NewPlotName left "Ion rate, Hz"
			endif
		endif
		
		Pk_graphTweaks()

	endif
	
End


//1.11D2
Function HR_calc_TSeriesMSMatricies(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,errorType)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar todoStr=root:panel:sq_toDoWvNm
	nvar CreateItxForPMF=root:HR_panel:CreateItxForPMF
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	nvar/z HR_removeIsotopes=root:HR_panel:HR_removeIsotopes
	nvar HR_checkcalcHRErrors=root:HR_panel:HR_checkcalcHRErrors

	nvar ams_time_saved=root:panel:ams_time_saved
	nvar ms0_ion2mass=root:panel:ms0_ion2mass
//	nvar ms0_corr=root:panel:ms0_corr   //1.14E

	if (!NVar_exists(HR_removeIsotopes))		//1.11D
		variable/g root:HR_panel:HR_removeIsotopes=0
		nvar/z HR_removeIsotopes=root:HR_panel:HR_removeIsotopes
		ControlInfo/W=HR_Analysis_Panel HRResults_RemoveIsotopes
		HR_removeIsotopes=V_flag
	endif

	wave/z todo=$(todoStr)

	string paramStr, specList, destList, tempStr, nonHRSpec, HRSpec, timeWt, MinIonStr, SpecStr, destStr, nonSpecParamStr, tempStr2, SpecParamStr, tempStr1, outputList, fname
	variable idex, num, numSpec, jdex, KillFlag=0, AutoName=0
	
	if (strlen(HRResults_ionList)==0)
		HRResults_ionList="all"
	endif
	
	fname="HRPMFInput.itx"
	if (CreateItxForPMF)
		ControlInfo/W=HR_Analysis_Panel HRResults2_killMx
		KillFlag = V_value
		ControlInfo/W=HR_Analysis_Panel HRResults2_autoname
		AutoName = V_value
		if (AutoName)
			fname = IgorInfo(1)+".itx"
		endif
	endif
	
	paramstr=""
	tempStr=""
	nonSpecParamStr=""
	SpecParamStr=""
	if (CreateItxForPMF)
//		HRResults_ionList= "HROrg"
		if (strlen(errorType) == 0)
			abort "The user has selected the Create itx of all PMF HROrg waves checkbox but the error option has not been selected. - aborting from HR_calc_TSeriesMSMatricies"
		endif
	endif
	
	paramStrPartial+= "product_Type:3;"		// 1.08C fix

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
		paramStr=""
	 	HR_getParamStr(paramstr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
		destList ="HRMx" +specTypeInitial+"_"+ReplaceString("/", specList, "/HRMx" +specTypeInitial+"_" )
		destList =  RemoveFromList("HRMx" +specTypeInitial+"_",destList, "/") 	

		paramStr+="HRSpec_flag:0;"
		paramstr += "specList:"+specList + ";"
		paramstr += "destList:"+destList+";"	
		paramstr += paramStrPartial	
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)
		num = itemsInList(specList, "/")
		nonSpecParamStr=paramStr
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
		paramStr=""
	 	HR_getParamStr(paramstr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", paramstr) 	 	
		destList ="HRMx" +specTypeInitial+"_"+ReplaceString("/", specList, "/HRMx" +specTypeInitial+"_" )	
		destList =  RemoveFromList("HRMx" +specTypeInitial+"_",destList, "/") 	

		paramStr += "HRSpec_flag:1;"
		paramstr += "specList:"+specList + ";"
		paramstr += "destList:"+destList+";"		
		paramStr += paramStrPartial
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)
		num = itemsInList(specList, "/")
		SpecParamStr=paramStr
	else
		paramStr=""		//  1.12H
	endif

	numSpec=ItemsINList(StringByKey("specList", paramstr) ,"/") +ItemsInList(StringByKey("specList", nonSpecParamStr), "/")
	destList=StringByKey("destList", paramstr)+StringByKey("destList", nonSpecParamStr)
	specList=StringByKey("specList", paramstr)+StringByKey("destList", nonSpecParamStr)
	
	if (strlen(HRSpec)>0)
		wave/t ExactMassText = root:HR_frag:SpeciesMassText
		wave ExactMassWave= root:HR_frag:SpeciesMassWave		//1.14E
	elseif(strlen(nonHRSpec)==0)			//1.21D
		abort "There is neither an HR Species nor a family chosen.  Did you want to simply generate a time series?  Aborting from HR_calc_TSeriesMSMatricies"   		// non family
	else
		for(idex=0;idex<ItemsInList(nonHRSpec);idex+=1)
			tempStr1 = stringFromList(idex, nonHRSpec, ",")  //1.91E 
			if (!(stringMatch(tempStr1[0,5], "family") || stringMatch(tempStr1, "all")) )
				abort "There is neither an HR Species nor a family chosen.  Did you want to simply generate a time series?  Aborting from HR_calc_TSeriesMSMatricies"   		// non family
			endif
		endfor
		wave/t ExactMassText = root:HR_sticks:ExactMassText_fitTodo
		wave ExactMassWave= root:HR_sticks:ExactMassWave_fitTodo  	//1.14E
	endif
	duplicate/o ExactMassText HRMx_ExactMassText
	duplicate/o ExactMassWave HRMx_ExactMassWave

	if (HR_removeIsotopes)		// depends on whether or not we have species or not

		sq_SetIsIsotopeWeighting(ExactMassText)		// creates root:HR_stick:isIsotopeFlag.. .should have place holders for species if needed
		wave isIsotopeFlag=root:HR_frag:isIsotopeFlag
		num=numpnts(isIsotopeFlag)
		for(jdex=num-1;jdex>=0;jdex-=1)	// go backwards
			if (numtype(isIsotopeFlag[jdex])==0)		// this is an isotope
				DeletePoints/M=0 jdex, 1,HRMx_ExactMassText,HRMx_ExactMassWave 		// ROWS
				for(idex=0;idex<numSpec;idex+=1)
					wave resultWave = $"root:"+stringFromList(idex, 	destList, "/")	
					DeletePoints/M=1 jdex, 1, resultWave		// COLUMNS
					if (HR_checkcalcHRErrors)
						wave resultWaveErr = $"root:"+stringFromList(idex, 	destList, "/")+"_err"
						DeletePoints/M=1 jdex, 1, resultWaveErr		// COLUMNS
					endif
				endfor
			endif	
		endfor
	endif

//	if (strlen(HRSpec)>0)
//		wave/t textwave = $"root:HR_frag:SpeciesMassText"
//	else
//		wave/t textwave = HRMx_ExactMassText
//	endif
	
	gen_setDimLabelFromTextwave(1, resultWave, HRMx_ExactMassText)		//1.20E
	if (HR_checkcalcHRErrors)
		gen_setDimLabelFromTextwave(1, resultWaveErr, HRMx_ExactMassText)		//1.20E
	endif
		
	// new in 1.09F
	if (CreateItxForPMF)		// change in 1.10Q from requiring HROrg to be multiple species.
	// Will need to be changed for ePToFSum
		wave/wave TimeWaves=sq_GetModifiedTimes()
		wave TimeMSOpen = TimeWaves[0]
		wave TimeMSClosed = TimeWaves[1]
		wave TimePToF = TimeWaves[2]
		MinIonStr = Err_minErr1ion(HR_checkConvertTougm3, TimeMSOpen)		// recreate every time.  // in SQ_MSconc_1.50L
		// deal with non 'as saved' time base
		if (ams_time_saved)	
			outputList = "root:index:t_series;root:index:rn_series;root:minErr1ion;"
		else
			wave t_base=$"root:"+sq_tbase()
			sq_sumOrAvgOverTbase(t_base, timeMSopen, "TimeMSOpen_xmin", 1)		// overwrite minErr1ion!
			wave TimeMSOpen_xmin = root:TimeMSOpen_xmin
			make/O/N=(numpnts(t_base)) minErr1ion = 1/TimeMSOpen_xmin	
	
			if(ms0_ion2mass == 1)		
				wave/Z ioneff = root:diagnostics:ioneff
				wave/Z flowrate = root:diagnostics:flowrate
				wave/Z corr_fact = root:diagnostics:corr_fact	
				if (!WaveExists(ioneff))
					wave/Z ioneff = root:diagnostics:ioneff_logged
				endif
				make/o/n=(numpnts(timeMSopen)) ugfac_wav_tmp
				ugfac_wav_tmp=(PMF_AW_NO3/PMF_AVOGADRO)*1e12/(ioneff[p]*flowrate[p])     // presumes ioneff exists; you did the AB corrections
				if(HR_checkConvertTougm3)  // 1.14E  typo   .. ms0_corr
					ugfac_wav_tmp*=corr_fact[p]      // if you want to fold in the Airbeam correction factor
				endif	
				sq_sumOrAvgOverTbase(t_base, ugfac_wav_tmp, "ugfac_wav_xmin", 0)	
				wave ugfac_wav_xmin = root:ugfac_wav_xmin
				minErr1ion *= ugfac_wav_xmin	
				killwaves/z 	ugfac_wav_xmin, TimeMSOpen_xmin, ugfac_wav_tmp
			endif
			duplicate/o t_base $"root:"+NameofWave(t_base)+"x"/wave=NewTimeWave  // we need for this to be one point smaller so folks won't get confused when inputting into pmf		
			deletepoints 0,1, NewTimeWave, minErr1ion			// we keep data as end of measurement
			outputList = "root:"+NameOfWave(NewTimeWave)+";root:minErr1ion;"

		endif
		
		tempStr=""
		for(idex=0;idex<numSpec;idex+=1)
			destStr = stringFromList(idex, destList, "/")     // "HRMx" +specTypeInitial+"_"+ReplaceString("/", specList, "/HRMx" +specTypeInitial+"_" )	
			specStr = stringFromList(idex, specList, "/")  
			wave data=$"root:"+destStr
			wave err=$"root:"+destStr+"_err"

			// In preparation for Ingrid's panel, we want very short matrix names
			wave/z HRMxSpec= $"root:HR"+ReplaceString("HR", specStr, "")  // we don't duplicate/o in case it exists... we may have too many big waves in the experiment
			if (WaveExists(HRMxSpec))
				redimension/n=(dimsize(data,0), dimsize(data,1)) HRMxSpec
				fastop HRMxSpec=data		
			else
				rename data $"HR"+ReplaceString("HR", specStr, "")
			endif
			wave/z HRMxSpecErr = $"root:HR"+ReplaceString("HR", specStr, "")+"Err" // we don't duplicate/o in case it exists... we may have too many big waves in the experiment
			if (WaveExists(HRMxSpecErr))
				redimension/n=(dimsize(err,0), dimsize(err,1)) HRMxSpecErr
				fastop HRMxSpecErr=err		
			else
				rename err $"HR"+ReplaceString("HR", specStr, "")+"Err"
			endif
						
			tempStr+="root:HR"+ReplaceString("HR", specStr, "")	+";root:HR"+ReplaceString("HR", specStr, "")+"Err"	+";"
		
		endfor
 		tempStr1 =selectString(strlen(HRSpec)>0, "root:HR_frag:ExactMassText;root:HR_frag:ExactMassWave;", "root:HR_frag:SpeciesMassText;root:HR_frag:SpeciesMassWave;")
		tempStr2 =selectString(HR_removeIsotopes, tempStr1,  "root:HRMx_ExactMassWave;HRMx_ExactMassText;")		//1.11D1 fix  
//		tempStr2 =selectString(HR_removeIsotopes, "root:SpeciesWaveTextNoIso;SpeciesMassWavetNoIso", "root:HR_frag:SpeciesMassText;root:HR_frag:SpeciesMassWave;")

		tempStr+= tempStr2+outputList
		
		Save/B/T tempStr AS fname //"HRPMFInput.itx"  //1.54C  1.21D
		
		NewDataFolder/o root:PMFOutput
		string str
		for(idex=0;idex<ItemsInList(tempStr);idex+=1)		// we DO NOT wave to move t_series
			wave w = $StringFromList(idex, tempStr)
			str = NameofWave(w)
			if (stringMatch(str,  "t_series"))
				duplicate/o w, $"root:PMFOutput:t_series"
				continue
			endif
			if (stringMatch(str,  "rn_series"))
				duplicate/o w, $"root:PMFOutput:rn_series"
				continue
			endif
			if (Exists("root:PMFOutput:"+str))
				wave Wold = $"root:PMFOutput:"+str
				duplicate/o w, $"root:PMFOutput:"+str

			else
				MoveWave w, root:PMFOutput:
			endif			
		endfor
		
//		Print "// The list of matricies "+tempStr+" were created or overwritten and placed in the root folder; no graphs were created." 		
	endif
		
	Print "// The list of matricies "+ReplaceString("/", destList, ", "  ) +" with a prefix of HRMx_ were created and placed in the root:PMFOutput folder; no graphs were created.  See waves HRMx_ExactMassWave and HRMx_ExactMassText."
	killwaves/z TimeWaves
	if (KillFlag)
		Killwaves/z root:ExactMassTextNoIso, ExactMassWaveNoIso
		destList = ReplaceString("/", destList, ";")
		sq_KillWavesInList(destList)
	endif
End


Function HR_calcPlot_5PanelSummary(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string destList = HR_Calc_5PanelSummary(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
	HR_Plot_5PanelSummary(waveNameSuffix, myPlotName, spectraType, specTypeInitial, destList)

End


// Does the HR average and displays Doug's 5 panel graph 
Function/s HR_calc_5PanelSummary(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$(todoStr)
	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra

	string  destList, paramStr, tempStr, errList, tempList		// 1.08E added tempList variable
	variable idex, num	
	
	 // IN Doug's graph only these families are used.
	num = ItemsInList(DOUG5GRAPH_MAINFAMLIST, "/")
	
	destList=replaceString("/", DOUG5GRAPH_MAINFAMLIST, "_"+specTypeInitial+"_temp/")
		
	paramStr =""
	paramStr+="product_Type:2;"	// average mass spec
	paramstr+="specList:"+DOUG5GRAPH_MAINFAMLIST + ";"
	paramstr+="destList:"+destList + ";"
	paramstr+=paramStrPartial

	squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+errorType)
	
	if (HR_checkAvgHRMS_UMR)		// we need to sum to unit mass
		// for each family in 5graph summary
		for(idex = 0;idex< num;idex+=1)
			tempStr = stringFromList(idex, DOUG5GRAPH_MAINFAMLIST, "/")
			wave ExactStickWave = $stringFromList(idex, destList, "/")
			make/o/n=0	$("root:UMR"+SpecTypeInitial+"_"+tempStr+ "_"+waveNameSuffix)  // will be resized in UM_SumHRtoUMR
			wave resultWave = $("root:UMR"+SpecTypeInitial+"_"+tempStr+ "_"+waveNameSuffix)
			UM_SumHRtoUMR(ExactStickWave,resultWave,0)		
			if (strlen(errorType)>0)
				wave ErrWave = $stringFromList(idex, destList, "/")+"_err"		//i.e. MSSD_familyNH
				make/o/n=0	$("root:UMR"+SpecTypeInitial+"_"+tempStr+ "_"+waveNameSuffix+"_err")// will be resized in UM_SumHRtoUMR
				wave resultWave = $("root:UMR"+SpecTypeInitial+"_"+tempStr+ "_"+waveNameSuffix+"_err") //i.e. MSSD_familyNH
				UM_SumHRtoUMR(ErrWave,resultWave, 0)		
				killwaves/z ErrWave
			endif
			destList = RemoveFromList(nameofWave(ExactStickWave), destList, "/")
			destList = AddListItem("UMR"+SpecTypeInitial+"_"+tempStr+ "_"+waveNameSuffix, destList,"/", idex)
			killwaves/z ExactStickWave
		endfor	
	else 	//1.08E rename non UMR waves from the _temp suffix to the todo wave
		TempList=""
		for(idex = 0;idex< num;idex+=1)
			tempStr = stringFromList(idex, destList, "/")
			wave ExactStickWave = $tempStr
			tempStr= CleanUpName(replaceString("_temp", tempStr, "_"+todoStr),0)
			duplicate/o ExactStickWave $tempStr
			killwaves/z ExactStickWave
			TempList+=tempStr+"/"
			if (strlen(errorType)>0)
				tempStr = stringFromList(idex, destList, "/")+"_err"	
				wave ErrWave = $tempStr		//i.e. MSSD_familyNH
				tempStr= CleanUpName(replaceString("_temp", tempStr, "_"+todoStr),0)
				duplicate/o ErrWave $tempStr
				killwaves/z ErrWave
			endif
		endfor
		destList = TempList	
		// end 1.08E addition
	endif
	
	if (NormalizeSpectra)
		sq_NormalizeSpectra(destList, delimiter="/")
	endif

	return destList
	
End


Function HR_plot_5PanelSummary(waveNameSuffix, graphName, spectraType, specTypeInitial, destList)
string waveNameSuffix, graphName, spectraType, specTypeInitial, destList

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar NormalizeSpectra = root:HR_panel:NormalizeSpectra
	wave t_series=root:index:t_series
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B
	wave/t HR_familyName = root:HR:HR_familyName

	string destStr, specList, familyStr, axisStr, legendStr, moreText, axisStrOld, colorStr, labelStr //1.09E change axis label
	variable idex, num, pos, tempVar, total
		
	if (HR_checkAvgHRMS_UMR)
		wave xwave = root:HR_Sticks:amu_HR
	else
		wave/z xwave = root:HR_Sticks:ExactMassWave_FitTodo		//1.08E
		if (!WaveExists(xwave))		// for the case of someone upgrading who has not yet done a fit for a todo wave
			wave xwave=root:HR_Sticks:ExactMassWave // 1.08E replaced with *_FitTodo
		endif
	endif

	num = ItemsInList(DOUG5GRAPH_MAINFAMLIST, "/")	
	axisStr=""
	axisStrOld=""
	legendStr=""
	total=0
	
	if(HRResults_graphOutputType==1)

		Display/W=(5, 50, 550,400)/N=$graphName as graphName
		tempVar=1
		for(idex=0;idex<num;idex+=1)
			familyStr = replaceString("family", stringfromList(idex, DOUG5GRAPH_MAINFAMLIST, "/"),"")
			pos = sq_findStr(HR_familyName, familyStr,1)
			colorStr = "("+num2str(HR_family_R[pos])+","+num2str(HR_family_G[pos])+","+num2str(HR_family_B[pos])+")"
			wave familyWave = $stringfromList(idex, destList, "/")
			axisStr = stringfromList(idex, DOUG5GRAPH_MAINFAMAXISLIST, "/")
			labelStr = stringfromList(idex, DOUG5GRAPH_HRSPECLABELLIST, "/")
			AppendToGraph/w=$graphName/L=$axisStr familyWave vs xwave
			ModifyGraph/w=$graphName freePos($axisStr)={0,bottom}
			Label/w=$graphName $axisStr "\\K"+colorStr+labelStr
			ModifyGraph/w=$graphName lblPos( $axisStr)=100
			ModifyGraph/w=$graphName grid($axisStr)=2
			if(HR_checkCalcHRErrors)
				wave familyWaveErr = $nameofWave(familyWave)+"_err"
				ErrorBars/w=$graphName $nameofWave(familyWave) Y,wave=($nameofWave(familyWaveErr),$nameofWave(familyWaveErr))
			endif
			if (!stringmatch(axisStr, axisStrOld))
				ModifyGraph/w=$graphName axisEnab($axisStr)={tempVar-.18,tempVar}
				tempVar-=.2
			endif
			axisStrOld = axisStr
			Wavestats/q/m=1 familyWave
			sprintf moreText,  "\\K"+colorStr+familyStr +"    %.3f\r", V_avg*V_npnts		// use 3 places after digit  1.09E
			total+=V_avg*V_npnts
			legendStr+=moreText
		endfor
		ModifyGraph/w=$graphName grid(bottom)=2, nticks(bottom)=9, minor(bottom)=1, axisEnab(bottom)={0.1,1}
		ModifyGraph/w=$graphName gridRGB=(34816,34816,34816)
		SetAxis/w=$graphName/A/E=0
		ModifyGraph/w=$graphName mode=1,lsize=2,toMode=3
		Label/w=$graphName bottom "m/z"
		
		legendStr = "normalized? "+selectstring(NormalizeSpectra, "N", "Y")+"\r"+legendStr
		legendStr = "total "+num2str(total)+"\r"+legendStr
		legendStr = selectString(HR_checkConvertTougm3, "Ion rate (Hz)", "NO3 equiv. mass, (ug/m3)")+"\r"+legendStr
		TextBox/w=$graphName/C/N=text0/A=RT legendStr[0, strlen(legendStr)-2]		// remove last carriage return
	
		pk_ColorizeByFamily()
		ShowInfo
			
		Pk_graphTweaks()	

	elseif(HRResults_graphOutputType==4)
	
		for(idex=0;idex<num;idex+=1)
			familyStr = replaceString("family", stringfromList(idex, DOUG5GRAPH_MAINFAMLIST, "/"),"")
			pos = sq_findStr(HR_familyName, familyStr,1)
			colorStr = "("+num2str(HR_family_R[pos])+","+num2str(HR_family_G[pos])+","+num2str(HR_family_B[pos])+")"
			wave familyWave = $stringfromList(idex, destList, "/")
			Wavestats/q/m=1 familyWave
			sprintf moreText,  "\\K"+colorStr+familyStr +"    %.2f\r", V_avg*V_npnts
			total+=V_avg*V_npnts
			legendStr+=moreText
		endfor

		legendStr = "normalized? "+selectstring(NormalizeSpectra, "N", "Y")+"\r"+legendStr
		legendStr = "total "+num2str(total)+"\r"+legendStr
		legendStr = selectString(HR_checkConvertTougm3, "Ion rate (Hz)", "NO3 equiv. mass (ug/m3)")+"\r"+legendStr
		TextBox/w=$graphName/C/N=text0/A=RT legendStr[0, strlen(legendStr)-3]
	
	endif	

End


// Returns 2 strings: the first is a list of acceptable HR specis, the second a list of not found species
// sample usage HR_plotMassesVsTime_prep("C2H3O, familyCH, famblyCHO") returns goodSpecies:C2H3O,familyCH,; badSpecies:famblyCHO,
Function/S HR_SpeciesList_prep(HRList)
string HRList

	wave/t ExactMassText = root:HR_sticks:ExactMassText
	wave/t HR_familyName = root:HR:HR_familyName
	
	wave/z/t HR_spec_list=root:HR_frag:HR_spec_list
	wave/z/t HR_specname_list=root:HR_frag:HR_specname_list

	variable massPt, idex, num 
	string massStr, massNotFoundStr="", massToPlot=""
	string speciesFamilyList, tempStr
	
	speciesFamilyList = sq_textwave2List(HR_familyName)
	
	num = ItemsInList(HRList, ",")
	HRList = ReplaceString(" ", HRList, "")
	 
	for (idex=0; idex<num; idex+=1)
		
		massStr = StringFromList(idex, HRList, ",")
		massPt =  sq_TextIntextWave(massStr, ExactMassText)
		if (massPt>=0)
			massToPlot+=massStr+","
		else
			tempStr = massStr[6, strlen(massStr)-1]
			if (stringmatch(lowerStr(massStr[0,5]),"family") &&  sq_findStr(HR_familyName,tempStr,1) >=0   && exists("root:int_sticks:mask_"+tempStr  ))				
				massToPlot+=massStr+","
			elseif (WaveExists(HR_spec_list) && WaveExists(HR_specname_list) && stringmatch(lowerStr(massStr[0,1]),"hr") && (sq_findStr(HR_spec_list,tempStr,2) >=0   ||  sq_findStr(HR_specname_list,tempStr,2) >=0 ))	
				massToPlot+=massStr+","
			else
				massNotFoundStr +=massStr + ","
			endif
		endif
	endfor
 
 	HRList=massToPlot
 	return "goodSpecies:"+massToPlot+";"+"badSpecies:"+massNotFoundStr	
 	
End


// Plots individual exact mass sticks as a function of time.
Function HR_plotMassesVsTime(wlist, spectraType)
string wlist, spectraType

	wave t_series = root:index:t_series
	nvar HR_Check_newTimeGr = root:HR_Panel:HR_Check_newTimeGr

	if (HR_Check_newTimeGr==1)		// we want new graph
		Display
		// Sq_AddCntrl_RunsFromCsrs() 	//1.02A 
	endif
	
	variable idex, num
	string massStr	
	
	num = ItemsInList(wlist, ",")
	 
	for (idex=0; idex<num; idex+=1)
		wave massWave = $StringFromList(idex, wlist, ",")+"_"+spectraType
		AppendtoGraph massWave vs t_series
	endfor

	Legend/C/N=text0/F=0/A=MC
	Label bottom " "
	ModifyGraph nticks(bottom)=8,dateInfo(bottom)={0,1,0}
 	kbcolorizetraces(.5,1,0)			// 6.03 fix
	ShowInfo

End

// new in 1.04J
Function HR_adjustDiffLabel()

	nvar HR_UseOpenClosedMzParams =  root:HR_panel:HR_UseOpenClosedMzParams
	if (HR_UseOpenClosedMzParams)
		Label/W=HR_PeakHeights_gr DiffAxis "\\K(65280,0,0)Diff, Hz/ns  - NOT FITTED!!"
	else
		Label/W=HR_PeakHeights_gr DiffAxis "\\K(65280,0,0)Diff, Hz/ns"
	endif

End


// Main peak height graph for one run.
// Significantly changed in 1.03C
Function HR_plotPeakHeightsOneRun()

//	nvar HR_ShowInsets = root:HR_Sticks:HR_ShowInsets
	nvar HR_MaxNumGausFits = root:HR_Sticks:HR_MaxNumGausFits
	nvar HR_ShowAllTags = root:HR_Sticks:HR_ShowAllTags
	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF

	sq_initializeGlobalNVar("root:HR_Sticks:HR_FitTagsUp", 1)
	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoTagsTiny", 1)
	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoTagsUp", 1)

	nvar HR_FitTagsUp = root:HR_Sticks:HR_FitTagsUp
	nvar HR_IsoTagsTiny = root:HR_Sticks:HR_IsoTagsTiny
	nvar HR_IsoTagsUp = root:HR_Sticks:HR_IsoTagsUp

	variable idex
	string fldrSav0= GetDataFolder(1)

//	HR_ShowInsets=0		// always initialize to 0

	DoWindow/K HR_Sticks_gr		//1.02A
	DoWindow/F HR_PeakHeights_gr
	
	if (V_flag==1)		// window exists, just update
		// update
		HR_SetVar_CenterOnThisAMU("",nan,"","")
		SticksGr_AppendChosenMassTags()
		SticksGr_check_ShowAllTags("",HR_ShowAllTags)
		HR_PeakHeightsGr_labelYaxis()	// sets axis labels for OpenAxis, ClosedAxis
		SticksGr_check_IsoTagsTiny("",HR_IsoTagsTiny)
		SticksGr_check_IsoTagsUp("",HR_IsoTagsUp)
		SticksGr_check_FitTagsUp("",HR_FitTagsUp)
		if (HR_singleSpectraMSorPToF==0)		//ptof
			Label/W=HR_PeakHeights_gr DiffAxis "\\K(65280,0,0)Top - Bottom, Hz/ns"
		elseif (HR_singleSpectraMSorPToF==1)		// MS
			HR_adjustDiffLabel()
		elseif (HR_singleSpectraMSorPToF==2)		// ePToFSum

			HR_adjustDiffLabel()
		endif
		return 0
	endif
	
	SetDataFolder root:HR_Sticks:

	wave OneRunDisplayHRRegion,  OneRunRawDiffMz, OneRunDisplayVertGrid, ExactMassWave
	wave gridMarks01,gridMarks1,gridMarks10,gridMarks100, gridMarksX
	wave OneRunRawSpectraDiffBkFt, OneRunRawDiffMz, OneRunRawSpectraClosedBkFt, OneRunRawClosedMz, OneRunRawSpectraOpenBkFt, OneRunRawOpenMz
	wave OneRunResidSpectraOpen,OneRunResidSpectraClosed,OneRunResidSpectraDiff,OneRunResidPerSpectraOpen,OneRunResidPerSpectraClosed,OneRunResidPerSpectraDiff
	wave OneRunPeakHeightDiff,OneRunPeakHeightOpen,OneRunPeakHeightClosed,OneRunSqBkStickClosed,OneRunSqBkStickOpen,OneRunSqBkStickDiff,OneRunPeakHeightOpenMClosed
	wave OneRunRawSpectraOpen,OneRunRawSpectraClosed,OneRunRawSpectraDiff

	wave GausFit_D_Y, GausFit_X, GausFit_D_Sum_Y, GausFit_O_Y, GausFit_O_Sum_Y, GausFit_C_Y, GausFit_C_Sum_Y

	Display/N=HR_PeakHeights_gr /W=(69.6,51.2,675,532.4) as "HR_PeakHeights_gr"

	// display horizontal and vertical grids first so they are behind everything
	AppendToGraph/R OneRunDisplayHRRegion vs OneRunRawDiffMz
	AppendToGraph/R OneRunDisplayVertGrid vs ExactMassWave

	AppendToGraph/L=DiffAxis gridMarks01,gridMarks1,gridMarks10,gridMarks100, vs gridMarksX
	AppendToGraph/L=OpenAxis gridMarks01, gridMarks1, gridMarks10, gridMarks100, vs gridMarksX
	AppendToGraph/L=ClosedAxis gridMarks01, gridMarks1, gridMarks10, gridMarks100, vs gridMarksX

	// display raw spectra//1.09H we only display the original spectra with the baseline removed
//	AppendToGraph/L=DiffAxis OneRunRawSpectraDiff vs OneRunRawDiffMz
//	AppendToGraph/L=OpenAxis OneRunRawSpectraOpen vs OneRunRawOpenMz
//	AppendToGraph/L=ClosedAxis OneRunRawSpectraClosed vs OneRunRawClosedMz
	
	//squirrel baselines
	Appendtograph/L=DiffAxis OneRunRawSpectraDiffBkFt vs OneRunRawDiffMz
	Appendtograph/L=ClosedAxis OneRunRawSpectraClosedBkFt vs OneRunRawClosedMz
	Appendtograph/L=OpenAxis OneRunRawSpectraOpenBkFt vs OneRunRawOpenMz

	// display raw residuals to residuals axis
	AppendToGraph/L=ResidualAxis OneRunResidSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=ResidualAxis OneRunResidSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=ResidualAxis OneRunResidSpectraDiff vs OneRunRawDiffMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraDiff vs OneRunRawDiffMz

	// display raw residuals to raw axes
	AppendToGraph/L=OpenAxis OneRunResidSpectraOpen vs OneRunRawOpenMz		// these are on the individual raw spectra axis	//1.04A
	AppendToGraph/L=ClosedAxis OneRunResidSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=DiffAxis OneRunResidSpectraDiff vs OneRunRawDiffMz
	
	// display peak heights
	AppendToGraph/L=DiffAxis OneRunPeakHeightDiff vs ExactMassWave
	AppendToGraph/L=OpenAxis OneRunPeakHeightOpen vs ExactMassWave
	AppendToGraph/L=ClosedAxis OneRunPeakHeightClosed vs ExactMassWave

	// display squirrel baseline sticks		// new in 1.09H
	AppendtoGraph/l=ClosedAxis OneRunSqBkStickClosed vs ExactMassWave
	AppendtoGraph/l=OpenAxis OneRunSqBkStickOpen vs ExactMassWave
	AppendtoGraph/l=DiffAxis OneRunSqBkStickDiff vs ExactMassWave

	// handle open minus closed.  need to reappend the squirrel baseline stick values.
	AppendtoGraph/l=DiffAxis OneRunSqBkStickDiff vs ExactMassWave
//	AppendToGraph/L=DiffAxis OneRunPeakHeightOpenMClosed vs ExactMassWave   1.22A

	//1.05B		// a temporary fix for those who did not recalc the fits for one spectra.... should not be necessary
	if (!Exists("root:HR_Sticks:OneRunRawSpectraOpenp"))
		duplicate/o OneRunRawSpectraOpen OneRunRawSpectraOpenp
		duplicate/o OneRunRawSpectraClosed OneRunRawSpectraClosedp
		duplicate/o OneRunRawSpectraDiff OneRunRawSpectraDiffp
	endif
	
	// 1.14G  moved these to appear before gauss fits
	AppendToGraph/L=OpenAxis OneRunRawSpectraOpenp vs OneRunRawOpenMz		// these are on the individual raw spectra axis	//1.04A
	AppendToGraph/L=ClosedAxis OneRunRawSpectraClosedp vs OneRunRawClosedMz
	AppendToGraph/L=DiffAxis OneRunRawSpectraDiffp vs OneRunRawDiffMz
	ModifyGraph rgb(OneRunRawSpectraDiffp)=(0,0,0), rgb(OneRunRawSpectraOpenp)=(0,0,0),rgb(OneRunRawSpectraClosedp)=(0,0,0)
	// 1.14G change as per Doug
	ModifyGraph mode(OneRunRawSpectraDiffp)=3, mode(OneRunRawSpectraOpenp)=3, mode(OneRunRawSpectraClosedp)=3
	ModifyGraph marker(OneRunRawSpectraDiffp)=19,marker(OneRunRawSpectraOpenp)=19,marker(OneRunRawSpectraClosedp)=19
	ModifyGraph msize(OneRunRawSpectraDiffp)=3,msize(OneRunRawSpectraOpenp)=3,msize(OneRunRawSpectraClosedp)=3

	// moved these gaussian shapes to the end
	// gaussian shapes diff
	for(idex = 0;idex <HR_MaxNumGausFits; idex+=1)
		AppendToGraph/L=DiffAxis GausFit_D_Y[][idex] vs GausFit_X
	endfor 
	AppendToGraph/L=DiffAxis GausFit_D_Sum_Y vs GausFit_X
	
	// gaussian shapes open
	for(idex = 0;idex <HR_MaxNumGausFits; idex+=1)
		AppendToGraph/L=OpenAxis GausFit_O_Y[][idex] vs GausFit_X
	endfor 
	AppendToGraph/L=OpenAxis GausFit_O_Sum_Y vs GausFit_X
	
	// gaussian shapes closed
	for(idex = 0;idex <HR_MaxNumGausFits; idex+=1)
		AppendToGraph/L=ClosedAxis GausFit_C_Y[][idex] vs GausFit_X
	endfor 
	AppendToGraph/L=ClosedAxis GausFit_C_Sum_Y vs GausFit_X

	SetDataFolder fldrSav0
	ModifyGraph margin(left)=55,margin(bottom)=43,margin(top)=7,margin(right)=5,width=432
	ModifyGraph height=396	//1.09H
	
	ModifyGraph width=0, height=0 // 1.20S  allow for users to resize
	
	// make grids pretty 
	ModifyGraph  rgb(gridMarks01)=(34816,34816,34816), rgb(gridMarks1)=(34816,34816,34816),rgb(gridMarks10)=(34816,34816,34816),rgb(gridMarks100)=(34816,34816,34816)
	ModifyGraph lstyle(gridMarks01)=8,lstyle(gridMarks1)=7,lstyle(gridMarks10)=2
	ModifyGraph  rgb(gridMarks01#1)=(34816,34816,34816), rgb(gridMarks1#1)=(34816,34816,34816),rgb(gridMarks10#1)=(34816,34816,34816),rgb(gridMarks100#1)=(34816,34816,34816)
	ModifyGraph lstyle(gridMarks01#1)=8,lstyle(gridMarks1#1)=7,lstyle(gridMarks10#1)=2
	ModifyGraph  rgb(gridMarks01#2)=(34816,34816,34816), rgb(gridMarks1#2)=(34816,34816,34816),rgb(gridMarks10#2)=(34816,34816,34816),rgb(gridMarks100#2)=(34816,34816,34816)
	ModifyGraph lstyle(gridMarks01#2)=8,lstyle(gridMarks1#2)=7,lstyle(gridMarks10#2)=2

	// make raw spectra pretty
//	ModifyGraph rgb(OneRunRawSpectraDiff)=(0,0,0), rgb(OneRunRawSpectraOpen)=(0,0,0),rgb(OneRunRawSpectraClosed)=(0,0,0)
//	ModifyGraph mode(OneRunRawSpectraDiff)=4, mode(OneRunRawSpectraOpen)=4, mode(OneRunRawSpectraClosed)=4
//	ModifyGraph marker(OneRunRawSpectraDiff)=8,marker(OneRunRawSpectraOpen)=8,marker(OneRunRawSpectraClosed)=8
//	ModifyGraph msize(OneRunRawSpectraDiff)=3,msize(OneRunRawSpectraOpen)=3,msize(OneRunRawSpectraClosed)=3
	
	ModifyGraph mode(OneRunResidPerSpectraOpen)=4,mode(OneRunResidPerSpectraClosed)=4, mode(OneRunResidPerSpectraDiff)=4
	ModifyGraph msize(OneRunResidPerSpectraOpen)=1, msize(OneRunResidPerSpectraClosed)=1, msize(OneRunResidPerSpectraDiff)=1
	ModifyGraph rgb(OneRunResidPerSpectraOpen)=(65280,43520,0), rgb(OneRunResidPerSpectraClosed)=(29168,26112,0),rgb(OneRunResidPerSpectraDiff)=(65280,0,0)

	ModifyGraph mode(OneRunResidSpectraOpen)=4,mode(OneRunResidSpectraClosed)=4, mode(OneRunResidSpectraDiff)=4
	ModifyGraph msize(OneRunResidSpectraOpen)=1, msize(OneRunResidSpectraClosed)=1, msize(OneRunResidSpectraDiff)=1
	ModifyGraph rgb(OneRunResidSpectraOpen)=(0,0,0), rgb(OneRunResidSpectraClosed)=(0,0,0),rgb(OneRunResidSpectraDiff)=(0,0,0)

	//	resid traces on raw spectra axes
	ModifyGraph msize(OneRunResidSpectraDiff#1)=2,mode(OneRunResidSpectraDiff#1)=4
	ModifyGraph msize(OneRunResidSpectraClosed#1)=2,mode(OneRunResidSpectraClosed#1)=4
	ModifyGraph msize(OneRunResidSpectraOpen#1)=2,mode(OneRunResidSpectraOpen#1)=4
	ModifyGraph useMrkStrokeRGB(OneRunResidSpectraClosed#1)=1, mrkStrokeRGB(OneRunResidSpectraClosed#1)=(28928,26112,0), mrkThick(OneRunResidSpectraClosed#1)=2
	ModifyGraph useMrkStrokeRGB(OneRunResidSpectraOpen#1)=1, mrkStrokeRGB(OneRunResidSpectraOpen#1)=(65280,49152,16384), mrkThick(OneRunResidSpectraOpen#1)=2
	ModifyGraph useMrkStrokeRGB(OneRunResidSpectraDiff#1)=1, mrkStrokeRGB(OneRunResidSpectraDiff#1)=(52224,0,0), mrkThick(OneRunResidSpectraDiff#1)=2

	ModifyGraph rgb(OneRunResidSpectraDiff#1)=(0,0,0)
	ModifyGraph rgb(OneRunResidSpectraClosed#1)=(0,0,0)
	ModifyGraph rgb(OneRunResidSpectraOpen#1)=(0,0,0)

	ModifyGraph grid(ResidualAxis)=2,gridRGB(ResidualAxis)=(34816,34816,34816),  tick(ResidualAxis)=2  	//1.05A
 
 	//  color the individual gaussian fits for diff, open closed
	for(idex = 1;idex <HR_MaxNumGausFits; idex+=1)
		ModifyGraph rgb($"GausFit_D_Y#"+num2str(idex))=(65280,0,0)
	endfor 
	ModifyGraph rgb(GausFit_D_Sum_Y)=(24576,24576,65280)

	for(idex = 1;idex <HR_MaxNumGausFits; idex+=1)
		ModifyGraph rgb($"GausFit_O_Y#"+num2str(idex))=(65280,43520,0)
	endfor 
	ModifyGraph rgb(GausFit_O_Sum_Y)=(24576,24576,65280)
	
	for(idex = 1;idex <HR_MaxNumGausFits; idex+=1)
		ModifyGraph rgb($"GausFit_C_Y#"+num2str(idex))=(29168,26112,0)
	endfor 
	ModifyGraph rgb(GausFit_C_Sum_Y)=(24576,24576,65280)
	ModifyGraph rgb(GausFit_D_Y)=(65280,0,0)
	ModifyGraph rgb(GausFit_O_Y)=(65280,43520,0)

	ModifyGraph lstyle(GausFit_D_Sum_Y)=0, lStyle(GausFit_O_Sum_Y)=0, lStyle(GausFit_C_Sum_Y)=0
	ModifyGraph lsize(GausFit_D_Sum_Y)=2,lsize(GausFit_O_Sum_Y)=2, lsize(GausFit_C_Sum_Y)=2

	// axis colors, positions 
	ModifyGraph zero(ResidualAxis)=1,zero(DiffAxis)=1,zero(OpenAxis)=1,zero(ClosedAxis)=1
	ModifyGraph lblPos(ResidualAxis)=78,lblPos(DiffAxis)=78,lblPos(OpenAxis)=78,lblPos(ClosedAxis)=78
	ModifyGraph lblLatPos(ResidualAxis)=0,lblLatPos(OpenAxis)=0,lblLatPos(ClosedAxis)=0
	ModifyGraph freePos(ResidualAxis)=0, freePos(DiffAxis)=0, freePos(OpenAxis)=0, freePos(ClosedAxis)=0

	ModifyGraph axisEnab(ResidualAxis)={0.88,1}		// 1.05A change {0.93,1}
	ModifyGraph axisEnab(right)={0,0.86}
	ModifyGraph axisEnab(OpenAxis)={0.61,0.86}
	ModifyGraph axisEnab(ClosedAxis)={0.33,0.59}
	ModifyGraph axisEnab(DiffAxis)={0.05,0.31}
	
	// axis labels
	Label DiffAxis "\\K(65280,0,0)Diff, Hz/ns"
	Label ResidualAxis "Resid"
	ModifyGraph minor(bottom)=1

	// raw spectra background color & line size
	ModifyGraph lsize(OneRunRawSpectraDiffBkFt)=2
	ModifyGraph rgb(OneRunRawSpectraDiffBkFt)=(65280,0,0)
	ModifyGraph lsize(OneRunRawSpectraClosedBkFt)=2
	ModifyGraph rgb(OneRunRawSpectraClosedBkFt)=(65280,0,0)
	ModifyGraph lsize(OneRunRawSpectraOpenBkFt)=2
	ModifyGraph rgb(OneRunRawSpectraOpenBkFt)=(65280,0,0)

	// vertical grid tweaks
	ModifyGraph mode(OneRunDisplayHRRegion)=7
	ModifyGraph rgb(OneRunDisplayHRRegion)=(56576,56576,56576)
	ModifyGraph hbFill(OneRunDisplayHRRegion)=4

	ModifyGraph mode(OneRunDisplayVertGrid)=1
	ModifyGraph rgb(OneRunDisplayVertGrid)=(34816,34816,34816)
	ModifyGraph nticks(right)=0,noLabel(right)=2
	SetAxis right 0,1e-8
	
	// peak height sticks
	ModifyGraph mode(OneRunPeakHeightDiff)=1, mode(OneRunPeakHeightOpen)=1, mode(OneRunPeakHeightClosed)=1
	ModifyGraph lSize(OneRunPeakHeightDiff)=3,lSize(OneRunPeakHeightOpen)=3,lSize(OneRunPeakHeightClosed)=3
	ModifyGraph rgb(OneRunPeakHeightDiff)=(0,65280,0), rgb(OneRunPeakHeightOpen)=(0,65280,0), rgb(OneRunPeakHeightClosed)=(0,65280,0)
	
	// squirrel baseline sticks - make them all red, like the baselines
	ModifyGraph rgb(OneRunSqBkStickClosed)=(65280,0,0), rgb(OneRunSqBkStickOpen)=(65280,0,0), rgb(OneRunSqBkStickDiff)=(65280,0,0),  rgb(OneRunSqBkStickDiff#1)=(65280,0,0)
	ModifyGraph mode(OneRunSqBkStickClosed)=1, mode(OneRunSqBkStickOpen)=1, mode(OneRunSqBkStickDiff)=1,  mode(OneRunSqBkStickDiff#1)=1
	ModifyGraph lsize(OneRunSqBkStickClosed)=1,  lsize(OneRunSqBkStickOpen)=1,  lsize(OneRunSqBkStickDiff)=1,  lsize(OneRunSqBkStickDiff#1)=1

	//1.09H addition - put sticks on top of the baseline
	ModifyGraph toMode(OneRunPeakHeightClosed)=3, toMode(OneRunPeakHeightOpen)=3, toMode(OneRunPeakHeightDiff)=3		// make the peak height sticks sit above the baselines
//	ModifyGraph toMode(OneRunPeakHeightOpenMClosed)=3		// make the peak height sticks sit above the baselines

	// open minus closed points and error bars  1.22A
//	ModifyGraph mode(OneRunPeakHeightOpenMClosed)=8
//	ModifyGraph rgb(OneRunPeakHeightOpenMClosed)=(65280,0,52224)
//	ModifyGraph marker(OneRunPeakHeightOpenMClosed)=11
//	ErrorBars/T=2/Y=9 OneRunPeakHeightOpenMClosed Y,wave=(root:HR_Sticks:OneRunDiffCountingError,root:HR_Sticks:OneRunDiffCountingError)

	// Colorized sticks on Doug's suggestion, 1.04P
	ModifyGraph zColor(OneRunPeakHeightDiff)={root:HR_Sticks:ExactMassColorTable,*,*,directRGB,0}
	ModifyGraph zColor(OneRunPeakHeightOpen)={root:HR_Sticks:ExactMassColorTable,*,*,directRGB,0}
	ModifyGraph zColor(OneRunPeakHeightClosed)={root:HR_Sticks:ExactMassColorTable,*,*,directRGB,0}

	// controls

	ControlBar/L 190

	TitleBox titleGraphTitle,pos={5,0},size={130,20},fSize=16,frame=0
	TitleBox titleGraphTitle,variable= root:HR_Sticks:HR_SticksGr_TItle
	TitleBox titleRunInfo,pos={5,20},size={150,26},fSize=10,frame=0,fStyle=0		//1.19C
	TitleBox titleRunInfo,variable= root:HR_Sticks:HR_SticksGr_RunInfo
	TitleBox title_deltaStr,pos={143,57},size={37,13},frame=0
	TitleBox title_deltaStr,variable= root:HR_Sticks:HR_DeltaValStr
	Button HR_PeakHeightsGr_butt_redoFits,pos={150,5},size={40,36},fsize=10,proc=HR_butt_reDoFit,title="Redo\rFits"
	
	Button button_down10amu,pos={25,77},size={30,18},proc=HR_butt_upOrDownXamu,title="<<"
	Button button_down1amu,pos={60,77},size={30,18},proc=HR_butt_upOrDownXamu,title="<"
	Button button_up1amu,pos={100,77},size={30,18},proc=HR_butt_upOrDownXamu,title=">"
	Button button_up10amu,pos={135,77},size={30,18},proc=HR_butt_upOrDownXamu,title=">>"
	SetVariable setvar_Mz,pos={5,57},size={120,16},proc=HR_SetVar_CenterOnThisAMU,title="Center on m/z"
	SetVariable setvar_Mz,limits={5,inf,1},value= root:HR_Sticks:HR_DisplayMz

	GroupBox groupAxisControl,pos={5,247},size={180,130},title="Axis Controls"
	GroupBox groupAxisControl,fColor=(1,1,1)
	SetVariable setvar_xAxisWidth,pos={25,265},size={145,16},proc=HR_SetVar_CenterOnThisAMU,title="X axis width"
	SetVariable setvar_xAxisWidth,format="%.3f"
	SetVariable setvar_xAxisWidth,limits={0.05,100,0.05},value= root:HR_Sticks:HR_StickGr_amuWidth
	CheckBox check_YAxisAbove0,pos={10,282},size={137,14},proc=HR_check_CenterOnThisAMU,title="Set Y-axis mins to be >=0"
	CheckBox check_YAxisAbove0,variable= root:HR_Sticks:HR_SetYaxisAbove0
	CheckBox check_Yscale,pos={10,302},size={136,14},proc=HR_check_CenterOnThisAMU,title="Set Y-axis on same scale"
	CheckBox check_Yscale,variable= root:HR_Sticks:HR_SameYScale
	CheckBox check_SetYaxis,pos={10,321},size={117,14},proc=HR_check_CenterOnThisAMU,title=" Define Y-axis values"
	CheckBox check_SetYaxis,variable= root:HR_Sticks:RawYAxisMinMax
	SetVariable setvar_yAxisMin,pos={18,338},size={165,16},proc=HR_SetVar_CenterOnThisAMU,title="Raw Spectra Axis Min"
	SetVariable setvar_yAxisMin,fSize=10,format="%.2f"
	SetVariable setvar_yAxisMin,limits={-100,1000,0.05},value= root:HR_Sticks:RawYAxisMin
	SetVariable setvar_yAxisMax,pos={18,357},size={165,16},proc=HR_SetVar_CenterOnThisAMU,title="Raw Spectra Axis Max"
	SetVariable setvar_yAxisMax,fSize=10,format="%.2f"
	SetVariable setvar_yAxisMax,limits={0.005,10000,0.25},value= root:HR_Sticks:RawYAxisMax

	TabControl tab0,pos={3,98},size={182,150},proc=PH_TabProc
	TabControl tab0,tabLabel(0)="Display Tweaks",tabLabel(1)="Legend",value= 0

	CheckBox PH0_check_ShowHorGrids,pos={38,163},size={63,14},proc=SticksGr_check_HorizGrids,title="Hor. grids"
	CheckBox PH0_check_ShowHorGrids,variable= root:HR_Sticks:HR_ShowHorGrids
	CheckBox PH0_check_ShowVerGrid,pos={110,164},size={65,14},proc=SticksGr_check_VertGrids,title="Vert. grids"
	CheckBox PH0_check_ShowVerGrid,variable= root:HR_Sticks:HR_showVerGrids

	CheckBox PH0_check_ResidualPercent,pos={10,179},size={147,14},fSize=11,proc=SticksGr_check_ResidPer,title="Resid axis = ratio to biggest"
	CheckBox PH0_check_ResidualPercent,variable= root:HR_Sticks:HR_plotResidualInPercent
	CheckBox PH0_check_ShowResidOnRawAxis,pos={10,195},size={127,14},fSize=11,proc=SticksGr_check_ShowResidOnRaw,title="Residuals on raw axes"
	CheckBox PH0_check_ShowResidOnRawAxis,variable= root:HR_Sticks:HR_ShowResidOnRawAxes
//	CheckBox PH0_check_ShowOpenMClosed,pos={10,212},size={101,14},fSize=11,proc=SticksGr_check_ShowOpenMClosed,title="Show Open stick - Closed stick"
//	CheckBox PH0_check_ShowOpenMClosed,variable= root:HR_Sticks:HR_ShowDiffEqOMC
	CheckBox PH0_check_ShowSqBaseline,pos={10,220},size={86,14},fSize=11,proc=SticksGr_check_DisplaySQBase,title="SQ baseline fit"
	CheckBox PH0_check_ShowSqBaseline,fStyle=0,fSize=11
	CheckBox PH0_check_ShowSqBaseline,variable= root:HR_Sticks:HR_ShowSQBaselineFits
	CheckBox PH0_check_LinesBetweenRaw,pos={89,220},size={80,14},fSize=11,proc=SticksGr_check_ShowLinesBetween,title="Lines on Raw"
	CheckBox PH0_check_LinesBetweenRaw,fStyle=0,fSize=11
	CheckBox PH0_check_LinesBetweenRaw,variable= root:HR_Sticks:HR_ShowLinesBetweenRaw
	
	CheckBox PH0_check_IsoTagsUp,pos={13,145},size={70,14},fSize=11,proc=SticksGr_check_IsoTagsUp,title="Iso tags up"
	CheckBox PH0_check_IsoTagsUp,variable= root:HR_Sticks:HR_IsoTagsUp
	CheckBox PH0_check_IsoTagsTiny,pos={84,145},size={74,14},fSize=11,proc=SticksGr_check_IsoTagsTiny,title="Iso tags tiny"
	CheckBox PH0_check_IsoTagsTiny,variable= root:HR_Sticks:HR_IsoTagsTiny
	CheckBox PH0_check_FitTagsUp,pos={81,126},size={70,14},fSize=11,proc=SticksGr_check_FitTagsUp,title=" Fit tags up"
	CheckBox PH0_check_FitTagsUp,variable= root:HR_Sticks:HR_FitTagsUp
	CheckBox PH0_check_ShowAllTags,pos={13,126},size={52,14},fSize=11,proc=SticksGr_Check_ShowAllTags,title="All tags"
	CheckBox PH0_check_ShowAllTags,variable= root:HR_Sticks:HR_ShowAllTags

	TitleBox PH1_TitleBox,pos={10,127},size={158,117},fSize=10,frame=0
	TitleBox PH1_TitleBox,variable= root:HR_Sticks:HR_legendStr

	GroupBox groupChangeMasses,pos={5,381},size={175,207},title="Change Masses to Fit"
	GroupBox groupChangeMasses,fColor=(1,1,1)
	ListBox listMassesAtThisInt,pos={10,397},size={160,93}
	ListBox listMassesAtThisInt,listWave=root:HR_Sticks:IntegerMz_FittingMasses
	ListBox listMassesAtThisInt,selWave=root:HR_Sticks:IntegerMz_FittingMassesSelect
	ListBox listMassesAtThisInt,mode= 1,selRow= 0,editStyle= 1,widths={90,70}
  //1.21C
	GroupBox groupAdd,pos={4.00,546.00},size={176.00,38.00}
	Button button_massCalc,pos={11.00,529.00},size={140.00,15.00},proc=HR_butt_IonMassCalculator,title="HR Ion Mass Calculator"
	Button button_massCalc,fSize=10
	Button button_AddThisMass,pos={5.00,549.00},size={60.00,30.00},proc=HR_butt_AddThisMass,title="Add ion to\rall HR ions"
	Button button_AddThisMass,fSize=10
	CheckBox check_AddIsoChildren,pos={6.00,490.00},size={79.00,36.00},title="Add/remove\riso. child with\r> mass parent"
	CheckBox check_AddIsoChildren,fSize=10,variable= root:HR_panel:NewHRIonQueryFindChosen
	
	SetVariable setVar_IonName,pos={68.00,565.00},size={108.00,15.00},bodyWidth=60,title="Ion Name"
	SetVariable setVar_IonName,fSize=10,value= root:HR_Sticks:SticksGr_newIonName
	SetVariable setVar_IonMass,pos={69.00,549.00},size={107.00,15.00},bodyWidth=60,title="Ion Mass "
	SetVariable setVar_IonMass,fSize=10,value= root:HR_Sticks:SticksGr_newIonMass
	Button button_UpdateMaskWave,pos={91.00,494.00},size={80.00,30.00},proc=HR_butt_updateMaskWave,title="Update list of\rHR ions to fit"
	Button button_UpdateMaskWave,fSize=10
	
	Button button_Pkgr_Open,pos={188,82},size={14,50},proc=HR_PeakHeights_gr_pop,title="p\ro\rp"
	Button button_Pkgr_Open,fSize=10,fColor=(56576,56576,56576)
	Button button_Pkgr_Closed,pos={188,215},size={14,50},proc=HR_PeakHeights_gr_pop,title="p\ro\rp"
	Button button_Pkgr_Closed,fSize=10,fColor=(56576,56576,56576)
	Button button_Pkgr_Diff,pos={188,378},size={14,50},proc=HR_PeakHeights_gr_pop,title="p\ro\rp"
	Button button_Pkgr_Diff,fSize=10,fColor=(56576,56576,56576)

	// 1.05b addition - make sure that the checkboxes for the pika vs squirrel baselines are set correctly

	// the order of these last steps don't matter
	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth
	nvar HR_ShowResidOnRawAxes = root:HR_Sticks:HR_ShowResidOnRawAxes
	nvar HR_ShowAllTags = root:HR_Sticks:HR_ShowAllTags

	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth)
	HR_calcGausFitWaves(HR_DisplayMz)

	SticksGr_check_DisplaySQBase("",1)
//	SticksGr_check_ShowPikplusSqBa("",1) 		//1.05A		//1.09H
//	Sticksgr_disableBaselineChks()  	//1.05A  1.09H	//1.09H
	SticksGr_check_ShowResidOnRaw("",HR_ShowResidOnRawAxes)		//1.09H

	SticksGr_AppendChosenMassTags()	
	HR_ShowAllTags=1
	SticksGr_check_ShowAllTags("",1)	
 	
 	HR_adjustDiffLabel()
  	PH_TabProc("",0)
  
	SticksGr_Check_ShowAllTags("", 1)
	HR_PeakHeightsGr_labelYaxis()
//	HR_ck_oneRunOrAvg("HRFit_ck_OneRunRawSpectra",0)		//1.11H
	
	sq_initializeGlobalNVar("root:HR_sticks:HR_IsoTagsTiny",1)			// plot sticks or rawpopmenu choice
	sq_initializeGlobalNVar("root:HR_sticks:HR_IsoTagsUp",1)			// plot sticks or rawpopmenu choice
	sq_initializeGlobalNVar("root:HR_sticks:HR_FitTagsUp",1)			// plot sticks or rawpopmenu choice
	nvar HR_IsoTagsTiny=root:HR_sticks:HR_IsoTagsTiny
	nvar HR_IsoTagsUp=root:HR_sticks:HR_IsoTagsUp
	nvar HR_FitTagsUp=root:HR_sticks:HR_FitTagsUp
	SticksGr_check_IsoTagsTiny("",HR_IsoTagsTiny)
	SticksGr_check_IsoTagsUp("",HR_IsoTagsUp)
	SticksGr_check_FitTagsUp("",HR_FitTagsUp)
	SticksGr_check_ShowLinesBetween("",nan)

End


Function HR_PeakHeightsGr_labelYaxis()

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
	if (HR_singleSpectraMSorPToF==1)
		Label OpenAxis "\\K(65280,43520,0)\\K(65280,43520,0)Open, Hz/ns"
		Label ClosedAxis "\\K(29168,26112,0)Closed, Hz/ns"
	elseif (HR_singleSpectraMSorPToF==0)

		ControlInfo/w=HR_analysis_Panel HRFit_popup_PToFOpen
		Label OpenAxis "\\K(65280,43520,0)\\K(65280,43520,0)"+S_value+", Hz/ns"
		ControlInfo/w=HR_analysis_Panel HRFit_popup_PToFClosed
		Label ClosedAxis "\\K(29168,26112,0)"+S_value+", Hz/ns"
	elseif (HR_singleSpectraMSorPToF==2)
		Label OpenAxis "\\K(65280,43520,0)\\K(65280,43520,0) ePToFSum, Hz/ns"
		Label ClosedAxis "\\K(29168,26112,0)Closed, Hz/ns"
	endif

End


Function HR_PeakHeights_gr_pop(ctrlName) : ButtonControl
string ctrlName
	
	string specStr =stringFromList(2,ctrlName, "_")
	if (WhichListItem(specStr, "Open;Closed;Diff")<0)
		abort "Had problems with popping "+ctrlName
	endif
 	HR_PeakHeights_gr_Spec(specStr)
 		
End


Function SticksGr_check_IsoTagsUp(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_IsoTagsUp = root:HR_Sticks:HR_IsoTagsUp
	HR_IsoTagsUp=checked==1
	
	wave/t IsotopicMassText=root:HR_sticks:IsotopicMassText
	wave IsotopicMask=root:HR_sticks:IsotopicMask
		
	variable num, idex
	string fragStr
	
	num=numpnts(IsotopicMassText)
	for(idex=0; idex < num; idex +=1)
		fragStr = IsotopicMassText[idex]
		if (IsotopicMask[idex])	//  constrained
			if(HR_IsoTagsUp)
				Tag/C/N=$fragStr/O=90/Y=32
			else
				Tag/C/N=$fragStr/O=0/Y=2
			endif
		endif
	endfor

End


Function SticksGr_check_IsoTagsTiny(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	wave /T ExactMassText_all = root:HR:ExactMassText_all
	wave /T ExactMassTag_all = root:HR:ExactMassTag_all

	nvar HR_IsoTagsTiny = root:HR_Sticks:HR_IsoTagsTiny
	HR_IsoTagsTiny=checked==1
	
	wave/t IsotopicMassText=root:HR_sticks:IsotopicMassText
	wave IsotopicMask=root:HR_sticks:IsotopicMask
		
	variable num, idex, count
	string fragStr, origTagStr
	
//	num=numpnts(IsotopicMassText)
	num=numpnts(ExactMassText_all)
	for(idex=0; idex < num; idex +=1)
//		fragStr = IsotopicMassText[idex]
		fragStr = ExactMassText_all[idex]
		if (strsearch(fragStr, "j", 0) >=0 )	//  constrained
//		if (IsotopicMask[idex])	//  constrained
			origTagStr=stringbyKey("TEXT", AnnotationInfo("HR_peakHeights_gr", fragStr ) )
			origTagStr=ReplaceString("\\\\", origTagStr, "\\")
			origTagStr=ReplaceString("\\Z06", origTagStr, "")
			origTagStr=ReplaceString("\\Z12", origTagStr, "")
			if(HR_IsoTagsTiny)
				Tag/C/N=$fragStr  "\\Z06"+ReplaceString("\\M", origTagStr, "\\M\\Z06")	
			else
				Tag/C/N=$fragStr  "\\Z12"+ReplaceString("\\M", origTagStr, "\\M\\Z12")	
			endif
		else
		
		
		endif
	endfor

End


Function SticksGr_check_FitTagsUp(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	wave /T ExactMassText = root:HR_sticks:ExactMassText

	nvar HR_FitTagsUp = root:HR_Sticks:HR_FitTagsUp
	HR_FitTagsUp=checked==1
			
	variable num, idex, count
	string fragStr, origTagStr
	
	num=numpnts(ExactMassText)
	count=0
	for(idex=0; idex < num; idex +=1)
		fragStr = ExactMassText[idex]
		if (HR_FitTagsUp)
			if (strsearch(fragStr, "j", 0)<0 )
				Tag/C/N=$fragStr/Y=(16+2*mod(count,2))
				count+=1
			endif
		else
			Tag/C/N=$fragStr/Y=2
		endif
	endfor

End

//1.06 addition  disabled in 1.09H
//Function Sticksgr_disableBaselineChks()
//
//	nvar HR_UseSQBaseline = root:HR_panel:HR_UseSQBaseline
//
//	DoWindow HR_PeakHeights_gr
//	if (V_flag==1)
//		if (HR_UseSQBaseline)
////			Checkbox PH0_check_OffsetPeakHts, Win=HR_PeakHeights_gr, disable = 2, fstyle = 2
////			Checkbox PH0_check_ShowPikaFitSqBaseli, Win=HR_PeakHeights_gr, disable = 0, fstyle = 0
//		else
////			Checkbox PH0_check_OffsetPeakHts, Win=HR_PeakHeights_gr, disable = 0, fstyle = 0
////			Checkbox PH0_check_ShowPikaFitSqBaseli, Win=HR_PeakHeights_gr, disable = 2, fstyle = 2
//		endif
//	endif
//	
//End


// Button functions on Sticks_gr
// 4 graph buttons taken from Pete & Allison's code
Function HR_butt_upOrDownXamu(ctrlName) : ButtonControl
string ctrlName
	
	strswitch (ctrlName)
	
	case "button_up1amu":
		HR_SetAxisUpOrDownXamu(1, 1)
		break
	case "button_down1amu":
		HR_SetAxisUpOrDownXamu(0, 1)
		break
	case "button_up10amu":
		HR_SetAxisUpOrDownXamu(1, 10)
		break
	case "button_down10amu":
		HR_SetAxisUpOrDownXamu(0, 10)
		break
	endswitch	
		
End

// returns string of newly added HR ion
//Function/S HR_addThisMass(NewIonName, newIonMass)
//string NewIonName
//variable newIonMass
//
//	wave/t ExactMassText_All = root:HR:ExactMassText_All
//	wave ExactMassWave_All = root:HR:ExactMassWave_All
//	wave/t ExactMassComments = root:HR:ExactMassComments
//	wave Mask_Stick_integration = root:HR:Mask_Stick_integration
//	wave Mask_Stick_Integration_Default = root:HR:Mask_Stick_Integration_Default
//	wave/t Mask_Isotope_reference = root:HR:Mask_Isotope_reference
//	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance
//
//	variable insertionPt, num
//	string abortStr
//	
//	abortStr=""	
//	num = numpnts(ExactMassWave_All)
//
//	// two sanity checks - one to see if the mass exists, another to see if the text exists
//
//	NewIonName = CleanupName(NewIonName, 0)
//	NewIonName = upperStr(NewIonName)
//	NewIonName = ReplaceString("J", NewIonName, "j")		// js represent isotopes
//	NewIonName = ReplaceString("_", NewIonName, "")		// no underscores
//	
//	FindValue/TEXT=NewIonName/TxOP=4 ExactMassText_All
//	if (V_Value >=0)
//		abortStr =  "It appears that this ion already exists in the wave ExactMassText_All at location " + num2str(V_Value) +" - Aborting from HR_addThisMass"
//	endif		
//	if (newIonMass < 4 || newIonMass > 1500)		// 1.06J fix by urging from Puneet, old version was 300
//		abortStr =  "The added mass must be between 4 and 999 - Aborting from HR_addThisMass"	
//	endif
//	
//	insertionPt = binarysearch(ExactMassWave_All, newIonMass) + 1
//	if (insertionPt ==-1)		// means that the original binary search returned -2
//		insertionPt=num		// very last entry
//	elseif(newIonMass == ExactMassWave_All[insertionPt])
//		abortStr = "It appears as if this entry already appears in the list - Please refresh the screen! - Aborting from HR_addThisMass"
//	endif
//		
//	if (strlen(abortStr)==0)
//		InsertPoints insertionPt,1, ExactMassText_All,ExactMassWave_All,ExactMassComments
//		InsertPoints insertionPt,1, Mask_Stick_integration, Mask_Stick_Integration_Default
//		InsertPoints insertionPt,1, Mask_Isotope_abundance,Mask_Isotope_reference
//		ExactMassText_All[insertionPt] = NewIonName
//		ExactMassWave_All[insertionPt] = newIonMass
//		ExactMassComments[insertionPt] = ""
//		Mask_Isotope_reference[insertionPt] = ""
//		Mask_Isotope_abundance[insertionPt] = nan
//		Mask_Stick_integration[insertionPt] = 1		// presume that if added they also want to fit
//		Mask_Stick_Integration_Default[insertionPt] = 0
//		return NewIonName
//	else	
//		return abortStr
//	endif
//	
//End

Function HR_butt_AddThisHRIon(ctrlName) : ButtonControl
	String ctrlName

	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass
	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	nvar NewHRIonQueryChooseToFit = root:HR_panel:NewHRIonQueryChooseToFit
	svar NewHRIonQueryIsoParent = root:HR_panel:NewHRIonQueryIsoParent		// fix in 1.10B
	nvar NewHRIonQueryIsoAbundance = root:HR_panel:NewHRIonQueryIsoAbundance

	HR_addThisMass(NewHRIonQueryText, NewHRIonQueryMass,possibleChooseToFit=NewHRIonQueryChooseToFit, possibleIsotopParent=NewHRIonQueryIsoParent, possibleIsotopAbund=NewHRIonQueryIsoAbundance)

	HR_butt_MakeExactMassWaves("") // 1.21B
	
End

// Used with Sticks_gr
Function HR_SetAxisUpOrDownXamu(upFlag, Xamu)
variable upFlag, XAmu
	
	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_sticks:HR_StickGr_amuWidth

	// note that the HR_reCenterAmu function resets th DisplayMz variable
	if (upFlag==1)// go up
		HR_DisplayMz+=XAmu 	
	else // go down
		HR_DisplayMz-=XAmu 
		HR_DisplayMz = max(HR_DisplayMz, 5)		// don't go too low	
	endif
	HR_reCenterAmu(HR_DisplayMZ, HR_StickGr_amuWidth)	// controls x and y scales	
	HR_calcGausFitWaves(HR_DisplayMz)

End


// Used with Sticks_gr
Function HR_reCenterAmu(Center,Range, [specStr])
Variable Center, Range
string specStr

	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz

	wave ExactMassWave = root:HR_sticks:ExactMassWave
	wave UnitMass = root:HR_sticks:UnitMass
	wave MassStartPnt = root:HR_sticks:MassStartPnt
	wave MassEndPnt = root:HR_sticks:MassEndPnt
	wave OneRunDisplayHRRegion = root:HR_Sticks:OneRunDisplayHRRegion 
	wave/d ExactMassWave_All= root:HR:ExactMassWave_All

	wave StartPt = root:HR_sticks:StartPt
	wave EndPt = root:HR_sticks:EndPt

	wave OneRunRawSpectraOpenp = root:HR_sticks:OneRunRawSpectraOpenp
	wave OneRunRawSpectraClosedp = root:HR_sticks:OneRunRawSpectraClosedp
	wave OneRunRawSpectraDiffp= root:HR_sticks:OneRunRawSpectraDiffp
	
	wave OneRunPeakHeightOpen = root:HR_sticks:OneRunPeakHeightOpen		// 1.02A fix
	wave OneRunPeakHeightClosed = root:HR_sticks:OneRunPeakHeightClosed
	wave OneRunPeakHeightDiff= root:HR_sticks:OneRunPeakHeightDiff
	wave OneRunResidSpectraOpen = root:HR_sticks:OneRunResidSpectraOpen		// 1.02A fix
	wave OneRunResidSpectraClosed = root:HR_sticks:OneRunResidSpectraClosed
	wave OneRunResidSpectraDiff= root:HR_sticks:OneRunResidSpectraDiff

	wave OneRunRawSpectraDiff = root:HR_sticks:OneRunRawSpectraDiff	
	wave OneRunRawDiffMz = root:HR_sticks:OneRunRawDiffMz		//1.04J change to use diff

	svar HR_DeltaValStr = root:HR_sticks:HR_DeltaValStr

	nvar HR_SameYScale = root:HR_sticks:HR_SameYScale
	nvar HR_SetYaxisAbove0 = root:HR_sticks:HR_SetYaxisAbove0
	nvar RawYAxisMinMax=root:HR_Sticks:RawYAxisMinMax
	
	nvar HR_plotResidualInPercent = root:HR_sticks:HR_plotResidualInPercent

	nvar RawYAxisMax=root:HR_Sticks:RawYAxisMax
	nvar RawYAxisMin=root:HR_Sticks:RawYAxisMin

	variable O_max, O_min, C_max, C_min, D_max, D_min, deltaVal
	variable XptLeft, XptRight, thisMax, thisMin, UnitMassPt, UnitMassLeft, UnitMassRight, UnitMassStartPt, xMassLeft, xMassRight
		
	HR_DisplayMz = max(center, round(Wavemin(OneRunRawDiffMz) ) )		//1.19A
	HR_DisplayMz = min(center, round(Wavemax(OneRunRawDiffMz) ) )
	Center = HR_DisplayMz

	specStr = SelectString( ParamIsDefault(specStr ),  specStr, "" )
	UnitMassStartPt = UnitMass[0]	// the integer offset of all masses
	
	// set bottom
	xMassLeft = binarysearch(ExactMassWave_All, center-.5)
	xMassRight = binarysearch(ExactMassWave_All, center+.5)

//OneRunDisplayHRRegion

	if (xMassLeft>=0 && xMassRight>=0 && (xMassRight - xMassLeft) >=1 )		//1.19B
		SetAxis bottom  ExactMassWave_All[xMassLeft+1]- Range/2	, ExactMassWave_All[xMassRight]+ Range/2	
	else
		SetAxis bottom  Center - Range/2, Center + Range/2	
	endif
	
	// sets the Y-axis
	// first get max and mins of raw spectra
	XptLeft = floor(binarysearch(OneRunRawDiffMz, Center - Range))
	XptRight = ceil(binarysearch(OneRunRawDiffMz, Center + Range))

	WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunRawSpectraOpenp
	O_max = V_max
//	O_min = V_min
	WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunRawSpectraClosedp
	C_max = V_max
//	C_min = V_min; 
	WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunRawSpectraDiffp
	D_max = V_max
//	D_min = V_min; 
	
	//1.05A
	WaveStats/M=1/Q/R =  [XptLeft, XptRight] OneRunResidSpectraOpen
	O_min = numtype(V_min)==0? min(O_min, V_min): O_min			// if we have a value then set to min of olde and new
	WaveStats/M=1/Q/R =  [XptLeft, XptRight] OneRunResidSpectraDiff
	D_min = numtype(V_min)==0? min(D_min, V_min): D_min			// if we have a value then set to min of olde and new
	WaveStats/M=1/Q/R =  [XptLeft, XptRight] OneRunResidSpectraClosed
	C_min = numtype(V_min)==0? min(C_min, V_min): C_min			// if we have a value then set to min of olde and new
	
	// next get max of sticks, don't bother with mins
	UnitMassPt = round(binarysearch(UnitMass, Center))
	if (UnitMassPt==-2)
		UnitMassPt = numpnts(MassStartPnt)-1		//1.19A
	elseif(UnitMassPt==-1)		//1.19E
		UnitMassPt=0
	endif
	UnitMassLeft = MassStartPnt[UnitMassPt] 
	UnitMassRight = MassEndPnt[UnitMassPt] 	

	if (UnitMassLeft==UnitMassRight)	// only one mass at this integer m/z
		O_max = max(O_max, numtype(OneRunPeakHeightOpen[UnitMassRight])==0 ? OneRunPeakHeightOpen[UnitMassRight] : O_max)	// 1.03C fix	
		D_max = max(D_max, numtype(OneRunPeakHeightDiff[UnitMassRight])==0 ? OneRunPeakHeightDiff[UnitMassRight] : D_max)	
		C_max = max(C_max, numtype(OneRunPeakHeightClosed[UnitMassRight])==0 ? OneRunPeakHeightClosed[UnitMassRight] : C_max)	

	elseif( UnitMassLeft< UnitMassRight )
		WaveStats/M=1/Q/R = [UnitMassLeft, UnitMassRight] OneRunPeakHeightOpen
		O_max = numtype(V_max)==0? max(O_max, V_max): O_max			// if we have a value then set to max of olde and new
		WaveStats/M=1/Q/R = [UnitMassLeft, UnitMassRight] OneRunPeakHeightDiff
		D_max = numtype(V_max)==0? max(D_max, V_max): D_max			// if we have a value then set to max of olde and new
		WaveStats/M=1/Q/R = [UnitMassLeft, UnitMassRight] OneRunPeakHeightClosed
		C_max = numtype(V_max)==0? max(C_max, V_max): C_max			// if we have a value then set to max of olde and new
	endif	
	
	thisMax = Max(Max(O_max, C_max),D_max)
	thisMin = Min(Min(O_min, C_min),D_min)
	
	if (RawYAxisMinMax)
		if (strlen(specStr)==0)
			SetAxis DiffAxis RawYAxisMin, RawYAxisMax
			SetAxis OpenAxis RawYAxisMin, RawYAxisMax
			SetAxis ClosedAxis RawYAxisMin, RawYAxisMax
		else
			SetAxis $specStr+"Axis" RawYAxisMin, RawYAxisMax
		endif
	else
		if (HR_SameYScale)
			thisMin = Min(thismin, -0.1*abs(thisMax))		// 1.05A jose wanted
			if (strlen(specStr)==0)
				SetAxis DiffAxis  thisMin, thisMax*1.1
				SetAxis OpenAxis  thisMin, thisMax*1.1
				SetAxis ClosedAxis thisMin, thisMax*1.1
			else
				SetAxis $specStr+"Axis" thisMin, thisMax*1.1
			endif
		else
			if (strlen(specStr)==0)
				SetAxis DiffAxis D_min, D_max*1.1
				SetAxis OpenAxis O_min, O_max*1.1
				SetAxis ClosedAxis C_min, C_max*1.1
			else
				string SpecList = "Diff;Open;Closed"
				variable SpecNum = WHichListItem(specStr, SpecList)
				thisMin = SelectNumber(SpecNum-1 ,D_min, O_min, C_min)
				thisMax = SelectNumber(SpecNum-1 ,D_max, O_max, C_max)
				SetAxis $specStr+"Axis" thisMin, thisMax*1.1
			endif
		endif
	endif
		
	// adjust residual axis	
	if (strlen(specStr)==0)
		SticksGr_SetResidAxis(XptLeft, XptRight, HR_plotResidualInPercent)
		HR_CreatePeakHtsListBox()
	endif
	

	// Set delta Val global string
	deltaVal = mod(Center, 14) + 1
	deltaVal = (deltaVal>6)? deltaVal-14:deltaVal
	HR_DeltaValStr = "Delta: "+num2str(deltaVal)
		
End


// Used with Sticks_gr
Function HR_SetVar_CenterOnThisAMU(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth

	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth)
	HR_calcGausFitWaves(HR_DisplayMz)

End


// Used with Sticks_gr
Function HR_check_CenterOnThisAMU(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth

	nvar RawYAxisMinMax = root:HR_Sticks:RawYAxisMinMax
	nvar HR_SameYScale = root:HR_Sticks:HR_SameYScale
	nvar HR_SetYaxisAbove0 = root:HR_Sticks:HR_SetYaxisAbove0

	if (stringmatch(ctrlName, "check_SetYaxis") && RawYAxisMinMax)
		HR_SameYScale=0
		HR_SetYaxisAbove0=0
	elseif (stringmatch(ctrlName, "check_Yscale") && HR_SameYScale)
		RawYAxisMinMax=0
	elseif (stringmatch(ctrlName, "check_YAxisAbove0") && HR_SetYaxisAbove0)
		RawYAxisMinMax=0
	endif

	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth)

End


// Used with Sticks_gr
// hides or shows HR ions that have NOT been 'fit
Function HR_ExactMassTagsAll(AppendFlag)
variable AppendFlag

	wave /T ExactMassText_all = root:HR:ExactMassText_all
	wave /T ExactMassTag_all = root:HR:ExactMassTag_all
	wave/d ExactMassWave_all = root:HR:ExactMassWave_all
	wave Mask_Stick_integration= root:HR:Mask_Stick_integration
				
	wave/t IsotopicMassText=root:HR_Sticks:IsotopicMassText
	wave IsotopicMask= root:HR_Sticks:IsotopicMask

	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoSmallTags", 0)
	nvar HR_IsoSmallTags= root:HR_Sticks:HR_IsoSmallTags
	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoUpTags", 0)
	nvar HR_IsoUpTags= root:HR_Sticks:HR_IsoUpTags
	
	variable idex, num, IsoFlag, IsoCount=0
	string fragStr

	num=numpnts(ExactMassText_all)
	if (AppendFlag)
		for(idex=0; idex < num; idex +=1)
			fragStr = ExactMassText_all[idex]
			if (cmpstr(fragStr, "Co", 1)==0)	
				fragStr="Cobalt"
			endif
			IsoFlag = strsearch(fragstr, "j", 0)>=0
			
			if (Mask_Stick_integration[idex]==0)		// those we DO NOT choose to fit  arrow and text are gray
				Tag/C/G=(34816,34816,34816)/V=1 /N=$fragStr/I=1/L=2/F=0/X=0.00/Y=-8.00/A=MB bottom , ExactMassWave_all[idex], "\\K(34816,34816,34816)"+ExactMassTag_all[idex]
				if (IsoFlag)		// change arrow type
					Tag/C/N=$fragStr/TL={sharp=1,lineRGB=(34816,34816,34816)}
				endif
			endif
		endfor
	else		// we are NOT appending, so kill, now just hide
		for(idex=0; idex < num; idex +=1)
			if (Mask_Stick_integration[idex]==0)
				fragStr = ExactMassText_all[idex]
				Tag/C/N=$fragStr/V=0		// instead of killing we make opaque
			endif
		endfor
	endif
	
End 

// Used with Sticks_gr
// For isotopic ions that have been constrained, make them small and/or 'put up'
// assumes all tags are already displayed
Function HR_ExactMassTagsIsoAll()
variable AppendFlag

	wave /T ExactMassText_all = root:HR:ExactMassText_all
	wave /T ExactMassTag_all = root:HR:ExactMassTag_all
	wave/d ExactMassWave_all = root:HR:ExactMassWave_all
	wave Mask_Stick_integration= root:HR:Mask_Stick_integration

	wave/t IsotopicMassText=root:HR_Sticks:IsotopicMassText
	wave IsotopicMask= root:HR_Sticks:MaskIsotopicMask
				
	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoSmallTags", 0)
	nvar HR_IsoSmallTags= root:HR_Sticks:HR_IsoSmallTags
	sq_initializeGlobalNVar("root:HR_Sticks:HR_IsoUpTags", 0)
	nvar HR_IsoUpTags= root:HR_Sticks:HR_IsoUpTags
	
	variable idex, num, TagLocation
	string fragStr

	num=numpnts(IsotopicMassText)
	for(idex=0; idex < num; idex +=1)
		fragStr = IsotopicMassText[idex]
		if (IsotopicMask[idex])	//  constrained
			if (HR_IsoSmallTags)
//				Tag/Y=30/N=$fragStr/TL={sharp=1,lineRGB=(34816,34816,34816)}  "\\Z06"+ReplaceString("\\M", ExactMassTag_all[idex], "\\M\\Z06")	
			endif
			if(HR_IsoUpTags)
				Tag/C/N=$fragStr/Y=3
			endif
		endif
	endfor
	
End 


// Used with PeakHeights_gr
Function HR_calcGausFitWaves(HR_DisplayMz)
variable HR_DisplayMz

	wave run_series = root:index:rn_series

	wave UnitMassNumPeakSum = root:HR_sticks:UnitMassNumPeakSum
	wave numOfPeaks = root:HR_sticks:numOfPeaks
	wave UnitMass = root:HR_sticks:UnitMass
	wave MassStartPnt = root:HR_sticks:MassStartPnt
	wave MassEndPnt = root:HR_sticks:MassEndPnt

	wave gausFit_X = root:HR_sticks:GausFit_X
	wave GausFit_D_Sum_Y = root:HR_sticks:GausFit_D_Sum_Y
	wave GausFit_O_Sum_Y = root:HR_sticks:GausFit_O_Sum_Y
	wave GausFit_C_Sum_Y = root:HR_sticks:GausFit_C_Sum_Y
		
	wave UnitSigma = root:HR_Sticks:UnitSigma

	wave SigmaOneRunOpen = root:HR_Sticks:SigmaOneRunOpen
	wave SigmaOneRunClosed = root:HR_Sticks:SigmaOneRunClosed
	wave SigmaOneRunDiff = root:HR_Sticks:SigmaOneRunDiff

//	wave HR_BkOneRunOpen = root:HR_sticks:HR_BkOneRunOpen
//	wave HR_BkOneRunClosed = root:HR_sticks:HR_BkOneRunClosed
//	wave HR_BkOneRunDiff = root:HR_sticks:HR_BkOneRunDiff
		
	wave OneRunPeakHeightOpen = root:HR_sticks:OneRunPeakHeightOpen		//1.02A fix
	wave OneRunPeakHeightClosed = root:HR_sticks:OneRunPeakHeightClosed
	wave OneRunPeakHeightDiff = root:HR_sticks:OneRunPeakHeightDiff
	wave OneRunPeakHeightOpenMClosed = root:HR_sticks:OneRunPeakHeightOpenMClosed

	wave ExactMassWave = root:HR_sticks:ExactMassWave
	wave OneRunMassTime = root:HR_sticks:OneRunMassTime			// will have temporary ways

	wave OneRunRawOpenMz= root:HR_sticks:OneRunRawOpenMz		// changed in 1.04J
	wave OneRunRawClosedMz= root:HR_sticks:OneRunRawClosedMz
	wave OneRunRawDiffMz= root:HR_sticks:OneRunRawDiffMz	
	wave OneRunRawSpectraOpen = root:HR_sticks:OneRunRawSpectraOpen
	wave OneRunRawSpectraClosed = root:HR_sticks:OneRunRawSpectraClosed
	wave OneRunRawSpectraDiff = root:HR_sticks:OneRunRawSpectraDiff
		
	//1.05A	
	wave OneRunRawSpectraOpenBkFt = root:HR_sticks:OneRunRawSpectraOpenBkFt
	wave OneRunRawSpectraClosedBkFt = root:HR_sticks:OneRunRawSpectraClosedBkFt
	wave OneRunRawSpectraDiffBkFt = root:HR_sticks:OneRunRawSpectraDiffBkFt

	wave OneRunResidSumOpen = root:HR_Sticks:OneRunResidSumOpen		
	wave OneRunResidSumClosed = root:HR_Sticks:OneRunResidSumClosed			
	wave OneRunResidSumDiff = root:HR_Sticks:OneRunResidSumDiff		

	wave GausFit_D_Y = root:HR_Sticks:GausFit_D_Y		
	wave GausFit_O_Y = root:HR_Sticks:GausFit_O_Y			
	wave GausFit_C_Y = root:HR_Sticks:GausFit_C_Y		

	wave OneRunDisplayHRRegion = root:HR_Sticks:OneRunDisplayHRRegion 
	wave StartPt = root:HR_sticks:StartPt
	wave EndPt = root:HR_sticks:EndPt

	nvar HR_RunVar = root:HR_Panel:HR_RunVar
	
	nvar HR_plotResidualInPercent = root:HR_sticks:HR_plotResidualInPercent
	nvar HR_MaxNumGausFits = root:HR_sticks:HR_MaxNumGausFits
	nvar HR_UsePeakShapeVar = root:HR_Panel:HR_UsePeakShapeVar
	svar HR_FinalPSName = root:HR_PeakShape:HR_FinalPSName
	nvar HR_checkDoNotGrabRawSpectra = root:HR_Panel:HR_checkDoNotGrabRawSpectra		//1.10K
	
	nvar HRSticksDisplayXResolution = root:HR_Sticks:HRSticksDisplayXResolution

	nvar HR_UseOpenClosedMzParams = root:HR_Panel:HR_UseOpenClosedMzParams
	if (HR_UseOpenClosedMzParams)
		wave mz_FitInterceptOpen = root:mzFitting:mz_FitInterceptOpen
		wave mz_FitSlopeOpen = root:mzFitting:mz_FitSlopeOpen
		wave mz_FitPowerOpen = root:mzFitting:mz_FitPowerOpen
		wave mz_FitInterceptClosed = root:mzFitting:mz_FitInterceptClosed
		wave mz_FitSlopeClosed = root:mzFitting:mz_FitSlopeClosed
		wave mz_FitPowerClosed = root:mzFitting:mz_FitPowerClosed
	else
		wave mz_FitInterceptOpen = root:mzFitting:mz_FitIntercept
		wave mz_FitSlopeOpen = root:mzFitting:mz_FitSlope
		wave mz_FitPowerOpen = root:mzFitting:mz_FitPower
		wave mz_FitInterceptClosed = root:mzFitting:mz_FitIntercept
		wave mz_FitSlopeClosed = root:mzFitting:mz_FitSlope
		wave mz_FitPowerClosed = root:mzFitting:mz_FitPower
	endif

 	// 1.05A
 	nvar/z HR_ShowPKplusSQBaselineFits = root:HR_Sticks:HR_ShowPKplusSQBaselineFits
//	if (!NVar_Exists(HR_ShowPKplusSQBaselineFits))
//		variable/g  root:HR_Sticks:HR_ShowPKplusSQBaselineFits=1		//  changed default behavior.
//		nvar HR_ShowPKplusSQBaselineFits = root:HR_Sticks:HR_ShowPKplusSQBaselineFits
//	endif
//	nvar/z HR_UseSqBaseline = root:HR_panel:HR_UseSqBaseline		//1.09H should always be 1
	
	variable thisAMU, sqrt2, numPeaksThisAmu	
	variable slope, intercept, power
 	variable idex, UnitMassIndex, currentRunIndex, pt
	variable PeakWidth, PeakHeight, PeakCenter	 // 1.09H, background, 
	variable UnitMassStartPt = UnitMass[0]
	variable mzStartPnt, mzEndPnt
	  
	UnitMassStartPt = UnitMass[0]
	
	if (UnitMassStartPt>HR_DisplayMz ||UnitMass[numpnts(UnitMass) -1]<HR_DisplayMz)		//1.19E
		return 0
	endif
	
	// gray region display	
	fastop OneRunDisplayHRRegion = 0

	fastop GausFit_D_Sum_Y = 0
	fastop GausFit_O_Sum_Y = 0
	fastop GausFit_C_Sum_Y = 0
	
	currentRunIndex =sq_FindRun(run_series, HR_RunVar)
	UnitMassIndex = HR_DisplayMz - UnitMassStartPt		// have to be careful when indexing... this variable takes care of the offset
	
	if (UnitMassIndex>=numpnts(StartPt) )
		return 0
	endif
	
	OneRunDisplayHRRegion[StartPt[HR_DisplayMz - UnitMassStartPt], EndPt[HR_DisplayMz - UnitMassStartPt]]=1 //  1 is arbitrary, is displayed on right axis

	PeakWidth = UnitSigma[UnitMassIndex]	//1.19A		// be careful.  Here we are assuming that the peak width is held  constant in the fit.
	
	duplicate/o gausFit_X root:HR_sticks:gausFit_XTimeOpen, root:HR_sticks:gausFit_XTimeClosed, root:HR_sticks:gausFit_XTimeDiff
	wave gausFit_XTimeOpen = root:HR_sticks:gausFit_XTimeOpen
	wave gausFit_XTimeClosed = root:HR_sticks:gausFit_XTimeClosed
	wave gausFit_XTimeDiff = root:HR_sticks:gausFit_XTimeDiff
	
	// prepare to calculate guas fit y waves
	UnitMassIndex = HR_DisplayMz - UnitMassStartPt		// have to be careful when indexing... this variable takes care of the offset
//	MassStartPntVar = MassStartPnt[orderedIndex]		// note that these values are dependent upon the exact masses selected
//	MassEndPntVar = MassEndPnt[orderedIndex]

	//1.05A  We fit in time space, 10 pts to the left and right of the min and max mz.
	// we need to get a wave corresponding to the region we fit in mz space
	// use the open m/z fitting parameters to get the region in m/z space, that all gaussian waves will be plotted against, but do the calcs for the
	// gaussians using the separate (if necessary) open, closed m/z parameters
	intercept = mz_FitInterceptClosed[currentRunIndex]
	slope = mz_FitSlopeClosed[currentRunIndex]
	power = mz_FitPowerClosed[currentRunIndex]
//	OneRunMassTime =  intercept+slope*(ExactMassWave^power)
//	TimeStartPnt = round(OneRunMassTime[MassStartPntVar]) - 10 		// starting and ending points in time space
//	TimeEndPnt = round(OneRunMassTime[MassEndPntVar]) +10
	mzStartPnt =  ( (StartPt[UnitMassIndex] - intercept)/slope)^(1/power)		// starting and ending points in mz space
	mzEndPnt = ( (EndPt[UnitMassIndex]*1.0001 - intercept)/slope)^(1/power)					//1.19B
	// 1.14I  we do not care if the intercept is positive...

	// initialize gaus fit x waves - gausFit_X is independent of m/z calibration
//	gausFit_X = HR_DisplayMz   - 0.25+ p*(.5/HRSticksDisplayXResolution)		// changed in 1_05.A display wider view default is HRSticksDisplayXResolution = 3001
	gausFit_X = mzStartPnt  + p*((mzEndPnt -mzStartPnt) /HRSticksDisplayXResolution)		// changed in 1.04B
	 
	sqrt2 = sqrt(2)
	thisAMU = HR_DisplayMz
	numPeaksThisAmu=min(HR_MaxNumGausFits, numOfPeaks[UnitMassIndex])

	//1.10K
	wave PeakShape = $"root:HR_peakshape:"+HR_FinalPSName
//	if (HR_checkDoNotGrabRawSpectra)
//		duplicate/o PeakShape PeakShapeBlurred
//		wave todoPtHistMatrix = root:HR_sticks:todoPtHistMatrix		// 2D matrix rows  = mz, cols are normalized point histograms  1.10K
//		make/o/n=(dimSize(todoPtHistMatrix,1)) mzhist
//		mzhist = todoPtHistMatrix[thisAMU-UnitMassStartPt][p]
//		Convolve mzhist, PeakShapeBlurred
//		SetScale/P x -7.5,0.05,"", PeakShapeBlurred		// the convolution makes the scaling wrong
//		wave PeakShape = PeakShapeBlurred
//	endif
	
 	 // 1.05A
// 	if(HR_ShowPKplusSQBaselineFits) 		// 1.09H	// get the squirrel baseline values onto the same x axis as the gauss fit waves
 		duplicate/o gausFit_X root:HR_Sticks:gausFit_X_sqOpenBaseline, root:HR_Sticks:gausFit_X_sqClosedBaseline, root:HR_Sticks:gausFit_X_sqDiffBaseline
		wave gausFit_X_sqOpenBaseline = root:HR_Sticks:gausFit_X_sqOpenBaseline
		wave gausFit_X_sqClosedBaseline = root:HR_Sticks:gausFit_X_sqClosedBaseline
		wave gausFit_X_sqDiffBaseline = root:HR_Sticks:gausFit_X_sqDiffBaseline
 		gausFit_X_sqOpenBaseline  = interp(gausFit_X[p], OneRunRawOpenMz, OneRunRawSpectraOpenBkFt )
 		gausFit_X_sqClosedBaseline  = interp(gausFit_X[p], OneRunRawClosedMz, OneRunRawSpectraClosedBkFt )
 		gausFit_X_sqDiffBaseline  = interp(gausFit_X[p], OneRunRawDiffMz, OneRunRawSpectraDiffBkFt )
//	endif

	// find the gaus y waves
	if (numPeaksThisAmu>0)
	 	// OPEN
 //		if (HR_UseSqBaseline)
 //			background = 0
//		else
// 			background = HR_BkOneRunOpen[UnitMassIndex]
//		endif
		
		PeakWidth = SigmaOneRunOpen[UnitMassIndex]			// Use the peak width from the in the fit *NOT* from the linear m/z formula.
				
		intercept = mz_FitInterceptOpen[currentRunIndex]
		slope = mz_FitSlopeOpen[currentRunIndex]
		power = mz_FitPowerOpen[currentRunIndex]
		gausFit_XTimeOpen = intercept + slope*gausFit_X^power
		OneRunMassTime =  intercept+slope*(ExactMassWave^power)
		// 1.14I  we do not care if the intercept is positive...

		variable PSminX = DimOffset(PeakShape, 0)
		variable PSmaxX = PSminX+(numpnts(PeakShape)-1)*DimDelta(PeakShape, 0)
		make/free/o/n=(numpnts(gausFit_XTimeOpen)) PeakShapeIndex, mytempWave
		
		GausFit_O_Y=nan
		for (idex=0;idex<numPeaksThisAmu;idex+=1)
//	 		wave gausY = $"root:HR_Sticks:GausFit_O_"+sq_num2str2char(idex)+"_Y"
			PeakHeight = OneRunPeakHeightOpen[ UnitMassNumPeakSum[UnitMassIndex]+ idex]		// kinda tricky
			PeakCenter = OneRunMassTime[ UnitMassNumPeakSum[UnitMassIndex]+ idex]
			mytempWave = (gausFit_XTimeOpen[p] - PeakCenter)/ (PeakWidth)
	 		PeakShapeIndex = limit(mytempWave[p], PSminX, PSmaxX)
			if (HR_UsePeakShapeVar)
				GausFit_O_Y[][idex] = PeakHeight * PeakShape(PeakShapeIndex[p])
			else
				GausFit_O_Y[][idex]  = PeakHeight*exp(-PeakShapeIndex[p]^2)
			endif
			GausFit_O_Sum_Y+=GausFit_O_Y[p][idex] 
//	 		GausFit_O_Y[][idex] +=background			// when using squirrel baseline, background= 0
		 	 // 1.05A
//	 		if(HR_ShowPKplusSQBaselineFits  && HR_UseSqBaseline)
		 		GausFit_O_Y[][idex] +=gausFit_X_sqOpenBaseline[p]			// when using squirrel baseline, background= 0	
//			endif
	 	endfor
	 	
//		for (idex=numPeaksThisAmu;idex<HR_MaxNumGausFits;idex+=1)
//	 		wave gausY = $"root:HR_Sticks:GausFit_O_"+sq_num2str2char(idex)+"_Y"
//	 		gausY=nan
//	 	endfor
	 	
//	 	GausFit_O_Sum_Y+=background // be careful to  deal with background only once
	 	// 1.05A
//	 	if(HR_ShowPKplusSQBaselineFits  && HR_UseSqBaseline)
	 		GausFit_O_Sum_Y+=gausFit_X_sqOpenBaseline // be careful to  deal with background only once
//		endif

	 	// CLOSED
 //		if (HR_UseSqBaseline)
// 			background = 0
//		else
// 			background = HR_BkOneRunClosed[UnitMassIndex]
//		endif
 		PeakWidth = SigmaOneRunClosed[UnitMassIndex]			// Use the peak width from the in the fit *NOT* from the linear m/z formula.

		intercept = mz_FitInterceptClosed[currentRunIndex]
		slope = mz_FitSlopeClosed[currentRunIndex]
		power = mz_FitPowerClosed[currentRunIndex]
		gausFit_XTimeClosed= intercept + slope*gausFit_X^power
		OneRunMassTime =  intercept+slope*(ExactMassWave^power)
		// 1.14I  we do not care if the intercept is positive...

		GausFit_C_Y=nan
		for (idex=0;idex<numPeaksThisAmu;idex+=1)
			PeakHeight = OneRunPeakHeightClosed[ UnitMassNumPeakSum[UnitMassIndex]+ idex]		// kinda tricky
			PeakCenter = OneRunMassTime[ UnitMassNumPeakSum[UnitMassIndex]+ idex]
			mytempWave = (gausFit_XTimeClosed[p] - PeakCenter)/ (PeakWidth)
	 		PeakShapeIndex = limit(mytempWave[p], PSminX, PSmaxX)
			if (HR_UsePeakShapeVar)		// bug fix 1.08D
				GausFit_C_Y[][idex] = PeakHeight * PeakShape(PeakShapeIndex[p])/// *exp(-((gausFit_XTimeClosed[p]-PeakCenter)/PeakWidth)^2)  * PeakShape((gausFit_XTimeClosed[p] - PeakCenter)/ (PeakWidth))
			else
				GausFit_C_Y[][idex]  = PeakHeight*exp(-(PeakShapeIndex[p])^2)
			endif
			GausFit_C_Sum_Y+= GausFit_C_Y[p][idex] 
//	 		GausFit_C_Y[][idex] +=background
		 	 // 1.05A
//	 		if(HR_ShowPKplusSQBaselineFits && HR_UseSqBaseline)
		 		GausFit_C_Y[][idex] +=gausFit_X_sqClosedBaseline[p]			// when using squirrel baseline, background= 0	
//			endif
	 	endfor
	 	
//	 	GausFit_C_Sum_Y+=background // be careful to deal with background only once
	 	// 1.05A
//	 	if(HR_ShowPKplusSQBaselineFits  && HR_UseSqBaseline)
		 	GausFit_C_Sum_Y+=gausFit_X_sqClosedBaseline // be careful to deal with background only once
//		endif
	
		// DIFF	we always use open m/z params for diff
		intercept = mz_FitInterceptOpen[currentRunIndex]
		slope = mz_FitSlopeOpen[currentRunIndex]
		power = mz_FitPowerOpen[currentRunIndex]
		gausFit_XTimeDiff = intercept + slope*gausFit_X^power
		OneRunMassTime =  intercept+slope*(ExactMassWave^power)
		// 1.14I  we do not care if the intercept is positive...
		
		fastop GausFit_D_Y= (nan)
		if (HR_UseOpenClosedMzParams)		// we are using separate open and closed m/z params
			GausFit_D_Y = GausFit_O_Y - GausFit_C_Y
			GausFit_D_Sum_Y = GausFit_O_Sum_Y - GausFit_C_Sum_Y
			// 1.08D fix
//			for (idex=0;idex<numPeaksThisAmu;idex+=1)
//				GausFit_D_Sum_Y +=GausFit_D_Y[p][idex]
//			endfor
		else			
//	 		if (HR_UseSqBaseline)
//	 			background = 0
//			else
//	 			background = HR_BkOneRunDiff[UnitMassIndex]
//			endif
			for (idex=0;idex<numPeaksThisAmu;idex+=1)
				PeakHeight = OneRunPeakHeightDiff[ UnitMassNumPeakSum[UnitMassIndex]+ idex]		// kinda tricky
				PeakCenter = OneRunMassTime[ UnitMassNumPeakSum[UnitMassIndex]+ idex]
				mytempWave = (gausFit_XTimeDiff[p] - PeakCenter)/ (PeakWidth)
	 			PeakShapeIndex = limit(mytempWave[p], PSminX, PSmaxX)
				if (HR_UsePeakShapeVar)
					GausFit_D_Y[][idex] = PeakHeight * PeakShape(PeakShapeIndex[p])// *exp(-((gausFit_XTimeDiff[p]-PeakCenter)/PeakWidth)^2) * PeakShape((gausFit_XTimeDiff[p] - PeakCenter)/ (PeakWidth ))
				else
					GausFit_D_Y[][idex] = PeakHeight*exp(-(PeakShapeIndex[p])^2)
				endif
				GausFit_D_Sum_Y += GausFit_D_Y[p][idex]
//		 		GausFit_D_Y[][idex]+=background
			 	 // 1.05A
//		 		if(HR_ShowPKplusSQBaselineFits && HR_UseSqBaseline)
			 		GausFit_D_Y[][idex] +=gausFit_X_sqDiffBaseline[p]		// when using squirrel baseline, background= 0	
//				endif
		 	endfor
//	 		GausFit_D_Sum_Y+=background		// be careful to  deal with background only once
		 	// 1.05A
//		 	if(HR_ShowPKplusSQBaselineFits  && HR_UseSqBaseline)
		 		GausFit_D_Sum_Y+=gausFit_X_sqDiffBaseline		// be careful to  deal with background only once
//			endif
	 	endif
	 			
	else // we do not have peaks at this mass
	
		fastop GausFit_D_Y=(nan)
		fastop GausFit_O_Y=(nan)
		fastop GausFit_C_Y=(nan)
		
		fastop GausFit_D_Sum_Y=(nan)
		fastop GausFit_O_Sum_Y=(nan)
		fastop GausFit_C_Sum_Y=(nan)

	 endif
	 	
End


// consolidated in 1.47H

Function HR_ConvertExactMassName()

	Wave/t ExactMassText_All = root:HR:ExactMassText_All 
	Wave/t ExactMassTag_All = root:HR:ExactMassTag_All 
	
	HR_ConvertTextToTag(ExactMassText_All, ExactMassTag_All)

End


//1.12N
// Creates or overwrite ExactMassTag_All
Function HR_ConvertTextToTag(textWave, tagWave)
wave/t textWave, tagWave
	
	string str, char, subStr, tagStr, tempStr, tagStrSuffix
	variable positionA, positionB, idex, length, num, tempA, tempB
	
	num=numpnts(textWave)		//1.12N
	redimension/n=(num)  tagWave
		
	for(idex=0;idex<num;idex+=1)
		str = textWave[idex]
		tagStr = ""
		tagStrSuffix=""
		length = strlen(str)
		
		// deal with wierdo Cobalt first		//1.04J
		if(cmpstr(str, "Co", 1)==0)
			tagWave[idex] = "Cobalt"
			continue
		endif
				
		// deal with easy pluses
		positionA = strsearch(str, "plus", 0)
		if (positionA>0)		// we have a plus only
			if (stringmatch("2", str[positionA+4])==1)
				str = ReplaceString("plus2",str, "" )
				tagStrSuffix = "\\S++\\M" 
			else
				str = ReplaceString("plus",str, "" )
				tagStrSuffix = "\\S+\\M" 
			endif
		endif

		for (positionA=0;positionA<length;positionA+=1)	
			char = str[positionA]
			if (stringmatch("j", char)==1)
				positionB = positionA		//	positionA is the first number
				do
					positionB+=1
					subStr = str[positionB]	
				while(positionB < length && strsearch("0123456789",subStr,0)>=0)//	positionB is the last number
				positionB-=1
				
				tempStr ="\\S"+str[positionA+1, positionB] +"\\M"
				tagstr+=tempstr
				positionA=positionB		// positionA will have another value added to it in the for loop 
						
			elseif ( strsearch("0123456789",char,0)>=0) // we have a number
				positionB = positionA		//	positionA is the first number
				do
					positionB+=1
					subStr = str[positionB]	
				while(positionB < length && strsearch("0123456789",subStr,0)>=0)//	positionB is the last number
				positionB-=1
				
				tempStr ="\\B"+str[positionA, positionB] +"\\M"				
				tagstr+=tempstr				
				positionA=positionB		// positionA will have another value added to it in the for loop 
			else
				tagstr+=char
			endif
		endfor
		
		//  aahh, finally
		
		tagWave[idex] = tagStr + tagStrSuffix

	endfor

End


Function SticksGr_check_ShowResidOnRaw(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_ShowResidOnRawAxes = root:HR_Sticks:HR_ShowResidOnRawAxes

	ModifyGraph hideTrace(OneRunResidSpectraDiff#1)=!HR_ShowResidOnRawAxes
	ModifyGraph hideTrace(OneRunResidSpectraOpen#1)=!HR_ShowResidOnRawAxes
	ModifyGraph hideTrace(OneRunResidSpectraClosed#1)=!HR_ShowResidOnRawAxes

End


// Functionality removed in 1.09H
//Function SticksGr_check_OffsetPeakHts(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//
////	nvar HR_ShowOffsetPeakHts = root:HR_Sticks:HR_ShowOffsetPeakHts
//	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
//	wave UnitMass = root:HR_Sticks:UnitMass
//
//	variable UnitMassIndex
//	UnitMassIndex = HR_DisplayMz - UnitMass[0]
//	if (HR_ShowOffsetPeakHts)
//		// A somewhat devious way to get at the baseline constant value
//		wave HR_BkOneRunDiff = root:HR_Sticks:HR_BkOneRunDiff
//		wave HR_BkOneRunOpen = root:HR_Sticks:HR_BkOneRunOpen
//		wave HR_BkOneRunClosed = root:HR_Sticks:HR_BkOneRunClosed
//		ModifyGraph offset(OneRunPeakHeightOpenMClosed)={0,HR_BkOneRunDiff[UnitMassIndex]}
//		ModifyGraph offset(OneRunPeakHeightDiff)={0,HR_BkOneRunDiff[UnitMassIndex]}
//		ModifyGraph offset(OneRunPeakHeightOpen)={0,HR_BkOneRunOpen[UnitMassIndex]}
//		ModifyGraph offset(OneRunPeakHeightClosed)={0,HR_BkOneRunClosed[UnitMassIndex]}
//	else
//		ModifyGraph offset(OneRunPeakHeightOpenMClosed)={0,0}
//		ModifyGraph offset(OneRunPeakHeightDiff)={0,0}
//		ModifyGraph offset(OneRunPeakHeightOpen)={0,0}
//		ModifyGraph offset(OneRunPeakHeightClosed)={0,0}
//	endif
//
//End


// 1.22A no longer used, left in because of backwards compatibility
Function SticksGr_check_ShowOpenMClosed(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_ShowDiffEqOMC = root:HR_Sticks:HR_ShowDiffEqOMC
	if (!HR_ShowDiffEqOMC)
		ModifyGraph hideTrace(OneRunPeakHeightOpenMClosed)=1
	else
		ModifyGraph hideTrace(OneRunPeakHeightOpenMClosed)=0
	endif

End


// Used with Sticks_gr
Function SticksGr_AppendChosenMassTags()
	
	wave /T ExactMassText = root:HR_Sticks:ExactMassText
	wave /T ExactMassTag= root:HR_Sticks:ExactMassTag
	wave ExactMassWave = root:HR_Sticks:ExactMassWave

	variable idex, num
	string fragStr
	
	num=numpnts(ExactMassWave)
	for(idex=0; idex < num; idex +=1)
		fragStr = ExactMassText[idex]
		Tag/C/N=$fragStr/I=1/L=2/F=0/X=0.00/Y=2.00/A=MB/G=(0,0,0) bottom , ExactMassWave[idex], ExactMassTag[idex]
		if (strsearch(fragstr, "j", 0)>=0)
			Tag/C/N=$fragStr/TL={sharp=1,lineRGB=(34816,34816,34816)}
		endif
	endfor

End 


Function SticksGr_check_ShowAllTags(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_ShowAllTags = root:HR_Sticks:HR_ShowAllTags
	HR_ShowAllTags=checked==1
	HR_ExactMassTagsAll(HR_ShowAllTags)

End


//Function HR_ck_TimeSeriesOption(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//
//	nvar HR_TimeSeriesClosed = root:HR_Panel:HR_TimeSeriesClosed
//	nvar HR_TimeSeriesOpen = root:HR_Panel:HR_TimeSeriesOpen
//	nvar HR_TimeSeriesDiff = root:HR_Panel:HR_TimeSeriesDiff
//
//	if (strsearch(ctrlName, "Closed",0)>0)
//		HR_TimeSeriesClosed=1
//		HR_TimeSeriesOpen=0
//		HR_TimeSeriesDiff=0
//	elseif(strsearch(ctrlName, "Open",0)>0)
//		HR_TimeSeriesClosed=0
//		HR_TimeSeriesOpen=1
//		HR_TimeSeriesDiff=0
//	else
//		HR_TimeSeriesClosed=0
//		HR_TimeSeriesOpen=0
//		HR_TimeSeriesDiff=1
//	endif
//	
//End


Function HR_butt_SetMzForOpenClosed(ctrlName) : ButtonControl
	String ctrlName

	wave mz_FitIntercept = root:mzFitting:mz_FitIntercept
	wave mz_FitSlope = root:mzFitting:mz_FitSlope
	wave mz_FitPower = root:mzFitting:mz_FitPower
	
	string ClosedOrOpenStr
	if (strsearch(ctrlName, "losed", 0)>=0)
		duplicate/o mz_FitIntercept root:MzFitting:mz_FitInterceptClosed
		duplicate/o mz_FitSlope root:MzFitting:mz_FitSlopeClosed
		duplicate/o mz_FitPower root:MzFitting:mz_FitPowerClosed
		ClosedOrOpenStr = "closed"
	else
		duplicate/o mz_FitIntercept root:MzFitting:mz_FitInterceptOpen
		duplicate/o mz_FitSlope root:MzFitting:mz_FitSlopeOpen
		duplicate/o mz_FitPower root:MzFitting:mz_FitPowerOpen
		ClosedOrOpenStr="open"
	endif
	
	print "// The current mz fit parameters were set to be used for these spectra: "+ClosedOrOpenStr

End


Function HR_check_UseOC_Mz(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	if (checked)		// just check the Interecpt param and assume if one exists all 3 do.
		nvar HR_UseOpenClosedMzParams = root:HR_Panel:HR_UseOpenClosedMzParams
		wave/z mz_FitInterceptO =root:MzFitting:mz_FitInterceptOpen
		wave/z mz_FitInterceptC =root:MzFitting:mz_FitInterceptClosed
		if (!WaveExists(mz_FitInterceptO) || !WaveExists(mz_FitInterceptC) )
			HR_UseOpenClosedMzParams=0
			abort "Could not find the separate m/z fitting parameters for Open and Closed.  See step 0B. -Aborting from HR_check_UseOC_Mz"
		endif			
	endif
	
End


////////////////////////////////////////////////////////////////////////////////////////////
// Functions used when making a rough average via the HR panel
Function RA_butt_makeRoughAvgs(controlname) : ButtonControl
string controlname

	nvar RA_UseCurrentToDo = root:IndividAndAvgSpectra:RA_UseCurrentToDo
	nvar RA_UseConsecutiveRuns = root:IndividAndAvgSpectra:RA_UseConsecutiveRuns
	nvar RA_RunStart = root:IndividAndAvgSpectra:RA_RunStart
	nvar RA_RunStop = root:IndividAndAvgSpectra:RA_RunStop
	nvar RA_PutAvgPrepSticks = root:IndividAndAvgSpectra:RA_PutAvgPrepSticks
	nvar RA_PlotAvgs = root:IndividAndAvgSpectra:RA_PlotAvgs
	nvar RA_SaveIndividRuns = root:IndividAndAvgSpectra:RA_SaveIndividRuns

	string temp_toDo_makeFromName_sv,  temp_toDo_makeFromRuns_sv, temp_sq_toDoWvNm, strtmp
	
	svar toDo_makeFromRuns_sv=root:panel:toDo_makeFromRuns_sv
	svar toDo_makeFromName_sv=root:panel:toDo_makeFromName_sv
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm

	if (RA_UseCurrentToDo==1)		
		wave RA_todoWave = $"root:"+sq_toDoWvNm
	else
		if (RA_RunStop<RA_RunStart)
			Abort "The start run number must be smaller than the stop run number."
		endif
			
		temp_sq_toDoWvNm= sq_toDoWvNm
		temp_toDo_makeFromName_sv = toDo_makeFromName_sv
		temp_toDo_makeFromRuns_sv = toDo_makeFromRuns_sv
		toDo_makeFromName_sv = "RA_todoWave"
		toDo_makeFromRuns_sv = num2str(RA_RunStart) + "-" + num2str(RA_RunStop)
		sq_butt_ToDoFromRuns("") 
		wave RA_todoWave = $"root:RA_todoWave"
	endif

	sq_RoughAvgRawSpec(RA_todoWave, "IndividAndAvgSpectra", RA_SaveIndividRuns)
	
	if (RA_PutAvgPrepSticks)	
		wave AvgDiff = root:IndividAndAvgSpectra:AvgDiff
		wave AvgOpen = root:IndividAndAvgSpectra:AvgOpen
		wave AvgClosed = root:IndividAndAvgSpectra:AvgClosed
		wave AvgMz= root:IndividAndAvgSpectra:AvgMz
	
		duplicate/o AvgDiff root:HR_sticks:OneRunRawSpectraDiff
		duplicate/o AvgOpen root:HR_sticks:OneRunRawSpectraOpen
		duplicate/o AvgClosed root:HR_sticks:OneRunRawSpectraClosed
		duplicate/o AvgMz root:HR_sticks:OneRunRawMz
	endif

	if (RA_PlotAvgs)
		RA_PlotRoughAvgRawSpec(RA_todoWave, "IndividAndAvgSpectra")
	endif
	
	if (RA_UseConsecutiveRuns==1)		
		Killwaves RA_todoWave
		toDo_makeFromName_sv = temp_toDo_makeFromName_sv
		toDo_makeFromRuns_sv = temp_toDo_makeFromRuns_sv
		sq_pop_toDoList("",0,"Get List")
		strtmp=SQ_getTODOwaves()
		sq_pop_toDoList("",FindListItem(sq_toDoWvNm, strtmp), sq_toDoWvNm)
	endif

End


Function RA_PlotRoughAvgRawSpec(ToDoWave, DataFolderName)
wave ToDoWave
string DataFolderName

	wave AvgMz = $"root:"+DataFolderName+":AvgMz"
	variable kdex, idex, num, RunNum
	string whichRaw
	
	num = numpnts(ToDoWave)
	if (num>30)
		DoAlert 1, "There are over 30 raw spectra in this plot. Are you sure you want to continue?" 
		if (V_flag ==2)		// No
			return 0
		endif
	endif
	
	for(kdex=0;kdex<3;kdex+=1)
	 	whichRaw = StringFromList(kdex, "Open;Closed;Diff")
	 	Display as "AverageRaw"+whichRaw 
 		for (idex=0;idex<num;idex+=1)
			RunNum = ToDoWave[idex]
			wave AvgWave =  $"root:"+DataFolderName+":"+whichRaw+"_"+Num2str(RunNum)
			AppendToGraph AvgWave vs AvgMz
		endfor
		Legend/C/N=text0/F=0/A=MC
		sq_RainbowizeTraces()
		wave AvgWave =  $"root:"+DataFolderName+":Avg"+whichRaw
		AppendToGraph AvgWave vs AvgMz
		ModifyGraph lsize($NameofWave(AvgWave))=3,rgb($NameofWave(AvgWave))=(0,0,0)
	endfor

End


Function RA_Initialize()
	
	DoWindow/F RA_MakeRoughAveragePanel
	if (V_flag==1)
		return 0
	endif
	
	if(!DataFolderExists("IndividAndAvgSpectra")  )
		
		NewDataFolder/o root:IndividAndAvgSpectra
		
		variable/g root:IndividAndAvgSpectra:RA_UseCurrentToDo = 1
		variable/g root:IndividAndAvgSpectra:RA_UseConsecutiveRuns = 0
		variable/g root:IndividAndAvgSpectra:RA_RunStart = 0
		variable/g root:IndividAndAvgSpectra:RA_RunStop = 0
		variable/g root:IndividAndAvgSpectra:RA_PutAvgPrepSticks = 1
		variable/g root:IndividAndAvgSpectra:RA_PlotAvgs = 0
		variable/g root:IndividAndAvgSpectra:RA_SaveIndividRuns = 0
		
		string/g root:IndividAndAvgSpectra:RA_Disclaimer
		string/g root:IndividAndAvgSpectra:RA_GeneralInfo
		
		svar RA_Disclaimer= root:IndividAndAvgSpectra:RA_Disclaimer
		RA_Disclaimer = ""
		RA_Disclaimer += "A rough raw spectrum average is a simple point-wise average\r"
		RA_Disclaimer += "of all the open, closed and difference raw spectra. If there is any\r"
		RA_Disclaimer += "considerable change in the m/z calibration during these runs\r"
		RA_Disclaimer += "this average will smear out the peaks.\r\r"
		RA_Disclaimer += "Raw spectra and averages are placed in a data folder called\r"
		RA_Disclaimer += "IndividAndAvgSpectra."

		svar RA_GeneralInfo= root:IndividAndAvgSpectra:RA_GeneralInfo
		RA_GeneralInfo = "If the user does not want squirrel to retrieve the spectra indicated\r"
		RA_GeneralInfo += "by the run number in the panel, but instead use other values\r"
		RA_GeneralInfo += "there are two methods to go about this.\r"
		RA_GeneralInfo += "\r"
		RA_GeneralInfo += "(1) The user can manually input values into three waves which\r"
		RA_GeneralInfo += "reside in the HR_Sticks folder: OneRunRawSpectraClosed, \r"
		RA_GeneralInfo += "OneRunRawSpectraOpen, OneRunRawSpectraDiff\r"
		RA_GeneralInfo += "Be aware that the code will use the m/z fitting parameters\r"
		RA_GeneralInfo += "for the run indicated in the panel.\r"
		RA_GeneralInfo += "\r"
		RA_GeneralInfo += "(2) The user can create an average spectra of contiguous runs\r"
		RA_GeneralInfo += "(i.e. runs 30-42) or all runs in a todo wave.  This method is\r "
		RA_GeneralInfo += "outlined in the Rough Averages Tool below."				
		
	endif
	
	RA_MakeRoughAveragePanel_create()

End


Function RA_MakeRoughAveragePanel_create()

	PauseUpdate; Silent 1		// building window...
	NewPanel/N=RA_MakeRoughAveragePanel /W=(448,72,824,638) as "RA_MakeRoughAveragePanel"
	SetDrawLayer UserBack
	SetDrawEnv linethick= 3,linefgc= (65280,0,0),fillpat= 0,fillfgc= (56576,56576,56576)
	DrawRect 5,535,337,238
	SetDrawEnv fsize= 24
	DrawText 19,274,"Make Rough Averages Tool"
	SetDrawEnv linethick= 3,linefgc= (0,52224,0),fillpat= 0,fillfgc= (60928,60928,60928)
	DrawRect 5,9,335,230
	SetDrawEnv fsize= 24
	DrawText 19,41,"Do Not Access Spectra Info"
	TitleBox title_generalInfo,pos={15,44},size={313,177}
	TitleBox title_generalInfo,variable= root:IndividAndAvgSpectra:RA_GeneralInfo
	CheckBox RA_check_UseCurrentToDo,pos={12,384},size={129,14},proc=RA_ck_UseCurrent,title="Use current  todo wave"
	CheckBox RA_check_UseCurrentToDo,variable= root:IndividAndAvgSpectra:RA_UseCurrentToDo,mode=1
	TitleBox RA_title,pos={145,401},size={18,21},variable= root:panel:sq_toDoWvNm
	CheckBox RA_ck_UseConsecutiveRuns,pos={12,401},size={121,14},proc=RA_ck_UseCurrent,title="Use consecutive runs"
	CheckBox RA_ck_UseConsecutiveRuns,variable= root:IndividAndAvgSpectra:RA_UseConsecutiveRuns,mode=1
	SetVariable RA_setvar_start,pos={151,423},size={120,16},title="RunStart"
	SetVariable RA_setvar_start,value= root:IndividAndAvgSpectra:RA_RunStart
	SetVariable RA_setvar_stop,pos={152,441},size={120,16},title="RunStop"
	SetVariable RA_setvar_stop,value= root:IndividAndAvgSpectra:RA_RunStop
	CheckBox RA_ck_Plot,pos={13,492},size={124,14},title="Show plot of averages"
	CheckBox RA_ck_Plot,variable= root:IndividAndAvgSpectra:RA_PlotAvgs
	CheckBox RA_ck_put,pos={13,456},size={213,14},title="Put averages in waves for HR sticks calc"
	CheckBox RA_ck_put,variable= root:IndividAndAvgSpectra:RA_PutAvgPrepSticks
	CheckBox RA_ck_Kill,pos={13,475},size={133,14},proc=RA_ck_PlotAvgs,title="Save individual raw runs"
	CheckBox RA_ck_Kill,variable= root:IndividAndAvgSpectra:RA_SaveIndividRuns
	Button RA_butt,pos={45,511},size={120,20},proc=RA_butt_makeRoughAvgs,title="Make rough averages"
	TitleBox RA_title_disclaim,pos={14,276},size={310,99}
	TitleBox RA_title_disclaim,variable= root:IndividAndAvgSpectra:RA_Disclaimer
	Button RA_butt_End,pos={301,543},size={40,20},proc=RA_butt_end,title="End"

End



Function RA_butt_end(ctrlName) : ButtonControl
	String ctrlName
	DoWIndow/K RA_MakeRoughAveragePanel
End


// Function in Rough Average Panel
Function RA_ck_UseCurrent(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar RA_UseCurrentToDo = root:IndividAndAvgSpectra:RA_UseCurrentToDo
	nvar RA_UseConsecutiveRuns = root:IndividAndAvgSpectra:RA_UseConsecutiveRuns
	
	if (strsearch(ctrlName, "urrent", 0)>=0) 		// don't deal with capital letters
		RA_UseCurrentToDo=1
		RA_UseConsecutiveRuns = 0
	else
		RA_UseCurrentToDo=0
		RA_UseConsecutiveRuns = 1
	endif

End


// Function in Rough Average Panel
Function RA_ck_PlotAvgs(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar RA_PlotAvgs = root:IndividAndAvgSpectra:RA_PlotAvgs
	nvar RA_SaveIndividRuns = root:IndividAndAvgSpectra:RA_SaveIndividRuns
	
	if (RA_SaveIndividRuns) 		// don't deal with capital letters
		CheckBox RA_ck_Plot disable = 0
	else
		RA_PlotAvgs=0
		CheckBox RA_ck_Plot disable = 1
	endif

End


// *************************************************
// Will change the colors of the first 27 traces on the topmost graph

Function sq_RainbowizeTraces()

	DoUpdate
	
	string traceStr, traceList
	variable idex, num

	traceList = TraceNameList("", ";", 1)
	num = ItemsInList(traceList)
	sq_MakeRainbowColorTable()
	WAVE RainbowColorTable = $"root:panel:RainbowColorTable"
	
	for (idex=0; idex<num; idex+=1)
		traceStr = StringFromList(idex,traceList,  ";")
		ModifyGraph rgb($traceStr)=(RainbowColorTable[mod(idex,26)][0],RainbowColorTable[mod(idex,26)][1],RainbowColorTable[mod(idex,26)][2]);DelayUpdate
	endfor
	
	Killwaves/z RainbowColorTable

End


////////////////////////////////////////////////////////////////////////////////////////////
//  Functions used in the control panel section of the Sticks_gr window
// 1.08E
// Functionality removed in 1.09H
//Function SticksGr_check_showResidErrors(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//
//	if (checked)
//		//1.08E Doug doesn't want
//		ErrorBars/T=2/Y=15 OneRunPeakHeightDiff Y,wave=(root:HR_Sticks:OneRunResidNoiseDiff,root:HR_Sticks:OneRunResidNoiseDiff)
//		ErrorBars/T=2/Y=15 OneRunPeakHeightOpen Y,wave=(root:HR_Sticks:OneRunResidNoiseOpen,root:HR_Sticks:OneRunResidNoiseOpen)
//		ErrorBars/T=2/Y=15 OneRunPeakHeightClosed Y,wave=(root:HR_Sticks:OneRunResidNoiseClosed,root:HR_Sticks:OneRunResidNoiseClosed)
//		//1.08E Doug doesn't want
//	else
//		ErrorBars OneRunPeakHeightDiff OFF 
//		ErrorBars OneRunPeakHeightOpen OFF 
//		ErrorBars OneRunPeakHeightClosed OFF 
//	endif
//
//End


//Functionality killed in 1.09H
//Function SticksGr_check_DisplayInsets(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//
//	nvar HR_ShowInsets=root:HR_Sticks:HR_ShowInsets
//	
//	if (HR_ShowInsets)
// 		UM_PlotIntMassSpectra("Diff", 0)
//  		UM_PlotIntMassSpectra("Open", 0)
// 		UM_PlotIntMassSpectra("Closed", 0)
//
//		ModifyGraph axisEnab(UnitStickBottom)={0.05,0.20}
//		ModifyGraph axisEnab(UnitStickOpen)={0.8,0.9}
//		ModifyGraph axisEnab(UnitStickClosed)={0.5,0.6}
//		ModifyGraph axisEnab(UnitStickDiff)={0.2,0.3}
//		
//		ModifyGraph freePos(UnitStickBottom)=-345
//		ModifyGraph freePos(UnitStickOpen)=-22, freePos(UnitStickClosed)=-22, freePos(UnitStickDiff)=-22
//		ModifyGraph tick(UnitStickClosed)=2, tick(UnitStickDiff)=2,tick(UnitStickOpen)=2
//		ModifyGraph btLen(UnitStickBottom)=2,btLen(UnitStickDiff)=2,btLen(UnitStickOpen)=2, btLen(UnitStickClosed)=2
//
//		ModifyGraph fSize(UnitStickDiff)=8, fSize(UnitStickOpen)=8, fSize(UnitStickClosed)=8, fSize(UnitStickBottom)=8
//
//	else
//		HR_RemoveUnitStickInsetGraphs()
//	endif
//		
//	nvar HR_DisplayMz = root:HR_sticks:HR_DisplayMz
//	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth
//	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth)
//
//End


Function HR_RemoveUnitStickInsetGraphs()
	
	variable idex, num
	string wlist, wstr
	
	wlist = TraceNameList("", ";", 1)
	num=itemsInList(wlist)
	for (idex=0;idex<num;idex+=1)
		wstr=StringFromList(idex, wlist )
		if (stringMatch(wstr[0,3], "int_") ||  strsearch(wstr, "_p_OneSpectra", 0)>=0)
			wave w = TraceNameToWaveRef("", wstr )
			removeFromGraph $NameOfWave(w)
		endif
	endfor
	
End


Function SticksGr_check_SameYscale(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_DisplayMz = root:HR_sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth
	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth)

End


Function SticksGr_check_HorizGrids(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_showHorGrids = root:HR_Sticks:HR_ShowHorGrids
	
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks01)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks01#1)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks01#2)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks1)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks1#1)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks1#2)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks10)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks10#1)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks10#2)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks100)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks100#1)=!HR_showHorGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(gridMarks100#2)=!HR_showHorGrids

End


Function SticksGr_check_VertGrids(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_showVerGrids = root:HR_Sticks:HR_showVerGrids

	ModifyGraph/W=HR_PeakHeights_gr hideTrace(OneRunDisplayVertGrid)=!HR_showVerGrids
	ModifyGraph/W=HR_PeakHeights_gr hideTrace(OneRunDisplayHRRegion)=!HR_showVerGrids

End

////////////////////////////////////////////////////////////////////////////////////////////
//1.17G
// A table for seeing the grouping of exact masses into unit masses.  
// Currently not callable from a panel.
//Window UnitMassTable() : Table
//	PauseUpdate; Silent 1		// building window...
//	String fldrSav0= GetDataFolder(1)
//	SetDataFolder root:HR_Sticks:
//	Edit/W=(190.2,125.6,801,546.2) UnitMass,numOfPeaks,UnitSigma
//	ModifyTable width(UnitMass)=42,width(numOfPeaks)=53
//	SetDataFolder fldrSav0
//EndMacro
//
//// A table for viewing diff sticks from one run
//Window UsedEMTOneRun() : Table
//	PauseUpdate; Silent 1		// building window...
//	String fldrSav0= GetDataFolder(1)
//	SetDataFolder root:HR_Sticks:
//	Edit/W=(42,69.2,610.2,468.2) ExactMassText,ExactMassWave,OneRunStick_temp
//	ModifyTable width(ExactMassText)=96,format(ExactMassWave)=3,digits(ExactMassWave)=6
//	ModifyTable width(ExactMassWave)=108,width(OneRunStick_temp)=97
//	SetDataFolder fldrSav0
//EndMacro
//

////////////////////////////////////////////////////////////////////////////////////////////
// From 2006GeneralMacros
//  Should eventually be dumped to sq panel ipf?  Is there a similar built in Igor function? 
Function sq_TextIntextWave(str, textWave)
	String str
	Wave/t textWave

	variable returnVal, idex, num

	returnVal=-1
	num = numpnts(textWave)
	for (idex=0;idex<num;idex+=1)
		if (cmpstr(str, textWave[idex])==0)
			returnVal = idex
			break
		endif		
	endfor

	return returnVal

End


Function HR_butt_UpdateNewExactMass(ctrlName) : ButtonControl
	String ctrlName

	DoAlert 2, "If you want to overwrite all HR ion waves with newly loaded values, press yes.  If you want to check newly loaded values with existing entries, press no.  To do nothing press cancel."
	switch (V_flag)
	case 3:		// cancel
		return 0
		break
	case 2:	// 	no
		HR_butt_IonMassCalculator("")
		HR_MassCalcQueryHRionTab("HRCo",3)		// Compare two HR ion lists
		TabControl/Z tab0 value=3, win = HRIonMassCalculator 
		string msg=""
		msg+="Before proceeding, users must import the 8 news waves (four with a prefix ExactMass*, four with a prfix of mask_*) into a data folder. "		//1.02A the wording has been slightly changed.
		msg+=" Press yes only if you have loaded these waves."  //.111L	
		DoAlert 1, msg
		if (V_flag==1)	
			HR_UpdateAllMassedWaves()
			wave/d ExactMassWave_All = root:HR:ExactMassWave_All
			print "// ** The mask stick integration waves have been updated to retain choices from an earlier version of the ExactMassWave_All & family of waves."
			print "// The new ExactMassWave_All et al  waves. have been moved from the root directory into the HR directory."
			print "// The old ExactMassWave_All has been overwritten on "+date()+ " " + time()	
		endif
		break
	case 1:	// yes
		Dfref df = GetDataFolderDFR()
		NewDataFolder/o/s root:tempDF
		Loadwave/T/O
		if (V_flag==8)
			pk_HRIonWaveDescriptions()
			wave/t HRIonAllWaveNames = root:HRcompareLists:HRIonAllWaveNames
			make/free/o/t pikaLIstWave, AandBHRname, AnotBHRname, BnotAHRname
			gen_list2Textwave (S_waveNames, pikaLIstWave)
			gen_CompareTextWaves(HRIonAllWaveNames, pikaLIstWave,  AandBHRname, AnotBHRname, BnotAHRname)
			if (numpnts(AnotBHRname)==0  && numpnts(BnotAHRname)==0 )
				duplicate/o root:tempDF:ExactMassWave_All root:HR:ExactMassWave_All
				duplicate/o root:tempDF:ExactMassText_All root:HR:ExactMassText_All
				duplicate/o root:tempDF:ExactMassTag_All root:HR:ExactMassTag_All
				duplicate/o root:tempDF:ExactMassComments root:HR:ExactMassComments
				duplicate/o root:tempDF:Mask_Isotope_abundance root:HR:Mask_Isotope_abundance
				duplicate/o root:tempDF:Mask_Isotope_reference root:HR:Mask_Isotope_reference
				duplicate/o root:tempDF:Mask_Stick_Integration root:HR:Mask_Stick_Integration
				duplicate/o root:tempDF:Mask_Stick_Integration_default root:HR:Mask_Stick_Integration_default
			else
				KillDataFolder/z root:tempDF
				SetDataFolder df
				edit HRIonAllWaveNames
				Abort "There was a problem with the newly loaded waves.  Make sure the 8 waves in HRIonAllWaveNames were loaded.  This operation is case sensitive.  Waves loaded were "+S_waveNames
			endif
			KillDataFolder/z root:tempDF
		else
			KillDataFolder/z root:tempDF
			SetDataFolder df
			edit HRIonAllWaveNames
			Abort "There was a problem with the newly loaded waves.  Make sure the 8 waves in HRIonAllWaveNames were loaded.  Waves loaded were "+S_waveNames
		endif
	endswitch
	
End


Function HR_UpdateAllMassedWaves()
//  Assumes that these six wave have been imported
	wave/z NewExactMassWave_All = root:ExactmassWave_All
	wave/t/z NewExactMassText_All = root:ExactmassText_All
	wave/t/z NewExactMassTag_All = root:ExactmassTag_All		//1.49E
	wave/z NewExactMassComments = root:ExactMassComments
	wave/z NewMask_Isotope_abundance = root:Mask_Isotope_abundance
	wave/z NewMask_Isotope_reference = root:Mask_Isotope_reference
	wave/z NewMask_Stick_Integration = root:Mask_Stick_Integration
	wave/z NewMask_Stick_IntegrationDEF = root:Mask_Stick_Integration_default
	
	wave/z OldExactMassWave_All = root:HR:ExactmassWave_All
	wave/t/z OldExactMassText_All = root:HR:ExactmassText_All
	wave/t/z OldExactMassTag_All = root:HR:ExactmassTag_All
	wave/z OldExactMassComments = root:HR:ExactMassComments
	wave/z OldMask_Isotope_abundance = root:HR:Mask_Isotope_abundance
	wave/z OldMask_Isotope_reference = root:HR:Mask_Isotope_reference
	wave/z OldMask_Stick_Integration = root:HR:Mask_Stick_Integration
	wave/z OldMask_Stick_IntegrationDEF = root:HR:Mask_Stick_Integration_default

	if (!WaveExists(NewExactMassWave_All) || !WaveExists(NewExactMassText_All) || !WaveExists(NewExactMassText_All) || !WaveExists(NewMask_Isotope_abundance) || !WaveExists(NewMask_Isotope_reference) || !WaveExists(NewMask_Stick_Integration)  )
		Abort "Please make sure the 8 waves have been loaded into the root directory. - Aborting from HR_UpdateAllMassedWaves"
	endif

	variable iNew, iOld, nOld, nNew, pos, sumOld
	
	sumOld = sum(OldMask_Stick_Integration)
	nOld=numpnts(OldExactMassWave_All)
	nNew=numpnts(NewExactMassWave_All)
	
	//  we build up the new mask stick integration wave by putting the old values into the default wave
	// at the end we put this newly created default into the non-default wave, then overwrite the default with the one downloaded from the web.
	make/o/N=(nNew)  CombinedMask_Stick_Integration
	CombinedMask_Stick_Integration=0  // not needed, every value should get re-written
	
	for (iNew=0;iNew<nNew;iNew+=1)
		pos = sq_findStr(OldExactMassText_All,NewExactMassText_All[iNew],1)		// exact match, look for the new, see if it is in the old
//		stringMatch cmpStr(,,1)
		if (pos>=0)		// test for the same-ness of the text.  The exact mass values may change with the addition of digits of precision
			CombinedMask_Stick_Integration[iNew]=OldMask_Stick_Integration[pos]
		else
			CombinedMask_Stick_Integration[iNew] = NewMask_Stick_Integration[inew] // change to whatever the default is in the newer set 
		endif
		
	endfor

	// now dump the new into the old
	duplicate/o NewExactMassWave_All root:HR:ExactMassWave_All
	duplicate/o NewExactMassText_All root:HR:ExactMassText_All
	duplicate/o NewExactMassComments root:HR:ExactMassComments
	duplicate/o NewMask_Isotope_abundance root:HR:Mask_Isotope_abundance
	duplicate/o NewMask_Isotope_reference root:HR:Mask_Isotope_reference
	duplicate/o NewMask_Stick_IntegrationDEF root:HR:Mask_Stick_Integration_default // keeps the default values from the new set!
	
	// be careful
	duplicate/o CombinedMask_Stick_Integration root:HR:Mask_Stick_Integration	
	
	if (WaveExists(NewExactMassTag_All) && WaveExists(NewExactMassTag_All))
		duplicate/o NewExactMassTag_All root:HR:ExactMassTag_All
		killwaves/z  NewExactMassTag_All
	endif
	
	// now kill the waves in the root folder
	killwaves/z CombinedMask_Stick_Integration
	killwaves/z  NewExactMassWave_All, NewExactMassText_All, NewExactMassComments, NewMask_Isotope_abundance, NewMask_Isotope_reference,  NewMask_Stick_Integration, Mask_Stick_Integration_default

	// recreate the tag wave
	HR_ConvertExactMassName()
	print "// The number of HR fragments selected in the old mask wave was "+num2str(sumOld)
	print "// Keeping the fragment choices, the new mask wave has " +num2str(sum(root:HR:Mask_Stick_Integration))

End


Function SticksGr_check_ResidPer(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_sticks:HR_StickGr_amuWidth

	HR_reCenterAmu(HR_DisplayMZ, HR_StickGr_amuWidth)	// controls x and y scales	

End



Function SticksGr_SetResidAxis(XptLeft, XptRight, checked)
variable XptLeft, XptRight, checked

	wave OneRunResidSpectraOpen = root:HR_sticks:OneRunResidSpectraOpen
	wave OneRunResidSpectraClosed = root:HR_sticks:OneRunResidSpectraClosed
	wave OneRunResidSpectraDiff	= root:HR_sticks:OneRunResidSpectraDiff

	wave OneRunResidPerSpectraOpen = root:HR_sticks:OneRunResidPerSpectraOpen
	wave OneRunResidPerSpectraClosed = root:HR_sticks:OneRunResidPerSpectraClosed
	wave OneRunResidPerSpectraDiff = root:HR_sticks:OneRunResidPerSpectraDiff

	variable O_max, O_min, C_max, C_min, D_max, D_min, thisMin, thisMax
	// now for the residual axis
	if (checked)
		// find max
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidPerSpectraOpen
		O_max = numtype(V_max)==0 ? V_max : 0		// fix in 1.03C
		O_min =  numtype(V_min)==0 ? V_min : 0
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidPerSpectraClosed
		C_max =  numtype(V_max)==0 ? V_max : 0
		C_min =  numtype(V_min)==0 ? V_min : 0 
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidPerSpectraDiff
		D_max =  numtype(V_max)==0 ? V_max : 0
		D_min =  numtype(V_min)==0 ? V_min : 0 
		thisMax = Max(Max(O_max, C_max),D_max)
		thisMin = Min(Min(O_min, C_min),D_min)
		ReorderTraces OneRunResidPerSpectraOpen, {OneRunResidSpectraOpen,OneRunResidSpectraClosed,OneRunResidSpectraDiff,OneRunResidPerSpectraOpen,OneRunResidPerSpectraClosed,OneRunResidPerSpectraDiff}
		ModifyGraph rgb(OneRunResidSpectraOpen)=(65535,65535,65535), rgb(OneRunResidSpectraClosed)=(65535,65535,65535), rgb(OneRunResidSpectraDiff)=(65535,65535,65535)
		ModifyGraph rgb(OneRunResidPerSpectraOpen)=(65280,43520,0), rgb(OneRunResidPerSpectraClosed)=(29168,26112,0), rgb(OneRunResidPerSpectraDiff)=(65280,0,0)
		
		ModifyGraph manTick(ResidualAxis)={0.05,0.05,0,2},manMinor(ResidualAxis)={0,0}
		SetAxis ResidualAxis -0.1,0.1		//1.05A  Doug would like these to be constant... make a variable in the panel?

	else
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidSpectraOpen
		O_max = numtype(V_max)==0 ? V_max : 0
		O_min =  numtype(V_min)==0 ? V_min : 0
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidSpectraClosed
		C_max =  numtype(V_max)==0 ? V_max : 0
		C_min =  numtype(V_min)==0 ? V_min : 0 
		WaveStats/M=1/Q/R = [XptLeft, XptRight] OneRunResidSpectraDiff
		D_max =  numtype(V_max)==0 ? V_max : 0
		D_min =  numtype(V_min)==0 ? V_min : 0 
		thisMax = Max(Max(O_max, C_max),D_max)
		thisMin = Min(Min(O_min, C_min),D_min)
		ReorderTraces OneRunResidSpectraOpen, {OneRunResidPerSpectraOpen,OneRunResidPerSpectraClosed,OneRunResidPerSpectraDiff, OneRunResidSpectraOpen,OneRunResidSpectraClosed,OneRunResidSpectraDiff}
		ModifyGraph rgb(OneRunResidPerSpectraOpen)=(65535,65535,65535), rgb(OneRunResidPerSpectraClosed)=(65535,65535,65535), rgb(OneRunResidPerSpectraDiff)=(65535,65535,65535)
		ModifyGraph rgb(OneRunResidSpectraOpen)=(65280,43520,0), rgb(OneRunResidSpectraClosed)=(29168,26112,0), rgb(OneRunResidSpectraDiff)=(65280,0,0)
	
		SetAxis ResidualAxis thisMin*1.1, thisMax*1.1
		ModifyGraph manTick=0

	endif

End


Function HR_OneHRStickResidGr()
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_Sticks:
	Display/N=OneHRStickResidGr /W=(137.4,69.2,571.8,436.4)

	wave OneRunRawOpenMz, OneRunRawClosedMz,OneRunRawDiffMz, OneRunResidSpectraOpen,OneRunResidSpectraClosed, OneRunResidSpectraDiff 
	wave OneRunResidPerSpectraOpen,OneRunResidPerSpectraClosed , OneRunResidPerSpectraDiff,OneRunResidSumDiff,OneRunResidSumClosed,OneRunResidSumOpen, UnitMass

	AppendToGraph/L=Resid OneRunResidSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=Resid OneRunResidSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=Resid OneRunResidSpectraDiff vs OneRunRawDiffMz
	AppendToGraph/L=ResidPercent OneRunResidPerSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=ResidPercent OneRunResidPerSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=ResidPercent OneRunResidPerSpectraDiff vs OneRunRawDiffMz
	AppendToGraph/L=ResidSum OneRunResidSumDiff,OneRunResidSumClosed,OneRunResidSumOpen vs UnitMass
	SetDataFolder fldrSav0
	ModifyGraph margin(left)=61,margin(right)=11
	ModifyGraph mode(OneRunResidSpectraOpen)=4,mode(OneRunResidSpectraClosed)=4,mode(OneRunResidSpectraDiff)=4
	ModifyGraph mode(OneRunResidPerSpectraOpen)=4,mode(OneRunResidPerSpectraClosed)=4
	ModifyGraph mode(OneRunResidPerSpectraDiff)=4,mode(OneRunResidSumDiff)=1,mode(OneRunResidSumClosed)=1
	ModifyGraph mode(OneRunResidSumOpen)=1
	ModifyGraph lSize(OneRunResidSumDiff)=2,lSize(OneRunResidSumClosed)=2,lSize(OneRunResidSumOpen)=2
	ModifyGraph rgb(OneRunResidSpectraOpen)=(65280,43520,0),rgb(OneRunResidSpectraClosed)=(39168,26112,0)
	ModifyGraph rgb(OneRunResidPerSpectraOpen)=(65280,43520,0),rgb(OneRunResidPerSpectraClosed)=(39168,26112,0)
	ModifyGraph rgb(OneRunResidSumClosed)=(39168,26112,0),rgb(OneRunResidSumOpen)=(65280,43520,0)
	ModifyGraph offset(OneRunResidSumClosed)={0.05,0},offset(OneRunResidSumOpen)={-0.05,0}
	ModifyGraph grid(Resid)=2,grid(bottom)=2,grid(ResidPercent)=2
	ModifyGraph zero(Resid)=1,zero(ResidPercent)=1,zero(ResidSum)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(Resid)=(34816,34816,34816),gridRGB(bottom)=(34816,34816,34816)
	ModifyGraph gridRGB(ResidPercent)=(34816,34816,34816)
	ModifyGraph lblPos(Resid)=60,lblPos(ResidPercent)=60,lblPos(ResidSum)=60
	ModifyGraph lblLatPos(Resid)=-18,lblLatPos(ResidSum)=-13
	ModifyGraph freePos(Resid)={0,bottom}
	ModifyGraph freePos(ResidPercent)={0,bottom}
	ModifyGraph freePos(ResidSum)={0,bottom}
	ModifyGraph axisEnab(Resid)={0.33,0.66}
	ModifyGraph axisEnab(ResidPercent)={0,0.32}
	ModifyGraph axisEnab(ResidSum)={0.68,1}
	Label Resid "Raw Residual"
	Label bottom "m/z"
	Label ResidPercent "Percent Residual"
	Label ResidSum "Summed Residual"
	ShowInfo
	SetAxis bottom 10,101
	Legend/C/N=text0/J/F=0/A=MC/X=36.86/Y=44.38 "\\s(OneRunResidSpectraOpen) Open\r\\s(OneRunResidSpectraClosed) Closed\r\\s(OneRunResidSpectraDiff) Diff"
End


Function HR_butt_ResidvsTime(ctrlName) : ButtonControl
	String ctrlName

	HR_ResidvsTime()

	nvar HR_checkNewResidSeriesGr = root:HR_Panel:HR_checkNewResidSeriesGr

	nvar HR_TimeResidSeriesMz = root:HR_Panel:HR_TimeResidSeriesMz
	nvar HR_TimeResidSeriesOpen = root:HR_Panel:HR_TimeResidSeriesOpen
	nvar HR_TimeResidSeriesClosed = root:HR_Panel:HR_TimeResidSeriesClosed
	nvar HR_TimeResidSeriesDiff = root:HR_Panel:HR_TimeResidSeriesDiff
	string SpecType=""
	if (HR_TimeResidSeriesOpen)
		SpecType="Open"
	elseif(HR_TimeResidSeriesClosed)
		SpecType="Closed"
	else	
		SpecType="Diff"
	endif
	wave t_series = root:index:t_series
	wave Residwave = $"root:HRResid_"+num2str(HR_TimeResidSeriesMz)+"_"+SpecType	

	if (HR_checkNewResidSeriesGr)		// create a new one
		Display/N=ResidTimeSeriesGr /W=(96,143.6,491.4,351.2) residwave vs t_series
		ModifyGraph grid=2
		ModifyGraph zero(left)=1
		ModifyGraph nticks(bottom)=9
		ModifyGraph minor(bottom)=1
		ModifyGraph gridRGB=(52224,52224,52224)
		ModifyGraph dateInfo(bottom)={0,1,0}
		Label left "Residual Sum"
		Label bottom " "
		ShowInfo
		Legend/C/N=text0/J/F=0
		ModifyGraph gaps=0		//1.08E
	else
		DoWindow/F ResidTimeSeriesGr
		if(V_flag==1)		// window exists, just append	
			appendtograph residwave vs t_series
		endif
	endif

End


Function HR_ResidvsTime()

	nvar HR_TimeResidSeriesMz = root:HR_Panel:HR_TimeResidSeriesMz
	svar todoStr=root:panel:sq_toDoWvNm		//^ 1.35 change
	wave/z todo=$(todoStr)	

	nvar HR_TimeResidSeriesOpen = root:HR_Panel:HR_TimeResidSeriesOpen
	nvar HR_TimeResidSeriesClosed = root:HR_Panel:HR_TimeResidSeriesClosed
	nvar HR_TimeResidSeriesDiff = root:HR_Panel:HR_TimeResidSeriesDiff

	string SpecType=""
	if (HR_TimeResidSeriesOpen)
		SpecType="Open"
	elseif(HR_TimeResidSeriesClosed)
		SpecType="Closed"
	else	
		SpecType="Diff"
	endif
	
	squirrel_fetch(todo, HR_ExtractResidSum, "MzVal:"+num2str(HR_TimeResidSeriesMz)+";dest:HRResid_"+num2str(HR_TimeResidSeriesMz)+"_"+SpecType, "ResidSum"+SpecType)

End


//  Very simple squirrel fetch function that creates MSDiff_p
Function HR_ExtractResidSum(index_pos,paramstr,acorn,n_acorns)
	wave index_pos
	string paramstr
	variable acorn 
	variable n_acorns

	string dest = stringbykey("dest",paramstr)
	wave ResidMatrix=$stringbykey("acorn_0",paramstr)
	variable MzVal = str2num(stringbykey("MzVal",paramstr))
	wave series_index = root:index:series_index

	variable idex, numOfRuns = numpnts(index_pos), currentRunIndex, RunVar, unitMassOffset
	
	wave UnitMass = root:HR_sticks:UnitMass
	
	unitMassOffset=UnitMass[0]
	
	if (acorn==0)
		wave rn_series = root:index:rn_series
		make/o/n=(numpnts(rn_series)) $dest=nan
	endif
		
	wave destwave = $dest

	fastop destwave = (nan)
	for (idex=0;idex<numOfRuns;idex+=1)
	
		sq_ams_prog_upd(100*(acorn+(idex/numOfRuns))/n_acorns)
		
		if (index_pos[idex]==-1)
			continue
		endif
		
		// first get all info that is constant for this run
		currentRunIndex = series_index[index_pos[idex]]				//1_1A bug fix
		RunVar = rn_series[currentRunIndex]		// not necessary, just updates panel
					
		destwave[currentRunIndex] = ResidMatrix[idex][MzVal-unitMassOffset]
			
	endfor // each run	

End


Function HR_ck_TimeResidSeriesOption(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_TimeResidSeriesClosed = root:HR_Panel:HR_TimeResidSeriesClosed
	nvar HR_TimeResidSeriesOpen = root:HR_Panel:HR_TimeResidSeriesOpen
	nvar HR_TimeResidSeriesDiff = root:HR_Panel:HR_TimeResidSeriesDiff

	if (strsearch(ctrlName, "Close",0)>0)
		HR_TimeResidSeriesClosed=1
		HR_TimeResidSeriesOpen=0
		HR_TimeResidSeriesDiff=0
	elseif(strsearch(ctrlName, "Open",0)>0)
		HR_TimeResidSeriesClosed=0
		HR_TimeResidSeriesOpen=1
		HR_TimeResidSeriesDiff=0
	else
		HR_TimeResidSeriesClosed=0
		HR_TimeResidSeriesOpen=0
		HR_TimeResidSeriesDiff=1
	endif

End


//Eliminated functionality 1.09H
//Function HR_ck_FitFailOption(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//
//	nvar HR_FitFailClosed = root:HR_Panel:HR_FitFailClosed
//	nvar HR_FitFailOpen = root:HR_Panel:HR_FitFailOpen
//	nvar HR_FitFailDiff = root:HR_Panel:HR_FitFailDiff
//
//	if (strsearch(ctrlName, "Close",0)>0)
//		HR_FitFailClosed=1
//		HR_FitFailOpen=0
//		HR_FitFailDiff=0
//	elseif(strsearch(ctrlName, "Open",0)>0)
//		HR_FitFailClosed=0
//		HR_FitFailOpen=1
//		HR_FitFailDiff=0
//	else
//		HR_FitFailClosed=0
//		HR_FitFailOpen=0
//		HR_FitFailDiff=1
//	endif
//
//End


Function HR_ResidSeriesGr()
	PauseUpdate; Silent 1		// building window...
	Display/N=ResidTimeSeriesGr /W=(96,143.6,491.4,351.2)
	ModifyGraph grid=2
	ModifyGraph zero(left)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB=(52224,52224,52224)
	ModifyGraph dateInfo(bottom)={0,1,0}
	Label left "Residual Sum"
	Label bottom " "
	Cursor/P A HRResid_42 150;Cursor/P B HRResid_40 150
	ShowInfo
	Legend/C/N=text0/F=0
End


Function HR_butt_familyTable(ctrlName) : ButtonControl
	String ctrlName

	ControlInfo HRGrps_popup_viewFamily
	
	wave/z mask_NO = root:Int_sticks:mask_NO		// could use any family		//1.04P sanity
	if (!WaveExists(mask_NO))
		abort "You must choose the masses to fit before this table is available. - aborting from HR_butt_familyTable"	
	endif
	
	UM_GenerateAxByMaskWaves(root:HR_sticks:ExactMassText, "")
	
	HR_CreateFamilyMembers($"root:Int_sticks:mask_"+S_Value)
	
	doWindow/F HR_familyMemberTable		//1.03B
	if (V_flag==0)
		String fldrSav0= GetDataFolder(1)
		SetDataFolder root:Int_Sticks:
		wave/t FamilyMemText, FamilyMemWave
		Edit/N=HR_familyMemberTable/W=(144,66.2,443.4,429.2) FamilyMemText, FamilyMemWave
		ModifyTable format(Point)=1
		SetDataFolder fldrSav0
	endif
	
	wave/t HR_familyName = root:HR:HR_familyName
	wave/z HR_family_R = root:HR:HR_family_R
	wave/z HR_family_G = root:HR:HR_family_G
	wave/z HR_family_B = root:HR:HR_family_B
	if (waveexists(HR_familyName)==0)		// assume that if one is missing, they all are.
		HR_MakeHRFamilyBatch()
		wave/t HR_familyName = root:HR:HR_familyName
		wave HR_family_R = root:HR:HR_family_R
		wave HR_family_G = root:HR:HR_family_G
		wave HR_family_B = root:HR:HR_family_B
	endif
	ModifyTable rgb(root:Int_Sticks:FamilyMemText)=(HR_family_R[V_Value-1], HR_family_G[V_Value-1], HR_family_B[V_Value-1] )
	ModifyTable rgb(root:Int_Sticks:FamilyMemWave)=(HR_family_R[V_Value-1], HR_family_G[V_Value-1], HR_family_B[V_Value-1] )
	ModifyTable style(root:Int_Sticks:FamilyMemText)=1
	ModifyTable style(root:Int_Sticks:FamilyMemWave)=1
	ModifyTable format(root:Int_Sticks:FamilyMemWave)=3,digits(root:Int_Sticks:FamilyMemWave)=6
	ModifyTable showParts=0xFE

End


//Function HR_IsotopesTable()
//
//	DoWindow/F IsotopesTable
//	if (V_flag==0)
//		String fldrSav0= GetDataFolder(1)
//		SetDataFolder root:HR_Sticks:
//		Edit/W=(55.2,77.6,645.6,334.4)/N=IsotopicMassesTable as "IsotopesTable" 
//		
//		GP_populate_IsotopesTable()
//	
//		SetDataFolder fldrSav0	
//	endif
//	
//End


Function HR_populate_IsotopesTable()		// from main HR panel

	AppendToTable root:HR_Sticks:IsotopicMassText,root:HR_Sticks:IsotopicMassWave,root:HR_Sticks:IsotopicMask,root:HR_Sticks:IsotopicAbund
	AppendToTable root:HR_Sticks:IsotopicParentText
	ModifyTable format(Point)=1,rgb(root:HR_Sticks:IsotopicAbund)=(0,15872,65280),rgb(root:HR_Sticks:IsotopicParentText)=(0,15872,65280)
	ModifyTable style(root:HR_Sticks:IsotopicMask)=1,rgb(root:HR_Sticks:IsotopicMask)=(65280,0,0)
	ModifyTable width(Point)=30
//	ModifyTable showParts=0xFE		//1.09B
	ModifyTable title(root:HR_Sticks:IsotopicMassText)="HR ion",title(root:HR_Sticks:IsotopicMassWave)="Mass",title(root:HR_Sticks:IsotopicMask)="Constrain Mask"
	ModifyTable width(root:HR_Sticks:IsotopicMassText)=60,width(root:HR_Sticks:IsotopicMassWave)=60
	ModifyTable width(root:HR_Sticks:IsotopicMask)=40,width(root:HR_Sticks:IsotopicAbund)=60
	ModifyTable width(root:HR_Sticks:IsotopicParentText)=60
	ModifyTable format(root:HR_Sticks:IsotopicAbund)=3,digits(root:HR_Sticks:IsotopicAbund)=6
	
End


Function HR_tabProc(ctrlName,tabNum) : TabControl
	String ctrlName
	Variable tabNum
	
	variable cont_disp,idex,nCont
	string cont_list, cont_item

	cont_list=controlnamelist("")
	nCont=itemsinlist(cont_list)
	
	for (idex=0;idex<nCont;idex+=1)
		cont_item=stringfromlist(idex,cont_list)
		strswitch (cont_item[0,4])
			case "HRGen":		// outside of tabs	
				cont_disp=0
				break
			case "SetUp":	
				cont_disp=tabNum!=0
				break
			case "HRGrp":	
				cont_disp=tabNum!=1
				break
			case "HRFit":	
				cont_disp=tabNum!=2
				break
			case "HRTod":	
				cont_disp=tabNum!=3
				break
			case "HRRes":	
				cont_disp=tabNum!=4
				break
		endswitch
		controlinfo /w=HR_Analysis_Panel $cont_item
		switch (abs(v_flag))
			case 1:
				button $cont_item disable=cont_disp
				break
			case 2:
				checkbox  $cont_item disable=cont_disp
				break
			case 3:
				popupmenu $cont_item disable=cont_disp
				break
			case 4:
				valdisplay $cont_item disable=cont_disp
				break
			case 5:
				setvariable $cont_item disable=cont_disp
				break
			case 6:
				chart $cont_item disable=cont_disp
				break
			case 7:
				slider $cont_item disable=cont_disp
				break
			case 8:
				tabcontrol $cont_item disable=cont_disp
				break
			case 9:
				groupbox $cont_item disable=cont_disp
				break
			case 10:
				titlebox $cont_item disable=cont_disp
				break
			case 11:
				listbox $cont_item disable=cont_disp
				break
		endswitch
	endfor

	string myWInList, winStr
	variable  num
	
	myWInList = ChildWindowList("HR_Analysis_Panel")
	num= ItemsInList(myWinList)
	for(idex=0;idex<num;idex+=1)
		
		winStr = stringFromList(idex, myWInList)
		if(tabNum!=1)
			if (stringmatch("HR", winStr[0,1])  )
				KillWindow $"HR_Analysis_Panel#"+winStr
			endif		
		endif
	endfor

	if(tabNum==1)
		HR_plotAllHRGrpPlots()
	endif

// APES monkey, 1.06J
	if(tabNum==4)
//		SetDrawEnv gstart,gname=apespict
//		DrawPICT 522,307,0.5,0.5,ProcGlobal#PkAPESlogo
//		SetDrawEnv gstop
		ControlInfo/W=HR_Analysis_Panel HRResultsA
		HRResults_TabProc("HR_Analysis_Panel", V_Value)
	else
		HRResults_TabProc("HR_Analysis_Panel", -1)
		DrawAction getgroup=apespict
		if (V_flag)
			DrawAction delete=V_startpos,V_endpos
		endif
	endif

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
	if (tabnum==3)
//		Listbox HRTodoFit_PToFRegionList disable = 2*HR_singleSpectraMSorPToF	// MS = 1, PToF = 0, ePToF = 3
//		Checkbox HRTodoFit_ck_FItThesePToF disable = 2*HR_singleSpectraMSorPToF   // 1.60E
		if (HR_singleSpectraMSorPToF==1)		// MS
//			Checkbox HRTodoFit_ck_ManyRunsOpenClosed disable=0	// show
//			Checkbox HRTodoFit_ck_ManyRunsOpenClosed  disable=1   // title = "Find open and closed HR sticks also"
//			nvar HR_CalcManyRunsOpenClosed = root:HR_panel:HR_CalcManyRunsOpenClosed
//			HR_CalcManyRunsOpenClosed=1
		elseif (HR_singleSpectraMSorPToF==0)		// PToF

//			Checkbox HRTodoFit_ck_ManyRunsOpenClosed disable=1
//			Checkbox HRTodoFit_ck_ManyRunsOpenClosed title = "Find HR fits for PToF 'open & 'closed'"
		elseif (HR_singleSpectraMSorPToF==2)		// ePToFSum
		endif
	endif
	
End


Function HR_butt_PeakShapePanel(ctrlName) : ButtonControl
	String ctrlName
	
	// check to see if they did step 1, creating the MSDiff_p wave.
//	sq_pop_dump2memList("",nan,"Get List")
//	svar sq_dump2memList=root:panel:sq_dump2memList
//	svar sq_dump2memWvNm=root:panel:sq_dump2memWvNm

	sq_GetIndexNotDoneYet()
	HR_PeakShapePanelWIndow()	// this calls the Peak Shape panel

//	print "// The peak width and shape panel were viewed at "+date() + " " + time()  //1.59
	
End


// new in 1.07C
Function HR_checkDuplicatesAllMasses()

	wave/d ExactMassWave_all = root:HR:ExactMassWave_all
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	wave Mask_Stick_Integration = root:HR:Mask_Stick_Integration		// 1.21B
	wave/t ExactMassComments = root:HR:ExactMassComments
	wave Mask_stick_integration_default = root:HR:Mask_stick_integration_default
	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance
	wave/t Mask_Isotope_Reference = root:HR:Mask_Isotope_Reference
	variable idex,num, loopTooBig = 500//
	string str
	
	num =numpnts(ExactMassWave_all)
	wave/t ExactMassText_all = root:HR:ExactMassText_all

	duplicate/o ExactMassWave_all ExactMassWave_allDUP, ExactMassWave_allDIFF
	// check for duplicate masses	//1.07C		
	ExactMassWave_allDIFF[1,]=ExactMassWave_all[p] - ExactMassWave_all[p-1]		//1.58G
	ExactMassWave_allDIFF[0]=1		// any non zero
	wavestats/q/m=1 ExactMassWave_allDIFF
	if (V_min==0)
		do
			str = PK_SortHRionTextByCHNSO(ExactMassText_all[V_MinLoc-1])
			if (stringmatch(str, PK_SortHRionTextByCHNSO(ExactMassText_all[V_MinLoc])))
				if (stringmatch(str, ExactMassText_all[V_MinLoc-1]))
					deletepoints V_MinLoc,1, ExactMassWave_all, ExactMassText_all, Mask_Stick_Integration, ExactMassComments, Mask_stick_integration_default, Mask_Isotope_abundance,Mask_Isotope_Reference, ExactMassWave_allDIFF
				else
					deletepoints V_MinLoc-1,1, ExactMassWave_all, ExactMassText_all, Mask_Stick_Integration, ExactMassComments, Mask_stick_integration_default, Mask_Isotope_abundance,Mask_Isotope_Reference, ExactMassWave_allDIFF
				endif
				ExactMassWave_allDIFF[1,]=ExactMassWave_all[p] - ExactMassWave_all[p-1]		//1.58G
			else
				break
			endif
			wavestats/q/m=1/r=[V_MinLoc+1,] ExactMassWave_allDIFF
		while(V_min==0 && V_MinLoc+2<num && V_MinLoc>0)
		
		sq_butt_popThis("HRGrps_HR_AllMassesTable")		//1.13A
		ModifyTable/W=HR_AllMassesTable selection=(V_MinLoc-1, 0 , V_MinLoc-1, 0 , V_MinLoc-1, 0 ), topLeftCell=(V_MinLoc-1 , 0)
		abort "The wave containing all masses, root:HR:ExactMassWave_all contains duplicates near "+num2str(V_MinLoc) + " - Aborting from HR_checkDuplicatesAllMasses"
	endif

	// check for duplicate text	//1.07C
	duplicate/free/o/t ExactMassText_all, ExactMassText_allDUP
	for (idex=0;idex<num;idex+=1)
		str=ExactMassText_allDUP[0]
		deletepoints 0,1, ExactMassText_allDUP
		FindValue/TEXT=str/TxOP=7 ExactMassText_allDUP
		ExactMassWave_allDIFF[idex] = V_Value	
	endfor

	if (WaveMax(ExactMassWave_allDIFF)>=0)
		sq_butt_popThis("HRGrps_HR_AllMassesTable")  //1.13A
		ModifyTable/W=HR_AllMassesTable selection=(V_maxloc-2, 0 , V_maxloc-2, 0 , V_maxloc-2, 0 ), topLeftCell=(V_maxloc-2 , 0)
		abort "There was a problem with duplicate mass of "+ExactMassText_all[V_maxloc]+" near "+num2str(V_maxloc+ExactMassWave_allDIFF[V_maxloc]-2) +  " and "+num2str(V_maxloc)+" - Aborting from HR_checkDuplicatesAllMasses"
	endif

	Killwaves/z ExactMassWave_allDUP, ExactMassWave_allDIFF, ExactMassText_allDUP

End


// added in 1.02A simply checks that the 'all waves have the same number of points and are in increasing order in
// case the user added masses
Function HR_checkOrderOfAllMasses()	

	wave/d ExactMassWave_all = root:HR:ExactMassWave_all
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	wave ExactMassComments = root:HR:ExactMassComments
	wave Mask_Stick_integration = root:HR:Mask_Stick_integration
	wave Mask_Stick_integration_default = root:HR:Mask_Stick_integration_default
	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance
	wave Mask_Isotope_reference = root:HR:Mask_Isotope_reference
	
	variable num
	
	num =numpnts(ExactMassWave_all)

	// check that the mass wave is in increasing order
	duplicate/o ExactMassWave_all ExactMassWave_allDUP, ExactMassWave_allDIFF
	sort ExactMassWave_allDUP ExactMassWave_allDUP
	ExactMassWave_allDIFF = ExactMassWave_allDUP - ExactMassWave_all
	wavestats/q/m=1 ExactMassWave_allDIFF
	if (V_max > 0 || V_min < 0)
		Killwaves/z ExactMassWave_allDUP, ExactMassWave_allDIFF
		sq_butt_popThis("HRGrps_HR_AllMassesTable")		//1.13A
		ModifyTable/W=HR_AllMassesTable selection=(V_MinLoc-1, 0 , V_MinLoc-1, 0 , V_MinLoc-1, 0 ), topLeftCell=(V_MinLoc-1 , 0)
		abort "The wave containing all masses, root:HR:ExactMass is not in increasing order.  There was a problem at point "+num2str(V_MaxLoc) + " or "+num2str(V_minloc) + " - Aborting from HR_checkOrderOfAllMasses"
	endif
		
	// check the number of points
	if(num != numpnts(ExactMassText_all) )
		Abort "The waves root:HR:ExactMassText_all and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	elseif(num != numpnts(ExactMassComments))
		Abort "The waves root:HR:ExactMassComments and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	elseif(num != numpnts(Mask_Stick_integration))
		Abort "The waves root:HR:Mask_Stick_integration and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	elseif(num != numpnts(Mask_Stick_integration_default))
		Abort "The waves root:HR:Mask_Stick_integration_default and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	elseif(num != numpnts(Mask_Isotope_abundance))
		Abort "The waves root:HR:Mask_Isotope_abundance and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	elseif(num != numpnts(Mask_Isotope_reference))
		Abort "The waves root:HR:Mask_Isotope_reference and root:HR:ExactMassWave_all must have the same number of points - Aborting from HR_checkOrderOfAllMasses"
	endif

	Killwaves/z ExactMassWave_allDUP, ExactMassWave_allDIFF, ExactMassText_allDUP
	
End


Function HR_OneRunHRSticksTable_Create()

	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_Sticks:
	wave ExactMassWave,ExactMassText,ExactMassIsotopeRef,ExactMassIsotopeAbund ,OneRunStickOpen,OneRunStickClosed,OneRunStickDiff
	wave OneRunPeakHeightOpen,OneRunPeakHeightClosed,OneRunPeakHeightDiff
	wave OneRunSqBkStickOpen,OneRunSqBkStickClosed,OneRunSqBkStickDiff
	Edit/W=(36.6,60.2,712.2,316.4)/N=OneRunHRSticksTable as "OneRunHRSticksTable"
	AppendToTable ExactMassWave,ExactMassText,ExactMassIsotopeRef,ExactMassIsotopeAbund
	AppendToTable OneRunStickOpen,OneRunStickClosed,OneRunStickDiff
	if (exists("root:HR_Sticks:OneRunPeakHeightOpen"))
		AppendToTable OneRunPeakHeightOpen,OneRunPeakHeightClosed,OneRunPeakHeightDiff
		AppendToTable OneRunSqBkStickOpen,OneRunSqBkStickClosed,OneRunSqBkStickDiff
	endif

	ModifyTable format(Point)=1
	SetDataFolder fldrSav0

	//  modified in 1.03C
	ModifyTable rgb(root:HR_Sticks:OneRunStickOpen)=(52224,34816,0), rgb(root:HR_Sticks:OneRunPeakHeightOpen)=(52224,34816,0)
	ModifyTable rgb(root:HR_Sticks:OneRunStickDiff)=(52224,0,0), rgb(root:HR_Sticks:OneRunPeakHeightDiff)=(52224,0,0)
	ModifyTable rgb(root:HR_Sticks:OneRunStickClosed)=(26112,17408,0), rgb(root:HR_Sticks:OneRunPeakHeightClosed)=(26112,17408,0)
	ModifyTable style(root:HR_Sticks:OneRunStickOpen)=1
	ModifyTable style(root:HR_Sticks:OneRunStickClosed)=1
	ModifyTable style(root:HR_Sticks:OneRunStickDiff)=1

End


Function HR_butt_ViewResiduals(ctrlName) : ButtonControl
	String ctrlName

	DoWIndow/F OneHRStickResidGr
	if (V_flag==0)
		HR_OneHRStickResidGr()
	endif

End


Function HR_butt_ViewHRSticksTable(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F OneRunHRSticksTable
	if (V_flag==0)
		 HR_OneRunHRSticksTable_Create()
	endif

End


Function HR_ck_oneRunOrAvg(ctrlName,checked) : CheckBoxControl
	string ctrlName
	variable checked

	nvar HR_checkDoNotGrabRawSpectra = root:HR_panel:HR_checkDoNotGrabRawSpectra 	// misnamed, should be single run or average todo

	if (strsearch(ctrlName, "Not",0) >0)
		CheckBox HRFit_ck_NotOneRunRawSpectra  value = 1
		CheckBox HRFit_ck_OneRunRawSpectra value = 0
		HR_checkDoNotGrabRawSpectra = 1 	// misnamed, should be single run or average todo
	else
		CheckBox HRFit_ck_NotOneRunRawSpectra  value = 0
		CheckBox HRFit_ck_OneRunRawSpectra value = 1
		HR_checkDoNotGrabRawSpectra = 0		// misnamed, should be single run or average todo
	endif

End




// JPEG: width= 224, height= 249
Picture PIKALogo
	ASCII85Begin
	s4IA0!"_al8O`[\!<E1V!/U[Us8E!<;f?8iG@>N'3Zq.2@rcL/De=)6:M+3Q@qG\p!(-_n#6tM>"pt
	VA#R^tH$P"!b%LijW*>K>%(aC+K,U+<S+XS]u0.&,).3Tlh5qt2V4$Ghl,q_SW6Tdmu4[(t-gAjSA$
	4@4O%1X?h&0*b[+t,N74$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,Mc4$,M
	cs1eUH#Q\<64Tb^/!!3`5!tbS6_uLbW!!36'!<E3$zz"9ei/"p"]/#lhgC3tMAn!<WE+!X/W."Tno/
	!<<-%!rrH9"VMsl0gR!\"r&h$EIj5s6;jKl1U4dD@drmm(*mqZ6\>?V!#Ye;!s&E'zz!!!!"!WrE*"
	olL@+qXeW!<<3&!<<0'!<<*"!!!!"&HW%I+Yc7r+u3#(EW=hp"99kMg&MN`!<<05!tbMt!79>42*(g
	ZY>r1bNg5P6;bEoTW2-d0##S5h9;.N,8"eMV"k9JmP,6^)CikU#RF?dehd2J"$kuJR#.&WG?2jm>Xe
	3"6[5ID?YSo4IB4RliRVqc\</6o.Ek"-0i.fnp[7r!A2u8M$X&LJ!B@O*haT@#rJKC]NNNjKn?c\lT
	U$e+[lJGg*-6M3(cfpbPJQeU)2D"ue%:DfBW/dt(.r]$>8f?p9+.B;)V>:f.po&,1f.03']alK:..S
	hrSs"QPXTT>^'k$K:WMbWp`R+CW&5qKB$=Rb\'LIEsX%resNig<GTZ0BDeWIOdV,aeQBgNf#;r9hk^
	6;mhehN`K<i'i<9'@CAAU@uk>bKjZ<"<U*?B$`)f/baqA:S0b,-(K>m=pn1Y6$Z7C8@o=;E[=.@TA[
	n:7&?p9Zb7!^5'J_T04d<:A(TSMU\aeACbAd/[`:)LV79,CMXYb`f>K.b0*c3G;8\U5C0sbcAqP[7o
	/+tjAJO_\p('T),K$aL<70Y4'%Zh33:u&re7HX]Y8q_SHrbQ$M!L_`@aS]+.A4WaW.7D^bp-!:u+Vb
	.'=WACXk#nQj#$dYA_[/:GkiNWK/uaol@Z26PdZ6&'[,B)+mU>$pQSsh=.cgaC?,g]fI2PGn`aI.9O
	[bgf4uGnQ)&;Wa4fk*LgK;>&RD]l:bfU4Pm(e!OMgQe@eAO<`N?Q7YQZkIejhV6&^FoV*h$-qUDTVY
	*E"4k,Q#BX<j-K&&+sUV5"jYWh&hNXTTP9d'N=FDlTV-C+6cPZauA`+2qu-o168'n+`g+UD$7e/Oh9
	0;^H*78H!Xf?`_jWFW@t_Xk3?K=pl&*IVC[8HgkfBAIm0^CnjLsrA=N.[3a:cdnSfg9;G]FPV:![^4
	Jl7V4;h14H>e;PDY+k)l[*.j-nC7d,o_SWm;lhNa;=(p7U2"d\<6M*KupKNX]'q[q]UX[c4q]MC2t[
	8'PYi<Le,">>)q5altZ`d_(4dVq>N<8MO00;TRsL2/cBsBQ9Ar)Hj)C[RCQcn9Laf:<tP54m5r8>VE
	pnpX:Al`cW2bF(IEF*3WGEeUi-r8#]=`:^n]Cb(fc[-BM<*e_JXeV"BXCT&3B%>cOUZZH8"c[19kUo
	$n7l8"_80ZI4*g20>18ckfW"IhYo`fppS^9d,fLg]8W6qYBuBLU=GR5J:>^7HTh;>@SbDd+ZO_e0)'
	5*"MVg/[1nsFu%8LZ1NQ0l.g!+'T1^;I++RgMX>L6U-W6@-CAhufl@#lB!ZT$Js3T7K=&?RKF)e+;l
	IY%;+;<.0KYluX>$LJeLkiB^O!%T&t@i.?]$`hiftt1O3JaSnO]P]6)`J?4]N.OOoht"c!'"!.Pi2/
	e;j[3c7=VD2"23Fr7<??Q^X)^`D<.?5jg,B*f:s[4B:Y"KRmHomDkZu;3`tE1K@!g#)Y2Q3oZo'oP1
	]C2!>2EdF6,-9iD[%2$^Kg+r`!n.b_(SA[H,J>em=#e2Pj"1!ZEF]<\G^WZO#iVA*6>GG*gTX*^k5D
	aG00:t&-)bBlOuHWJEWfL32*1m\mrf5q.^]Q^Ag,!?1UF$e,oPbmho6TrsUaH&aP)s!lbC`IVoO\`[
	V7A`"^bpJR:UKDB3Nf@7Z_\FU@;$d@<:BIt<bL6=k:2A*L5+qlhA=*;rC2^*L,@RQ%,I8q@*Q&,PT(
	Pj9YA.D"U`nf_$:fdP#Q)opHj"Hl-r>o1\%PRAFr&@H%22*hc7*._IgNacM!R?@p8=cFWX2`X9:URd
	7OlaS/aB:MHOLtq!.#;YeO*P_UhLQGi"1;5em!WtI!=Kb;`+f[;9LT]0p@,PX7',T?iq)j2+5hUXR3
	F%?!OINN_.'a)NC854f_4#1laB-*"G*]g-fjkh`!;K_t8I-Rtm&$[WkqI8-8W0])t^.+g[IadAPLuS
	F%k!r)=+DKA9G.YALJ=RN$:^1CAl.,sIF)$D0P/H#I@bQICKm0JUh"jfTrX2=#V-]+ZGf-X$!T>tMk
	>^BEU>[:SP?23gkLB^<a78U&"2KRc0qGuI"#9I'X[lL.bCr/-0`l;72Ud?&GpIOMTt%+Q-K!,.t#Ep
	lAi-ac4kA:+Gl=.^2^D4-\Q6AKoZC25.sXH3g9fVs8C.J]tZC[?=(`MtsiIeSGLP4Vdm>u^h(>mW-d
	J$,ZZ)Z2E]SkIHu5+nM?P.B.KI4tQ_#rThSXB/15T=#!&OgUMR4m7/K'_#lO0"iq2:lh^$rI<\))\]
	kBo'1_t:bukd!-A%g5jIn^HD0fg4l?.`>[I@fnpePM2RYcn0:Q/BTAG[Cc@"/(lKLSl\i`$a4CnHa"
	+/(08U#UK\N]/DGUKS,o6bb^Rcj-)F[#I<T6`=*4q!lPgt%Z\]utW$BRY3$XDZi>mX+i^$N?sP/ae#
	gTBKI'Si4?p6*_m1X)XcFAA/`BC0/bNJD_E1H/cPh4j)!SgPFBH!33_m.Qj0cnEJrWqJgN+4'-g5kS
	X"UP=3-QCSk:RdOsLpE)(FmJ**'\]#%5pjG"6c^ine/o79S=8M4J$ULlF#jB"7/:,B"%JZjd8Zr.af
	2HOj,I\4"MC\$)uYd@)JGs-_]CN3&F,E745mHuCG#[6(%$BS"<Icd!$nFG9iN2WehU3:jLP(-6DVQm
	dFdF!6uM>!fmD9.n!Q*@@_/,4)rRg4\`"3hP4NaG5LrTqpr^>+4(#UCJ`bk*9A#/f41*01u9+GsX&B
	N,Ci4aIr0q2G3fA9pN3"Z"H,%&3kSFcJmgEEI^JmHitg9Sf'qYf]lOeZs69b#OHoqbS2q0\k>PP/+[
	f&-gtt`EPC!FdOT*Y(bKFQDK\=Y^ZjB7t0N/mG=Ti"/%1BL#OoV=P.Vb6O"c"N#F8@2,P29`uNU%Qu
	PuqZ(O#ekEB-6^B_$i<qYuSTTJ5TBWe3mbsh/Pd&fQim^P*bH`Z:0Ao7/J+Y7o:cQ"ak/JIa4M+RY/
	kQ)::UYq4.F[h=Xs3aCr`!c$,VUrl!rTc.TA3J'5lAhi-C1"u7m`/7A9\m$@9r^b`:[^r^IHihc\<8
	d__N!o;\Ndc/ej%Z6HE+MUM$)2CkM4R5Q!S76U'rEamnp%8X$[Ql>cq-VJeG7dCUK-4=)4)d`[!XrW
	,TX%"$E$PLpi;=P6e814E4Tpe'm\K%uX-u916$=[":"Wc+@X7N\gNY<I2p/dX2pVX@1aQ74H$l!BA0
	pV:lEM-+9?a3fU[<3FO*(/i^W\hc.2_rAjMnB*eYeb^k9JEpMuGQ2O+c"j-@^=X_`]9\YK8_.E[XID
	A$^GbNh8LXJ)<7I^8XVOM!/[!n$k`^oRdIp-W,f5i&m0nqpDh5VHSlVt;T:a-/\ip(6S9SGPugPUN>
	Tl;!Ng.qdMZMD[<_X-dT-Q_nLk*Bu*ZE)u\ki`NIn,,@lRg6JM]nL(*4_9g_[XCYM(Y8G^+parkoSu
	ZI?K8G,^*'\H9d8VlN:X88<I9`Vjkg8i2ljpfG+WboVb[^u9@RR=0KAs]<si5;dEftmAIl)NF^fZE.
	DX"PMBXJ"/<JOmV"URHA<^^Lcr[Q0B8[*lmP67i%%CgOf3p!\YoB1=*u4+eUBUbNCCD6Ai6\@dB]iM
	-]OX%qOibD<9rUGrUmmN*?K$J6a,6`6#-o\ae,EEMR1[qkUEaM3789LmBC[MEKrq`2/A@sE_8*l/V,
	6mO]n$*W>mj%=1R#c?,8;)$541jR/hO:<*[jd;11IUDK&6].-6>6G$P!HC2Ij]E#VC:@6bH[tVGds6
	%C1k'-qL](MN/cSC@#s2."ttX2Iq8a;LRgflK&Wiol@`PX:s.,m;fF,=)4)d`][Y3=)/Z7HPP9&`qH
	/-7_;\H&j(%]k*tkZe^bb-?mEap%8?_&W.1YYCAJ*h^^rPeWG+QZMU5T*$)^98WXsY*ef#VWK$mk['
	`tl3>OR80)n*1`4kUHngRJjN)rY!OHaRBQ>^a_lCLib)S(8^0B;Nj*r'TL.SY"sUB[J".737`=.F[m
	e>QYgSL,L4()9Mg,)NoRNV,c92:S7>;fAY?kQ("BLmMS%Z2910P[R<;`<LPd66]??)aJ.eG@+4.,'*
	&'f4OQrN>.F?K6^%""9V;q'rg_Tc2(sn8^:O,rjp?Ptbr.QY'Ak09lkf*!g0Be-5Dl3c-nAE&jGdEM
	L*Jd.aRNEJJj(n`7dp7%8DW\@B6*RXWUX1mNKK7kN)]J+a3Ns![_5_-7%4Q24Tq?@'KgT*bT'?g64[
	Yc$6N;kLo?;W#lS"Td_i"SB?Nd6Yor"[5nm.Fo[R-fVDA(#r2Mj.B9G33BE%t\\sGR>;$GhOOMHfZ*
	9Cr"7o9IjPkW6mF%Y(Rm%G_5d[s#i`cLUn"00CY$nX#M)0bT:Lf]VW2#V`%;=s%\%-)kC;E[A%f\T*
	c%$p:B8+b0'#(/FTF!N)"*3lRiC4\Fa0b,1ha<[4>N28+-U>CVFM"+?1<O16WNd.^sk,NH9qEdrsKQ
	57A`8L5e@l6ZI[")C"MpYDBRcKd2Z:-GNndP%bl17@`B)n)V<!m"H6GjKe@#D8'S9&$%$K"O,s3pcA
	Ek>YP9T=@p>bE!U\PoZ4D=(HEFkS/m$)R!CSD!g!,Q2:h^kcKP8R'Ot:\=YeLWlg185J\X$P/!?&i'
	\6C=?DOl-nQ$g5>AR`)#m&Cs5J*o:"dE_b=DH(08/"p*b_P#OPP\AqR<0[:[gtR>VT1iE6sTj7O.ke
	$Od)2ZPSm'l4G37b%b9VUiR.*pr]tH:)<mA$R75Ll+ChBt'-E=Sm?G9l^ts:Pr#!Wq9523DnI0I]*,
	m2Gt;s(nj<[To&-1K=n[aC^V%MOh&JPBNX=/cAQp8@BroX87D6?rTVh_Lb-_*.$"N!Ck_lhPPD(sDQ
	$bVNgX[;M='&*aBWA%'[oWZd%GF?*nfP*[Bl<)N'VbE0`'iO\N^K"U[Dj8XfGYSN&L$Lo8;\RnY3T3
	4Aa@7n6Do:O4:6d%=DXFi@3j_Wbjd.JehhCSG#XFqW7(\4#>!^S?At6IhW]EeT2eYICZN+57u)\+4K
	JH$%+h3r&LUH[=U9,`at8&8c'E7HSHdjpSF<9nWMEB\:-D$%2X449,Rq!\/gp+e@4`o`mjK^FVI`SX
	7;C:F5DV&e`K>%O*k5f&$!;l%49_)RiW"qdp`lc(j+HA_;nLA-nhg<][Q#+h7B=+qEYu`XYW[KAG"$
	?mc/k(]=/D3<.XC.2F#cI=I'*-DJYhpC2>;-Jjo@.QlbFp'cE`):uT?6-@70'W.sHnJ6:hK#I,;g2:
	J+aYj)es!CB^D$_aqd=XZ]hJ\[u?[l!29</MR/=2>pCZS!YH[ofY4E/0"uJ<5TA#.,#Z\/h=gP[E*"
	E^-s/0G/n*3#SLN:e!01).\AkGc"Y]i0Vm4RNNHS+K61l[d"hGJ-@l4(nn-4&Wd/CS-fhK]2!`MY:$
	?1],m9Y[3_B$ac)ZKF:Z:Jh(qsn<kJA3DQ!,VC@D/Y/9k%h;f?Fs<a.="(\XRIe)Z_3D;k807sKU_M
	EVIV(t8Dtm7Oo;H5Se?LI@9nC+_`+7fL=!X`@O"j2TLD=(?o1&)*tLHAV"\A<45B[6D%*78@i'6O2>
	$&WoPUXHH+!p)g\a+W\(n.S7aYdmG[P_%,GhkOV`^Ym6:=pd"NfElNR'aKA95?W8+-.ZHJ>c#u[)9=
	s)h8G;1t]XUM*CRLSj&9%sE>8h<20V[k,TS;LN2h=V1S54PYc*cX@L"rITJ$5(4;WP@#eTE7(LQ9n!
	'G9@Qo9s</,YikPZ1XS0R@>Gu%mTb9lYk`e@OfC/A12"j5XHuA>i`u`mog"`6]itJl7bDQi-q9iY=O
	Tp9rJA)I67O*9Z%!XW@\V,X&XqQaprj=;&#Z,>\':73iml'Sgb\uI3MfrmK^19,;DF$H@D]h>l:Z^V
	VWQ>.p/:UrBJ&$Jn)NP6fbd<rmgXjS2e`LK0`9UPipr;><@KqMIn\RnJ7*&_=J77&3/<63$4U?B\2D
	G.6>O[B[8Y$kYTVrkp1_c3&N9Od(0:jT:?G"*IhQF#P#fr0U=Tbg_3(4lHTA\P2hU<b0R8lU9^?k_8
	R=]RbenT82l*NJc2Te_MO6>,`#$[?%X4%AP&pS-]3;E^h*(]'Wqg8XrW1Y8E2fZ5+6b4Ua'_Wa>iYW
	8_/j.!pnp38.;LangUqbhuX*4(:NN9"?nnE?)a+mf',%/;*j!W]hpQih4.k3+.=Ul78Ys8S9N!g7`c
	o\]Z)FjLdMU1L:4^)bYf+9C3&/4#chH7%1;R`iOBo-<P7,o]t(!Vf/_VBifQ@UOIBTP4BGb6*7UQca
	@FsGgKjZ&TAGr&+a)(FHW2GUSTeUkd`Lm+Lj5gC%r*.N2g2<n_`prse7&=l[;9#Eq[_DLX?UI+UQ3m
	fDf*"+B/!W^anDko$&ZH(iR$m5G,oWFH7#!nd@Y^p2LYA>4aV/rJO;;`N^jgiC'p4fD]Vf5q.!^:LE
	`/,#(0DCaO'5sn!#[?QQ\.[?J't3)D4*Nh^]4686tGS0F)B4.\VZN1#RPXB0ITlg*jmQ^Vas;.607L
	NNr&02nGeCnMr21D`QjHb"m"0XMN;Z8@+D`8cI5BpJABL:^^roUC;In2:71H9bH4jbL7_`I^NLq;!A
	UMgfp]hc5Ds1U^V4\q!CcB+[i^N)fT.K;,.8sDe&AT;+0rb>BM*"Be[)88HU!tXFXljkUo_63@E'%-
	o0944YU&5T6sLV?*`rThhk.)h/re=UTj4Fdkt)u^.U@JOkQV'UGNOFQ=!\tWT_8n1!?t&-[;D#VT8W
	ajOBIJineq;j3:F7?s8/V%'eme`@@/e\9-$sAWMf!9B!TR"-M;iQ6;Lb'$"c!44-<JIdUd'L7:/=is
	4;(aBN>L(eGYTSGRK,pQfXT(N^T@-&BU6r)#M']P+1b6^L6rc]S5-AuM)X,)^.[\<.A5."l0<mohk5
	8pI+C`^(`"6dM[ND\836E>S2+gsc3[l34Ws\7Lna\F=k*qc7;r>s2(FJWW]Ul+D&3THb<pN?r;IJ5l
	mUA:[-=.k]-#4FuiI"EGOVNPL!X>uCnT^M4Kp@idu>mOP=jjpG't'pBCLM2@R77T\7>eB'];>QJA?&
	2H<hC>_gYbXhW"c%68p8EG_K+92o7#(V'@nk\^KFek#aKU\BLm9.Jk"6hf\DEj(SGXh8bOPZc0d`.N
	;mWkPh)tIZ#Ns@OA9p`g__C;=hf\=@g@tU3o)=T.1U$9/(c>"FT%lCs>^RDQW:bs(8<8B9775\N9]Z
	9ZM&`0M]V6I3rGp]m3_8!d^<u-L#i+):_HuHlJ6!!HgV'KR';",HJiiaW!jO:K'(PRs9*K;e1`lujg
	,W>kRd7GZIf0:Tm+!V$$'J,RPW\!Kl"XMU*#I\lAYQ9U:p8K?C*:Br.53!>;l)-9j4mO>64SNSsk2@
	(<rr<NcqQ]dlc$^S+;N;V"#:"jfXf<lDDWFb_b/UF]a61]h,m'3-:,[3eB[INF\g[0WqgIbnB7Q@@F
	!SdK6=^Ij#E@!_^Q5cR[_5/?l,f!Q7QZ!8p<G/_NJ$%2Me20k+%c<)gYS4$W>`H&c?Sq<`.P)1/4XN
	)^=5mL"P]GmZ.Mon5Tte)o%S@#T%1ppMCT;>`^W$f?NM^]ON/m?;'-WS!h2GINU/pT.KNqC8Y"p44;
	oCmg3!eWUmtr0:fAOJQ8ohD9h?2m9bc=s6,t@5ohgi\73MOR\))n#1@kfF&umkM3#OSRkpA`=%,4-W
	L?=5M"%5LsU!Etg=UAd\G%9cAjSf%Xd7.9/GlV[qn.ZpOV-&ET=#n@[d]Q$gQPhqS.];a\9ffeFCU@
	i+buNfsk*OrDZ7/pX_'92q!f<:*grT456Z.as$pB09Zs.f-h*^A#,OqAiMFF=6e@g+M&9i2ZmON?rO
	j.dG^h4mQ](VkcV7,qjlN_DpI3]k.8jPNo1iMVZglLELOFQ`d;poOrBq>F9CG,oVBTA.t7#dauq<UE
	-pT.l5\r&oAelGo64&rPIV"Rae!&VrV+>cbIIJd!aj@"WGMuq[8#!D[`,k!iDlFU/2E!Ng5:b^-H,n
	f:<aPcq6,dW"<'?p_/rW9@nNdilZEpeS8ij"#VBj#<+*=E&SB>CUa+]s^'!,?e^"rJF[iuj!,eog-/
	$PW67nLkahZL-u=:cD9%k6@\=huM4&RJ2^PHEnklVoe@?Md3O4Bl\5`Bqu-F4H:h(_6U"]4t?K!)A7
	$kAGam5L1pV;h+&TemiKt.52Praot^?pq^pI-M@/DR\\Oq#Zo-#:eP,)"2aHC*Iqg21g4p#'S`m]sC
	+V4h$5tH:"W7YbqREQ01I]=$g6\\EonTePa7*U421jCbDeG;"gZBQ=$]p9Mh/?8E"mF%g1NjtKZGcl
	p#2+4,*UhP::sM,-LdJ>lCLV-de<W<sjQ=.)keU]m4&*%sTc[(rmmjHWbAcOb@#`/,;*aC^7afjFNE
	:4^%+@"F+)5HS)'$)nT$Kr<\jSmmQRgmWIG"Q"[7a6Qi4gf]8HDYfVp[`JHW?[s3`#>.9A-ir7Q_@[
	51Kr\g2!8+>I2-Y/7M%0[h*oqE'*[RVVd$$kW4"rj9MVdG'^jJlU8u)Le6upjmb_%-(_n,6D4SpB>k
	Ee[%oDC6$re2.D(@^!&+Zr`nH-4;G>0H:N9*7O?%L(8>'O2Vp_6CV0NqljK]ShT#d9E<u+jVRJ>qom
	Jd0TU%aC7#:,hO+7u]urBq$F(O$(S#g7m./RllKbd)?tr7!<92TR.m(_`NL4AbmUjZl6[OoWHeb7l?
	/GCu%QVF$6E3cY6Sd4cL>-\LQEhTAaFW7]7Vpbd3M_au%5%T*>dp-'pANjEHK6:oK#Y'_,r+H[pHl7
	l&$`8iZNk<J?0XgJoU*d5+I5lI`2DXA#"cJR_<#^sM[qpFri&KHfIep&9fMA3to$\6Bq*K5D==,q>t
	raT\r$lH-+IQd!?V^or1CCWt%;!7SMM0'mQ8F;q5#OVRS;ZLXfM#!I5J#<9WN\eN3oDZb*QOu_<,Z:
	tf0&E,.`X0t@_&qNs>[9(L_RA%@5>6'&[_6qmg[l/hNP&_f%+JJ;)k0l<J8uBZ5IdRkkL),/J``'Y9
	$IoGOu(G@MnZo*ZtSGDYlnZr<"6VPC?.Oo!$$XLnOP9Dk5b7WmUs^`8YpVDqRb?S13;]AR$5O)SYi=
	",\Em(m8"k&U0KB:H=IWYp8+W\V\E^H090dO.?MX4jOKegmVAk<=98[VD.qUuP\*)4C3UKYk0ra4i0
	<p?[1>L*[9p<<Rcd)dJY:)P20VX*ka8K$e42cN<f"W469Nem6q$]+%1r#WWA_:;g-ND^aZ_+,Y='HD
	>m]uO*/$Jo6>'r=PAgQSL33FqC'H#3fliY7gT]`;.?*7gX^m;;pOu9L/i-<T]Fd?%$G9F#LnOgMNS(
	M7h:r;_M'SH^M?+rc\]OOepo;%tlfDWcSfja`];E4Cq*&QZequ%3+jsKAWP=HhH44O%G`ObP]d)K@P
	uScErrC`c^D+4kbio;#0Z[P)7_Guhr)7lY;&,luZE+*Y6Q@2in)*c;iO1WqX9e,Vf#-4(aWSdE;t,b
	;4:Mb>jcOf2*7O&,".\O<on_%7DCmL\HXV91T>:BUPj2`B#1hN.!+SW[_Ip;D__%!;8qd:#Xq-J[,#
	ZT&)&NJLTVe'Y85qYUF4uGH9bSAJ3)e"IP=$K*KiqO=&og=P`RJ<e$8<s-LcVlH`n;&TQ&GaC\Rt+[
	E8nO>%!KbX"HM"OTL*2\OB_V490](oA`oL?)ALt3\HZG:!b3;(1q$WJ-#XY='R>iqY8JRGf]J:Ob9$
	?X]2ngu()";@.cH/#71f[@`e8AC+>EeW=j*@+DEo?(MR(eW7Dg4GJ:>@r7LnY5l.6D_9[$,k/.?b)N
	.m^A!L."q!sSB_rmE(B+H9kT:d^alGmd@6k=Kh24DhkuC2U/%2,E1YM^ia=As5<;l[f"g+/RX%]E?6
	j'e=W;Y/B%>ignf=Oe>\nM=SA/V#LDpfek9oDV[2P5WQ[J8M=tK[%=&=gD%Nj9XsncmbsPO_"+Cbhi
	Uj#B\<uoZrp:*LO=%O5IFKDUibjdRV_em-ZbonC8Uc.?L=@ZSQ[h?aN'Q&#l%<`WaV108e_gkhPpF@
	6?Qmd-[kp?)sHUi$MMa6d2-/3'Y<6s3QeZ,BW^H)%2p_+S0JAN@rMgSUf-=8*0\Vb!-Q*dGl,k;@kS
	:nUS1-J7;W:KB.\$?2*ab%:#Wbi5#!LmVuP?$D*IW)_cJ*DnO+W?mO/JLOIEj+qc2W04:7Y[nN\H71
	$qhW"aQrbDCUJjqpl&k+.COR7-XV'k5_+'m'nm9?86"PLa51B;JD)KmBkHl?:uPS(K&"!g71l]SNCT
	-V4;RRdWmEVMl?-<DQdG:/38dO=(9lfAcR!7o[M%5M!B&cM4nVb8[fPmhLiA+)]2IBCoZM:ogYp\_"
	V>TH'9<&Y3G[IqW\?!(ts"S$tNCa2e6,3][(A*@kgCi%*Ss+[6%Kd\9[42W*b6+^+0*4kbG#4`JtFT
	<T;[7Wm')qA-(DK,\+9)=O9#R\]u\TN5GB#EdjdTfW4(u,ET1G!B:dc:t.D@[;l<:n+\`!N+eOIB2H
	4H^nM^oe0l4)hQ\g#'#Ib6$]m'8dIpbVJmrV#<0;i%3QKq%'[j<;0l<[ppr<So3I$=kZ#"odH9$u/#
	AsmIaiBj6OHSta9Aj=I=ThO$8.lBLJuYT,3BWbVC-&.f,K0"IM]=E5pE"%G]U)M;N%/$CZF52!J&/3
	\rJmX(I7Z#\o_tR=E]rsMo2X'OT;;4`-/`A.[i6aLc+GqmN\SS#7lC4-+0=PcW0Nl-<t#Rah2lBV\E
	!7_/1d=;H@J^1Sk1=$>oXn8f=.&*KW^\?3$<jBJuL!raerJC-L#rWGo2OZ*"Y-6U3nD*EH5Pi6a0ub
	,-Y6T`uX^WQNqIHD?kXdYH1jkP$@2I9MqNM2QLd"=9/!R!$%(_o2F^Dki6Y%34+;ZSD-nDeO]`N9e!
	DXX!5O\"`3Anrr?GUo]<L(HTMM1/fdX!#!K90^\V"b[-/cm9:\;D)&VWe,d&rY!Tt3%i-#&""\MM%9
	.S(0@?<J1Kgm(L.u<'1<Q&pWi/Y[XBI&c(D_;blVuSG5nXgjWMI!@=>Np<P?`9O>EUt*QcI-ZQSppL
	4e4Qt\^'&.CBkZV'Ol/V2?7>sYamXl;<e7B/@3ge=.tGOO.kY?f6F&n'\;iF%4QNpTd!6\b`XXH9(K
	\sOB"tr[To&IC;uFEr_&iRQ=$HE6ob:U-@i1@aKm*F*o1=(3L8*0@IB+:0cJBu509TlTG=*NiKl?,I
	a0ccYcpL"=8.KXTnPW*Ak^K-_S)FfKen&I&b'T.i?%">-=4[IOmu$s0f)f&q'uGe4d\k?&^*D,\mHg
	=AVPs^YW4_ZqY)I7VUh+j'1#J$,Hr:Nc4,$1!(KZqO[`BP1kC8BCa.ZY\&i?kn8WQ\CfrAgn!0o24J
	1<nX%lKmQq1#E<o91!LS+ih4RTI0)buOAmobpEn1'H[%<W(lR9f!:(_*-Gtnm!:%1`BY4\Z$AUg9Z>
	r.<'Zu9/TjPfQX%i@HN<TLq43'j%@a0AUo1!UG=lb/)0GWC'"dA).ZL,B=V=foV/(g!^XI6@bg.8Y>
	Kl4PVd0?:H5/rd[FJJ[*9X*.n^jj;u'T_P?L+.6IW+WFHMD,4c&Vp-+2ja6l]CaYLLVXH94Md@?O$2
	3$W/R5=k?p2,,A"b4MD,*f:?$N?i\bjP]l'=aLBC?oMV+[5i_'Lr4c":VA*fN!<mVb;&?>g::O`F=s
	0U1c[jlnUo(6]XofE"s=HLU'^)>4?<(BOnPmUUg,h*S9rW/T\#'mP3,N<@-9'p%VhiMQ":,+%G2ZKq
	'KMs$QKYrWKLcK-hjY(#;bIkLX7kBM2BdLoVc7?3E]A>^@-.<(pBfdKZ#-=8BJnur:crB[C3JQ-pLG
	Krg\lE.3sVF=OZNhSGrT.D.Xu^>&?;HRnJ9MOJjOMGnlQl:J:NJD;gCpW5M6L!H6^MZ+Ic08Mihc@s
	%f<n$mY=]'bQ(+rAr7XLGI4nZ<-,9K;)QGNUfnc$kmq_02sMQAb89:e"Ti/t?N6L`&Ed\``p,k*#X(
	W*<P4gUnJ"]=PV9689S2a.2\fCLM@cC:^g/RbB$rM1&=G[>MnDJlMIi@CuO>\>GuH[$C;up;\^]]]'
	g^F1[T-@%;uDn`+g-qW-u*dX;f$_.iaVqP<Xqp@_c.M#pog)2Tr:pr<X,p,(Xti#/5S)=8`.jgP6VE
	r/'!^YZ>`57_J6>>&odXIA0H.kFR[\.OmF_OTQYoQME!BYAafpgVgs'Y1u:5b4=)>hV[%APn!Cap2m
	1_9OL9bcHE132r(N57#Rt3c*B6Ur(9FGhGAlH]ilVo2f2M27;h;V53BS?c/b$R(&2J<=n=9D=2[4q<
	^H'_..,)'JbHRJ`It,&.S!%qH*`;a=$MnWeWpp@eS6mU,MWKiLN&\f],)S5f^9SFmMo_ZIZ`7/atlC
	gKI;!I/8AS+0Bd*5lUh6,P+TYoY4Irnf.7a*"CqeOs<%`E)1<?hp-Z93Mh*jW'l4!kr^[J7Cn-l&V@
	$\Jlq(44f`Y%6o>6<p2&)0E[8,YJ6S'c]tADaH%d(.#5FM1;7M-]>=r1o@4+P^k8Y&U2]b'DhQMIRg
	,_`Enk!rLLN\^tr.%;/5IE5+$\i-u1SiE/j*'eZg[Y$2L88[S7.M3CFke2E%o,$AFreR-k,6DCr/7V
	)!C!SfFLP`!gJ_<R-+%*FlmJaTP'6345>Qkja1WFiC5[Iq-^iog:^iQCKa?GQ6=fR>#lF-X?#%u3g9
	ZH37`n5bR1Q@a:P4qYC,stM/T)RRbYg[)<^!S?@.ET.X(?G"<$n/Xo-MW7N0'h,Sei"toZGI7S13e1
	^qg_3Tp"kPLe+WcA<E31a+@tqXY3l/4%\j<j/!SBZ[`qG*oWHso@k/&-jf&PG..+gpB_gN87;>(*dK
	$%fZF-BO,[r=;e$gplItb3_M-hWe[uNSlpVn1Q@73SA7/1VN`Ehd7:Rp,(0bJ&*`L2##q*iij41:ha
	R[aIO*@e[;Q_mDi,/<l-C?@H'3ZbXJ^+g:1j,)Dbm%c,2[9IeXgQ=[OrLQth7,d"WGJ<=I\^KSIAlN
	[]eVhPf9hjmmS+W/l.iZO,+S)k6O.#s$rC\lHR.n(EJbLQ5=rfto1b0bMC&Wge9&*j7`g$%6f0_:B\
	rF:GkZBVUP*t$K&pZpPS^4Rk./ogSZ/7)/Oe\,0NstA*emgL#&*^q,igfr^]+:nM"-,Uq5WPc5qrUq
	h]df<Eo=kQ!.-UQZKUp%Bk'^F<.K@dn@si-3>0oqFI]\\c?%/>pn[b?WlK!MZBOqm%t%?`gS:]OI)M
	i"]7jL1(7gBQCBU2B?'q1=11WVnI>'2;GpKm)@0fto':QDn0X&hj[20/Vk9nL[AGI>VS@1KiH;992$
	[HLW`?i^g\2XPqHK=3I<E:@2.rlZ.dj1M]!eO5)Z#J@q!0?G\MAST5\VH&YjW])4W+Y1RalbN$PP;8
	U:%03n+tlQ&!REmV4^[-e[CV&D(msAlV4@8$`E0?;r&L'M_`&PJ']+U\'C"N[T=<gp9NXh<D/<H:+m
	man^<ur\(%@!b;^0OPX?oSn6P0@Kp)j;7T%Rq?pogK,rr<Wo[+[o!TqDsJ^Pq]E4Xs#*n(OV?hu#-d
	Zm>FHmd!C<[W]-/U2EHaTB60"n+rL"?i3DT?W^T!`X(t.Asuj'#ZGV$m@4eR#DuH&Us#oH>&%.6JZ[
	WlZ..bu*O`0ZG;.$+#:I8p:+!['oVq5T]+QB=/fH")BI+/l*0KORp[.^Net&3ZQ/eT#3NYJ<<gHj)i
	b0\L;WI\@NK/(@k2DBMN:%C%H;n(=V7U)%E?@Y^\;.1-3e3;"KcQKs_R=HkGjfdG]Q7BY!0!:3:E?/
	ZqS?Hil,'#%lk-bc"33Rgqg/P2_0KfQ>HFQ$eKs&Z%biaX)3/^"46%$<=nKjD6o.qPr%FodD(\*s^R
	mL#<@0.3&\21l%%nSm`X`c=inM:6rr<.!Z.&*D+cs";UDI&<Hu:=[F.E-tg9s3fgqe.&r,t"WQeTKr
	'Gd[dC]VC7&beDHp?u?OeEjB`e]t(k7%pNCWt`?GhnNudA7Sb;%T?Z*dQ>qU*.0j<E^s[VRB'FnbAI
	;NVK%>gHaZ0bn8k0c1_eYa>?s+Y?-FfD0Te?uJ\`Ifj0jEdWlIk=gKC0VrE/&7!.,Fu53')$?YXGP_
	^*j8?IF3p'WFo6+Wu%M%WV/d2:j4Of=j$-%&=f:I*=M_5\"Zj+h<gNaiBK,r:@pL>2>KJ?UWOP'UcI
	XQW@"A8B2^#47[*7Q(Wo_Md&<Icus#3(gmk9:3al(J%3`bd]@:_DXD(<E?h3dk/.`cHuZtcZgC<^+$
	MB*NCqk:n#pjn\6/U[5YJ[.@?nH7e.+Ls;>9\8>$HC6(oFm,5`OT>eB_dfYk-0T*L4;6D;]VOjH62k
	[cPXU%.%AH(h'oqF.?`tY4N`#A%\%nXk#1e#\E==??sis*"LcP6YIgtelenr\lS]GG*uc+\DSg^#E8
	93+I_;.Zuncu6kVi"6K]nrEhJWOGPss1)YC,mQ+^+ac;@_15ZA_nEK#)=d+W'"l>8DeB:<iV8E+1f)
	+H<$j+H+41dr<bl4^&:kC[M0<(io,Vil&A4CfP7[;tG,=lbqjb(p$Il*0U%3'E![r#ZZ&V$5u;SHY`
	;7V.]CQK?_sd,^hSAG5FG9(007HXq>COuYQY-o29%1?Tetp/f<?"5=iU@oeNUY+T!/31:`IMeH"].:
	V(L`]7K-!::XVT<63G9k(FWJ2FNRb;!g[i+.>^+G/kb/2['R4lS7IR.c?-hJg*9AFR]k76aLqjVICp
	Rrh6he#LD6Ar39B;24L6F3eUajQ(+S8'eq8><uV`O.`Uf3DfZ':.Y865?`+3q6c/JjHa*Ya*O#faf*
	r[-&L;pDu;$3i\j.P)"ZYtkOkc09.:m,m4>%8eIB^!n:+BkgD"_:V=2l\1?XdPg:?e?hRuk4>ZQ_G>
	^Oj6p>J3!R]RDJom4]YoSe5K4GgBt#*uoFU>qFXbp\>5%`]8ebWi,;ou>1WN4Qm)BtBmW6`eu4;amd
	nnuFXEG>$A@Sc8\t/jp=gg&_(LWT"OpiuEDBOB]a4!iqOR<QE6jAt`ma%(h+u^5tn-62$u=X^JA``s
	CPG0ZC]RX3sj:cT(ArkIkc/LO,u#i-ijOkSlWm=P%P?ZPj>HKR6lh(mCP>Wi>D4l3RQB$$[=MP<eFH
	]#3'1a7Rr7d[R@Z@hb4ed?ePR^g@t]Do2MS%Z:c;,3t/B:!sY'DuQ>AWp).6G8=JFnFA\Bn`<^Q?sn
	pk4Z2`GJS'+Lm7Od"^\Q:38?:5((\KE>]T<>Cna0LAR7&rS:7*UO&tJnj**,8S4\;N1mU8%TbfV3oF
	"Zkg%r?D11JubA7^=tiX%QZ-OmT9F7"J<oAX.;3B7ki[[RN083:BZB)R7ZG_LM(MLq9$@[8/^mWEsP
	IJ\gh8'jdSJ/uNl]6kVPMG)`q7!#/r`NSfe83A^u_h^cqT]ps;o>=RoP&9eSBi3reJ3QJY1rr<tg;J
	&YWL\?>:76@BR8W9=!,I_QQ.POeB*]&i:*.pPJ>>2T<\?j\SXO,%"1<cO>B\Wb!a_jE),Mo_LGCL0=
	er]s6?t.MK\C_[`GNXqCSC+Je>:DaI"O\_u..#]"?o*m73>juiWoo'noFGbLWnk+WCNX&-bLpUL"co
	cDkFL.-G2GP.!QK(met&OLHCg[BO(iuuCu_7qh7IM(kBQCi)6!Ht5)H&1Ea7CUY9ZuWb(*OnA*a3X]
	6g[8=l,r4/bA]A0!W=[-Q+;Qa8gjMDQ>60-AOhDQK`(>CMP+KPXqb$(+0Gj,bP(UZ_%oq#q_rrh/u;
	d68/sZ=3)bo3AmLgi[?Ye8G]&0g+h*1qH>i(.Wa7&.m9kHn6UqL%4'Wb(%e`n3;;>Qg9PQNO[C%Z0q
	j5<*7Dt=_ONH09<.08r,0i1[;GOD&!tb&7<`H)bdj.9N`?0,!'jm:D$-E?qpMGqiOP)eg3P/*8X%YH
	am9$$`d@ki=^%f3e(.=Q_&F*r5uStZ6?"sU%e%\=2-P(oN$@7sR9:T`RgAENc@csP%MXjNhueP%I]B
	JB(7%\2BNiq"E05%gbHLL?-NeB&Q;cQmp(_2-Ff[-uQuqY9MKt)6S]\QQRraWMm>i.)-k!-ias`sjd
	]>i[(<5?*B:JhO>b[KnT>!N^_)*'IjFZU2SN1+ilR,MT&=*KbQjiSVJp>'TPj;?c(3XmVfr=5V\+m5
	C=4Or(RmFk5T'*>PXIej'H'6E)-a^<KOZ;U"!XDOc#g)\aZ,I;$StC##7bqjR%Jej*NI#86e4;mFE4
	NgRhNT\q44kV!hJGP'`(J+-Dn%`V=<?8$!$9WC_tP(^2t>44/9`Z]lZkm]i8Iahh>$]aRQ]U]U.5WT
	DU`+(IES2*G+;ucjY1][DCK/1`MS0jl?\=@aZFU=BM37.-t#PtgGETIcV:HG`@k+UaXiCd`s\H?!VG
	Jpn"*%5SgalA22'[(e?eD]o)1j)9N4S$+h$LZrr>!=_9HL(=-H_8m\dEnNY5J?RM'q17G9N4n[KtL,
	G3Po0-6H<K65Fd2#$QELU`HH.Yg1&lna_0`crkg<hcHdqJ2(D(=l$=TeUZ!_j4:>)g:9`!#tu`rFmm
	ib]!-aFK,,'XRH'm_+9@jZF_e8[XPE032.%$kcH%pdT)p;,0'3eW"L0q0L-pT>ke<n1d^&5Qe*N-]W
	l7Bp52\om47iLn4:[Ak-u(?<?dDL]`uidD^9\eR_Fr/Q;GrJc+$=]38'?`a#o"RPSU%`FhY++HA("Y
	fNlRf-]SKXFX9TZNQ7+!'edLoFhYFDYE6?kBR&>Q#69gh3%LL=p,T$/Q[2@(CPf1EAU-h+JgbFg#9]
	.h6,c#gS$EC^L]>^J@FLP`Kh$BfDeK%rF$k>krhE2XpbQ?o!SX:t,I,2qo7-EOR@A\p4]!Tkk**V<c
	IOH+nn8:o0?C7RR]:Pi77Wd=8e7'kD!JZjYu0,`1uq!"3Di.:DDUpBoD(CnGZePi2J/.],`c]0Y=)c
	><X:C""q=\VPfXWp>Pp9HIoi$]K+4-/]*/q=Q5J^^e;F;Hf"1h>7k-d\HQR"IcAOj6fgdY?PiK/o+^
	(=LqR</#',hi5']./$I;8.Qi"WPOO%K=cIrFhiXbWmkP#;/$.?1Wd!%>W&$rc.H,Oh4<[]p)\5S\Vq
	NWhah.:(061!(^!&'Z+'/"GuEpSD'Dosf9!7#W&;HB[_6`^/=VaTV@?V&+ZVNC*$8&'A*:7V!i-M&-
	GVI[9q'C_*bM@W?B;BsoNCpKIs9/DW1?ETqMaZY-^ncrP2/WS23L,-*?<A6*+:1^"9BI$'?r+%S8j\
	IGDmQO.ME'QY+N`O&m_UEN"22hC<Xf/IF&=m)MP+,=e%01>g?&`5,XHq<K?>.KU+8G*TZOAF`)>Ngi
	8=h5V"Y_eb&4H^@,D8Qe.fQ#\UNjZ8`et$GjpCTePTl&)r:BM\6dGNfe3hD\9kV"KmjrU416P_5D0M
	'(lJ%qGo^.h=HDt3U.nI2IB/\Ghs+gR6,9Q9@=Jlm0rrq)fN<(O7BqT7Mk-s$D@Uja_k+d&pim\=Gh
	J@U\-P/H)R\JXI^Q4)QZKX/1JmMO7k0jWJLb".P^@]u/'S&76Jg-k#2*+u_;a8FCJ-P/=3*QHbR2Ts
	*2Cj%d%%LF$N;>,;njlNgT_.=$pUu=_)+/+;Xa./\!$)'4iV2\roL/`E?m?Ksb"H;h7QPe"4'ROE$"
	d^XV2#,YQB[Kem_$#bN_NHY"E^gO1mu^%u-:PFKGe.dq"E,Dl8o<YLfQX/g>[0G9HXPXED^Tu9/it0
	+RRaL7:M1YV).R8%A10,Y4dQ:pkDBcK'['S)bDR>(-+\F_in3i4c4mQoeV!VV\$]*VZ%<A*D<:RdEp
	V7G#3J?(GDqaC(uSn_j-gF9dM5<J;Q1]OQTL(r>P7CZU9"qQdFFgPZlMNU>`t#+;''ZcA:ihkNn+T;
	/n9k5Uj/0lhCrGah#`CUPOsGARih9pH=O$ug.,<('#Ms/F.8!g,j8?A6YDV<SG5rH?"r12Hq1+\C14
	N$,(>gJ/df*2K`L^p5T/uTc^H14,tO?L*BKMQ,K*)]aPfMI%bnFu!)I&/]bV__B\%@uc"X([gtS0S9
	K't<:'YX[8`Y%>a>M0<k]E@V24[iAa9Af)7'.'UJ3YJDE"=>RROVOR8%@%@1T3qT7bgT+kNR,QBN"b
	Oc3N`9?WlY1ER,]$-&p3:*r`a<bVI0>QO$4X(a/eK63WY1hG8&t2%G4E!=QH(eaY$1?ll1-S\pOOSg
	uIpk^'\NBjhmiP&#6M)3uB(`5E:6mHY_oNqf>*BIkd,m&XB)URFBH.?cE!+$P87f5<>;*7]?]_9t!t
	Q7L/.d)"G9Qni(4Buff@Q*^0KH7=?;=ch%<aVoNZ@$VCG@kSV((>dsR%?,MI`^fr-bqo^5WsMI@b:?
	05hU'Ns@-(/aGpMFAhD'XWRVah+ilPW#36%Y4<c-!kIUrkF%QcRo+SW[FA%%uhkB-T]PY,gY[WNNm!
	mSUo48Q/^cPX];1s%#U-#6tYD8CR'>=h5U6QN_$dI)[OSX]o**"i8A8K1X?[Btr2j11cKDjBaDnEh^
	'-8IIi8t:BWfip&qfi\p`aG?kbE=/ifS\pIW4oFK'oWHX1dc4VM+l6P<W$[HO!D@V?)#B,Sk6HRZUk
	i&WA+9_^V"-+^Z$Fm.oaq5CI,GE[A<5L!LRS!+m1m*"0Ws)%Q!hM=YTrk9^VVP*-&V+:=1bqYWB;du
	;o&R-irj=Lc"I#&e7,l"!aBmSWKb'bR08I'P,*Ol+T#2Q_",*]E_6/TjdE^o=ps.47qEC/-j!%r:dm
	Ft=o`c6Fp>(#jbmtlK2%fk2NK!cBkuH:5GVfZ>Hf5l;decGVUB$;P\--3BTgUMlt"S'4%ZQZ\/L,]W
	-k$j-Z*kGT+s[gr''cU5'rahoq+mS:/3lPTH[ts<(Suqf/2^t\i;QB/AFKJ$`n%FLN2*&#MQC`)E%F
	oES\Yc)'_4sI<t<6XEYsMmod8fMUpn#U\J5033KhGdPb:!HDR@,]-YH;:P2pd>"9`2U4U)SXS/'cg0
	SM&QI_8X()ql"Vh[jK>G3Xe%g6N,UgaZk""+>fEQB27/O2U\(GNFdNbJ1jjL;OEqd-g9obfU\Sj/RL
	T<3;o0p(gC]*+_`G!<^jD.?k?cIjIn,VZ<-!&Kf"LtihonU^SfH>Sh7R4g41&=\q/n4^B0`-imPa$'
	?!@o#d!VpUN[*"c;Z8K:celEWLlOuAoQ!?<bYpT&h!o/kr"NWGZ,ZE2aOQ2[!9R[)(.7tiTF;3Xqn!
	gCG,\^V8KcIPQ7>Y;mn:Y.GhJM2L?fs=?rF_$foSaN?;WhiGpIZb1c4J-L@>4q<IAYr_OWYN6LapUd
	hDU(`[`ulJXZat%TE:_kU,2I*H=&Ep@OJI:S)u>$5/u,2s6#^J"'O.F,).0uhaZT<n>T3'81Z+:Rm+
	4P`Hg(T-dD0?34$3R-r)"6VaYq.ueRrC/T*#c-7u$"^(@=$8@'Rgio8g9rnue[4>#n07f?tIo@_._S
	+iT24Df;EZ.6?`jZ79(/1.XFOn!sA*C$+aD(:CLU,*uEQcK<D3"293`!#2>(Q:UZ^D(k]M&0F#E3Mu
	:Z?fO%G'?b^FEmM>FGa+Bliuk;9.WP@8hK+bE`_HF=kJ#*[nj\>VFQ$>`Ka:5j50&fCg69j/,'6D@]
	Se,PW'?arehQ'40RiY5K3!n,RaY9BO_&QZDQ/>Z"D!"0e?p;Hio]oB[Ybs,#`fja1&q@P*Y*Jhc!)h
	VU2HQT;i4lMbAjeQ:oT-n!<#1GlK92$rq/\US`S\m-A%1$7Gd!n.\3!_E-u\U5G^=]$VYB</>m`N&7
	*jViXjc"KB/0(++m,)UDD835qEgJ."nCI+-b&lfQ$`i`ACQEUh]lL8aj%K^4Q3.CXT=)K/ei-*,K3W
	'Oe:2r76Vb@q<k30NpS9,JM,E,:>GlE"qKfBA0[VqK4?U>(!bS+A7NWClF$%AHU\rOjBPdI<?.-L=n
	3(XE,.i8`acg\1<)NmP7#u;u*-9W!:+%02Ss>j\h4koB#$Z$6^lkWT@&0^h:FeN4Sup\^^#7mH*+9A
	=`H^,AdcJcJ?Cd!V;6l1lL?dBs2?S9Md%Jf+ZFVM.Zj0=R?QXle)(H<,2F5%EW#ffoH"Hl=_.F2'pf
	Ij>-r*#CITQ!jo&ZQ/#VIbC1_AeTP6A#08GLfSIlumI`(k>jh(<+Sh]^2!9J=_V4iJ\<n-Y10bg75U
	D-iEV0_^^YY>knqgn*67_i)*?f3aM%#l%)jT$Z.`uc!12FY`GHomkI3<k`8.sH3:*em5?($`RB,L6p
	`A@hIFoJkGC'*VTan#;"PAL7!iU!^H8W44VpLE+`j#'9/`AW%qQMU&D1GgM@EmZo*$ni^Ob7==_krp
	2=nLp5BHM5YRXFr@8Y6A$lj]Lunmt*#Yb3MChMCh1eCK7i:=,',7:(^HOK4jI3O9RgJPZlJ5\@/n+f
	(sO6h::V`Q&1slg,9,2aP*=[rC=SCp@kBR9;PqI8T/NU--S%dP0QL_V][PC?;IMO8*Buu7aBH)99`.
	,;MGS(Z,mEQ)&3J'="WSpo_.l[%u<(.H,R0G`/giHFHYfH*8tp;$n+,Sg6MGF+/X^<=JW<`<Z(t#JP
	K8lOoYA!Nd\YWQdkA>J&er6$o2/+PP$-=qce1:!(u/N%lD0hS`Bi1eCig0An9a(1,<f6D">AgNn*3=
	6?soI:=QZ>Q['&f\mk%]*#8[%iuIqm$:t3EdqUSqEWp&m'FB"!Ye2J/`]1'MjgYi<dcJo9!Nl]6T]2
	k`)4KMZgk/Tu!s=Xtdp4+u5+tY!WR>2-%r*_AL<SRP[e'.O^c8MnIE"3c9;g_$#A4$EE%7$pHQ!pmG
	<Q`2<l_bbJXY\JBt?<5bP%Y]i+-]]IHi<u_oSmslCZ=&=@iRRRDQeMp8#1&7B$?NZG$M[Gne+EdcSC
	:fEp]Eg16Q$*u/NFD?ehXr0&HmIgi?pYo2tST]a3>90cT9?CJl-n?h@qej'_`SAg-8)!%8<>*cJUK3
	U\DN9l)`3LBoYH;>cGc.`;N].>)T0,f*hD=(a5fWp0j@CQf22[$UEa*Lg/PMGJeW[#c8%T#^,IHX`o
	G+YK_#oF][e@O69^S,P.c='/J(HR5pQOb'$\'WorpGg2<K1FccGr)i!Z`;+j,Y3F.q\gDC]ou,K&3M
	Ua,O>VE__D7D^</NIbn4F2EHYs(RRtl7(uqmu=&q#ZTe1!CJEeXApX%YHle>RZ!L?:&0CC?)UtAi7m
	3UVYDC(<R<FoVA%!`q`bD1Z:?'@"`)j%#RP>&\%P&WY@W*kcVU1E0&!0Rj69d`-4SCAO,J2aY9L[cO
	Jh#qdiV^>9J"-5G1q4MSo=cQXEe?RjIgkIRVG<#&V#K8^R[-NMBNM_gT^`u2;363K']tLqOf34&9lA
	l96DFA(B_h7^*VrQ4^;ne_mdus0;X#-V6EY#i-e7NuK,ndX<;6gaVmE)7"=*AM!"BNsVh-dRP1-ZYT
	gY9gsPqCebBd,nt9X,hI)&OE0a\P?53[O(uA[e(48;AG2M)#:tqf2jVX\q6_(g49D72<J=--e=1<[=
	Ggb-j%aYgQ`\`H?8H<CG]?o>@fm#RKk3N]ttM9pS=-Rr`p5K4Li'N&j5)$io>1jSA7@kJqCo%N:2k[
	27<CD,)t#\e%B9of3>g*QLCh_\*3%rMU0_2+tQ^SOa,Y8Bb,T+_:fCl=]ZYrr?5&BS,CCI2qOGRb(C
	cr$Ntp!$07SH]/""U+\C6hcmZ`A<,Zd(A&=H%ucT3@l`7_pncner)t%\_3FLV,:dKV7d_Nh,;r.DJU
	iVJJ,Il5<LV(MmSN2T.?,L0_1J[X,jk-EOe9l5H%-:1:g(kr($&35,dF*9ed$SA#jtGDT&+6:a^Vi/
	pdPE_n=>C\"jRGc)9*/3k.6`JMp_/ML:""Bn[#Dc_.('cLbs;=H>5A!*;O#n%us@G^YCCmdd#72q9U
	n<bhJ#S@ES@-<c?oQob]OH[Xp5RB/!q:>6R:-,M3*i0j;;AD*_O..pKrMaF0^8/V37ScYpctIq#t]$
	U-m?1B)!IWaDR*Zs,6%CclRVi,-9K,1Je%\$NZ$<4fK&f)B>$1LLcZ<+=L!q8P]#igX]+W(D%N]Ws'
	*,HAoW`^td`MJt]KEo-SeqVIKUXBA2pb2"I9VBjG-0RI2No1Y+j4'O4@2ViLkU8CqV;\\djG=pO>GG
	*%d4\P2-39(^qbs#3&Y['TJhqm,/o#k_SmPDI-!'0([Ta-SX#KWQTom=A)hAC)/!/c`*M-L8W`eoC4
	g^KD(32k*(:ART<fP/W)Eg%1a@.GX7eD-%VDKY"9Qeo3EU3UXLZIU[O8`2VYisbY4jLgd\g&e]B)9>
	%E'.UPskhF91cBEB8b8?B;gn:1qj:T_#MX@sdK)Y1RW1p]LicXR_CQcRYLhq$N`3AtQp7aT'-+_u:>
	P+(K:oF[N(a*iRhgs\,'OVc,ZZU>ikn#+`;+GmOZ-'!Bf0Z.83+"$Mqde.R(@,&NF\-_Vp+tH!BsMt
	n/Ag4EKa[iS8Bq4n&kt[[iO[2aS6'Vgf`^;5+4NR5\:/drh##V_,e&(oR`?2W%`a^!+\o\dG6$]Tfn
	,F,,@6#g%Vo3G>13oJD1Yu6RGi8?9+OQ=p3q"6a1$B/,gu=s4)55=L2M.e+cFf30onqmC]XVWrrBj3
	)O7*"hFN@7T*,:`<taVk%WY^!qNosW(ug*P=5k*M\@JlO4]VP>:0p=*g?mp_rq&AO0`FIYH59^2A!R
	7d4XQ#ti6e$'FO!<J%aissR`p7PTjlg[pVf;-M[tI\;Yf\d>_1-r"jgO;M=m=G;KgDFdBYYm;=$4Kk
	N1K4CnZ-iIL[ghSlA4M;J3Hbp_7S@P/[K#OnY\H,t;Qh1i'EZ7VOIG(`.@8p7kslTHVoHpG<?D<fUC
	rN15'Y0$2BLJVnC,X2G9AR]f?2iA)rg^`]r`=SN!dHVu-"e?5SYY,`k%pIs\a:g2MMb/P=/!KY!=*-
	"6g/X>g0ZH=b;d?t,p=ge@=<Ia>iC5_IY=kgSDUt9epc8^t2<(RWpjeNoWEc=euZ;-%n%2Zr<h!3:a
	UUj*C,<I.;)13%+.H%a"r+DJFkUS/t0hiX9$eaM'grRAa8tHjg5Lu*&HoZ*<l$'(",b1fEKn3);DK%
	T&:3/ScR$!m`#MU/W!W1J<E0I@ucgW^D`[/(I^pB=PZZ:+dXkHub`6lPd$YOC42-bHUa_$[tOt_4bb
	(EE]dH$JE246-P>C-$YcWU3V,g,L*T3&W;aVr"FbH]).qbncF[C;O'@1Rgbo4-PF7`%2e5:j#A=MPs
	VTPHW=/"%ZmO;i+)XE/=&+j^"RoCpG1C,b*C&CFftj*S0c/^?[8:S^LQ5DkfG>",<b$XBo9\qNK="F
	AZ;`@\ImqgCcheZYZ`5"NR#MiN4:W\^N]`"s4G[#8J='kK":&)*'[FkWO]cV2hMD^$3H(+CGJ)+!9b
	[V/ef^:/CFG[_XJ^L.;-orSG!*PKTgBk8.F8GeA3lmR5UOMm79Vd9hb,nDSY`bX(2#W)j%o!VUS>;Y
	<,ONc;]OpF;<btdk.eC.6T<4KD1M([^cAs,AM`c(nurrE"r?J4%)Rga>2P9Y/s/>F5HgPVLqH#7[E]
	rFYGSM?/7^kinKJ,=4TIYh51H^cF[RRX]BkGX*sND@^YW5fs#N[cu6]Rnbt=s$S/O\uJ%iVrnB+6pW
	H55D?Q%>DKcF"PYQPYK`=I@dhO,L6K'J%\ou%>LNmi+"(Ea;d%_r_`[qUiu<E-2M5#;N"Mc\2%:URT
	X$&C#Ul<Og+Jgqi4)u<K/W7&ZfW.BHo(5r@s7iA1t1e!5?t*i^THoXl@X)dZY#i7(L>ua,KVN\>cO3
	V]3efZU\jWr4.u7ok4)W*lX`nWV32q+_;2ZB3)d%81^N<dMJ->EOA$S68R'eHY;_Lq4Y9%q&qLhBc_
	T8<^QqaE";pNKD3FKYYAhWD5fCEM;j]ViQ32JO<-`tPM>V3/N2n:8IRN>Hhd!gglgMPmHek4#Ef?1q
	_7osp:[DPL03^29m(f3Df3/2#`ViAS2ubdPJQo*hoIu3.=5WM1H8FFShS*h0_ItXhss@o.qI8SQ;!h
	tm`*V(6@DP`N\eZkG9:6YWJ=PX-F$=>gU@[U!O)hTGK*/nJ$gbFVpdACCFi;u'F5IECel2@J]Z"'cR
	6bJ*OMb_V`$%M#/]A>,9j`S09-6[J.JR5NtfRT\5p,)G"i>]b!Oj>3BbEJmJut$H4KSlHs.J7&=3al
	Z@g4?bbr0q#lT1Nmsoro88UOLL\s^r,\#"@@D\Q6GWS\Be`e[HT2(F%6E;ZRP"8ETVH3pj#<_PQk*t
	,*?<F:L6-@-O4R!n%Ec<d]NMe&rj"s))24_gK(MPLF4HWl]V'@ra7QY!2-f!(GL.W`"^XH%VP_^1,Q
	,Yj\K=DOVN.5Sf*gpH7C(Y2IkfGTui(\#Q(H>(l#JhS!pW36`FZ:r+n)itRKpL87jb"\4/l[J-N8Tj
	,k9'(a/R]P<p"ml"1q,tdN^=(E5&q6*S8^dcN9?)Ce0h2)V7l#V@$X_obAc'M\d?e-%@d;INM#AQ=1
	=Wf5qR]/A\(GK.)AuU)9L3RhJs*U8nfBjh+Mg-F`DA`4Fnk],e"bm(`4B+HFV6aeQr-VW?&ci>MFj4
	5RSnQ2EMm#Z)"I7U&Wd
	ASCII85End
End


// main HR panel function that brings up a web site
//Function HR_butt_url_latestVersion(ba) : ButtonControl
//	STRUCT WMButtonAction &ba
//
//	switch( ba.eventCode )
//		case 2: // mouse up
//			browseurl /z "http://cires.colorado.edu/jimenez-group/ToFAMSResources/ToFSoftware/index.html#Analysis3"
//			break
//	endswitch
//
//	return 0
//End
//
//
// main HR panel function that brings up a web site
//Function HR_butt_url_FAQs(ba) : ButtonControl
//	STRUCT WMButtonAction &ba
//
//	switch( ba.eventCode )
//		case 2: // mouse up
//			browseurl /z "http://cires.colorado.edu/jimenez-group/wiki/index.php/ToF-AMS_Analysis_Software"		//1.06J
////			browseurl /z "http://cires.colorado.edu/jimenez-group/ToFAMSResources/ToFSoftware/PikaInfo/"
//			break
//	endswitch
//
//	return 0
//End


//Function HR_butt_UpgradePika(ba) : ButtonControl
//	STRUCT WMButtonAction &ba
//
//	switch( ba.eventCode )
//		case 2: // mouse up
//			sq_updateIpfs("pk", "HR_Analysis_Panel", "HR_getHRwin()")
//			break
//	endswitch
//
//	return 0
//End


// added in 1.02A
Function HR_butt_ViewFamilyTable(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F HR_FamilyTable
	if (V_flag == 0)
		HR_ViewFamilyTable()			
	endif

End


// Added in 1.02A
Function HR_ViewFamilyTable() 

 	wave/z/t HR_familyName = root:HR:HR_familyName
	wave/z/t HR_familyListDefinition = root:HR:HR_familyListDefinition
	if (!WaveExists(HR_familyListDefinition))
		make/t/n=(numpnts(HR_familyName)) root:HR:HR_familyListDefinition = "default"
		wave/z/t HR_familyListDefinition = root:HR:HR_familyListDefinition	
	endif
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR:
	wave/t HR_familyName,HR_familyListDefinition
	wave HR_family_R,HR_family_G, HR_family_B
	Edit/W=(5.25,42.5,624.75,490.25)/N=HR_FamilyTable HR_familyName,HR_familyListDefinition as "HR_FamilyTable"
	AppendToTable HR_family_R,HR_family_G, HR_family_B
	ModifyTable format(Point)=1
	SetDataFolder fldrSav0

End


//  Added in 1.02A
Function HR_popMenu_FamilyList(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			if (stringMatch(popStr, "Get List") )		//1.07A changed the name of this popup
				PopupMenu HRGrps_popup_viewFamily, mode = 1, popvalue = "Air", value=sq_textwave2List(root:HR:HR_familyName) +";Get List"
				PopupMenu HRResults_pop_family, mode = 1, popvalue = "Air", value=sq_textwave2List(root:HR:HR_familyName) +";Get List"		//1.06E
			endif		
			break
	endswitch

	return 0
End


//obsolete in 1.05B
//Function PK_calcSQBaselineFit()
//
//	variable currentRunIndex, isWFlag, numInRaw, run_int, run_sl, run_pow
//
////	For now we will ignor whether user selected different open and closed mz fitting parameters
//	wave mz_FitIntercept = root:mzFitting:mz_FitIntercept
//	wave mz_FitSlope = root:mzFitting:mz_FitSlope
//	wave mz_FitPower = root:mzFitting:mz_FitPower
//	
//	wave rn_series = root:index:rn_series
//	wave TofTypeWKey = root:diagnostics:TofTypeWKey
//	wave unitMass = root:HR_Sticks:UnitMass
//
//	nvar HR_RunVar = root:HR_Panel:HR_RunVar
//
//	nvar bk_smoothBackground = root:baselineFitting:bk_smoothBackground
//	nvar resolution_R0 = root:diagnostics:resolution_R0
//	nvar resolution_dm = root:diagnostics:resolution_dm
//	nvar resolution_m0 = root:diagnostics:resolution_m0
//
//	nvar bk_StickRegionMaxAmu = root:baselineFitting:bk_StickRegionMaxAmu
//	variable peakIntegrationDelta	
//	if (NVar_Exists(bk_StickRegionMaxAmu)==1 && bk_StickRegionMaxAmu>0)
//		peakIntegrationDelta = bk_StickRegionMaxAmu/2
//	else
//		peakIntegrationDelta=.4		//default
//	endif
//
//	wave OneRunRawSpectraOpen =root:HR_sticks:OneRunRawSpectraOpen
//	wave OneRunRawSpectraClosed =root:HR_sticks:OneRunRawSpectraClosed
//	wave OneRunRawSpectraDiff =root:HR_sticks:OneRunRawSpectraDiff
//
//	duplicate/o OneRunRawSpectraOpen root:HR_sticks:OneRunRawSpectraOpenBkFt
//	duplicate/o OneRunRawSpectraClosed root:HR_sticks:OneRunRawSpectraClosedBkFt
//	duplicate/o OneRunRawSpectraDiff root:HR_sticks:OneRunRawSpectraDiffBkFt
//	
//	wave OneRunRawSpectraOpenBkFt =root:HR_sticks:OneRunRawSpectraOpenBkFt
//	wave OneRunRawSpectraClosedBkFt =root:HR_sticks:OneRunRawSpectraClosedBkFt
//	wave OneRunRawSpectraDiffBkFt =root:HR_sticks:OneRunRawSpectraDiffBkFt
//
//	numInRaw = numpnts(OneRunRawSpectraOpen)
//	make/o/n=(numpnts(UnitMass)) root:HR_sticks:mz_peak, root:HR_sticks:mz_start, root:HR_sticks:mz_end
//	make/o/n=(numpnts(UnitMass)) root:HR_sticks:mz_startMz, root:HR_sticks:mz_endMz	//, root:HR_sticks:mz_regionY
//	make/o/n=(numInRaw) root:HR_sticks:axis_temp=nan,root:HR_sticks:res_temp=nan
//
//	wave mz_peak =root:HR_sticks:mz_peak
//	wave mz_start =root:HR_sticks:mz_start
//	wave mz_end =root:HR_sticks:mz_end
//	wave mz_startMz =root:HR_sticks:mz_startMz
//	wave mz_endMz =root:HR_sticks:mz_endMz
////	wave mz_regionY =root:HR_sticks:mz_regionY
//	wave axis_temp =root:HR_sticks:axis_temp
//	wave res_temp =root:HR_sticks:res_temp
//
//	currentRunIndex =sq_FindRun(rn_series, HR_RunVar)
//
//	run_int=mz_FitIntercept[currentRunIndex]
//	run_sl=mz_FitSlope[currentRunIndex]
//	run_pow=mz_FitPower[currentRunIndex]
//	isWFlag = TofTypeWKey[currentRunIndex]
//
////	axis_temp=((p-run_int)/run_sl)^(1/run_pow)
////	res_temp=resolution_R0-(resolution_R0/(1+exp((axis_temp[p]-resolution_m0)/resolution_dm)))	
////	sq_StickCalcPrep(OneRunRawSpectraOpenBkFt, res_temp, axis_temp, UnitMass[0], 0, peakIntegrationDelta, mz_peak, mz_start, mz_end)
////
//// 	bk_createStickComplimentMask(OneRunRawSpectraOpenBkFt, mz_start, mz_end, axis_temp )
////	sq_smooth_nans(OneRunRawSpectraOpenBkFt, bk_smoothBackground)
////	bk_makeBkZeroBeyondMassX(axis_temp, OneRunRawSpectraOpenBkFt, 1)
////	bk_fitStickCompliment(OneRunRawSpectraOpenBkFt, isWFlag, 0, 1)		// use the open std dev if using a cubic spline
////
//// 	bk_createStickComplimentMask(OneRunRawSpectraClosedBkFt, mz_start, mz_end, axis_temp )
////	sq_smooth_nans(OneRunRawSpectraClosedBkFt, bk_smoothBackground)
////	bk_makeBkZeroBeyondMassX(axis_temp, OneRunRawSpectraClosedBkFt, 1)
////	bk_fitStickCompliment(OneRunRawSpectraClosedBkFt, isWFlag, 0, 1)		// use the Closed std dev if using a cubic spline
////
//// 	bk_createStickComplimentMask(OneRunRawSpectraDiffBkFt, mz_start, mz_end, axis_temp )
////	sq_smooth_nans(OneRunRawSpectraDiffBkFt, bk_smoothBackground)
////	bk_makeBkZeroBeyondMassX(axis_temp, OneRunRawSpectraDiffBkFt, 1)
////	bk_fitStickCompliment(OneRunRawSpectraDiffBkFt, isWFlag, 0, 1)		// use the Diff std dev if using a cubic spline
//
//	mz_startMz =((mz_start[p]-run_int)/run_sl)^(1/run_pow) 
//	mz_endMz = ((mz_end[p]-run_int)/run_sl)^(1/run_pow) 
//
//End	
//

// For PeakHeights_gr
Function  SticksGr_check_DisplaySQBase(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_ShowSQBaselineFits = root:HR_Sticks:HR_ShowSQBaselineFits

	if (HR_ShowSQBaselineFits)
		ModifyGraph hideTrace(OneRunRawSpectraDiffBkFt)=0
		ModifyGraph hideTrace(OneRunRawSpectraOpenBkFt)=0
		ModifyGraph hideTrace(OneRunRawSpectraClosedBkFt)=0
	else
		ModifyGraph hideTrace(OneRunRawSpectraDiffBkFt)=1
		ModifyGraph hideTrace(OneRunRawSpectraOpenBkFt)=1
		ModifyGraph hideTrace(OneRunRawSpectraClosedBkFt)=1
	endif

End


// For PeakHeights_gr  //1.14I
Function  SticksGr_check_ShowLinesBetween(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_ShowLinesBetweenRaw = root:HR_Sticks:HR_ShowLinesBetweenRaw
	ModifyGraph mode(OneRunRawSpectraOpenp)=3+HR_ShowLinesBetweenRaw
	ModifyGraph mode(OneRunRawSpectraClosedp)=3+HR_ShowLinesBetweenRaw
	ModifyGraph mode(OneRunRawSpectraDiffp)=3+HR_ShowLinesBetweenRaw

End

// Functionality removed in 1.09H
// added in 1.05B after some urging from Jose
//Function SticksGr_check_ShowPikplusSqBa(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//	
// //	nvar HR_ShowPKplusSQBaselineFits = root:HR_Sticks:HR_ShowPKplusSQBaselineFits		1/09H
//	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
// 
//	wave OneRunRawSpectraOpenBkFt =root:HR_sticks:OneRunRawSpectraOpenBkFt
//	wave OneRunRawSpectraClosedBkFt =root:HR_sticks:OneRunRawSpectraClosedBkFt
//	wave OneRunRawSpectraDiffBkFt =root:HR_sticks:OneRunRawSpectraDiffBkFt
//
//	wave OneRunRawSpectraOpenp =root:HR_sticks:OneRunRawSpectraOpenp
//	wave OneRunRawSpectraClosedp =root:HR_sticks:OneRunRawSpectraClosedp
//	wave OneRunRawSpectraDiffp =root:HR_sticks:OneRunRawSpectraDiffp
//	
//	wave OneRunRawSpectraOpen =root:HR_sticks:OneRunRawSpectraOpen
//	wave OneRunRawSpectraClosed =root:HR_sticks:OneRunRawSpectraClosed
//	wave OneRunRawSpectraDiff =root:HR_sticks:OneRunRawSpectraDiff
//	
//	ModifyGraph hideTrace(OneRunRawSpectraOpenp)=!HR_ShowPKplusSQBaselineFits
//	ModifyGraph hideTrace(OneRunRawSpectraOpen)=HR_ShowPKplusSQBaselineFits
//	ModifyGraph hideTrace(OneRunRawSpectraClosedp)=!HR_ShowPKplusSQBaselineFits
//	ModifyGraph hideTrace(OneRunRawSpectraClosed)=HR_ShowPKplusSQBaselineFits
//	ModifyGraph hideTrace(OneRunRawSpectraDiffp)=!HR_ShowPKplusSQBaselineFits
//	ModifyGraph hideTrace(OneRunRawSpectraDiff)=HR_ShowPKplusSQBaselineFits
//	
//	HR_calcGausFitWaves(HR_DisplayMz)
//
//End


// For PeakHeights_gr
Function HR_CreatePeakHtsListBox()
		
	nvar HR_DisplayMz = root:HR_sticks:HR_DisplayMz
	
	wave/t ExactMassText_All  = root:HR:ExactMassText_All
	wave/d ExactMassWave_All  = root:HR:ExactMassWave_All
	wave Mask_stick_Integration  = root:HR:Mask_stick_Integration
	
	wave IntegerMz_FittingMassesSelect = root:HR_Sticks:IntegerMz_FittingMassesSelect
	wave/t IntegerMz_FittingMasses = root:HR_Sticks:IntegerMz_FittingMasses

	variable firstInMass, lastInMass, massesAtInteger, idex, numAllMasses
	string tempstr
	
	numAllMasses = numpnts(ExactMassText_All)
	firstInMass = binarysearch(ExactMassWave_All, HR_DisplayMz-.5) + 1
	if (firstInMass == -1)
		firstInMass = numAllMasses-1		//1.19A
	endif
	lastInMass = binarysearch(ExactMassWave_All, HR_DisplayMz+.5) 
	lastInMass = selectnumber(lastinMass<0, lastInMass, numAllMasses-1)//1.03F
	
	massesAtInteger = lastInMass - firstInMass + 1
	
	make/o/t/n=(massesAtInteger,2) root:HR_Sticks:IntegerMz_FittingMasses		
	make/o/n=(massesAtInteger,2) root:HR_Sticks:IntegerMz_FittingMassesSelect
	
	wave/t IntegerMz_FittingMasses =  root:HR_Sticks:IntegerMz_FittingMasses
	wave IntegerMz_FittingMassesSelect =  root:HR_Sticks:IntegerMz_FittingMassesSelect
	
	IntegerMz_FittingMasses[][0] = ExactMassText_All[p+firstInMass]
	
	for(idex=0;idex< massesAtInteger; idex+=1)
		sprintf tempStr, "%1.6f", ExactMassWave_All[idex+firstInMass]
		IntegerMz_FittingMasses[idex][1] = tempStr
	endfor
	IntegerMz_FittingMassesSelect[][0]= 32	// first column has a checkbox
	IntegerMz_FittingMassesSelect[][0] +=16*Mask_stick_Integration[p+firstInMass]

	IntegerMz_FittingMassesSelect[][1]= nan

End


// for Use in the Peak Heights graph
Function HR_butt_updateMaskWave(ctrlName) : ButtonControl
	String ctrlName
		
	HR_MassCalcGlobals()  //1.13D
	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	wave/d ExactMassWave_All  = root:HR:ExactMassWave_All
	wave Mask_stick_Integration  = root:HR:Mask_stick_Integration
	wave IntegerMz_FittingMassesSelect  = root:HR_Sticks:IntegerMz_FittingMassesSelect
	wave/t IntegerMz_FittingMasses  = root:HR_Sticks:IntegerMz_FittingMasses
	
	variable firstInMass, lastInMass, numAllMasses
	numAllMasses = numpnts(ExactMassWave_All)
	
	firstInMass = binarysearch(ExactMassWave_All, HR_DisplayMz-.5) + 1
	lastInMass = binarysearch(ExactMassWave_All, HR_DisplayMz+.5) 
	lastInMass = selectnumber(lastinMass<0, lastInMass, numAllMasses-1)//1.03F
	
	// 1.13D addition.  We want to be sure that we also remove isotopic children of any mass that was deselected.
	make/FREE/o/n=(lastInMass - firstInMass+1) Mask_stick_IntegrationSection = Mask_stick_Integration[p+firstInMass] 
	PK_AddOrRemoveIsoChild(IntegerMz_FittingMassesSelect, IntegerMz_FittingMasses,  Mask_stick_IntegrationSection)	
		
	Mask_stick_Integration[firstInMass,lastInMass] = mod(IntegerMz_FittingMassesSelect[p-firstInMass][0]/16,2)

End


Function HR_butt_reDoFit(ctrlName) : ButtonControl
	String ctrlName

	HR_butt_CalcSticksForThisRun("HR_PeakHeightsGr_butt_redoFits")			//1.04G

End


// Function checks the existence of nans within the waves in the list
// for only the runs in the todo wave.
Function sq_check_NansInWaveList(todoWave, wavList)
wave todoWave
string wavList
	
	wave rn_series = root:index:rn_series
	variable idex, numWaves, numOrigNans
	string str
 	
	numOrigNans = numpnts(rn_series) - numpnts(todoWave)
 	make/o/n=(numpnts(rn_series))  tempWave
 	sq_makeMaskFromTodofindRun(tempWave,todoWave)
  	
 	tempwave = selectnumber(tempwave[p] ==1, 0, 1)		// make 1s and 0s instead of 1s and nans
 	numwaves = itemsinList(wavList)
 	
 	for (idex = 0; idex < numWaves; idex+=1)
 		str = stringfromList(idex, wavList)
 		wave/z  wav = $(stringfromList(idex, wavList))
 		if (!Waveexists(wav))
 			print "// Wave "+str+" doesn't exist - didn't check for nans in function sq_check_NansInWaveList"
 			continue
 		endif
 		tempwave *=wav
 		wavestats/q/m=1 tempWave
 		if (V_numNans>numOrigNans)
 			tempwave = selectnumber(numtype(tempwave[p]) ==0, p, nan)
 			wavestats/q/m=1 tempWave
			killwaves/z tempwave
 			abort "There is a nan at run "+num2str(rn_series[V_minLoc])+ " in wave "+str + " - aborting from sq_check_NansInWaveList"
 		endif
 	endfor
 	killwaves/z tempWave
 	
End


// a debugging help function that returns the m/z value of a given point in a raw spectra
Function sq_ReturnMz(RunNum, pt)
variable RunNum, pt
	
	wave run_index = root:index:run_index
	wave Mz_fitPower = root:MzFitting:Mz_fitPower
	wave Mz_fitSlope = root:MzFitting:Mz_fitSlope
	wave Mz_fitIntercept = root:MzFitting:Mz_fitIntercept
	variable Pos, Mz
	
	Pos = Sq_findRun(run_index, RunNum)
	
	Mz =( (pt -  Mz_fitIntercept[pos])/Mz_fitSlope[pos]  )^(1/Mz_fitPower[pos])
		//  1.14I  do we flag when Mz_fitIntercept is positive?
	return Mz
End


// a debugging help function that returns the point number for a given m/z in a raw spectra
Function sq_returnPt(RunNum, Mz)
variable RunNum, Mz
	
	wave run_index = root:index:run_index
	wave Mz_fitPower = root:MzFitting:Mz_fitPower
	wave Mz_fitSlope = root:MzFitting:Mz_fitSlope
	wave Mz_fitIntercept = root:MzFitting:Mz_fitIntercept
	variable Pos, Pt
	
	Pos = Sq_findRun(run_index, RunNum)
	
	Pt =  Mz_fitIntercept[pos] + Mz_fitSlope[pos]*(Mz^Mz_fitPower[pos])
		//  1.14I  do not care when when Mz_fitIntercept is positive?
	
	return Pt

End


// The peakHeights-gr now has a tab to fit more stuff
Function  PH_TabProc(ctrlName,tabNum): TabControl
	String ctrlName
	Variable tabNum

	string cont_list, cont_item
	variable idex, nCont, cont_disp
	
	cont_list=controlnamelist("HR_PeakHeights_gr")
	nCont=itemsinlist(cont_list)
	
	for (idex=0;idex<nCont;idex+=1)
		cont_item=stringfromlist(idex,cont_list)
		cont_disp=0		// default to everything is displayed
		strswitch (cont_item[0,2])
			case "PH0":	
				cont_disp=tabNum!=0
				break
			case "PH1":
				cont_disp=tabNum!=1
				break
		endswitch
		controlinfo /w=HR_PeakHeights_gr $cont_item
		switch (abs(v_flag))
			case 2:
				checkbox  $cont_item disable=cont_disp		//d == 0 means display d ==1 means hide 
				break
			case 10:
				Titlebox  $cont_item disable=cont_disp		//d == 0 means display d ==1 means hide 
				break
		endswitch
	endfor

End


// new in 1.04J
Function HR_populate_ChemFormTable() 

	wave/z/t ChemicalFormulaText = root:HR_Sticks:ChemicalFormulaText
	if (!WaveExists(ChemicalFormulaText))
		make/o/n=0 root:HR_Sticks:ChemicalFormulaMass
		make/t/o/n=0 root:HR_Sticks:ChemicalFormulaText
	endif
	
	AppendToTable root:HR_Sticks:ChemicalFormulaText, root:HR_Sticks:ChemicalFormulaMass
	ModifyTable format(Point)=1,width(Point)=30,width(root:HR_Sticks:ChemicalFormulaText)=90,title(root:HR_Sticks:ChemicalFormulaText)="Chem. Formula"
	ModifyTable format(root:HR_Sticks:ChemicalFormulaMass)=3,digits(root:HR_Sticks:ChemicalFormulaMass)=8,width(root:HR_Sticks:ChemicalFormulaMass)=90
	ModifyTable title(root:HR_Sticks:ChemicalFormulaMass)="Mass"

End


// new in 1.04J
// a handy function that tells you how many chemical elements there are in a chemical formula
// HR_ReturnNumElements("j13CC2H4O", "C",  "a|u|l|r|o")  returns 3 
Function HR_ReturnNumElements(massStr, ElementStr, ElementSuffStr)  
string massStr, ElementStr, ElementSuffStr

	variable charPos, containsX, len, numAfterElement
	string str1, str2

	containsX = 0
	charPos = 0
	len = strlen(massStr)

	do
		charPos = strsearch(massStr, ElementStr, charPos)
		if (charPos>=0 && !grepstring(massStr[charPos+1], ElementSuffStr)  )
			containsX += 1
			splitstring/E="("+ElementStr+")(\\d{1,3})" massStr, str1, str2	
			if (strlen(str2) ==0)	//we do not have numbers after the letter
				numAfterElement = 1
			else	
				numAfterElement = str2num(str2)
			endif
			containsX+= numAfterElement - 1
		endif
		charPos = charPos<0 ? len : charPos+1
	while(charPos <len)
	
	return containsX

End


// new button function , sets list of families for average HR mass spec  // 1.04J
//  goes through the HR_familyName and checks to see that a paired mask wave exists // 1.04J
Function HR_DoFamilyMaskWavesExist()		

	wave/t HR_familyName = root:HR:HR_familyName
	variable idex, num
	num = numpnts(HR_familyName)

	for (idex =0;idex<num;idex+=1)
		wave/z mask_X = $"root:int_Sticks:mask_"+HR_familyName[idex]
		if (!waveExists(mask_X))
			abort "The mask wave root:int_Sticks:mask_"+HR_familyName[idex] +" does not exist. Check the HR family table  - aborting from  HR_DoFamilyMaskWavesExist"
		endif
	endfor

End


//1.04J
Function PK_graphTweaks()

	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
	nvar stickthick=root:panel:gdef_stick_thick
	nvar gdef_cursors=root:panel:gdef_cursors
	nvar gdef_gaps=root:panel:gdef_gaps

	wave/t HR_familyName = root:HR:HR_familyName
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B

	wave HR_specColor_R = root:HR_frag:HR_specColor_R
	wave HR_specColor_G = root:HR_frag:HR_specColor_G
	wave HR_specColor_B = root:HR_frag:HR_specColor_B
	wave/t HR_specName_List = root:HR_frag:HR_specName_List
	wave/t HR_spec_List = root:HR_frag:HR_spec_List

	string wavList, listitem, listitem_modified, partialStr
	variable idex, jdex, num, TS_Flag, pdex, numPartial
	
	TS_Flag =  stringmatch(stringbykey("UNITS", axisinfo("","bottom")), "dat")
	
	wavlist=tracenamelist("",";",1)
	num=itemsinlist(wavlist)
	for (idex=0;idex<num;idex+=1)
		listitem=upperstr(stringfromlist(idex,wavlist))
		listitem_modified = ReplaceString(sq_toDoWvNm, listitem, "")
		listitem_modified = ReplaceString("MSSD_", listitem_modified, "")
		listitem_modified = ReplaceString("MSSO_", listitem_modified, "")
		listitem_modified = ReplaceString("MSSC_", listitem_modified, "")
		listitem_modified = ReplaceString("MSSM_", listitem_modified, "")
		listitem_modified = ReplaceString("UMRD_", listitem_modified, "")
		listitem_modified = ReplaceString("UMRO_", listitem_modified, "")
		listitem_modified = ReplaceString("UMRC_", listitem_modified, "")
		listitem_modified = ReplaceString("UMRM_", listitem_modified, "")
		listitem_modified = ReplaceString("Diff", listitem_modified, "")
		listitem_modified = ReplaceString("Open", listitem_modified, "")
		listitem_modified = ReplaceString("Closed", listitem_modified, "")
		listitem_modified = ReplaceString("OMinusC", listitem_modified, "")
		listitem_modified = ReplaceString("family", listitem_modified, "")

		numPartial = itemsINList(listitem_modified, "_")
		for (pdex=0;pdex<numPartial;pdex+=1)
			partialStr = stringFromList(pdex, listitem_modified, "_")
			jdex=sq_findstr(HR_familyName,partialStr,1)
			if (jdex>-1)
				modifygraph rgb($listitem)=(HR_family_R[jdex],HR_family_G[jdex],HR_family_B[jdex])
				if (!TS_Flag)	// not a time series, but a mass spec
					modifygraph lsize($listitem)=stickthick, mode($listitem)=1
				endif
				break
			else
				jdex=sq_findstr(HR_spec_List,partialStr,1)
				if(jdex>-1)
					modifygraph rgb($listitem)=(HR_specColor_R[jdex],HR_specColor_G[jdex],HR_specColor_B[jdex])
					if (!TS_Flag)	// not a time series, but a mass spec
						modifygraph lsize($listitem)=stickthick, mode($listitem)=1
					endif
					break
				else
					jdex=sq_findstr(HR_specName_List,listitem_modified,1)
					if(jdex>-1)
						modifygraph rgb($listitem)=(HR_specColor_R[jdex],HR_specColor_G[jdex],HR_specColor_B[jdex])
						if (!TS_Flag)	// not a time series, but a mass spec
							modifygraph lsize($listitem)=stickthick, mode($listitem)=1
						endif
						break
					endif
				endif
			endif
		endfor
	endfor

	if (gdef_cursors)
		Showinfo
	else
		Hideinfo
	endif

	if (!TS_Flag )
		label bottom "m/z"	
	endif
	
	ModifyGraph gaps=gdef_gaps

End



//  NO HR frag table applied to sticks!!
Function UMR_plot5GraphSummary(familyPrefix, familySuffix, errStr, graphName) 
string familyPrefix, familySuffix, errStr, graphName

	PauseUpdate; Silent 1		// building window...
	Display/W=(5, 50, 550,400)/N=$graphName as graphName
	wave wave_Cx = $"root:"+familyPrefix+"Cx"+familySuffix
	wave wave_CH = $"root:"+familyPrefix+"CH"+familySuffix
	wave wave_CHO1 = $"root:"+familyPrefix+"CHO1"+familySuffix
	wave wave_CHOgt1 = $"root:"+familyPrefix+"CHOgt1"+familySuffix
	wave wave_CHO1N = $"root:"+familyPrefix+"CHO1N"+familySuffix
	wave wave_CHOgt1N = $"root:"+familyPrefix+"CHOgt1N"+familySuffix
	wave wave_CHN = $"root:"+familyPrefix+"CHN"+familySuffix
	wave wave_NO = $"root:"+familyPrefix+"NO"+familySuffix
	wave wave_NH = $"root:"+familyPrefix+"NH"+familySuffix
	wave wave_SO = $"root:"+familyPrefix+"SO"+familySuffix

	wave/z wave_Cx_err = $"root:"+errStr+"Cx"+familySuffix
	wave/z wave_CH_err = $"root:"+errStr+"CH"+familySuffix
	wave/z wave_CHO1_err = $"root:"+errStr+"CHO1"+familySuffix
	wave/z wave_CHOgt1_err = $"root:"+errStr+"CHOgt1"+familySuffix
	wave/z wave_CHO1N_err = $"root:"+errStr+"CHO1N"+familySuffix
	wave/z wave_CHOgt1N_err = $"root:"+errStr+"CHOgt1N"+familySuffix
	wave/z wave_CHN_err = $"root:"+errStr+"CHN"+familySuffix
	wave/z wave_NO_err = $"root:"+errStr+"NO"+familySuffix
	wave/z wave_NH_err = $"root:"+errStr+"NH"+familySuffix
	wave/z wave_SO_err = $"root:"+errStr+"SO"+familySuffix

	variable num = numpnts(wave_CH)
	wave/z UMR_X_axis = root:HR_sticks:UMR_X_axis
	if (!WaveExists(UMR_X_axis) || num != numpnts(UMR_X_axis)  )		// bug fix 1.10C
		make/o/n=(num) root:HR_sticks:UMR_X_axis=p+1
		wave UMR_X_axis = root:HR_sticks:UMR_X_axis
	endif
	
	AppendToGraph/L=CHN wave_CHN vs UMR_X_axis 
	AppendToGraph/L=CHON wave_CHO1N, wave_CHOgt1N vs UMR_X_axis
	AppendToGraph/L=CHO wave_CHO1, wave_CHOgt1 vs UMR_X_axis
	AppendToGraph/L=CH wave_CH vs UMR_X_axis
	AppendToGraph/L=CH wave_Cx vs UMR_X_axis
	AppendToGraph/L=Inorganic wave_SO,wave_NO,wave_NH vs UMR_X_axis

	if (strlen(errStr)>0)
		ErrorBars $NameOfWave(wave_Cx) Y,wave=(wave_Cx_err,wave_Cx_err)
		ErrorBars $NameOfWave(wave_CH) Y,wave=(wave_CH_err,wave_CH_err)
		ErrorBars $NameOfWave(wave_CHO1) Y,wave=(wave_CHO1_err,wave_CHO1_err)
		ErrorBars $NameOfWave(wave_CHOgt1) Y,wave=(wave_CHOgt1_err,wave_CHOgt1_err)
		ErrorBars $NameOfWave(wave_CHN) Y,wave=(wave_CHN_err,wave_CHN_err)
		ErrorBars $NameOfWave(wave_CHO1N) Y,wave=(wave_CHO1N_err,wave_CHO1N_err)
		ErrorBars $NameOfWave(wave_CHOgt1N) Y,wave=(wave_CHOgt1N_err,wave_CHOgt1N_err)
		ErrorBars $NameOfWave(wave_SO) Y,wave=(wave_SO_err,wave_SO_err)
		ErrorBars $NameOfWave(wave_NO) Y,wave=(wave_NO_err,wave_NO_err)
		ErrorBars $NameOfWave(wave_NH) Y,wave=(wave_NH_err,wave_NH_err)
	endif
	
	Pk_graphTweaks()

	ModifyGraph grid(CHN)=2,grid(bottom)=2,grid(CHON)=2,grid(CHO)=2,grid(CH)=2
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB(CHN)=(34816,34816,34816),gridRGB(bottom)=(34816,34816,34816)
	ModifyGraph gridRGB(CHON)=(34816,34816,34816),gridRGB(CHO)=(34816,34816,34816),gridRGB(CH)=(34816,34816,34816)
	ModifyGraph lblPos(CHN)=63,lblPos(CHON)=73,lblPos(CHO)=70,lblPos(CH)=73,lblPos(Inorganic)=63
	ModifyGraph lblLatPos(CHN)=-7,lblLatPos(CHON)=-3,lblLatPos(CH)=-4,lblLatPos(Inorganic)=-1

	ModifyGraph freePos(CHN)={0,bottom}
	ModifyGraph freePos(CHON)={0,bottom}
	ModifyGraph freePos(CHO)={0,bottom}
	ModifyGraph freePos(CH)={0,bottom}
	ModifyGraph freePos(Inorganic)={0,bottom}
	ModifyGraph axisEnab(CHN)={0.21,0.39}
	ModifyGraph axisEnab(bottom)={0.1,1}
	ModifyGraph axisEnab(CHON)={0.41,0.59}
	ModifyGraph axisEnab(CHO)={0.61,0.79}
	ModifyGraph axisEnab(CH)={0.81,1}
	ModifyGraph axisEnab(Inorganic)={0,0.19}

	Label CHN "\\K(36864,14592,58880)CHN"
	Label CHON "\\K(16384,48896,65280)CHON"
	Label CHO "\\K(65280,16384,35840)CHO"
	Label CH "\\K(0,39168,0)CH"
	Label Inorganic "SO,NH,NO,Cl"
	SetAxis/A/E=0
	SetAxis bottom 10,120		//1.08E
	ShowInfo
	
	string textStr = "", moreText
	Wavestats/q/m=1 wave_Cx		//1.06E
	sprintf moreText,  "\\K(0,0,0)Cx = %.1f\r", V_avg*V_npnts
	textStr+=moreText
	Wavestats/q/m=1 wave_CH
	sprintf moreText,  "\\K(0,39168,0)CH = %.1f\r", V_avg*V_npnts
	textStr+=moreText
	Wavestats/q/m=1 wave_CHO1
	sprintf moreText,   "\\K(32640,0,26112)CHO1 = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_CHOgt1
	sprintf moreText,   "\\K(65280,0,52224)CHOgt1 = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_CHO1N
	sprintf moreText,   "\\K(8192,24448,32640)CHO1N = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_CHOgt1N
	sprintf moreText,   "\\K(16384,48896,65280)CHOgt1N = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_CHN
	sprintf moreText,   "\\K(36864,14592,58880)CHN = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_NO
	sprintf moreText,   "\\K(0,65280,65280)NO = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_NH
	sprintf moreText,   "\\K(65280,43520,0)NH = %.1f\r", (V_avg * V_npnts)
	textStr+=moreText
	Wavestats/q/m=1 wave_SO
	sprintf moreText,   "\\K(65280,0,0)SO = %.1f", (V_avg * V_npnts)
	textStr+=moreText
	TextBox/C/N=text0/A=RT "Pika sticks - no HR frag applied!\r"+textStr

	ModifyGraph mode=1,lsize=2,toMode=3
	pk_ColorizeByFamily()
	ModifyGraph rgb($NameofWave(wave_CHN))=(38912,2560,65280)		// lame but we started defining CHN as CHN not CNH
	Label bottom "m/z"
  
End


// new in 1.04P
//  assumes wave names will have i.e. a  '_CH_' in the name 
Function PK_ColorizeByFamily()

	string mywaveList, myWaveStr
	variable idex, num, pos, jdex, numFamily

	wave/t/z HR_familyName = root:HR:HR_familyName
	wave/z HR_family_R = root:HR:HR_family_R
	wave/z HR_family_G = root:HR:HR_family_G
	wave/z HR_family_B = root:HR:HR_family_B
	if (waveexists(HR_familyName)==0)		// assume that if one is missing, they all are.
		HR_MakeHRFamilyBatch()
		wave/t HR_familyName = root:HR:HR_familyName
		wave HR_family_R = root:HR:HR_family_R
		wave HR_family_G = root:HR:HR_family_G
		wave HR_family_B = root:HR:HR_family_B
	endif

	numFamily = numpnts(HR_familyName)

	myWaveList = TraceNameList("",";",1)
	num = ItemsInList(myWaveList)

	for  (idex =0;idex<num;idex+=1)
		myWaveStr = stringFromList(idex,myWaveList )
		for(jdex=0;jdex<numFamily;jdex+=1)
			pos = strsearch(myWaveStr, "_"+HR_familyName[jdex]+"_",0)	// method = 2 match part of str
			if (pos>=0)
				ModifyGraph  rgb($myWaveStr)=(HR_family_R[jdex], HR_family_G[jdex], HR_family_B[jdex] )
//				print pos,HR_familyName[jdex] ,myWaveStr
				break
			endif
		endfor
	endfor

End


// new in 1.04P
Function HR_plot_HRFamilyColorLegend()

	HR_makeHRFamilyLegend()
	svar HR_legendStrUnitSticks = root:Int_Sticks:HR_legendStrUnitSticks
	PauseUpdate; Silent 1		// building window...
	Display/N=HRFamilyColorLegend /W=(40,260,130,550)  as "HRFamilyColorLegend"
	ModifyGraph mode=1
	ModifyGraph lSize=4
	ModifyGraph hideTrace=1
	//ModifyGraph zColor(HR_family_pointNumber)={root:HR:HR_family_2dColorTable,*,*,directRGB}
	ModifyGraph nticks=0
//	ModifyGraph axOffset(left)=-3.85714,axOffset(bottom)=-1.66667
//	ModifyGraph axRGB=(65535,65535,65535)
	TextBox/X=0/Y=0  "\\Z14\\f01"+HR_legendStrUnitSticks
	//ColorScale/C/N=text0/A=MC/X=-8.57/Y=0.89 cindex=root:HR:HR_family_2dColorTable, heightPct=100
	//ColorScale/C/N=text0 widthPct=50
	//ColorScale/C/N=text0 userTicks={root:HR:HR_family_pointNumber,root:HR:HR_familyName}
//	ColorScale/C/N=text0 axisRange={1,15,0}
End


// new in 1.04P
Function HR_updateFamilyColorLegend()

	wave/t HR_familyName = root:HR:HR_familyName
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B

	variable num = numpnts(HR_familyName)

	make/o/n=(num) root:HR:HR_family_pointNumber
	make/o/n=(num,3) root:HR:HR_family_2dColorTable

	wave HR_family_pointNumber = root:HR:HR_family_pointNumber
	wave HR_family_2dColorTable = root:HR:HR_family_2dColorTable

	HR_family_pointNumber = p+1
	HR_family_2dColorTable[][0] = HR_family_R[p]
	HR_family_2dColorTable[][1] = HR_family_G[p]
	HR_family_2dColorTable[][2] = HR_family_B[p]

End


// new in 1.04P
Function HR_butt_familyTableLegend(ctrlName) : ButtonControl
	String ctrlName
	
	HR_updateFamilyColorLegend()
	
	DoWindow /F HRFamilyColorLegend
	if (V_flag==0)
		HR_plot_HRFamilyColorLegend()
	endif
	
End



// new in 1.04P
// done when only looking at one raw spectra
Function PK_butt_5FamilyMSGraph(ctrlName) : ButtonControl
	String ctrlName

	UM_GenerateAxByMaskWaves(root:HR_sticks:ExactMassText, "")		// 1.10C addition so that family definitions are recalculated
	
	Wave OneRunResidNoiseOpen = root:HR_Sticks:OneRunResidNoiseOpen
	Wave OneRunResidNoiseClosed = root:HR_Sticks:OneRunResidNoiseClosed
	Wave OneRunResidNoiseDiff = root:HR_Sticks:OneRunResidNoiseDiff
	
	UM_MakeIntResolutionSticks(root:HR_sticks:ExactMassWave, root:HR_sticks:OneRunResidNoiseDiff, "Diff", "root:Int_Sticks:intRN", "root:Int_Sticks:OneRunRNSumSpec" )
	UM_MakeIntResolutionSticks(root:HR_sticks:ExactMassWave, root:HR_sticks:OneRunResidNoiseClosed, "Closed", "root:Int_Sticks:intRN", "root:Int_Sticks:OneRunRNSumSpec")
	UM_MakeIntResolutionSticks(root:HR_sticks:ExactMassWave, root:HR_sticks:OneRunResidNoiseOpen, "Open", "root:Int_Sticks:intRN", "root:Int_Sticks:OneRunRNSumSpec")
		
	DoWIndow/F  OneSpec_5Graph_Closed// 1.05A addition
	if (V_Flag==0)
//		UMR_plot5GraphSummary("Int_Sticks:int_", "_Closed", "Int_Sticks:intRN_", "OneSpec_5Graph_Closed") 
		UMR_plot5GraphSummary("Int_Sticks:int_", "_Closed", "", "OneSpec_5Graph_Closed") 		//1.08E
	endif
	DoWIndow/F  OneSpec_5Graph_Open// 1.05A addition
	if (V_Flag==0)
//		UMR_plot5GraphSummary("Int_Sticks:int_", "_Open", "Int_Sticks:intRN_", "OneSpec_5Graph_Open") 
		UMR_plot5GraphSummary("Int_Sticks:int_", "_Open", "", "OneSpec_5Graph_Open") 		//1.08E
	endif
	DoWIndow/F  OneSpec_5Graph_Diff// 1.05A addition
	if (V_Flag==0)
//		UMR_plot5GraphSummary("Int_Sticks:int_", "_Diff", "Int_Sticks:intRN_", "OneSpec_5Graph_Diff") 
		UMR_plot5GraphSummary("Int_Sticks:int_", "_Diff", "", "OneSpec_5Graph_Diff") 		//1.08E
	endif
	DoWindow/F  OneSpec_5Graph_OMinusC// 1.08E addition
	if (V_Flag==0)
		UMR_plot5GraphSummary("Int_Sticks:int_", "_OMinusC", "", "OneSpec_5Graph_OMinusC") 
	endif

End


Function HR_checkNansMaskIntegration() 	// makes waves root:HR_Sticks:ExactMassWave et al from root:HR:ExactMassWave_All & integration mask
	
	Wave/Z Mask_Stick_integration = root:HR:Mask_Stick_integration 
	Wavestats/q/m=1 Mask_Stick_integration
	if (V_numNans!=0 || V_numInfs>0)
		duplicate/o Mask_Stick_integration Bad_Mask_Stick_integration 
		Bad_Mask_Stick_integration=numtype(Mask_Stick_integration[p]) !=0
		edit Bad_Mask_Stick_integration, Mask_Stick_integration
		display Bad_Mask_Stick_integration
		showinfo
		abort "There are Nan values in your root:HR:Mask_Stick_integration wave.  Use the table and graph to enter 0 or 1 values for all entries.  Aborting from HR_checkNansMaskIntegration"
	elseif(V_max!=1 )
		duplicate/o Mask_Stick_integration root:Bad_Mask_Stick_integration 
		Bad_Mask_Stick_integration=Mask_Stick_integration[p]>1
		edit Bad_Mask_Stick_integration,Mask_Stick_integration
		display Bad_Mask_Stick_integration
		showinfo
		abort "There are values > 1 in your root:HR:Mask_Stick_integration wave.  Use the table and graph to enter 0 or 1 values for all entries.   Aborting from HR_checkNansMaskIntegration"
	elseif(V_min !=0 )
		duplicate/o Mask_Stick_integration root:Bad_Mask_Stick_integration 
		Bad_Mask_Stick_integration=Mask_Stick_integration[p]<0
		edit Bad_Mask_Stick_integration, Mask_Stick_integration
		display Bad_Mask_Stick_integration
		showinfo
		abort "There are values <0 in your root:HR:Mask_Stick_integration wave.  Use the table and graph to enter 0 or 1 values for all entries.  Aborting from HR_checkNansMaskIntegration"
	endif

	killwaves/z 	NansIn_Mask_Stick_integration
	
End


Function HR_butt_MakeExactMassWaves(ctrlName) : ButtonControl
string ctrlName
	
	// sanity checks for the all masses waves
	HR_checkOrderOfAllMasses()		//1.02A	//checks the exactmass_all waves

	HR_checkDuplicatesAllMasses()	//1.07C  //checks the exactmass_all waves

	HR_convertExactMassName()		//tags	// make tags for //checks the exactmass_all waves	// change from 1.02A
	//done with sanity checks of the _all waves.  Now get down to business
	
	HR_checkNansMaskIntegration() 	//1.11M  make sure that there are no nans in the integration wave
	
	HR_makeIntegrationMaskWave() 	// makes waves root:HR_Sticks:ExactMassWave et al from root:HR:ExactMassWave_All & integration mask

	HR_checkClosenessAdjacentIons() 	//1.15E

	//UM_generateAxByMaskWaves(root:HR)	// mask_CHO, etc		//1.08E  make mask_family waves
	wave/t ExactMassText = root:HR_sticks:ExactMassText
 	UM_generateAxByMaskWaves(root:HR_sticks:ExactMassText, "")
 
//	wave/t ExactMassText = root:HR_sticks:ExactMassText
// 	UM_makeChosenMassFamText(ExactMassText, "root:HR_Sticks:ExactMassFamilyText")		// added in 1.08E

	// for calcs in anticipation finding HR sticks
//	UM_makeDutyCycleCorr()			// root:Int_Sticks:dutyCycleCorr  done in HR_CalculateSticksSQ_prep

	HR_extractIsotopicValues()		// if a user omitted a mass, we need to check that any isotopic offsprings aren't fit 

	HR_makeUnitMassWave()		// calculates numOfPeaks, MassStartPnt = idex values of exact mass fragments to fit

	print "// The user chose "+num2str(numpnts(root:HR_Sticks:ExactMassText))+" HR ions to fit on "+date()+ " " + time()
	 
End


Function HR_butt_CheckIsotopeMask(ctrlName) : ButtonControl
	String ctrlName

	string OrphanedMasses
	//  first check to see if isotopic parent were chosen
	OrphanedMasses = HR_CheckIsotopeParents()
	
	if (strlen(OrphanedMasses)>0 )
		Abort " These isotopic parents of these masses: "+ OrphanedMasses+" were not chosen to be fit!  Either change the IsotopicMask value to 0 or choose to fit their parents! Aborting from HR_butt_SetIsotopeMask"
	endif
	
	HR_SortIsotopicValues()
	print "// The Isotopic masses that were chosen to constrain by parent peaks are feasible; isotopic parents exist if constrained and the order of masses to fit has been resolved.  "+date() + " " + time()

End


//  no longer used... but nice to have around for some to dig deep and see if frags were converted correctly
Function HR_butt_ConvertedFrags(ctrlName) : ButtonControl
	String ctrlName

	HR_smartConvertFrags("HROrg", 0)		// considert HROrg to be the default... really it could be any HR species
	//HR_generateFinalFrags()

	DoWindow /F HRConvertedFragTable
	if (V_flag==1)
		return 0
	endif

	wave/t HR_specname_list = root:HR_frag:HR_specname_list
	wave HR_specColor_R = root:HR_frag:HR_specColor_R
	wave HR_specColor_G = root:HR_frag:HR_specColor_G
	wave HR_specColor_B = root:HR_frag:HR_specColor_B

	string fldrSav0
	variable idex, num
	
	num = numpnts(HR_specname_list)
	fldrSav0 = GetDataFolder(1)
	SetDataFolder root:HR_frag:
	Edit/N=HRConvertedFragTable/W=(5,40,490,405) as "HRConvertedFragTable"	
	wave HR_fragIonIndex,SpeciesMassWave,SpeciesMassText
	AppendToTable HR_fragIonIndex,SpeciesMassWave,SpeciesMassText
	ModifyTable width(Point)=0,width(HR_fragIonIndex)=55
	ModifyTable format(SpeciesMassWave)=3,digits(SpeciesMassWave)=6
	ModifyTable showParts=0xFE
	for(idex=0;idex<num;idex+=1)
		wave frag_HRspecies =$"frag_"+HR_specname_list[idex]
		AppendToTable $NameofWave(frag_HRspecies)
		ModifyTable rgb($NameofWave(frag_HRspecies))=(HR_specColor_R[idex],HR_specColor_G[idex],HR_specColor_B[idex]), style($NameofWave(frag_HRspecies))=1	 
	endfor
	
	SetDataFolder fldrSav0

End


Function HR_plotAllHRGrpPlots()
	
	Edit/W=(10,195,525,375)/HOST=# 
	HR_populate_AllMassesTable()
	RenameWindow #,HRAllMassesTable
	SetActiveSubwindow ##
	
// 1.09H
//	Edit/W=(285,185, 525, 305)/HOST=# 
//	HR_populate_ChosenMassesTable()
//	RenameWindow #,HRChosenMassesTable
//	SetActiveSubwindow ##
//	
//	Edit/W=(285,340,525,430)/HOST=# 
//	HR_populate_IsotopesTable()	
//	RenameWindow #,HRIsotopesTable
//	SetActiveSubwindow ##

End


//1.08E
// Although it isn't called from any other function it is called via a pop button
Function HR_populate_ChosenMassesTable()
	
	UM_GenerateAxByMaskWaves(root:HR_sticks:ExactMassText, "")
	HR_populate_ChosenMassesTableX("")	

End


//1.08E
Function HR_butt_ChosenMassFitTodo(ctrlName) : ButtonControl
	String ctrlName

	wave/t/z ExactMassText_FitTodo=root:HR_Sticks:ExactMassText_FitTodo // 1.08E replaced with *_FitTodo
	if (!WaveExists(ExactMassText_FitTodo))		// for the case of someone upgrading who has not yet done a fit for a todo wave
		abort "You must first fit a todo wave (perhaps after upgrading) to use this feature - aborting from HR_butt_ChosenMassFitTodo"
	endif

	UM_GenerateAxByMaskWaves(root:HR_sticks:ExactMassText, "_FitTodo")		// recategorize HR ions

	DoWindow/F HRChosenMassesFitTodo
	if (V_flag==1)
		return 0
	endif

	Edit/N=HRChosenMassesFitTodo/W=(285,340,625,630) as "HRChosenMassesFitTodo"
	
	HR_populate_ChosenMassesTableX("_FitTodo")

End


//1.08E
// extracted the functionality of HR_populate_ChosenMassesTable to make versatile for one run vs many in todo.
Function HR_populate_ChosenMassesTableX(ExactWaveSuffix)
string ExactWaveSuffix

	wave/t/z ExactMassFamilyText = $"root:HR_Sticks:ExactMassFamilyText"+ExactWaveSuffix
	wave/t/z ExactMassText = $"root:HR_Sticks:ExactMassText"+ExactWaveSuffix
	wave/z ExactMassWave = $"root:HR_Sticks:ExactMassWave"+ExactWaveSuffix
	
	string familyStr
	variable idex, num
		
	wave/t/z HR_familyName = root:HR:HR_familyName
	wave/z HR_family_R = root:HR:HR_family_R
	wave/z HR_family_G = root:HR:HR_family_G
	wave/z HR_family_B = root:HR:HR_family_B
	if (!waveexists(HR_familyName))		// assume that if one is missing, they all are.
		HR_MakeHRFamilyBatch()		// I think we always want to redo this 1.04P
		wave/t HR_familyName = root:HR:HR_familyName
		wave HR_family_R = root:HR:HR_family_R
		wave HR_family_G = root:HR:HR_family_G
		wave HR_family_B = root:HR:HR_family_B
	endif
	
	if (exists("root:HR_Sticks:ExactMassFamilyText")==0)
		UM_generateAxByMaskWaves(root:HR_sticks:ExactMassText, ExactWaveSuffix)		//1.09C
	endif
	
	AppendToTable ExactMassText,  ExactMassWave, ExactMassFamilyText
	ModifyTable format($GetWavesDataFolder(ExactMassWave,2))=3
	ModifyTable digits($GetWavesDataFolder(ExactMassWave,2))=6
	ModifyTable width($GetWavesDataFolder(ExactMassText,2))=60,width($GetWavesDataFolder(ExactMassWave,2))=60, width($GetWavesDataFolder(ExactMassFamilyText,2))=40
	ModifyTable title($GetWavesDataFolder(ExactMassText,2))="HR ion",title($GetWavesDataFolder(ExactMassWave,2))="Mass",title($GetWavesDataFolder(ExactMassFamilyText,2))="Family"
	ModifyTable width(point)=30
	ModifyTable showParts=0xFE

	num=numpnts(HR_familyName)
	for (idex=0;idex<num;idex+=1)
		familyStr = HR_familyName[idex]
		wave myFamilyWave = $"root:Int_Sticks:mask_"+familyStr+ExactWaveSuffix		//1.08E
		AppendToTable myFamilyWave	
		ModifyTable width($GetWavesDataFolder(myFamilyWave,2))=30, title($GetWavesDataFolder(myFamilyWave,2))=familyStr, style($GetWavesDataFolder(myFamilyWave,2))=1
		ModifyTable rgb($GetWavesDataFolder(myFamilyWave,2))=(HR_family_R[idex], HR_family_G[idex],HR_family_B[idex])		// fix by mjc
	endfor	

End


//  master function for doing all HR calcs
// one place for many sanity checks
Function HR_butt_MS_Calc(controlname) : Buttoncontrol
string controlname

	nvar HR_checkUseAB = root:HR_panel:HR_checkUseAB
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkAskForSuffix=root:HR_panel:HR_checkAskForSuffix
	nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0
	nvar HR_checkConvertNegsTo0 = root:HR_panel:HR_checkConvertNegsTo0
	nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors
//	nvar HRResults_dataType = root:HR_panel:HRResults_dataType
	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
//	nvar HRResults_ErrType = root:HR_panel:HRResults_ErrType		//1.12O
	nvar NormalizeSpectra = root:HR_panel:NormalizeSpectra		// 1.09K fix for when we do SQ vs Pika
//	nvar HR_checkPToFDVa = root:HR_panel:HR_checkPToFDVa
	svar HRResults_ionList=root:HR_panel:HRResults_ionList

	nvar ams_time_saved=root:panel:ams_time_saved		// not intuitive to users that this feature will work.
	nvar ams_time_custom=root:panel:ams_time_custom		// not intuitive to users that this feature will work.

	nvar/z  HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal		//1.114F  Manjula's new Elem ratio cal method
	if (!NVar_exists(HR_elementalImprovedCal) )
		variable/g root:HR_panel:HR_elementalImprovedCal=1
		nvar HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal
	endif

	wave t_series=root:index:t_series
	wave squirrel_index = root:index:squirrel_index
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$"root:"+todoStr		

	nvar tof1_norm=root:panel:tof1_norm		//1.20E
	nvar tof0_fragAirIs0 = root:panel:tof0_fragAirIs0  //1.20E	

	string spectraType, specTypeInitial, paramStr, paramStrPartial, specList, destList, tempStr, nonHRSpec,HRSpec, errorType, t_base
	string waveNameSuffix, WaveListToPlotStick,WaveListToPlotRaw, myWinName, myPlotName, myWinList, tempList, tempSpecList
	string HRResultsButtonList,timewt, Wave2PlotList
	variable idex, num, HRResultsType, MSorPToFHRsticks, matrixFlag, numHR
	
 	
 	// an extensive section of sanity checks
//	it is important that the button controls on the main ams panel do not change from these values.  Should make a static Constant?	
	HRResultsButtonList = ""
	HRResultsButtonList += "HRResultsT_button_diurnalCalc;"			// 0 = diurnal
	HRResultsButtonList += "HRResultsT_button_HRVsTime;"			// 1 = time series
	HRResultsButtonList += "HRResultsM_button_HRvsMz;"			// 2 = avg mass spec 
	HRResultsButtonList += "HRResults2_button_TseriesMass;"		// 3 = export 2 d time series m/z
	HRResultsButtonList += "HRResultsM_button_PlotHRDoug5;"		// 4 = Doug's 5 graph family summary
	HRResultsButtonList += "HRResultsE_button_EARatios;"			// 5 = EA ratios time series
	HRResultsButtonList += "HRResultsE_button_EAMassSpec;"		// 6 = Elemental Mass Spec
	HRResultsButtonList += "HRResultsE_button_EARatioDiurn;"		// 7 = EA ratios time series, Diurnal
	HRResultsButtonList += "HRResultsM_button_1SpecieGroup;"	// 8 =family colored for single HR SPECIES
	HRResultsButtonList += "HRResultsM_button_AerSpeciesDug;"	// 9 = Doug's 5 graph family summary for SPECIES
	HRResultsButtonList += "HRResultsM_button_MassDefect;"		// 10 = Doug's 5 graph family summary for SPECIES		// 1.16Z
	HRResultsButtonList += "HRResultsT_butt_1SpecieFGroupTS;" 	// 11 added in 11.14E

	HRResultsButtonList += "HRResultsP_avconc;"		//  12  added in 1.20E
	HRResultsButtonList += "HRResultsP_imconc;"		//  13  added in 1.20E
	HRResultsButtonList += "HRResultsP_mscon;"			//  14  added in 1.21G
	HRResultsButtonList += "HRResultsP_exco;"			//  15  added in 1.21G

	// This is not a popup menu item, but rather an internal code for use in the sq_conc function
	HRResultsType = WhichListItem(controlName, HRResultsButtonList)
	if (HRResultsType<0)
		abort "Please recreate the Pika panel.  Aborting from HR_butt_MS_Calc"  //1.14M
	endif

	if (!waveexists(todo) || numpnts(todo) == 0 )
		abort  "Todo wav "+todoStr+" does not exist or is zero length - Aborting from HR_butt_MS_Calc"
	endif

	if (HR_checkUseAB)
		sq_ABsanity()
	endif

	HR_cleanupHRResults_ionList(HRResultsType) // 1.22A

	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (ItemsInList(nonHRSpec,",")>0 && ( (HRResultsType>=2 && HRResultsType<=11)  || HRResultsType>=14 )	)	//1.22A
		for(idex=ItemsInList(nonHRSpec,",")-1;idex>=0;idex-=1)
			tempStr = stringFromList(idex, nonHRSpec, ",")
			if (!stringmatch(LowerStr(tempStr[0,min(strlen(tempStr)-1,5)]), "family"))
				DoAlert 1, "The entity "+	tempStr+" appears to be a single HR ion, but a result is requested that contains a full m/z dimension. Remove "+tempStr+"?"		
				if (V_flag==1)  // No
					nonHRSpec = RemoveListItem(idex, nonHRSpec, ",")
					HRResults_ionList = RemoveFromList(tempStr, HRResults_ionList, ",")  
//				else
					return 0
				endif
			endif
		endfor
	endif	

	ControlInfo/W=HR_Analysis_Panel HRResults_pop_graphOutputType  // HRResults_pop_graphType  //1.12O
	if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Please Reselect")  || stringMatch(S_Value, "Get List"))
		abort "Please select the graph output type from the drop down menu."
	endif

 	ControlInfo/W=HR_Analysis_Panel HRResults_pop_dataSet
	if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Get List"))
		abort "Please select the data type from the drop down menu."
	else
		spectraType=S_Value
	endif
	MSorPToFHRsticks = 1  // presume MS data
	make/free/n=7 HRPToFInfo
	
	if (!stringmatch(spectraType[0,1], "HR"))		//PToF
		MSorPToFHRsticks=0
		pk_returnHRPToFInfo(spectraType, HRPToFInfo) 
//		if (HR_checkConvertTougm3)
//			abort "Generating to units of ug/m3 is not yet possible. - Aborting from HR_butt_MS_Calc"
//		endif
		if ( !(HRPToFInfo[%RowPos]>= 0) )
			abort "Had problems finding the correct PToF HR data set. - Aborting from HR_butt_MS_Calc"
		endif
//		spectraType = spectraType[5, strlen(spectraType)-1]	
		if (HRPToFInfo[%IsSub])
			specTypeInitial="P"+num2istr(HRPToFInfo[%SubRowA])+"L"+num2istr(HRPToFInfo[%SubRowB])
		else
			specTypeInitial="P"+num2istr(HRPToFInfo[%RowPos])
		endif
		matrixFlag = HRPToFInfo[%MatrixFlag]>1
		if(!matrixFlag && HRResultsType<=1 & HR_checkConvertTougm3)
			DoAlert 1, "Conversion to ug/m3 is not appropriate for non matrix HRPToF data.  To change the units to Hz, press yes, else to abort press no."
			if (V_flag==1)
				HR_checkConvertTougm3=0
			endif
		elseif(matrixFlag && HRResultsType<=1 & HR_checkConvertTougm3 && HRPToFInfo[%IsSub]==0)
			DoAlert 2, "Conversion to ug/m3 for non matrix HRPToF data that hasn't been DC subtractd (Step 5c) is like generating MS Open in ug/m3.  To change the units to Hz, press yes, else to abort press cancel."
			if (V_flag==3)
				abort
			elseif(V_flag==1)
				HR_checkConvertTougm3=0
			endif
		endif
	else			//MS
		if (strsearch(spectraType, "HROMinusC", 0)   >=0	) ////////HRResults_dataType==4)		//1.11A fix  1.11D fix, capital letters!
			specTypeInitial="M"/// m for Open minus closed
		else 
			specTypeInitial=spectraType[2]		//i.e. HROpenStick
		endif
	endif

	if( MSorPToFHRsticks && FindDimlabel(squirrel_index,2,spectraType)<0)
		abort "The data set "+spectraType+" not found. Perhaps you need to fit HR sticks? - Aborting from HR_butt_MS_Calc"
	endif

	if(HR_checkCalcHRErrors)
		if (!MSorPToFHRsticks)
			abort "Errors are not yet available for HR PToF data sets - Aborting from HR_butt_MS_Calc"
		endif
		ControlInfo/W=HR_Analysis_Panel HRResults_pop_ErrType
		if (stringMatch(S_Value, "Initialize") || stringMatch(S_Value, "Get List"))
			abort "Please select the HR error type from the drop down menu. - Aborting from HR_butt_MS_Calc"
		endif
//		S_Value="DiffSitck"
		if(FindDimlabel(squirrel_index,2,S_Value)<0)
			abort "The error data set "+S_Value+" not found.  Perhaps you need to refit HR sticks or calculate total ion count error?  - Aborting from HR_butt_MS_Calc"
		endif
		// sanity check added in 1.12O		// right now we assume that HR sticks are HRO, HRC HRD, or HROM
//		if (  (stringmatch(specTypeInitial, "M") && strsearch(S_Value, "OMinusC", 0) <=0)  ||  (!stringmatch(specTypeInitial, "M")  && !stringMatch(specTypeInitial, S_Value[2]) )	  )
		if (!stringMatch(specTypeInitial, S_Value[2]) )	
			if ( ! (strsearch(S_Value, "OMinusC", 0)>0 && (stringmatch(specTypeInitial, "M") || stringmatch(specTypeInitial, "D") )) )
				DoAlert 1, "The data and error choices don't seem to match.  For example closed spectra but open errors.  Continue?"
				if (V_flag==2)
					abort "The user chose to abort"
				endif			 
			endif
		endif
		if(HRResultsType>=12)
			DoAlert 1, "No error data sets are available for HR PToF data. Press yes to unselect and continue without errors. "
			if (V_flag)
				HR_checkCalcHRErrors=0
			else
				return 0
			endif
		endif
		errorType=S_Value
	else
		errorType=""
	endif
		
	//1.15P	
	if ( HR_elementalImprovedCal && ( stringmatch(controlName, "HRResultsE_button_EARatios") || stringmatch(controlName, "HRResultsE_button_EARatioDiurn") )   )
		DoWindow/F HROrgCheck_Panel
		if (V_flag==0)			// this panel does not exist
			DoAlert, 1, "You have selected the Improved-Ambient formulation, but the HROrgCheck_panel doesn't exist.  This panel helps users asses their fCO and fCHO.  Continue without the panel? "
			if (V_flag == 2)		// No was pressed.
				Abort "The user chose to abort."
			endif
			wave/z fCO2 = root:elementalAnalysis:fCO2
			wave/z fCHO = root:elementalAnalysis:fCHO
			if (  !WaveExists(fCHO) || !WaveExists(fCO2) )
				HROrgCheck_Panel_make("")
				abort "The waves 	root:elementalAnalysis:fCO2 or root:elementalAnalysis:fCHO do not exist. Use the HROrgCheck panel to calculate." 		

			endif
			DoAlert, 1, "The fCO and fCHO waves from the HROrgCheck_panel will be used. Continue? "
			if (V_flag == 2)		// No was pressed.
				Abort "The user chose to abort."
			endif
		endif
	endif

	if (!ams_time_saved && HRResultsType==5 )		//1.58G
		Abort "Calculating elemental ratios for the non-saved time base is not yet possible."
	endif
		
	if (HRResultsType==6)
		if(itemsInList(HRResults_ionList, ",")>=2)	// 1.22A 
			DoAlert 1,  "Calculating elemental mass spectra for more than one species is not yet possible. To continue only with the HROrg species press yes."
			if (V_flag==1)
				HRResults_ionList="HROrg"
			endif
		elseif(strlen(HR_CheckListForHRSpecies(HRResults_ionList, 4))==0)
			Abort "Calculating elemental ratios is only possible for HR species."
		endif
	endif

	if (HRResultsType>=12 && HRResultsType<=14 && !matrixFlag)  // 12 - 14   //1.21G
		abort "These calculations are only possible with HR PToF matricies - Aborting from HR_butt_MS_Calc"
		sq_checkPToFparamsSameTodo(todo)
	
		if (tof1_norm) //  && tof1_datatype==2)
			Abort "This functionality is not yet available.   Aborting from Pk_butt_ToFConc"		//1.59D
	//		Abort "You cannot normalize to MS data if the diamter axis is X vs PToF  - Aborting from Pk_butt_ToFConc"		//1.59D
		endif
	
		// Check if todo wave has >0 PToF spectra.  We possibly reduce the selected todo wave to run that have PToF (todo = tempTodo)
		wave/z allPToF = root:allPToF	
		if (WaveExists(allPToF))
			sq_create_todo(todoStr+" and allPTOF","TempPToF")
			wave todo = root:TempPToF
			if (numpnts(todo)==0)
				killwaves/z root:tempTodo
				abort "There are no PToF runs in "+todoStr+".  Aborting from Pk_butt_ToFConc"
			endif
		endif
	
		variable hasPToF, hasePToF
		if (hasPToF && hasEPToF )
			abort "Cannot continue because the todo wave "+todoStr+" has both PToF and ePToF runs.  Aborting from Pk_butt_ToFConc"
		elseif(hasEPToF)
			abort "Cannot continue because the todo wave "+todoStr+" has ePToF runs.  Aborting from Pk_butt_ToFConc"
		endif	
	elseif (HRResultsType<12 && matrixFlag)
		abort "These calculations are not possible with HR PToF matrix data set - Aborting from HR_butt_MS_Calc"
	endif

	// first, is it feasible to do an average?
	if (sq_OnlyOneModeInTodo(todo)!=1 )		//^ 1.40A
		abort  "Cannot perform on a todo wave with different modes (v and w switching) - Aborting from HR_butt_MS_Calc"		//  not neccessarily the case...
	endif			

//////////////////////
// now we start preparing for getting data
	
	//1.14M
	numHR = PK_WavesForHRResults()		//1.08G	get correct list of HR ions  		//  changed in 1.10C to now also recalculate family designations

	HR_butt_TableHRIonsTodoFit("")			//1.14I

	// we need something in the species list, except for EA and Dougs's 
	HRResults_ionList = replaceString(" ",HRResults_ionList,"")
	if (HRResultsType<2 && (itemsinlist(HRResults_ionList,",")==0 ) )
		abort "No species were identified - Aborting from HR_butt_MS_Calc"	 
	endif

	if (HRResultsType==3 && ItemsInList(HRResults_ionList, ",")>1 )		//1.14M
		doAlert 1, "More than one matrix will be generated containing the full time series (rows) and HR ions (columns).  Press yes if you intend to generate > 1 matrix, no to abort"
		if (V_flag==2)
			abort "The user chose to abort"
		endif
	endif

	//1.51Q  add option for doing Elemental analysis on something other than HROrg
	if (HRResultsType==5)		//1.14M
		if (itemsInList(HRResults_ionList, ",")>=2)
			abort "When calculating elemental analysis there can be only one or zero (=HROrg) number of species. - Aborting from HR_butt_MS_Calc"	
		elseif(itemsInList(HRResults_ionList, ",")==0)
			HRResults_ionList="HROrg"
		endif		
		if (stringmatch(specTypeInitial, "O") || stringmatch(specTypeInitial, "C"))		//1.14M
			abort "The elemental ratio value calibration factors may not be applicable to Open or Closed spectra. - Aborting from HR_butt_MS_Calc"	
		endif
	endif

	if (HRResultsType==10 && itemsInList(HRResults_ionList, ",")>=2)
		abort "Can only do Mass defect plot for one item - reduce the list to be one entity: "+HRResults_ionList+". - Aborting from HR_butt_MS_Calc"	
	endif
	
	// for doing diurnal plots, we want to NOT try do calcs with non-auto save time base
	t_base=""
	if (ams_time_saved!=1)
		if ( HRResultsType == 0 || HRResultsType == 7)  // diurnal calcs, ER diurnal calcs
			abort "Cannot do diurnal calculations with a time base that is not the as-saved option. - Aborting from HR_butt_MS_Calc"	
		elseif (HRResultsType == 3  || HRResultsType == 5)  // time series, EA time series, 2 d matrix
			if (ams_time_custom)
				abort "Cannot export 2D matrix with custom time at this time.   - Aborting from HR_butt_MS_Calc"	
			endif
		endif
		t_base=sq_tbase()		// returns empty string if using the as saved option
	endif
	
	myPlotName=""
	myWinName = WinName(0,1)		// get name of the top graph, need it for appending or checking to see if the graph already exists
		
	if (HRResults_graphOutputType==3 && HRResultsType<14)  // if we are appending, does it make sense?
		if ( strlen(myWinName)==0 )
			abort "It doesn't make sense to append results because no graphs exist - Aborting from HR_butt_MS_Calc"
		endif
		if (WhichListItem("bottom", AxisList(myWinName )) < 0 )
			abort "Cannot append results if no axis named 'bottom' does not exist in the top graph, "+myWinName+" - Aborting from HR_butt_MS_Calc"
		endif
		GetAxis/Q/W=$myWinName bottom		// presumes that the bottom axis is named bottom  Sets V_min and V_max
		
		// start sanity checks regarding graphs. HRResultsType = 3 is time series mass spec, 4 is Doug's graph
		if ( !(HRResultsType==0 || HRResultsType==1 || HRResultsType==2 || HRResultsType==12)) // not time-series mass spec, and we append
			abort "Can only append time-series or mass spec types of results - Aborting from HR_butt_MS_Calc"
		elseif(HRResultsType==0) // diurnal
			if (V_min>25 || V_max >25)
				abort "It doesn't appear to make sense to append a diurnal trace to the top most graph - Aborting from HR_butt_MS_Calc"
			endif
		elseif(HRResultsType==1) // time series
			if ( !(V_min> date2secs(1970,1,1)) )
				abort "It doesn't appear to make sense to append a time series trace to the top most graph - Aborting from HR_butt_MS_Calc"
			endif
		elseif(HRResultsType==2) // mass spec
			if ( V_min>= date2secs(1970,1,1)) 
				abort "It doesn't appear to make sense to append a mass spec trace to the top most graph - Aborting from HR_butt_MS_Calc"
			endif
		elseif(HRResultsType==12) // PToF Size dist
			nvar tof1_datatype = root:panel:tof1_datatype
			if ( tof1_datatype == 1)  // DVA
				if (V_min>= date2secs(1970,1,1))  
					abort "It doesn't appear to make sense to append a size distribution trace to the top most graph - Aborting from HR_butt_MS_Calc"
				endif
			else   // PToF time
				if ( ! (V_max< 1)  )
					abort "It doesn't appear to make sense to append a size distribution trace to the top most graph - Aborting from HR_butt_MS_Calc"
				endif
			endif
		
		endif
	endif

	if ( HRResultsType>=12 && !HRPToFInfo[%MatrixFlag] )
		abort "The selected HR PToF data set must be a matrix. - Aborting from HR_butt_MS_Calc"
	elseif (MSorPToFHRsticks==0 && HRPToFInfo[%matrixFlag]>1 && HRResultsType<12)
		abort "The selected HR PToF data set cannot be a matrix for this operation - Aborting from HR_butt_MS_Calc"
	endif
		
	if (HR_checkAskForSuffix)
	 	waveNameSuffix = sq_getWaveNameSuffix()
 	else
 		waveNameSuffix = todoStr
 	endif

	myWinList = WinList("*", ";", "WIN:1" )		// just a generic list of all graph windows
	
	// we passed several sanity checks.  Now start to prepare things.
	
	strswitch(specTypeInitial[0])
		case "O" :
		timeWt="1"
		break
		case "C" :
		timeWt="2"
		break
		case "P" :
		timeWt="4"		// PTOF
		break
		default:
		timeWt="3"	// diff or ominusc
		break
	endswitch
	
	paramStrPartial=""
	paramStrPartial="Todo:"+todoStr+";"
	paramStrPartial+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"
	paramStrPartial+="negTo0_flag:"+num2str(HR_checkConvertNegsTo0)+";"		//bug! forgot the :  1.09D fix
	paramStrPartial+="corr_op:"+num2str(HR_checkUseAB)+";"
	paramStrPartial+="ug_op:"+num2str(HR_checkConvertTougm3)+";"	
	paramStrPartial+="t_base:"+t_base+";"	
	paramStrPartial+="timeweight_op:"+timeWt+";"		//1.07C
	paramStrPartial+="spectraType:"+spectraType+";"		//1.21G

	//1.14M
	if (numHR>0)
		if (HRResultsType>=12)	//	HR PTOF matrix
			paramStrPartial+="min_ly:0;max_ly:"+num2str(numHR-1)+";"
		else
			paramStrPartial+="min_cl:0;max_cl:"+num2str(numHR-1)+";"
		endif
	endif
	
	variable runPos = sq_getRunPos(todo[0])

	// for single HR PTOF data sets
	paramStrPartial+="PToFFlag:"+num2str(!MSorPToFHRsticks)+";"		//1.07C
	if(!MSorPToFHRsticks)  // PToF
	
//		paramStrPartial+="DVa:"+num2str(HR_checkPToFDVa)+";"		//1.21G
		if (HRPToFInfo[%matrixFlag]==0)		// PToF  single data set
//			paramStrPartial+="frag_exclude:HR_frag_air;"	
//			if (HR_checkPToFDVa)
//				variable dtVal =pk_Returndtdlogdp(HRPToFInfo[%startBin],HRPToFInfo[%stopBin],runpos)
//				string dtValStr, loDva, hiDva
//				sprintf dtValStr, "%0.8f", dtVal
//				paramStrPartial+="dtdlogdp_op:"+dtValStr+";"						//1.19E
//				variable/c sizeEdges = sq_FindHRPToFEdges(HRPToFInfo[%startBin],HRPToFInfo[%stopBin], runPos)	  // at this point we know it is not a matrix	// simply a way to store 2 variables... is not really a complex numb
//				paramStrPartial+="OneBindlog_op:"+Num2str(log(imag(sizeEdges)) - log (real(sizeEdges)))+";"		//1.19E
//				sprintf loDva, "%d", real(sizeEdges)
//				sprintf hiDva, "%d", imag(sizeEdges)
//				paramStrPartial+="loEdge:"+loDva+";"
//				paramStrPartial+="hiEdge:"+hiDva+";" 
//			endif
//			paramStrPartial+="hz_op:1;" 1.21G

		elseif(HRResultsType>=12)  // PToF Matrix		
			variable numbins = HRPToFInfo[%matrixFlag]
//			variable binDelta = ceil( (HRPToFInfo[%StopBin]+1 - (HRPToFInfo[%StartBin]))/numbins)
			make/o/n=6/Free DVa_wave 
			sq_GetPToFParams(DVa_wave, runPos)
			wave/wave HRPToFMxXaxis = HR_MakeHRPToFMxXaxis(HRPToFInfo, runPos, "root:PToF:")
		endif
	endif
	
	// if we output a graph, find graph name
	switch (HRResultsType)
		case 0: //	0 is diurnal
			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request
				myPlotName = myWinName
				if (V_min <-1 || V_max >25)
					abort "It doesn't make sense to append a diurnal plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName = "DiurnalHRGr_"+waveNameSuffix
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif
			
			// Finally, get to work!
			HR_MSCalcPlot_Diurnal(waveNameSuffix,myPlotName, spectraType, specTypeInitial, paramStrPartial)
		
		break

		case 1: //	tseries
			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request
				myPlotName = myWinName
				if (V_min <3e9 || V_max >5e9)
					abort "It doesn't make sense to append a time series plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName = "TseriesHRGr_"+waveNameSuffix
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif
			
			// Finally, get to work!
			HR_CalcPlot_MSVsTime(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
		
		break

		case 2:		// average mass spectra.  Lots of things can go wrong.
			// next, check about the feasibility of graphing the results
			if (HRResults_graphOutputType==2)		// for now disable the plot multiple option, it makes things way too confusing with updating plots
				abort "Please reselect the graph output option. Plotting multiple graphs for average mass spec gets too confusing. - Aborting from HR_butt_MS_Calc"			
			elseif(HRResults_graphOutputType==3)// check to see that it makes sense to append request
				myPlotName	= myWinName	
				if (V_min < 0 || V_max > 5000)		// we are appending raw spectra vs itof
					abort "It doesn't make sense to append an mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType==4)// check to see that it makes sense to update
				myPlotName	= myWinName	
				if( V_min < 0 || V_max > 5000) 	// it gets way to confusing to append sticks, but appending raw spectra is ok, as long as we plot raw vs m/z
					abort "It doesn't make sense to append a m/z mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName	="MSAvgHRGr_"+waveNameSuffix		
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			elseif(HRResults_graphOutputType ==4)	// update
				myPlotName	=myWinName	
			endif
			
			// Now check that we aren't appending species that are already there 
			tempList = GetUserData(myWinName, "", "specList" )
			if(HRResults_graphOutputType==3)		// we append

// eventually we will want to include this, but for now it gets too confusing	
//				if (ItemsInList(gen_IntersectLists(tempList, ReplaceString(",", HRResults_ionList, ";"))) >0 )
//					abort "Cannot append average spectra of a species if that species is already plotted - Aborting from HR_butt_MS_Calc"
//				endif
//			elseif(HRResults_graphOutputType==4) // we update.  Make sure that the currently selected species are plotted.
//				tempSpecList = ReplaceString(",", HRResults_ionList, ";")
//				for(idex=0;idex<ItemsInList(tempSpecList);idex+=1)
//					if (WhichListItem(stringfromlist(idex,tempSpecList),tempList)<0 )
//						abort "Cannot update an average spectra graph if the species "+stringfromlist(idex,tempSpecList)+" is not already plotted - Aborting from HR_butt_MS_Calc"
//					endif
//				endfor
			endif
		
			// Finally, get to work!
			HR_CalcPlot_MSAvg(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
			
		break
		case 3: //	tseries mass spec matricies, no plotting
			
			HR_calc_TSeriesMSMatricies(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType)
		
		break
		default :
			
		case 4: // Doug's graph 5 HRResults_butt_PlotHRDoug5
			
			if(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName	="HR5GrSummary_"+waveNameSuffix		
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			elseif(HRResults_graphOutputType ==4)	// update
				myPlotName	=myWinName	
			endif
			HR_calcPlot_5PanelSummary(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
		
		break
		default :

		case 5: //	 EA time series ratios HRResults_button_EARatios
			
			string  VKstr="", EAstr="" 	,TSstr="", CorrelStr = ""	//1.15F
			variable VKflag, EAflag, TSflag
			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request				
				myPlotName = myWinName	
				if(strsearch(myWinName, "EARatiosGr", 0)>=0)		// we want to append to a EA ratios graph.  Make sure we have the matching Van Krevelen graph
					VKstr =ReplaceString("EARatiosGr", myWinName,"VanKrevelen")
					EAstr = myWinName
					TSstr = ReplaceString("EARatiosGr", myWinName,"TimeSeriesForEAGr")
				elseif (strsearch(myWinName, "VanKrevelen", 0)>=0)
					VKstr =myWinName
					EAstr = ReplaceString("VanKrevelen", myWinName,"EARatiosGr")
					TSstr =ReplaceString("VanKrevelen", myWinName,"TimeSeriesForEAGr")
				else
					abort "You have selected to append, but both EARatiosGr* and VanKrevelen* graphs must exist - Aborting from HR_butt_MS_Calc"
				endif
				DoWindow/F $VKstr		// order is imp here...HR_calcPlot_EARatios relies on  EA graph being first
				VKflag=V_flag
				DoWindow/F $EAstr
				EAflag=V_flag
				DoWindow/F $TSstr
				TSflag=V_flag
				if (EAflag!=1 || VKflag!=1  || TSflag!=1)
					abort "You have selected to append, but EARatiosGr, VanKrevelen and TimeSeriesForEA graphs must exist.  Looking for "+VKstr+" and "+EAstr+" and "+TSstr+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				EAstr = "EARatiosGr_"+waveNameSuffix
				if (CheckName(EAstr, 6) )
					EAstr = UniqueName(EAstr,6,0)	// only apppend to graphs created in 1.46B
				endif
				VKstr = "VanKrevelen_"+waveNameSuffix
				if (CheckName(VKstr, 6) )
					VKstr = UniqueName(VKstr,6,0)	// only apppend to graphs created in 1.46B
				endif
				TSstr = "TimeSeriesForEA_"+waveNameSuffix
				if (CheckName(TSstr, 6) )
					TSstr = UniqueName(TSstr,6,0)	// only apppend to graphs created in 1.46B
				endif
				CorrelStr = "IA_vs_AAForEA"+waveNameSuffix
				if (CheckName(CorrelStr, 6) )
					CorrelStr = UniqueName(CorrelStr,6,0)
				endif
			elseif(HRResults_graphOutputType ==2)
				abort "Plotting multiple graphs is no longer an option since VanKrevelen plots have been added  - Aborting from HR_butt_MS_Calc"
			endif

			Wave2PlotList = HR_calc_EARatios(waveNameSuffix, spectraType, paramStrPartial, errorType)
			if ( HR_elementalImprovedCal) // EA Time series.  First calc fHROrgCO and fHROrgCHO  //1.15F  Manjula's correction
				waveNameSuffix+="_IA"
			endif
			HR_plot_EARatioTimeSeries(Wave2PlotList, waveNameSuffix, TSstr)
			
			wave HC =$"root:ElementalAnalysis:Ratio_H_C_"+waveNameSuffix		//1.12I
			wave OC =$"root:ElementalAnalysis:Ratio_O_C_"+waveNameSuffix
			wave OM_OC =$"root:ElementalAnalysis:Ratio_OM_OC_"+waveNameSuffix
			
			nvar IA_AA_Correlation = root:ElementalAnalysis:IA_AA_Correlation
			if ( HR_elementalImprovedCal && IA_AA_Correlation)
				if (HRResults_graphOutputType==3)
					DoWindow/F $CorrelStr
				endif
				HROrgCheck_Plot_EA_AAvsIA(HC,OC,OM_OC, waveNameSuffix, Correlstr )
			endif

			if (HRResults_graphOutputType==3)
				DoWindow/F $VKstr
			endif
			HR_plot_VanKrevelen(HC,OC, VKstr) 

		break
//		default :  //1.21G

		case 6: //	EA average mass spec HRResults_button_EAAMassSpec
			
			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request
				myPlotName = myWinName
				if  (V_min <3e9 || V_max >5e9)
					abort "It doesn't make sense to append mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName = "EASpectrumGr_"+waveNameSuffix
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif

			 HR_calcPlot_EAMassSpec(waveNameSuffix, myPlotName, spectraType, paramStrPartial, errorType)
		
		break
		case 7: //	EA average mass spec HRResults_button_EA Diurnal
			
			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request
				myPlotName = myWinName
				if (V_min <-1 || V_max >25)
					abort "It doesn't make sense to append a diurnal plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName = "DiurnalEAGr_"+waveNameSuffix
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif

			 HR_calcPlot_EARatioDiurnal(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial+ "specTypeInitial:"+specTypeInitial+";")  //1.14H fix
		
		break
		case 8: //	grouped avg mass spec for a single HR species
			// first, is it feasible to do an average?
			if(itemsInList(HR_CheckListForHRSpecies(HRResults_ionList, 4), ",")!=1)
				abort "There must be one and only one species in the list to perform this operation - aborting from HR_calcHRSpeciesGroupedGr"
			endif
			if (sq_OnlyOneModeInTodo(todo)!=1 )		//^ 1.40A
				abort  "Cannot do mass averaging on a todo wave with different modes (v and w switching) - Aborting from HR_butt_MS_Calc"		//  not neccessarily the case...
			endif			
			// next, check about the feasibility of graphing the results
			if (HRResults_graphOutputType==2 || HRResults_graphOutputType==3)		// for now disable the plot multiple option, it makes things way too confusing with updating plots
				abort "Please reselect the graph output option. Plotting multiple graphs for average mass spec gets too confusing. - Aborting from HR_butt_MS_Calc"			
			elseif(HRResults_graphOutputType==4)// check to see that it makes sense to update
				myPlotName	= myWinName	
				if( V_min < 0 || V_max > 5000) 	// it gets way to confusing to append sticks, but appending raw spectra is ok, as long as we plot raw vs m/z
					abort "It doesn't make sense to append a m/z mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName	="MSAvgHRSpeciesGr_"+waveNameSuffix		
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif
					
			// Finally, get to work!
			HR_CalcPlot_MSAvgSpeciesGrouped(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
			
		break
		
		case 9: //	grouped avg mass spec for all aerosol HR species
			if (sq_OnlyOneModeInTodo(todo)!=1 )		//^ 1.40A
				abort  "Cannot do mass averaging on a todo wave with different modes (v and w switching) - Aborting from HR_butt_MS_Calc"		//  not neccessarily the case...
			endif			
			// next, check about the feasibility of graphing the results
			if (HRResults_graphOutputType==2 || HRResults_graphOutputType==3)		// for now disable the plot multiple option, it makes things way too confusing with updating plots
				abort "Please reselect the graph output option. Plotting multiple graphs for average mass spec gets too confusing. - Aborting from HR_butt_MS_Calc"			
			elseif(HRResults_graphOutputType==4)// check to see that it makes sense to update
				myPlotName	= myWinName	
				if( V_min < 0 || V_max > 5000) 	// it gets way to confusing to append sticks, but appending raw spectra is ok, as long as we plot raw vs m/z
					abort "It doesn't make sense to append a m/z mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName	="MSAvgHRSpeciesGr_"+waveNameSuffix		
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif
					
			// Finally, get to work!
			HR_CalcPlot_5PanelHRSpecies(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
			
		break				

		case 10: //	avg mass defect
			// first, is it feasible to do an average?
			if (sq_OnlyOneModeInTodo(todo)!=1 )		//^ 1.40A
				abort  "Cannot do mass averaging on a todo wave with different modes (v and w switching) - Aborting from HR_butt_MS_Calc"		//  not neccessarily the case...
			endif			
			// next, check about the feasibility of graphing the results
			if (HRResults_graphOutputType==2)		// for now disable the plot multiple option, it makes things way too confusing with updating plots
				abort "Please reselect the graph output option. Plotting multiple graphs for average mass spec gets too confusing. - Aborting from HR_butt_MS_Calc"			
			elseif(HRResults_graphOutputType==3)// check to see that it makes sense to append request
				myPlotName	= myWinName	
				if (V_min < 0 || V_max > 5000)		// we are appending raw spectra vs itof
					abort "It doesn't make sense to append an mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType==4)// check to see that it makes sense to update
				myPlotName	= myWinName	
				if( V_min < 0 || V_max > 5000) 	// it gets way to confusing to append sticks, but appending raw spectra is ok, as long as we plot raw vs m/z
					abort "It doesn't make sense to append a m/z mass spec plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName	="MassDefectHRGr_"+waveNameSuffix		
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			elseif(HRResults_graphOutputType ==4)	// update
				myPlotName	=myWinName	
			endif
					
			// Finally, get to work!
			HR_CalcPlot_MSDef(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
		break
		
		case 11: //	HRResults_butt_1SpecieFGroupTS ... treat it like type 3, time series average mass spec and then sum to families later

			if(HRResults_graphOutputType==3) // check to see that it makes sense to append request
				myPlotName = myWinName
				if (V_min <3e9 || V_max >5e9)
					abort "It doesn't make sense to append a time series plot to the bottom axis on graph "+myWinName+" - Aborting from HR_butt_MS_Calc"
				endif
			elseif(HRResults_graphOutputType ==1)	// new graph but we already have one of these
				myPlotName = "TSHRGr_Fam"+waveNameSuffix
				if (CheckName(myPlotName, 6) )
					myPlotName = UniqueName(myPlotName,6,0)	// only apppend to graphs created in 1.46B
				endif
			endif
			
			HR_calcplot_TSMSMatriciesFGrp(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)

		break

		case 12: //	HR PToF Size avg distrib
			HR_calcplot_PTOFSizeDist(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
		break

		case 13: //	HR PToF image plot
			HR_calcplot_PTOFImage(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
		break
		
		case 14: // HRResultsP_mscon	size resolved avg mass spec
			HR_calcplot_PTOFMS(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
		break
		
		case 15: //	HRResultsP_exco 3D matrix export
			HR_calcplot_PTOFExport(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
		break
		default :
		abort "There was a problem finding the name of the button you pressed. - aborting from  Aborting from HR_butt_MS_Calc"
	
	endswitch

	string dfStr = getDataFolder(1)		//1.14D
	SetDataFolder root:HR_ms_mats
	Killwaves/z/a
	SetDataFolder $dfStr
 	Killwaves/z root:TempPToF
 
End


Function HR_cleanupHRResults_ionList(HRResultsType)
variable HRResultsType
//	HRResultsType  = 2 = avg mass spec 
//	HRResultsButtonList += "HRResults2_button_TseriesMass;"		// 3 = export 2 d time series m/z
//	HRResultsButtonList += "HRResultsM_button_PlotHRDoug5;"		// 4 = Doug's 5 graph family summary
//	HRResultsButtonList += "HRResultsE_button_EARatios;"			// 5 = EA ratios time series
//	HRResultsButtonList += "HRResultsE_button_EAMassSpec;"		// 6 = Elemental Mass Spec
//	HRResultsButtonList += "HRResultsM_button_1SpecieGroup;"	// 8 =family colored for single HR SPECIES
//	HRResultsButtonList += "HRResultsM_button_AerSpeciesDug;"	// 9 = Doug's 5 graph family summary for SPECIES
//	HRResultsButtonList += "HRResultsM_button_MassDefect;"		// 10 = Doug's 5 graph family summary for SPECIES		// 1.16Z
//	HRResultsButtonList += "HRResultsT_butt_1SpecieFGroupTS;" 	// 11 added in 11.14E
//
//	HRResultsButtonList += "HRResultsP_avconc;"		//  12  added in 1.20E  size dist
//	HRResultsButtonList += "HRResultsP_imconc;"		//  13  added in 1.20E  PToF image
//	HRResultsButtonList += "HRResultsP_mscon;"			//  14  added in 1.21G  ave mass spec
//	HRResultsButtonList += "HRResultsP_exco;"			//  15  added in 1.21G
	svar HRResults_ionList=root:HR_panel:HRResults_ionList

 	HRResults_ionList = ReplaceString(";", HRResults_ionList, ",")		//1.13D
 	HRResults_ionList = ReplaceString(",,", HRResults_ionList, ",")		//1.13D
 	HRResults_ionList = ReplaceString(" ", HRResults_ionList, "")		//1.13D

	string str, nonHRSpecList, HRSpecList
 	variable idex, num = itemsInLIst(HRResults_ionList)
	nonHRSpecList = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	HRSpecList = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpecList)==0 && strlen(HRSpecList)==0)
		if (HRResultsType== 2 || HRResultsType== 14 )
			HRResults_ionList="all"
		else
			abort "There seems to be something wrong with the HR result list in step 6i. Is there a typo?"
		endif
	endif

	if (itemsInList(HRResults_ionList, ",") != ItemsInList(nonHRSpecList, ",") +ItemsInList(HRSpecList, ",") )
		abort "There seems to be something wrong with the HR result list in step 6i. Is there a typo?"
	endif

End


Function	HR_MSCalcPlot_Diurnal(waveNameSuffix,myPlotName, spectraType, specTypeInitial, paramStrPartial)
string waveNameSuffix,myPlotName, spectraType, specTypeInitial, paramStrPartial

	string waves2plot
	waves2plot = HR_MSCalc_Diurnals(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial)
	HR_MSplot_DiurnalBoxPlot(waves2plot, myPlotName)

End


// almost identical to sq_MSCalc_Diurnals
Function/s HR_MSCalc_Diurnals(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial

	nvar HRResultsT_whisker = root:HR_panel:HRResultsT_whisker		//1.14M
	
	sq_journal_new("DiurnalPlots")

	variable nspecies, idex, kdex, percentile_1, percentile_2, hourdex 
	variable length, timepoint, count, numberpoints, jdex
	string specStr, destWaveList, elemStr, colorTriad

	wave t_series = root:index:t_series
	length = numpnts(t_series)
	if (HRResultsT_whisker == 2)
		percentile_1 = 5
		percentile_2 = 95
	else
		percentile_1 = 0
		percentile_2 = 100
	endif
	
	sq_diurnalIndex()

	wave t_series = root:index:t_series

	wave DiurnalCounter = root:panel:diurnals:DiurnalCounter
	make/o/n=0 root:panel:diurnals:hourdata_temp
	wave hourdata_temp = root:panel:diurnals:hourdata_temp
	
	// we need to be careful when calling the time series function so that we don't create new waves, etc
	destWaveList = HR_calc_MSVsTime("temp", spectraType, specTypeInitial, paramStrPartial, "")		//1.08E changed _temp to temp
			
	nspecies = itemsinlist(destWaveList)

	// loop through all selected species - for diurnal calcs reworked in 1.44B
	for (idex = 0; idex < nspecies; idex += 1)
		specStr = stringfromlist(idex, destWaveList)				
		wave/z datawave = $specStr
		specStr = ReplaceString("_temp", specStr, "_"+waveNameSuffix)
		
		// make median, min, max, percentile waves
		make /O/N=24 $(specStr + "_median") 
		wave medianw = $(specStr + "_median")
		make /O/N=24 $(specStr + "_mean") 
		wave meandata = $(specStr + "_mean")
		make /O/N=24 $(specStr + "_" + num2str(percentile_1) + "p")
		wave p1w = $(specStr + "_" + num2str(percentile_1) + "p")
		make /O/N=24 $(specStr + "_" + num2str(percentile_2) + "p")
		wave p2w = $(specStr + "_" + num2str(percentile_2) + "p")
		make /O/N=24 $(specStr + "_25p")
		wave p25w = $(specStr + "_25p")
		make /O/N=24 $(specStr + "_75p")
		wave p75w = $(specStr + "_75p")
		
		// calculate median, min, max, 25% and 75% percentiles
		for (hourdex=0; hourdex<24; hourdex+=1) 
			if (DiurnalCounter[hourdex]>0)
				// data exists for this hour
				redimension/N=(DiurnalCounter[hourdex]) hourdata_temp		// temporary wave, will be killed at the end
				wave DiurnalIndex = $("root:panel:diurnals:DiurnalIndex" +num2istr(hourdex))		// should be created in sq_diurnalIndex
				hourdata_temp = datawave[DiurnalIndex[p]]			
				sort hourdata_temp hourdata_temp		// any nans should appear at the bottom
				wavestats/q/m=1 hourdata_temp			// m=1 calcs average
				numberpoints=v_npnts
				
				medianw[hourdex] = hourdata_temp[((numberpoints+1)/2)-1]
				meandata[hourdex] = v_avg
				p25w[hourdex] = hourdata_temp[round(numberpoints*1/4)-1]
				p75w[hourdex] = hourdata_temp[round(numberpoints*3/4)-1]
				if (HRResultsT_whisker != 2)
					p1w[hourdex] = hourdata_temp[0]
					p2w[hourdex] = hourdata_temp[numberpoints - 1]					
				else
					p1w[hourdex] = hourdata_temp[round(numberpoints*5/100)-1]
					p2w[hourdex] = hourdata_temp[round(numberpoints*95/100)-1]
				endif
			else			// no data, make blank
				medianw[hourdex] = nan
				meandata[hourdex] = nan
				p25w[hourdex] = nan
				p75w[hourdex] = nan
				p1w[hourdex] = nan
				p2w[hourdex] = nan
			endif
		endfor				
		
		killwaves/z datawave
		
	endfor
	
	sq_journal_end()

	destWaveList = replaceString("_temp", destWaveList, "_"+waveNameSuffix)
	
	return destWaveList		// note that we don't actually return all the waves for diurnal plots - the XXX_median waves, etc
	
End


Function	HR_MSplot_DiurnalBoxPlot(waves2plot, newPlotName)
string waves2plot, newPlotName

	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	nvar HRResultsT_whisker = root:HR_panel:HRResultsT_whisker
	wave DiurnalHours = root:panel:diurnals:DiurnalHours	
	
	variable percentile_1, percentile_2, idex, nspecies, EAFlag, jdex
	string species, textBoxStr, ElemStr, graphName, colorTriad
		
	nspecies = itemsinlist(waves2plot)
	
	EAFlag = StringMatch(waves2plot, "Ratio_H_C")>=0
	
	switch(HRResults_graphOutputType)		
		case 1:		// 1 is plot single, there is only one graph 
			display/N=$newPlotName as newPlotName
			break
		case 2:			// 2 is multiple; kill old window if exists
			for (idex = 0; idex < nspecies; idex += 1)
				species = stringfromlist(idex, waves2plot)
				graphName = "Diurnal_"+species
				doWindow/K $graphName
				display/N=$graphName as graphName				
				doWindow/F graphName 
				textBoxStr = ""
			endfor 
			break
		case 3:		// 3 is append, get current window name
			textBoxStr = ""
			break
		case 4:			// 4 is update
			return 0
			break
	endswitch
	
	if (HRResultsT_whisker == 2)
		percentile_1 = 5
		percentile_2 = 95
	else
		percentile_1 = 0
		percentile_2 = 100
	endif
	
	for (idex = 0; idex < nspecies; idex += 1)
		species = stringfromlist(idex, waves2plot)
			
		if (HRResults_graphOutputType==2)
			newPlotName = "Diurnal_"+species
		endif
		
		doWindow/F newPlotName
			
		wave medianw = $(species + "_median")
		wave meanw = $(species + "_mean")
		wave p1w = $(species + "_" + num2str(percentile_1) + "p")
		wave p2w = $(species + "_" + num2str(percentile_2) + "p")
		wave p25w = $(species + "_25p")
		wave p75w = $(species + "_75p")
		
		gen_fBoxPlot_graphAxNm(medianw,p75w, p25w, p2w, p1w, DiurnalHours, 0.3, 0, $"", $"", 0, 0, 0,newPlotName, "left")
		AppendToGraph/W=$newPlotName/L meanw vs DiurnalHours
		
		ModifyGraph minor(left)=1, nticks(bottom)=12
		ModifyGraph rgb=(0,0,0)
		setwindow kwtopwin,userdata(noleg)="1"
		
		if(HRResults_graphOutputType==2)	// individual plots per species	
			textBoxStr =  "Diurnal Pattern of " + species + " (" + num2str(percentile_1) + "-" + num2str(percentile_2) + "% whiskers)"	
			TextBox/W=$newPlotName/C/N=text0/F=0/A=RT textBoxStr
			textBoxStr=""
		elseif (HRResults_graphOutputType==1 && idex == nspecies-1 )		// one plot for many species
			textBoxStr =  "Diurnal Pattern of \r" + replacestring(";", waves2plot, "\r") + "(" + num2str(percentile_1) + "-" + num2str(percentile_2) + "% whiskers)"	
			TextBox/W=$newPlotName/C/N=text0/F=0/A=RT textBoxStr
		elseif (HRResults_graphOutputType==3)	// append trace
			// for now users will just have to deal with not
		endif
		
	endfor
		
	sq_applyGraphDefs(waves2plot)
	if (HR_checkConvertTougm3)
		Label left "\\F'Symbol'm\\F'Arial'g /m3"
	else
		Label left "Signal, Hz"
	endif
	if (EAFlag)
		Label left "Ratios"
	endif

	Label bottom "Diurnal Hour"//1.08E

	for (idex = 0; idex < nspecies; idex += 1)
		species = stringfromlist(idex, waves2plot)
		if (EAflag)		// only colors 'new' EA waves
			ElemStr =NameOfWave(meanw)[6] 
			jdex = WhichListItem(ElemStr,ELEM_LIST)
			colorTriad = stringFromList(jdex, ELEM_COLORLIST)
			wave meanw = $(species + "_mean")
			if (stringmatch(NameOfWave(meanw)[6,7] , "OM")  )
				colorTriad = "0,0,0"
			endif
			ModifyGraph rgb($NameOfWave(meanw))=(str2num(stringFromList(0, colorTriad, ",")),str2num(stringFromList(1, colorTriad, ",")),str2num(stringFromList(2, colorTriad, ","))  )
		endif			
	endfor
	
End


Function HR_butt_viewEAtable(ctrlName) : ButtonControl
	String ctrlName

	svar HRResults_ionList = root:HR_panel:HRResults_ionList
	wave/t HR_spec_List = root:HR_frag:HR_spec_List		//1.11D typo fix
	HRResults_ionList = ReplaceString(" ", HRResults_ionList, "")
	variable SpecRow = sq_findStr(HR_spec_List,ReplaceString(",", HRResults_ionList, ""),1)
	if (itemsInList(HRResults_ionList, ",")!=1 || SpecRow<0)
		abort "The EA analysis couldn't find the HR species you requested - aborting from HR_butt_viewEAtable"
	endif
	
	wave/t frag_wave= $"root:HR_frag:frag_"+HR_spec_List[SpecRow]  // i.e. frag_HRorg
	HR_EAatomicMassSeparation(frag_wave)

	dowindow/f EA_AtomicMassFractionTable
	if (V_flag==0)
		HR_view_AtomicMassFractionTable() 
	endif
	
End


// PNG: width= 62, height= 95
Picture PkAPESlogo
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!".!!!"b#R18/!%"LJ!<<*"!HV./63+16*9dG'!"!U8=`XQC(D6]J(D6
	a]T@-U;!!!mY79FY1De=*8@<,oZ9ke*XDf]i/F<F@kAnbadJ*f+5!!%6H8OPjDG[>O+=-I4[Q(I_]j
	uI_8g[_Lq2]A'<)fNfc(m55`_iRD\(Xf-(pgYRTl46EE;M6Zu)oVqO.EEV\MW0RK(t\j-D6(k7o_rB
	uT''C+B,*Z[)i:T;4D1;"^MheL]k`%Ks7(U6n'2FS&)5+D7bcYNC^5`BD/X?JIm7l+459/Fjf@e2c(
	")UJ'Q:j[+"PjHi3YQHh?N!4$GiE2f>_+e^`ci0Y>i[cW`Kb5Ad<2a/uajrdEMG-cbW*)n4P>jCC?E
	)RP4oe^ar"[^`j(()E53F1G">9t!Elos9^/ecs"mmqcijn"<AcBA:qSF;mm^g6G=sm?:=pefN]FU+I
	u,gM$Gr:%EkQ2V$)KcJ.T_T6]!7V^C-9K`=6ro2#/QS:=>qhTjFppoImCn9oI<d8!FHgUJ7_DQO?PK
	/PkUc0tIU?@-_PHdD7d^US#?j6*><Vto.nb]BAJ[Ggb^9ai@o52O<fcH^ZH?9cCl:NGFQYhnh]T6&u
	?Za4hp28%5QjKNLiT!\O[^]!WUTPi*aE8s(%'FurT4)2[H!?ZL72Rd#$q1[K[43OA&@$<.c`+8U]]`
	.-YYT4e1[->C]\&r0$1LAC_kC5UFJ(AiB^d!)*"Ad?*I&PG+NZ/kEV8]9S_Lc[om'8oMD/Jr<44l^=
	VMrRU2SnSRhV#HM[^\$IVC*bFGb7Em3'etFL9m(kKF9k%3Q8mV5AWg(&.1p;6.cZRI*1d$g[WB_Rpm
	PSQ`2DlZG/o$V7Ts7a`DONa`DsoqqMac`VY'q5AP!@JRDd'#c_\)\*n;ml`2pq^!#U8c.:IWF/a^Pk
	aG2+L2Hp+NXO.@nYsrUe@)eEg[=J^)R@tTNa7SIUh7[QG`-5$mV1G;GLN<aRq4=0K5!^S8O_>[Hjr#
	`_W!t8]HM09H8sf:PLK=92<sgMbf3FKP-/''&dc0oms^`n_hQ'sp>TJ\mI0MQe`EVc5<Foa/@Lh/Pr
	:GXVT17c1ljHTJ_17[B$pp+?2;*Jg.SsMX&MiuBYK"@jSjR)$)3@!^X(SPIceC\&J\%o3/+e8ebc[A
	C^SM(-1c<sh<Xjti^SQFs-S/Vc#an%Is*l=ch>)ugL/7CS=Qr&1XeHkWRD]`4P2l3$ZduUcIQ=VhVR
	5KLTR\g\4R2L2a(gZ#HdBu;6r&7m:9W[An?#@$7Iq-0GkB[OjDB*VubpghE/oOYhA1E4PZkUT'`sXh
	E/Xam-Ge#K+i-?P)!ui:L24RgH.N,_pF(ujZL&92.kq\'H/7eK^U/8@Y0@WnOZ[7jLIUsCL%2^rZ&a
	6j,Ig!3K#sV6?)]\jkhdS/BFUpUX[;jEEtKCKi9KKYSQD,f5&B:EGo`,$"eUrIVMB3R7;^$d0qH,;+
	U/p&*$GE[f78);,'!e2\-,1Qkl#^q`Hs/a4@L$4,82*eBRO\.6_R&LY1\m%M"M\Cp&nU)4(\WA(YM&
	R+H*4Ybc0e&3K4f9X.a<a\s8CU^a3!g<ROX2ES\/G'Au#_%E;j%iNU8o,uM!IVD4_6P+Fp4J2H1fo(
	$!Fg6p=LR?"C%0`6IAOf[9I*?q?30Y%a_,Tp9>,!d;B5El_l\l:CjBgVh2:?ud6,'+[k`pF9'@,AE2
	LIX'%V=&R>&)(lS'd]]5KS'7c*Di=<;@$Tc*_O%c;+/YQnK4'?P@1mEE(@nBL7%<;EF"'k4;jgC7O2
	I.s,NTC!XujZ0SqiJ)M5r\gFk6JAZF!FGNQS,b*jR!ld+N6nRlt(sUfQ/$%:KM@DajbiYLl"Z("FGE
	7Lr@a@j)j%%GM`f#h"p$u9j?CJdHn.7SI+V0"$5b&prr5aEjV/lG,=pY-jduh!#V^KO_rJYN,Ecq$0
	T?>1Yp--_c#;.(L)fn6ACe">VP,uFB_YPgeI,?SqL-Et^6aVVIR+ai4n&nK<rnL?E2=Q=]0O?aW(JH
	V@5<hq3[#3@C6=.!L'nu-B/50:eJ(L+"T`^l5]?SS>+fI\U)*NrJ-#V^-mGhE+I;jGd(0B'"ALoJc[
	::Dj,L#0Hp-H<>m<2]9>\K0>50?@.EVif6a8ahBe\:hNe+V`!>pT6=h7C/Jk1GVkeDcG]mW6&J(+mp
	l)VUTNV-MnXK#=phh:W?ma`";s):*_cLA7@o7M\)>TqE!)C$OKP!Ldtf:q7`5A*54G"XPWn"W$r,f-
	l1[)Pj&hSLVI"6RNQBi2i4;-q>*,oGZ,4?4.,Kq43H-Q`kV\I9k&7VCNUL7FsPBC?G]>,h*9;QDW?j
	p^s'h2m3NJkJ;slFpOA"="^u\K4?fM^--i:P"9Dh*>=_6dO3A4\#WSJZpfZ.O8eo=DZB!/rlb$1_5A
	geP0BXKq892r4=h+Ai@53WM</qf,lXOT`;$o"bg_@?+J%Bh"IjV\4dCN9ggU*n+E`fCBB=2?f4(ZY`
	95a(p1rn=e:^5Q=gs9Or:8m]:L1d^^+^MRX%'i9A`G9B.&Z\%bF:N3+aO6*c.j:6Qb2bURK=S,^VN;
	J8qYG(#A?M'EOKIL^G:?ENS/tj!eR\#p]uX;A2.5[!I!eeE/.iZW',Y0]H&#aZmSX.g->K6^Ma)4^]
	#VJk,f0KUBaSNkf/:\5,=gSP=ApkN[Yb+$r`=%k@##Vo>FQ^dKkg32MtD2\k&bnAp;"0(+_@npm-Tg
	SUW=lLdb^hLB[pQL$:tP6u24u@5OIALs0hk*R/.1%]t=%;'C-AU+WGqQW*2jcKcG>qJ4lb)4[n-CQ,
	A9+Q7d&2j/-aqbqiGQ:hmakoqP6@E6+%UkY5.N!F36A[\]ROrbYao'a9#6eFN;HX8mcL>Ot(T7$Qpp
	?#RdCG0&_i$1/7O+-kL]5m!OS%P*kFCm4e%lujBis#n5,N>Q(rNY6rPY.X[1q`Lf-RTT:",q9Kd8#i
	bK8Z,#Lc<2L<#\;pOC:=+U*6.'Gunr""5hRqpK*8Yet=4p1B7<>mn7PpS=!-=B7K"jHB%,_PKm;Y>n
	U#&U)FTN`84987+<->h9./9mjWF-8;O=g819mqiB<P?<hc,rdN4M_\+A925;SWO^kcWQGGj92H)&(.
	fP:.&5&HcBGB(dd'LYikIs-n!T5VbdhY;3(?,#lA)]sHaZlQDBCkS:<rLG3"1OD8N,\L^YOgrh-IV+
	g$TtsT>'\RK53qmHrMNmr?dGb:Y'mjZ2-fPPRi7e'!ZOWSi8V6ZYcb=:.q@.b9jOU3A^*3LS_DK5rF
	P>)Ke4%nHp`8tTD2(9!EsBJ^SbZ1[<I_cC7S8Op>GKV+o9HX*iTYf\3'L.1AR7&TZ^slO3'<"OR@Lt
	jhRi18?[URVpqr`2c-<r1[WW%NnY1I0nYbcdhtb1`SaV$*IJ1d2U,Eg.[N-2+Z[@K;MS@3m+kN3P>%
	gDW<$c.0[J67`ZKEsh`c:Psmu+]j&R#ju9OY8k"%=(9:\?g1<H5+;FQNciUJ<rjJaadUnHJjGjO$3h
	oeR/Z0/el,pH_R2(KXU?jPPg>.]i!5\c99FnuFj!KFKkl$J`HbNPoGgo[&9D4AA3='pHKJiqi$8:g5
	Z4aVqYErOk=Drac,/@V05<m/8?d@q+Z>D@rJsrVVTInGWMJk`eN,!;efh1S,nOI.HoDHhua4(M;]?!
	m)F'Dhk59SLibDpNUpN[Q9plLHBhdA+6#[$Z%plF_4T06jrKS;uW=!p(5%qesf0KVV.3^?n;>U$7h`
	Fe(8?K9O(=S/Vs5f6J4JFU<!,u_g0k`FnVkfUI5.qO@4$bL_.=#X;jbkl:URS/+N)B=^\J[2>gCO,9
	+H&`MD9h"mP#6f`[M3"5o"JM3p6f_s&SIal7GjB(UETHV*A,jgd"IrTiqPFo-[grEgg4Sss#!NupQ%
	:S-p[F[G?1_u9;\5Q"rkG7nDYR&cU[0>IFj4am/.F*@[BZPCU;g>/q/=/bn8EH)JeA.c%c!C<)gEsT
	U$1u!13nO5MY#SJllJ34-ZQL'0X8j]D#ind=*P*FI*Z@J\nf"su)S3l+HCr@Y<`qNZ`$ZlP;4f$O%N
	D;P8rQ7G#WVNU=Y^WHPo(V-,DMFXDUlGoNe^/Y@i\X;CaqV+Mac?omC>;6LVhCLVi!QuV;9mbd#+GV
	"1+VeA=:Ci:V"p3M4oku0=58644$AS0^>"[ii:#HIQhR&XqtE;9\g&!TJAiM;937J6Z^3?"QhTqr06
	n%jm+9h>(-0NX(L!"BDGI[cmJXK+I*e2K3t$,)[S2G$G*C#ed2o$eC,fB]1JBbJcnIde65dEc="b46
	W]Z,mPi'uJ)#i+T'gC7@<Tn5\h;r#K8(k>^>4RJu,@6FuqOb=^DFhMKC632.=ri4pm#VYe=o;DXi+P
	sMLU+1R.j,8\ol4ANO]+&WHj'nl7G-lLN-VoN+:U3dji`Y+Ya8FB=D%@fTH]Ed_lpi2f%/I-Zfb,gm
	mn4+7GMWqFPab0I&cS."\2'pa[S\6k\T$n1rF*S?ipG9Ihl4tAIgWljbp8%2JYqnCs%-ehnd5N->p#
	Xll*R.ZVbUpdb\R"=gQ8`$X##ZeAF="\=<"<!j/9e<Gn\"PZt;HM$Oip-Q@&f%<cL<-[<<col&>?qe
	[BOcin$:`>"`2A$asHEltepq(V70#_^_2cA*1efuHU!D\&RN7m-,@(_VnXjqeiom+bhJE3ZJLpE.@W
	CI7IE\]N`Q0gGE;ons(qre12W%k[YEP9$/Fq1E(HTdaU8KKNf]'-q6-L]O2g1JWs\A]W<ogKs7<9*0
	j5eJ47d[C3M!O-%TGmh*#"A$k9p/PuSj]&u;SXPiVhckH0rZ?#s2c$@(fr>P;D-X2s3\qALBp5LUb5
	MEk,N[$Vh2f:BO+&L@8)cFY<au;.E3p/aDh(GU;?o$2&JXWf533!aZO!mLj'$UMTLR:R=V_N[gL]J!
	+JqV?=6`E40fZ++X?k]HkjG!<ekp%2?-BH%Gc`IajSs&1%+gLsU^X^Vlrb90dIGg5$1h2D*i>@%W'7
	j)SM@VJ15W_Xhd#o'6AHr[s3WS=E?+tGu*EZmL/V1)C$]F/AUh)a6S6aB33@\+pl8$'Ad*MAK\!QsJ
	pKgsk?u9J\#*]Qd,GI3XRt6a_<<F!U^?RAiRLD\rj+'(mQTDT^%5/h7e699Q4mmi(U(crR7dVlH(IC
	(?&dE;Bgd!/Wa#jlu["nh?6*cO^a6gjh([^>HAin]KMT<A'ZV`5'U\<d=,BA;j*:>@]Z]k-TY_Zl.W
	Jg9?dJP3?fEHsl7`)@:VnaKTpl_>)T+l@r(a;):3:GPT<j7V;4<l*R^)9+Q34[ON0qSPh(9okYOEEf
	^06.Pp_*o<Sah0>o$7fk/<HqQ<%**$hIdcV$5_#\TYiZ;_E(E<sA"P"J#Z0:C[$\PC:"20oj;Fh-eE
	5n+@oeO0N.//4""S0Bp^r[e%lr6b]?oUHWE^%QT-7A:rJ2D]k8KOTrlj.k)pD;NCIg``o<EqIg=k1r
	cZ$6%+$Bhh,M/SF3sfG[ntL7QD4OZaMH"4\.q\7#9O(P<%o&N_bDaLN:G"\cD4.o)&>!JgrB,-@*@b
	h[bm$n;JQSpq]Q`'f-]Zn:9Z<*Q3[_em5>7H;P40>ICX:7+cA<1[GY[k'!O\1<Hs.1!;#s_922/$cU
	fq=YQ02/gq;Abs@=$MFU70Cd(r_o/b)/Z#(W>0%<6gI)pj)Z869;8t_G)#CqSq[;mh=LK0rhq5cR&Y
	FK%qP]J\?W;:QEY@d?`hA2KNRBN/ilso#R^&%p10P!t.D2f%0OI[;/-#&hD5!&sK':iC0njNnKl`!=
	mMCeCTbjd&OW79b<s(RUPfbprr^8j0l>'S>8kdVRb-../C_8$J72=?^sDDq923i9(JCJ:X"ZK9.j.M
	T8WN^+AhK&YY$SsFKhafCMp+0#0dll2_i45\->M2KLPf<]iJu>.Xf.PKK`K_Jr\n(E?M9>QrkO?r<1
	e$VF2.sePn-*-0*te(8]0OB!0#''TM+ZpB)>'>GsEa_;bA`i;rXY*6B/IBcls<1C?A\PYChN3DW>1X
	H<Te,2K"\\$ETbl]6&24-1'j#pm^1VZl\%/:PZ$\Rsu[$sAd+?0'S-'hmfmq8Nf*3Ij@QqM=?.s7.X
	R72(WQr(jhTkF7rLE@JMg\/cW]&>d(=aK#D#\$du56r1.i3-$O:]RMo6U^Tk2j`*8qDjp5C<Aq7@]u
	,g*mk-BD`3XUoWLKZd$8S03XK[N<'foH5#Hq]f.K80M**i]sH[N^ec-W`W:\"Qi*JXkICrBc[M:saq
	/X]Bo_Z+lZK1#WUeAX;qP&j<`->,U7FN!Vh5C(WDhg_"!BbKLVXAt$];"5[=N7ZVU+!..>8Gj?&NR]
	qXU\D&ghD%DSGL.hI$['Uh*jI/_0$VlOa$5-JQkUSBJW)<V'P=t-A;%0!/FXW@";i)I0C_bp.@hOMR
	3s?f!e*_iNI>AHc+&$o_cqWA6/39%=BCgU;;531DBndHB*8lR"C)mS1(r:KheGMV([W1M-si.o1W,.
	seIEB'TeLsr;L>Qm$\jN0<2/C<$Yu@AjhugBX`JL8"?,97A<I*YCj3W:+p(D@JmP5PfQasG-4JY*ou
	/gUP2$=W1+,?Gq?O'9.HY"biZpgY2?=+3L>l2`nLaZn&D1s/Z?QO?/NQ7oMup+D#*0K%jA&EG#A2*,
	1MAaO&!Q)Ej2]rmC,Tm?H]l#GdK5n`C4O++cB7:[@lf>5?\PU&Wldf@6%,?e#$#^,g*NW=g@Sa`o$W
	=R`2Z>NUc:.oF.rE?3)6GLffT5:Au)d@BQfDJB_*dV-S2S(`/P-'$"6AWab#=NOt!#U_!^Z_,olmK_
	+QacQkM77d89_1R"C#HU*-/h:H.or`Rt9tf\>-jqni]a]Yk%\>/#[@*Q9#>]p`E8Fq\kpFn1E75+K6
	R'66Aq9N+SMC2^/#L`;9A%B4ada&<!JT7Ub\\?oqfmhb/"g>XF;(r8M]\008:Nf%;0($_MJf;*prIJ
	'Yr_$Zk0F-/j\CdY,bV7rlUesAa]9(BS^#E>B;AC4+*b-?Ds2OI$pTY3lS0V+"OoGRi5M:Y>U$n'(V
	-Pk>?AWI+2Hg?4GkW*V#4q8IS#=-RI3lK.#Z@KRuVg;#p/1KP6%<WnU5];k"l?(hjY30EA&\8l4cco
	ln0PM26S[AW0%XC^H3N*$rQDW2JWt@\^#FHtuH@i(lk_-@)WOA,kLi;g_1H&\`a*r;^\]q0ppnp^S!
	<&CLd"QF_J#OR`ohDC%;RA6L;et)S&VHI@6s-9He$:R\#h;O*S'*0@/nI2I+qg`SfAd5pbTL2Ho,sY
	rOHP`(AWOrP4gX)6-dUPuc@/t"8bIY+4P=DoJJbi)&)"2+^`+Uf-;^U.A"o9`\&Us!L=\uDEAi?d_m
	W;M$ml>?>ZnV+0\L5TYOu`>a#melf&h,g4GCXsjj7f$kUfT1Z+2dc#^r2rEF9?.Aet'9GY+e\e*RM)
	8_VPS?gLW?\ISDEC]KtDLhibHF?[1X%K@7i4FVRXndf?_YA]0'*M]jE0EW+J@B4.>,T1?N?BTnJAYW
	F;Ui^L'U!:BOnD]"Eq3;Q:*5o#um,]'01u9AjQ-QA6+ENGkCt]lf.9SMli@u:FK0LUQRmMgiM,qb2j
	$5>O5rVqc:!\>Ye$b$nL2X;@=W94.)plH_g%Z-eBH4Aem:V!B:D*qH>5DX&7h*[n1^d`VOGOqP]LnS
	$18Rk,#M;k0$of!/G:U5F1n(\[Z.TVj?&l,r<(;BA[gIHH(>jM6.Xf!5HG)XhJNWEAReKeFo_o01C*
	uh\2ZV\#l4di`BB0Clp?L@X^pJO,;5I@K\hI;Yn\bT>4lZboYgGKq!C.=5j])qcW>Sfh-e+ct=Y(aJ
	SFmH6kU,6Q'C*_=1-h5H"GDe+A>C)*j``cMI;gY(['+h[XB`mp9QKMpZ>m^rA\^VKGoq+VdmPjPcp0
	<T>kg7c02OlX&Uu_b2`DUnmk]#Gg7kGjCZ!f;NC#a%Npn8+c9$5fFU1;?C*BpeWcW[fTgrJgN#q,#@
	=51gJr>W8^;d&469PKA]5-%Y'4>PT_E"#<oJ"tZ+^)*/FdFe#M1:GKb`hru:r"eO3s;Ppf69"d(?aE
	Y.-gmu4!M6SUB-SR'I+tM[P<^/-:fK1oLKlk8X%*_#e34oQ%NV$0*N.KTs1Ss^a=,!E!H*8:#^T_q9
	gQILWt1V8YRTn+[4JF4>iF.;9Vk:m(n`V`lp)0?86_Aro)^OQ$Pg*1uoth!!.<ShK=4Mc$erfFaV0P
	X>HS"KY>)3Khb\lE<2d@n!IC-QRNr5f=C=G"!htghRiOqr8UMkqqAe1F_6L.l,FQsW67Xb_UY!goo2
	5\]MJ=l*=9XQNR"HagO`U;Zoo2f-`TJeX<,N92V(+0+7'$\)$Lb4Bgh"+_O4s[r,slS6.i/$k.p%50
	RMgM@[=*ITMBKFU;?`^Rm0-Ua'8V)D"*O?OLREH\RY4GJ:.KL".Z`sY7!5,]hM>PSqW4Ufm02DFqtp
	-@=EmUf`?ib`KUK)ms[g77^C,6Posj1WmW?q(/?SKlp9'e<&4#9"L1K8($,*r=NN&GA\f[D8L4"@?6
	m(5Qr=QO]WmQ#nY(QN[jg_R#"T!E;IE=7qipTq''@-N/;_b4AjaR_nNT_L]ih]%rI#I?!#Q\I%GNKb
	b@a@ekDoJHl3MuaQ+<?o]+IJ:_ni+=,.Eml?YRPCa5+?<Or4XYH[k->Mrh)P'La_0d``^CM&jrp?u@
	]WO=amiVcd,ueSs8`mM[!ljiSn7'anmQdUIRun3L7Zm'I1:.!e34']?;J!kCq,;j.'&'"B437BkuKW
	9&LjNGsH4K^kC^U0U4UQoA$-73''#_@9U4h6kFpWH0P"4-UQu(80/1&RT$g:<4%@a@*-JT55F(n'D/
	5:0ac!,F%,7_pP#L5#WUYPUu7h&asM&0^IM+__,+l4c.f*<;j5S\[T!uK,RLTij9j8Yd'A<Jte\=n\
	?r27$1.G:m<dfE4$2c'e@`Y?!:HLb;f63f5<k61]j.s61R,A.`lN?g6UEN=ePVF"UK'oS+MA=8_MY=
	'j[)d0VjH^)J-eipUW,$eKYVRI9fGNPmCGf'9UU9UbJ$ZEH]b<Pa[Fj,rl:*\>"UYr5%[0c?,;ngcc
	_.G)A[2dFrf^3B-=B#\"_XGB0_^fCW+ML0CsFPT#k1Gr6Ki)Qh6Q$;D25FV1#e'+rj-a2u-YDnl6Gr
	6r[*G5R3#pRrZnI25_3$`Z4NH9"d76U)b]XDcHRSsgq/!]o1L,l;BG][u:"BrRdr_N!'BOF$J\j6>(
	K?T`ZBNb+G4a[R+$S9!LumnMlUMc1dW,]iXL*2-SIfCKEHZ]CVk"'j^k&rhpdYam4mCXcm/0cO/5DI
	AM>JHYt6Jj9gol7L/bQosREaQb*ScUj9E9q@,5q&$MU@]Gs'M:2s^aVen&j*3ks1J#FW?CY,iJB;6D
	YM[j_*O2<(@AfgeTCFb];"ELgj3?'k`43bUKk;Ah\t>/L$GSMd;M.GP7;CsN6q&@T@mD<],nLukI#W
	IG4ML1sWSX:P8hDiCOObYO6o1bZo)A810*tpDTQUWS79:jIQ$;T0U;`?G0:Jlt;K>m#Y32N4O%(U1(
	$<3#Bf\>nk$%uY_E.,OUD1ZslcJP9QZZlhEt3s^RN[n@%qq0=mE"!=%4m^@'^<G]Uq4n17&Q.I'0cd
	(DM$0d6I+9K4q`oe#-5`(aH$[59KpAO9s98qX^8Q:_W'%//*G;LZ$Z)1eWoein.AFK`A5K$&&i0.66
	T/a&5D!</Z8gZ5N"=.?kAnNn*sT>Dh<QAK(JQTQYhF3/O+")>Xp2<Ipjoqo=;.!,5$f9Qdu^u7g5"o
	i`gaa4#UAr?Q#1,"nbgQeWQ0)0bdNIe\j.EZp&46cY.>Jl9T#6124j*Ln_1;<O=!0J66u<)I".t+@2
	J"fpl8+?t5;&@l@b]fKDB>=F20JZu[C97P3@W]XGQt$(u=KSnGE68_6bra*":Ai%\e<mXKrmOut*\6
	:fH!`0G,ikbGc0_i_(]V_jZ/R#M8CN-lq(Nd]06]k^ktN%Z"m!)jShNi3L1dWoq.?m&6gQKo-#d+^7
	omZ3J!VsVH]*Fs\j#M_o`EKQPgVV@13h2a:7lg<uf9.BI-PP`uM-."Z>d8HbMeG0=/Jth/@r0S+aI4
	O0?)gnA4B1od/n<6R?@477+S;X=Z_%X++1fqZ6WAs]I<aF.&SWEaOp;<nj(9+)>?q>%g_>:qgEOZK]
	8W<l**+J!HGCUZ1q_TmDX^F3>(0Eu.D&Le*WJX[</3;DF^\.7mmFs>mc6ue3i?(C+2sI\WUCQI-jsa
	RK-oqq!01@(86?A<(UechjK?gat$fiFbW=OR<+$P)/eh>i)q-6E<(P8TcR5]'@Bt%te:U[D$S#01ZX
	]-Nt;L?$1ruKG;IsW9B55@EM;\<B/_&#&Qhtdc#TYrKdT^c"c=VQ86JUIjtN8Z(('bS^Z^A1*:VB=b
	s83_>4Wbh$_Pti(;hjF>pASQJTn'WNtIB/O3ad*lS/brDRU$Be#UV9$I1ueDpNEbf9++BtJVsn1HJ@
	q[V+S2rg"KjE4luVA09J!lK!1u,i!s9RH5&hLI1l&%D/iU,-7[r#5N7t*Y\#ARt$)qa)W9JsXjP'92
	m06k()j&EC9s.p36pZaD@uaq>:>'beLg<LK6nMrI'pUSrJ#Xj<'!Q[_kr.(.3RC(W1gI+<ltc&d;Sq
	djO$'41N(h.q9.cq8Tgi(!iZZ_s.-<l5$_qD0,+L^Q1!\GfYs^/m0o")Flg"h1'==HA@[#:V_3kH_V
	IsnP?G2Ae=O$$0+br_2\Xtl?6GMPnR@clD,WVdr<]9f)">^SB0hm$iGdfZm"<l8G(7)-Jn`)OB]FNX
	g.iETc!N*oqA8rJP'&W;4)T`Ps]Ke!8eN>@H=0C138D"_c@1?D`&L)^]F!.sO2+;G9TlmJBk"0CQPU
	'r2cWFC-P[pQL,Xl"510"H1Nk[5#9o4/Dnu:bBq<fk+C4NR(rUNb%<.0HIaFqeI3L.!ho,i-1)t(,D
	E5CuYq?_T'/BaF[CmO(?&$gpm;C`hRH,=WiOjaBU`m5K58LcXM&0>?A$7Vp4eh;_$73>YL$:76!16a
	]FS#,TNlE)ugW#_&mC_HP0X5VsFf^u<5(BbV&JP5DqHlOLt8(&d(kEn<BJl,e*!]eF<\c4j_Int$S5
	>sDghh=g8)d,2e!N"@`K^$2\dkEJ1kos:\>Fh'cD)UZoX0)g^*"[-.d(lN<n`CP\LItlHf[L*H>#)/
	R9";`tYkXB9_H2-hJVPcSc$Nq]OOb.'i:>E68[`Nl][\W?#4]Vi.i?`'91*`f"/;M',\dRM?YU00cO
	Z0-g>hH&%0J^MY0pc<7X.C3Z&<^O8u-UL#*:"O]+h_8ipT2W,AJ1pRfjar:LE+JmbGD!H:W@J]g52[
	ma\&RS-O*joJ`g!dhp>";alnp)+$I408'faEM,"lCd^jpHqfg6U'Lr`o\qT$[DVuHUthu94b)u'#Bq
	9Q>Zak&,kS9R#[o<HFuaoW#4p=jE,qfAe;pDE>FJ%I*_Nh)2gS\;'5l[>NK_!WT!OC*d`Vl_B.;A)e
	q1V4p\gH>'1Y;9)_]A^=HqhD;`NGZ+s?>WnFGWW+[Lor"T*eZU-YNQRPpaMj/#m>+nEJW^H2i%?S9q
	LDr)\1+HM>X_,&e*_;EK'8%(8/W-L"p6#CQC&iSfWb(*G*)LcK8]jbtL45p@S[E_7GE8K4Rn[^Ud5t
	`I8gQq!:g&TB_qkGK#,L_&2jDh2,#G@2BBGZC,RSXQ:EC.@\W[C%co2Z%\.W,^p,+DbC1(I<)$AV4$
	p=>^dN7ZeVlh&EK8bDgk`;7XgQ<=n<cLRd8pS4W^fQe*$C'DT-W!"d6)8':#X&YE`:o*XFe9/dEku-
	QDH-agqK@#@"pRY8CI)9EHq':o?0K;P+4@H/[W[O)U]^'@"]4W99Fj4E.bLF++"\=k,lJ_2<a=ji;5
	.`Rh2F<0J@[Z4;415L9T+)*fl'62V`N&T(=P"(WahOK5_-%OGrZMbM"B4&l4i-lP&n#LAD$][pedVn
	I,7RrAWUM]AX>Ya7LkEE]j$rq8_[kcUc(nWQ1YTHbmies[r#jFU``DQu\I&C(1ZkEE(KQc%F#^bF4d
	T=2FJ:5E\Z3jM]"fCT^e7Acr+LrQ@]INKT0FL&T`&>4mq'+ZlRMXNM0iCJ1E)tOkQM)BU<m^Ef"XmQ
	i:X837EH>i$@/:8G7'*Y*aoL7SI&Y_E\o'X4LAUnklpEpEEhHV3YaE)<XPHCKpu9cTU4dJ,[dML/@;
	@QL&XQXKW]<"dUFn%jpj`BOU_Hq)[Jg_J[Z!)@CRc=G_s6aDnPTEcLNm^f1^eh&;`sa3'q,WBe1o/-
	9tIcSnnrPT!heA^qc'I9?I*oB#(8.fI>]V9_F:m0'`($0G\(DF_V<rpUUj+FoCSd%XK@BE[dQBnD8Q
	Q2Z7tf.;[iF^Cp[R=Jk6X>\<O1=h#('=_4J1<OhfW`>H^G<W:pW4)f-]^1'R4>0.d?4IjG`.?Op^;.
	Z<Zl'XNYG*#9=A8B=:eegHFYF->%T541pZ"Zh-dU$$Ubbd(52o-V6;nt04+VJsV53b)aHkS<C!rG=i
	%oe,PhnJ\or0#?"EACYC8#4.b(>4@VGES3;iAC?2V;"Qu9lR?5XZMD/B0n)h=(,eV@$.km65;lUjX(
	l;#do*O%(ZlL2%L`T2=osiX5k$l,';cOF71n!M\6W@%+TEpkK_CHo=r[N78jp0.26AkdX,5S:=)^/j
	mVDH<bOO$??5,QH8_Jl:5LiK!Ae:-Zeq'*a$RmqVm`/UGn5dW'Af$`R1c3#M!pE$?EhN\M_SN:IMTu
	"h0nbJG;GE'8E>_+=5KqNYseD/I/5U=jepb[[K:h.p*=i`]Lg?0coNs\D1A'fT_AQ%:!TMY=/cM1*;
	V)?[g5$aLlWNgL6-\$%=]&F"Qg,Y`Ybg"!>*Q83u<HHQ2h?VU"0Lul`ek#Q45N!<>fQ>88M0o1Fd1i
	V9?M@T/Ae5i62Da,>@^XZq+PS-9r2/(BdgG,.9tqC0>YJ0[X#ui^cR!8AiqdK(n$=T0/VeYo@2u:s?
	E467kHJs+45&#fGG_jYc8kf9e+.-^/2O#o@`YC4jmT*W^i)-(V9F]8O).[[$nm5nN!4?TWnn+Ve+6i
	D_M$.][=HX?*Y>BpLUHErc_L-L"9rTcuE!L88n2-`=TKCh]3rmMPBB#0Els3lC<a2>kF9MGOl/fG&Z
	s;W<\%(M[6i%`'hUPsq)`U`=R>@9&@ZZ61->i$\_\CY*G.A$VJoPa_p0^.%FoSL/[ne9X]B=G+$Tj'
	;I*7q/a%@^`i%p$shOi"'F1]Yq;$>VMS/N$.K"bm<RZmFt1c@W'>l&R&WQg5O[C4WAoW[W5tl]SqME
	mpBFcE7P2H+>I/M:hYq*HKTECAnRS/8sqSaN)0ODiH&C^"6,=1$SkpUC<9S5C=A-;ig+2E2$aoQ>6R
	#0aYq[nf@A_Ralu+tVSUJED1+kWYchQO@WT%#YXjFtfW9XQ6,IKu@$6S2]20=,+`rMZ6mn$;5G;E\*
	$tmK,*H?F*q,^*(X5n9^uEoZLW9tYLb-e'0i,g7Ps8ea"Rf4<hg>C:p@^T:,Z3!P)_*l`k8?t/,M:j
	+?G()iQS,W>.tqm3hBi*@AWj^d*@Uhp<G<@k,Xj_)`Qldc:NF;#8_!Qn0\*;/n2^*'VPWfV;"0UfHa
	FsfRLql*D:-q(f<2K]f@Nr]]ls?X[19NG$C$B^oi\M6?/LF9YpRYc%&%YkKB]g2F$sr[T;lZOk`@R$
	Oi0)IZ_PqmFbDRC4%NdO=7-o<a+migfqLo9B(jM.+Y$6OhC$lP]4e'Y>]/V$(\cn;#k'*P;.mJoGAV
	/-nWL6RE$XR,iSi=&QWWGdoDIlf-Ct_J%^r\ErT<2WXGL_k].nffFZ'1Ch)TY#P,s?<_IjasRClOO.
	8.;5hf]K/;4H\d;XtXnL#44VIe_T/,cDZ!DQ2SJ%#mjJn538d5qK1T'&da#A(-:Iaq7ir=2dQ/>e?H
	;dg;G]WNNj*,eu=G,e7s(]IV6L(GHOAc#k#8YQm96L12*>m!X86l6JO@_S7md,S@90>Zc+^]K>:g'6
	0BUBT)\W:d_4^)6>'7llRW;C>`X^B#HQ$T!H#?!.8cD4=5K6r6nSWpd&U*L)/TM>WujpoMJ.3[ck'-
	5R^GcmFNE;gg[SCnkBm19jbmG8DQcrc%(?pDp"l@-0H4g2<($A?(t@oKXQq?G,!6G%o1A[qOECVR&1
	mUPM%er"_!n,q4I+=,0_#/@&lR^DmgXQ<?'TC6decmfk1agKJdCN_M%_.5M.<0SN?Ln%kN1\64BkBB
	e7U`+5ikT%cR3$:mL%M73QL>n_k$L>mAO&I?'"A5I1OG#i^fA$E\=2D=Q/839gN+-pg)&S&Zhq"@u(
	qE`I1e>lMNX0$%=0ge#6T?6GcPH$qpiTABf.hMd<oFBk\&FJd1ofheQnS#!b=J!X>)-&m>*H%k6ifH
	tcq/:1a=puE7YrEFL"4%q`GpY\>aNZ$ElGd!PmYA%@Pr[E9WC"4sP\($=jni=CuFLIDA]X(P1FA6DP
	HpFqE_2D6XJ/>t3AD91c2F<7-J:XCMP^'6W[L2,(6:]rnlYi)Y;Hs!s!_#$KS.gQc=3%SZ.U,1_/u5
	2?eZqFLg2?f=dSo(:n0%LYAO&<B$?<A&+?GBhYcWd89E[kQT.MhpmsjeQm@C`DJ/#X91LUn6a6WL]@
	tsabDoKZ"S7JOiq4k-G(hoCoNU:aTpqD(N3/bIlj`6hr?OO/$_KT8jCtuoM$M:lR@EWl@)<qg',B=o
	m-H_jKL3;;/GC_VUNmRQ4!akEV>d"^p.a;j`/!mH9nP?c'\@RiWXZ#-H0peT6ln-jPW;2MY?6irn2/
	Dh;m%XS:)j4,Bcq8:Up9"G99hXq[3(h%sKS"$Q@B'p$b\s6oh\QWZ2_JPh'Q-p4^Rm=!o^RQhmGji<
	KV(V4^hKs6!A@ZH!;R)l0@&Hdbm)XO\s`p'<l.I3'[C0nSH+4^]]fG,p],/[:2[FiH![>.H^0Rm6:6
	geXI$</3bW*\EHX(KCb47ca;.ZsHrei-o260j%5"%>RP?)sdarJbl=F.pAYNZMHW"lBir/Vd:9"dUP
	+?`XZh%H.WFM+Ym7nTXR&m3S`ddSNO9M-:'/7,aju9@nE35k"cmH;;2aT<r`#<Wpb"Ks+?"9Blg;/l
	PBG&i1!))*#j%fDm6i#C9!jU'\*DqDO?ubmriR`W=<Y:L-qrT-.P9om:P'O3_)6FZp:J.5.a:+5rW[
	$9DTRp7j@>:qHPLrFt9`?UCQGr@qaN"Sk^[]]AD1uMa$<l"/5(K0C3NWYC%'0Q-?:!-9mGbU`iG5ua
	F0ln)</ND!niNdWB?`RKJi.ZhET`=*;WO1LO<M.h/N%d]jt)o6(`/)t($+],9H,O!M!ISocD274Cch
	J[oJISkd-Ti3ptc%.p>)!.FfKuJrYC!0b(".2jr]>r8t.hmrlHi.M%rAIcS8;<)<%69e7sN5KJK%5!
	[OB+#4]j0&k^Nk3Qe9i;\WRh=hTa7CZ_!p@h,_s;glN;CuQsm`Xtf1V(5WBF[eSqJ[@;Z>q\%NNGqL
	'k/^_a_,Ni*cp/Q6o@!,9$iB3J7aac[(t=?fZJ*"4%mi";_W$>q#=^IX4inSk%,PM=V%5RGK\JknE0
	hWR6fMMNe8/Bh\jb:`$#1aeJo=YU53ca*CkHY?VO!NK;o#m6`i<*XMC1=Joqi0)%#pejG"=f;L]cE5
	E4\_lJe?G$]c7@a<P#-!6#Th@8Ym!IZmW^@B/IDrII*4!8kq@_Hu0uG%e?'BQ(C0&mTWL`QFb2-SZR
	hFZ+aB23#jMb)glNA2hN10aKZ]lfLVWlA'P>E&&GP^fZWk$,E'k^,dcIISj)UJ$S4PW[!';q(,Xn,+
	ia,9/fpBn^meIL`"c+4B'IOQ9JImF2d4Z+]B^9CN`QSc@FSr0>mRAIBA!%>q9(\dJOrY&AVCpqa^gH
	7!#<UV/s4n"54]<lPC7(AB(s[R-H`,YY&.?S4%r0-43;nPb?',XF/mDj'4DBfJe6IDcklFu-le7TN.
	f.:DK:78pRi'K38f_\g%lY/Wte/a'N&=S+0Ls-\#-_#)[tp.GsD$WFaV&NT;tHkoO"Sca91i5GMj`V
	<DWurh!]bJ2rhE:;s*IS2C[>8^HcCdW8#nK1XpW<<i4%`#S3GC9VN>XRh?MN?u\X_7J3uiD2UdA_7o
	d2*_7fT1T"kpKm[;@s$3N(Ju0QN;=;5d<RV_^8#3NFoe-"!L9s:([]I\%"I_Yi0'O%\@Z)0:OoSkfj
	L'RX$E+s&]1-$m*6Te"5t6J>BU[$PM!QZZm@lHUJIspP]m]ZL/s=O;1$f.'q)M'ZQD98eE.$1qR5"E
	7T#G$B`J_oDdq[58CX$0^a3jW-"=L+tF^T-W-nLg*a\fB$P$mB1it33XAJ%(EJfpYEMWP3o]b]!\20
	SLapQ]2R7EN89pQ'duUJU0@JM3O$\Om!;5MZq'4>p849MSl^CM9?$XZ%J55'Xi8RT)YD!/g\'Cm*qG
	p]*1SZJB'iWb"k&+h3uiiJ_b'N]9T[c0Zjc$4tOpPYNTt8`A\-7[@bkj>jR_M=Po+_WRX0DPRqi7Z!
	$s>9!'gAk3?VNJR(Gq2NV:$$lmkasoj:T<q7_\FVr1f3n+W#rPR#M*NjR%1H]OH%rWd'Zd+6"K(ck[
	T)SNmMRS;rg_#iaGIK%dDoAF)i\]'\k[M>0>=sNcG+Z2r;Meh_`Q*,]>8,6JJjhB-^^]kPr%J7c7gN
	O%n"E'/^l9EUHF_N&eqkO9!hc>_57PuCdb!6s/\Bg_q7-K2@L3R5a^l_!dc2e@DS:=O":@K4)RU2f)
	j)#kr$8\FU"L8SlAM!G>mihWkcLpa2nC;oJM`Yp\&/uiL2%4qM5asV4'WZn20cXR24N+&@H!(%3nU>
	$t[[;V5`Lj=`d6J]+g3g<`Lald+!fpN,8ufs(^TkYe<]C@@rO)o]T_0e8,<CUd89A^s7t%0Q7)'r9'
	J]-A,bK7m<!u3l$-W,`4=V1])B0aqEcC(J:"$g>PBM1s9?Al\nQnq?">oaN2C5GoB@KbrKF#p<bRdW
	uhMFjSOE)R8AbL_Z`lqN61BD<:^jA*=G$F-rb\b!A4jA&U:\#2XGIPKa<A2TsF,(O).GdDqAcfjKE2
	')CC3U83@lfPlH\aU/oQ<9d>CgYL8/!#J^I&X@hZR/QLnj[Rj3N*X\a'J'Q=PUI.$9ra-\/Lfo)7*o
	$M_q27fD+q&8k@7S_?LJO#rkJ/]C,^n)_Vpb_:puuk^mbp^ih"s>K$I:aB,Vgn:'_Pn)d4nI]NKRO[
	m8b#Ko\H!7+JnI<[98UP7Jp.-PgERr';3]b*h]KJnVuZOY!G9oh9?V";D;YuNlg^![e\D0p"ZQfb*?
	AgM,`Y>e/DnX,rFp4UeIe0'A^2(_sAQSDXkY!QA+.kgII#Z#';ZWT*;+A,Y74VV24.5#"(smiW`k8d
	KNh)\[>F6;'+4i)\;@"Cj28\^Q(3W\TFZbcik=>_rOB^hBaR0i,bc0I,"sCe=7OpB8*G_]4KA7kV4D
	h1F/\NQpr;>T`uU@`Xo\RY<qK&G./eBHdhj"%%.M5pV^BXrF"PLRko&o,<g/P/Bkk5c-,U[DGZX-Z3
	@*DV\`V"+t=#R(EA;0a1Oa)9UrGO:iQNYF;HIIcO]+m2aFFGUGpYfcFokRa_oXA*P1;5(WhrmN`M]T
	J5!Zf^`TXu&R#",1T,k$)-U:]%^2),^2`=ZHN=f>hH0I+a$9SA*2SA_dC4Q4e&1r=5$)@S+cuT#,H?
	lB)aqVljJWj.moVV[HD$PZ/LMGVYo,C!cnp"X!PtR275/)OK"T)#Y1Y.8JM;u/8e$5HHOVOMSW)hj4
	Ylh2Ol<Xt-llO`0P!u:+Rd^e8JkI5CIECB66irJqa,fA/2X%IOD9Ir98fLC/k9:!5u"[R1kUm?J[8X
	k9R*JjN6,.nLcMDWT0X\t0Hj4@$LLd:&fnC#HNFr+:_M6"bfUf]l!QlLBdR;(l3ukF3t#FjN_`b`]%
	tq=(;^4%mQZ-t-$=sOGgAccAY!HX$-a/CDZstS\K+;Hlad<C+3lpd-ooJmj"7E^M9T4VS,,5\P_J3o
	F)6iHK)%b7E'iKks$h?[n8O?1?*%g`c2:/;$qX%5XDNo,o[s6qaq.=NP&@b2IT.#i*54UE+#=o&J=.
	DK=VKp']]XfXOCi%IG&32UqOHSM:>%Je8i_F@0-I'J)!'G=d>_:*<CPF:k_*AF8EEL7WB?n"HKI-%;
	7:bVF_dE+MH4,I&A.4[nmRBJfJ$:p&<2!.CTPL?S(Fj,HN;XeZ^9)XD=9XT+qj4e!8H[+8;<9m(C0M
	FOc<ioBboc[J*99*AH&$cklHDKOkf1%1BAjE-#=7qgtCLWL$^:$&!`]/K.MWZg$1\4id8$f`>t!S0I
	at_.ENG0&NIg-\0A@,XI:GDqUC<XgLTf9I$6j/5>f`s.+:\Wp&n4o(7Sr[]n;*.WuuKk?k@mnnk;fi
	2C(;c29)?(COQpGH?_e]m5^?-WN+*=6,0_C$fn?V-&`-0e&5gtj=Ur=&q.nu;BoMEaDr:(FZ<hMc]4
	)VFVi.;3mr->T5>2C,d53D3:fr.[(KKi5>7V6;GH#L)Hqe,OL*!RVNi<pVBJ6\?)-ZG6_MjeT;3^o4
	F\.\W[XO*G--%ZPWDpi2In"$9;a>>g%(*!dBFDlS`W_>2aZ\>UCg8?9RboSgTYC"OW:B9.p9cSD>gq
	K.&Yn2AmL+nQX]-WQ3/kuXb31]>@he;;W%^`=&7fG92*@Lg"Aq;S=U7kl+cnq(0Aq&N-&ricJG;jil
	IZtr;:J,q:b`7^Q3Y]U)@o,6EAGS%2uJW&I5[an=g:pRh/)f=i=jBdH_c?!%sG[>=M'/7hqi"S;A*+
	D`r;.TUi5\d$.jEHt#5@.Bc*4$5'4KSa,+]*1=TFj:\2k*R4=X?[P?e@Z_Z:Ar]g9Y32cn:OcW%^</
	f4ljQK$Z4g8W^>G_S9uYP`:)[VL+$+ho@Omgu]6E^UVM4:^5p4F48;5`lYEP)#R&B]I8!0)>j+C<H2
	V\iCm.4#'1u;p'qTa<&N,XTIXD@4/PqX"PXm=BV9HU\Y/VV2Z<WWr*^GD?o-=?&h!,cgaS_'=01UMq
	.SQ.+=o/NAA`loFK[>JRa"=ks'=a-"1"2@8,_`5-U3?`-7@/@(,Y#Pti`n2G7A#7H:Ms6hE]t>?!lI
	_ct!#(#1XjLg^k";bao\e?:P+K49;JnYJ@_WbDkirq?e,B1<6FG;t7j8r3`l%#E&uo[KZ^F5h.&(Ro
	X5&AOe3rUUs71)IZ=gOOIFPDcC&I>(cab4c.6"[=3FDs#NiMH`HQQ;Cb]F"5h>""Q<GgGC$T=I$+cZ
	.a.d;E4CnTDnn^M/"Tc%Em9j]7i=<KVg9qFY-hC$'ZOUOHANg=/#FfZ1RObn0*#B\[]4:-'LgoBtJQ
	?hdYN5E,_G?^QqB'"sXT#md)geQhbh;PjbU*[]Z6i9R?;GArAmo+E:"9<S4.U]G`BngB)EqOLfrL&l
	<F[!k)72881PH"J16qm`("3CUlR.3>>rf`uP'GC`5*e*DZk<XK8pIS'[5dM^O#kY$fT#?Na"FI>_R)
	BuDr`,I;#,3#UaHT=^X5FfY1Cb>.1J.Mb@%]tYLt%lWoSi,Z_.Mun8G]6QoW/%T_oNt]GFG'$ojKZA
	qk=ZcNRI@t)``nm@"V6k_bq?!Z;Y(N(2fLq"JoPN]``)(.AQ&=i&J!Pnt1Kg+>9fCken\@SbhT@P`-
	kZ)$SVfJp4R2p6uRI(7mM6ADdlK>A9ioF[dmo#tI6c\idh\I@IOBD-i0k-;NH>YbIUUUglX+\au>!H
	mg<2$0&bgVGeeK*;VDhmcJ/LMhHeCZ(mUMl`p2k[=rc:=ZL&p2^p1Mm[$Xk6]1_<N!oM]d^mG1$IHm
	bZ<o[^0MQB-0j<X&jRr(I2-hINZYW>[XmOl'bb7sJBNYjjVO<SVllh@AOYMCZTDpH=&rjECUj:4BdL
	bl=Tn^e(A(llaAo3#X,!C;i@AOf=B<c;F`Ip-&("6re6-Cu4kVr<F,^ah1[,#B-cIY:*O.TcT%.>Gt
	'?W$(1XDeQ,aou#3eCa<]4%@;,t(;j1un$!GsU2>JaS_68^u;+]1TLu%uC:shd`Nu`g3Z*87rMV$40
	En'mdLt;,q$S6c/[3gmZpgGc2e&,'KiH0=_Zs6pFcE,0@]a77B$]J*J.H9jpaj;u4a#K_S1B1WeO6V
	uh-RTrP=/Jel4q9>+-N^]f$j:<`bd_otpjbnhBf]LI7Hhb\>l9%6g3QZNG[OAXF#K7EDEr`-T-j_*u
	Z&)IiA1,WU_/f=-JSOppa:]WYq9DlX\gfo&!@M8oL#TG0+ZV8MC]mX`a8/A!.9e<#f_dSGE$RA,>Nf
	_p3*B`2>g(rb>j?O7m8Ki&8,YBIYf%Foq!LM*X_a`&R@&h\$7"qp9;-*qM6"3u5>DR>7S,]Q.bTY71
	r]M\r=9%[nUC8-C=`]4QT'l2bX3GC'^kAf*qX?PZEc<lr?NSaYg>IR-Co,SK5ht(tb!j8CNSe@tYg:
	QuZT`9aqu16q0#Q<@oT0#QHOh`k%jStsipo'P\c=JPIlr9#eW'<&dZ1rY*H<?"FeUAUZERJNqmh]B;
	FiAp=`J@_<_V58UFH!4EEWV4jHUVGPD=SEkLJOAKg%R0P'RCnRYK"RL<Qu=65@oSW7=;-8Z:C,Y69I
	+ZPj&4\d4,'Tk]L:9g?SEHV3`L)L:Q:5&,aJP?'2TPsQ.k/!R&u'.#@R]fO-8Wg;F:NVEOElRGtfCp
	-?'Q/jsi9X%9.?Ts[NNCDJE$"L]A!/Q$S2/oLt^:KP]31_j7UH]Vt[>tZa=f;.nMD6tjOTu2m.1$#f
	)4G+K"02*i#g[ZC"d"q](gtXC2NTVW"^1!AP3Au+<8M*A?*$6Z#'42""O6<4JODL%;M;U'UioA$9!+
	5"`7+(hARac4d6uMflXlBf(R;/;_4'D[k0&1l'UhG#&MB`b=YWTS/qc#r[S@FUj8e'YLZ6;;O^R4X[
	U3?3ILSrR+m_gAPmP\rbm?M]eG66f)1^%qol&8lbNpA_pWbj=-(KCIUR!h>nN?Zf2R7Z?mUp(bUpKp
	7c84A/1tfoGo.UZbf1#QS,c2<u4OR>,Z6nBqY=e".=%Kf72:bl;3ji@:3o:[!oK>X9Y/+8\s#M8[9:
	o;>;VIuc,g\6d5j;O+D=X*0@ZNgt]qi=a=h,lg+t5T,C3*&k4(hiW70t[/?F@Z1!/t0?_>L=k?0+\X
	q$oIUkP!#/]UN#'8r7]3LTf/53_-/_ocT4E3-;sb1@3:Q=4,'%QL)]'!=!ZMrm64M+.U+8L6!m=iT'
	uoioY=1N!R/Xjo_uIbSKhgU*lbpk>X")(bof(-utV#3)=JlLq(fZ2e5%j^6=6Yq\R">5-*I<UDkA5$
	EN"T:hCt992"rgP2UVu%r0k<`_.srj#qfa!hUgoWb:at[(,tL]0%9X@ji'sVb2iC*KJVu$n6WKl$R>
	C?H^T>S>H5&^FP#[)T)WC#K;O%^^lm?>-,SL/88;FodP9eU@F_VfQ8m!\99b/b*p:4l5/3*NnZ5prH
	s$[9oN-<1g;k>k#_[0Q/j)G2DrpLLo>qG6M;rdEfj).WNuO\1GO15<FHg>brT_^^Xnut@BS`aD:ebs
	dgF3^\XnJYY;>f2LZ,Gj/?tm%+3P.qO>c7Pg5$^,RuIFAJHjo#@ki,r&?!PV9m>&;m;jtQmYfujSBf
	SnB0ra6>N[kq?B,%dqFq$P_@7eGdg%0-/k<#CnF]jJ@RK>>I1cX8Q[QUn9^Q5nCoY$fp9u>JV[o.;l
	>Mo1YG:p7#Z$dHOG(q^5[-H4ZGQ:M_:c2iqXbCr+Q5o-:.@K)'].%B&ODG\kn;7dr$@En3,%"&N*2&
	&l3MQ5h<V;H^d\qIKPNW;]`'&s@mB^qF4Qq-&em(,=1q`_Zd,Pq6%Hrt?#<T;d4ZkKqBb*9a<p+52/
	2Ka>t4cL0HY]+Yel?Hd$,,B3+1,&cMU(&AcT2I%n]H5-FcgqLr*)90/9Or]$'s3F"je1WA>(T6hd;7
	4JLI)=>5fW6X\/m$Wf^dF"2?uF2T>HJ6_W#.SM^(<eu.K,a++k)a_S0TK9ThnIuh2;+QmV2U34CO3`
	&I[*=5r10m?M5jO"Z\H..k-INTtE#?T>L#bZ@..1.k4fh>#7q=gFUlnD6k5M0CoQ*"a"n'%5O64OIB
	1VWOfT-Odd3*QabCP\Ok!<9DhkP;T'LmYWJ6HNmEZCJ1-3*.25DHfk#qm6ed0c6Ei<`X,e'ohdTWF>
	&:s1\SS9[@O)g%9%0<_c0`J49@9R5&fN]P`$F52c&Sf)m2&MZiHjFp^hB&!-E1F<>4#Yp6?-Dr#/-`
	VOhA.G1_B($Wo"F2UCTZ$jmWtX#CGbYcE#dLP8RmNKGcp^QL<blo4FO14d<JO<sc]SDI4f57o4=Q5I
	<4.ZA<$r\;0efW0mB<+l3X&gsbV"OmrTIu900<6=;"duR?RNnG^m!7oC^W&a:iCb@YLPkUJSBV)0!C
	hr7knGlp08OLm9+W#Kq%Ek%VlY6eV<\Xn/EI!neq29PL&L6%TQpE^Qahf<'PKO3(`S6Ubr0i.[$(4C
	4YqoG%m:nA:rUZGl.cl=o9mFa%(\^/FLR\7o26Q=$FN?T0['tap@jDJlW;:1SalbO&V`[q([7b?UO>
	(7j#Z[c6sh>*^`tY1\1ie[$BD]gJ*)mWpKhnaDQ$pe0ce?7uWup8@)do?kBKk"(m*=\,etR@QAZh[6
	QINRMXl5(#Wpq8V%ng2p7=Cjsb5`75G3PqbsG_&uZ2e8NA9HdEhMJF^tCBgAcQni15A$n6NB<r<JXn
	:16#`%RDplXNjZ2\V`GN6#,CgEcDAmWKkO?W@]]-nKGakoh=T`iTIlsG/72XSHAoaQc-GkR$^JNF<T
	32O;dB=3FBWm*ObG%O&T`Q],88+C7Q#J\lg,_e4+OX0?Z[\.(^Xpk@^9L&mq+3/"rt_<7sK);TlN"i
	T8P\AmD%QF2(u_:4N'6@A:0ZcaCs5c\@\?>`RNol=Gbp#ZQuScJmF6hBg!ZB`1'N2Vl\eQM"bI5uNL
	)hp-U9mQ72(ZM`6<WN;BG=$.&j9fBsQUO6&6)4&&P>[F(21nnO!rj\C8;fAV`8sFY$R(JrAV3=g2\Q
	KGf'aFC_]b>t!4!tlc?!T9Z<LdWrYs^?*1aK6,[5I3.&koQ%NUk(u7!*c.PaYF>38.[`->UqJ@\(9s
	i0:2_r?*(0`X#te2/g.Y"P(6O^-&F/[bnSf?E<lqnZ[P?UQlSX>Zo&[Xfo*)e1[<qOt'Y,WA#`?21:
	Spk6_VE$M@-JZIeD$_e2sWHrg6Ij5l6n8jf>hRe,tH+KtGOO!WXlB/A&A-Ib!ubj>2fMe>o73JPgSE
	"HA1Pb*u;*>F9cb#[>!Gb`KITj)A#k8Lo@.ET$((C.sh\<"%P*,@*EQ[Pu)<<HbMVI8J\1,BFJn+r$
	eoIfo[+"6?Q2Ala%r<YTITO2=M3\0(_Lt[ZL1m;/V/5Wjeb4Y0V_p=:tqF1=[.-r53RdIYe6X?lNG\
	]mM+Slng'Y`E7At->MoubfSjkt8+7IuR:>!%Y,KaSMAYZHk:\D0diitiE21u*cucsn2FG:$TjC$/sA
	<CC(:oOUOp=\F;PP:d?G`[k*M@/3b[TOFUbd,bFp@%;n2U8?E]bg/C.f$9to;^DMK(9,-mRLeQaApm
	]SKrI?da%QZC7-YZB@h@#`l=M8`c86fQKTS,D=ju_Y>pd1u!>A>TP)u2.&<0D(9^IaD.T:u-I9,s^X
	Oe@jdTRpXK&b=_L7^5Q$u"lPptS/h.hVGXERss2,T!La+L(c=bU'U04Yb,P>X0eUcjiooNIlj'Lh7`
	/oj*`Km2\:D'>0"<Ms6o;4/+XkLH@Rn@'S"8i/(u2=D6\.>lcc$G/_s)o&N`Gp1;^L;Mt*.*)YjQ%?
	ZcBnYj[&17ti>/E*7j8UTH4<Zm*:Sf3Za65Clq%5jXL[!<HOefn_7b]4Wb%0SMuVPj\EEb?93X`Of,
	$m_RC><XVu"+sa1/2`(C#neDj3,YD4,>(,\qp_?oDOFimXbKL$3J?JFn68c?Rd4_>X_g4114GB$el!
	l"TqO\kUP^+"&9'S%3(,K<B=2atFlbKPLZ]E#p1,gC[<Ym])poj;jEY@jPQqg/;t;e?F0ps!'M`,6I
	kfN@^@2$F'K`Kl6Cp"P=jrrmSeoCLKi[Hp<5D$Z0jR"?5kU7#iS;1"`8#"!W$\2FA=[/iq*X_e'TTE
	2\X%e?7UL,n*)M6Pn@CVA<KjQY8pC_tdn!D^]>Hee.FlP$2;E=:k;jTYqa;#F2gPj&K9@%T=<pb2\s
	m,0,8Mi"QIGD/.cS!6ZJ-Z)/2Xi+QRiWA,#?^G]lj[INYuH:@A*pVN!$K7m*:5D-Rg43`?4;"$A\6Q
	N,ZZ5lR4nSl.8Jkc6Vt;d<p]MGF4WKW<PmEnE?A_)K3@dlDsW]/]7XT:@GRI=s&h41jg12jH(esDh*
	U,n[8[]&4"=#?/lJ_C\*S:E7j2B2ubS\e6"BWkFSsA`q\=Hoo+m7OZ\P3ZIPA8$'Gu?#HlYch)pu6G
	PCC`XitDJ>;[,4&(md<<JK-R:c0W"*)Rg<a*G]XMt0nK9koV,.h@2OF6kb$+j%RjnpWO4(j%R@!^Hu
	cRC,MVqPK]!?9*i=;l?L+"&ap"6%ltMKV8SX(Y`0CqqJmYgQBPncPQolG>%l")>'Ukl4NTX1s'35@S
	=>_g\\h*0osiOSFj!<Zq^B$)?2g-D[lbe-mb]kk=lb?<1dqpe"Hc2']&Ibe"3^,=G5g6+_;]TI1B7<
	[%L?X4-mMM%BhH!,e\\7&C+JODXBM-;:/$4Z`2isb-(I]28=+7Tbre-3q.k[oGkUWNihZ6'Ou7'Q16
	63mFWIX?$a#oI%C3RL6C(lhj^)t92&=L]30$_T?s;Vdt%]WAUfOt^"!2=!"@8A?k!H]gq7bc,j1deT
	&0&9mY'qe3p"Ql2!6Xmfluksd711'p^B)dbQI7f-d]+^:3jCr'SK'u*k;VQp[I]/k)F:lh3e(SZ+HN
	MHBT"cb)!LaBSp,V29A@q_6RV.>Kn2q<BHWq([7d1bYOY#F<0W(4#UK]+X4K-[aikE3SCi+__%K4;&
	?ke+jemkrI0Mf&b^mqfkp,a5H)jBl=l58+0)]nYN(SAe+^e5,sOt&&'l@4Du5paA-pFeoWuh./uR'@
	II#GLr9ijXX/T3IG7rk>bQV/OeoBu!R,9a&M2"C*burdRj?*nBR[](n*X&cO,dJB63%rj.:_]E("rW
	B(@!t9=pg,d'H%Zf;ZS+qNMATA%YI^Y,d^;$Unh:r]r532@p!bF4l$g,:[8dqjAKfhgmAq47L<Dnc?
	[0[@+O?gE!C#m2'2UA1VP*jN-k17oMR?pp`No0ER@qMk^J`CcCaRQG#AD>9WR7#)X2D<o?_>9F-(6?
	_5Nf,rUUSL,6:kiLY$Z)(q:9JkDg^Ra9\/*9?[V[Z*F)dmFnH310@N(;QIrA&OFYN=Gs.MRfsA_d*%
	!sE]L2PQHgcSF%p__/HjX]iKOKk8Nkf;'[n'_ELsFgIen@H'B_;kbpuq.a_l.m(r7'dBAkZa:Zr?RU
	i<uO(^iF'XR`0HIa%`qG,NpZg8Om^KOp[XDBr2>=/$CllK1VI#E7e<ifMN>h'8`'tB:G/MTlZOag'L
	(!kbW%A[WfjMQm<3JFK8OU[W')X7MZkn#*0H9/WD.ebjdo2+TF?,0S-h:]u]\cKLPZDoKc#_(8G[\H
	ggnD'"-CG\;?(5HI&0Iao#?H<,HT]`!49\/>H3((tbnY4_!!m(*K>KhXh4aiYI1V@34.`MTh%aDhk1
	IhfXgD)8\k`]9P`a_TXSONZo6<iKdC,i:J0(Z6PiuKh]?.#u$9KW5=4A8r.OO:9B`>SB#6aRR!WeO0
	)h&mlu%:LA/n#a4s?Q:KuHq2KWg'.b"/GAPU=6L;/]*;7!XUi:s%b%W4QH&oqdR%sDr_r8)'Z#-<HA
	dE]qJ-^ts$XUcsc^g(U$p0gYUr4E1^7auF.P<S9WgUD2uWY.H^F3JTX61-NZ&X"k2g[XOg]^FK*#.n
	rjKsSXs7tR<tGeMj-+#%6eH:kub<YmcEAeJ&.d&m9FB09DWEJ"ktWGd:1i=n=`-bu6niB!3'kb/>Ho
	CG3f%cim)mi`]n;4d8f-<[5aeh6#f1n2iD`Gib)B`FWC2I6XLBi_+%bTH+Fc/"13[2Jn\;Q+_UI>W[
	0)7X\nWM519,n2V)7sOX-GESd0eU*[V/AJ_uVWp,jP^=&b5<oiA<?UsS.t`:r!4W/_F7Z.pD44J$2\
	@aP*D6Bi43)jf&,8+GUBb>q)+/qXdf`%7&1t05O'k/7X#$?a`a?H-S'Nh4k,_P-TQn]=hLg5#4+tO!
	RjX93@bfB3IrUk_R5`mG9;3fr:ALu$HNY.p%q$;9Z*)h('.]cDN9)+,)Ib&I=3RcB=BojEM$nMA/q9
	4%#]K91b7*aFX3sG:%,7eP>[$K-i/c<f6;akBV&d9NMZoLlnh<#m+S.949QYLjnZ<7tVLA16QPmbMd
	7UoYR:FP/?Pni>p/BpQ<n\NYd[^Xgc`&Hk"WiPVKmlNl$]jfR@XVqD`^FRKnh/01]pEcHRFBB/nV\i
	bC7IkE/O"9n'79*Qn5FC-NF4#IZ4!GHfc<)5dni%B;OTQ3,PgObJ(W>^cFX>1mH:*j&sM[?4A,"\/M
	_RB-c(M*C/8uW)iAoBBt$j>(i<]>gZp3b?!iXU?DJHdJPeRnK_H!>eW<=6QG2C>,:)lt3e;?SFkTDl
	&p[J`cl^.C\A3%s;,2ZkFE^+7%P$E0&*P3#5RU6q5PjM4O:/4F@GtbVK!j-6:5Hh1<9B;b<\,8@nB*
	uV#TmJi_dg*k(,YrAa(9_h[<L@q++9]UMZL^`8K4.[!#;]U)E=8=0RCkTAY=<4J,ZC[_#3P:0G^/8*
	:DFW#^t/.N4sq>9mZ_Din0UP]-%#I])l8O$PW=)WSC_qooLXGb7\K=$5g`V;-*=d;r'bZC//sXe4#[
	di2/p+"up@=^kj:2?#c[o54e65"^#WEl:XjD1#*akPNu/KM.<ZVD0:'RBdYY[EpRfV$L&n`$Om69G1
	7!X\WJG(7ek)$IMa!HGJ=%3p=@u:LZ3T(:`H9GWo?uH7fh*RY2#;'=J9kl4.=NA:Y`keGR$Gfc"-fb
	7KU9D#jO?ooi8;4#/H/h@]l7.ii0dYUJT/HLDYL5ji?bp:OX?tCVuuIgsWupdPqTO_8>omIJ2bM3?$
	lMgV:o\oQT515t@[$NZiRJ$aOa_]@BD2rT.%N+=c$7qj,GC$$?pnOcd(jM?UV6#m)iP50h<TJlN'NR
	;p^jR[g#pZlkL!jK)OK3bCfmZ-!TW@S"M"U'3Ts+doEiUXWoh$mroH)ftuNg%C#ERi=$7:O`5Z`;$C
	_$s)!JA:_Fk/\!-CWAn'q.hV&%b_"gNA?Q-5'%fe"lLNXKKdN6kc5i8DLkVPZbrs@6@.*JH,O=2o>p
	a5LK<PemH2"Y+nH!!+'pqWb%^XJ.^#Y+r9q`g-oVL`EN^>B[hJN;\0E/0K#EqgJp7(M,@/*bar5.\^
	9E:p2?W)PaK2\Ki<A.]B7UAEFmX7gY+t]rhC7$9DoPI7AA3tfG73.gDaJ_Cg'4q=;.Dk2/=PV<i9/J
	L2jVt49U7$(AHhF:N6Y(JSIRR_=mFMQZAF;'Vd9^XJHpk:$FL<6^BU5'l)jo*!;^\LPgUn]kcW'>tU
	g;;>$3?<DRKcTYSTXMI+fpcP/?CP?6&&2B'+Zu\I@dUq&WV!^N?epLGkUJF_Jk5YqiKE:DP)F#nI5c
	$OdRTH+(KV-\=@Rfa8rCJpGk?a@`$C(e?0A6mN""7k7k'!VLK-D;!r#H0>'K*?,WO(59E@$k7g9U6n
	l$d:;pkG3_6$k&cdsU`b%F[+5^W1-_oG+7WCZW$jAJg4YF&TL`m.)PK1UUc?W]1_3bqE0'8o2l^WkY
	<3G,AM=+tmdED9;0bW(MN_hjWrsbHOQ%efa(GhG?PZneI'f3N-%Ju[n/AB6h(>U":TUm1BqhUc"dES
	A>]<mnJd>#(VMMF%`X0l"g>%)#bV;6Ob(AGAlY)qmp(9>k=_o=lg%\CUnEJeW@<S+B8-h(:9m*i^`h
	tZEI39cnHg"9mfb4[HeK".@]O[BG?i1T_<3NXuZ,9/"&P(9t+D(%<+*!SKYBp-Tr=DE3(m";a.PbTl
	Pm2lnDqTLc$(6-1n$M5H9;k'U:8Ub&1TS''C'WR/HfG%+rL6;ou8&)L:`#d%M#%m-\Oi^>aD@Y1#,?
	4H7qcqIVXqOp;KuugkX!ATm0rKEP4O52>eksn_0!C%2Gs%rEJPN"RcTMecPS"WdS0B)`htt#DF!^SS
	jN2i:]a'J^[;.%>/!O0q2d`r(%t:*6FE<a@=''t<f?$2>2]8(3j&:g6Y0PlpX7T>\^=U:n()8S&#XT
	:BBCt*8/aEE_7M:k1Cl.a&mb1pAn&Um)?r<4^lNDA#r.Ma,'H"pE%bijdW%E#E>nKT(816>B&-],tO
	D[9F+g5<+>Eh`dR5'1k;WGE1:O.U:(k`V]7gN]I#>JNH9[kCb.`)q[DkXrRQ\h<U\JdFOWj>hupd-r
	'g5N@4EF/aOB/!>r)KfS]6Xb=2X7B?d3M7/T=sSdq`%K_)qc<<!]qD>gdu@Qj0N/5aq8a:-A&?^Z:N
	s>s[6G4Dq1p=N'7GEGb8jK+bCL`'ih:iK90R;UKi7KC@8Vc[.G!5*LM=#Jh+'i3rWTp6p+DC>E,ERp
	6D<r-O1oYT%A^=d5BZaXC_R*Ac,Pbd_'*b4JM!9I)J^X9).7<P3DU^]1%]EdJ@0LVK\Y[jf(h:"$"s
	nd&Qhb+(rOn@X'%:==^GY6qK6D66gkHAaSj1^4Bo5V6_9M7DuL<`j;p71YTGQnoEA(19o`A$n&+m_k
	Bt5o:,hFceXO>qTZV*E13h=5QpL2.dpr6fgVaFmG_a*l'#F7V1YkMSN5PmgPU8`HUGF3).::JbYagh
	dR-BK+0<fV-P#J90e9TIp;A,u>+k=<JrNY4[6l$N7g1rLX99\=eZ/C2,JP->B0.MpD=JXs9%iPDFil
	-er>dlFu'jsb"Un83u*b$<\8i'7^3e45I4BJINjV.VS[=L&O`hdj:"97fEI$=$.5So`sCSDp.`L@VY
	W/3/oWfu%&cnPUYn/S2H$/?MPE!n+Equ(^FA8\cV(UcFfg5$s%0n&:Gq#OD+%.bhO#WGSA;#2?tqup
	\42PN3d/TN"VHVCXcjG4fm90/akI]O'Mo.qD.`]LCYetOr$+OkZ(2@tRaGo*fAm,jt$DH&r7I63$(&
	Ss0a_DtTuq3gPrMJ:3W(M!eodY4k69uR[g/4ZoDp2q*I3KclD:!HO=f@DQcK>p<1kV%CCpN;=,`$so
	S%I9D,^s3%0_cuLihu#A7>Md=MEVu^,EmIriM#>RG8jGql8S3>m,U[c9+t:ukPW'FXFSj'^S:_0jJV
	0[L%57<H':^7oQU'P9JqkB'mibSE?qj\qK\g!=^9K.@3!XR_D;gIsF`=(7,ZEMr"`k```&gpULPVJJ
	"7<$u1&,6F0dWf8]^qS"gGs.T#K_S>+k<Go_Q3m_[B57`VKc,>]!"gfg*apQ8fE_>Wl)e%%8CIpMOA
	W.^Qnn\jt%&O_ASVgC:=`JG'HE$KGh"%Zd/d"KW-\'[X+2SoNrL5J.M1;jDTP647+tVo69E]]>NfVJ
	rB].UZ2nJ=XtXX3*6PE7mFK:F\3pdn(M_61I0Y(m]s!9C$?D[%V8N>KB6[!Jl+G^g1P"@U&<p*A_M\
	/0[D^pmb))qoG]kWkHiWq$'kdrW0f!t*i<WQhG2#@*\ng2KG+[*8i3dR/cPP;7GGd9*b5\Y*24Vd(c
	lu9difl>-<_mn@R_6IYFDMQZ2hA.cWc@C3:8(F>cI=@L:GN';Bi_]<Cir[]tj&(*]9T_Q?=58C_&uT
	Yf.u\3sDBH7nSU/3__/$<>t'#oF",[^]1p\hqikGCB5;?1R1t3&YbXg$_bXtD.]i=Y``ao4VjE`'.e
	a)Z0TIlGed6GP(ST;hP!`A!k3E,[9F*XjEuOg+NTq@(5JrlIuRBB`aE#:8hG.!)$VU9oe?r&"OQi6)
	<!!#R2Y%[ZJ!#/,?h--\q#HFF6AYRB>m]o19n&E4<k_Z\qZMC]*3ZN<osS*._1@h2>)shkqTC_f-nc
	U5LE1o9^14W].FZ#0`cPd%!RsrD$S7P(Ihh&=0gC[-ttP;#fI&\R8^o"GDHX'7W";*+&k`AXAeV6QY
	+ADNq:@&$e78_TL&l!XKXT35BD`^$O7D5B@(,48P2=XnT)+pju=F>RSH6_!WG1]_4Eppe1<i5R=OFU
	Eku"Q8b.r$J-mU:`JAXj\\NIh"Y^I/HP/ZuE1XqdL5gM>Oi(W`5k2uCV?C^qM31S)5X]CQ(lLkDpMo
	o!\VH)X40BQqRadT?j4K)[9HFo_Od!A@>-iI#*V9HH/dsoAOL:cACI;ULembSU#9(BPe)hp^"\_SY0
	cp)r@AIO=I.O-%E$$Ge@3P"U"RAYV\,Z3;W;qP%NH($^=DC1LDc(G?9mp:6e_td;Wb.?3ec'5b.qkV
	f<'eoA)L6?Q,AV=P@IC2O_]gf4_(O%s[Xq()_g@G!AO>3Cj9t.T+u>A76^q4'HbD!R9rgQBkTZnk)(
	:&CK?o&@YM5L#1^pinAp,h5@>a05:Do%-X4/I,]0]W?=J%*&_qTJ-iXt/8"qP6L/HeC>KK@D_TFTrO
	6[NMc;XX0c#&MS89K1XJEG`RQW#8/f:id(>=6drrKBCFFR/kt4+J4KbaJ_jB"T.$?oT_r@*jguXnmf
	n%N/ZYP`0oiF@:Is&msPYcq2C?a:F\E#!k>Tm%ta\dp.'W1HU1mk0IaWrQnoU/(K+VISg>0<csiCKK
	NJjRG(]IF"\)%D&>fJYTBB^n#'A7aEoc@Ppi=F<Qr"$p9K:kW8SO>,$pK>?n8W0@W<@D6=+BmA@d%U
	pK+EcR3GhTVF@F@2J2XCIgL2p@*jp'E=YJF:=gC>+B!9.(Sq'R^SBET2h-<pU:FS(Q0EUOlcdM8<"&
	EM7ga)6riGT8)`?b-CD5=`Iq-%(a!Af)8<'2NfVTd[I7(DAHAd')1c%BPUrqRB"PIC6JkNQELIeU>O
	TKTgb(!)?s#0jRe.!PZCJ+0);DgqK;<:;rraW\S,$PpR#jI-cAV.aF/!O^6We*E5#",S2L5/HP[5oG
	Pn9QJ5^)$(TT<>=Xn1@cjhYrmXcd>a7dTcr`S*YW:sA=go+N+-2[rLH"Y:3:^cp"?B)Qop3.5(3!l"
	GEp%*9R1i"@n\^93Ubf.rTK@`m,[Te1Ph(JV38JJh>Z"p!D6NPWg@X3`A;8#7]r8qFE(j^'JSudbQ@
	bKT%9<d(+iKE+k;<B'Pe$4*(_NrqHEj?ad`KhY35'I/(+QAbMaim38Gg^@Tn\mDhHh*fDe1KDq).h/
	E9VMbPD]L^8W2LsOWJX/+<l90SGFW/Ho@K+2nI?s&n_7dV3qqhJ/:>f^Di&7aQM8\9_S(l[[G=Sud6
	5W9CEQ3WpR+J]<c=@)PBR&4"^1RD%YMg)VTJU$Y(>eGUsc%3"@24]&4QNFZcrqZ9\O5=QBIf;@mrZ'
	$.S#oVl1SkOj4h@K8h8uaVbV2X\,p-5sSjO3-crBZHkQ>r+"b5TE$&LBL@>R('W&@)MQVQ5k^S%@o!
	V`n:U/U_\P[]6O$KgBJm3\O9n(_T+q"oQQh.,m&g?Kk#o!^S_LdRmT_C'KHA.RRb,Af!n-Itfb9?oQ
	P,2h],Omj\;\$2Y]Om:t*.>2k)!GN+RO.cSc0T77\IQ*^iGSXJQg/*ouJlhk&8u^Te&iur#Lf?DBg7
	ltnb`R)IqXp=pFITh@N4uhi>um>[^laO+Yn5,-U5i[@V[bSaq0eh>-Qsus8N%^Y?UEE)83WCTegu9<
	.;aIYK6f]5mfC6M=9\l5eU\TcT1fW*,jB78dEqXs=Q(4O<LG">:!_L_ViMn\'M7hiDc1RZUNUYMlAb
	KhW%ti"]cBH?mRq#D2BWi#Hc9X'9`,YQ2g>i?QWhRkPB]?)bAYqJqON;#lO>lJ5a9+\;dk=e`LE6Xn
	$m([TrSO0Q$93)dVCrpD(n/nJVc">(5[N$7KCT(:@6K;Q&6nJ)KUoFQ.Kr!o[a)]nH`_G7tP#Yg^hB
	nJ8shH2qu<[@Y_r"*=?8&Dn&=:Vc<J!pdLIMV\R"-RLY0+`)lt:Rh\\sB=[PZM/XeU9"S2hms+pkni
	<57gK2sGg(2pKJ,5p.A@DR/j=&jFaA$`C%9O@:r:mc$p7IFdMldk/_RoklOCm4=iR$guoUp<TCr64Z
	pHG4cJkhbdQ-ai',,uX`9S1MS0JT85BG:0d*4d*RQRc<`m](rM[7),,r4`65n%AIU[SG@dM4(HO[P1
	!%&*9s6L;FGcD:h<,EFAlY&oDlLj87cj%uF>RgAga\hp2Kd3C'RbA=1_aKH4fl:c_F`BiBV41dbmLa
	lF!7l2%W<:ipZb?1j0u`S*$C4tfXG00$S]9hEif3I-/.gj"3*\]*8pOhX*Xq?MR]e;h<CiM15G.NI<
	+IcEA+_O(nPC,UBkZOMA\gfo8Jm=T2rX,V>EVW^Z0-YcF4D?j'ClR1aH1q<0\WE6\ehT.u4r)1sa`Z
	$q3\O3--$Cec/LA2)l%6j^PheJ>h76j/cbYA(I*lcc4KVan<;:A(K[8imVaiQE][aRbd<5Vq-!-ju?
	4SU,nffFj"d[18h?q+D.,L2aDA?=IG;XF[A(St/C-:U9Me`>n`Vf&#SG@ln3=e2Dn?V!)`2Jm&rUsa
	E:IeUIhoA0+lL72lthWL+r`uG!8LHj((2-6u&r6>\-8>*"6p]uq!o9ckQ8o0cqS7VC:hd,8i1ArsR)
	")3tE^,YjP&VA)+2fN#=aNi&'!A)[=M.\@m?LS7m(]SI9eMgZ*mL;[XQ#>fI*4H3TITWbh4J[:i_uR
	@W%R^Cccoa0?[MgD:^+%.^="?@./@.1Bn)b=I/j-Eq"+29D6QJd&C)+'-_@*tW*tN[]I\A)k;:@V-q
	_E'''g-oR]m-+X.e=P.O8_@X1khKfiOtLlt_YjmiJ?JM`.WtebSpX]h`V(,Y'u$^>^!Mq9c[cM'gL0
	<69@@I3Z+g@W3+mV]#mm:b[4C0=Y-+@q&F&X)!:1hmN>+H'T8]/JtBDVTVI#],9N1-`M?Z\]7*\cqR
	]SWlm4L[.E9e6781%c<f32eRNLe>+7MP$fO4UnaS/-akPI[GBk8u=pjWZS>854QMTFpHA?Rr^<Iia+
	rfE7cg`'Q5NhX[kp_.df]8a`ZU&>YkJXnKFXTbJT<LB+5#L)D-7P<*N"@g<9e]c!6oc@R$k%-5'=&[
	.En^NUs5e_;,uW0s'4locN&Anjdp@NDpQP:djL!hBm;FA1fC#,Q*qG_fW<uY3`*'bLZi@La^4mJJ^N
	oK5(V2N!2TGJl0:i-g!m?`]d)TDCBY/$Db/!&M[Q^>"=[-aZa-D/\BJ$Do-aEP0(d%$/puaR/L]Z^K
	k;5T+PuR,DSrs>?1r3Yr]g)@2q`5\ifr'&KO+6e#[,@--mn$@(J4P'![OdZ-S6sc;@h#eke`p>'^@D
	ka,\9D<]<+kJ")K.%.+H`[.`6E^q1q7R^BpY;H*Y!#kfaXh>B`$)04/LEnu$umhL#,?,!ZG=7@p[Hq
	(?3m\efjQM7r\<lLH$5LA0F%]\BA'^XFd;c`LPG6NR4J(2!,&R57Q=%JM?9Q]2j+@aem`i5%o.LC.A
	LK%EQ[6k<Gunj8j]COJP(MRanbQ%^nP0b5COZe`3-:\&o1`Q+U(d:)fR%^;FrB1UWoV<Y]QS(nI"9.
	PZ'qX2OucC[(#AOeQQ:!iA(HV)KY#l>RTq;'pRd$TBD]nmh8BV0bD$]SJ-khl@4\#;0s6145hJ:\o;
	H/p_P6IL9YnB23q9=D%k4\*7i]ls&%oD0g)Z]$!sr@Yi"bg+/h-WN+/KMbJ-2aQ=n"QhEoSn^.#-Hs
	`jjLsP$,^CbtJaVBq%HY8u_q/4QThAM5!5_L2(=3mU5uN8h3I+NE/4K,g>a&q;4'Z3q:>$LV0(tAV<
	Z2'b`["Wu+P`kg'U-*gb2In;<kGLV+5b[1[K#g_gM#q1/Q\Qs+ap-aQq>I/*8C9:J,4BChtt$8-Ode
	%r1G"r_+pc!I1RCi8Sa[1&5+6S2a=uil5)IQp=_`;Ir2)Dd<qKLs3@g[bm^.5Xmc3V+hM0qB-[1lo+
	2DKFJ*$;IqIR609@l4P/I@i7m]$>L\(mHOE"H6'gX]?Ds];dIZ6Rg^mK,m+=RgCf=;qi5q06LFe>Ot
	3<#Xu0rhA!qF&qUS*6\%,aEQJ4)MR_i(-hble8/W`&"R;!Y0\B.YSm5=24dCYIC]`j!4&h\(a.D:]G
	FHakS6aYelR7S+QdL,KG?BdFWo:?eL7\"Cs6:eL^ZfIqKGEL2IYWTE26sL1hSaadT5);uGPlA^c(4&
	XQOIX3K]28/>RT$]?qMbB[h04MO1b4T\$(BIa:0mID8mZb=YRQWPiRq1._OB3Z)Q(6rleo`cF%7LRr
	@6m[_HOA!kBeNT>AWj0fspfH/n?rfj)8\D:7I_fR=,<:H>/fO%Y>ZlRuC$*h:7im'Y](quu(]PfDkX
	N14opnK$Pn+E2=]$F&eDTF.3H1U"TD,$j0D3*FS:B@,oMXS7Y-(q!27:!iCC./Q:sD#(YcQG_?0F&5
	i3(apSslbq(e@GqM5P!UBF7XUiPs_e\p72/5\kCT+s1h0mNS1uUEBG=*;3J+QuVm*beT1%F5j%)-j.
	V->*t6-aX[Z(h'4dET@s#H8^Ig=Ak5GY@H.-8.3]rdIQ#<oK^U/c81,YFFJ?IEE&@i[rhJBNr@g,,4
	En/eS@AjEpskfp2VFhQQW#8IPr`W]>j.M2+oh7+hX>5T][N/jb]U,R>Xo)u>p_9s6Ikr!>bf'p`EqX
	#34$[EM('<E.6!GIhY&,TZ,7X"OY.Ye,))1tgT4C95C(mF^\_12hu;4lLRncY8$g3jmu'!l?Y22F]h
	5m%k/)3LNfK7+@[D@oI+;1<q*"s#l6!rRHk75EKd3[U\:AJHfKp7[INIig(.uddTlW;ZFB-X#MNg4M
	s,mfE:soKqk6"i0@$:Z]C3AgfU)L^KYe%I'EVFpT?B]@pStj[nk)uIjp+k7bo-0`5-ZutsVT\_Vo]o
	MtO,DuJYu$IVQr+5V)NGSD!%nmsi_uOP3E)-/J,7LkC&>^WILuP;@QKFbCB^`h06@;<K.6VD-9q>0M
	-lFdr)eHGV?iC<UML@]iX6gi0Fd:E.:mZc(T?TNWY^]13^X;@2r't#+LMaAESdR8GGH0<g95?>Cg@o
	;i*@X1;>jk09NghehX-qtBK)^)g1s[uDNe_l@\k6]WN0l`[@)J/T6p2:?slO%5^Z,@Yc^2>VV\6?C^
	S\LPTZr%#:q*ciH$IV]a*-[Qf%[u$uD93]L+I;NE1NtFuT0BQ&DC`(KaSR[a'g&4W,O,>3M2.AJCLW
	2t'(\S#1=#1R-m_)^BgLh\Uf)p6^MYQ\*R1Ouatoaf;t'h-VrA[;^7Q(!!gd]`W\J>eRjn[50s&dBB
	a:gj*'B,s-f/O5r?jXVZoVe^nTgpuN%-^R3VP7<56URrWgWl?ojPB#R(Ir7m8S5L;XEjr)JeiZ!?n2
	IC?4Ydn&.8$G,<oar(C?BT-1Au*mkS0)!WMM`KZP036Q?P?RB*B^)m4dD/\WWg7UbHWraWl8k/$ZJG
	"r&L<-+91[TmJ?ZWq`!$Rs5AJ"pF,o:UMp5q:=\Y3g3%19Zmf)9q<PoKf-I:>!Rr"l.-d,if-GPVS*
	+SBN*`:UM!R?*]50kM@:$9sh'Q+&lN'Pl[J5GA[%Qo2(G[4+*B2[]Xd(o/M-g*Tic,GE&"Z_o>s6QB
	+doRi;.g5`PAHn+nqA9lJo?ZpOP=MmN8_3E\Vc7&iIOa>hWHl+qsE?pHgTXuhBK_&DI7efBcI$(ha`
	d!)sAiiJsgu-%doOl\_h;;K&Ytf52b%KCDOA1N8E1Y)t9;/c<FSpf,+@-;tTp/qKo5:acQ4DrMi+r,
	J)mR'H80+]hD&=99Q^!93,(Vbcg0<ju=>#C/(h0!JcM<nsS2O9i1f;XBA&[JtWQ\DmUiCj*T:=R[Y\
	\IH(&LQQrE\o43,^*)bi\R=qo!TE;5Jc*uU.c::,QoP>a&-WIV>MW,OD?qD'DKf!O#19>Cg'.?t"3f
	@'QlEAq8?fs9B"`r'A0Q<dr>!%#tbH9I5NbJ@U5(8J\o[,qtWqRZJZK%\eBX%6A9M$!sCgG%:W+gaU
	Q>N\J2\PIU)j\U!4]+hlWt,INZd1ba5Sls-+d4K">g>@+e8EX.%k2MmO9V+YkjL%&8(88!/'tguZug
	Od>:p?&7A^5N]`/-CERN\FNW%PVJ'>n4nkjZ`VqaqE)kjG[5`c\ALU"%V'9]H#a]>lp(E;!ghqllT^
	;X<beC/mb%ekU)]>_M:KO,U(^%V-?!+Xoe=<A"%I:(W+hB1kME75B6Wlh3g$?LS*8"GKKQl.j/ikG<
	?pI:D72kR66D17n"/<cGFH3+1O;-r+OGF4@/-q)u7nXd#!&[89j,L<iR'F^LP8.V>fWB^@B.AVO(&V
	<G2=ALVVqn]oP>jV/Nl'3"CT-4^>/06O@E:jV#5:Z)^SG2dE^[o%^.UXttS4dhKli$jUp2mn8R\Um>
	9lV8gE-E6u+&HI1]3XVZ[+dk7-h]bDi@e!*=ZkcHTMI?=98U.B:HpND]Nh6-*NE*FC]Ed+X&#G?a(S
	2^:fB>ZG^C56m*k%WI-MuA>!%-9`%<u?YVTmA]:VH]nY!I)lKIq55@YbShtt$8a>Kd0@,;moRsS6$q
	T,L:"`-(:;[Vpt\m4US0BEuJ,$$s+N>5Up:<WIH*3X0o5r_&1"K;4$Ha9_i"=%\!WU"$'=5^VEhgP6
	6QcSq'J<TYm%IL#LT"r:VGOJ0K-0?0jV&!kW%im/pKL=67Hr+HN=1ER]&U?"&Np=#kP-QF6-KN70nF
	LG%lZB<SWQD9MECLGg1l9j!$0;;PQ"Pk'di5Or5P=,ra)G38K*[*`)(;^tWC]V'['s?+)e&@,2)-95
	3WH6#S4I;-(A/=Whdb?^J(,h;?UZ@0;ADRmPX0_N0&qrrPtLcA^cMY%A6]rmWDCZJGMV+8\ng_]c!)
	c!e7gbR[*"RVWfdH(EU`JVQgkr]_rN7O?/rO\irEDLpMjV39`d[@.5M^RN-H[_kT-3YO(;7]f+WFb8
	Fso*)[$U_'`GLIDR)8l?J,3TqNi:O*anPChtgNiNs.\sQXsV&`UGU_RD6[@PX'fHE>)bHl`<rch)`1
	a>a3_1I?LtJl"'.p[(#)!gN3AN-[p@3f:6blEIKe0@nHPDqUNhe((."`kBH4I:Eu&=J*Z7ap1OEpce
	&N=50eP[.nJs#0ZGj;]H!`oB-`,Bk.?MB03ICIot5P`[+^&E[-6A"[\&n2:q$mk25YI3<7oo[B=Vl`
	R+<M]i"(=8rQam0??2%bZF^+?MD$9D4ml8%7&PNCB%R\pPDX^G6<U:,2e>_f.')5_^[O2TkQ9*$mj_
	!hWF+9*U5Req6+kRChA%:Zn9+]!@^TQW8"q4c,H3tW#T(X23bX:egjY$1rh05Y=0Ktpr&@4%>buu>L
	kbjU*cjTW<$n*_+*KLPEfmh]E<uhUAC\A;dZi::fGZLMnE3dIOeX=l:11cf^-Ce_c8%Fo1p`_6IH-;
	GEr)P$4KHSNK[>nF$Gq'/r:,?=G#0G;QdVL_M=nBg^K4FC3JQ/&0[`4Wp/Du.?S9!MNOjQdZJ?k?11
	.4/T?afLPZPK?jGjicH(E7[F>?bBo-t(q'X:WtPdqg?RI,0#LY_KkmsL&MB6q]S(EOkBC't^k[DCOB
	3<UQX&(S:,]&GeaR%#:meRPD:Y;Ge,A2_NM6H<i*K2:tX\.PLaW<Fc/!/$bF#OT[alQ!&#%JX#"*63
	>JK<Ud[WB(Kb(>#Z?[V;o[ANiEti3,&#Zj^c[Ju8A1(X9Ql.uJ`:Sb-r=Q(q3QXKUJ;]aA@)Q7qRd;
	\c`_O^#NQLPne!`=A66\leW,3EWc,eO*_kDY6EmqLA9Qs+ntEg[1X5Zi@B1eR/>!ps9)-0rImkmLVs
	4H9ir1nq>49m)EIbX\gGOah1TT5_[6>;PB4Oc`BC3NR,;A*2I"E'!r[3K;mfR/\Z-YNWNl8iGan$*i
	<]R#(*aEp(#Z]kbYXn[#4b(3OrRi.:h;QP!r^"a\/F)@h!lTq66Wm(:j93C`2FM\;Ha?F*\:@D7qU2
	m+'GI[C54>?bQ*H(;c@EA8a(O?:)cjq&)iOiikX>ce-ujIanAZ(I)I\^jSs=Gn)@o8XS);.(uEaP[b
	l1nD!/HcA$XCmV&1QKBKjdh$j(tq+AgBJWSSFUt0?LH3RXE,5m/l-lM-IoJ#1^1U#5ck`j5<.YR+mi
	u#Ndm80egP_!C/`!)$l]sh.m/g6*UKfC"h\Tk;BXR@[3Ac>P^4o+1sqf8SC%7dR%r_k]K>/SLD??bP
	Fe#n,c\#VF(h7`USf<77R-)IsnR(g=`(&k!/0E,lp5Cq)YnA@KMqtH2C(\B"9!"%cb;;,M=3S<T<ZY
	+*1F']_j\8spJ^Br)R;mst3l?JqM$d@4\(JiaCYLO&X\jsHnplN#+DB"@d`5L/&b#e($=6KdX?F\DV
	*U,iFj,c`l.>g[)r*!I"EE][Bk(Y,gj;ARE)/XZO2mm^`F]n^,lIUH#/QP2,^4f5&XAS<$A4k#9IXl
	J""c!HG9G5TMD2*Ut)HWEUql,$S?AhXd&Jq.kld!Hqn,M3Zb-1eNPHQ7^GMT?>Je(speZ5#STH5'+7
	j;9+6Xo:YIdpm*mNYK`UA8b<f24WMm4JNlTDd#qCAa./!E+?cSA3GW:+j1aRoKNR+;?T]mH!'2f3#U
	K8QFPm9LmX0/'@.Qllo>QofO\DFsDi1F)eP_a>H7W/ORdmkq,=UEk1RpL3huR$#>%hY$EV]<3I,:LA
	\@Woa_!dUM1b@(\qiHz8OZBBY!QNJ
	ASCII85End
End


// create the data base file
Function PK_exportSaveFileDB()

	svar todoStr=root:panel:sq_toDoWvNm
	svar FileName = root:ExportForDataBase:FileName
	nvar maxmz = root:ExportForDataBase:maxmz
	nvar CreateSuppl = root:ExportForDataBase:CreateSuppl
	svar SourceStr=root:ExportForDataBase:SourceStr
 	
	wave/z/T myExactMassFamilyText = root:HR_Sticks:ExactMassFamilyText_FitTodo
	wave/z/T myExactMassText = root:HR_Sticks:ExactMassText_FitTodo
	wave/z myExactMassWave = root:HR_Sticks:ExactMassWave_FitTodo
	if ( !WaveExists(myExactMassFamilyText) ||  !WaveExists(myExactMassText)  ||  !WaveExists(myExactMassWave)  )
		wave/T myExactMassFamilyText = root:HR_Sticks:ExactMassFamilyText
		wave/T myExactMassText = root:HR_Sticks:ExactMassText
		wave myExactMassWave = root:HR_Sticks:ExactMassWave
	endif
	
	variable idex, num, fileId, pos
	string sourceTempStr, wList, species, spectraType, specTypeInitial, str, tempList, EndingCode=""

	sourceTempStr = SourceStr[0, min(9, strlen(SourceStr)-1)]

// 	svar SpeciesList = root:ExportForDataBase:SpeciesList  //="NO3,SO4,Org,NH4,Chl,PAH"
	svar HRResults_ionList=root:HR_panel:HRResults_ionList

	if (FindDimLabel(root:index:squirrel_index, 2, "HROMinusCStick") >=0)
		spectraType="OminusC"		// this will be the default - if users have only Diff data, we will need to bypass the abort statement below.
		specTypeInitial="M"/// m for Open minus closed
		variable/g root:ExportForDataBase:HRStickType=1
	else
		spectraType="Diff"		// this will be the default - if users have only Diff data, we will need to bypass the abort statement below.
		specTypeInitial="D"/// m for Open minus closed
		variable/g root:ExportForDataBase:HRStickType=0
	endif

	Save/B/O/T/M="\r\n"/P=ExportDBPath "root:ExportForDataBase:DBInfoDesc_"+sourceTempStr+";root:ExportForDataBase:DBInfo_"+sourceTempStr  as FileName+".itx"		// overwrites if it already exists
//	Save/O/T/M="\r\n"/P=ExportDBPath DBInfo as FileName+".itx"		// overwrites if it already exists
	
	num = itemsInList(HRResults_ionList, ",")
	
	wList=GetWavesDataFolder(myExactMassText, 2)+";"+GetWavesDataFolder(myExactMassFamilyText, 2)+";"
	Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+".itx"

	// HR values
//	wList="root:ExportForDataBase:ExactMassWave;"
//	if (strlen(speciesList)==0)
		wList=GetWavesDataFolder(myExactMassWave, 2)+";root:ExportForDataBase:HR"+specTypeInitial+"_"+sourceTempStr+";"
//	else
//		for(idex=0;idex<num;idex+=1)		// go through each species in list
//			wList+="root:ExportForDataBase:UMR_"+todoStr+"_"+stringfromList(idex,HRResults_ionList, ",")	+";"
//		endfor	
//	endif
	Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+".itx"

	// UMR values
	wList = "root:ExportForDataBase:amu_HR_"+sourceTempStr+";"	
	Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+".itx"
	for(idex=0;idex<num;idex+=1)		// go through each species in list
		species=stringfromList(idex,HRResults_ionList, ",")	
		// diff
		wave DiffStick = $"root:ExportForDataBase:UMR"+specTypeInitial+"_"+stringfromList(idex,HRResults_ionList, ",")+"_"+sourceTempStr	
		if (maxmz< numpnts(DiffStick))	// original data extended out beyond maxmz
			DeletePoints maxmz, 1e7, DiffStick
		endif
		wList = GetWavesDataFolder(DiffStick, 2)+";"
		Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+".itx"
	endfor	
	
	// now save code at the end of file to automatically display spectra
	Open/A/P=ExportDBPath fileId as FileName+".itx" 
	EndingCode="X Display /W=(260,130,660,330) \r\n" 
	fprintf fileId, "%s", EndingCode
	for(idex=0;idex<num;idex+=1)		// go through each species in list
		species=stringFromList(idex, HRResults_ionList, ",")
		if ( !(stringmatch(species, "familyAir") || stringmatch(species, "familyHO")) )
			wave DiffStick = $"root:ExportForDataBase:UMR"+specTypeInitial+"_"+species+"_"+sourceTempStr	
			EndingCode="X AppendtoGraph "+NameOfWave(DiffStick)+" vs amu_HR_"+sourceTempStr+" \r\n"
	//		if (strlen(speciesList)==0)
				EndingCode+="X ModifyGraph rgb("+NameOfWave(DiffStick)+")=("+sq_getColorString(ReplaceString("family", species, "" ),2)+") \r\n"
	//		else
	//			EndingCode+="X ModifyGraph rgb(UMR"+specTypeInitial+"_"+species+")=("+sq_getColorString(species,3)+") \r\n"
	//		endif
			fprintf fileId, "%s", EndingCode
		endif
	endfor
	
	EndingCode="X ModifyGraph mode=1 \r\n"
	EndingCode+="X ModifyGraph lsize=2\r\n"
	EndingCode+="X ModifyGraph toMode=3 \r\n"
	EndingCode+="X Label bottom \"m/z\" \r\n"
	EndingCode+="X legend \r\n"		//1.49E
	
	EndingCode+="X Edit/W=(5.25,42.5,450.75,370.25) DBInfoDesc_"+sourceTempStr+",DBInfo_"+sourceTempStr+" \r\n"			//1.49E
	EndingCode+="X ModifyTable format(Point)=1,width(DBInfoDesc_"+sourceTempStr+")=134,width(DBInfo_"+sourceTempStr+")=144 \r\n"

	fprintf fileId, "%s", EndingCode
	Close fileID

	if (CreateSuppl)

		// deal with InfoVal, ParVal		
		wave/t InfoValText = $"root:ExportForDataBase:InfoValText_"+sourceTempStr
		wave/t ParValText = $"root:ExportForDataBase:ParValText_"+sourceTempStr
		wave InfoVal = $"root:ExportForDataBase:InfoVal_"+sourceTempStr
		wave ParVal = $"root:ExportForDataBase:ParVal_"+sourceTempStr
		wList =GetWavesDataFolder(InfoValText, 2)+";"+GetWavesDataFolder(ParValText, 2)+";"+GetWavesDataFolder(InfoVal, 2)+";"+GetWavesDataFolder(ParVal, 2)+";"
				
		if(FindDimLabel(root:index:squirrel_index, 2, "ComParVal")>=0)
			wave/t ComParValText = $"root:ExportForDataBase:ComParValText_"+sourceTempStr
			wave ComParVal = $"root:ExportForDataBase:ComParVal_"+sourceTempStr
			wList +=GetWavesDataFolder(ComParValText, 2)+";"+GetWavesDataFolder(ComParVal, 2)+";" 
		endif
		
		Save/O/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"

		wList = "root:ExportForDataBase:amu_HR_"+sourceTempStr+";"
		Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"
		//  deal with closed sticks
		for(idex=0;idex<num;idex+=1)		// go through each species in list
			species=stringFromList(idex, HRResults_ionList, ",")	
			wave ClosedStick = $"root:ExportForDataBase:UMRC_"+species+"_"+sourceTempStr
			if (maxmz< numpnts(ClosedStick))	// original data extended out beyond maxmz
				DeletePoints maxmz-1, 1e7, ClosedStick
			endif
			wList = GetWavesDataFolder(ClosedStick, 2)+";"
			Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"
		endfor
	
	 	// raw spectra
	 	wave RawSpectraDiffMz = $"root:ExportForDataBase:RawSpectraDiffMz_"+sourceTempStr
	 	wave RawSpectraClosedMz = $"root:ExportForDataBase:RawSpectraClosedMz_"+sourceTempStr
	 	wave RawSpectraDiff = $"root:ExportForDataBase:RawSpectraDiff_"+sourceTempStr
	 	wave RawSpectraClosed = $"root:ExportForDataBase:RawSpectraClosed_"+sourceTempStr
	
		pos=BinarySearch(RawSpectraClosedMz,maxmz)
		if (pos>0)
			DeletePoints pos+1, 100000, RawSpectraDiffMz, RawSpectraClosedMz, RawSpectraClosed, RawSpectraDiff
		endif
		
		wList = "root:ExportForDataBase:RawSpectraDiffMz_"+sourceTempStr+";root:ExportForDataBase:RawSpectraClosedMz_"+sourceTempStr+";"
		wList +="root:ExportForDataBase:RawSpectraClosed_"+sourceTempStr+";root:ExportForDataBase:RawSpectraDiff_"+sourceTempStr+";"
		Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"

		// peak width and shape
		wList = "root:ExportForDataBase:PeakShape_"+sourceTempStr+";root:ExportForDataBase:PW_parameters_"+sourceTempStr
		Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"

		// frag waves
		SetDataFolder root:HR_frag
		tempList = Wavelist("HR_frag_*", ";", "")
		SetDataFolder root:
		wList = ""		
		for(idex=0;idex<itemsinList(tempList);idex+=1)
			wList+="root:ExportForDataBase:"+stringfromList(idex,tempList, ";")+"_"+sourceTempStr+";"
		endfor
		Save/A/T/M="\r\n"/P=ExportDBPath/B wList as FileName+"_supp.itx"
	
		//ending code to display graphs
		Open/A/P=ExportDBPath fileId as FileName+"_supp.itx"
		EndingCode="X Display /W=(260,130,660,330) \r\n" 
		fprintf fileId, "%s", EndingCode
		for(idex=0;idex<num;idex+=1)		// go through each species in list
			species=stringFromList(idex, HRResults_ionList, ",")
			if ( !(stringmatch(species, "familyAir") || stringmatch(species, "familyHO")) )
				EndingCode="X AppendtoGraph UMRC_"+species+"_"+sourceTempStr+" vs amu_HR_"+sourceTempStr+" \r\n"
		//		if (strlen(speciesList)==0)
					EndingCode+="X ModifyGraph rgb(UMRC_"+species+"_"+sourceTempStr+")=("+sq_getColorString(ReplaceString("family", species, "" ), 2)+") \r\n"
	//			else
	//				EndingCode+="X ModifyGraph rgb(Closed_"+species+")=("+sq_getColorString(species, 3)+") \r\n"
	//			endif
				fprintf fileId, "%s", EndingCode
			endif
		endfor

		EndingCode="X ModifyGraph mode=1 \r\n"
		EndingCode+="X ModifyGraph toMode=3 \r\n"
		EndingCode+="X ModifyGraph lsize=2\r\n"
		EndingCode+="X Label bottom \"m/z\" \r\n"
		EndingCode+="X legend \r\n"		//1.49E

		EndingCode+="X Display /W=(260,130,660,330) \r\n" 
		EndingCode+="X AppendtoGraph RawSpectraClosed_"+sourceTempStr+" vs RawSpectraClosedMz_"+sourceTempStr+" \r\n"
		EndingCode+="X ModifyGraph rgb(RawSpectraClosed_"+sourceTempStr+")=(1,1,1) \r\n"
		EndingCode+="X AppendtoGraph RawSpectraDiff_"+sourceTempStr+" vs RawSpectraDiffMz_"+sourceTempStr+" \r\n"
		EndingCode+="X ModifyGraph rgb(RawSpectraDiff_"+sourceTempStr+")=(65280,0,0) \r\n"
		EndingCode+="X Label bottom \"m/z\" \r\n"
		EndingCode+="X legend \r\n"		//1.49E

		fprintf fileId, "%s", EndingCode
		Close fileID
	endif		
	
	PathInfo ExportDBPath
	
	print "// On  "+time() +" "+date()+" the file "+FileName+".itx "+selectstring(CreateSuppl, "","and supppliment file ")+"has been created for submission to the AMS data base at "+S_path
	
End


// creates average raw and stick, closed and diff spectra in anticipation of writing these waves to an igor text file.
Function PK_exportForDataBase() 

	svar todoStr=root:panel:sq_toDoWvNm

	nvar HR_checkUseAB = root:HR_panel:HR_checkUseAB
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkAskForSuffix=root:HR_panel:HR_checkAskForSuffix
	nvar HR_checkConvertNansTo0 = root:HR_panel:HR_checkConvertNansTo0
	nvar HR_checkConvertNegsTo0 = root:HR_panel:HR_checkConvertNegsTo0
	nvar HR_checkCalcHRErrors=root:HR_panel:HR_checkCalcHRErrors
//	nvar HRResults_dataType=root:HR_panel:HRResults_dataType
	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
//	nvar HRResults_ErrType=root:HR_panel:HRResults_ErrType
	nvar HR_checkAvgHRMS_UMR=root:HR_panel:HR_checkAvgHRMS_UMR

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar SourceStr =root:ExportForDataBase:SourceStr

	nvar CreateSuppl = root:ExportForDataBase:CreateSuppl	
	svar speciesList = root:ExportForDataBase:speciesList
 	
	wave/t HR_FinalPSNameWave = root:HR_PeakShape:HR_FinalPSNameWave

	wave HR_FinalPWInterceptWave = root:HR_PeakShape:HR_FinalPWInterceptWave		// we are only using this for the number of points.
	wave HR_FinalPWSlopeWave = root:HR_PeakShape:HR_FinalPWSlopeWave		// we are only using this for the number of points.
	wave HR_FinalPWPowerWave = root:HR_PeakShape:HR_FinalPWPowerWave		// we are only using this for the number of points.
	
	// an unhappy compromise for updating popmenus on the main squirrel panel - keep the old values!
	variable idex, numFam, numMasses, firstRun, pos
	variable old_HRResults_graphOutputType	// , old_HRResults_dataType
 	string spectraType, specTypeInitial, paramStrPartial, errorType, paramStr, tempList, sourceTempStr

	old_HRResults_graphOutputType=HRResults_graphOutputType
//	old_HRResults_dataType=HRResults_dataType
	
	wave todo =$"root:"+todoStr
	if (sq_OnlyOneModeInTodo(todo)!=1 )
		abort  "Cannot do mass averaging on a todo wave with different modes (v and w switching) - Aborting from sq_exportForDataBase"
	endif

 	if (!exists("root:diagnostics:corr_fact"))
 		abort "The standard methodology is to use the AB correction factor corr_fact, but this wave has not been created.  aborting from sq_exportForDataBase"
 	endif
 	
	wave/z/t myExactMassFamilyText = root:HR_Sticks:ExactMassFamilyText_FitTodo
	wave/z/t myExactMassText = root:HR_Sticks:ExactMassText_FitTodo
	wave/z myExactMassWave = root:HR_Sticks:ExactMassWave_FitTodo
	if (!waveExists(myExactMassFamilyText) || !waveExists(myExactMassFamilyText) || !waveExists(myExactMassFamilyText))
		wave/t myExactMassFamilyText = root:HR_Sticks:ExactMassFamilyText
		wave/t myExactMassText = root:HR_Sticks:ExactMassText
		wave myExactMassWave = root:HR_Sticks:ExactMassWave
	endif

	if (FindDimLabel(root:index:squirrel_index, 2, "HROMinusCStick") >=0)
		spectraType="HROminusCStick"		// this will be the default - if users have only Diff data, we will need to bypass the abort statement below.
		specTypeInitial="M"/// m for Open minus closed
		variable/g root:ExportForDataBase:HRStickType=1
	else
		spectraType="HRDiffStick"		// this will be the default - if users have only Diff data, we will need to bypass the abort statement below.
		specTypeInitial="D"/// m for Open minus closed
		variable/g root:ExportForDataBase:HRStickType=0
	endif

	if(FindDimlabel(root:index:squirrel_index,2,spectraType)<0)		//1.11B change
		abort "The data set HR"+spectraType+"Stick not found.  Perhaps you need to fit HR sticks?  - Aborting from HR_butt_MS_Calc"
	endif

	numMasses = numpnts(myExactMassWave)
	
	sourceTempStr = SourceStr[0, min(9, strlen(SourceStr)-1)]

//	if (strlen(speciesList)>0)
//		DoAlert 2, "It is recommended to leave the species list blank for HR spectra, so that all fitted ions are included.  Press Yes to continue with only "+speciesList+", No to use all fitted ions, Cancel to abort"
//		if (V_flag==2)	
			speciesList=""
			HR_butt_setResultsList("HRResults_butt_clearList")
			HR_butt_setResultsList("HRResults_butt_setListHRfams")
//		elseif(V_flag==3)
//			Abort "The user chose to abort."
//		else
//			speciesList = ReplaceString(" ", speciesList, ""  )
//			HRResults_ionList=speciesList
//		endif
//	endif

	numFam = itemsinList(HRResults_ionList, ",")
		
//  	HRResults_ionList =speciesList	
	HRResults_graphOutputType =5		// do nothing
	HR_checkConvertTougm3 = 1
	HR_checkUseAB = 1	
	HR_checkCalcHRErrors = 0	
	HR_checkAskForSuffix = 0
	HR_checkConvertNansTo0 = 0
	HR_checkConvertNegsTo0 = 0
	HR_checkAvgHRMS_UMR = 1

	paramStrPartial=""
	paramStrPartial+="nanTo0_flag:"+num2str(HR_checkConvertNansTo0)+";"
	paramStrPartial+="negTo0_flag:"+num2str(HR_checkConvertNegsTo0)+";"		//bug! forgot the :  1.09D fix
	paramStrPartial+="corr_op:"+num2str(HR_checkUseAB)+";"
	paramStrPartial+="ug_op:"+num2str(HR_checkConvertTougm3)+";"	
	
 	// Open minus closed or diff
	// creates waves such as UMRM_todo_familySO
	HR_checkAvgHRMS_UMR = 1
	HR_CalcPlot_MSAvg(sourceTempStr, "", spectraType, specTypeInitial, paramStrPartial, "")		
	// put results in the ExportForDataBase data folder
	for(idex=0;idex<numFam;idex+=1)
		wave UMRM_todo_wave = $"root:UMR"+specTypeInitial+"_"+sourceTempStr+"_"+stringfromList(idex,HRResults_ionList, ",")		//UMRD_todo_familyCHOgt1
		duplicate/o UMRM_todo_wave $"root:ExportForDataBase:UMR"+specTypeInitial+"_"+stringfromList(idex,HRResults_ionList, ",")+"_"+sourceTempStr
	endfor
	wave amu_HR = root:HR_Sticks:amu_HR
	duplicate/o amu_HR $"root:ExportForDataBase:amu_HR_"+sourceTempStr

	// creates waves  MSSM_todo_familyCHOgt1, etc.	
	HR_checkAvgHRMS_UMR = 0
	HR_CalcPlot_MSAvg(sourceTempStr, "", spectraType, specTypeInitial, paramStrPartial, "")		
//	if (strlen(speciesList)==0)		// all families
		// to keep things simple we want to add the different ions to gether to get One Sticks wave and One family designation wave	
		make/o/n=(numMasses) $"root:ExportForDataBase:HR"+specTypeInitial+"_"+sourceTempStr/wave=HR_Stick
		fastop HR_Stick = (0)
		for(idex=0;idex<numFam;idex+=1)
			wave HR = $"MSS"+specTypeInitial+"_"+sourceTempStr+"_"+stringfromList(idex,HRResults_ionList, ",")
			HR_Stick+=HR
		endfor
//	else
//		for(idex=0;idex<numFam;idex+=1)
//			wave HR = $"MSS"+specTypeInitial+"_"+todoStr+"_"+stringfromList(idex,HRResults_ionList, ",")
//			duplicate/o HR  $"root:ExportForDataBase:HR"+spectraType+"_"+stringfromList(idex,HRResults_ionList, ",")
//		endfor
//	endif
		
	if (CreateSuppl)
	
		 sq_exportDBDAQInfo()	//  creates root:ExportForDataBase:ParVal, root:ExportForDataBase:ParValText etc		

		// First do closed HR sticks, HR and summed to unit res
//	 	HRResults_dataType=3		// Closed
		// creates waves such as UMRC_todo_familySO
		HR_checkAvgHRMS_UMR = 1
		HR_CalcPlot_MSAvg(sourceTempStr, "", "HRClosedStick", "C", paramStrPartial, "")		
		for(idex=0;idex<numFam;idex+=1)
			wave UMRM_todo_wave = $"root:UMRC_"+sourceTempStr+"_"+stringfromList(idex,HRResults_ionList, ",")		//UMRD_hjkh_familyCHOgt1
			duplicate/o UMRM_todo_wave $"root:ExportForDataBase:UMRC_"+stringfromList(idex,HRResults_ionList, ",")+"_"+sourceTempStr
		endfor
	
		// create waves  MSSC_todo_familyCHOgt1, etc.	
		HR_checkAvgHRMS_UMR = 0
		HR_CalcPlot_MSAvg(sourceTempStr, "", "HRClosedStick", "C", paramStrPartial, "")		
//		if (strlen(speciesList)==0)		// all families
			make/o/n=(numMasses) $"root:ExportForDataBase:HRC_"+sourceTempStr=0
			wave HRC_Stick = $"root:ExportForDataBase:HRC_"+sourceTempStr
			for(idex=0;idex<numFam;idex+=1)
				wave HR = $"MSSC_"+sourceTempStr+"_"+stringfromList(idex,HRResults_ionList, ",")
				HRC_Stick+=HR
			endfor
//		else
//			for(idex=0;idex<numFam;idex+=1)
//				wave HRC = $"MSSC_"+todoStr+"_"+stringfromList(idex,HRResults_ionList, ",")
//				duplicate/o HR  $"root:ExportForDataBase:HRC_"+stringfromList(idex,HRResults_ionList, ",")
//			endfor
//		endif
				
		// peak width and shape
		firstRun=todo[0]
		pos = sq_findRun(root:index:rn_series, firstRun)
		wave PeakShapeWave = $"root:HR_PeakShape:"+HR_FinalPSNameWave[pos]
		duplicate/o PeakShapeWave $"root:ExportForDataBase:PeakShape_"+sourceTempStr
		make/o $"root:ExportForDataBase:PW_parameters_"+sourceTempStr/Wave=PW_parameters
		PW_parameters ={HR_FinalPWInterceptWave[pos], HR_FinalPWSlopeWave[pos], HR_FinalPWPowerWave[pos]}

		// raw spectra waves
		sq_exportForDBRawSpectra() 
		
		// frag waves
		SetDataFolder root:HR_frag
		tempList = Wavelist("HR_frag_*", ";", "")
		SetDataFolder root:
		for(idex=0;idex<itemsinList(tempList);idex+=1)
			wave HR_frag = $"root:HR_Frag:"+stringfromList(idex,tempList, ";")
			duplicate/o HR_frag $"root:ExportForDataBase:"+stringfromList(idex,tempList, ";")+"_"+sourceTempStr
		endfor
		
	endif

	duplicate/o myExactMassFamilyText $"root:ExportForDataBase:ExactMassFamilyText_"+sourceTempStr
	duplicate/o myExactMassText $"root:ExportForDataBase:ExactMassText_"+sourceTempStr
	duplicate/o myExactMassWave $"root:ExportForDataBase:ExactMassWave_"+sourceTempStr

	HRResults_graphOutputType=old_HRResults_graphOutputType
//	HRResults_dataType=old_HRResults_dataType
	
End


Function PK_butt_ExportExactMassAll(ctrlName) : ButtonControl
	String ctrlName

	string HRList 
	HRlist ="root:HR:ExactMassText_All;root:HR:ExactMassTag_All;root:HR:ExactMassWave_All;root:HR:ExactMassComments;"
	HRlist +="root:HR:Mask_Isotope_Reference;root:HR:Mask_Isotope_abundance;root:HR:Mask_Stick_Integration;root:HR:Mask_stick_integration_default"

	Save/O/T/B HRlist  // Let the user decide the location and name of this file.
			
End


//1.09H  1.16H
// Changed the functionality so that it checks all spectra types and also puts bad runs in a table.
//Function HR_butt_HRFitFailTodo(ctrlName) : ButtonControl
//	String ctrlName

//	nvar HR_FitFailClosed = root:HR_panel:HR_FitFailClosed
// 	nvar HR_FitFailOpen = root:HR_panel:HR_FitFailOpen
//	nvar HR_FitFailDiff = root:HR_panel:HR_FitFailDiff
//	nvar HR_CalcManyRunsOpenClosed = root:HR_panel:HR_CalcManyRunsOpenClosed		//1.14M
//	wave/z UnitMass_FitTodo =root:HR_Sticks:UnitMass_FitTodo
//	wave squirrel_index =root:index:squirrel_index
//	wave series_index =root:index:series_index
//	wave rn_series =root:index:rn_series
//	wave t_series =root:index:t_series
//

//	if (!waveexists(UnitMass_FitTodo))
//		abort "You must first perform an HR fit on a todo wave - aborting from HR_butt_HRFitFailTodo"
//	endif
//

//	string Suffix, suffixList, initial, resultStr, BadFitTableStr, printStr=""
//	variable mzstart, mzStop, numrun, idex, kdex,dataSetPos, num, numMz, jdex,numBadRuns,failFlag
//

//	svar todoStr=root:panel:sq_toDoWvNm		//^ 1.35 change
//	setDataFolder root:  //1.08E
//	wave/z todo=$(todoStr)
//	numrun = numpnts(todo)
//

//	if ( !waveexists(todo)  || numpnts(todo)==0)	//^
//		Abort " Either the todo wave was not found or was of zero length - Aborting from HR_butt_HRFitFailTodo"
//	endif	
//
////	if (HR_CalcManyRunsOpenClosed)		// 1.09H


////		suffixList="Open;Closed;Diff"
////	else
//		SuffixList="Diff"
////	endif
//
//	for(kdex=0;kdex<itemsInList(SuffixList);kdex+=1)
//		suffix=stringFromList(kdex, SuffixList)
//	
//		initial=suffix[0]
//		resultStr="HR_FitFail"+initial+"_d"
//		wave/z failwave_d = $resultStr
//		killwaves/z failwave_d
//		wave/z failwave_d = $resultStr
//		if (WaveExists(failwave_d))
//			abort "You must kill the wave "+resultStr+" before continuing - aborting from HR_butt_HRFitFailTodo"
//		endif
//		
//		dataSetPos=FindDimLabel(squirrel_index,2, "HR_FitFail"+initial)
//		if (dataSetPos<0)
//			abort "Could not find the data set "+resultStr+" aborting from HR_butt_HRFitFailTodo"
//		endif
//		make/o/n=(dimsize(squirrel_index,0)) index_pos_temp	
//		sq_makeMaskFromTodofindRun(index_pos_temp,todo)
//		index_pos_temp*=series_index
//		gen_RemoveNaNs(index_pos_temp)
//		num = numpnts(index_pos_temp)
//			if (num != numrun) 
//			print "// The data set "+resultStr+" does not exist for every run in the todo wave. "+num2str(numrun - num)+" runs do not have data. "
//		endif		
//
//		// get data set
//		squirrel_fetch(todo,sq_dump2memory,"dest:"+resultStr,"HR_FitFail"+initial)
//		wave/z failwave_d = $resultStr	// should have index_pos_temp rows
//		Wavestats/q/m=1 failwave_d
//		numMz=dimsize(failwave_d,1)
//		
//		Make/d/o/n=(0) $"BadFitRun_"+suffix,$"BadFitTime_"+suffix
//		Make/t/o/n=(0) $"BadFitMz_"+suffix
//		wave BadFitRun = $"BadFitRun_"+suffix
//		wave BadFitTime = $"BadFitTime_"+suffix
//		wave/t BadFitMz = $"BadFitMz_"+suffix
//		numBadRuns=0
//		
//		for(idex=0;idex<num;idex+=1)		
//			failFlag=0
//			for(jdex=0;jdex<numMz;jdex+=1)
//				if (failwave_d[idex][jdex]==1)
//					if(failFlag==0)
//						insertpoints numBadRuns, 1, BadFitMz, BadFitRun,BadFitTime
//						BadFitRun[numBadRuns] = rn_series[index_pos_temp[idex]]
//						BadFitTime[numBadRuns] = t_series[index_pos_temp[idex]]
//					endif
//					BadFitMz[numBadRuns]+=num2str(jdex+UnitMass_FitTodo[0])+";"
//					failFlag=1
//				endif
//				
//			endfor
//			if (failflag)
//				numBadRuns+=1
//			endif
//		endfor
//				
//		if (numBadRuns>=1)
//			HR_displayHRFailWins(suffix)
//			printStr+=suffix
//		else
//			Killwaves/z BadFitRun, BadFitTime, BadFitMz
//		endif
//	endfor
//	killwaves/z index_pos_temp
//	if (strlen(printStr)==0)
//		DoAlert 0, "There were no mzs for which the pika fit did not converge for todo wave "+todoStr
//	endif
//End


//1.09H
Function HR_displayHRFailWins(suffix)
string suffix

	string initial = suffix[0]
	wave failwave_d= $"HR_FitFail"+initial+"_d"
	wave BadFitRun = $"BadFitRun_"+suffix
	wave BadFitTime = $"BadFitTime_"+suffix
	wave/t BadFitMz = $"BadFitMz_"+suffix
	wave/z UnitMass_FitTodo =root:HR_Sticks:UnitMass_FitTodo

	DoWindow/F $"HRFitFailGr_"+suffix
	if (V_flag==0)
		Display/W=(175.75,50,520,260) as "HRFitFailGr_"+suffix
		AppendImage failwave_d
		ModifyImage $NameofWave(failwave_d) ctab= {0,1,Rainbow,0}
		SetAxis/A/R left
		ModifyGraph mirror=2
		Label left "m/z"
		Label bottom "run row number in todo"
		SetAxis/R left  UnitMass_FitTodo[0]-.5,  UnitMass_FitTodo[numpnts(UnitMass_FitTodo)-1]+.5
		SetAxis bottom dimsize(failwave_d,0)+.5,-0.5
		ShowInfo
		ModifyGraph swapXY=1
		TextBox/C/N=text0 "Successful fits are red.\rNumber of failed fits:"+num2str(sum(failwave_d))
	else
		TextBox/C/N=text0 "Successful fits are red.\rNumber of failed fits:"+num2str(sum(failwave_d))
	endif
	DoWindow/F $"HRFitTodoTable"+suffix
	if (V_flag==0)
		Edit/N=$"HRFitTodoTable"+suffix/W=(5,40,180,270) as "HRFitTodoTable"+suffix		//^ 1.08E
		AppendTotable BadFitRun, BadFitTime, BadFitMz
		ModifyTable format(BadFitTime)=8
	endif

End


// returns the mass of a value
Function PK_FindMassFromFormula(HRIonText)
string HRIonText

	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass
	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText

	NewHRIonQueryText=HRIonText
	make/t/o/n=1/FREE PossibleHRIonText = NewHRIonQueryText, inVorWnameTemp
	make/o/n=1/FREE resultMassTemp, multiChargedTemp

	pk_recalc_IonMasses(PossibleHRIonText, resultMassTemp, multiChargedtemp, inVorWnameTemp)

	NewHRIonQueryMass = resultMassTemp[0]

	killwaves/z  resultMassTemp, multiChargedtemp, inVorWnameTemp, exactMassDiff, PossibleHRIonText

	return NewHRIonQueryMass

End


//1.08E  modified in 1.09C
Function HR_butt_massCheckAllIons(ctrlName) : ButtonControl
	String ctrlName

	nvar HRIonCheckAllMassLimit= root:HR_panel:HRIonCheckAllMassLimit
	wave/t ExactMassText_All = root:HR:ExactMassText_All	
	wave/d ExactMassWave_All = root:HR:ExactMassWave_All	

	variable idex, num, countProbs
	string str
	
	num = numpnts(ExactMassWave_All)

	make/o/n=(num)/T inVorWnameTemp
	make/d/o/n=(num) resultMassTemp, multiChargedtemp, exactMassDiffTemp

	pk_recalc_IonMasses(ExactMassText_All, resultMassTemp, multiChargedtemp, inVorWnameTemp)
	
	exactMassDiffTemp = abs(ExactMassWave_All - resultMassTemp)

	make/t/o/n=0 root:HR_panel:ProbMassText/Wave=ProbMassText
	make/o/n=0/d root:HR_panel:ProbMassCalc/Wave=ProbMassCalc
	make/o/n=0 root:HR_panel:ProbMassAllWave/Wave=ProbMassAllWave
	make/o/n=0/d root:HR_panel:ProbMassDiff/Wave=ProbMassDiff
	make/o/n=0 root:HR_panel:ProbMassIndex/Wave=ProbMassIndex

	countProbs=0

	for (idex=0;idex<num;idex+=1)
		if (exactMassDiffTemp[idex]>HRIonCheckAllMassLimit)
			insertpoints countProbs, 1, ProbMassText,ProbMassCalc,ProbMassAllWave,ProbMassDiff,ProbMassIndex
			ProbMassText[countProbs] = ExactMassText_All[idex]
			ProbMassCalc[countProbs] = resultMassTemp[idex]
			ProbMassAllWave[countProbs] = ExactMassWave_All[idex]
			ProbMassDiff[countProbs] = exactMassDiffTemp[idex]
			ProbMassIndex[countProbs] = idex
			countProbs+=1
		endif	
	endfor
	
	killwaves/z  resultMassTemp, multiChargedtemp, inVorWnameTemp, exactMassDiffTemp
	
	if (countProbs==0)
		sprintf str, "%1.2e",HRIonCheckAllMassLimit
		DoAlert 0, "Did not find any problems with mass values  within "+str
	endif
	
End


Function HR_butt_FindIsoDiscrepancy(ctrlName) : ButtonControl
	String ctrlName

	nvar HRIsoAbundanceDiffLimit = root:HR_panel:HRIsoAbundanceDiffLimit
	
	wave/t ExactMassText_All = root:HR:ExactMassText_All
	wave/d ExactMassWave_All = root:HR:ExactMassWave_All
	wave/t ExactMassComments = root:HR:ExactMassComments
	wave Mask_Stick_integration = root:HR:Mask_Stick_integration
	wave Mask_Stick_Integration_Default = root:HR:Mask_Stick_Integration_Default
	wave/t Mask_Isotope_reference = root:HR:Mask_Isotope_reference
	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance

	variable idex, num, isotopeAbund, countProbs, CalcAbund, AllWaveAbund
	string HRIonStr, AllwaveParent, CalcParent
	
	countProbs=0
	make/t/o/n=0 root:HR_panel:ProbIsotopeText/Wave=ProbIsotopeText
	make/t/o/n=0 root:HR_panel:ProbIsotopeCalcParent/Wave=ProbIsotopeCalcParent
	make/t/o/n=0 root:HR_panel:ProbIsotopeAllwaveParent/Wave=ProbIsotopeAllwaveParent
	make/o/n=0 root:HR_panel:ProbIsotopeMass/Wave=ProbIsotopeMass
	make/o/n=0 root:HR_panel:ProbIsotopeCalcAbund/Wave=ProbIsotopeCalcAbund
	make/o/n=0 root:HR_panel:ProbIsotopeAllWaveAbund/Wave=ProbIsotopeAllWaveAbund
	make/o/n=0 root:HR_panel:ProbIsotopeAllWaveIndex/Wave=ProbIsotopeAllWaveIndex

	num = numpnts(ExactMassText_All)
	for(idex=0;idex<num;idex+=1)
		HRIonStr=ExactMassText_All[idex]
		if (strsearch(HRIonStr, "j", 0)>=0  && strsearch(HRIonStr, "plus", 0)<0)
			AllwaveParent = Mask_Isotope_reference[idex]
			AllWaveAbund = Mask_Isotope_abundance[idex]
			CalcParent = HR_findIsotopParent(HRIonStr)
			CalcAbund =HR_findIsotopAbund(HRIonStr)
			if (!stringMatch(AllwaveParent, CalcParent) || abs(CalcAbund-AllWaveAbund)> HRIsoAbundanceDiffLimit )
				insertpoints countProbs, 1, ProbIsotopeText,ProbIsotopeCalcParent,ProbIsotopeAllwaveParent,ProbIsotopeMass,ProbIsotopeCalcAbund,ProbIsotopeAllWaveAbund, ProbIsotopeAllWaveIndex
				ProbIsotopeText[countProbs] = HRIonStr
				ProbIsotopeCalcParent[countProbs] = CalcParent
				ProbIsotopeAllwaveParent[countProbs] = AllwaveParent
				ProbIsotopeMass[countProbs] = ExactMassWave_All[idex]
				ProbIsotopeCalcAbund[countProbs] = CalcAbund
				ProbIsotopeAllWaveAbund[countProbs] = AllWaveAbund
				ProbIsotopeAllWaveIndex[countProbs] = idex
				countProbs+=1
			endif
		endif
	endfor

	killwaves/z  ParentElementCountWave,  ParentHRnameElementOrder, ParentHRnameElementOrderIndex, ProbIsotopeAllWaveAbund
	
	if (countProbs==0)
		sprintf HRIonStr, "%1.2e",HRIsoAbundanceDiffLimit
		DoAlert 0, "Did not find any problems with isotopes within "+HRIonStr
	endif
	
End


// new in 1.09 x
Function HR_populate_ProblemIsoTable() 
	PauseUpdate; Silent 1		// building window...

	wave/z ProbIsotopeText = root:HR_panel:ProbIsotopeText
	if (!WaveExists(ProbIsotopeText))
		make/t/o/n=0 root:HR_panel:ProbIsotopeText
		make/t/o/n=0 root:HR_panel:ProbIsotopeCalcParent
		make/t/o/n=0 root:HR_panel:ProbIsotopeAllwaveParent
		make/o/n=0 root:HR_panel:ProbIsotopeMass
		make/o/n=0 root:HR_panel:ProbIsotopeCalcAbund
		make/o/n=0 root:HR_panel:ProbIsotopeAllWaveAbund
		make/o/n=0 root:HR_panel:ProbIsotopeAllWaveIndex
		wave/z ProbIsotopeText = root:HR_panel:ProbIsotopeText		// needed because code references it  below
	endif
		make/o/n=0 root:HR_panel:ProbIsotopeAllWaveIndex
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_panel:
	wave ProbIsotopeText,ProbIsotopeCalcParent,ProbIsotopeAllwaveParent
	wave ProbIsotopeMass,ProbIsotopeCalcAbund,ProbIsotopeAllWaveAbund, ProbIsotopeAllWaveIndex
	
	AppendToTable ProbIsotopeText,ProbIsotopeCalcParent,ProbIsotopeAllwaveParent
	AppendToTable ProbIsotopeMass,ProbIsotopeCalcAbund,ProbIsotopeAllWaveAbund, ProbIsotopeAllWaveIndex
	ModifyTable format(Point)=1,width(Point)=36,width(ProbIsotopeText)=75,title(ProbIsotopeText)="HR ion"
	ModifyTable width(ProbIsotopeCalcParent)=68,title(ProbIsotopeCalcParent)="calc. parent"
	ModifyTable width(ProbIsotopeAllwaveParent)=66,title(ProbIsotopeAllwaveParent)="'All' wave parent"
	ModifyTable format(ProbIsotopeMass)=3,digits(ProbIsotopeMass)=6,width(ProbIsotopeMass)=80
	ModifyTable title(ProbIsotopeMass)="Mass",format(ProbIsotopeCalcAbund)=3,digits(ProbIsotopeCalcAbund)=6
	SetDataFolder fldrSav0

End


Function HR_populate_conflictTable()

	PauseUpdate; Silent 1		// building window...
	
	wave/z ProbMassIndex=  root:HR_panel:ProbMassIndex
	if (!WaveExists(ProbMassIndex))
		make/t/o/n=0 root:HR_panel:ProbMassText/Wave=ProbMassText
		make/o/n=0 root:HR_panel:ProbMassCalc/Wave=ProbMassCalc
		make/o/n=0 root:HR_panel:ProbMassAllWave/Wave=ProbMassAllWave
		make/o/n=0 root:HR_panel:ProbMassDiff/Wave=ProbMassDiff
		make/o/n=0 root:HR_panel:ProbMassIndex/Wave=ProbMassIndex
		wave/z ProbMassIndex=  root:HR_panel:ProbMassIndex
	endif
	
	String fldrSav0= GetDataFolder(1)	
	SetDataFolder root:HR_panel:
	AppendToTable ProbMassText, ProbMassDiff,ProbMassAllWave,ProbMassCalc,ProbMassIndex
	ModifyTable format(Point)=1,width(Point)=39,title(ProbMassText)="HR Ion",title(ProbMassIndex)="point number"
	ModifyTable format(ProbMassAllWave)=3,digits(ProbMassAllWave)=6,title(ProbMassAllWave)="'All' wave mass"
	ModifyTable format(ProbMassCalc)=3,digits(ProbMassCalc)=6,title(ProbMassCalc)="calc. mass"
	ModifyTable title(ProbMassDiff)="mass difference"
	SetDataFolder fldrSav0
End


//1.08F
Function HR_butt_IonMassCalculator(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F HRIonMassCalculator
	if (V_flag)
		return 0
	endif
	HR_MassCalcGlobals()
	HR_HRIonMassCalculator() 

	nvar QueryTypeRRX = root:HR_Panel:QueryTypeRRX
	QueryTypeRRX=0
	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	NewHRIonQueryFindExists = 1
	NewHRIonQueryFindChildChosen = 1
	  
	HR_MassCalcQueryHRionTab("",0)
	
End


Function HR_butt_TableHRIonsTodoFit(ctrlName) : ButtonControl
	String ctrlName

	svar sq_toDoWvNm = root:panel:sq_toDoWvNm		//1.08G
	string HRtodoFolder, fromString1, fromString2

	svar sq_toDoWvNm = root:panel:sq_toDoWvNm		//1.08G

	ControlInfo /w=HR_analysis_Panel HRResults_pop_dataSet 
	string currentDataSetStr = S_value
	variable MSorPToFFlag = stringMatch(S_value[0,1],"HR") // 1 is MS
	string TableName = "HRIonsMS_"+sq_toDoWvNm
	if (MSorPToFFlag)// MS
		TableName="HRIonsMS"+"_"+sq_toDoWvNm	
	else		// PToF
		TableName="HRIons"+currentDataSetStr+"_"+sq_toDoWvNm
	endif
	TableName = CleanUpName(TableName, 0)
	
	DoWindow/F $TableName
	if (V_flag) 
		return 0
	endif
	
	wave/z HRstick_series = root:index:HRstick_series	// this is really a flag for version 1.08G or higher
	if (WaveExists(HRstick_series))	
		HRtodoFolder = PK_FindHRResultsWavesFitTodo()
	
		fromString1 = "root:HR_sticks:"+HRtodoFolder+":"
		fromString2 = "root:HR_sticks:"+HRtodoFolder+":"
		
		wave ExactMassText_FitTodo = $fromString1+"ExactMassText_FitTodo"	
		wave ExactMassWave_FitTodo = $fromString1+"ExactMassWave_FitTodo"	
		wave ExactMassIsotopeRef_FitTodo = $fromString1+"ExactMassIsotopeRef_FitTodo"		// not sure if these are needed, but we do them here
		wave ExactMassIsotopeAbund_FitTodo = $fromString1+"ExactMassIsotopeAbund_FitTodo"
		wave/t ExactMassFamilyText_FitTodo = root:HR_sticks:ExactMassFamilyText_FitTodo
	else		// pre 1.08G
		wave ExactMassText_FitTodo = root:HR_Sticks:ExactMassText
		wave ExactMassWave_FitTodo = root:HR_Sticks:ExactMassWave
		wave ExactMassIsotopeRef_FitTodo = root:HR_Sticks:ExactMassIsotopeRef	// not sure if these are needed, but we do them here
		wave ExactMassIsotopeAbund_FitTodo = root:HR_Sticks:ExactMassIsotopeAbund
		wave/t ExactMassFamilyText_FitTodo = root:HR_Sticks:ExactMassFamilyText	
	endif
	
	UM_GenerateAxByMaskWaves(ExactMassText_FitTodo, "_FitTodo")
		
	if (strlen(ctrlName)==0)
		return 0		// don't create table
	endif
	
	edit/N=$(TableName) as TableName		//1.14I  moved from start of function

	AppendtoTable ExactMassText_FitTodo, ExactMassWave_FitTodo, ExactMassIsotopeRef_FitTodo, ExactMassIsotopeAbund_FitTodo, ExactMassFamilyText_FitTodo

	wave/t HR_familyName = root:HR:HR_familyName
	variable kdex, numFamily
	
	numFamily = numpnts(HR_familyName)

	// family identifiers
	for (kdex = 0;kdex<numFamily;kdex+=1)	// go through all the families to find its match
		if (WaveExists(HRstick_series))
			wave/z ThisFamily = $fromString2+"mask_"+HR_familyName[kdex]+"_FitTodo"		
		else	// pre 1.08G
			wave/z ThisFamily = $"root:Int_Sticks:mask_"+HR_familyName[kdex]	
		endif
		if (WaveExists(ThisFamily))
			AppendtoTable ThisFamily
		endif
	endfor		

	// parts needed for UMR summing of HR sticks
	if (WaveExists(HRstick_series))
		wave MassStartPnt_FitTodo = $fromString1+"MassStartPnt_FitTodo"	
		wave MassEndPnt_FitTodo = $fromString1+"MassEndPnt_FitTodo"	
		wave UnitMass_FitTodo = $fromString1+"UnitMass_FitTodo"		// not sure if these are needed, but we do them here
		wave numOfPeaks_FitTodo = $fromString1+"numOfPeaks_FitTodo"
	else		// pre 1.08G
		wave MassStartPnt_FitTodo =root:HR_Sticks:MassStartPnt	
		wave MassEndPnt_FitTodo = root:HR_Sticks:MassEndPnt	
		wave UnitMass_FitTodo = root:HR_Sticks:UnitMass		// not sure if these are needed, but we do them here
		wave numOfPeaks_FitTodo = root:HR_Sticks:numOfPeaks
	
	endif
	AppendtoTable MassStartPnt_FitTodo, MassEndPnt_FitTodo, UnitMass_FitTodo, numOfPeaks_FitTodo

End


//1.08G
Function HR_butt_HRSpeciesFitTodoTable(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F HRIonsSpeciesTable
	if (V_flag) 
		return 0
	endif

	PK_WavesForHRResults()		// copies waves to their place in HR_Sticks folder 		//  changed in 1.10C to now also recalculate family designations

	svar HRresults_ionList = root:HR_panel:HRresults_ionList
	
	HR_smartConvertFrags("HROrg", 0)		// considert HROrg to be the default... really it could be any HR species
//	HR_generateFinalFrags()
	
	// this is tricky.  The species waves are reinterpreted every time because the HR frag waves may change every time
	wave/t SpeciesMassText = root:HR_frag:SpeciesMassText
	wave SpeciesMassWave = root:HR_frag:SpeciesMassWave
	wave/t SpeciesFamilyText = root:HR_frag:SpeciesFamilyText
	
	edit/N=HRIonsSpeciesTable as "HRIonsSpeciesTable"

	AppendtoTable SpeciesMassText, SpeciesMassWave, SpeciesFamilyText

End


// generate 2 strings: exceptionFamilyList, exceptionMassList
//new in 1.09A
Function/S HR_GenerateFamilyExceptionLists()

	variable idex, numFamily, exceptionWaveNum, kdex, tempVar, exceptionFlag, posO, numAfterElement, charPos //1.07D
	string fragment, exceptionWaveList, exceptionStr, str1, str2, wStr
	variable tempNum, totalNumExceptions=0

	wave/t HR_familyName = root:HR:HR_familyName		//1.02A
	wave/z/t HR_familyListDefinition = root:HR:HR_familyListDefinition		//1.02A

	numFamily = numpnts(HR_familyName)

//	string/g root:HR_sticks:exceptionMassList=""
//	string/g root:HR_sticks:exceptionFamilyList=""
//	svar exceptionFamilyList = root:HR_sticks:exceptionFamilyList
//	svar exceptionMassList = root:HR_sticks:exceptionMassList
	string exceptionMassList=""
	string exceptionFamilyList=""
	
	exceptionWaveList=""
	exceptionWaveNum=0
	for (idex = 0;idex<numFamily;idex+=1)
		if (WhichListItem(HR_familyName[idex], ION_FAMILY_LIST)<0)
			exceptionWaveList +=num2str(idex)+";"
			exceptionWaveNum+=1
		endif
	endfor
			
	for (kdex=0;kdex<numFamily;kdex+=1)
		exceptionStr = HR_familyListDefinition[kdex]
		exceptionStr=RemoveFromList("default",exceptionStr,  ";", 0)
		if (stringmatch(exceptionStr[0,strlen("familyWave_")-1], "familyWave_"))
			wave/z/t HRionwave = $"root:HR:"+exceptionStr
			if (WaveExists(HRionwave))
				exceptionStr = sq_textwave2List(HRionwave)
			else
				wStr=""
			endif
		else 
			wStr=""
		endif
		
		 if (strlen(exceptionStr)>0 && !stringmatch(exceptionStr, "*;"))		// kinda suggested by Mike C. 1.07C
            		exceptionStr += ";"
       	endif
		tempNum = ItemsInList(exceptionStr)
		exceptionMassList += exceptionStr
		for(idex=0;idex<tempNum;idex+=1)
			exceptionFamilyList +=  num2str(kdex)+";"
		endfor
		totalNumExceptions+=tempNum
	endfor
	
	return exceptionMassList+"/"+exceptionFamilyList

End

//new in 1.09A
// for a given fragment, return the family the algorithm wants to put it in
// consolidated with pk_FindFamilyFroHRIon in 1.16N
//Function/s HR_returnGrouping(ChemFragment, exceptionFamilyList, exceptionMassList)
//string chemFragment, exceptionFamilyList, exceptionMassList
//	
//	variable idex, numFamily, numExactMasses, iPnt, exceptionWaveNum, kdex, tempVar, exceptionFlag, posO, numAfterElement, charPos //1.07D
//	string str1, str2
//	string GrpStr
//	variable tempNum
//
//	wave/t HR_familyName = root:HR:HR_familyName
//	
//	exceptionFlag=0
//	// first check to see if it is any of our execeptions
//
//	GrpStr=""
//	
//	kdex = WhichListItem(chemFragment,exceptionFamilyList)
//	if (kdex>=0)
//		tempNum = str2num(stringFromList(kdex, exceptionMassList))
//		return HR_familyName[tempNum]
//	endif
//	
//	// this fragment was not listed individually in any of the entries in the family table.  We need to parse by formula
//	// Check Cl first, before checking for organic, C
//	if(strsearch(ChemFragment, "Cl", 0) !=-1)
//		GrpStr="Cl"
//	elseif(strsearch(Chemfragment, "Cr", 0) !=-1 || strsearch(Chemfragment, "Cu", 0) !=-1)	
//		GrpStr="Other"
//	
//	// does it have C, a real Carbon
//	elseif(strsearch(Chemfragment, "C", 0) != -1)
//		if(strsearch(Chemfragment, "S", 0) != -1 && strsearch(ChemFragment, "Si", 0) == -1)		// update in 1.04P
//			GrpStr="CS"
//		else		// no S
//			if(strsearch(Chemfragment, "O", 0) != -1)		// there is a CO, not check if there is an N
//
//				// find out how many Os we have.  
//				// Does NOT work for when we have one O and one O isotope in same fragment, nor with the plus2 fragments such as CO2plus2
//				splitstring/E="(O)(\\d{1,9})" ChemFragment, str1, str2	
//				if (strlen(str2) ==0) //we do not have numbers after the letter
//					numAfterElement = 1
//				else
//					numAfterElement = 0
//				endif
//					
//				if(strsearch(ChemFragment, "N", 0) != -1 && strsearch(ChemFragment, "Ni", 0) == -1)
//					if (numAfterElement)
//						GrpStr="CHO1N"
//					else
//						GrpStr="CHOgt1N"
//					endif						
//				else
//					if (numAfterElement)
//						GrpStr="CHO1"
//					else
//						GrpStr="CHOgt1"
//					endif						
//
//				endif
//			elseif (strsearch(Chemfragment, "N", 0) != -1 && strsearch(Chemfragment, "Ni", 0) == -1)		// doesn't have an O but has an N
//				GrpStr="CHN"
//			elseif(strsearch(Chemfragment, "H", 0) != -1)// no Hs either
//				GrpStr="CH"
//			else		// has a C but neither S nor N nor O
//				GrpStr="Cx"
//			endif
//		endif	// it has a C and an S
//	//  No Cblah or C, must be inorganic, air, other
//	else 
//		// check for O
//		if(strsearch(Chemfragment, "O", 0) != -1)
//			// There is an oxygem
//			if(strsearch(Chemfragment, "N", 0) !=-1 && strsearch(Chemfragment, "Ni", 0) == -1)
//				GrpStr="NO"
//			elseif (strsearch(Chemfragment, "S", 0) !=-1)
//				GrpStr="SO"
//			elseif (strsearch(Chemfragment, "H", 0) !=-1 || strsearch(Chemfragment, "D", 0) !=-1)
//				GrpStr="HO"
//			elseif(strsearch(Chemfragment, "W", 0) !=-1 || strsearch(Chemfragment, "Al", 0) !=-1  )
//				GrpStr="Other"
//			else
//				GrpStr="Air"
//			endif
//		// check for N	
//		elseif (strsearch(Chemfragment, "N", 0) != -1 && strsearch(Chemfragment, "Ni", 0) == -1)
//			// there is a nitrogen
//			if(strsearch(Chemfragment, "H", 0) !=-1 || strsearch(Chemfragment, "D", 0) !=-1)
//				GrpStr="NH"
//			else
//				if (strsearch(Chemfragment, "Na", 0) != -1)
//					GrpStr="Other"
//				else
//					GrpStr="Air"
//				endif
//			endif
//		// check for S
//		elseif (strsearch(Chemfragment, "S", 0) !=-1)
//			charPos = strsearch(Chemfragment, "S", 0)		//1.07C
//			if (charPos>=0 && !grepstring(Chemfragment[charPos+1], "r|n|b|i|e|c")   )		// changed to include c for Sc in 1.04A
//				GrpStr="SO"
//			else
//				GrpStr="Other"							
//			endif
//		else // no Cblah, C, O, N, S
//			if(strsearch(Chemfragment, "Ar", 0) !=-1)
//				GrpStr="Air"			
//			else
//				GrpStr="Other"	
//			endif
//		endif
//	endif
//	
//	return GrpStr
//	
//End


//new in 1.09A
Function HR_CalcPlot_MSAvgSpeciesGrouped(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string tempStr
	tempStr = HR_Calc_MSAvgSpeciesGrouped(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType) 
	HR_plot_MSAvgSpeciesGrouped(tempStr, myPlotName)

End


//new in 1.09A
Function/s HR_Calc_MSAvgSpeciesGrouped(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	svar todoStr=root:panel:sq_toDoWvNm
	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra
	wave/z todo=$(todoStr)

	HR_checkAvgHRMS_UMR = 0

	string paramStr, specList, tempStr, nonHRSpec, HRSpec, nonHRSpecDestList, HRSpecDestList, timeWt, specStr
	variable idex, num
		
	paramStr=""	
	paramStrPartial+= "product_Type:2;"
		
	// do HRSpecs 
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)	// should contain one and only one species
	specStr=stringfromList(0, HRSpec, ",")
 	paramstr=""
 	HR_getParamStr(paramstr,specStr, 1, 0)		//1.06E
	specList=StringByKey("specList", paramstr) 	 	
	HRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_" +waveNameSuffix+"_")
	HRSpecDestList =  RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",HRSpecDestList, "/") 	

	paramStr+=paramStrPartial+"HRSpec_flag:1;"
	paramstr+="specList:"+specList + ";"
	paramstr+="destList:"+HRSpecDestList + ";"	

	squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";")
	wave SpeciesMassWave = root:HR_Frag:SpeciesMassWave	
	wave ExactStickWave = $stringFromList(idex, HRSpecDestList, "/")
	HRSpecDestList = UM_SumHRSpeciestoGroupsUMR(ExactStickWave, waveNameSuffix,specStr)		

	if (NormalizeSpectra)
		sq_NormalizeSpectra(HRSpecDestList)
	endif

	return HRSpecDestList
	
End


Function HR_plot_MSAvgSpeciesGrouped(destListHRSpec, NewPlotName)
string destListHRSpec, NewPlotName

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar NormalizeSpectra = root:HR_panel:NormalizeSpectra
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	
//	nvar HR_checkStacksticks = root:HR_panel:HR_checkStacksticks		//1.11G  //1.121B
	wave/z amu_HR = root:HR_Sticks:amu_HR			//1.08C
	wave/z SpeciesMassWave = root:HR_frag:SpeciesMassWave

	variable idex, numHR, numNonHR
	string legendStr		
	if(HRResults_graphOutputType!=4)

		// bring graph to front (for multiple graphs do nothing for now)
		if (HRResults_graphOutputType==3)
			DoWindow/F $NewPlotName
		endif
		
		numHR = ItemsInList(destListHRSpec)
		for(idex=0;idex<numHR;idex+=1)
			wave specitem=$stringFromList(idex, destListHRSpec, ";")
			if((HRResults_graphOutputType==1 && idex==0 && numNonHR==0) || HRResults_graphOutputType==2)
				display/N=$NewPlotName as NewPlotName
			endif
			Appendtograph/W=$NewPlotName specitem vs amu_HR
			ModifyGraph/W=$NewPlotName mode($NameofWave(specitem))=1
		endfor

		label/W=$NewPlotName bottom "m/z"
		if (HR_checkConvertTougm3)
			label/W=$NewPlotName left "Nitrate equivalent mass g/m3 *"
		else
			label/W=$NewPlotName left "Ion rate, Hz"
		endif
		
		legend/w=$NewPlotName/N=myLegend
		AppendText/w=$NewPlotName/N=myLegend  "normalized? "+selectstring(NormalizeSpectra, "N", "Y")
		
		Pk_graphTweaks()

		if (HR_checkAvgHRMS_UMR)
			ModifyGraph toMode=3		// add to next
		endif
	endif
	
End

// 1.09A
// given any stick wave, sum to the unit mass values
Function/s UM_SumHRSpeciestoGroupsUMR(ExactStickWave, waveNameSuffix,SpecStr)
wave ExactStickWave
string waveNameSuffix, SpecStr

	wave/t SpeciesMassText= root:HR_frag:SpeciesMassText
	wave SpeciesMassWave = root:HR_frag:SpeciesMassWave
	wave/z MassStartPnt_FitTodo = root:HR_Sticks:MassStartPnt_FitTodo
	wave/z MassEndPnt_FitTodo = root:HR_Sticks:MassEndPnt_FitTodo
	wave/z UnitMass_FitTodo = root:HR_Sticks:UnitMass_FitTodo	//1.08E
	if (!WaveExists(UnitMass_FitTodo) || !WaveExists(MassStartPnt_FitTodo) || !WaveExists(MassEndPnt_FitTodo))		// for the case of someone upgrading who has not yet done a fit for a todo wave
		wave UnitMass_FitTodo = root:HR_Sticks:UnitMass	//1.08E
		wave MassStartPnt_FitTodo = root:HR_Sticks:MassStartPnt	//1.08E
		wave MassEndPnt_FitTodo = root:HR_Sticks:MassEndPnt	//1.08E
	endif

	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra
	
	wave/t HR_familyName = root:HR:HR_familyName
	wave/t HR_specFamilyBase = root:HR_frag:HR_specFamilyBase		// for a given species, tells what families are in it by default
	wave/t HR_spec_list = root:HR_frag:HR_spec_list		// for a given species, tells what families are in it by default
	make/o/t/n=(numpnts(SpeciesMassWave)) root:HR_frag:SpeciesGroupText
	wave/t SpeciesGroupText = root:HR_frag:SpeciesGroupText
	string lists = HR_GenerateFamilyExceptionLists()
//	SpeciesGroupText=HR_returnGrouping(SpeciesMasstext[p], stringFromList(0, lists, "/"), stringFromList(1, lists, "/"))		//1.16N
	SpeciesGroupText=pk_FindFamilyFroHRIon(SpeciesMasstext[p], stringFromList(1, lists, "/"), stringFromList(0, lists, "/"), HR_familyName)
	
	variable firstMz = UnitMass_FitTodo[0]		// the first place we fit masses, typically 12
	variable lastMz = UnitMass_FitTodo[numpnts(UnitMass_FitTodo)-1]
	variable newRange = lastMz - firstMz+1
	
	variable idex, numFamily, HRspecPos
	string FamStr,displayList, HRSpecFamilyList
	
	HRspecPos=sq_TextIntextWave(SpecStr, HR_spec_list)
	HRSpecFamilyList = HR_specFamilyBase[HRspecPos]
	numFamily = numpnts(HR_familyName)
	displayList=""
	
	if (!strlen(waveNameSuffix)==0)
		waveNameSuffix="_"+waveNameSuffix
	endif
	
	make/o/n=(lastMz) root:HR_Sticks:amu_HR = p+1		// for use in plotting
	make/t/o/n=(lastMz) root:HR_Sticks:amu_HR_text = num2str(p+1)		// for use in plotting

	make/o/N=(lastMz) temp_MassStartPnt, temp_MassEndPnt
	wave MassStartPnt_FitTodo = temp_MassStartPnt
	wave MassEndPnt_FitTodo = temp_MassEndPnt
	MassStartPnt_FitTodo =binarysearch(SpeciesMassWave, firstMz+p - 0.5)+1
	MassEndPnt_FitTodo = binarysearch(SpeciesMassWave, firstMz+p + 0.5)
	MassEndPnt_FitTodo[newRange-1] = numpnts(SpeciesMassWave)-1		//1.03F

	duplicate/o ExactStickWave ExactStickWaveTemp
	for(idex=0;idex<numFamily;idex+=1)
		FamStr=HR_familyName[idex]
		make/o/n=(lastMz) $"UM"+SpecStr+"Grp_"+FamStr+waveNameSuffix
		wave GroupedUMRresultWave =  $"UM"+SpecStr+"Grp_"+FamStr+waveNameSuffix
		ExactStickWaveTemp=ExactStickWave*stringmatch(SpeciesGroupText[p], FamStr)
		GroupedUMRresultWave[0, firstMz-2]=0		// if the firstMz = 12,set masses 1 - 11, rows 0 - 10, to zero
		GroupedUMRresultWave[firstMz-1,lastMz-1] = MassEndPnt_fitTodo[p-(firstMz-1)] >= MassStartPnt_fitTodo[p-(firstMz-1)] ? sum(ExactStickWaveTemp, MassStartPnt_fitTodo[p-(firstMz-1)],MassEndPnt_fitTodo[p-(firstMz-1)]) : 0	
		if (Sum(GroupedUMRresultWave)==0 && FindListItem("family"+FamStr,HRSpecFamilyList)<0)	  //1.11E TimO	// if this family is in the definition of a species, keep it  1.09D
			killwaves/z GroupedUMRresultWave	
		else
			displayList+=NameofWave(GroupedUMRresultWave) + ";"
		endif
	endfor

	if (NormalizeSpectra)
		sq_NormalizeSpectra(displayList)
	endif
	
	killwaves/z temp_MassStartPnt, temp_MassEndPnt, ExactStickWaveTemp

	return displayList

End


// Added in 1.09D  DOug's 5 panel only with species
Function HR_CalcPlot_5PanelHRSpecies(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string tempStr
	tempStr = HR_Calc_5PanelHRSpecies(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial) 
	HR_Plot_5PanelHRSpecies(tempStr, myPlotName)
	
End


// Added in 1.09D  DOug's 5 panel only with species
Function/s HR_Calc_5PanelHRSpecies(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	svar todoStr=root:panel:sq_toDoWvNm
	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra

	wave/z todo=$(todoStr)

	HR_checkAvgHRMS_UMR = 0		// we first have to do it in HR , not UMR space for the family grouping

	string paramStr, specList, tempStr, HRSpec, nonHRSpecDestList, HRSpecDestList, specStr, HRSpecFamilyList, sumList
	variable idex, num, temp_normalizeSpectra
		
	temp_normalizeSpectra= NormalizeSpectra		// an inelegant solution to the issue that UM_SumHRSpeciestoGroupsUMR will want to normalize
	NormalizeSpectra=0
	
	HR_butt_setResultsList("HRResults_butt_setListAerHRfams")  // sets HRResults_ionList
	
	paramStr=""	
	paramStrPartial+= "product_Type:2;"
		
	// do HRSpecs 	
 	paramstr=""
  	specList=HRResults_ionList
  	HR_getParamStr(paramstr,specList, 1, 0)		//1.06E
	specList=StringByKey("specList", paramstr) 	 	
	HRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_" +waveNameSuffix+"_")
	HRSpecDestList =  RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",HRSpecDestList, "/") 	

	paramStr+=paramStrPartial+"HRSpec_flag:1;"
	paramstr+="specList:"+specList + ";"		//1.11E TimO
	paramstr+="destList:"+HRSpecDestList + ";"	

	squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType)

	HR_checkAvgHRMS_UMR=1		// we do the summing in unit mass space ourselves
	
	
	HRSpecFamilyList=""
	num=itemsInList(HRSpecDestList, "/")
	for(idex=0;idex<num;idex+=1)
		wave ExactStickWave = $stringFromList(idex, HRSpecDestList, "/")
		HRSpecFamilyList += UM_SumHRSpeciestoGroupsUMR(ExactStickWave, waveNameSuffix,stringFromList(idex, HRResults_ionList, ","))
	endfor
	
	NormalizeSpectra=temp_normalizeSpectra		//
	if (NormalizeSpectra)
		sq_NormalizeSpectra(HRSpecFamilyList)
	endif
	
	return HRSpecFamilyList

End


// Added in 1.09D  DOug's 5 panel only with species
Function HR_plot_5PanelHRSpecies(destListHRSpec, NewPlotName)
string destListHRSpec, NewPlotName

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar NormalizeSpectra = root:HR_panel:NormalizeSpectra

	wave t_series=root:index:t_series
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B
	wave/t HR_familyName = root:HR:HR_familyName

	string destStr, specList, familyStr, axisStr, legendStr, moreText, axisStrOld, colorStr, destListCopy, waveStr, waveFamilyStr,specStr,labelStr
	variable idex, num, pos, tempVar, total
		
	if (HR_checkAvgHRMS_UMR)
		wave xwave = root:HR_Sticks:amu_HR
	else
		wave/z xwave = root:HR_Sticks:ExactMassWave_FitTodo		//1.08E
		if (!WaveExists(xwave))		// for the case of someone upgrading who has not yet done a fit for a todo wave
			wave xwave=root:HR_Sticks:ExactMassWave // 1.08E replaced with *_FitTodo
		endif
	endif

	num = itemsInList(destListHRSpec,";") //1.11E TimO  // ItemsInList(DOUG5GRAPH_MAINFAMLIST, "/")	
	axisStr=""
	axisStrOld=""
	legendStr=""
	total=0
	destListCopy=destListHRSpec		// gradually remove items in the list to see who is left
	tempVar=1
	
// UMHROrgGrp_CHOgt1
	if(HRResults_graphOutputType==1)

		Display/W=(5, 50, 550,400)/N=$NewPlotName as NewPlotName
		
		//  we need to find the wave in our wave list and remove them one at at time.  Kinda painful	
		for(idex=0;idex<ItemsInList(DOUG5GRAPH_MAINFAMAXISLIST, "/");idex+=1)
			familyStr = replaceString("family", stringfromList(idex, DOUG5GRAPH_MAINFAMLIST, "/"),"")		// ie Cx
			specStr = stringfromList(idex, DOUG5GRAPH_HRSPECLIST, "/")
			pos = sq_findStr(HR_familyName, familyStr,1)
			waveStr = gen_partialstringfromList(destListHRSpec, specStr+"Grp_"+familyStr+"_", delimiter=";")
			// print waveStr
			wave/z familyWave = $waveStr
			if (!WaveExists(familyWave))	// as in the case when someone removed familyCx from HROrg		//1.10C
				wavestr = stringFromList(0, destListHRSpec, ";") //	UMHRChlGrp_Cl_allV
				wave first = $wavestr	
				waveStr = ReplaceString("_"+stringFromList(1,wavestr, "_" )+"_", wavestr, "_"+familyStr+"_")
				duplicate/o first $waveStr /Wave = familyWave
				familyWave = 0
			endif
			destListCopy=RemoveFromList(waveStr,destListCopy, ";")
			colorStr = "("+num2str(HR_family_R[pos])+","+num2str(HR_family_G[pos])+","+num2str(HR_family_B[pos])+")"
			axisStr = stringfromList(idex, DOUG5GRAPH_HRSPECAXISLIST, "/")
			labelStr = stringfromList(idex, DOUG5GRAPH_HRSPECLABELLIST, "/")
			AppendToGraph/w=$NewPlotName/L=$axisStr familyWave vs xwave
			ModifyGraph/w=$NewPlotName freePos($axisStr)={0,bottom}
			Label/w=$NewPlotName $axisStr "\\K"+colorStr+labelStr
			ModifyGraph/w=$NewPlotName lblPos( $axisStr)=100
			ModifyGraph/w=$NewPlotName grid($axisStr)=2
//			if(HR_checkCalcHRErrors)
//				wave familyWaveErr = $nameofWave(familyWave)+"_err"
//				ErrorBars/w=$graphName $nameofWave(familyWave) Y,wave=($nameofWave(familyWaveErr),$nameofWave(familyWaveErr))
//			endif
			if (!stringmatch(axisStr, axisStrOld))
				ModifyGraph/w=$NewPlotName axisEnab($axisStr)={tempVar-.18,tempVar}
				tempVar-=.2
			endif
			axisStrOld = axisStr
			Wavestats/q/m=1 familyWave
			sprintf moreText,  "\\K"+colorStr+familyStr +"    %.3f\r", V_avg*V_npnts
			total+=V_avg*V_npnts
			legendStr+=moreText
		endfor
		ModifyGraph/w=$NewPlotName grid(bottom)=2, nticks(bottom)=9, minor(bottom)=1, axisEnab(bottom)={0.1,1}
		ModifyGraph/w=$NewPlotName gridRGB=(34816,34816,34816)
		SetAxis/w=$NewPlotName/A/E=0
		ModifyGraph/w=$NewPlotName mode=1,lsize=2,toMode=3
		Label/w=$NewPlotName bottom "m/z"
		
		// deal with the stragglers
		for(idex=0;idex<ItemsInList(destListCopy);idex+=1)
			waveStr =  stringfromList(idex, destListCopy)
			familyStr = stringfromList(1,waveStr , "_")		// ie Cx
			specStr = waveStr[2,6]
			axisStr =  StringByKey(specStr, DOUG5GRAPH_SPECDEFAXISLIST,  ":",  ";")
			pos = sq_findStr(HR_familyName, familyStr,1)
			colorStr = "("+num2str(HR_family_R[pos])+","+num2str(HR_family_G[pos])+","+num2str(HR_family_B[pos])+")"
			wave familyWave = $waveStr
//			destListCopy=RemoveFromList(specStr,destListCopy, ";")
//			axisStr = stringfromList(idex, DOUG5GRAPH_HRSPECAXISLIST, "/")
			AppendToGraph/w=$NewPlotName/L=$axisStr familyWave vs xwave
			ModifyGraph/w=$NewPlotName freePos($axisStr)={0,bottom}
			ModifyGraph/w=$NewPlotName lblPos( $axisStr)=100
			ModifyGraph/w=$NewPlotName grid($axisStr)=2
			Wavestats/q/m=1 familyWave
			sprintf moreText,  "\\K"+colorStr+specStr+"_"+familyStr +" %.3f\r", V_avg*V_npnts
			total+=V_avg*V_npnts
			legendStr+=moreText		
		endfor
		legendStr = "normalized? "+selectstring(NormalizeSpectra, "N", "Y")+"\r"+legendStr
		legendStr = "total "+num2str(total)+"\r"+legendStr
		legendStr = selectString(HR_checkConvertTougm3, "Ion rate (Hz)", "NO3 equiv. mass, (ug/m3)")+"\r"+legendStr
		TextBox/w=$NewPlotName/C/N=text0/A=RT legendStr[0, strlen(legendStr)-2]
	
		pk_ColorizeByFamily()
		ShowInfo
			
		Pk_graphTweaks()	

	elseif(HRResults_graphOutputType==4)
	
		for(idex=0;idex<num;idex+=1)
			familyStr = replaceString("family", stringfromList(idex, DOUG5GRAPH_MAINFAMLIST, "/"),"")
			pos = sq_findStr(HR_familyName, familyStr,1)
			colorStr = "("+num2str(HR_family_R[pos])+","+num2str(HR_family_G[pos])+","+num2str(HR_family_B[pos])+")"
			wave familyWave = $stringfromList(idex, destListHRSpec, "/")
			Wavestats/q/m=1 familyWave
			sprintf moreText,  "\\K"+colorStr+familyStr +"    %.2f\r", V_avg*V_npnts
			total+=V_avg*V_npnts
			legendStr+=moreText
		endfor

		legendStr = "normalized? "+selectstring(NormalizeSpectra, "N", "Y")+"\r"+legendStr
		legendStr = "total "+num2str(total)+"\r"+legendStr
		legendStr = selectString(HR_checkConvertTougm3, "Ion rate (Hz)", "NO3 equiv. mass (ug/m3)")+"\r"+legendStr
		TextBox/w=$NewPlotName/C/N=text0/A=RT legendStr[0, strlen(legendStr)-3]
	
	endif	

End


//  Added in 1.09D  given a list of waves, sum them all and divide by the total
Function sq_NormalizeSpectra(myWaveList [,delimiter])
string myWaveList, delimiter

	string myDelimiter
	variable idex, num, SumTemp
	
	myDelimiter=selectString (ParamIsDefault(delimiter), delimiter, ";")
	num = itemsInList(myWaveList,myDelimiter)
		
	SumTemp=0 
	for(idex=0;idex<num;idex+=1)
		wave/z OneWave = $stringfromList(idex, myWaveList, myDelimiter)
		if (WaveExists(OneWave))
			SumTemp += sum(OneWave)
		endif
	endfor

	for(idex=0;idex<num;idex+=1)
		wave OneWave = $stringfromList(idex, myWaveList, myDelimiter)
		if (WaveExists(OneWave))
			OneWave /= sumTemp
		endif
	endfor

End


Function HR_butt_RemoveIsotopes(ctrlName) : ButtonControl		//1.11D
	String ctrlName

	svar HRResults_ionList = root:HR_Panel:HRResults_ionList
	variable idex, num
	string lst="", str=""
	for (idex=0;idex<ItemsInList(HRResults_ionList, ",");idex+=1)
		str=StringFromList(idex,HRResults_ionList, ",")
		if (strsearch(str, "j",0) <0)
			lst+=str+","
		endif
	endfor
	HRResults_ionList=lst

End


Function HR_butt_setResultsList(ctrlName) : ButtonControl
	String ctrlName

	svar HRResults_ionList = root:HR_panel:HRResults_ionList
	wave/t HR_familyName = root:HR:HR_familyName
	wave/t HR_spec_list = root:HR_frag:HR_spec_list
	wave ExactMassWave= root:HR_Sticks:ExactMassWave
	wave/t ExactMassText = root:HR_Sticks:ExactMassText
	wave MassStartPnt = root:HR_Sticks:MassStartPnt
	wave MassEndPnt = root:HR_Sticks:MassEndPnt
	nvar HR_ChosenMassesIntegerAMU = root:HR_Panel:HR_ChosenMassesIntegerAMU

	variable idex, num, pos
	string tempList, str

	if (strlen(HRResults_ionList)>0 && !stringmatch(",", HRResults_ionList[strlen(HRResults_ionList)-1]))
		 HRResults_ionList+=","
	endif
	
	nvar/z BCdata = root:HR_frag:BCdata		//1.12N

	strswitch(ctrlName)
		case  "HRResults_butt_clearList":
			HRResults_ionList=""
		break
		case  "HRResults_butt_setListHRfams":
			num = numpnts(HR_familyName)
			// HR_DoFamilyMaskWavesExist()			
			HRResults_ionList=""
			for (idex =0;idex<num;idex+=1)
				HRResults_ionList += "family"+HR_familyName[idex]+","
			endfor
		break
		case  "HRResults_butt_setListAerHRfams":
			Wave/t/z UserHRSpecies = root:HR_frag:UserHRSpecies		//1.20H
			if (WaveExists(UserHRSpecies))
				wave/t HR_specname_list  = root:HR_frag:UserHRSpecies 
				for(idex=0;idex<numpnts(UserHRSpecies);idex+=1)	/// check to make sure that all the items in this text wave exist in the species text wave
					if (sq_findStr(HR_specname_list,UserHRSpecies[idex],1)<0)
						edit UserHRSpecies
						HR_butt_HRbatchTable("")
						abort "The entry "+UserHRSpecies[idex]+" is not an HR species. Perhaps there is a typo or you need to create the species? Aborting from HR_butt_setResultsList"
					endif
				endfor
				HRResults_ionList = SelectString(WaveExists(UserHRSpecies),DEFAULTHRSPECIES, sq_textwave2List(UserHRSpecies) )
			else
				HRResults_ionList=DEFAULTHRSPECIES
				if (NVar_exists(BCdata) &&  BCdata)		//1.12N
					HRResults_ionList+="HRBC," 		//1.15E
				endif
			endif
			HRResults_ionList = replaceString (";", HRResults_ionList, ",")
		break
		case  "HRResults_butt_allHRspecies":
			HRResults_ionList = sq_textwave2List(HR_spec_list)
			HRResults_ionList = replaceString (";", HRResults_ionList, ",")
		break
		case  "HRResults_butt_EnterAllMassUMR":
			tempList=""
			pos = HR_ChosenMassesIntegerAMU - round(ExactMassWave[0])			//1.12O
			if (pos>=numpnts(MassStartPnt))
				abort "You have chosen an m/z that is larger than the largest HR ion chosen to fit.  Aborting from HR_butt_setResultsList"
			endif
			for (idex=MassStartPnt[pos]; idex<=MassEndPnt[pos]; idex+=1)
				tempList+=ExactMassText[idex]+","
			endfor		
			HRResults_ionList+=tempList		// 1.09B
		break
		case  "HRResults_butt_appendFamMem":
			ControlInfo HRResults_pop_family		
			if (stringmatch(S_Value,"Initialize") )
				abort "Please initialize the family popup menu aborting from HR_butt_setResultsList" 
			endif
			HR_CreateFamilyMembers($"root:Int_sticks:mask_"+S_Value)		// uses code from the popup menu in HR ion Groups tab
			wave/t FamilyMemText = root:Int_sticks:FamilyMemText		//1.10C
			tempList = sq_textwave2List(FamilyMemText)
			HRResults_ionList +=replaceString (";", tempList, ",") 	// 1.09B
		break
	endswitch

	// remove possible duplicates from list		// added in 1.10C
	tempList=""
	num = itemsInList(HRResults_ionList, ",")
	
	for (idex=0; idex<num; idex+=1)
		str=stringFromList(idex, HRResults_ionList, ",")
		if (WhichListItem(str, tempList, ","  , 0 , 1)<0  )
			tempList+=str + ","	
		endif
	endfor		
	HRResults_ionList=tempList

End


//add a mass from the peak Heights graph
Function HR_butt_AddThisMass(ctrlName) : ButtonControl		// overhauled in 1.08E
string ctrlName

	nvar SticksGr_newIonMass = root:HR_Sticks:SticksGr_newIonMass
	svar SticksGr_newIonName = root:HR_Sticks:SticksGr_newIonName
	nvar NewHRIonQueryFindChosen = root:HR_panel:NewHRIonQueryFindChosen
	string returnStr
	
	variable possibleIsotopAbundVar=nan, possibleChooseToFitVar=0
 	string possibleIsotopParentStr=""
 
 	if (HR_OneHRIonElementalComp(SticksGr_newIonName)) // this HR ion text is a legitimate ion name
 		variable diff =abs(SticksGr_newIonMass - pk_FindMassFromFormula(SticksGr_newIonName)  )
 		if (diff > 0.001)
 			Abort "The chemical formula you have entered, "+SticksGr_newIonName+" does not match the mass.  Please rename or check the mass."
 		endif
 	endif
 
  	if (strsearch(SticksGr_newIonName, "j", 0)>0)		// dump to HR ion mass calculator  //1.19F
		svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText		// input
		svar NewHRIonQueryIsoParent = root:HR_panel:NewHRIonQueryIsoParent		// output
		nvar NewHRIonQueryIsoAbundance = root:HR_panel:NewHRIonQueryIsoAbundance // output
		NewHRIonQueryText=SticksGr_newIonName		// i.e. Naj37Cl
		HR_butt_CalcMassOneHRIon("")		
		if (strlen(NewHRIonQueryIsoParent)==0)  // 
			abort "Had problem identifying the parent of isotope "+SticksGr_newIonName+" Aborting from HR_butt_AddThisMass"
		else
			wave/t ExactMassText_All = root:HR:ExactMassText_All
			FindValue/TEXT=(NewHRIonQueryIsoParent)/TXOP=7 ExactMassText_All
			if(V_value<0) 
				abort "The parent of isotope "+SticksGr_newIonName+", which is "+NewHRIonQueryIsoParent+" doesn't appear to exist yet. Add the parent first. Aborting from HR_butt_AddThisMass"
			endif			
		endif
		possibleIsotopAbundVar = NewHRIonQueryIsoAbundance
		possibleIsotopParentStr = NewHRIonQueryIsoParent
	endif
	returnStr= HR_addThisMass(SticksGr_newIonName, SticksGr_newIonMass, possibleIsotopAbund = possibleIsotopAbundVar, possibleIsotopParent = possibleIsotopParentStr, possibleChooseToFit=NewHRIonQueryFindChosen)

	if (strlen(returnStr)>25)		// assumes no HR ion will be bigger than 25 characters
		abort returnStr
	else
		SticksGr_newIonName = returnStr
		HR_CreatePeakHtsListBox()
	endif	

	 HR_butt_MakeExactMassWaves("")
	 
End


// function below were added or revisedin 1.09D
Function HR_massCalcGlobals()

	sq_initializeGlobalSVar("root:HR_panel:NewHRIonQueryText", "")		//1.08E
	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryMass", nan)		//1.08E

	sq_initializeGlobalNVar("root:HR_panel:HRIsoAbundanceDiffLimit", 1e-3)		//1.10 default changed	
	sq_initializeGlobalNVar("root:HR_panel:HR_isotopeLowerLimit", 1e-3)			//1.10 default changed
	sq_initializeGlobalNVar("root:HR_panel:HR_isotopeLowerLimit", 1e-3)			//1.10 default changed
	sq_initializeGlobalSVar("root:HR_panel:NewHRIonQueryIsoParent", "")	
	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryIsoAbundance", nan)	

	sq_initializeGlobalSVar("root:HR_panel:NewHRIonQueryIsoExists", "Exists?")	
	sq_initializeGlobalSVar("root:HR_panel:NewHRIonQueryIsoChosen", "Chosen to fit?")	
	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryFindExists", 1)	
	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryFindChildChosen", 1)	
	sq_initializeGlobalNVar("root:HR_panel:NewHRIonQueryChooseToFit", 1)	

	sq_initializeGlobalNVar("root:HR_Panel:QueryTypeRRX",1)
	sq_initializeGlobalSVar("root:HR_panel:IonQueryRoot","C2H")
	sq_initializeGlobalSVar("root:HR_panel:IonQuerySuffix","O2")
	sq_initializeGlobalNVar("root:HR_panel:IonQueryMaxMz",120)
	sq_initializeGlobalNVar("root:HR_panel:HR_checkQueryChosen",1)
	sq_initializeGlobalNVar("root:HR_panel:Query_addC",1)
	sq_initializeGlobalNVar("root:HR_panel:Query_addCH",1)
	sq_initializeGlobalNVar("root:HR_panel:Query_addCH2",1)

	sq_initializeGlobalNVar("root:HR_panel:IncludeIsoChildren",1)

	make/t/o/n=0 root:HR_Panel:IsoChildToAllNames
	make/o/n=0 root:HR_Panel:IsoChildToAllMass
	make/o/n=0 root:HR_Panel:IsoChildToAllAbund
	make/t/o/n=0 root:HR_Panel:IsoChildToAllParent	// text wave of HR isotopic parents

	make/o/n=0 root:HR_Sticks:ChemicalFormulaMass
	make/t/o/n=0 root:HR_Sticks:ChemicalFormulaText

	make/o/n=0 root:HR_panel:NewIsotopeHRIonsAbundance
	make/t/o/n=0 root:HR_panel:NewIsotopeHRIonsParent
	make/t/o/n=0 root:HR_panel:NewIsotopeHRIonsName

	sq_initializeGlobalSVar("root:HR_Panel:HR_familyWaveOnlyList", "Get List")			//1.20Y addition
	sq_initializeGlobalSVar("root:HR_Panel:HR_familyWaveOnlyMembers", "")	
	sq_initializeGlobalSVar("root:HR_Panel:HR_familyWaveOnlyCList", "0;0;0;")	
	sq_initializeGlobalSVar("root:HR_Panel:HR_familyWaveOnlyName", "")	

	PK_CreateElementWaves()

End


// Given a text wave of HR ion names and a tolerance find all the isotopic children of them
// creates:
// root:HR_Panel:IsoChildToAllNames/wave=IsoChildToAllNames		// text wave of HR isotopic ions that are not in the all list
// root:HR_Panel:IsoChildToAllParent/wave=IsoChildToAllParent		// text wave of HR isotopic parents
// root:HR_Panel:IsoChildToAllAbund/wave=IsoChildToAllAbund		// isotopic abundance
// root:HR_Panel:IsoChildToAllMass/wave=IsoChildToAllMass		// isotopic abundance
Function HR_FindMissingIsotopes(MassTextWaveToSearch,abundanceMin,MissIsoChildToAllNames, MissIsoChildToAllParent, MissIsoChildToAllAbund, MissIsoChildToAllMass)
wave/t MassTextWaveToSearch, MissIsoChildToAllNames, MissIsoChildToAllParent
wave MissIsoChildToAllAbund, MissIsoChildToAllMass
variable abundanceMin

	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	
	string massStr
	variable idex, num, numAddToAll, numAddToAllTemp, PeriodicTableFlag //1.19C  1.21B

	make/o/n=0 IndexWave
	
	make/t/o/n=0 IsoChildToAllNamesTemp, IsoChildToAllParentTemp
	make/o/n=0 IsoChildToAllAbundTemp
		
	numAddToAll=0
	
	num = numpnts(MassTextWaveToSearch)
	for (idex=0;idex<num;idex+=1)
		massStr=MassTextWaveToSearch[idex]
		if (strsearch(massStr, "j", 0)>=0 || strsearch(massStr, "plus", 0)>=0 || strsearch(massStr, "inV", 0)>=0  || strsearch(massStr, "inW", 0)>=0 )  
			continue
		endif
		// find all isotopes, every one
		PeriodicTableFlag = HR_OneHRIonElementalComp(massStr)		// sets root:HR_Panel:ElementCountWave
		wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
		wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
		wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal
		make/o/t/n=0 root:HR_panel:NewIsotopeHRIonsParent/Wave=NewIsotopeHRIonsParent	// contain EVERY isotopes> tolerance
		make/o/t/n=0 root:HR_panel:NewIsotopeHRIonsName/Wave=NewIsotopeHRIonsName	// contain EVERY isotopes> tolerance
		make/o/n=0 root:HR_panel:NewIsotopeHRIonsAbundance/Wave=NewIsotopeHRIonsAbundance	// contain EVERY isotopes> tolerance
		
		if (PeriodicTableFlag)		//1.19C
			HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, HR_isotopeLowerLimit, NewIsotopeHRIonsName, NewIsotopeHRIonsAbundance)
				
			numAddToAllTemp=numpnts(NewIsotopeHRIonsName)
			if (numAddToAllTemp>0)
				insertPoints numAddToAll, numAddToAllTemp, IsoChildToAllAbundTemp, IsoChildToAllNamesTemp, IsoChildToAllParentTemp
				IsoChildToAllNamesTemp[numAddToAll, ] = NewIsotopeHRIonsName[p-numAddToAll]
				IsoChildToAllParentTemp[numAddToAll, ] = massStr
				IsoChildToAllAbundTemp[numAddToAll, ] = NewIsotopeHRIonsAbundance[p-numAddToAll]
				numAddToAll+=numAddToAllTemp
			endif
		endif
	endfor
		
	HR_IsotopeSubset(IsoChildToAllNamesTemp,IsoChildToAllParentTemp, IsoChildToAllAbundTemp, MissIsoChildToAllNames, MissIsoChildToAllParent, MissIsoChildToAllAbund)

	make/t/o/n=0  inVorWnameTemp
	make/o/n=0 multiChargedTemp
	pk_recalc_IonMasses(MissIsoChildToAllNames, MissIsoChildToAllMass, multiChargedtemp, inVorWnameTemp)
	
	killwaves/z inVorWnameTemp, multiChargedTemp, IndexWave 
	killwaves/z IsoChildToAllNamesTemp, IsoChildToAllParentTemp, IsoChildToAllAbundTemp

	sq_KillWavesInList(WaveList("ElementComboNameTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementComboAbundTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementAbundTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementNameTemp*", ";", ""))
	sq_KillWavesInList(WaveList("HRnameElement*", ";", ""))

End


// creates and sets root:HR_Panel:HRnameElementOrder, root:HR_Panel:HRnameElementOrderIndex, root:HR_Panel:HRnameElementTotal
// and ElementCountWave
Function HR_oneHRIonElementalComp(HRIonName, [AllAtomOrder, ThisHRIonNameOrder])		// 1.12H
string HRIonName
wave AllAtomOrder, ThisHRIonNameOrder		// 

	wave/T ElementIonName = root:HR:ElementIonName		// created in CreateElementWaves
	wave ElementIonMass = root:HR:ElementIonMass		// created in CreateElementWaves
	wave/T ElementIsotopParentList = root:HR:ElementIsotopParentList		// created in CreateElementWaves
	wave/T ElementIsotopParentIndexList = root:HR:ElementIsotopParentIndexList		// created in CreateElementWaves
	wave ElementIsotopAbund = root:HR:ElementIsotopAbund		// created in CreateElementWaves
	
	string IonNameStr, ResidIonName, str1, str2, IsotopePosList,infoStr, elemStr
	variable stepPos, startPos, elementIndex, numAfterElement
	variable ionIndex, massTemp, plusPos, inPos, numElements, elementPos, HRnameElementOrderCount
	variable PeriodicTableFlag=1  //1.21B

	make/o/n=(numpnts(ElementIonName)) root:HR_Panel:ElementCountWave/wave=ElementCountWave
	ElementCountWave=0
	
	make/o/t/n=0 root:HR_Panel:HRnameElementOrder/wave=HRnameElementOrder
	make/o/n=0 root:HR_Panel:HRnameElementOrderIndex/wave=HRnameElementOrderIndex
	make/o/n=0 root:HR_Panel:HRnameElementTotal/wave=HRnameElementTotal
	HRnameElementOrderCount =0

	numElements = numpnts(ElementIonName)
	startPos=0
	massTemp=0
	IsotopePosList=""
	
	variable AtomOrderFlag = !paramIsDefault(AllAtomOrder)  && !paramIsDefault(ThisHRIonNameOrder)   // 1.12H
	if (AtomOrderFlag)
		redimension/n=0 ThisHRIonNameOrder
	endif
	
// deal with AMS unique plus2 and inV naming scheme
	plusPos=strsearch(HRIonName, "plus", 0, 2)
	inPos=strsearch(HRIonName, "inV", 0, 2)		// as in inV or inW
	if(inPos>=0	)	// 1.15
///			multiChargedtemp[ionIndex] = 4		//The exact mass values will likely not work out exactly.
		HRIonName=HRIonName[0,strlen(HRIonName)-4]			// truncate the 'inV' part of the ion name
	endif
	inPos=strsearch(HRIonName, "inW", 0, 2)		// as in inV or inW
	if(inPos>=0	)	// 1.15
//			multiChargedtemp[ionIndex] = 4/9	// The exact mass values will likely not work out exactly.
		HRIonName=HRIonName[0,strlen(HRIonName)-4]			// truncate the 'inV' part of the ion name
	endif

	// check for multiple-charged ions first; reformat their ionNames by removing "plus*" 
	if (plusPos>=0) 
		splitstring/E="(plus)(\\d{1,3})" HRIonName, str1, str2
		if (strlen(str2) ==0) //we do not have numbers after the letter
			numAfterElement = 1
		else	
			numAfterElement = str2num(str2)
		endif
//		multiChargedtemp[ionIndex] =numAfterElement
		HRIonName=HRIonName[0,plusPos-1]+HRIonName[plusPos+4+strlen(str2),strlen(HRIonName)-1]  // truncate the plus2 part of the ion name
	endif
 	
 	// read ions for all the elements and isotopes
 	str2=""
	if (strlen(HRIonName)==0)
		return 1	
	endif
	
 	do 
 		ResidIonName=HRIonName[startPos, startPos+6]
		for (stepPos=6;stepPos>=0;stepPos-=1) //maximum string length for the element name = 6: e.g., j207Pb
			IonNameStr=HRIonName[startPos, startPos+stepPos]
//			print IonNameStr
			for (elementIndex=0;elementIndex<numElements;elementIndex+=1)
				if (cmpStr(ElementIonName[elementIndex],IonNameStr,1)==0)
//				if (stringmatch(ElementIonName[elementIndex],IonNameStr))   // not case sensitive!!		//1.11K
//					print IonNameStr,startPos, startPos+stepPos
					 
					splitstring/E=("("+ElementIonName[elementIndex]+")"+"(\\d{1,3})") ResidIonName, str1, str2
					if (strlen(str2)==0) //we do not have numbers after the letter
						numAfterElement= 1
						infoStr+= "Read Ions of " + ElementIonName[elementIndex] + " Num: 1"+"\t\t" //note out when run the code for a long ion list
						ElementCountWave[elementIndex]=1
					else	
						numAfterElement = str2num(str2)
						infoStr+= "Read Ions of " + str1 + " Num:"+ str2 +"\t\t"//note out when run the code for a long ion list
						ElementCountWave[elementIndex]=numAfterElement
					endif
					massTemp += (numAfterElement*ElementIonMass[elementIndex])

					InsertPoints HRnameElementOrderCount, 1,HRnameElementOrder, HRnameElementOrderIndex, HRnameElementTotal
					HRnameElementOrder[HRnameElementOrderCount]=ElementIonName[elementIndex]
					HRnameElementOrderIndex[HRnameElementOrderCount]=elementIndex
					HRnameElementTotal[HRnameElementOrderCount]=ElementCountWave[elementIndex]
					HRnameElementOrderCount+=1
					
					if (AtomOrderFlag)
						InsertPoints HRnameElementOrderCount-1, 1, ThisHRIonNameOrder
						ThisHRIonNameOrder[HRnameElementOrderCount-1] = AllAtomOrder[elementIndex]
					endif
					
					elementPos = sq_TextIntextWave(str1, ElementIonName) 
					if (elementPos<0)
						// print "// Could not find element "+str1+"  Continuing..."
					elseif (strlen(ElementIsotopParentList[elementPos])>0)		// is a parent isotope
						IsotopePosList+=num2str(elementPos)+";"						
					endif
					break
				endif
			endfor
			if (( elementIndex< numElements) && cmpStr(ElementIonName[elementIndex],IonNameStr,1)==0)		//1.58G
				startPos+=(stepPos+strlen(str2))
				break
			elseif(elementIndex== numElements && strlen(IonNameStr)==1 ) // && stepPos==0)		// this is a non periodic table ion, i.e. T in TCH4 or CH4T
				return 0
				//PeriodicTableFlag=0
				// print "bad?", IonNameStr, stepPos
			endif
		endfor
		startPos+=1	
	while(startPos<strlen(HRIonName))
// 	resultMassTemp[ionIndex]=massTemp/multiChargedtemp[ionIndex]
// 	infoStr+= "multiCharged: "+num2str(multiChargedtemp[ionIndex]) //note out when run the code for a long ion list

//1.21B
	variable idex, num = numpnts(HRnameElementOrder)
	redimension/u/i HRnameElementOrderIndex
	for(idex=num-1;idex>0;idex-=1)
		FindValue/i=(HRnameElementOrderIndex[idex])/s=0 HRnameElementOrderIndex 
		if (V_Value<idex)
			HRnameElementTotal[V_Value]+=HRnameElementTotal[idex]
			deletepoints idex, 1,HRnameElementOrderIndex, HRnameElementTotal, HRnameElementOrder
			if(AtomOrderFlag)
				deletepoints idex, 1,ThisHRIonNameOrder
			endif 
		endif
	endfor

	return num //PeriodicTableFlag		//1.19C  1.21B

End


// using root:HR_Panel:ElementCountWave
// creates and modifies root:HR_panel:NewIsotopeHRIonsAbundance and  root:HR_panel:NewIsotopeHRIonsName, root:HR_panel:NewIsotopeHRIonsParent
Function HR_findIsotopes_Tolerance(ElementCountWave, tol, HRIonName)
wave ElementCountWave
variable tol
string HRIonName

	wave/T ElementIonName = root:HR:ElementIonName		// created in CreateElementWaves
	wave ElementIonMass = root:HR:ElementIonMass		// created in CreateElementWaves
	wave/T ElementIsotopParentList = root:HR:ElementIsotopParentList		// created in CreateElementWaves
	wave/T ElementIsotopParentIndexList = root:HR:ElementIsotopParentIndexList		// created in CreateElementWaves
	wave ElementIsotopAbund = root:HR:ElementIsotopAbund		// created in CreateElementWaves

	variable idex, jdex, kdex, num, elementPos, binomialCoeff, isotopElemAbund,isotopicRatioToParent
	string str1, IsotopePosList, IsotopeNameList, isotopicChildStr, isotopicElementStr,isotopicParentStr
	variable IsotopeParentPos, numOfElement, numNew
	string IsotopeIndexList, NonIsotopicElementStr, HRIonNamePrefix, HRIonNameSuffix, isotopicElement, parentElement
	
	make/o/n=0 root:HR_panel:NewIsotopeHRIonsAbundance/wave=NewIsotopeHRIonsAbundance
	make/t/o/n=0 root:HR_panel:NewIsotopeHRIonsName/wave=NewIsotopeHRIonsName
	make/t/o/n=0 root:HR_panel:NewIsotopeHRIonsParent/wave=NewIsotopeHRIonsParent
			
	// first get IsotopePosList
	num=numpnts(ElementCountWave)
	IsotopePosList=""
	for (idex=0;idex<num;idex+=1)	// go through all elements
		if (ElementCountWave[idex]>0)		// mass has this element
			if (strlen(ElementIsotopParentList[idex])>0)		// is a parent isotope
				IsotopePosList+=num2str(idex)+";"						
			endif	
		endif
	endfor
		
	numNew=0
	// then parse the list of elements with isotopes
	for(idex=0;idex<ItemsInList(IsotopePosList);idex+=1)
		// for each element that has an isotope
		IsotopeParentPos = str2num(stringFromList(idex,IsotopePosList))
		parentElement = ElementIonName[IsotopeParentPos]
		IsotopeNameList = ElementIsotopParentList[IsotopeParentPos] 
		IsotopeIndexList = ElementIsotopParentIndexList[IsotopeParentPos] 
		numOfElement = ElementCountWave[IsotopeParentPos] 
		for(jdex=0;jdex<itemsInList(IsotopeIndexList);jdex+=1)
			// go through all the possible isotopes for this parent
			isotopicElement = stringFromList(jdex, IsotopeNameList)
			isotopElemAbund = ElementIsotopAbund[str2num(stringFromList(jdex, IsotopeIndexList))]
			HRIonNamePrefix = HR_ExtractHRIonNamePart(HRIonName, ElementIonName[IsotopeParentPos], -1)
			HRIonNameSuffix = HR_ExtractHRIonNamePart(HRIonName, ElementIonName[IsotopeParentPos], 1)
			isotopicParentStr=HRIonNamePrefix+parentElement+ selectString(numOfElement>1,"", num2str(numOfElement))+HRIonNameSuffix
			for(kdex=1;kdex<=numOfElement;kdex+=1)
			// for each isotope swap out as up to numOfElement many isotopic elements
				// potential new isotopic child
				binomialCoeff=binomial(numOfElement, kdex)
				isotopicElementStr = isotopicElement + selectString(kdex>1,"", num2str(kdex))
				NonIsotopicElementStr=selectString(numOfElement-kdex >0,"", ElementIonName[IsotopeParentPos] + selectString(numOfElement-kdex>1,"", num2str(numOfElement-kdex)) )
				isotopicChildStr=HRIonNamePrefix+isotopicElementStr+NonIsotopicElementStr+HRIonNameSuffix
//				print isotopicChildStr
				isotopicRatioToParent=binomialCoeff*(isotopElemAbund^kdex)		//((numOfElement-kdex)/numOfElement)*
				if (isotopicRatioToParent>tol)
					insertpoints numNew, 1, NewIsotopeHRIonsAbundance,NewIsotopeHRIonsName, NewIsotopeHRIonsParent
					NewIsotopeHRIonsName[numNew]=isotopicChildStr
					NewIsotopeHRIonsParent[numNew]=isotopicParentStr
					NewIsotopeHRIonsAbundance[numNew]=isotopicRatioToParent
					numNew+=1
				endif
			endfor
		endfor
	endfor	

end


// using root:HR_Panel:HRnameElementOrder, root:HR_Panel:HRnameElementOrderIndex
// returns part of HRIonName with element X removed
Function/s HR_extractHRIonNamePart(HRIonName, isotopicElementStr, SuffixFlag)
string HRIonName, isotopicElementStr
variable SuffixFlag

	Wave ElementCountWave = root:HR_Panel:ElementCountWave
	Wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
	Wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex

	string returnStr = ""
	variable elemPos, idex, numElem, num
	elemPos = sq_TextIntextWave(isotopicElementStr, HRnameElementOrder)
	
	num=numpnts(HRnameElementOrder)
	if (suffixFlag<0)		// prefix
		if (elemPos==0)
			returnStr=""
		else
			for(idex=0;idex<elemPos;idex+=1)
				numElem=ElementCountWave[HRnameElementOrderIndex[idex]]
				returnStr +=HRnameElementOrder[idex]+selectString(numElem>1, "", num2str(numElem) )
			endfor
		endif
	else				// suffix
		if (elemPos==num-1)
			returnStr=""
		else
			for(idex=elemPos+1;idex<num;idex+=1)
				numElem=ElementCountWave[HRnameElementOrderIndex[idex]]
				returnStr +=HRnameElementOrder[idex]+selectString(numElem>1, "", num2str(numElem) )
			endfor
		endif
	endif
	
	return returnStr

End


// *************************************************
// does the intersection of two waves
Function sq_inTextWave1InTextWave2(textWave1,textWave2, IndexWave, NotFlag)
Wave/t textWave1,textWave2
wave IndexWave
variable NotFlag

	variable idex, num, indexCounter, pos
	num = numpnts(textWave1)

	indexCounter=0
	redimension/n=0 IndexWave

	for (idex=num-1;idex>=0;idex-=1)		// go backwards to keep same order
		pos=sq_TextIntextWave(textWave1[idex], textWave2)		// pos2 is the position of the idexth entry of textwave1 within textwave2
		if ((pos<0 && NotFlag) || (pos>=0 && !NotFlag))
			insertpoints indexCounter, 1, IndexWave
			indexwave[indexCounter]=idex
		endif		
	endfor

//	return IndexWave		//1.57J

End


// returns string of newly added HR ion
Function/S HR_addThisMass(NewIonName, newIonMass, [possibleIsotopAbund, possibleIsotopParent, possibleChooseToFit])
string NewIonName, possibleIsotopParent
variable newIonMass, possibleIsotopAbund,possibleChooseToFit

	wave/t ExactMassText_All = root:HR:ExactMassText_All
	wave/d ExactMassWave_All = root:HR:ExactMassWave_All
	wave/t ExactMassComments = root:HR:ExactMassComments
	wave Mask_Stick_integration = root:HR:Mask_Stick_integration
	wave Mask_Stick_Integration_Default = root:HR:Mask_Stick_Integration_Default
	wave/t Mask_Isotope_reference = root:HR:Mask_Isotope_reference
	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance

	variable insertionPt, num, isotopeAbund, chooseToFit
	string abortStr, ParentStr, returnStr

	isotopeAbund = selectnumber(ParamIsDefault(possibleIsotopParent), possibleIsotopAbund,nan)
	ParentStr = selectstring(ParamIsDefault(possibleIsotopParent), possibleIsotopParent,"")	
	ChooseToFit = selectnumber(ParamIsDefault(possibleChooseToFit), possibleChooseToFit, 0)	 //selectnumber(ParamIsDefault(possibleChooseToFit), possibleChooseToFit, 1)	
	
	abortStr=""	
	num = numpnts(ExactMassWave_All)

	// two sanity checks - one to see if the mass exists, another to see if the text exists

	NewIonName = CleanupName(NewIonName, 0)
//	NewIonName = upperStr(NewIonName)	//	1.09K fix
//	NewIonName = ReplaceString("J", NewIonName, "j")		// js represent isotopes
	NewIonName = ReplaceString("_", NewIonName, "")		// no underscores
	
	FindValue/TEXT=NewIonName/TxOP=7 ExactMassText_All
	if (V_Value >=0)
		abortStr =  "It appears that this ion already exists in the wave ExactMassText_All at location " + num2str(V_Value) +" - Aborting from HR_addThisMass"
	endif		
	if (newIonMass < 1 || newIonMass > 1500)		// 1.06J fix by urging from Puneet, old version was 300
		abortStr =  "The added mass must be between 1 and 1500 - Aborting from HR_addThisMass"	
	endif
	
	insertionPt = binarysearch(ExactMassWave_All, newIonMass) + 1
	if (insertionPt ==-1)		// means that the original binary search returned -2
		insertionPt=num		// very last entry
	elseif(newIonMass == ExactMassWave_All[insertionPt])
		abortStr = "It appears as if this entry already appears in the list - Please refresh the screen! - Aborting from HR_addThisMass"
	endif
		
	if (strlen(abortStr)==0)
		InsertPoints insertionPt,1, ExactMassText_All,ExactMassWave_All,ExactMassComments
		InsertPoints insertionPt,1, Mask_Stick_integration, Mask_Stick_Integration_Default
		InsertPoints insertionPt,1, Mask_Isotope_abundance,Mask_Isotope_reference
		ExactMassText_All[insertionPt] = NewIonName
		ExactMassWave_All[insertionPt] = newIonMass
		ExactMassComments[insertionPt] = ""
		Mask_Isotope_reference[insertionPt] = ParentStr
		Mask_Isotope_abundance[insertionPt] = isotopeAbund
		Mask_Stick_integration[insertionPt] = ChooseToFit		// presume that if added they also want to fit
		Mask_Stick_Integration_Default[insertionPt] = ChooseToFit
		returnStr= NewIonName
	else	
		returnStr= abortStr
	endif
	if (!ParamIsDefault(possibleChooseToFit) && possibleChooseToFit)
		make/t/o/FREE/n=1 NewIOnWaveText = NewIonName
		HR_change2FitHRIon(NewIOnWaveText, possibleChooseToFit)
	endif
	return returnStr

End


// table in HR ion mass calculator panel
Function HR_populate_IsotopChildrenTable()

	wave/z IsoChildToAllNames =  root:HR_Panel:IsoChildToAllNames
	if (!WaveExists(IsoChildToAllNames))
		make/t/o/n=0 root:HR_Panel:IsoChildToAllNames
		make/t/o/n=0 root:HR_Panel:IsoChildToAllParen
		make/o/n=0 root:HR_Panel:IsoChildToAllAbund
		make/o/n=0 root:HR_Panel:IsoChildToAllMass
	endif
	
	Appendtotable root:HR_Panel:IsoChildToAllNames
	Appendtotable root:HR_Panel:IsoChildToAllMass
	Appendtotable root:HR_Panel:IsoChildToAllAbund
	Appendtotable root:HR_Panel:IsoChildToAllParent	// text wave of HR isotopic parents

	ModifyTable format(Point)=1,width(Point)=18,width(root:HR_Panel:IsoChildToAllNames)=72,title(root:HR_Panel:IsoChildToAllNames)="HR Ion"
	ModifyTable format(root:HR_Panel:IsoChildToAllMass)=3,digits(root:HR_Panel:IsoChildToAllMass)=6,width(root:HR_Panel:IsoChildToAllMass)=62
	ModifyTable title(root:HR_Panel:IsoChildToAllMass)="Mass",format(root:HR_Panel:IsoChildToAllAbund)=3,digits(root:HR_Panel:IsoChildToAllAbund)=6
	ModifyTable width(root:HR_Panel:IsoChildToAllAbund)=66,title(root:HR_Panel:IsoChildToAllAbund)="Iso. abundance"
	ModifyTable width(root:HR_Panel:IsoChildToAllParent)=66,title(root:HR_Panel:IsoChildToAllParent)="Iso. parent"

End

// table in HR ion mass calculator panel
Function HR_populate_MissIsoChildTable()

	wave/z MissIsoChildToAllNames =  root:HR_Panel:MissIsoChildToAllNames
	if (!WaveExists(MissIsoChildToAllNames))
		make/t/o/n=0 root:HR_Panel:MissIsoChildToAllNames
		make/t/o/n=0 root:HR_Panel:MissIsoChildToAllParent
		make/o/n=0 root:HR_Panel:MissIsoChildToAllAbund
		make/o/n=0 root:HR_Panel:MissIsoChildToAllMass
	endif
	Appendtotable root:HR_Panel:MissIsoChildToAllNames
	Appendtotable root:HR_Panel:MissIsoChildToAllMass
	Appendtotable root:HR_Panel:MissIsoChildToAllAbund
	Appendtotable root:HR_Panel:MissIsoChildToAllParent	// text wave of HR isotopic parents

	ModifyTable format(Point)=1,width(Point)=36,width(root:HR_Panel:MissIsoChildToAllNames)=98,title(root:HR_Panel:MissIsoChildToAllNames)="HR Ion"
	ModifyTable format(root:HR_Panel:MissIsoChildToAllMass)=3,digits(root:HR_Panel:MissIsoChildToAllMass)=6,width(root:HR_Panel:MissIsoChildToAllMass)=102
	ModifyTable title(root:HR_Panel:MissIsoChildToAllMass)="Mass",format(root:HR_Panel:MissIsoChildToAllAbund)=3,digits(root:HR_Panel:MissIsoChildToAllAbund)=6
	ModifyTable width(root:HR_Panel:MissIsoChildToAllAbund)=98,title(root:HR_Panel:MissIsoChildToAllAbund)="Iso. abundance"
	ModifyTable width(root:HR_Panel:MissIsoChildToAllParent)=102,title(root:HR_Panel:MissIsoChildToAllParent)="Iso. parent"

End


// presumes HRIonStr is given, returns an abundance based on the ratio of its parent
Function HR_findIsotopAbund(HRIonStr)
string HRIonStr

	string jMassStr, ParentStr, tempStr1, tempStr2
	variable idex, numElem, isoFlag,pos, elemIsoRatio, xmanyElem, xmanyIso, isotopicRatioToParent
	variable binomialCoeff, PeriodicTableFlag		//1.19D
	
	wave/t ElementIonName = root:HR:ElementIonName
	wave ElementIsotopAbund = root:HR:ElementIsotopAbund
	
	PeriodicTableFlag = HR_OneHRIonElementalComp(HRIonStr)		//1.19C
	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
	wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal

	if (PeriodicTableFlag)
		duplicate/o/t HRnameElementOrder HRnameElementOrderChild
		duplicate/o HRnameElementOrderIndex HRnameElementOrderIndexChild
		duplicate/o HRnameElementTotal HRnameElementTotalChild
	
	   	ParentStr = HR_FindIsotopParent(HRIonStr)
		PeriodicTableFlag = HR_OneHRIonElementalComp(ParentStr)
	 	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
	 	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
	 	wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal
		 
		isotopicRatioToParent=1
	 	numElem=numpnts(HRnameElementOrderChild) // numpnts(HRnameElementOrder)  //1.21B
	 	for(idex=0;idex<numElem;idex+=1)
	  		splitstring/E=("j(\\d{1,3})([[:alpha:]]+)") HRnameElementOrderChild[idex], jMassStr, ParentStr
	 		if (strlen(jMassStr)>0)		// element is an isotope	// bug fixed in 1.10A
	 			isoFlag=1
	 			tempStr1="j"+jMassStr+ParentStr		// = j13C
	  			pos=sq_TextIntextWave(ParentStr, HRnameElementOrder)		// find where C is 
	  			xmanyElem = HRnameElementTotal[pos]		// the total number of parent elements
	 			pos=sq_TextIntextWave(tempStr1, HRnameElementOrderChild)		// find where C is 
	  			xmanyIso= HRnameElementTotalChild[pos]
				
	 			elemIsoRatio = ElementIsotopAbund[HRnameElementOrderIndexChild[idex]]
	 			binomialCoeff=binomial(xmanyElem, xmanyIso)
	 //			print xmanyElem, xmanyIso,elemIsoRatio
				isotopicRatioToParent*=binomialCoeff*(elemIsoRatio)^xmanyIso
			endif
		endfor
		
		if (!isoFlag)
			isotopicRatioToParent=nan
		endif
	endif
	
	killwaves/z  ParentElementCountWave,  ParentHRnameElementOrder, ParentHRnameElementOrderIndex
	killwaves/z  HRnameElementOrderChild, HRnameElementOrderIndexChild, HRnameElementTotalChild
	return isotopicRatioToParent
	
End


// returns a (possibly empty) string containing the name of the ion's isotopic parent
Function/s HR_findIsotopParent(HRIonStr)		//1.19D
string HRIonStr

	string returnStr, jMassStr, ParentStr
	variable idex, num, isoFlag, pos, pos2, xmany,PeriodicTableFlag
	
	wave/t ElementIonName = root:HR:ElementIonName

 	PeriodicTableFlag = HR_OneHRIonElementalComp(HRIonStr)
 	wave ElementCountWave = root:HR_Panel:ElementCountWave
 	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
 	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
 
	returnStr=""
 	if (PeriodicTableFlag)		//1.19D
	 	duplicate/o ElementCountWave ParentElementCountWave
	 	duplicate/o HRnameElementOrder ParentHRnameElementOrder
	 	duplicate/o HRnameElementOrderIndex ParentHRnameElementOrderIndex
		
		num = numpnts(HRnameElementOrder)
	 	
	 	isoFlag=0
	 	
	 	for(idex=num-1;idex>=0;idex-=1)
	  		splitstring/E=("j(\\d{1,3})([[:alpha:]]+)") HRnameElementOrder[idex], jMassStr, ParentStr 
	 		if (strlen(jMassStr)>0)		// element is an isotope
	 			isoFlag=1
	 			pos=sq_TextIntextWave(ParentStr, ElementIonName)
	 			ElementCountWave[pos]+=ElementCountWave[HRnameElementOrderIndex[idex]]
	 			pos2=sq_TextIntextWave(ParentStr, HRnameElementOrder)
	 			if (pos2>=0)			// isotopic parent already in wave
	 				deletepoints idex, 1, HRnameElementOrder, HRnameElementOrderIndex
	 			else
	 				HRnameElementOrder[idex]=ParentStr
	 				HRnameElementOrderIndex[idex]=pos
	 			endif
	 		endif
	 	endfor
	 	
	 	if (isoFlag)
	 		num = numpnts(HRnameElementOrder)
		 	for(idex=0;idex<num;idex+=1)
		 		xmany=ElementCountWave[HRnameElementOrderIndex[idex]]
		 		returnStr+=HRnameElementOrder[idex]+selectString (xmany>1, "", num2str(xmany))
	 		endfor
	 	endif
	else
		redimension/n=0 	HRnameElementOrder,HRnameElementOrderIndex	
	endif 	
 	return returnStr

End


// Given waves of ions to fit, adds them to the 'all' waves if they don't exist, and chooses to fit them
Function HR_addWavesToAll(IonNameWave, IonMassWave, [IsoAbundWave, IsoParentWave, ChooseToFit, DontUpdateChosen])
wave/t IonNameWave, IsoParentWave
wave IonMassWave, IsoAbundWave
variable ChooseToFit, DontUpdateChosen  // 1.20S

	variable idex, num, pos,posParent, count
	wave/t ExactMassText_All = root:HR:ExactMassText_All
	
	num = numpnts(IonNameWave)
	count=0

	for(idex=0;idex<num;idex+=1)
		pos= sq_TextIntextWave(IonNameWave[idex], ExactMassText_All) 
 		if (pos<0)
			if (!ParamIsDefault(IsoAbundWave) && !ParamIsDefault(IsoParentWave))
				HR_addThisMass(IonNameWave[idex], IonMassWave[idex], possibleIsotopAbund=IsoAbundWave[idex],possibleIsotopParent=IsoParentWave[idex],possibleChooseToFit = ChooseToFit)
 			else
				HR_addThisMass(IonNameWave[idex], IonMassWave[idex])
			endif
 			count+=1
		endif
	endfor

 	if (ChooseToFit)
 		HR_change2FitHRIon(IonNameWave, ChooseToFit)
 	endif
 	
 	if (ParamIsDefault(DontUpdateChosen) || DontUpdateChosen!=0)
 		HR_butt_MakeExactMassWaves("")
 		print "// Added "+num2str(count)+" HR ions to the root:HR:ExactMassText_All wave"
	endif
End


// Given a wave of HR ion names, change the mask_stick_integration wave to be 1 so that we fit it
//1.09C
Function HR_change2FitHRIon(HRNameWave,FitFlag)
wave/t HRNameWave
variable fitFlag

	variable idex, num, pos

	wave/t ExactMassText_All = root:HR:ExactMassText_All
	wave Mask_Stick_integration = root:HR:Mask_Stick_integration

	num = numpnts(HRNameWave)
	
	for(idex=0;idex<num;idex+=1)
		pos= sq_TextIntextWave(HRNameWave[idex], ExactMassText_All) 
		if (pos>=0)
			Mask_Stick_integration[pos]=FitFlag
		else
			print "// Could not find HR ion "+HRNameWave[idex] + " in wave ExactMassText_All"
		endif
	endfor
	
End


// button on HR Mass Calculator panel
Function HR_butt_AddListToAll(ctrlName) : ButtonControl
	String ctrlName

	wave/t IsoChildToAllNames = root:HR_Panel:IsoChildToAllNames
	wave IsoChildToAllMass =  root:HR_Panel:IsoChildToAllMass
	wave IsoChildToAllAbund = root:HR_Panel:IsoChildToAllAbund
	wave/t IsoChildToAllParent =  root:HR_Panel:IsoChildToAllParent	// text wave of HR isotopic parents

	nvar NewHRIonQueryChooseToFit = root:HR_panel:NewHRIonQueryChooseToFit

	HR_AddWavesToAll(IsoChildToAllNames, IsoChildToAllMass, IsoAbundWave=IsoChildToAllAbund, IsoParentWave=IsoChildToAllParent, ChooseToFit=NewHRIonQueryChooseToFit)

End


// button on HR Mass Calculator panel.  Find missing isotopic children, those that are not in the all waves.
Function HR_butt_FindIsoChildrenForAll(ctrlName) : ButtonControl
	String ctrlName

//	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	wave/t ExactMassText_all = root:HR:ExactMassText_all

	NewHRIonQueryFindExists=0
	HR_checkProc_massCalc("MCalc_ck_IsoNotExistInAll",1)		// simulate a "Does not exist"  // MCalc_ck_IsoNotExistInAll
	
	make/t/o/n=0 root:HR_Panel:MissIsoChildToAllNames/wave=MissIsoChildToAllNames		// text wave of HR isotopic ions that are not in the all list
	make/t/o/n=0 root:HR_Panel:MissIsoChildToAllParent/wave=MissIsoChildToAllParent	// text wave of HR isotopic parents
	make/o/n=0 root:HR_Panel:MissIsoChildToAllAbund/wave=MissIsoChildToAllAbund		// isotopic abundance
	make/o/n=0 root:HR_Panel:MissIsoChildToAllMass/wave=MissIsoChildToAllMass		// isotopic abundance

	HR_FindMissingIsotopes(ExactMassText_all, HR_isotopeLowerLimit, MissIsoChildToAllNames, MissIsoChildToAllParent, MissIsoChildToAllAbund, MissIsoChildToAllMass) 	
 
	if (numpnts(MissIsoChildToAllNames)==0)
		DoAlert 0, "There are not any missing child isotopes at this time."
	endif

End


//  The idea is to eliminate isotopes that don't fulfill conditions
// candidates are in NewIsotopeHRIonsName,NewIsotopeHRIonsParent, NewIsotopeHRIonsAbundance
// results are put in  IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund)
Function HR_IsotopeSubset(NewIsotopeHRIonsName,NewIsotopeHRIonsParent, NewIsotopeHRIonsAbundance, IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund)
wave/t NewIsotopeHRIonsName, NewIsotopeHRIonsParent, IsoChildToAllNames, IsoChildToAllParent
wave NewIsotopeHRIonsAbundance, IsoChildToAllAbund

	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists		// t or f for whether we search for this or not
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen  // t or f for whether we search for this or not

	wave ExactMassText_All = root:HR:ExactMassText_All
	wave ExactMassText = root:HR_sticks:ExactMassText
	wave IsotopicMassText = root:HR_sticks:IsotopicMassText
	
	variable idex, num, numInTemp
	
	make/t/o/n=0/FREE NamesTemp, ParentTemp	
	make/o/n=0/FREE AbundTemp			// will hold the values we want
	
	make/o/t/n=0  myAandBtext, myAnotBtext, myBnotAtext, myAandBposText
	make/o/n=0  myAandBpos, myAnotBpos, myBnotApos    
	
	gen_CompareTextWaves(NewIsotopeHRIonsName, ExactMassText_All, myAandBtext, myAnotBtext, myBnotAText,  AandBpos=myAandBposText, AnotBpos=myAnotBpos,  BnotApos=myBnotApos )

	if (NewHRIonQueryFindExists)		// ions exist in all

		numInTemp=numpnts(myAandBposText)
		redimension/n=(numInTemp) NamesTemp, ParentTemp, AbundTemp, myAandBpos
		
		if (numInTemp>0)			//1.19B			
			myAandBpos=Str2num(ReplaceString("A", stringFromList(0,myAandBposText[p]), ""))
			NamesTemp[] = NewIsotopeHRIonsName[myAandBpos[p]]
			ParentTemp[] = NewIsotopeHRIonsParent[myAandBpos[p]]
			AbundTemp[] = NewIsotopeHRIonsAbundance[myAandBpos[p]]	
			gen_CompareTextWaves(NamesTemp, ExactMassText, myAandBtext, myAnotBtext, myBnotAText,  AandBpos=myAandBposText, AnotBpos=myAnotBpos,  BnotApos=myBnotApos)
		
			if (NewHRIonQueryFindChildChosen)		// children are fit	
				numInTemp=numpnts(myAandBtext)		//1.12N  fixed typo numpnts(AandBtext)
				redimension/n=(numInTemp) IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund, myAandBpos  //1.20S
				if (numInTemp>0)		//1.19C
					myAandBpos=Str2num(ReplaceString("A", stringFromList(0,myAandBposText[p]), ""))
					IsoChildToAllNames[] = NamesTemp[myAandBpos[p]]
					IsoChildToAllParent[] = ParentTemp[myAandBpos[p]]
					IsoChildToAllAbund[] = AbundTemp[myAandBpos[p]]
				endif	
			else		// children are not fit
				numInTemp=numpnts(myAnotBtext)		//1.12N
				redimension/n=(numInTemp) IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund  //1.20S
				if (numInTemp>0)		//1.19B
					IsoChildToAllNames[] = NamesTemp[myAnotBpos[p]]
					IsoChildToAllParent[] = ParentTemp[myAnotBpos[p]]
					IsoChildToAllAbund[] = AbundTemp[myAnotBpos[p]]
				endif
			endif
		else  // numInTemp=0
			redimension/n=(0) IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund  //1.20S
		endif
	else
		numInTemp=numpnts(myAnotBtext)		
		redimension/n=(numInTemp) IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund  //1.20S
		if (numInTemp>0)				//1.19C
			IsoChildToAllNames[] = NewIsotopeHRIonsName[myAnotBpos[p]]
			IsoChildToAllParent[] = NewIsotopeHRIonsParent[myAnotBpos[p]]
			IsoChildToAllAbund[] = NewIsotopeHRIonsAbundance[myAnotBpos[p]]
		endif
	endif	

	killwaves/z myAandBtext, myAnotBtext, myBnotAtext, myAandBposText, myAandBpos, myAnotBpos, myBnotApos    

End


// Gold button on the HRIonMassCalculator
// Fills in several entries in the calc panel, including all the isotopic children with a minimum lower limit abundance
Function HR_butt_CalcMassOneHRIon(ctrlName) : ButtonControl
	String ctrlName

	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	svar NewHRIonQueryIsoParent = root:HR_panel:NewHRIonQueryIsoParent
	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	nvar NewHRIonQueryIsoAbundance = root:HR_panel:NewHRIonQueryIsoAbundance
	
	svar NewHRIonQueryIsoExists = root:HR_panel:NewHRIonQueryIsoExists
	svar NewHRIonQueryIsoChosen = root:HR_panel:NewHRIonQueryIsoChosen
		
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	wave/t ExactMassText= root:HR_sticks:ExactMassText

	wave/t IsoChildToAllNames = root:HR_Panel:IsoChildToAllNames
	wave/t IsoChildToAllParent =root:HR_Panel:IsoChildToAllParent
	wave IsoChildToAllAbund = root:HR_Panel:IsoChildToAllAbund
	wave IsoChildToAllMass = root:HR_Panel:IsoChildToAllMass
	wave/t NewIsotopeHRIonsParent = root:HR_panel:NewIsotopeHRIonsParent	
	wave/t NewIsotopeHRIonsName= root:HR_panel:NewIsotopeHRIonsName
	wave NewIsotopeHRIonsAbundance = root:HR_panel:NewIsotopeHRIonsAbundance

	variable PeriodicTableFlag=0
	make/o/t/n=0/FREE NamesTemp, ParentTemp //1.21B
	make/o/n=0/FREE AbundTemp  //1.21B

	NewHRIonQueryMass = pk_FindMassFromFormula(NewHRIonQueryText)

	make/o/t/n=0/FREE inVorWnameTemp
	make/o/n=0/FREE  multiChargedtemp
	
	// check if isotope, if so, what is its parent and abundance
	if (strsearch(NewHRIonQueryText, "j", 0)>=0 || strsearch(NewHRIonQueryText, "plus", 0)>=0 || strsearch(NewHRIonQueryText, "inV", 0)>=0  || strsearch(NewHRIonQueryText, "inW", 0)>=0 )  
		 if (strsearch(NewHRIonQueryText, "plus", 0)>=0)
		 	variable plusPos = strsearch(NewHRIonQueryText, "plus", 0)
		 	string plusStr = NewHRIonQueryText[plusPos,strlen(NewHRIonQueryText)-1]
		 	NewHRIonQueryText[plusPos,strlen(NewHRIonQueryText)-1]=""
		 endif
		 if (strsearch(NewHRIonQueryText, "j", 0)>=0 )
			NewHRIonQueryIsoParent = HR_FindIsotopParent(NewHRIonQueryText)
			PeriodicTableFlag=HR_OneHRIonElementalComp(NewHRIonQueryIsoParent)
			if (PeriodicTableFlag)
				NewHRIonQueryText = PK_SortHRionTextByCHNSO(NewHRIonQueryText)   //1.21B
				NewHRIonQueryIsoParent = PK_SortHRionTextByCHNSO(NewHRIonQueryIsoParent)   //1.21B
				NewHRIonQueryIsoAbundance= HR_FindIsotopAbund(NewHRIonQueryText)
			else
				NewHRIonQueryMass=nan
				NewHRIonQueryIsoAbundance=nan
			endif
			redimension/n=0 IsoChildToAllNames
			redimension/n=0 IsoChildToAllParent
			redimension/n=0 IsoChildToAllAbund
			redimension/n=0 IsoChildToAllMass
			if (plusPos)
				NewHRIonQueryIsoParent+=plusStr
			endif
		endif
		if (plusPos)
			NewHRIonQueryText+=plusStr
		endif
	else		// not an isotope - find child isotopes
		PeriodicTableFlag = HR_OneHRIonElementalComp(NewHRIonQueryText)		// sets root:HR_Panel:ElementCountWave

		if (PeriodicTableFlag)
			NewHRIonQueryText = PK_SortHRionTextByCHNSO(NewHRIonQueryText)   //1.21B
			wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
			wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
			wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal
			HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, HR_isotopeLowerLimit, NewIsotopeHRIonsName, NewIsotopeHRIonsAbundance)
			redimension/n=(numpnts(NewIsotopeHRIonsAbundance)) NewIsotopeHRIonsParent
			NewIsotopeHRIonsParent = NewHRIonQueryText
			HR_IsotopeSubset(NewIsotopeHRIonsName,NewIsotopeHRIonsParent, NewIsotopeHRIonsAbundance, IsoChildToAllNames, IsoChildToAllParent, IsoChildToAllAbund)
			pk_recalc_IonMasses(IsoChildToAllNames, IsoChildToAllMass, multiChargedtemp, inVorWnameTemp) // get mass values
			NewHRIonQueryIsoParent=""
			NewHRIonQueryIsoAbundance=nan
		else
			NewHRIonQueryMass=nan		//1.19D
			redimension/N=0 IsoChildToAllNames, IsoChildToAllMass, IsoChildToAllAbund, IsoChildToAllParent
		endif
	endif
	
	if (stringMatch(WinName(0, 65), "HRIonMassCalculator"))
		TitleBox MCalc_titlNonPeriodT,win=HRIonMassCalculator, pos={15,210}, title= SelectString(!PeriodicTableFlag,"", "NON-PERIODIC TABLE ION NAME")
	endif
	
	// update panel
	NewHRIonQueryIsoExists = "Exists? "+ selectString(sq_TextIntextWave(NewHRIonQueryText, ExactMassText_all)>=0,  "No", "Yes")
	NewHRIonQueryIsoChosen = "Chosen to fit? "+ selectString(sq_TextIntextWave(NewHRIonQueryText, ExactMassText)>=0, "No", "Yes")

	// clean up
	killwaves/z IndexWaveTemp,inVorWnameTemp, multiChargedTemp
	killwaves/z NamesTemp,ParentTemp,AbundTemp
	killwaves/z  ParentElementCountWave,  ParentHRnameElementOrder, ParentHRnameElementOrderIndex

	sq_KillWavesInList(WaveList("ElementComboNameTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementComboAbundTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementAbundTemp*", ";", ""))
	sq_KillWavesInList(WaveList("ElementNameTemp*", ";", ""))
	sq_KillWavesInList(WaveList("HRnameElement*", ";", ""))
	
End


// presumes is only done for nonisotopic HR ions
// creates ElementComboNameTemp, ElementComboAbundTemp, ElementNameTemp, ElementAbundTemp which should be killed elsewhere
// Waves HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal should have been found via a previous call to HR_OneHRIonElementalComp
// The maximum number of different elemental ions that it tries to make isotopes is 4.  So it will find all isotopes for H2SO4, C2HNO, etc. but not CHNOS
Function HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, abundTol, resultName, resultAbund)
wave HRnameElementOrder, HRnameElementOrderIndex, HRnameElementTotal, resultAbund
wave/t resultName
variable abundTol

	wave/T ElementIonName = root:HR:ElementIonName		// created in CreateElementWaves
	wave ElementIonMass = root:HR:ElementIonMass		// created in CreateElementWaves
	wave/T ElementIsotopParentList = root:HR:ElementIsotopParentList		// created in CreateElementWaves
	wave/T ElementIsotopParentIndexList = root:HR:ElementIsotopParentIndexList		// created in CreateElementWaves
	wave ElementIsotopAbund = root:HR:ElementIsotopAbund		// created in CreateElementWaves

	variable numElementsInHRIon, idex, jdex,kdex, Ldex, numIsoChild, numElementX, numIso, isoAbund, COUNT, val, zdex, ydex
	string ElementStr, IsoChildList, parentStr, parentIndexList, tempStr1, tempStr2,tempStr3,tempStr4,tempStr5,tempStr6	
	variable val1
	
	// first get IsotopePosList
	numElementsInHRIon=numpnts(HRnameElementOrder)
	for (idex=0;idex<numElementsInHRIon;idex+=1)	// go through all elements
		ElementStr=ElementIonName[HRnameElementOrderIndex[idex]]
		IsoChildList=ElementIsotopParentList[HRnameElementOrderIndex[idex]]
		parentIndexList=ElementIsotopParentIndexList[HRnameElementOrderIndex[idex]]
		numElementX=HRnameElementTotal[idex]
		numIsoChild=itemsInList(IsoChildList)
		
		make/t/o/n=(1) $("root:HR_panel:ElementComboNameTemp"+ElementStr)/Wave=ElementComboName		
		make/o/n=(1) $("root:HR_panel:ElementComboAbundTemp"+ElementStr)/Wave=ElementComboAbund
		if (numElementX==1)		//1.14M
			ElementComboName=ElementStr
		else
			ElementComboName=ElementStr + num2str(numElementX)
		endif
		ElementComboAbund=1

		if (numIsoChild>0)		// this section much cleaned up in 1.12N
			make/t/o/n=(numIsoChild+1) $("root:HR_panel:ElementAtomName"+ElementStr)/Wave=ElementAtomName		
			make/o/n=(numIsoChild+1) $("root:HR_panel:ElementAtomAbund"+ElementStr)/Wave=ElementAtomAbund
			ElementAtomName[0, numIsoChild-1]=stringFromList(p,IsoChildList)
			ElementAtomAbund[0, numIsoChild-1]=str2num(stringFromList(p,parentIndexList))<0 ? 0 : ElementIsotopAbund[str2num(stringFromList(p, parentIndexList))]
			
			ElementAtomName[numIsoChild]=ElementStr
			ElementAtomAbund[numIsoChild]=1
 			
 			HR_getIsoAbundXmany(ElementAtomName, ElementAtomAbund, numElementX, ElementComboName, ElementComboAbund) 
 		endif
	
	endfor
	
	// now combine all the elementComboWaves
	switch(numElementsInHRIon)
		case 1:		// HR ion is a single element such as O
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)		//1.14G
				val1=ElementAbundTemp1[jdex]
				if (val1>abundTol && val1!=1 )
					insertpoints Count,1, resultAbund, resultName		
					tempStr1 = ElementNameTemp1[jdex]
					resultName[Count] = tempStr1
					resultAbund[Count] = val1
					count+=1
				endif
			endfor
		break
		case 2:		// there are only 2 elements such as HO
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave/t ElementNameTemp2 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave ElementAbundTemp2 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)
				for(kdex=0;kdex<numpnts(ElementNameTemp2);kdex+=1)
					val1=ElementAbundTemp1[jdex]*ElementAbundTemp2[kdex]
					if (val1>abundTol && val1!=1 )
						insertpoints Count,1, resultAbund, resultName		
						tempStr1 = ElementNameTemp1[jdex]
						tempStr2 = ElementNameTemp2[kdex]
						resultName[Count] = tempStr1+tempStr2
						resultAbund[Count] = val1
						count+=1
					endif
				endfor
			endfor
		break
		case 3:		// there are 3 elements such as C3H3O
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave/t ElementNameTemp2 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave ElementAbundTemp2 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave/t ElementNameTemp3 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave ElementAbundTemp3 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)
				for(kdex=0;kdex<numpnts(ElementNameTemp2);kdex+=1)
					for(Ldex=0;Ldex<numpnts(ElementNameTemp3);Ldex+=1)
						val1=ElementAbundTemp1[jdex]*ElementAbundTemp2[kdex]*ElementAbundTemp3[Ldex]
						// print val, ElementNameTemp1[jdex], ElementNameTemp2[kdex], ElementNameTemp3[Ldex]
						if (val1>abundTol && val1!=1 )
							insertpoints Count,1, resultAbund, resultName		
							tempStr1 = ElementNameTemp1[jdex]
							tempStr2 = ElementNameTemp2[kdex]
							tempStr3 = ElementNameTemp3[Ldex]
							resultName[Count] = tempStr1+tempStr2+tempStr3
							resultAbund[Count] = val1
							count+=1
//							print jdex, kdex, Ldex
						else
						continue
						endif
					endfor
				endfor
			endfor
		break
		case 4:		// there are 4 elements such as C3H3OS
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave/t ElementNameTemp2 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave ElementAbundTemp2 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave/t ElementNameTemp3 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave ElementAbundTemp3 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave/t ElementNameTemp4 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			wave ElementAbundTemp4 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)
				for(kdex=0;kdex<numpnts(ElementNameTemp2);kdex+=1)
					for(Ldex=0;Ldex<numpnts(ElementNameTemp3);Ldex+=1)
						for(idex=0;idex<numpnts(ElementNameTemp4);idex+=1)
							val1=ElementAbundTemp1[jdex]*ElementAbundTemp2[kdex]*ElementAbundTemp3[Ldex]*ElementAbundTemp4[idex]

							if (val1>abundTol && val1!=1 )

								insertpoints Count,1, resultAbund, resultName		
								tempStr1 = ElementNameTemp1[jdex]
								tempStr2 = ElementNameTemp2[kdex]
								tempStr3 = ElementNameTemp3[Ldex]
								tempStr4 = ElementNameTemp4[idex]
								resultName[Count] = tempStr1+tempStr2+tempStr3+tempStr4
								resultAbund[Count] = val1
								count+=1

							else
								continue
							endif
						endfor
					endfor
				endfor
			endfor
		break
		case 5:		// there are 5 elements such as C3H3OSNa // 1.21A
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave/t ElementNameTemp2 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave ElementAbundTemp2 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave/t ElementNameTemp3 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave ElementAbundTemp3 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave/t ElementNameTemp4 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			wave ElementAbundTemp4 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			wave/t ElementNameTemp5 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[4]]
			wave ElementAbundTemp5 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[4]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)
				for(kdex=0;kdex<numpnts(ElementNameTemp2);kdex+=1)
					for(Ldex=0;Ldex<numpnts(ElementNameTemp3);Ldex+=1)
						for(idex=0;idex<numpnts(ElementNameTemp4);idex+=1)
							for(zdex=0;zdex<numpnts(ElementNameTemp5);zdex+=1)
								val1=ElementAbundTemp1[jdex]*ElementAbundTemp2[kdex]*ElementAbundTemp3[Ldex]*ElementAbundTemp4[idex]*ElementAbundTemp5[zdex]
	
								if (val1>abundTol && val1!=1 )
	
									insertpoints Count,1, resultAbund, resultName		
									tempStr1 = ElementNameTemp1[jdex]
									tempStr2 = ElementNameTemp2[kdex]
									tempStr3 = ElementNameTemp3[Ldex]
									tempStr4 = ElementNameTemp4[idex]
									tempStr5 = ElementNameTemp5[zdex]
									resultName[Count] = tempStr1+tempStr2+tempStr3+tempStr4+tempStr5
									resultAbund[Count] = val1
									count+=1
	
								else
									continue
								endif
							endfor
						endfor
					endfor
				endfor
			endfor
		break
		case 6:		// there are 6 elements such as C3H3NOSNa // 1.21A
			redimension/n=(0) resultAbund, resultName
			count=0
			wave/t ElementNameTemp1 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave ElementAbundTemp1 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[0]]
			wave/t ElementNameTemp2 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave ElementAbundTemp2 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[1]]
			wave/t ElementNameTemp3 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave ElementAbundTemp3 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[2]]
			wave/t ElementNameTemp4 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			wave ElementAbundTemp4 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[3]]
			wave/t ElementNameTemp5 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[4]]
			wave ElementAbundTemp5 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[4]]
			wave/t ElementNameTemp6 = $"root:HR_panel:ElementComboNameTemp"+ElementIonName[HRnameElementOrderIndex[5]]
			wave ElementAbundTemp6 = $"root:HR_panel:ElementComboAbundTemp"+ElementIonName[HRnameElementOrderIndex[5]]
			for(jdex=0;jdex<numpnts(ElementNameTemp1);jdex+=1)
				for(kdex=0;kdex<numpnts(ElementNameTemp2);kdex+=1)
					for(Ldex=0;Ldex<numpnts(ElementNameTemp3);Ldex+=1)
						for(idex=0;idex<numpnts(ElementNameTemp4);idex+=1)
							for(zdex=0;zdex<numpnts(ElementNameTemp5);zdex+=1)
								for(ydex=0;ydex<numpnts(ElementNameTemp6);zdex+=1)
									val1=ElementAbundTemp1[jdex]*ElementAbundTemp2[kdex]*ElementAbundTemp3[Ldex]*ElementAbundTemp4[idex]*ElementAbundTemp5[zdex]*ElementAbundTemp6[ydex]
		
									if (val1>abundTol && val1!=1 )
		
										insertpoints Count,1, resultAbund, resultName		
										tempStr1 = ElementNameTemp1[jdex]
										tempStr2 = ElementNameTemp2[kdex]
										tempStr3 = ElementNameTemp3[Ldex]
										tempStr4 = ElementNameTemp4[idex]
										tempStr5 = ElementNameTemp5[zdex]
										tempStr6 = ElementNameTemp6[ydex]
										resultName[Count] = tempStr1+tempStr2+tempStr3+tempStr4+tempStr5+tempStr6
										resultAbund[Count] = val1
										count+=1
		
									else
										continue
									endif
								endfor
							endfor
						endfor
					endfor
				endfor
			endfor
		break
	case 0:  //1.21C
		break  // Should throw an error?
	default:  //1.21A
		Abort "It seems that you have more than 6 different elements in this HR ion. This seems like a mistake.  Aborting from HR_getAllIsotopicChildren."
	//	case :		// bailing
	endswitch		

End


Function/s gen_partialstringfromList(str, str2find, [delimiter])
string str, str2find, delimiter

	string returnStr, mydelimiter
	variable pos, posStart, posEnd

	returnStr=""
	delimiter = selectString(ParamIsDefault(delimiter), delimiter, ";")
	pos = strsearch(str, str2find, 0)

	if (pos>=0)

		posStart=strsearch(str, delimiter, pos, 1)
		posEnd=strsearch(str, delimiter, pos)
		posEnd = posEnd>0 ? posEnd : strlen(str)
//		print posStart, posEnd, strlen(str)
		returnStr = str[posStart+1, posEnd-1]

	endif

	return returnStr

End


Function HR_butt_ShowPkHtsGr(ctrlName) : ButtonControl
	String ctrlName
	
	DoWindow/F HR_peakHeights_gr
	
End


Function HR_butt_ViewHRIntegerSpectra(ctrlName) : ButtonControl
	String ctrlName

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF

	if (HR_singleSpectraMSorPToF==0)
		abort "This option is not available for HR PToF data  aborting from HR_butt_ViewHRIntegerSpectra"
	endif
 	
 	DoWindow/F SqVsPk_OneRun_Panel			//1.09H
 	if (V_flag==0)
 		HR_SqVsPk_OneRun_Panel()
 	endif
 	
 //	UM_PlotIntMassSpectra("Open",1)
//	UM_PlotIntMassSpectra("Closed",1)
//	UM_PlotIntMassSpectra("Diff",1)

End


//1.09H a sq vs pika panel for one run
Function HR_SqVsPk_OneRun_Panel()

	sq_initializeGlobalNVar("root:HR_panel:SQvsPikaMSlog_ck", 1)
	sq_initializeGlobalNVar("root:HR_panel:SQvsPikaMSCorrlog_ck", 1)
	nvar SQvsPikaMSlog_ck = root:HR_panel:SQvsPikaMSlog_ck
	nvar SQvsPikaMSCorrlog_ck = root:HR_panel:SQvsPikaMSCorrlog_ck

	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(140,90,620,330)/N=SqVsPk_OneRun_Panel as "SqVsPk_OneRun_Panel"
	SetDrawLayer UserBack
	DrawText 11,68,"MS"
	DrawText 270,68,"MS Corr."
	SetDrawEnv fsize= 18,fstyle= 1
	DrawText 6,22,"Squirrel vs Pika, Step 4"		//1.16H
	
	TabControl tabSpecies,pos={5,32},size={469,201},proc=SqVsPkOneRunTabProc
	TabControl tabSpecies,tabLabel(0)="Diff",tabLabel(1)="Open",tabLabel(2)="Closed"
	TabControl tabSpecies,value= 0

	Button HR_but_HR_SQvsPk1MSGraph,pos={195,50},size={50,20},proc=sq_butt_popThis,title="Pop"
	Button HR_but_HR_SQvsPk1MSCorrGraph,pos={419,50},size={50,20},proc=sq_butt_popThis,title="Pop"
	CheckBox check_logMS,pos={87,53},size={57,14},proc=HR_SqvsPk_CheckProc_leftAxisLog,title="Log axis"
	CheckBox check_logMS,variable= root:HR_panel:SQvsPikaMSlog_ck
	CheckBox check_logCorr,pos={356,53},size={57,14},proc=HR_SqvsPk_CheckProc_allAxisLog,title="Log axis"
	CheckBox check_logCorr,variable= root:HR_panel:SQvsPikaMSCorrlog_ck
	Button button0,pos={350,4},size={120,20},proc=HR_butt_familyTableLegend,title="Family color legend"
	Button button1,pos={369,25},size={100,20},proc=HR_butt_ShowPkHtsGr,title="Main Pika gr"
	TitleBox title0,pos={1,50},size={50,20}
	TitleBox titleRunInfo,pos={215,5},size={150,26},fSize=10,frame=0,fStyle=1  	//1.16H
	TitleBox titleRunInfo,variable= root:HR_Sticks:HR_SticksGr_RunInfo

	Display/W=(10,70,250,220)/HOST=# 
	RenameWindow #,HR_SQvsPk1MSGraph
	SetActiveSubwindow ##
	
	Display/W=(260,70,470,220)/HOST=# 
	RenameWindow #,HR_SQvsPk1MSCorrGraph
	SetActiveSubwindow ##

	HR_plotSqVsPk1RunGrs()

End


//1.09H a sq vs pika panel for one run
// plots spectra plot and correlation plot
Function	HR_plotSqVsPk1RunGrs()
		
	svar todoStr=root:panel:sq_toDoWvNm
//	nvar HRResults_dataType=root:HR_panel:HRResults_dataType // a numerical value

	string SpecType

 	ControlInfo/W=SqVsPk_OneRun_Panel tabSpecies
	SpecType = S_value
	
	doWIndow/f SqVsPk_OneRun_Panel

	setwindow SqVsPk_OneRun_Panel,userdata(SpecType)=SpecType

	// important to do the correlation plot first, as the totalPika stick is used in the plotting of the mass spectra plot.
	SetActiveSubwindow SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph
	gen_removeTracesFromGraph("SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph")
	HR_populate_SQvsPk1MSCorrGraph()
	DoWindow/F	SqVsPk_OneRun_Panel
	SetActiveSubwindow ##
	
	SetActiveSubwindow SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph
	gen_removeTracesFromGraph("SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph")
	HR_populate_SQvsPk1MSGraph()
	DoWindow/F	SqVsPk_OneRun_Panel
	SetActiveSubwindow ##
	
	// deal with possibly popped windows
	DoWindow/F HR_SqvsPk1MSCorrGraph
	if (V_flag)
		gen_removeTracesFromGraph("HR_SQvsPk1MSCorrGraph")
		HR_populate_SQvsPk1MSCorrGraph()
	endif
	
	DoWindow/F HR_SqvsPk1MSGraph
	if (V_flag)
		gen_removeTracesFromGraph("HR_SqvsPk1MSGraph")
		HR_populate_SQvsPk1MSGraph()
	endif
	
End


//1.09H a sq vs pika panel for one run
Function SqVsPkOneRunTabProc(ctrlName,tabNum) : TabControl
	String ctrlName
	Variable tabNum

 	ControlInfo/W=SqVsPk_OneRun_Panel tabSpecies
	setwindow SqVsPk_OneRun_Panel,userdata(spectraType)=S_Value

	HR_plotSqVsPk1RunGrs()

End


//1.09H a sq vs pika panel for one run
Function HR_populate_SQvsPk1MSGraph()

	string SpecType = getuserdata("SqVsPk_OneRun_Panel","","SpecType")
	UM_PlotIntMassSpectra(SpecType, 0)

	nvar SQvsPikaMSlog_ck = root:HR_panel:SQvsPikaMSlog_ck
	wave/t amu_HR_text = root:HR_Sticks:amu_HR_text 		// for use in plotting
	variable minStick, maxStick	
	ModifyGraph grid=2,gridRGB=(34816,34816,34816)
	
	wave MSSWave = $"root:Int_Sticks:MSS"+SpecType+"_p_OneSpectra"	
	wave totPika= $"root:Int_Sticks:int_totPika_"+SpecType		// this wave is created in the correlation plot.

	minStick =min(min(100,WaveMin(MSSWave)),WaveMin(totPika))
	maxStick =max(max(0,WaveMax(MSSWave)),WaveMax(totPika))

	if (SQvsPikaMSlog_ck)
		SetAxis left max(abs(minStick), 1e-3),maxStick
	else
		SetAxis left min(0,minStick),maxStick
	endif

	SetAxis bottom 10, numpnts(amu_HR_text)+1
	Label bottom "m/z"
	Label left "Hz"
	
	HR_SqvsPk_CheckProc_leftAxisLog("",SQvsPikaMSlog_ck)
	
End


//1.09H a sq vs pika panel for one run
Function HR_populate_SQvsPk1MSCorrGraph()

	variable idex, num, minStick, maxStick
	string FamilyStickStr, legendStr, paramStr, spectraType
	wave/t/z HR_familyName = root:HR:HR_familyName
	wave/z UnitMass = root:HR_Sticks:UnitMass
	
	nvar SQvsPikaMSCorrlog_ck = root:HR_panel:SQvsPikaMSCorrlog_ck
	spectraType = getuserdata("SqVsPk_OneRun_Panel","","SpecType")

	num=numpnts(HR_familyName)
	for  (idex =0;idex<num;idex+=1)
		FamilyStickStr = HR_familyName[idex]
		wave/z int_wave = $"root:Int_Sticks:int_"+FamilyStickStr+"_"+spectraType	// we can add a family after we have done this
		if (idex==0 && WaveExists(int_wave))
			duplicate/o int_wave $"root:Int_Sticks:int_totPika_"+spectraType
		endif
		wave totPika= $"root:Int_Sticks:int_totPika_"+spectraType
		if (idex>0  && WaveExists(int_wave) )
			totPika+=int_wave
		endif
	endfor
	
	variable lastMz = UnitMass[numpnts(UnitMass)-1]

	wave OneSpectra = $"root:int_sticks:MSS"+spectraType+"_p_onespectra"
	wave One2one = root:HR_panel:One2one		//1.07A
	
	make/t/o/n=(lastMz) root:HR_Sticks:amu_HR_text = num2str(p+1)
	 Wave amu_HR_text=root:HR_Sticks:amu_HR_text 	// for use in plotting
	
	minStick =min(min(100,WaveMin(OneSpectra)),WaveMin(totPika))
	maxStick =max(max(0,WaveMax(OneSpectra)),WaveMax(totPika))
	
	setwindow SqVsPk_OneRun_Panel,userdata(stickMin)=num2str(minStick)
	setwindow SqVsPk_OneRun_Panel,userdata(stickMax)=num2str(maxStick)

	if (WhichListItem("one2one", TraceNameList(WinName(1, 1), ";", 1 ))<0 )
		AppendToGraph OneSpectra vs totPika
	endif
	AppendToGraph one2one vs one2one
	ModifyGraph mode($NameofWave(oneSpectra))=3
	ModifyGraph msize($NameofWave(oneSpectra))=5
	ModifyGraph mrkThick($NameofWave(oneSpectra))=2
	ModifyGraph textMarker($NameofWave(oneSpectra))={root:HR_Sticks:amu_HR_text,"default",0,0,5,0.00,0.00}
	ModifyGraph grid=2,gridRGB=(34816,34816,34816)
	Label left "Squirrel, Hz"
	Label bottom "Pika, Hz"
	if (SQvsPikaMSCorrlog_ck)
		SetAxis left max(abs(minStick), 1e-3),maxStick
		SetAxis bottom max(abs(minStick), 1e-3),maxStick
	else
		SetAxis left min(0,minStick),maxStick
		SetAxis bottom min(0,minStick),maxStick
	endif
	HR_SqvsPk_CheckProc_allAxisLog("",SQvsPikaMSCorrlog_ck)

End


//1.09H a sq vs pika panel for one run
// for getting the mass spectra on a log plot
Function HR_SqvsPk_CheckProc_leftAxisLog(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	if (checked)
		ModifyGraph/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph log(left)=1
		GetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph/Q left
		if (V_min<1e-5)		//1e-5 is arbitrary
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph left 1e-05,V_max
		endif
	else
		ModifyGraph/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph log(left)=0
		GetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph/Q left
		if (V_min>=1e-5)		//1e-5 is arbitrary
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSGraph left 0,V_max
		endif
	endif
	DoWindow/F HR_SQvsPk1MSGraph
	if (V_flag)
		if (checked)
			ModifyGraph/W=HR_SQvsPk1MSGraph log(left)=1
			GetAxis/W=HR_SQvsPk1MSGraph/Q left
			if (V_min<1e-5)		//1e-5 is arbitrary
				SetAxis/W=HR_SQvsPk1MSGraph left 1e-05,V_max
			endif
		else
			ModifyGraph/W=HR_SQvsPk1MSGraph log(left)=0
			GetAxis/W=HR_SQvsPk1MSGraph/Q left
			if (V_min>=1e-5)		//1e-5 is arbitrary
				SetAxis/W=HR_SQvsPk1MSGraph left 0,V_max
			endif
		endif
	endif
End


//1.09H a sq vs pika panel for one run
// for getting the spectra correlation on log axis
Function HR_SqvsPk_CheckProc_allAxisLog(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
	if (checked)
		ModifyGraph/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph log=1
		GetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph/Q left
		if (V_min<1e-5)		//1e-5 is arbitrary
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph left 1e-05,V_max
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph bottom 1e-05,V_max
		endif
	else
		ModifyGraph/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph log=0
		GetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph/Q left
		if (V_min>=1e-5)		//1e-5 is arbitrary
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph left 0,V_max
			SetAxis/W=SqVsPk_OneRun_Panel#HR_SQvsPk1MSCorrGraph bottom 0,V_max
		endif
	endif
	DOWindow/F HR_SQvsPk1MSCorrGraph
	if (V_flag)
		if (checked)
			ModifyGraph/W=HR_SQvsPk1MSCorrGraph log=1
			GetAxis/W=HR_SQvsPk1MSCorrGraph/Q left
			if (V_min<1e-5)		//1e-5 is arbitrary
				SetAxis/W=HR_SQvsPk1MSCorrGraph left 1e-05,V_max
				SetAxis/W=HR_SQvsPk1MSCorrGraph bottom 1e-05,V_max
			endif
		else
			ModifyGraph/W=HR_SQvsPk1MSCorrGraph log=0
			GetAxis/W=HR_SQvsPk1MSCorrGraph/Q left
			if (V_min>=1e-5)		//1e-5 is arbitrary
				SetAxis/W=HR_SQvsPk1MSCorrGraph left 0,V_max
				SetAxis/W=HR_SQvsPk1MSCorrGraph bottom 0,V_max
			endif
		endif
	endif
End

// RemoveNaNs(theWave)
//	Removes all points in the wave with the value NaN.
//	A NaN represents a blank or missing value.
//	Returns the number of points removed.
Function gen_RemoveNaNs(theWave)
	Wave theWave

	Variable p, numPoints, numNaNs
	Variable val
	
	numNaNs = 0
	p = 0											// the loop index
	numPoints = numpnts(theWave)				// number of times to loop

	do
		val = theWave[p]
		if (numtype(val)==2)					// is this NaN?
			numNaNs += 1
		else										// if not NaN
			theWave[p - numNaNs] = val			// copy to input wave
		endif
		p += 1
	while (p < numPoints)
	
	// Truncate the wave
	DeletePoints numPoints-numNaNs, numNaNs, theWave
	
	return(numNaNs)
End


//1.09K
Function HR_FindRelatedHRIonSuffix(HRroot, HRsuffix, maxmz)
string HRroot, HRsuffix
variable maxmz

	wave ChemicalFormulaMass = root:HR_Sticks:ChemicalFormulaMass		// will contain results
	wave/t ChemicalFormulaText = root:HR_Sticks:ChemicalFormulaText

	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen
	nvar Query_addC = root:HR_panel:Query_addC
	nvar Query_addCH = root:HR_panel:Query_addCH
	nvar Query_addCH2 = root:HR_panel:Query_addCH2

	HR_OneHRIonElementalComp(HRroot)		// sets root:HR_Panel:ElementCountWave
	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
	wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal

	variable idex, num, Cflag, Hflag, Oflag, numC, numH, count, pos
	string carbonStr,hydroStr, ListA, ListB, ListC
	
	FindValue/TEXT="C"/TXOP=7 HRnameElementOrder
	Cflag = V_Value
	FindValue/TEXT="H"/TXOP=7 HRnameElementOrder
	Hflag = V_Value
	
	if ( Cflag<0  || Hflag< 0 || numpnts(HRnameElementOrder)!=2)
		abort "At this time the only allowable R root values use only C and H atoms.  Aborting from FindRelatedHRIonSuffix"
	endif
	
	numC=HRnameElementTotal[Cflag]
	numH=HRnameElementTotal[Hflag]
	count=0
	
	redimension/n=0 ChemicalFormulaText
	
	for(idex=1;idex<100;idex+=1)			// 100 is arbitrary
		carbonStr="C"+num2str(numC+idex*1)	
		
		// add a C group
		if (Query_addC)
			insertpoints count, 1, ChemicalFormulaText
			hydroStr="H"+selectString(numH==1, num2str(numH), "")	
			ChemicalFormulaText[count]=carbonStr+hydroStr+HRsuffix
			count+=1
		endif
		// add a CH group
		if (Query_addCH)
			insertpoints count, 1, ChemicalFormulaText
			hydroStr="H"+selectString((numH+idex*1)==1, num2str(numH+idex*1), "")	
//			ChemicalFormulaText[count+1]=carbonStr+hydroStr+HRsuffix  // 1.20X
			ChemicalFormulaText[count]=carbonStr+hydroStr+HRsuffix
			count+=1
		endif

		// add a CH2 group
		if (Query_addCH2)
			insertpoints count, 1, ChemicalFormulaText
			hydroStr="H"+num2str(numH+idex*2)	
	//		ChemicalFormulaText[count+2]=carbonStr+hydroStr+HRsuffix // 1.20X
			ChemicalFormulaText[count]=carbonStr+hydroStr+HRsuffix
			count+=1
		endif
	
	endfor	
	make/FREE/o/n=0 multiChargedtemp
	make/FREE/o/n=0/T inVorWnameTemp
	PK_recalc_IonMasses(ChemicalFormulaText, ChemicalFormulaMass, multiChargedtemp, inVorWnameTemp)

	//1.11L fix
	Sort ChemicalFormulaMass, ChemicalFormulaText, multiChargedtemp, inVorWnameTemp
	Sort ChemicalFormulaMass, ChemicalFormulaMass
	
	//1.11L fix
	pos = floor(BinarySearchInterp(ChemicalFormulaMass, maxmz ))
	if (Pos>=0)
		deletepoints pos, numpnts(ChemicalFormulaText), ChemicalFormulaText, ChemicalFormulaMass
	endif

	// now limit to the ions we want
	ListA=gen_TextWave2List(ChemicalFormulaText)
	switch(HR_checkQueryChosen)
	case 0:	// all HR ions in list
		Wave ExactMassText_all = root:HR:ExactMassText_all
		ListB=gen_TextWave2List(ExactMassText_all)
	 	ListC=gen_SameInBothLists(listA, listB)
	 	gen_List2textWave(ListC, ChemicalFormulaText)
	 break
	case 1:	// all  chosen HR ions
		Wave ExactMassText = root:HR_sticks:ExactMassText
		ListB=gen_TextWave2List(ExactMassText)
	 	ListC=gen_SameInBothLists(listA, listB)
	 	gen_List2textWave(ListC, ChemicalFormulaText)
	break
	case 2:	// HR ions not in list
		Wave ExactMassText_all = root:HR:ExactMassText_all
		ListB=gen_TextWave2List(ExactMassText_all)
	 	ListC=gen_InListANotListB(listA, listB)
	 	gen_List2textWave(ListC, ChemicalFormulaText)
	break
	endswitch
	
	PK_recalc_IonMasses(ChemicalFormulaText, ChemicalFormulaMass, multiChargedtemp, inVorWnameTemp)

End


//1.09K
Function HR_MassCalcQueryHRionTab(ctrlName,tab) : TabControl
	String ctrlName
	Variable tab

	variable cont_disp,tab_1,idex,num
	string cont_list, cont_item

	cont_list=controlnamelist("")
	num=itemsinlist(cont_list)
	for (idex=0;idex<num;idex+=1)
		cont_item=stringfromlist(idex,cont_list)
		strswitch (cont_item[0,3])
			case "MCal": 	// R root
				cont_disp=tab!=0
				break
			case "Veri":	//\
				cont_disp=tab!=1
				break
			case "Quer":	// query for CHNOS
				cont_disp=tab!=2
				break
			case "HRCo":	//	compare
				cont_disp=tab!=3
				break
			case "Fami":	//	compare
				cont_disp=tab!=4
				break
			default:
				cont_disp=0
		endswitch
		controlinfo /w=HRIonMassCalculator $cont_item
		switch (abs(v_flag))
			case 1:
				button $cont_item disable=cont_disp
				break
			case 2:
				checkbox  $cont_item disable=cont_disp
				break
			case 3:
				popupmenu $cont_item disable=cont_disp
				break
			case 4:
				valdisplay $cont_item disable=cont_disp
				break
			case 5:
				setvariable $cont_item disable=cont_disp
				break
			case 6:
				chart $cont_item disable=cont_disp
				break
			case 7:
				slider $cont_item disable=cont_disp
				break
			case 8:
				tabcontrol $cont_item disable=cont_disp
				break
			case 9:
				groupbox $cont_item disable=cont_disp
				break
			case 10:
				titlebox $cont_item disable=cont_disp
				break
			case 11:
				listbox $cont_item disable=cont_disp
				break
		endswitch
	endfor
	
	SetWindow HRIonMassCalculator#HRIsotopChildrenTable, hide=1 
	SetWindow  HRIonMassCalculator#HRPeriodicTable, hide=1 

	SetWindow  HRIonMassCalculator#HRConflictTable, hide=1 
	SetWindow  HRIonMassCalculator#HRProblemIsoTable, hide=1 
	SetWindow  HRIonMassCalculator#HRMissIsoChildTable, hide=1 
	SetWindow  HRIonMassCalculator#HRUnfitIsolTable, hide=1 

	SetWindow  HRIonMassCalculator#HRChemFormTable, hide=1 

	SetWindow  HRIonMassCalculator#HRAorBTable, hide=1 
	SetWindow  HRIonMassCalculator#HRABOptionalTable, hide=1 
	SetWindow  HRIonMassCalculator#HRAllWaveDescrip, hide=1 

	if(tab==0)
		SetWindow  HRIonMassCalculator#HRPeriodicTable, hide=0 
		SetWindow  HRIonMassCalculator#HRIsotopChildrenTable, hide=0 
	elseif(tab==1)
		SetWindow  HRIonMassCalculator#HRConflictTable, hide=0 
		SetWindow  HRIonMassCalculator#HRProblemIsoTable, hide=0 
		SetWindow  HRIonMassCalculator#HRMissIsoChildTable, hide=0 
		SetWindow  HRIonMassCalculator#HRUnfitIsolTable, hide=0 
	elseif(tab==2)
		SetWindow  HRIonMassCalculator#HRChemFormTable, hide=0 
	elseif(tab==3)
		SetWindow  HRIonMassCalculator#HRAorBTable, hide=0 
		SetWindow  HRIonMassCalculator#HRABOptionalTable, hide=0 
		SetWindow  HRIonMassCalculator#HRAllWaveDescrip, hide=0

	endif
	
End


//1.09K
// table in HR ion mass calculator panel
Function HR_populate_QueryTable()

	Appendtotable root:HR_Sticks:ChemicalFormulaText
	Appendtotable root:HR_Sticks:ChemicalFormulaMass

	ModifyTable format(Point)=1,width(Point)=18,width( root:HR_Sticks:ChemicalFormulaText)=72,title( root:HR_Sticks:ChemicalFormulaText)="HR Ion"
	ModifyTable format( root:HR_Sticks:ChemicalFormulaMass)=3,digits( root:HR_Sticks:ChemicalFormulaMass)=6,width( root:HR_Sticks:ChemicalFormulaMass)=62
	ModifyTable title( root:HR_Sticks:ChemicalFormulaMass)="Mass"
End


//1.09K
Function HR_ChemFormFind(MaxMz)
variable MaxMz

	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen

	if (HR_checkQueryChosen==1)
		wave exactMassWave = root:HR_sticks:exactMassWave
		wave/t exactMassText = root:HR_sticks:exactMassText
	else
		wave/d exactMassWave = root:HR:exactMassWave_all
		wave/t exactMassText = root:HR:exactMassText_all
	endif
	
	nvar/z HRIonMassCalcAllowOther = root:HR_Panel:HRIonMassCalcAllowOther
	if (!NVar_exists(HRIonMassCalcAllowOther))
		variable/g  root:HR_Panel:HRIonMassCalcAllowOther=1
		nvar/z HRIonMassCalcAllowOther = root:HR_Panel:HRIonMassCalcAllowOther
	endif

	nvar/z HRIonMassCalcAllowIso = root:HR_Panel:HRIonMassCalcAllowIso
	if (!NVar_exists(HRIonMassCalcAllowIso))
		variable/g  root:HR_Panel:HRIonMassCalcAllowIso=1
		nvar/z HRIonMassCalcAllowIso = root:HR_Panel:HRIonMassCalcAllowIso
	endif

	wave ChemicalFormulaMass = root:HR_Sticks:ChemicalFormulaMass
	wave/t ChemicalFormulaText = root:HR_Sticks:ChemicalFormulaText
	
	variable numC, numO, numH, numN, numS, pos
	
	// popmenus any,0,1,1+,2, 2+  popmenus count from 1
	ControlInfo Query_CHONS_popNumC
	numC = V_Value - 2
	if (stringMatch(S_value, "Select option"))
		abort "Please select the number of elements you want to search for. - aborting from HR_ChemFormFind"
	endif	
	ControlInfo Query_CHONS_popNumH
	numH = V_Value - 2
	if (stringMatch(S_value, "Select option"))
		abort "Please select the number of elements you want to search for. - aborting from HR_ChemFormFind"
	endif	
	ControlInfo Query_CHONS_popNumO
	numO = V_Value - 2
	if (stringMatch(S_value, "Select option"))
		abort "Please select the number of elements you want to search for. - aborting from HR_ChemFormFind"
	endif	
	ControlInfo Query_CHONS_popNumN
	numN = V_Value - 2
	if (stringMatch(S_value, "Select option"))
		abort "Please select the number of elements you want to search for. - aborting from HR_ChemFormFind"
	endif	
	ControlInfo Query_CHONS_popNumS
	numS = V_Value - 2
	if (stringMatch(S_value, "Select option"))
		abort "Please select the number of elements you want to search for. - aborting from HR_ChemFormFind"
	endif	
		
	redimension/n=(numpnts(exactMassText)) ChemicalFormulaText
	ChemicalFormulaText=exactMassText
	
	if (numC>=0)
		HR_RemoveHRIonsOfNumElem(ChemicalFormulaText, numC, "C", "a|u|l|r|o")
	endif
	if (numH>=0)
		HR_RemoveHRIonsOfNumElem(ChemicalFormulaText, numH, "H", "g|f|e")
	endif
	if (numO>=0)
		HR_RemoveHRIonsOfNumElem(ChemicalFormulaText, numO, "O", "x")
	endif
	if (numN>=0)
		HR_RemoveHRIonsOfNumElem(ChemicalFormulaText, numN, "N", "e|a|i|b|d|o")
	endif
	if (numS>=0)
		HR_RemoveHRIonsOfNumElem(ChemicalFormulaText, numS, "S", "e|a|i|b|d|o")
	endif
		
	make/n=0/o/FREE multiChargedtemp
	make/t/n=0/o/FREE inVorWnameTemp
	pk_recalc_IonMasses(ChemicalFormulaText, ChemicalFormulaMass, multiChargedtemp, inVorWnameTemp) // get mass values
	pos = BinarySearchInterp(ChemicalFormulaMass, MaxMz)
	if (pos>=0)
		deletePoints ceil(pos), numpnts(ChemicalFormulaText), ChemicalFormulaText, ChemicalFormulaMass
	endif

	if (!HRIonMassCalcAllowIso)
		HR_removeIsotopesfromList(ChemicalFormulaText, "root:HR_Sticks:ChemicalFormulaMass")
	endif

	if (!HRIonMassCalcAllowOther)
		HR_removeNonCHONS(ChemicalFormulaText, "root:HR_Sticks:ChemicalFormulaMass")
	endif

End


//1.09K
Function HR_RemoveHRIonsOfNumElem(exactMassText, NumElemRequested, elementStr, elementException)
wave/t exactMassText
string elementStr, elementException
variable NumElemRequested

	variable idex, num, numX, isOdd = mod(NumElemRequested,2), n = (NumElemRequested - isOdd)/2
	string massStr
	
	num = numpnts(exactMassText)
	for (idex=num-1;idex>=0;idex-=1)			// 	redone in 1.20X
		massStr=exactMassText[idex]		
		numX = HR_ReturnNumElements(massStr, elementStr,  elementException)
		if (NumElemRequested==0)
			if (numX!=0)
				deletepoints idex, 1, exactMassText
			endif
		else 
			if(isOdd)  // odd values of NumElemRequested mean we want exactly
				if (numX!=n+1)
					deletepoints idex, 1, exactMassText
				endif
			else  // even values mean we want n or more, n+
				if (numX<n)
					deletepoints idex, 1, exactMassText
				endif
			endif
		endif
									
//		switch(NumElemRequested) 
//		case 0:	// we want exactly 0   // isOdd = 0, n = 0
//			if (numX!=0)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 1:	// we want exactly 1  // isOdd = 1, n = 0
//			if (numX!=1)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 2:	// we want 1+  		 // isOdd = 0, n = 1
//			if (numX==0)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 3:	// we want exactly 2   // isOdd = 1, n = 1
//			if (numX!=2)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 4:	// we want 2+    // isOdd = 0, n = 2
//			if (numX<2)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 5:	// we want 3
//			if (numX!=3)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 6:	// we want 3+
//			if (numX<3)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 7:	// we want 4
//			if (numX!=4)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 8:	// we want 4+
//			if (numX<4)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 9:	// we want 5
//			if (numX!=5)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		case 10:	// we want 5+
//			if (numX<5)
//				deletepoints idex, 1, exactMassText
//			endif
//		break
//		default:	// we want 5+
//			DoAlert 1, "There seems to be something wrong with the number of atoms selected "+num2str(NumElemRequested)+" for "+massStr+" aborting from HR_RemoveHRIonsOfNumElem"
//		break
//		endswitch
	endfor
	
End


//1.09K
Function HR_QueryCheckType(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
	nvar QueryTypeRRX = root:HR_Panel:QueryTypeRRX
	QueryTypeRRX = stringMatch(ctrlName, "QueryRRX_check")

	checkbox QueryRRX_check value=QueryTypeRRX
	checkbox QueryCHONS_check value=!QueryTypeRRX	

	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen

	CheckBox Query_check_QueryNotInList  disable = !QueryTypeRRX

	if (QueryTypeRRX && HR_checkQueryChosen==2)		// not existing wa selected
		HR_ck_ChemFormFind("Query_check_QueryAll",1)			// set to all list
	endif
	
End


//1.09K
Function HR_ck_ChemFormFind(ctrlName,checked) : CheckBoxControl
	string ctrlName
	variable checked
	
	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen

	strSwitch(ctrlName)
		case "Query_check_QueryAll":
			HR_checkQueryChosen=0
		break
		case "Query_check_QueryChosen":
			HR_checkQueryChosen=1
		break
		case "Query_check_QueryNotInLIst":
			HR_checkQueryChosen=2
		break
	endswitch
	
	CheckBox Query_check_QueryAll  value = HR_checkQueryChosen==0
	CheckBox Query_check_QueryChosen value = HR_checkQueryChosen==1
	CheckBox Query_check_QueryNotInList value = HR_checkQueryChosen==2

End


//1.09K
Function HR_checkProc_massCalc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen

	strswitch(ctrlName)
		// does child exist?
		case "MCalc_ck_IsoExistInAll":
			NewHRIonQueryFindExists=1
			Checkbox MCalc_ck_IsoNotExistInAll, win=HRIonMassCalculator, value=!NewHRIonQueryFindExists
			Checkbox MCalc_ck_ChildFit, win=HRIonMassCalculator, disable=0
			Checkbox MCalc_ck_ChildNotFit, win=HRIonMassCalculator,  disable=0
		break
		case "MCalc_ck_IsoNotExistInAll":
			NewHRIonQueryFindExists=0
			Checkbox MCalc_ck_IsoNotExistInAll, win=HRIonMassCalculator, value=!NewHRIonQueryFindExists
			Checkbox MCalc_ck_ChildFit, win=HRIonMassCalculator, disable=2
			Checkbox MCalc_ck_ChildNotFit, win=HRIonMassCalculator,  disable=2
		break
				
		// iso child is fit?
		case "MCalc_ck_ChildFit":
			NewHRIonQueryFindChildChosen=1
			Checkbox MCalc_ck_ChildFit, win=HRIonMassCalculator, value=NewHRIonQueryFindChildChosen
			Checkbox MCalc_ck_ChildNotFit, win=HRIonMassCalculator, value=!NewHRIonQueryFindChildChosen
		break
		case "MCalc_ck_ChildNotFit":
			NewHRIonQueryFindChildChosen=0
			Checkbox MCalc_ck_ChildFit, win=HRIonMassCalculator, value=NewHRIonQueryFindChildChosen
			Checkbox MCalc_ck_ChildNotFit, win=HRIonMassCalculator, value=!NewHRIonQueryFindChildChosen
		break
	endswitch

	ControlInfo/W=HRIonMassCalculator tab0
	if (V_Value!=0)
		Checkbox MCalc_ck_IsoNotExistInAll, win=HRIonMassCalculator, disable=1
		Checkbox MCalc_ck_ChildFit, win=HRIonMassCalculator, disable=1
		Checkbox MCalc_ck_ChildNotFit, win=HRIonMassCalculator,  disable=1
	endif

End


// *************************************************
// Returns a string containing a ; separated list of text wave contents.
Function/s gen_TextWave2List(textWave)
	Wave/t textWave

	string returnList = ""
	variable idex=0, num = numpnts(textWave)
		
	for (idex=0; idex<num; idex+=1)
		returnList+=textWave[idex]+";"
	endfor
	
	return returnList

End


// *************************************************
//  Returns the text wave containing elements in the list; overwrites contents of text wave
Function gen_List2textWave(ListStr, textWave)
string ListStr
wave/t textWave

	variable idex=0, num=ItemsinList(ListStr)
	redimension/n=(num) textWave
	
	textWave = StringFromList(p, ListStr, ";")
	
End


// *************************************************
// Returns a string containing the common entries in the two lists.  (logical list AND)
Function/s gen_SameInBothLists(list1, list2)
	String list1, list2

	string str2, returnStr =""
	
	variable idex, num= ItemsInList(list1)
	for(idex=0; idex < num; idex+=1)	
		str2 = StringFromList(idex, list1,";")
		if (WhichListItem(str2 , list2, ";" )>=0)
			returnStr+=str2+";"
		endif					
	endfor										
	
	return returnStr
	
End


// *************************************************
// Returns a string containing the entries in list1 but not list2   (logical list AND NOT)
Function/s gen_InListANotListB(list1, list2)
	String list1, list2

	string str2, returnStr =""
	
	variable idex, num= ItemsInList(list1)
	for(idex=0; idex < num; idex+=1)	
		str2 = StringFromList(idex, list1,";")
		if (WhichListItem(str2 , list2, ";" )<0)
			returnStr+=str2+";"
		endif					
	endfor										
	
	return returnStr
	
End	


Function HR_butt_SetHRChoices2Todo(ctrlName) : ButtonControl
	String ctrlName

	PK_WavesForHRResults()	  		//  changed in 1.10C to now also recalculate family designations

	svar sq_toDoWvNm = root:panel:sq_toDoWvNm
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	wave Mask_Stick_Integration = root:HR:Mask_Stick_Integration
	wave IsotopicMask = root:HR_sticks:IsotopicMask

	wave/z/t ExactMassText_fitTodo = root:HR_sticks:ExactMassText_fitTodo	
	wave/z/t IsotopicMassText_FitTodo = root:HR_sticks:IsotopicMassText_FitTodo
	wave/z IsotopicMask_FitTodo = root:HR_sticks:IsotopicMask_FitTodo

	variable idex, num
	string HRStr, missingHRions=""
	num = numpnts(ExactMassText_fitTodo)
	
	Mask_Stick_Integration=0		// set all to zero then selectively add, one HR ion at a time
	
	for(idex=0;idex<num;idex+=1)
		HRStr=ExactMassText_fitTodo[idex]
		FindValue/Text=HRstr/TXOP=7 ExactMassText_all
		if (V_value>=0)
			Mask_Stick_Integration[V_value]=1
		else
			missingHRions+=HRStr+";"
		endif	
	endfor
	
	if (strlen(missingHRions)>0)
		print "// The following HR ions: "+missingHRions+" were listed as fit in the todo wave "+sq_toDoWvNm+" but do not exist in the current list of 'all' HR ions so they were not fit."  
	endif
	
	HR_butt_MakeExactMassWaves("")		// set the list of isotopes

	// deal with isotopes
	if (WaveExists(IsotopicMassText_FitTodo) && WaveExists(IsotopicMask_FitTodo) && numpnts(IsotopicMask)==numpnts(IsotopicMask_FitTodo)) 
		IsotopicMask=IsotopicMask_FitTodo
	else
		print "// Could not find the isotope mask for the todo wave "+sq_toDoWvNm+". Setting all isotopes to be constrained."
		IsotopicMask=1
	endif
	
End


Function HR_butt_QueryHRionChemForm(ctrlName) : ButtonControl
	String ctrlName

	nvar QueryTypeRRX = root:HR_Panel:QueryTypeRRX
	svar IonQueryRoot = root:HR_panel:IonQueryRoot
	svar IonQuerySuffix = root:HR_panel:IonQuerySuffix
	nvar IonQueryMaxmz = root:HR_panel:IonQueryMaxmz
	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen
	nvar Query_addC = root:HR_panel:Query_addC
	nvar Query_addCH = root:HR_panel:Query_addCH
	nvar Query_addCH2 = root:HR_panel:Query_addCH2
	
	nvar/z HRIonMassCalcAllowOther = root:HR_Panel:HRIonMassCalcAllowOther
	if (!NVar_exists(HRIonMassCalcAllowOther))
		variable/g  root:HR_Panel:HRIonMassCalcAllowOther=1
		nvar/z HRIonMassCalcAllowOther = root:HR_Panel:HRIonMassCalcAllowOther
	endif
	
	nvar HR_checkQueryChosen = root:HR_panel:HR_checkQueryChosen

	if (QueryTypeRRX==0)
		if (HR_checkQueryChosen==2)
			abort "Select an option for step 4. Aborting from HR_butt_QueryHRionChemForm"
		endif
		HR_ChemFormFind(IonQueryMaxmz)
	else
		nvar/z HRIonMassCalcAllowIso = root:HR_Panel:HRIonMassCalcAllowIso
		if (!NVar_exists(HRIonMassCalcAllowIso))
			variable/g  root:HR_Panel:HRIonMassCalcAllowIso=0
			nvar/z HRIonMassCalcAllowIso = root:HR_Panel:HRIonMassCalcAllowIso
		endif
		if (HRIonMassCalcAllowIso)
			abort "The option of finding isotopes via this method is currently not implemented.  Aborting from HR_butt_QueryHRionChemForm"
		endif
		if (Query_addC==0 && Query_addCH==0 && Query_addCH2==0)
			abort "You must choose at least one R(R')X checkbox with this option. Aborting from HR_butt_QueryHRionChemForm"
		endif
		HR_FindRelatedHRIonSuffix(IonQueryRoot, IonQuerySuffix, IonQueryMaxmz)
	endif

End


Function HR_butt_Add2ListOrChange2Fit(ctrlName) : ButtonControl
	String ctrlName

	wave ChemicalFormulaMass = root:HR_Sticks:ChemicalFormulaMass
	wave/t ChemicalFormulaText = root:HR_Sticks:ChemicalFormulaText
	wave/t ExactMassText_All = root:HR:ExactMassText_All
	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	nvar NewHRIonQueryChooseToFit = root:HR_panel:NewHRIonQueryChooseToFit
	nvar HR_isotopeLowerLimit = root:HR_panel:HR_isotopeLowerLimit
	nvar IncludeIsoChildren = root:HR_panel:IncludeIsoChildren
 
	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder
	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex
	wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal
	wave/t NewIsotopeHRIonsParent = root:HR_panel:NewIsotopeHRIonsParent
	wave/t NewIsotopeHRIonsName = root:HR_panel:NewIsotopeHRIonsName
	wave NewIsotopeHRIonsAbundance = root:HR_panel:NewIsotopeHRIonsAbundance	
	wave/t IsoChildToAllNames = root:HR_Panel:IsoChildToAllNames
	wave/t IsoChildToAllParent =root:HR_Panel:IsoChildToAllParent
	wave IsoChildToAllAbund = root:HR_Panel:IsoChildToAllAbund
	wave IsoChildToAllMass = root:HR_Panel:IsoChildToAllMass

	make/o/n=0/FREE multiChargedtemp
	make/o/n=0/FREE/t inVorWnameTemp
	
	variable idex, num, count=0, jdex, numIso, PeriodicTableFlag
	string HRStr, IsoStr
	
	num=numpnts(ChemicalFormulaMass)
	for(idex=0;idex<num;idex+=1)
		
		// first deal with the masses
		HRStr = ChemicalFormulaText[idex]
		FindValue/TEXT=HRStr/TxOP=7 ExactMassText_All
		if (V_Value >=0)
		//	abortStr =  "It appears that this ion already exists in the wave ExactMassText_All at location " + num2str(V_Value) +" - Aborting from HR_addThisMass"
		else
			HR_addThisMass(HRStr, ChemicalFormulaMass[idex], possibleChooseToFit=NewHRIonQueryChooseToFit)
			count+=1
		endif
		
		// find all isotopic children of this mass
		if (IncludeIsoChildren && strsearch(HRStr, "j", 0) <0)
			PeriodicTableFlag = HR_OneHRIonElementalComp(HRStr)	// sets HRnameElementOrder, etc
			if (PeriodicTableFlag)
				HR_getAllIsotopicChildren(HRnameElementOrder, HRnameElementOrderIndex,HRnameElementTotal, HR_isotopeLowerLimit, NewIsotopeHRIonsName, NewIsotopeHRIonsAbundance)
				// get isotopic children mass
				pk_recalc_IonMasses(NewIsotopeHRIonsName, IsoChildToAllMass, multiChargedtemp, inVorWnameTemp) // get mass values
				numIso = numpnts(NewIsotopeHRIonsName)
				for(jdex=0;jdex<numIso;jdex+=1)
					IsoStr=NewIsotopeHRIonsName[jdex]
					FindValue/TEXT=IsoStr/TxOP=7 ExactMassText_All
					if (V_Value >=0)
					//	abortStr =  "It appears that this ion already exists in the wave ExactMassText_All at location " + num2str(V_Value) +" - Aborting from HR_addThisMass"
					else
//						HR_addThisMass(IsoStr, IsoChildToAllMass[jdex], possibleIsotopAbund=NewIsotopeHRIonsAbundance[idex],possibleIsotopParent=HRStr,possibleChooseToFit = NewHRIonQueryChooseToFit)  1.20Z
						HR_addThisMass(IsoStr, IsoChildToAllMass[jdex], possibleIsotopAbund=NewIsotopeHRIonsAbundance[jdex],possibleIsotopParent=HRStr,possibleChooseToFit = NewHRIonQueryChooseToFit)
						count+=1
					endif
				endfor
				HR_change2FitHRIon(NewIsotopeHRIonsName, NewHRIonQueryChooseToFit)
			endif
		endif		
	endfor

	HR_change2FitHRIon(ChemicalFormulaText, NewHRIonQueryChooseToFit)

	redimension/n=0 IsoChildToAllNames,IsoChildToAllParent, IsoChildToAllAbund, IsoChildToAllMass

	HR_butt_MakeExactMassWaves("")

End


// creates 2 waves in the HR_frag folder
// isIsotopeFlag with nans and numbers.  Non-nan value indicate HR ions with a "j" somewhere, is an isotope
// IsotopeWeighting=1 contains 1 and fractions.  If HR ion is not an isotope nor is an isotopic parent, value is 1. 
//     Else value is the fractional weight needed for PMF (i.e. HR ions CH and j13CH each have a weight of .5)
// all these ions and their isotopes will be weighted as 1/(sum of number of ions and isotopes)
Function sq_SetIsIsotopeWeighting(SpeciesMassText)
wave/t SpeciesMassText

	wave/t Mask_isotope_reference= root:HR:Mask_isotope_reference
	wave/t ExactMassText_all= root:HR:ExactMassText_all		// all known HR ions, not just the ones that were fit

	variable idex, num, posInBig, posParentInBig, posParentInThis,numTimes
	string HRionStr, isoParentStr
	
	num = numpnts(SpeciesMassText)
	
	// make flag wave that has nans for non isotopes, integers for the placement of isotopic parents
	make/o/n=(num) root:HR_frag:isIsotopeFlag=nan, root:HR_frag:IsotopeWeighting=1
	wave isIsotopeFlag=root:HR_frag:isIsotopeFlag
	wave IsotopeWeighting=root:HR_frag:IsotopeWeighting
	
	// deal with isIsotopeFlag
	 for(idex=0;idex<num;idex+=1)
		HRionStr = SpeciesMassText[idex]
		if (strsearch(HRionStr, "j", 0)>=0)		// it is an isotope
			posInBig = sq_findStr(ExactMassText_all,HRionStr,1)
			isoParentStr = Mask_isotope_reference[posInBig]
			posParentInThis = sq_findStr(SpeciesMassText,isoParentStr,1)
			isIsotopeFlag[idex] = posParentInThis
		endif	
	endfor

	// deal with IsotopeWeighting
	make/i/o/n=(num)/FREE IsotopeCount=0
	for(idex=0;idex<num;idex+=1)
		if (isIsotopeFlag[idex]>=0 && (floor(isIsotopeFlag[idex]) - isIsotopeFlag[idex] )==0)		// it is an isotope
			posParentInThis=isIsotopeFlag[idex]	
			// how may times do we see its parent?
			IsotopeCount=( isIsotopeFlag[p]==isIsotopeFlag[idex])		// now has ones and zeros
			numTimes=sum(IsotopeCount)+1		// the +1 means include the parent
			IsotopeWeighting[] =IsotopeCount[p]==1 ?  1/numTimes : IsotopeWeighting[p]		// isotopic children
			IsotopeWeighting[posParentInThis]	=1/numTimes		// isotopic PARENTS
//			print posParentInThis, numTimes
		endif	
	endfor

End


// the purpose of this function is to check if the HR species is really a sum of other HR species.  Returns the
Function/s HR_HandleDollarSignHRFrag(specItem)
string specItem

	wave/t HR_specname_list=root:HR_frag:HR_specname_list
	wave/t HR_spec_list=root:HR_frag:HR_spec_list
	wave/t HR_specFrag_list=root:HR_frag:HR_specFrag_list
	string str, fragStr
	variable  jdex, pos1, loc
	
	variable CombineAtEndFlag=0
	string combStr=specItem
	
	loc=sq_findstr(HR_spec_list,specItem,1)
	if(loc==-1)		
		loc=sq_findstr(HR_specname_list,specItem,1)
	endif
	
	fragStr=ReplaceString(" ", HR_specFrag_list[loc], "")		// remove spaces		// i.e. $NH4,$NO3	
	
	if (stringmatch("$", fragStr[0]) )		// we have a "total" type species
		combStr = "CombineAtEnd:"+specItem+";"			////  i.e. CombineAtEnd:HRTotal;HRNO3/HRNH4/
		for(jdex=0;jdex<itemsInList(fragStr, ","); jdex+=1)		
			str=StringFromList(jdex,fragStr,",")
			str=str[1,strlen(str)-1]		// remove $
			pos1=sq_findStr(HR_spec_list,str,1)
			if (pos1>=0)
				combStr+=HR_spec_list[pos1]+"/"
			else
				abort "Could not find str in HR batch Table aborting from HR_HandleDollarSignHRFrag"
			endif
		endfor
			//WhichListItem
	endif

	return combStr

End


//  Instead of every HR frag wave being converted, we only do the HR frag waves that are needed for this data set
// for HR species that use the $ syntax, i.e. HRTotal = $HROrg,HRNH4, etc, we need to create these addend frags as well.
// UserList is ; separated
Function HR_smartConvertFrags(UserHRList, UseRIEflag)
string UserHRList
variable UseRIEflag

	wave HR_specCalFac_List = root:HR_frag:HR_specCalFac_List 
	wave/t HR_Spec_List = root:HR_frag:HR_Spec_List 
	wave/t/z ComboWaveName = root:HR_frag:ComboWaveName 
	wave/t/z ComboList = root:HR_frag:ComboList 
	
	if (!WaveExists(ComboWaveName) || !WaveExists(ComboList) )
		make/o/n=0/t root:HR_frag:ComboWaveName/wave = ComboWaveName
		make/o/n=0/t root:HR_frag:ComboList/wave = ComboList
	else
		redimension/n=0 ComboWaveName, ComboList
	endif

	string completeFragList, HRSpecList, firstTryHRSpecList, completeHRSpeciesList, fragStr, partSpeciesList, partFragList, speciesStr, str, combStr, newFragEntry, RIEList
	variable pos,num, idex, comboFlag, HOwBigCombo, numHRions, kdex, jdex, numInCombo
	wave/t HR_specfrag_List = root:HR_frag:HR_specfrag_List
	wave/t HR_spec_List = root:HR_frag:HR_spec_List
	wave/t HR_specname_List = root:HR_frag:HR_specname_List
	
	//	first determine if any of the requested entites are HR species that are like the $HRTotal beast.  If so, make sure to temporarily add them to the list of species. 
	comboFlag=0
	firstTryHRSpecList = HR_CheckListForHRSpecies(ReplaceString(";", UserHRList, ","), 4)		// generates ";" separated list
	HRSpecList = firstTryHRSpecList 
	num = itemsInList(firstTryHRSpecList, ",")
	for(idex=0;idex<num;idex+=1)		// check to see if they are like the HRTotal beast
		str = StringFromLIst(idex,firstTryHRSpecList, ",")		// i.e. HRTotal
		str = HR_HandleDollarSignHRFrag(str) // HR_HandleDollarSignHRFrag(str)	// i.e. CombineAtEnd:HRTotal;HRNH4/HRNO3/HRSO4/HROrg/HRChl/,
		if (stringMatch(str[0,4], "Combi") )		// every species should have at least 4 chars  CombineAtEnd:HRTotal;HRNH4/HRNO3/HRSO4/HROrg/HRChl/,
			HOwBigCombo=numpnts(ComboWaveName)
			InsertPoints HOwBigCombo, 1, ComboWaveName, ComboList
			comboFlag=1
			HRSpecList=RemoveListItem(idex, firstTryHRSpecList, ",")
			str =str[strlen("CombineAtEnd:"),strlen(str)-1]  // HRTotal;HRNH4/HRNO3/HRSO4/HROrg/
			ComboWaveName[HOwBigCombo]=stringFromLIst(0, str, ";")  //HRTotal
			str=stringFromLIst(1, str, ";")	// HRNH4/HRNO3/HRSO4/HROrg/
			str=ReplaceString("/", str, ",")	// HRNH4,HRNO3,HRSO4,HROrg,
			HRSpecList+=str			// note at this point HRSpecList may have duplicate.  I.e. if firstTryHRSpecList = HRNH4, HRTotal	
			ComboList[HOwBigCombo]=str
			HOwBigCombo+=1
		endif
	endfor
	
	completeFragList= HR_generateConvergeFragList(HRSpecList)		// get all the HR species that are dependent (via the HR frag table)
	
	completeHRSpeciesList=""
	num=itemsInList(completeFragList)		// i.e. HR_frag_organics;HR_frag_air;HR_frag_nitrate;
	for (idex=0;idex<num;idex+=1)
		fragStr=stringFromList(idex,completeFragList)
		pos = sq_findStr(HR_specfrag_List,fragStr,1)
		if (pos<0)
			abort "Could not find the HR species that uses the HR frag wave "+fragStr+"  aborting from HR_smartConvertFrags"
		endif
		completeHRSpeciesList+=HR_spec_List[pos]+";"
	endfor
	
	partSpeciesList=""
	partFragList=""
	HRSpecList=ReplaceString(",", HRSpecList, ";")	
	num=itemsInList(HRSpecList)		
	for (idex=0;idex<num;idex+=1)
		speciesStr=stringFromList(idex,HRSpecList)
		pos = sq_findStr(HR_spec_List,speciesStr,1)
		if (pos<0)
			if (pos<0 )
				pos = sq_findStr(HR_specname_list,stringFromLIst(idex,HRSpecList),1)	
			endif
			if (pos<0 )
				abort "Could not find the HR species "+speciesStr+"  aborting from HR_smartConvertFrags"
			endif
		endif
		str=HR_specfrag_List[pos]
		if (strsearch(str, "[", 0)>=0)		// is is a partial type like HROrg43, HR_frag_organic[43]
			partSpeciesList+=speciesStr+";"
			partFragList+=str+";"
		endif
	endfor

	HR_generateFinalFrags(OnlySpecList=completeHRSpeciesList, OnlySpecFragList=completeFragList,  partialSpeciesList=partSpeciesList, partialFragList=partFragList)	

//  at this point we have frag_HRNH4, etc, that look JUST LIKE squirrel frag waves!
//  if we have HR species like HRTotal,we need to combine them!!
	if (comboFlag)
		wave/t ComboWaveName = root:HR_frag:ComboWaveName
		wave/t ComboList = root:HR_frag:ComboList
		num = numpnts(ComboWaveName)
		wave/t tempWave =$"root:HR_frag:frag_"+StringFromList(0, ComboList[0], ",")
		numHRions = numpnts(tempWave)
		
		for(idex=0;idex<num;idex+=1)		// for each entry in ComboWaveName
			str = ComboWaveName[idex]
			combStr = ComboList[idex]
			numInCombo = itemsInList(combStr, ",")
			make/t/o/n=(numHRions) $"root:HR_frag:frag_"+str = ""	
			wave/t ComboFragWave= $"root:HR_frag:frag_"+str
			RIEList=""
			if (UseRIEflag)		// set RIEList
				for (kdex=0;kdex<numInCombo;kdex+=1)		// for each addend in the combo wave
					speciesStr=ComboList[kdex] // StringFromList(kdex, ComboList, ",")		// 1.57J
					pos=sq_findStr(HR_Spec_List, speciesStr, 1)
					RIEList+=num2str(HR_specCalFac_List[pos])+";"
				endfor
			endif
			for (jdex=0;jdex<numHRions;jdex+=1)		// for each HRion
				newFragEntry=""
				for (kdex=0;kdex<numInCombo;kdex+=1)		// for each addend in the combo wave
					wave/t thisFragWave = $"root:HR_frag:frag_"+stringFromList(kdex,combStr, "," )
					fragStr = thisFragWave[jdex]
					newFragEntry=selectString(strlen(fragStr)==0, stringFromList(kdex,RIEList)+"*"+newFragEntry+fragStr+",",newFragEntry)
				endfor
				ComboFragWave[jdex]=newFragEntry
			endfor
		endfor
	endif

End

// given a , or ; separated list of HR species that a user wants, generates a list of all other species and HR frag waves it depends on
Function/s HR_generateConvergeFragList(HRSpecList)
string HRSpecList

	string newStr, fragEntryStr, returnStr, regExpStr, str1, SummedSpeciesStr
	variable pos, idex, num, len
	
	wave/t HR_specFrag_list = root:HR_frag:HR_specFrag_list
	wave/t HR_spec_list = root:HR_frag:HR_spec_list
	wave/t HR_specname_list = root:HR_frag:HR_specname_list
	
	SummedSpeciesStr=""		// to handle HR species like HRTotal
	regExpStr= "HR_frag_([[:alnum:]]+)" + "\\["	
	HRSpecList = ReplaceString(" ", ReplaceString(",", HRSpecList, ";"), "")
	returnStr=""
	num=itemsInList(HRSpecList)
	for (idex=0;idex<num;idex+=1)
		pos = sq_findStr(HR_spec_list,stringFromLIst(idex,HRSpecList),1)		
		if (pos<0 )
			pos = sq_findStr(HR_specname_list,stringFromLIst(idex,HRSpecList),1)	
		endif
		fragEntryStr=HR_specFrag_list[pos]
		//
		SplitString/E=(regExpStr) fragEntryStr, str1		
		if (strlen(str1)>0)
			if (WhichListItem("HR_frag_"+str1, returnStr)<0)
				returnStr+="HR_frag_"+str1+";"
			endif
		else
			if (WhichListItem(fragEntryStr, returnStr)<0)
				returnStr+=fragEntryStr+";"
			endif
		endif
	endfor
	do 
		len=strlen(returnStr)
		newStr = HR_FindHRfragDependencies(returnStr)
		returnStr = newStr 		
	while (len!=strlen(newStr))
	
	return Newstr

End


// given a HR fragwave list, find all other HR frag waves that depend on it
Function/s HR_FindHRfragDependencies(HRfragList)
string HRfragList

	wave/t/z HR_specMassAlgebra = root:HR_frag:HR_specMassAlgebra
	variable idex, num,pos
	string tempStr ="", returnStr="", matchlist=HRfragList, one
	
	num=itemsinlist(HRfragList)
	for (idex=0;idex<num;idex+=1)	// for each species grab the HR frag wave and generate the text wave
		one=stringFromList(idex, HRfragList)
		wave/t/z textwave = $"root:HR_frag:"+stringFromList(idex, HRfragList)
		if (!WaveExists(textwave))		//1.16M
			//1.20H  If  the HR frag wave doesn't exist, then make sure it is not one of our main HRspecies.  
			// If it is not one of our main species we can create it and presume it should be full of blanks.
			if (WhichListItem(ReplaceString("HR_frag_", one,""),DEFAULTHRFRAGS)>=0)
				abort "Could not find the frag wave root:HR_frag:"+one+" You may copy the blank text wave root:HR_frag:HR_frag_chloride as an example. aborting from HR_FindHRfragDependencies"
			else
				make/t/o/n=(numpnts(HR_specMassAlgebra)) $"root:HR_frag:"+one =""
				wave/t/z textwave = $"root:HR_frag:"+one
			endif
		endif
		tempStr += sq_textwave2List(textwave)	
	endfor

	returnStr=HR_collapseHRfragSyntaxToList(tempStr, matchlist)
	
	return returnStr

End


Function/s HR_collapseHRfragSyntaxToList(biglist, matchlist)
string biglist, matchlist

	string itemstr
	variable idex, num, posStart, posStop
	num=itemsinlist(biglist)
	biglist =ReplaceString("-", biglist, ";")
	biglist =ReplaceString("*", biglist, ";")
	biglist =ReplaceString("[", biglist, ";")
	num=itemsinlist(biglist)
	for (idex=0;idex<num;idex+=1)
		itemstr=stringFromList(idex, biglist)
		if(strlen(itemstr)>7 && stringmatch("HR_frag_", lowerStr(itemstr[0,7]))  )
			itemstr = ReplaceString(",", itemstr, "")
			if (WhichListItem(itemstr, matchlist)<0)
				matchlist+= itemstr+";"//  1.20H
			endif
		endif
	endfor

	return matchlist

end


Function PToF_DataSet_globals()

	wave/z/t PToFDataSetNames= root:PToF:PToFDataSetNames
	wave/z/t PToFDataSetTodo= root:PToF:PToFDataSetTodo
	wave/z/i PToFDataSetStartPt= root:PToF:PToFDataSetStartPt
	wave/z/i PToFDataSetStopPt= root:PToF:PToFDataSetStopPt
	wave/z/i PToFDataSetMaxmz= root:PToF:PToFDataSetMaxmz
	wave/z/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag
	wave/z/i PToFTodoFit= root:PToF:PToFTodoFit

	if (!WaveExists(PToFDataSetNames) || !WaveExists(PToFDataSetTodo)  )		// arbitrary two of the 5
		make/o/n=0/t root:PToF:PToFDataSetNames/wave=PToFDataSetNames
		make/o/n=0/t root:PToF:PToFDataSetTodo/wave=PToFDataSetTodo
		make/o/n=0/i root:PToF:PToFDataSetStartPt/wave=PToFDataSetStartPt
		make/o/n=0/i root:PToF:PToFDataSetStopPt/wave=PToFDataSetStopPt
		make/o/n=0/i root:PToF:PToFDataSetMaxmz/wave=PToFDataSetMaxmz
		make/o/n=0/i root:PToF:PToFDataSetMatrixFlag/wave=PToFDataSetMatrixFlag
		make/o/n=0/i root:PToF:PToFTodoFit/wave=PToFTodoFit
	endif

	if (!WaveExists(PToFDataSetMatrixFlag) )
		make/o/n=(numpnts(PToFDataSetNames))/i root:PToF:PToFDataSetMatrixFlag/wave=PToFDataSetMatrixFlag
	else
		redimension/n=(numpnts(PToFDataSetNames)) PToFDataSetMatrixFlag
	endif
	
	wave/z ptof_OrigdVaSize= root:HR_panel:ptof_OrigdVaSize		//1.21G
	wave/z ptof_OrigdVaTime= root:HR_panel:ptof_OrigdVaTime

	if (!WaveExists(PToFDataSetNames) || !WaveExists(PToFDataSetTodo)  )		// arbitrary two of the 5
		make/o/n=0 root:HR_panel:ptof_OrigdVaSize/wave=ptof_OrigdVaSize
		make/o/n=0 root:HR_panel:ptof_OrigdVaTime/wave=ptof_OrigdVaTime
	endif

End


Function PToF_DataSetPanel(ctrlName) : ButtonControl
	String ctrlName
	
//	DoWindow/F PToFDataSetPanel
 	DoWindow/F HR_PTOFDVaGraph
 	if (V_flag==1)
 		return 0
 	endif

	PToF_DataSet_globals()
	
	wave/z ptof_OrigdVaSize= root:HR_panel:ptof_OrigdVaSize		//1.21G
	wave/z ptof_OrigdVaTime= root:HR_panel:ptof_OrigdVaTime
	if (!WaveExists(ptof_OrigdVaSize) || !WaveExists(ptof_OrigdVaTime) )
		make/n=0 root:HR_panel:ptof_OrigdVaSize/wave=ptof_OrigdVaSize, root:HR_panel:ptof_OrigdVaTime/wave=ptof_OrigdVaTime
	endif
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_panel:
	Display/N=HR_PTOFDVaGraph /W=(72.75,307.25,699.75,687.5) ptof_OrigdVaSize vs ptof_OrigdVaTime as "HR_PTOFDVaGraph"
	SetDataFolder fldrSav0
	ModifyGraph mode=4
	ModifyGraph rgb=(29440,0,58880)
	ModifyGraph grid=2
	ModifyGraph log(left)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph gridRGB=(43690,43690,43690)
	Label left "Aerodynamic Diam., nm"
	Label bottom "PToF time, (s)"
	SetAxis/A/E=1 bottom
	ShowInfo
	ShowTools/A
	ControlBar/L 285
	GroupBox groupCreate,pos={5.00,49.00},size={267.00,250.00},title="Create PToF data set (combine DAQ PToF bins)"
	GroupBox groupCreate,fColor=(1,1,1)
	Button buttonDva1,pos={75.00,24.00},size={60.00,20.00},proc=sq_butt_Dvagraph,title="Diam Plot"
	Button buttonDva1,fSize=10
	Button buttonDCMarkers,pos={3.00,24.00},size={70.00,20.00},proc=sq_butt_PToFDCGr_show,title="DC Markers"
	Button buttonDCMarkers,fSize=10
	Button buttonEPToFQs,pos={254.00,4.00},size={20.00,20.00},proc=sq_URLButton,title="?"
	Button buttonEPToFQs,fSize=10
	PopupMenu ams_todolist_pop,pos={10.00,64.00},size={220.00,19.00},bodyWidth=120,proc=HP_PopMenuProc,title="Step 1. Select todo"
	PopupMenu ams_todolist_pop,fSize=12
	PopupMenu ams_todolist_pop,mode=1,popvalue="Get List",value= #"root:panel:sq_toDoList+\"Get List;\"\t"
	CheckBox check_matrix,pos={9.00,125.00},size={14.00,14.00},proc=HP_ck_PToFSingleOrMany,title=""
	CheckBox check_matrix,fSize=10,value= 0,mode=1
	CheckBox check_single,pos={9.00,103.00},size={121.00,15.00},proc=HP_ck_PToFSingleOrMany,title="Single PToF data set"
	CheckBox check_single,fSize=12,value= 0,mode=1
	SetVariable setvar_NumDatasets,pos={27.00,122.00},size={45.00,18.00},bodyWidth=45,proc=HP_SetVarProc
	SetVariable setvar_NumDatasets,fSize=12,value= _NUM:20
	SetVariable setvar_StartBin,pos={10.00,176.00},size={93.00,18.00},bodyWidth=45,proc=HP_SetVarProc,title="Start bin"
	SetVariable setvar_StartBin,fSize=12,limits={0,inf,1},value= _NUM:21
	SetVariable setvar_StopBin,pos={10.00,198.00},size={93.00,18.00},bodyWidth=45,proc=HP_SetVarProc,title="Stop bin"
	SetVariable setvar_StopBin,fSize=12,value= _NUM:119
	SetVariable setvar_maxMz,pos={10.00,227.00},size={194.00,18.00},bodyWidth=45,title="Step 3. Enter max m/z value"
	SetVariable setvar_maxMz,fSize=12,value= _NUM:120
	SetVariable PToF_toDoName,pos={10.00,249.00},size={255.00,18.00},bodyWidth=80,title="Step 4. Enter PToF data set name"
	SetVariable PToF_toDoName,help={"The name to be used whenever you refer to this data set."}
	SetVariable PToF_toDoName,fSize=12,value= _STR:"M20y119"
	TitleBox titleStartBin_nm,pos={111.00,178.00},size={30.00,15.00},title="16nm"
	TitleBox titleStartBin_nm,fSize=12,frame=0,fStyle=0
	TitleBox titleStopBin_nm,pos={111.00,200.00},size={42.00,15.00},title="4217nm"
	TitleBox titleStopBin_nm,fSize=12,frame=0,fStyle=0
	Button buttonCreatePToFDataSet,pos={11.00,274.00},size={220.00,20.00},proc=HP_butt_CreateDataSet,title="Step 5. Create PToF data set(s)"
	Button buttonCreatePToFDataSet,fColor=(65280,49152,16384)
	GroupBox groupExisting,pos={4.00,300.00},size={270.00,135.00},title="Existing PToF data set info"
	GroupBox groupExisting,fColor=(1,1,1)
	ListBox PToFRegionList,pos={11.00,338.00},size={125.00,88.00},proc=HP_dataSetListBox
	ListBox PToFRegionList,listWave=root:PToF:PToFDataSetNames,mode= 1,selRow= 2
	SetVariable var_name,pos={147.00,345.00},size={100.00,15.00},title=" ",fSize=10
	SetVariable var_name,limits={0,inf,0},value= root:PToF:PToFDataSetTodo[2]
	SetVariable var_binStop,pos={147.00,395.00},size={70.00,15.00},title="Bin stop"
	SetVariable var_binStop,fSize=10
	SetVariable var_binStop,limits={0,inf,0},value= root:PToF:PToFDataSetStopPt[2]
	SetVariable var_binStart,pos={147.00,377.00},size={70.00,15.00},title="Bin start"
	SetVariable var_binStart,fSize=10
	SetVariable var_binStart,limits={0,inf,0},value= root:PToF:PToFDataSetStartPt[2]
	SetVariable var_maxMz,pos={147.00,413.00},size={110.00,15.00},title="Approx. max m/z"
	SetVariable var_maxMz,fSize=10
	SetVariable var_maxMz,limits={0,inf,0},value= root:PToF:PToFDataSetMaxmz[2]
	TitleBox titleIsMatrix,pos={147.00,364.00},size={118.00,12.00},title="Is PToF matrix? Yes, 26 bins"
	TitleBox titleIsMatrix,fSize=10,frame=0
	Button buttonSetDC1,pos={161.00,103.00},size={50.00,18.00},proc=HP_ButtSetDC,title="DC Reg1"
	Button buttonSetDC1,fSize=10
	Button buttonSetDC2,pos={215.00,103.00},size={50.00,18.00},proc=HP_ButtSetDC,title="DC Reg2"
	Button buttonSetDC2,fSize=10
	Button buttonShowPTOFDataSetTable,pos={176.00,177.00},size={85.00,30.00},proc=HP_butt_PToFDataSetTable,title="Table of new bin\rcenters, edges"
	Button buttonShowPTOFDataSetTable,fSize=10
	TitleBox title0,pos={41.00,144.00},size={209.00,24.00},title="If data is later normalized, ensure that matrix\rnm boundaries are ~ min, max of PToF size cal."
	TitleBox title0,fSize=10,frame=0
	TitleBox Step2,pos={9.00,84.00},size={217.00,15.00},title="Step 2. Set PToF data sets bin boundaries."
	TitleBox Step2,frame=0
	TitleBox Step2a,pos={75.00,124.00},size={173.00,15.00},title="new evenly spaced bins in matrix"
	TitleBox Step2a,frame=0
	TitleBox BigTitle,pos={5.00,4.00},size={202.00,19.00},title="Non-ePToF PToF Raw Spectra Group"
	TitleBox BigTitle,fSize=14,frame=0,fStyle=1
	TitleBox Step6,pos={147.00,330.00},size={92.00,12.00},title="Last todo wave used:"
	TitleBox Step6,fSize=10,frame=0
	TitleBox Step5z,pos={11.00,318.00},size={239.00,15.00},title="Select a data set in the list below to show info"
	TitleBox Step5z,fSize=12,frame=0

//
//
//	PauseUpdate; Silent 1		// building window...
//	NewPanel/N=PToFDataSetPanel /W=(601,72,879,468) as "PToF Data Set Panel"		//1.19E
////	ModifyPanel fixedSize=1
//	SetDrawLayer UserBack
//	DrawText 12,292,"Select a data set in the list below to show info"
//	SetDrawEnv fsize= 10
////	DrawText 10,222,"(\\\"PToF_\\\" prefix will be added)"
//	DrawText 147,305,"Last todo wave used:"
//	SetDrawEnv fsize= 14,fstyle= 1
//	DrawText 5,21,"Non-ePToF PToF Data Set v1.4"
//	DrawText 9,101,"Step 2. Set PToF data sets bin boundaries."
//	DrawText 75,140,"new evenly spaced bins in matrix"
//	GroupBox groupCreate,pos={5.00,49.00},size={269.00,206.00},title="Create PToF data set (combine DAQ PToF bins)"
//	GroupBox groupCreate,fColor=(1,1,1)
//	Button buttonDva1,pos={75.00,24.00},size={60.00,20.00},proc=sq_butt_Dvagraph,title="Diam Plot"
//	Button buttonDva1,fSize=10
//	Button buttonDCMarkers,pos={3.00,24.00},size={70.00,20.00},proc=sq_butt_PToFDCGr_show,title="DC Markers"
//	Button buttonDCMarkers,fSize=10
//	Button buttonEPToFQs,pos={254.00,4.00},size={20.00,20.00},proc=sq_URLButton,title="?"
//	Button buttonEPToFQs,fSize=10
//	PopupMenu ams_todolist_pop,pos={10.00,64.00},size={220.00,19.00},bodyWidth=120,proc=sq_pop_toDoList,title="Step 1. Select todo"
//	PopupMenu ams_todolist_pop,fSize=12
//	PopupMenu ams_todolist_pop,mode=1,popvalue="all",value= #"root:panel:sq_toDoList+\"Get List;\"\t"
//	CheckBox check_matrix,pos={9.00,125.00},size={14.00,14.00},proc=sq_ck_PToFSingleOrMany,title=""
//	CheckBox check_matrix,fSize=10,value= 0,mode=1
//	CheckBox check_single,pos={9.00,103.00},size={121.00,15.00},proc=sq_ck_PToFSingleOrMany,title="Single PToF data set"
//	CheckBox check_single,fSize=12,value= 1,mode=1
////	TitleBox title0,pos={165.00,207.00},size={102.00,12.00},title="Names auto. generated"
////	TitleBox title0,fSize=10,frame=0,fStyle=0
//	SetVariable setvar_NumDatasets,pos={27.00,122.00},size={45.00,18.00},bodyWidth=45,proc=PToF_SetVarProc
//	SetVariable setvar_NumDatasets,fSize=12,value= _NUM:0
//	SetVariable setvar_StartBin,pos={20.00,142.00},size={93.00,18.00},bodyWidth=45,proc=PToF_SetVarProc,title="Start bin"
//	SetVariable setvar_StartBin,fSize=12,limits={0,inf,1},value= _NUM:118
//	SetVariable setvar_StopBin,pos={20.00,164.00},size={93.00,18.00},bodyWidth=45,proc=PToF_SetVarProc,title="Stop bin"
//	SetVariable setvar_StopBin,fSize=12,value= _NUM:0
//	SetVariable setvar_maxMz,pos={10.00,181.00},size={194.00,18.00},bodyWidth=45,title="Step 3. Enter max m/z value"
//	SetVariable setvar_maxMz,fSize=12,value= _NUM:1
//	SetVariable PToF_toDoName,pos={10.00,203.00},size={255.00,18.00},bodyWidth=80,title="Step 4. Enter PToF data set name"
//	SetVariable PToF_toDoName,help={"The name to be used whenever you refer to this data set."}
//	SetVariable PToF_toDoName,fSize=12,value= _STR:""
//	TitleBox titleStartBin_nm,pos={130.00,144.00},size={42.00,15.00},title="?nm"
//	TitleBox titleStartBin_nm,fSize=12,frame=0,fStyle=0
//	TitleBox titleStopBin_nm,pos={130.00,162.00},size={48.00,15.00},title="?nm"
//	TitleBox titleStopBin_nm,fSize=12,frame=0,fStyle=0
//	Button buttonCreatePToFDataSet,pos={11.00,228.00},size={220.00,20.00},proc=PToF_butt_CreateDataSet,title="Step 5. Create PToF data set(s)"
//	Button buttonCreatePToFDataSet,fColor=(65280,49152,16384)
//	GroupBox groupExisting,pos={4.00,258.00},size={270.00,135.00},title="Existing PToF data set info"
//	GroupBox groupExisting,fColor=(1,1,1)
//	ListBox PToFRegionList,pos={11.00,296.00},size={125.00,88.00},proc=PToF_dataSetListBox
//	ListBox PToFRegionList,listWave=root:PToF:PToFDataSetNames,row= 6,mode= 1
//	ListBox PToFRegionList,selRow= 9
//	SetVariable var_name,pos={147.00,303.00},size={100.00,15.00},title=" ",fSize=10
//	SetVariable var_name,limits={0,inf,0},value= root:PToF:PToFDataSetTodo[9]
//	SetVariable var_binStop,pos={147.00,353.00},size={70.00,15.00},title="Bin stop"
//	SetVariable var_binStop,fSize=10
//	SetVariable var_binStop,limits={0,inf,0},value= root:PToF:PToFDataSetStopPt[9]
//	SetVariable var_binStart,pos={147.00,335.00},size={70.00,15.00},title="Bin start"
//	SetVariable var_binStart,fSize=10
//	SetVariable var_binStart,limits={0,inf,0},value= root:PToF:PToFDataSetStartPt[9]
//	SetVariable var_maxMz,pos={147.00,371.00},size={110.00,15.00},title="Approx. max m/z"
//	SetVariable var_maxMz,fSize=10
//	SetVariable var_maxMz,limits={0,inf,0},value= root:PToF:PToFDataSetMaxmz[9]
//	TitleBox titleIsMatrix,pos={147.00,322.00},size={81.00,12.00},title="Is PToF matrix? No"
//	TitleBox titleIsMatrix,fSize=10,frame=0
//	Button buttonSetDC1,pos={161.00,103.00},size={50.00,18.00},proc=PTOF_ButtSetDC,title="DC Reg1"
//	Button buttonSetDC1,fSize=10
//	Button buttonSetDC2,pos={215.00,103.00},size={50.00,18.00},proc=PTOF_ButtSetDC,title="DC Reg2"
//	Button buttonSetDC2,fSize=10
//	Button buttonShowPTOFDataSetTable,pos={185.00,143.00},size={85.00,30.00},proc=PToF_butt_PToFDataSetTable,title="Table of new bin\rcenters, edges"
//	Button buttonShowPTOFDataSetTable,fSize=10
//	CheckBox PToF_plotEdges,pos={175.00,27.00},size={100.00,14.00},proc=PTOF_CheckShowDVa,title="Plot new bin edges"
//	CheckBox PToF_plotEdges,fSize=10,value= 1
End


Function HP_dataSetListBox(ctrlName,row,col,event) : ListBoxControl
	String ctrlName
	Variable row
	Variable col
	Variable event	//1=mouse down, 2=up, 3=dbl click, 4=cell select with mouse or keys
					//5=cell select with shift key, 6=begin edit, 7=end
	ControlInfo PToFDataSetTab

	if (event==2)
		wave/t PToFDataSetNames= root:PToF:PToFDataSetNames
		wave/t PToFDataSetTodo= root:PToF:PToFDataSetTodo
		wave/i PToFDataSetStartPt= root:PToF:PToFDataSetStartPt
		wave/i PToFDataSetStopPt= root:PToF:PToFDataSetStopPt
		wave/i PToFDataSetMaxmz= root:PToF:PToFDataSetMaxmz
		wave/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag

		SetVariable var_name value = PToFDataSetTodo[row]
		SetVariable var_binStart value  = PToFDataSetStartPt[row]
		SetVariable var_binStop value = PToFDataSetStopPt[row]
		SetVariable var_maxMz value = PToFDataSetMaxmz[row]

		Titlebox titleIsMatrix title = "Is PToF matrix? "+selectString(PToFDataSetMatrixFlag[row]>0, "No", ("Yes, "+num2istr(PToFDataSetMatrixFlag[row]) +" bins") )
	endif
	return 0
End



// updates popup menu on HR Results tab
Function HR_pop_getStickDataSet(controlName,popNum,popStr) : PopUpMenuControl
	string controlName
	variable popNum
	string popStr

	svar HR_StickList=root:HR_panel:HR_StickList
	svar HR_StickListStr=root:HR_panel:HR_StickListStr

	string MSLIst = "HROpenStick;HRClosedStick;HRDiffStick;HROMinusCStick" //  1.22A
	string ErrLIst = "HROCountSigErr;HRCCountSigErr;HROMinusCCountSigErr;HROMinusCCountSigErr;"				

	variable sel
	
	if ( stringmatch( popStr, "Get List") )
		// update HR_StickList
		HR_updateHRStickList()
		sel = WhichListItem("HROMinusCStick",HR_StickList)
		PopupMenu HRResults_pop_dataSet,win=HR_analysis_panel,mode=limit(sel, 0, 100)+1
		if (strlen(WinList("HR_CE_Panel", ";", "WIN:64"))>0)
			PopupMenu HRResults_pop_dataSet, win=HR_CE_Panel,mode=limit(sel, 0, 100)+1
		endif
		HR_StickListStr=stringfromlist(limit(sel, 0, 100),HR_StickList)
	else		// a value in the list was chosen
		variable idex = WhichListItem (popStr, HR_StickList)			//1.14J
		if (idex<0)
			abort "Had a problem trying to choose "+popStr+"  aborting from HR_pop_getStickDataSet" 
		endif
		PopupMenu HRResults_pop_dataSet, win=HR_analysis_panel, mode=idex+1		//1.14J
		HR_StickListStr = popStr
		if (strlen(WinList("HR_CE_Panel", ";", "WIN:64"))>0)
			PopupMenu HRResults_pop_dataSet, win=HR_CE_Panel, mode=idex+1
		endif
	endif

	if (sel>=0)		//1.22A
		HR_pop_getStickErrSet("HRResults_pop_ErrType",nan,"Get List")  // update error list
		HR_pop_getStickErrSet("HRResults_pop_ErrType",nan, StringFromList(sel,ErrLIst))  //
 	else
 		nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors
 		HR_checkCalcHRErrors=0
 	endif

	PopupMenu HRResults_pop_dataSet, win=HR_analysis_panel,value= #"root:HR_panel:HR_StickList+\"Get List;\""	
	if (strlen(WinList("HR_CE_Panel", ";", "WIN:64"))>0)
		PopupMenu HRResults_pop_dataSet, win=HR_CE_Panel,value= #"root:HR_panel:HR_StickList+\"Get List;\""
	endif
End



Function HR_updateHRStickList()

	svar HR_StickList=root:HR_panel:HR_StickList
	wave/t data_index = root:index:data_index
	
	variable idex, num, len
	string LabelStr
	
	HR_StickList=""
	num = numpnts(data_index)
	for (idex=0;idex<num;idex+=1)
		LabelStr= data_index[idex]
		len=strlen(LabelStr)
		if (WhichListItem(LabelStr, "HROpenStick;HRDiffStick;HRClosedStick;HROMinusCStick;HRePToFSumStick;HRePToFSumDiffStick")>=0)			// the method for finding out which HR sticks data sets exist
			HR_StickList+=labelStr+";"		// MS data
		elseif(strlen(LabelStr)>11 && stringMatch(LabelStr[0,3], "PToF") && stringMatch(LabelStr[len-5, len-1], "Stick"))		// PToF data set.  Now see if it is an HR stick data set
			HR_StickList+=labelStr+";"		// PToF data		
		endif
	endfor

End


Function PK_Butt_CopySticksOneSpectra(ctrlName) : ButtonControl
	String ctrlName

	wave ExactMassWave = root:HR_Sticks:ExactMassWave
	wave/t ExactMassText = root:HR_Sticks:ExactMassText
	wave OneRunStickOpen = root:HR_Sticks:OneRunStickOpen
	wave OneRunStickClosed = root:HR_Sticks:OneRunStickClosed
	wave OneRunStickDiff = root:HR_Sticks:OneRunStickDiff

 	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF		//1.10Q
 	nvar HR_UseOpenClosedMzParams = root:HR_panel:HR_UseOpenClosedMzParams		//1.10Q
	nvar AvgTodoFlag = root:HR_panel:AvgTodoFlag 

	string OpenStr, ClosedStr, AvgStr, waveNote = "", dataFolderStr
	OpenStr="";ClosedStr=""
	if (HR_singleSpectraMSorPToF==0)		// PToF
		ControlInfo HRFit_popup_PToFOpen
		OpenStr=S_value
		ControlInfo HRFit_popup_PToFClosed
		ClosedStr=S_value
		dataFolderStr="PToF"
	elseif (HR_singleSpectraMSorPToF==1)		// MS

		dataFolderStr="MS"
	elseif (HR_singleSpectraMSorPToF==2)		// ePToFSum
		dataFolderStr="ePToFSum"
	endif
	
	if (AvgTodoFlag)		// we average a todo wave
		svar todoStr=root:panel:sq_toDoWvNm
		AvgStr= todoStr
	else
		nvar HR_RunVar=root:HR_panel:HR_RunVar
		sprintf AvgStr, "Run_%d",  HR_RunVar
	endif
	dataFolderStr+="_"+AvgStr+selectString(HR_singleSpectraMSorPToF, "_"+OpenStr, "")
	
	waveNote += "SingleRunOrTodo:"+num2str(!AvgTodoFlag)+";"
	waveNote += "MSorPToF:"+num2str(HR_singleSpectraMSorPToF)+";"
	waveNote += "MSOpen:"+SelectString(HR_singleSpectraMSorPToF-1, OpenStr, "MS", "ePToFSum")+";"
	waveNote += "MSClosed:"+SelectString(HR_singleSpectraMSorPToF , ClosedStr, "MS")+";"
	waveNote += "MSDiff:"+SelectString(HR_singleSpectraMSorPToF-1, OpenStr+"-"+ClosedStr ,"MS", "ePToFSumDiff")+";"
	
	Note ExactMassWave waveNote
	Note ExactMassText waveNote
	Note OneRunStickOpen waveNote
	Note OneRunStickClosed waveNote
	Note OneRunStickDiff waveNote
	
	NewDataFolder/o root:HR_SingleFits
	NewDataFolder/o $"root:HR_SingleFits:"+dataFolderStr
	
	duplicate/o ExactMassWave $"root:HR_SingleFits:"+dataFolderStr+":ExactMassWave"
	duplicate/t/o ExactMassText $"root:HR_SingleFits:"+dataFolderStr+":ExactMassText"
	duplicate/o OneRunStickOpen $"root:HR_SingleFits:"+dataFolderStr+":OneRunStickOpen"
	duplicate/o OneRunStickClosed $"root:HR_SingleFits:"+dataFolderStr+":OneRunStickClosed"
	duplicate/o OneRunStickDiff $"root:HR_SingleFits:"+dataFolderStr+":OneRunStickDiff"

	DoAlert 0, "HR Stick values waves were saved in root:HR_SingleFits:"+dataFolderStr+".  See wave notes for details."
		
End


Function HR_PToF_ChooseDataSet(controlName,popNum,popStr) : PopUpMenuControl
	string controlName
	variable popNum
	string popStr
	
	wave/t PToFDataSetNames = root:PToF:PToFDataSetNames
	if (stringmatch("Get List", popStr)) 
		PopupMenu HRFit_popup_PToFOpen,mode=2,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List\""
		PopupMenu HRFit_popup_PToFClosed,mode=2,popvalue="Get List",value= #"sq_textwave2List(root:PToF:PToFDataSetNames) +\";Get List\""
	endif

	HR_ck_OneSpectraMSorPToF("",0)		
	make/free HRPToFInfo
	pk_returnHRPToFInfo(popStr, HRPToFInfo) 
	if (stringmatch("HRFit_popup_PToFOpen", controlName))
		if (!(HRPToFInfo[%MatrixFlag]>=2))
			PopupMenu HRFit_popup_PToFOpen,mode=1,popvalue="Get List"
			abort "The MS Open analog mut be a matrix PToF data set, not a single bin"	
		endif
		ControlInfo/W=HR_Analysis_Panel HRFit_setvar_MatrixBin
		if (V_Value<0)
			SetVariable HRFit_setvar_MatrixBin, value=_NUM:0, win=HR_Analysis_Panel 
		elseif(V_Value>=HRPToFInfo[%MatrixFlag])
			SetVariable HRFit_setvar_MatrixBin, value=_NUM:(HRPToFInfo[%MatrixFlag]-1), win=HR_Analysis_Panel 
		endif	
	else			// closed		
		if (!(HRPToFInfo[%MatrixFlag]<=1))
			PopupMenu HRFit_popup_PToFClosed,mode=1,popvalue="Get List"
			abort "The MS Closed analog mut be a single bin PToF data set, not a matrix"	
		endif		
	endif
	
End


Function HR_CalcPlot_MSDef(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string tempStr
	tempStr = HR_Calc_MSDef(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial) 
	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	HR_plot_MSDef($stringFromList(0, tempStr, ";"), $stringFromList(1, tempStr, ";"), $stringFromList(2, tempStr, ";"), $stringFromList(3, tempStr, ";"), myPlotName,HRResults_graphOutputType, 1)

End


// 1.04J button function similar to the Squirrel MS spectra average button
Function/s HR_calc_MSDef(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	nvar HR_checkAvgHRMS_UMR = root:HR_panel:HR_checkAvgHRMS_UMR
	svar todoStr=root:panel:sq_toDoWvNm
	wave/z todo=$(todoStr)
	nvar NormalizeSpectra=root:HR_panel:NormalizeSpectra

	wave/t HR_familyName = root:HR:HR_familyName		//1.16Z
	string paramStr, specList, tempStr, nonHRSpec, HRSpec, nonHRSpecDestList, HRSpecDestList, timeWt
	variable idex, num, HRspecFlag
		
	HR_checkAvgHRMS_UMR = 0
	NormalizeSpectra=0
	
	paramStr=""	
	paramStrPartial+= "product_Type:2;"

	nonHRSpecDestList=""
	HRSpecDestList=""

	if (strlen(HRResults_ionList)==0)		//1.07C
		HRResults_ionList="all"		
	endif
		
	// Non HR Species First such as all
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families
	if (strlen(nonHRSpec)>0)
 		HRspecFlag=0
 		paramStr=""
	 	HR_getParamStr(paramstr,nonHRSpec, 1, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
		nonHRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_")
		nonHRSpecDestList =  RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",nonHRSpecDestList, "/") 	

		paramStr+=paramStrPartial+"HRSpec_flag:0;"
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+nonHRSpecDestList + ";"	
		
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType)
		
	endif

	// do HRSpecs such as HROrg
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families
	if (strlen(HRSpec)>0)
	 	HRspecFlag=1
	 	paramstr=""
	 	HR_getParamStr(paramstr,HRSpec, 1, 0)		//1.06E
		specList=StringByKey("specList", paramstr) 	 	
		HRSpecDestList ="MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_"+ReplaceString("/", specList, "/MSS" +SpecTypeInitial+"_" +waveNameSuffix+"_")
		HRSpecDestList =  RemoveFromList("MSS" +SpecTypeInitial+"_"+waveNameSuffix+"_",HRSpecDestList, "/") 	

		paramStr+=paramStrPartial+"HRSpec_flag:1;"
		paramstr+="specList:"+specList + ";"
		paramstr+="destList:"+HRSpecDestList + ";"	

		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType)
		
	endif

	if (HRspecFlag)
		wave ExactMassWave = root:HR_frag:SpeciesMassWave
		wave/t SpeciesMasstext = root:HR_frag:SpeciesMasstext
		string lists = HR_GenerateFamilyExceptionLists()
		make/o/t/n=(numpnts(ExactMassWave)) root:HR_frag:SpeciesGroupText/wave=SpeciesGroupText
//		SpeciesGroupText=HR_returnGrouping(SpeciesMasstext[p], stringFromList(0, lists, "/"), stringFromList(1, lists, "/"))		// 1.16N
		SpeciesGroupText=pk_FindFamilyFroHRIon(SpeciesMasstext[p],  stringFromList(1, lists, "/"), stringFromList(0, lists, "/"), HR_familyName)
		wave/t FamilyGroupText = root:HR_frag:SpeciesGroupText
		// wave/t ExactMassText = root:HR_frag:SpeciesMassText
		wave HRStickAvg = $"root:"+stringFromList(0, HRSpecDestList, "/")
		
		duplicate/o  ExactMassWave root:HR_frag:SpeciesMassDefect/wave=MassDefect
		MassDefect = ExactMassWave-round(ExactMassWave)
		
		duplicate/o  HRStickAvg   $"root:HR_frag:SqrtLog"+stringFromList(0, HRSpecDestList, "/")/wave=SqrtLog
		SqrtLog=sqrt(log(HRStickAvg*1000))

		make/o/n=(numpnts(HRStickAvg),3) root:HR_frag:SpeciesMassWaveColorTable /wave=HRionColorTable
	else		// just fitted HR ions
		wave ExactMassWave = root:HR_Sticks:ExactMassWave_FitTodo
		wave/t FamilyGroupText = root:HR_Sticks:ExactMassFamilyText_FitTodo
// 		wave/t ExactMassText = root:HR_Sticks:ExactMassWave_FitTodo
		wave HRStickAvg = $"root:"+stringFromList(0, nonHRSpecDestList, "/")
		
		duplicate/o  ExactMassWave root:HR_frag:SpeciesMassDefect/wave=MassDefect
		MassDefect = ExactMassWave-round(ExactMassWave)
		
		duplicate/o  HRStickAvg   $"root:HR_frag:SqrtLog"+stringFromList(0, nonHRSpecDestList, "/")/wave=SqrtLog
		SqrtLog=sqrt(log(HRStickAvg*1000))
		
		make/o/n=(numpnts(HRStickAvg),3) root:HR_Sticks:ExactMassColorTable_FitTodo /wave=HRionColorTable
	endif
	
	HR_make3DColorWave(FamilyGroupText, HRionColorTable)
	
	return GetWavesDataFolder(MassDefect, 2 )+ ";"+GetWavesDataFolder(ExactMassWave, 2 )+ ";"+GetWavesDataFolder(SqrtLog, 2 )+";"+GetWavesDataFolder(HRionColorTable, 2 )

End


Function HR_plot_MSDef(MassDefect, MassWave, SigWave, ColorTableWave, NewPlotName, graphOutputType, Step4Flag)
wave MassDefect, MassWave, SigWave, ColorTableWave
string NewPlotName
variable graphOutputType, Step4Flag
			

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
	if(graphOutputType!=4)

		// bring graph to front (for multiple graphs do nothing for now)
		if (graphOutputType==1)
			DoWindow/F $NewPlotName
			if (V_flag==1)
				return 0
			endif
		endif

		display/N=$NewPlotName as NewPlotName
			
		appendtograph/W=$NewPlotName MassDefect vs MassWave
		ModifyGraph zColor($NameOfWave(MassDefect))={ColorTableWave,*,*,directRGB,0}	
		if (HR_singleSpectraMSorPToF==1 || HR_singleSpectraMSorPToF==2)
			ModifyGraph zmrkSize($NameOfWave(MassDefect))={SigWave,0,3,0.5,5}
		else
			ModifyGraph msize=2
		endif				
		ModifyGraph mode=3,marker=19
		ModifyGraph grid=2,zero=0,gridRGB=(34816,34816,34816)
		ModifyGraph zero(left)=1

		HR_updateFamilyColorLegend()
		svar HR_legendStrUnitSticks = root:Int_Sticks:HR_legendStrUnitSticks
		TextBox/X=0/Y=0  "\\Z14\\f01"+HR_legendStrUnitSticks

		label/W=$NewPlotName bottom "m/z"
		if (Step4Flag)
			label/W=$NewPlotName left "Mass Defect "+ StringFromList(1, NewPlotName, "4")		// cheater way to get open closed diff
		else
			label/W=$NewPlotName left "Mass Defect"
		endif
	endif
	
End


Function HR_butt_Step4MassDefect(ctrlName) : ButtonControl
string ctrlName

	HR_CalcStep4MassDefect()
	HR_PlotStep4MassDefect()

End


Function HR_CalcStep4MassDefect()

	wave ExactMassWave = root:HR_Sticks:ExactMassWave
	wave ExactMassColorTable = root:HR_Sticks:ExactMassColorTable
	wave/t ExactMassText = root:HR_Sticks:ExactMassText
	wave OneRunStickOpen = root:HR_Sticks:OneRunStickOpen
	wave OneRunStickClosed = root:HR_Sticks:OneRunStickClosed
	wave OneRunStickDiff = root:HR_Sticks:OneRunStickDiff
	
	if (numpnts(ExactMassWave) != numpnts(OneRunStickOpen)) 
		abort "Please redo step 4... perhaps you added or removed ions to fit but did not fit them yet.  aborting from HR_butt_CalcStep4MassDefect "
	endif
	
	variable num = numpnts(OneRunStickOpen)
	make/o/n=(num)   root:HR_Sticks:ExactMassDefect/wave=ExactMassDefect
	make/o/n=(num)   root:HR_Sticks:OneRunStickOpenSqrtLog/wave=OneRunStickOpenSqrtLog
	make/o/n=(num)   root:HR_Sticks:OneRunStickClosedSqrtLog/wave=OneRunStickClosedSqrtLog
	make/o/n=(num)   root:HR_Sticks:OneRunStickDiffSqrtLog/wave=OneRunStickDiffSqrtLog
	
	ExactMassDefect = ExactMassWave-round(ExactMassWave)
	
	OneRunStickOpenSqrtLog =sqrt(log(OneRunStickOpen))
	OneRunStickClosedSqrtLog =sqrt(log(OneRunStickClosed))
	OneRunStickDiffSqrtLog =sqrt(log(OneRunStickDiff))

End


Function HR_PlotStep4MassDefect()
	
	wave ExactMassWave = root:HR_Sticks:ExactMassWave
	wave ExactMassDefect = root:HR_Sticks:ExactMassDefect
	wave ExactMassColorTable = root:HR_Sticks:ExactMassColorTable
	wave OneRunStickOpenSqrtLog = root:HR_Sticks:OneRunStickOpenSqrtLog
	wave OneRunStickClosedSqrtLog = root:HR_Sticks:OneRunStickClosedSqrtLog
	wave OneRunStickDiffSqrtLog = root:HR_Sticks:OneRunStickDiffSqrtLog

	HR_plot_MSDef(ExactMassDefect, ExactMassWave, OneRunStickOpenSqrtLog, ExactMassColorTable, "MassDefectStep4Open", 1, 1)
	HR_plot_MSDef(ExactMassDefect, ExactMassWave, OneRunStickClosedSqrtLog, ExactMassColorTable, "MassDefectStep4Closed", 1, 1)
	HR_plot_MSDef(ExactMassDefect, ExactMassWave, OneRunStickDiffSqrtLog, ExactMassColorTable,  "MassDefectStep4Diff", 1, 1)

	Execute "StackWindows/W=(10,20,540,350) MassDefectStep4Diff,MassDefectStep4Closed,MassDefectStep4Open"
End


//1.04P addition
Function HR_make3DColorWave(FamilyGroupText, ExactMassColorTable)
wave/t  FamilyGroupText
wave ExactMassColorTable

	wave/t HR_familyName = root:HR:HR_familyName
	wave HR_family_R = root:HR:HR_family_R
	wave HR_family_G = root:HR:HR_family_G
	wave HR_family_B = root:HR:HR_family_B
	
	variable numExactMasses, idex, pos
	
	numExactMasses = numpnts(FamilyGroupText)

	redimension/n=(numExactMasses, 3) ExactMassColorTable
		
	for(idex=0;idex<numExactMasses;idex+=1)
		pos = sq_findStr(HR_familyName,FamilyGroupText[idex],1)
		ExactMassColorTable[idex][0] = HR_family_R[pos]
		ExactMassColorTable[idex][1] = HR_family_G[pos]	
		ExactMassColorTable[idex][2] = HR_family_B[pos]	
	endfor

End


Function HR_butt_CorrectHRmass(ctrlName) : ButtonControl
	String ctrlName

	wave/t ProbMassText = root:HR_panel:ProbMassText
	wave ProbMassIndex= root:HR_panel:ProbMassIndex
	wave ProbMassAllWave = root:HR_panel:ProbMassAllWave
	wave ProbMassCalc = root:HR_panel:ProbMassCalc
	wave ProbMassDiff =root:HR_panel:ProbMassDiff

	wave/d ExactMassWave_all = root:HR:ExactMassWave_all

	HR_butt_massCheckAllIons("")		// we do this to make sure the point number in the wave ProbMassIndex is correct

	variable idex, num, count=0
	num = numpnts(ProbMassDiff)
	
	if (num !=numpnts(ProbMassIndex) || num !=numpnts(ProbMassAllWave) || num !=numpnts(ProbMassCalc) || num !=numpnts(ProbMassDiff) )
		abort "The number of points in the wave in the table HR_conflictTable are not the same."
	endif

	for (idex=num-1;idex>=0; idex-=1)
		if (ProbMassDiff[idex] < 0.5)
			ExactMassWave_all[ProbMassIndex[idex]] = ProbMassCalc[idex]
			count+=1
			deletepoints idex, 1, ProbMassText, ProbMassIndex,ProbMassAllWave, ProbMassCalc, ProbMassDiff
		endif
	endfor

	DoAlert 0, "The mass values for "+num2str(count) +" HR ions have been changeed"
	
End


Function HR_butt_correctIsoAbund(ctrlName) : ButtonControl
	String ctrlName

	wave/t ProbIsotopeText=root:HR_panel:ProbIsotopeText
	wave/t ProbIsotopeCalcParent=root:HR_panel:ProbIsotopeCalcParent
	wave ProbIsotopeAllwaveParent=root:HR_panel:ProbIsotopeAllwaveParent
	wave ProbIsotopeMass=root:HR_panel:ProbIsotopeMass
	wave ProbIsotopeCalcAbund=root:HR_panel:ProbIsotopeCalcAbund
	wave ProbIsotopeAllWaveAbund=root:HR_panel:ProbIsotopeAllWaveAbund
	wave ProbIsotopeAllWaveIndex=root:HR_panel:ProbIsotopeAllWaveIndex

	wave Mask_Isotope_abundance = root:HR:Mask_Isotope_abundance
	wave/t Mask_Isotope_reference = root:HR:Mask_Isotope_reference

	HR_butt_FindIsoDiscrepancy("")

	variable idex, num, count=0
	num = numpnts(ProbIsotopeText)
	
	if (num !=numpnts(ProbIsotopeCalcParent) || num !=numpnts(ProbIsotopeAllwaveParent) || num !=numpnts(ProbIsotopeMass) || num !=numpnts(ProbIsotopeCalcAbund) || num !=numpnts(ProbIsotopeAllWaveAbund) || num !=numpnts(ProbIsotopeAllWaveIndex))
		abort "The number of points in the wave in the table HR_ProblemIsoTable are not the same."
	endif

	for (idex=num-1;idex>=0; idex-=1)
		if (abs(ProbIsotopeCalcAbund[idex]-ProbIsotopeCalcAbund[idex] )  <= 0.2)
			Mask_Isotope_abundance[ProbIsotopeAllWaveIndex[idex]] = ProbIsotopeCalcAbund[idex]
			Mask_Isotope_reference[ProbIsotopeAllWaveIndex[idex]] = ProbIsotopeCalcParent[idex]
			count+=1
			deletepoints idex, 1, ProbIsotopeText, ProbIsotopeCalcParent,ProbIsotopeAllwaveParent, ProbIsotopeMass, ProbIsotopeCalcAbund, ProbIsotopeAllWaveAbund, ProbIsotopeAllWaveIndex
		endif
	endfor

	DoAlert 0, "The isotopic abundance values for "+num2str(count) +" HR ions have been changeed"

End


// updates popup menu on HR Results tab
Function HR_pop_getPToFStickDataSet(controlName,popNum,popStr) : PopUpMenuControl
	string controlName
	variable popNum
	string popStr

	sq_initializeGlobalSVar("root:HR_panel:HRPToF_StickList", "")

	svar HRPToF_StickList=root:HR_panel:HRPToF_StickList		// 
	svar HR_StickList=root:HR_panel:HR_StickList		// MS and PToF
	svar Step5iistr = root:HR_panel:Step5iistr

//	SetVariable HRTodoFit_NewPToF, win=$"HR_Analysis_Panel", disable=0
//	Step5iistr = "Name of the new HR PToF data set"
	Step5iistr ="New HR PToF data sets will be named A_B 'A Less B'\rwhere A and B are the 'Open' and 'Closed' data sets."   //1.60D

	variable idex, num
	string str
	if ( stringmatch( popStr, "Get List") )
		// update HR_StickList
		HR_updateHRStickList()
		num = itemsInList(HR_StickList)
		HRPToF_StickList=""
		for(idex=0;idex<num;idex+=1)
			str=stringFromList(idex,HR_stickList)
			if (stringmatch(str[0,3], "PToF") &&strsearch(str, "_", 0)<0 )			// 
				HRPToF_StickList+=str+";"
			endif
		endfor
		PopupMenu $controlName, win=HR_analysis_panel,value= #"root:HR_panel:HRPToF_StickList+\"Get List;\""	
	elseif (stringmatch(controlName, "HRTodoFit_pop_PToFOpen") )
		Step5iistr ="New HR PToF data sets will be named A_B 'A Less B'\rwhere A and B are the 'Open' and 'Closed' data sets." 
//		SetVariable HRTodoFit_NewPToF, win=$"HR_Analysis_Panel", disable=2
	endif

End


Function HR_buttPToFOMinusClosed(ctrlName) : ButtonControl
	String ctrlName

	svar todoStr=root:panel:sq_toDoWvNm	
	wave/z todo=$(todoStr)
	svar HRPToF_StickList = root:HR_panel:HRPToF_StickList
	
//	svar PToFMinusStr=root:HR_panel:PToFMinusStr			//1.19E

	string str, OpenStr, ClosedStr, newName, TodoPlusIterationNumOpen,TodoPlusIterationNumClosed,FolderStr, OpenStickName, ClosedStickName
	variable myindexOpen, myindexClosed//, multiple=0
	
	ControlInfo HRTodoFit_pop_PToFOpen
	OpenStickName=S_value
	ControlInfo HRTodoFit_pop_PToFClosed
	ClosedStickName=S_value
	
	if (stringMatch(OpenStickName, "Get List") || stringMatch(ClosedStickName, "Get List") || strLen(OpenStickName)==0  || strLen(ClosedStickName)==0  )
		Abort "Please reselect the PToF HR 'Open' or 'Closed' data set.  Aborting from HR_buttPToFOMinusClosed"
	endif
	
	if (stringMatch(OpenStickName,ClosedStickName) )
		Abort "Please reselect the PToF HR 'Open' or 'Closed' data set - the chosen selections are the same!  Aborting from HR_buttPToFOMinusClosed"
	endif

	// closed stuff
	ClosedStr = replaceString("Stick", ClosedStickName, "")

	make/free/o/n=7 HRPToFInfo
	PK_returnHRPToFInfo(ClosedStr,HRPToFInfo)	
	if (HRPToFInfo[%matrixFlag]>=2)
		abort "You cannot choose a matrix flag to be the item to subtract.  Aborting from HR_buttPToFOMinusClosed"
	endif
	
//	multiple = stringMatch(OpenStickName, "Selected Above")
//	//1.19E
//	if (multiple)
//		wave/i PToFTodoFit = root:PToF:PToFTodoFit		// numeric
//		wave/t PToFDataSetNames = root:PToF:PToFDataSetNames
//		str=ClosedStr[4,strlen(ClosedStr)-1]		// remove initial PToF
//		Findvalue/TExt=str/TXOp=4 PToFDataSetNames
//		if ( PToFTodoFit[V_Value]==1)
//			DoAlert 1, "The PToF data sets include the selected PToF 'closed', "+ClosedStr+" Press Yes to unselect this PToF group and continue, No to quit."
//			if (V_flag)
//				PToFTodoFit[V_Value]=0
//			else
//				return 0
//			endif
//		endif
//		if ( sum(PToFTodoFit)==0 )
//			Abort "No PToF groups were selected above.  Aborting from HR_buttPToFOMinusClosed"
//		endif
//		multiple=1
//	endif
//	multiple = sum(PToFTodoFit)
		
	wave/z ClosedSeriesWave = $ "root:index:"+ClosedStr+"_series"
	wave/z/t ClosedSeriesKey = $ "root:index:"+ClosedStr+"_seriesKey"

	if (!WaveExists(ClosedSeriesWave) || !WaveExists(ClosedSeriesKey) )
		abort "It doesn't seem as if you have performed a step 5, HR fits for every run in a todo wave, on this PToF data set "+ClosedStr+".  aborting from HR_buttPToFOMinusClosed" 
	endif

// closed
	make/FREE/o/n=(numpnts(ClosedSeriesWave)) ClosedtempMask
	sq_makeMaskFromTodofindRun(ClosedtempMask,todo)
	ClosedtempMask/=ClosedtempMask		// make nans and 1s
	ClosedtempMask*=ClosedSeriesWave		// will have nans an numerical values. numerical values are indexes in HRstick_seriesKey
	WaveStats/q/M=1 ClosedtempMask
	if (V_npnts==0)
		abort "There doesn't seem to be any HR sticks that were generated in this todo wave for "+ClosedStr+" .  Aborting from HR_buttPToFOMinusClosed"
	endif

	myindexClosed = Wavemax(ClosedtempMask)		// could use max or min
	TodoPlusIterationNumClosed = ClosedSeriesKey[myindexClosed]		// as of 1.11D this also has the iteration number
	//1.19E
//	TodoPlusIterationNumClosed= replaceString(stringFromList(0, TodoPlusIterationNumClosed, "_"),TodoPlusIterationNumClosed,"I0")
	wave/Z ClosedExactMassText_FitTodo = $"root:HR_sticks:HRIonWavePToF:"+ClosedStr+":"+TodoPlusIterationNumClosed+":ExactMassText_FitTodo"		// one of many waves could be used here	
	
	if (!WaveExists(ClosedExactMassText_FitTodo)	)		// for backwards compatibility
		abort "Something seems to be wrong with the wave root:HR_sticks:HRIonWavePToF:"+ClosedStr+":"+TodoPlusIterationNumClosed+":ExactMassText_FitTodo -  Aborting from  HR_buttPToFOMinusClosed()"
	endif

	variable numHR=numpnts(ClosedExactMassText_FitTodo)
	make/t/o/n=(numHR) /FREE AandBindex		// intersection
	make/o/n=(numHR) /FREE AnotBindex
	make/o/n=(numHR)  /FREE BnotAindex

	make/o/t/n=(numHR) /FREE AandBHRname		// intersection
	make/o/t/n=(numHR) /FREE AnotBHRname			
	make/o/t/n=(numHR) /FREE BnotAHRname

// open
	variable idex, pos=-1 //,numOpen = multiple ? multiple : 1
//	for(idex=0;idex<numOpen;idex+=1)

//		if (multiple)
//			pos+=1
//			FindValue/V=1/T=0.1/S=(pos) PToFTodoFit
//			OpenStr=PToFDataSetNames[V_Value]
//			OpenStickName= "PToF"+OpenStr+"Stick"		
//			if (WhichListItem(OpenStickName, HRPToF_StickList)<0)
//				abort "It doesn't seem as if you have performed step 5, HR fits for every run in a todo wave, on this PToF data set "+OpenStr+".  aborting from HR_buttPToFOMinusClosed" 
//			endif
//		endif
		
		OpenStr = replaceString("Stick", OpenStickName, "")
		wave/z OpenSeriesWave = $ "root:index:"+OpenStr+"_series"
		wave/z/t OpenSeriesKey = $ "root:index:"+OpenStr+"_seriesKey"

		if (!stringMatch(OpenStr, "Selected Above") && (!WaveExists(OpenSeriesWave) || !WaveExists(OpenSeriesKey)) )
			abort "It doesn't seem as if you have performed step 5, HR fits for every run in a todo wave, on this PToF data set "+OpenStr+".  aborting from HR_buttPToFOMinusClosed" 
		endif	

		make/FREE/o/n=(numpnts(OpenSeriesWave)) OpentempMask
		sq_makeMaskFromTodofindRun(OpentempMask,todo)
		OpentempMask/=OpentempMask		// make nans and 1s
		OpentempMask*=OpenSeriesWave		// will have nans an numerical values. numerical values are indexes in HRstick_seriesKey
		WaveStats/q/M=1 OpentempMask
		if (V_npnts==0)
			abort "There doesn't seem to be any HR sticks that were generated in this todo wave for "+OpenStr+". Aborting from HR_buttPToFOMinusClosed"
		endif
	
		myindexOpen = Wavemax(OpentempMask)		// could use max or min
		TodoPlusIterationNumOpen = OpenSeriesKey[myindexOpen]		// as of 1.11D this also has the iteration number
	//	TodoPlusIterationNumOpen= replaceString(stringFromList(0, TodoPlusIterationNumOpen, "_"),TodoPlusIterationNumOpen,"I0")   //1.14G  ECB wants to uncomment this
		wave/Z OpenExactMassText_FitTodo = $"root:HR_sticks:HRIonWavePToF:"+OpenStr+":"+TodoPlusIterationNumOpen+":ExactMassText_FitTodo"		// one of many waves could be used here	
	
		if (!WaveExists(OpenExactMassText_FitTodo)	)		// for backwards compatibility
			abort "Something seems to be wrong with the wave root:HR_sticks:HRIonWavePToF:"+OpenStr+":"+TodoPlusIterationNumOpen+":ExactMassText_FitTodo - Aborting from HR_buttPToFOMinusClosed()"
		endif
		// first see if the number of ions that were fit are the same
		
		gen_CompareTextWaves(OpenExactMassText_FitTodo, ClosedExactMassText_FitTodo,  AandBHRname, AnotBHRname, BnotAHRname, AandBpos=AandBindex, AnotBpos=AnotBindex, BnotApos=BnotAindex)
	
		if (numHR != numpnts(AandBindex)  || numpnts(BnotAindex)!=0 || numpnts(AnotBindex)!=0  )
			DoAlert 1, "Cannot do the operation because the list of HR ions that were fit are different.   Select yes to see a table of different ions chosen"
			if (V_flag==1)
				str = UniqueName(CleanupName( OpenStr+"_NotIn_"+ClosedStr+"_Name",0), 1, 0)
				duplicate/o AnotBHRname	$str/wave=AnotBHRnameWave	
				str = UniqueName(CleanupName( ClosedStr+"_NotIn_"+OpenStr+"_Name",0), 1, 0)
				duplicate/o BnotAHRname	$str/wave=BnotAHRnameWave	
				str = UniqueName(CleanupName( OpenStr+"_NotIn_"+ClosedStr+"_index",0), 1, 0)
				duplicate/o AnotBindex	$str/wave=AnotBHRindexWave
				str = UniqueName(CleanupName( ClosedStr+"_NotIn_"+OpenStr+"_index",0), 1, 0)
				duplicate/o BnotAindex	$str/wave=BnotAHRindexWave
				edit AnotBHRnameWave, BnotAHRnameWave, AnotBHRindexWave, BnotAHRindexWave			
			endif
		endif	
		
//	endfor
	
	// all checks done... do it!
	string paramstr = ""
//	pos=-1
//	for(idex=0;idex<numOpen;idex+=1)

//		if (multiple)
//			pos+=1
//			FindValue/T=0.1/V=1/S=(pos) PToFTodoFit
//			OpenStr=PToFDataSetNames[V_Value]
//			OpenStickName = "PToF"+OpenStr+"Stick"
//			newName=ReplaceString("PToF", OpenStr+"_"+ClosedStr, "")		//1.19E
//			pos=V_Value
//		else
			newName=ReplaceString("PToF", OpenStr+"_"+ClosedStr, "")
//		endif
		
		PK_returnHRPToFInfo(OpenStr,HRPToFInfo)	
		if (HRPToFInfo[%MatrixFlag]>1)
			paramstr+="PToFFlag:1;"
		endif
		
		squirrel_fetch(todo, pk_diffCalc, paramstr+"putInMemFlag:0;dest:PToF"+newName+"Stick", OpenStickName+";"+ClosedStickName)		//1.14G
		
	 	pk_duplicate_FitTodoWaves("PToF"+newName, PToFSubtractFlag=1) 	//1.08E
		pk_IndexHRResultsWavesFitTodo("PToF"+newName,  PToFSubtractFlag=1) //1.08G
		SaveExperiment
//	endfor

End


//1.12H
// 1.21B  not currently used

Function PK_CheckAtomOrderButtonProc(ctrlName) : ButtonControl
	String ctrlName
	
	pk_PeriodicTableMassOrder()  // changes ElementIonName etc to increasing mass order
	pk_AtomOrder()				// creates ElementIonNameAtomOrder that indicates which atoms are in best CHONS  order, is needed for pk_SortAllHRionsTextByCHONS

	wave/t ExactMassText_All = root:HR:ExactMassText_All
	wave/t Mask_Isotope_Reference = root:HR:Mask_Isotope_Reference
	wave/t ExactMassTag_All = root:HR:ExactMassTag_All

	make/o/n=0/t orderedByCHNSO, orderedByCHNSO_iso
	make/o/n=0 notOrderedFlag, notOrderedFlag_iso
	pk_SortAllHRionsTextByCHNSO(ExactMassText_All, orderedByCHNSO, notOrderedFlag)
	Edit ExactMassText_All, orderedByCHNSO, notOrderedFlag

//	ExactMassText_All = selectString(strlen(orderedByCHNSO)>0,ExactMassText_All[p],notOrderedFlag_iso[p])

	pk_SortAllHRionsTextByCHNSO(Mask_Isotope_Reference, orderedByCHNSO_iso, notOrderedFlag_iso)
	Edit Mask_Isotope_Reference, orderedByCHNSO_iso, notOrderedFlag_iso
//	Mask_Isotope_Reference = selectString(strlen(orderedByCHNSO_iso)>0,Mask_Isotope_Reference[p],notOrderedFlag_iso[p])

//	HR_ConvertTextToTag(ExactMassText_All, ExactMassTag_All)

//	if (strlen(probs)==0)
//		DoAlert 0, "The HR ion names conform to CHONS naming scheme"
//	else
//		print probs
//		sq_butt_popThis("HRGrps_HR_AllMassesTable")
//		DoAlert 0, "Some HR ion names do NOT conform to CHONS naming scheme. See the history window for the list of conforming name, existing name and row number"
//	endif
End


//1.12H
// returns list of HRions that do not conform to CHONS naming scheme
Function PK_SortAllHRionsTextByCHNSO(HRionTextWave, orderedTextwave, badFlagWave)
wave/t HRionTextWave, orderedTextwave
wave badFlagWave 

	variable idex, num
	string Str="", HRIon, problemStr=""
	num = numpnts(HRionTextWave)

	redimension/n=(num) orderedTextwave, badFlagWave 
	orderedTextwave=""
	badFlagWave=nan
	
	for (idex=0;idex<num;idex+=1)
		HRIon = HRionTextWave[idex]   
		if (strsearch(HRIon, "plus", 0)>=0 || strsearch(HRIon, "inV", 0)>=0 || strsearch(HRIon, "inW", 0)>=0 )    	// case sensitive
			continue		
		endif
		Str = PK_SortHRionTextByCHNSO(HRIon)
//		if ( strlen(Str)!= strlen(HRion) )		// currently this is a poor substitute for doing the atomic parsing.
//			problemStr += Str+ ":"+ HRIon+ ":"+ num2str(idex) + ";"
//		endif
		if (!stringMatch(HRIon,Str ))
// 			print "// At row "+num2str(idex) + " the HR ion name is "+HRIon+" but CHONS would indicate "+Str +"  Do not change the name if you have already performed HR fits."	
//			problemStr += Str+ ":"+ HRIon+ ":"+ num2str(idex) + ";"  //1.21B
			badFlagWave[idex]=1
			orderedTextwave[idex]=Str
		endif
	endfor

End


//1.12H
Function/s PK_SortHRionTextByCHNSO(HRion)
string HRion

	variable idex, num, jdex, numOther
	string Str=""

	wave/z ElementIonNameAtomOrder = root:HR:ElementIonNameAtomOrder
	if (!WaveExists(ElementIonNameAtomOrder))
		pk_AtomOrder()	
//		make/o/n=0 root:HR:ElementIonNameAtomOrder
		wave/z ElementIonNameAtomOrder = root:HR:ElementIonNameAtomOrder
	endif
	
	make/o/n=0/FREE ThisIonElementOrder
	HR_OneHRIonElementalComp(HRion, AllAtomOrder=ElementIonNameAtomOrder,ThisHRIonNameOrder=ThisIonElementOrder )		// sets root:HR_Panel:HRnameElementOrderIndex

	wave/t HRnameElementOrder = root:HR_Panel:HRnameElementOrder		// i .e. S or j34S
	wave HRnameElementOrderIndex = root:HR_Panel:HRnameElementOrderIndex // i.e. C is 0, j13C is 1, etc
	wave HRnameElementTotal = root:HR_Panel:HRnameElementTotal   // num of these atoms 
		
	Sort ThisIonElementOrder, HRnameElementOrder,  HRnameElementTotal, ThisIonElementOrder
	// ammonia exceptions
	if (numpnts(HRnameElementOrder)==2 && stringMatch(HRnameElementOrder[0], "H"))
		if( stringMatch(HRnameElementOrder[1], "N") )
			HRnameElementOrder={"N","H"}
			numOther=HRnameElementTotal[0]
			HRnameElementTotal[0] = HRnameElementTotal[1]
			HRnameElementTotal[1] = numOther
		elseif(stringMatch(HRnameElementOrder[1], "j15N") )
			HRnameElementOrder={"j15N","H"}
			numOther=HRnameElementTotal[0]
			HRnameElementTotal[0] = HRnameElementTotal[1]
			HRnameElementTotal[1] = numOther
		endif
	endif
	
	for (idex=0;idex<numpnts(ThisIonElementOrder);idex+=1)
		str += HRnameElementOrder[idex]
		if (HRnameElementTotal[idex]>1)
			str += num2str(HRnameElementTotal[idex])
		endif
	endfor
	return Str
	
End


//1.12H
// generates ElementIonNameAtomOrder which indicates the nice chemical order to isomers in CHONS order
// so if a user added C3H5SO3 it gets rearranged to C3H5O3S
// "C;H;N;S;F;Cl;Br;I;O;"  1.21B
// CHNSFClBrIO
Function PK_AtomOrder()

	wave/t ElementIonName = root:HR:ElementIonName
	wave/t ElementIsotopParentIndexList= root:HR:ElementIsotopParentIndexList
	wave/t ElementIsotopParentList= root:HR:ElementIsotopParentList
	
	variable num = numpnts(root:HR:ElementIonName)
	make/i/o/n=(num) root:HR:ElementIonNameAtomOrder/wave=ElementIonNameAtomOrder
	ElementIonNameAtomOrder=-1  

	make/FREE/i/o/n=(num) pwave=p
	make/FREE/i/o/n=(num) Origpwave=p

	duplicate/FREE/o/t ElementIonName ElementIonNameDUP
	duplicate/FREE/o/t ElementIsotopParentIndexList ElementIsotopParentIndexListDUP
	duplicate/FREE/o/t ElementIsotopParentList ElementIsotopParentListDUP
	
	string str, strParent, strParentIndex, indexStr, stringMyOrder , deleteList
	stringMyOrder="j13C;C;j2H;H;j15N;N;j33S;j34S;j36S;S;F;j37Cl;Cl;j81Br;Br;I;j17O;j18O;O;"  //1.21B
	variable idex, Val, kdex, firstNum = ItemsInList(stringMyOrder)
	deleteList=""
	for (idex=0;idex<firstNum;idex+=1)
		str=stringFromList(idex, stringMyOrder)
		grep/Q/E="^"+str+"$" ElementIonName
		if (V_startParagraph<0)
			abort "Something is wrong with root:HR:ElementIonName not containing the atom "+str+" aborting from pk_AtomOrder"		
		endif
		ElementIonNameAtomOrder[V_startParagraph]=idex
		deleteList+=num2str(V_startParagraph)+";"
	endfor
	deleteList = SortList(deleteList  , ";", 2)
	for (idex=firstNum-1;idex>=0;idex-=1)
		DeletePoints str2num(stringFromList(idex,deleteList)) , 1, ElementIonNameDUP, ElementIsotopParentIndexListDUP, ElementIsotopParentListDUP, pwave
	endfor
	
	for (idex=0;idex<num-firstNum;idex+=1)
		str = ElementIonNameDUP[idex]
		if (strsearch(str, "j", 0)>=0)			// this one an isotope  we take care of isotopes via the parents
			continue
		endif
		strParent = ElementIsotopParentListDUP[idex]		// lists progeny, i.e. j3He
		strParentIndex = ElementIsotopParentIndexListDUP[idex]		// lists progeny,index, i.e. 2
		if (strlen(strParent)>0 )		// it is a parent atom, i.e. He
			// first do isotopes
			for (kdex=0;kdex<itemsInList(strParent);kdex+=1)
				indexStr=stringFromList(kdex, strParentIndex)
				Val = str2num(indexStr)
// 				print idex, Val, Origpwave[Val]
				ElementIonNameAtomOrder[Val] =Val+ firstNum
			endfor
			// now do parent
			ElementIonNameAtomOrder[pwave[idex] ]=p+ firstNum
			// usually incrementing idex within a for loop is verboten... is there a cleaner way?
		else		// an atom that does not have any isotopic children i.e. Be
//			print str,  idex
			ElementIonNameAtomOrder[pwave[idex] ]=p+ firstNum
		endif
	endfor
End
 
 
//1.12H
// replaces ElementIonName, ElementIonMass etc waves with the same values sorted in increasing mass order
Function PK_PeriodicTableMassOrder()

	wave/t ElementIonName = root:HR:ElementIonName
	wave/d ElementIonMass = root:HR:ElementIonMass
	wave/t ElementIsotopParentList = root:HR:ElementIsotopParentList
	wave/t ElementIsotopParentIndexList = root:HR:ElementIsotopParentIndexList
	wave/d ElementIsotopAbund = root:HR:ElementIsotopAbund

	variable idex, num

	num=numpnts(ElementIonMass)
	if (num == numpnts(ElementIonName) && num == numpnts(ElementIsotopParentList) && num == numpnts(ElementIsotopParentIndexList)  && num == numpnts(ElementIsotopAbund))
		return 0
	endif

	duplicate/o/t/FREE ElementIonName ElementIonName1
	duplicate/o/FREE ElementIonMass ElementIonMass1
	duplicate/o/t/FREE ElementIsotopParentList ElementIsotopParentList1
	duplicate/o/t/FREE ElementIsotopParentIndexList ElementIsotopParentIndexList1
	duplicate/o/FREE ElementIsotopAbund ElementIsotopAbund1
	
	Sort ElementIonMass1 ElementIsotopAbund1, ElementIsotopParentIndexList1, ElementIonName1,ElementIsotopParentList1, ElementIonMass1

	string str, str1, str2
	variable Var
	
	ElementIsotopParentIndexList1=""
	ElementIsotopParentList1=""
	
	for(idex=0;idex<num;idex+=1)
		str = ElementIonName1[idex]		// i.e. H or j34S
		splitstring/E=("j"+"([[:digit:]]+)([[:alpha:]]+)") str, str1, str2 		// j, 34, S
		if (strlen(str2)>0 )		// this atom an isotope?
			// find its parent, i.e. S
			grep/Q/E="^"+str2+"$" ElementIonName1
			if (V_startParagraph<0)
				abort "Something is wrong with root:HR:ElementIonName not containing the atom "+str2+" aborting from SanityPeriodicTable"		
			endif
			ElementIsotopParentList1[V_startParagraph]+=str+";"
			ElementIsotopParentIndexList1[V_startParagraph]+=num2str(idex)+";"
		endif
	endfor

	ElementIonName = ElementIonName1
	ElementIonMass = ElementIonMass1
	ElementIsotopParentList = ElementIsotopParentList1
	ElementIsotopParentIndexList = ElementIsotopParentIndexList1
	ElementIsotopAbund = ElementIsotopAbund1

End


Function HR_plot_VanKrevelen(HC,OC, NewPlotName) 
wave HC,OC
string NewPlotName

	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType		// 1 - new, 2 = multiple, 3 = append, 4 = update
	// HRResults_graphOutputType 1 = single, 2 = multiple, 3 = append, 4 = update
	
	if(HRResults_graphOutputType<4)		// if update we do nothing, not even bring a graph to the top window

		if (HRResults_graphOutputType==1)  // single graph
			Display/N=$NewPlotName /W=(100,100,600,400) as NewPlotName
			// sally Ng triangle lines
			// sally Ng triangle lines
			make/o/n=100 root:panel:SallyLineX/wave=SallyLineX
			make/o/n=100 root:panel:SallyLineLeft/wave=SallyLineLeft
			make/o/n=100 root:panel:SallyLineRight/wave=SallyLineRight
			SallyLineX = p/99 + .02
			SallyLineLeft = (-6.0204)*SallyLineX+0.4154
			SallyLineRight = (-1.8438)*SallyLineX+0.3319
			// these values are based on the use of default values for H:S and O:C calibration factors of 0.910 and 0.750
			make/o/n=100 root:panel:OC_sallyTriangleRight_VK/wave=OC_sallyTriangleRight_VK  
			make/o/n=100 root:panel:OC_sallyTriangleLeft_VK/wave=OC_sallyTriangleLeft_VK
			make/o/n=100 root:panel:HC_sallyTriangleRight_VK/wave=HC_sallyTriangleRight_VK
			make/o/n=100 root:panel:HC_sallyTriangleLeft_VK/wave=HC_sallyTriangleLeft_VK
			OC_sallyTriangleRight_VK=3.82*SallyLineRight+0.0794   		// coefs from Pedro
			OC_sallyTriangleLeft_VK=3.82*SallyLineLeft+0.0794   	// coefs from Pedro
			HC_sallyTriangleRight_VK = 1.01+6.07*SallyLineX-16.01*SallyLineX^2	// coefs from Pedro
			HC_sallyTriangleLeft_VK = 1.01+6.07*SallyLineX-16.01*SallyLineX^2	// coefs from Pedro
		
			nvar HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal
			if (HR_elementalImprovedCal)		//1.14M
				TextBox/N=text0 "ACP 2015 improved ambient correction applied to data and\rcolored triangle lines (See Ng et al ACP 2011)"
				HC_sallyTriangleRight_VK *= 1.11  // 1.14I  manjula correction Canagaratna  et al ACP 2015
				HC_sallyTriangleLeft_VK *=  1.11   // 1.14I
				
				OC_sallyTriangleRight_VK *= 1.27  // 1.14I
				OC_sallyTriangleLeft_VK *= 1.27  // 1.14I
			endif

			make/o/n=2 root:panel:ones={1,1}
			make/o/n=2 root:panel:one2one={1e-5,1}
			
			String fldrSav0= GetDataFolder(1)
			SetDataFolder root:panel:

			wave ones, one2one
			
			
			AppendToGraph ones vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph one2one vs one2one
			AppendToGraph HC_sallyTriangleLeft_VK vs OC_sallyTriangleLeft_VK
			AppendToGraph HC_sallyTriangleRight_VK vs OC_sallyTriangleRight_VK

			ModifyGraph lSize(HC_sallyTriangleLeft_VK)=2,lSize(HC_sallyTriangleRight_VK)=2
			ModifyGraph lStyle(one2one#2)=3,lStyle(one2one#3)=3,lStyle(one2one#4)=3,lStyle(one2one#5)=3
			ModifyGraph lStyle(one2one#6)=3,lStyle(HC_sallyTriangleLeft_VK)=2,lStyle(HC_sallyTriangleRight_VK)=2
			ModifyGraph rgb(one2one)=(34816,34816,34816),rgb(ones)=(34816,34816,34816)
			ModifyGraph rgb(one2one#1)=(34816,34816,34816),rgb(one2one#2)=(34816,34816,34816)
			ModifyGraph rgb(one2one#3)=(34816,34816,34816),rgb(one2one#4)=(34816,34816,34816)
			ModifyGraph rgb(one2one#5)=(34816,34816,34816),rgb(one2one#6)=(34816,34816,34816)
			ModifyGraph rgb(HC_sallyTriangleLeft_VK)=(0,15872,65280)
			ModifyGraph offset(one2one)={0,2},offset(ones)={0,1},offset(one2one#1)={0,2},offset(one2one#3)={0,1}
			ModifyGraph offset(one2one#4)={0,2},offset(one2one#5)={0,-1},offset(one2one#6)={0,-2}
			ModifyGraph muloffset(one2one)={1.2,-1},muloffset(ones)={1.25,0},muloffset(one2one#1)={0,-2}
			ModifyGraph muloffset(one2one#2)={2,4},muloffset(one2one#3)={2,4},muloffset(one2one#4)={2,4}
			ModifyGraph muloffset(one2one#5)={2,4},muloffset(one2one#6)={2,4}
			ModifyGraph minor=1
			ModifyGraph standoff=0
			Label left "H:C"
			Label bottom "O:C"
			SetAxis/E=3 left 0,2.5
			SetAxis/E=3 bottom 0,2
			Tag/C/N=text1/F=0/G=(34816,34816,34816)/Y=10.00/L=0 one2one#4, 0, "OS=-2"
			Tag/C/N=text2/F=0/G=(34816,34816,34816)/Y=10.00/L=0 one2one#3, 0, "OS=-1"
			Tag/C/N=text3/F=0/G=(34816,34816,34816)/Y=10.00/L=0 one2one#2, 0, "OS=0"
			Tag/C/N=text4/F=0/X=0.00/L=0 one2one#1, 1, "m=-2\r+ketone/aldehyde"
			Tag/C/N=text5/F=0/X=-5.00/L=0 ones, 1, "m=0\r+alcohol/peroxide"
			Tag/C/N=text6/F=0/X=-3.99/Y=-14.24/L=0 one2one, 1, "m=-1\r+carboxylic acid"
			AppendtoGraph HC vs OC
			ModifyGraph mode($NameOfWave(HC))=2,  lSize($NameOfWave(HC))=2,rgb($NameOfWave(HC))=(0,0,0)
			SetDataFolder fldrSav0
		elseif(HRResults_graphOutputType==3)
			DoWindow/F $NewPlotName
			AppendtoGraph HC vs OC
			ModifyGraph mode($NameOfWave(HC))=2,  lSize($NameOfWave(HC))=2,rgb($NameOfWave(HC))=(0,0,0)
		endif
	endif

End


Function HR_findConstrainedFlag(IsotopicMassText, IsotopicMask,ExactMassText, ConstrainedKey)
Wave/T IsotopicMassText , ExactMassText
Wave IsotopicMask, ConstrainedKey

	variable pos, idex, num= numpnts(ExactMassText)
	redimension/n=(num) ConstrainedKey
	ConstrainedKey=0
	for(idex=0;idex<numpnts(IsotopicMask);idex+=1)
		if (IsotopicMask[idex]==0)
			continue
		endif
		FindValue/TEXT=IsotopicMassText[idex]/TXOP=7 ExactMassText
		if (V_Value<0)
			abort "Something is wrong in row "+num2str(idex)+" of the IsotopicMassText wave - couldn't find match in ExactMassText  Aborting from HR_findConstrainedFlag"
		endif
		ConstrainedKey[V_Value]=1
	endfor
	
End


Function HR_pop_getStickErrSet(controlName,popNum,popStr) : PopUpMenuControl
	string controlName
	variable popNum
	string popStr

	string HRErrList = ""
	variable countSigErrFlag
	HRErrList = HR_updateHRErrList()
	if ( stringmatch( popStr, "Get List") )
		// update HR_StickList
		PopupMenu HRResults_pop_ErrType,win=HR_analysis_panel,mode=1,popvalue=stringfromlist(0,HRErrList)
//		HRErrList=stringfromlist(0,HRErrList)
	else		
		PopupMenu HRResults_pop_ErrType,win=HR_analysis_panel,mode=1,popvalue=popStr
	endif
	HRErrList = RemoveFromList("HRFitOResidErr",HRErrList)	//1.12N  we don't use these anymore
	HRErrList = RemoveFromList("HRFitCResidErr",HRErrList)	//1.12N  we don't use these anymore
	HRErrList = RemoveFromList("HRFitDResidErr",HRErrList)	//1.12N  we don't use these anymore
	
	countSigErrFlag = WhichListItem("HROCountSigErr",HRErrList)>0
	if (countSigErrFlag)		// "HROMinusCCountSigErr"  "HROCountSigErr", "HRCCountSigErr"
// from PK_TotalCountingErrors, 1.21E
//	variable TotCountErrFlag =numberbykey("TotCountErrFlag",paramstr)
//	variable countSigErrFlag =numberbykey("countSigErrFlag",paramstr)
//	string OMinusCErrName = SelectString(!TotCountErrFlag ,"HROMinusCSigErr", "HROMinusCTotCountErr")
//	string OpenErrName =SelectString(!TotCountErrFlag ,"HROTotSigErr", "HROTotCountErr")
//	string ClosedErrName =SelectString(!TotCountErrFlag ,"HRCTotSigErr", "HRCTotCountErr")
		HRErrList = RemoveFromList("HROMinusCTotCountErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HROTotCountErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HRCTotCountErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HROMinusCSigErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HROTotSigErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HRCTotSigErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HROMinusCSigErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HROSigErr",HRErrList)	//1.12N  we don't use these anymore
		HRErrList = RemoveFromList("HRCSigErr",HRErrList)	//1.12N  we don't use these anymore
	endif
	
	variable M = WhichListItem("HROMinusCCountSigErr",HRErrList)
	M=limit(M, 0, 100)	
	string quote = "\""
	HRErrList+="Get List;"
	HRErrList = quote+HRErrList+quote
	PopupMenu HRResults_pop_ErrType, win=HR_analysis_panel,value= #HRErrList
	PopupMenu HRResults_pop_ErrType mode = M+1
	if (!stringmatch(popStr, "Get List"))			//1.14J
		PopupMenu HRResults_pop_ErrType, win=HR_analysis_panel,mode=popNum
	endif
End


Function/s HR_updateHRErrList()

	string HR_ErrList
	wave/t data_index = root:index:data_index
	
	variable idex, num, len
	string LabelStr
	
	HR_ErrList=""
	num = numpnts(data_index)
	for (idex=0;idex<num;idex+=1)
		LabelStr= data_index[idex]
		len=strlen(LabelStr)
		if (stringmatch("HR", LabelStr[0,1]) && stringmatch("Err", LabelStr[len-3,len-1]))			// the method for finding out which HR sticks data sets exist
			HR_ErrList+=labelStr+";"		// MS data
		elseif(stringMatch(LabelStr[0,4], "PToF_") && stringMatch(LabelStr[len-5, len-1], "Stick"))		// PToF data set.  Now see if it is an HR stick data set
			HR_ErrList+=labelStr+";"		// PToF data		
		endif
	endfor

	//hanged for Pedro  1.22A
	HR_ErrList = RemoveFromList("HRFitOResidErr",HR_ErrList)	//1.12N  we don't use these anymore
	HR_ErrList = RemoveFromList("HRFitCResidErr",HR_ErrList)	//1.12N  we don't use these anymore
	HR_ErrList = RemoveFromList("HRFitDResidErr",HR_ErrList)	//1.12N  we don't use these anymore
	
	variable countSigErrFlag = WhichListItem("HROCountSigErr",HR_ErrList)>0
	if (countSigErrFlag)		// "HROMinusCCountSigErr"  "HROCountSigErr", "HRCCountSigErr"
		HR_ErrList = RemoveFromList("HROMinusCTotCountErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HROTotCountErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HRCTotCountErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HROMinusCSigErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HROTotSigErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HRCTotSigErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HROMinusCSigErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HROSigErr",HR_ErrList)	//1.12N  we don't use these anymore
		HR_ErrList = RemoveFromList("HRCSigErr",HR_ErrList)	//1.12N  we don't use these anymore
	endif
	return HR_ErrList
End


//1.13D
Function PK_AddOrRemoveIsoChild(MatrixSelect, MatrixSelectMass,  Mask_stick_IntegrationSection)
wave MatrixSelect, Mask_stick_IntegrationSection
wave/t MatrixSelectMass 

	nvar NewHRIonQueryMass = root:HR_panel:NewHRIonQueryMass
	nvar NewHRIonQueryFindExists = root:HR_panel:NewHRIonQueryFindExists
	nvar NewHRIonQueryFindChildChosen = root:HR_panel:NewHRIonQueryFindChildChosen
	svar NewHRIonQueryText = root:HR_panel:NewHRIonQueryText
	wave/t ExactMassText_all = root:HR:ExactMassText_all
	wave Mask_Stick_integration = root:HR:Mask_Stick_integration

	variable pos, kdex, numThisAMU = numpnts(Mask_stick_IntegrationSection)
	variable idex, numAdd, numRemove
	string HRIonsRemoved = ""

	duplicate/o/FREE MatrixSelect MatrixSelectTemp
	MatrixSelectTemp = mod(MatrixSelectTemp[p][0]/16,2)
	
	make/FREE/o/n=(numThisAMU) WhatIsAdded = MatrixSelectTemp[p][0]==1 &&  Mask_stick_IntegrationSection[p]==0
	numAdd= sum(WhatIsAdded)
	
	NewHRIonQueryFindExists=1

	// add the iso children
	for (idex=0;idex<numThisAMU;idex+=1)
		if (WhatIsAdded[idex]==1)
			NewHRIonQueryFindChildChosen=0  // find children not fitted
			NewHRIonQueryText=MatrixSelectMass[idex] // +";"  1.20S Why the+";"? 
			HR_butt_CalcMassOneHRIon("")
			wave/d IsoChildToAllMass =  root:HR_panel:IsoChildToAllMass
			wave/t IsoChildToAllNames =  root:HR_panel:IsoChildToAllNames
			for (kdex=0;kdex<numpnts(IsoChildToAllNames);kdex+=1)
				pos = sq_findStr(ExactMassText_all,IsoChildToAllNames[kdex],4)
				if (Pos>=0 && NewHRIonQueryMass< IsoChildToAllMass[kdex])
					Mask_Stick_integration[pos]=1			
				endif
			endfor			
		endif
	endfor
	
	make/FREE/o/n=(numThisAMU) WhatIsRemoved = MatrixSelectTemp[p][0]==0 &&  Mask_stick_IntegrationSection[p]==1
	numRemove= sum(WhatIsRemoved)

	// remove the iso children
	for (idex=0;idex<numThisAMU;idex+=1)
		if (WhatIsRemoved[idex]==1)
			NewHRIonQueryText=MatrixSelectMass[idex] //+";"  1.20Y bug fix
			NewHRIonQueryFindChildChosen=1 // find children fitted
			HR_butt_CalcMassOneHRIon("")
			wave/d IsoChildToAllMass =  root:HR_panel:IsoChildToAllMass
			wave/t IsoChildToAllNames =  root:HR_panel:IsoChildToAllNames
			for (kdex=0;kdex<numpnts(IsoChildToAllNames);kdex+=1)
				pos = sq_findStr(ExactMassText_all,IsoChildToAllNames[kdex],4)
				if (Pos>=0 && NewHRIonQueryMass< IsoChildToAllMass[kdex])
					Mask_Stick_integration[pos]=0			
				endif
			endfor			
		endif
	endfor
		
End


// 
//1.14E
Function HR_calcplot_TSMSMatriciesFGrp(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial,errorType)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, errorType

	string wlist = HR_calc_TSMSMatriciesFGrp(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,errorType)
	HR_plot_TSMSMatriciesFGrp(wlist, waveNameSuffix, specTypeInitial, myPlotName) 
	
End


//1.14E
Function/s HR_calc_TSMSMatriciesFGrp(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,errorType)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, errorType

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar todoStr=root:panel:sq_toDoWvNm
	nvar CreateItxForPMF=root:HR_panel:CreateItxForPMF
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	nvar/z HR_removeIsotopes=root:HR_panel:HR_removeIsotopes
	nvar HR_checkcalcHRErrors=root:HR_panel:HR_checkcalcHRErrors

	nvar ams_time_saved=root:panel:ams_time_saved
	nvar ms0_ion2mass=root:panel:ms0_ion2mass

	if (!NVar_exists(HR_removeIsotopes))		//1.11D
		variable/g root:HR_panel:HR_removeIsotopes=0
		nvar/z HR_removeIsotopes=root:HR_panel:HR_removeIsotopes
		ControlInfo/W=HR_Analysis_Panel HRResults_RemoveIsotopes
		HR_removeIsotopes=V_flag
	endif

	HR_removeIsotopes=0
	CreateItxForPMF=0

	wave/z todo=$(todoStr)

	string paramStr, specList, destList, tempStr, nonHRSpec, HRSpec, timeWt, MinIonStr, SpecStr, destStr, nonSpecParamStr, tempStr2, SpecParamStr, tempStr1, outputList, FamList
	variable idex, num, numSpec, jdex
	
	if (strlen(HRResults_ionList)==0)
		abort "You must select one HR species.  Aborting from HR_calc_TSeriesMSMatriciesFGrp"
	endif
	
	paramstr=""
	tempStr=""
	nonSpecParamStr=""
	SpecParamStr=""
	
	paramStrPartial+= "product_Type:3;"		// 1.08C fix

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
		abort "You must select one HR species.  Aborting from HR_calc_TSeriesMSMatriciesFGrp"
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
		if (itemsInList(HRSpec, ",") > 1)
			abort "You must select one HR species.  Aborting from HR_calc_TSeriesMSMatriciesFGrp"
		endif
		paramStr=""
	 	HR_getParamStr(paramstr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", paramstr) 	 	
		destList ="HRMx" +specTypeInitial+"_"+ReplaceString("/", specList, "/HRMx" +specTypeInitial+"_" )	
		destList =  RemoveFromList("HRMx" +specTypeInitial+"_",destList, "/") 	

		paramStr += "HRSpec_flag:1;"
		paramstr += "specList:"+specList + ";"
		paramstr += "destList:"+destList+";"		
		paramStr += paramStrPartial
		squirrel_fetch(todo,PK_MS_concentration, paramstr, spectraType+";"+ errorType)
		num = itemsInList(specList, "/")
		SpecParamStr=paramStr
	else
		abort "You must select one HR species.  Aborting from HR_calc_TSeriesMSMatriciesFGrp"
	endif

	numSpec=ItemsINList(StringByKey("specList", paramstr) ,"/") +ItemsInList(StringByKey("specList", nonSpecParamStr), "/")
	destList=StringByKey("destList", paramstr)
	specList=StringByKey("specList", paramstr)
	
	wave/t ExactMassText = root:HR_frag:SpeciesMassText
	wave ExactMassWave= root:HR_frag:SpeciesMassWave
	wave/t SpeciesFamilyText = root:HR_frag:SpeciesFamilyText		

	string spec = stringFromList(0, specList, "/")
	wave SpeciesMatrix = $stringFromList(0, destList, "/")  // what shall we do with errors?
	if (HR_checkcalcHRErrors)
		 wave ErrorMatrix = $stringFromList(0, destList, "/")+"_err"  // what shall we do with errors?
		FamList = pk_SumSpectraToFamilies(spec, waveNameSuffix, SpeciesMatrix, ExactMassText, ExactMassWave, SpeciesFamilyText, ErrorMx =ErrorMatrix )
	else
		FamList = pk_SumSpectraToFamilies(spec, waveNameSuffix, SpeciesMatrix, ExactMassText, ExactMassWave, SpeciesFamilyText )
	endif

	Killwaves/z SpeciesMatrix, ErrorMatrix
	return FamList
	
End


//1.14E
Function/s PK_SumSpectraToFamilies(SpeciesStr, waveNameSuffix, SpeciesMatrix, ExactMassText, ExactMassWave, SpeciesFamilyText, [ErrorMx])
string SpeciesStr, waveNameSuffix
wave SpeciesMatrix, ExactMassWave, ErrorMx
wave/t ExactMassText, SpeciesFamilyText

	wave/t SpeciesMassText = root:HR_frag:SpeciesMassText
	duplicate/o/t SpeciesFamilyText SpeciesFamilyTextFilledIn
	pk_FillInFamilyDesignation(SpeciesFamilyTextFilledIn, SpeciesMassText)
	
	wave/t HR_familyName = root:HR:HR_familyName
	variable idex , numHRs, num, numRows
	string wName, wNameBase, wNameSuffix, wStr, famStr, FamList
	
	nvar HR_checkcalcHRErrors=root:HR_panel:HR_checkcalcHRErrors
	if (HR_checkcalcHRErrors && ParamIsDefault(ErrorMx) )
		abort "something went wrong with the error matrix  aborting from pk_SumSpectraToFamilies"
	endif

	numRows = dimsize(speciesMatrix,0)
	numHRs = dimsize(speciesMatrix,1)
	num=numpnts(SpeciesFamilyTextFilledIn)
	FamList=""
	
	matrixOP/o /free MySumMask = sumRows(SpeciesMatrix)
	redimension/n=(numRows) MySumMask
	MySumMask = MySumMask[p] == 0 ? nan : 1
		
	for (idex=0;idex<numpnts(HR_familyName);idex+=1)			//1.14G
		famStr = HR_familyName[idex]
		make/o/n=(numHRs)/free maskWave
		maskWave = stringMatch(famStr, SpeciesFamilyTextFilledIn[p])
		wName = famStr+"_"+waveNameSuffix+"_"+SpeciesStr
		MatrixOp/o $wName = SpeciesMatrix x maskWave		// matrix multiplication
		wave w = $wName
		if (HR_checkcalcHRErrors )
			matrixMultiply  SpeciesMatrix, maskWave
			wave M_product
			matrixOp/o tempErr = M_product*M_product
			MatrixOP/o $wName+"_err"=SumRows(tempErr)
			wave w_err =  $wName+"_err"
			MatrixOP/o $wName+"_err"=sqrt(w_err)
		endif

		if (waveMax(w) == 0 && WaveMin(w)==0 )
			killwaves/z w
			if (HR_checkcalcHRErrors )
				killwaves/z w_err
			endif
		else
			fastop w = w * MySumMask			
			FamList+=wName+";"
//			if (HR_checkcalcHRErrors )
//				fastop w_err = w_err * MySumMask			
//			endif
		endif
	endfor

	killwaves/z SpeciesFamilyTextFilledIn, M_product, tempErr
			
	return FamList
End


//1.14E
Function PK_FillInFamilyDesignation(SpeciesFamilyTextFilledIn, SpeciesMassText)
wave/t SpeciesFamilyTextFilledIn, SpeciesMassText

	wave/t HR_familyName = root:HR:HR_familyName

	variable idex, num = numpnts(SpeciesFamilyTextFilledIn)
	string HRion, famStr
	string exceptionWaveList, exceptionMassList, exceptionFamilyList
	
	exceptionWaveList=""
	exceptionMassList=""
	exceptionFamilyList=""
	
	pk_FindHRionExceptions(exceptionWaveList, exceptionMassList, exceptionFamilyList)

	for(idex=0;idex<num;idex+=1)
		if (strlen(SpeciesFamilyTextFilledIn[idex])==0)
			HRion = SpeciesMassText[idex]
			SpeciesFamilyTextFilledIn[idex]= pk_FindFamilyFroHRIon(HRion, exceptionMassList, exceptionFamilyList, HR_familyName)
		endif
	endfor

End


//1.14E
Function PK_FindHRionExceptions(exceptionWaveList, exceptionMassList, exceptionFamilyList)
string exceptionWaveList, &exceptionMassList, &exceptionFamilyList

	wave/t HR_familyName = root:HR:HR_familyName
	wave/t HR_familyListDefinition = root:HR:HR_familyListDefinition

	variable idex, kdex, exceptionWaveNum, numFamily, tempNum, totalNumExceptions
	string str1, exceptionStr
	
	numFamily = numpnts(HR_familyName)
//	exceptionWaveList and exceptionWaveNum will be used to keep track of exceptions.  They ARE NOT the true exception list of HR ions
	exceptionWaveList=""
	exceptionWaveNum=0
	for (idex = 0;idex<numFamily;idex+=1)
		if (WhichListItem(HR_familyName[idex], ION_FAMILY_LIST)<0)
			exceptionWaveList +=num2str(idex)+";"
			exceptionWaveNum+=1
		endif
	endfor

//  1.11A  need to make sure CSi family is defined if they fit any CSi peaks.  Will do so for all families defined in ION_FAMILY_LIST
	for(idex=0;idex<ItemsInList(ION_FAMILY_LIST);idex+=1)
		str1=stringFromList(idex, ION_FAMILY_LIST)
		kdex=sq_findStr(HR_familyName,str1,1)
		if (kdex<0)	// family doesn't exist, add it
			kdex = numpnts(HR_familyName)
			insertpoints kdex, 1, HR_familyName,HR_familyListDefinition, root:HR:HR_family_R,root:HR:HR_family_G,root:HR:HR_family_B 
			HR_familyName[kdex] = str1
			HR_familyListDefinition[kdex] = "default"
		endif
	endfor

	for (kdex=0;kdex<numFamily;kdex+=1)		// go through every row in the family table
		exceptionStr = HR_familyListDefinition[kdex]
		//1.10Q
		if (stringmatch("familyWave_", exceptionStr[0,strlen("familyWave_")-1])  )
			wave/z/t thisfamilywave = $"root:HR:"+exceptionStr
			if (!WaveExists(thisfamilywave) )
				HR_butt_ViewFamilyTable("")
				abort "Could not find family wave "+ exceptionStr+" in the root:HR: folder for family "+HR_familyName[kdex]+" aborting from UM_GenerateAxByMaskWaves"
			endif
			exceptionStr = gen_TextWave2List(thisfamilywave)
		endif
		exceptionStr=RemoveFromList("default",exceptionStr,  ";", 0)
		 if (strlen(exceptionStr)>0 && !stringmatch(exceptionStr, "*;"))		// kinda suggested by Mike C. 1.07C
            		exceptionStr += ";"
       	endif
		tempNum = ItemsInList(exceptionStr)
		exceptionMassList += exceptionStr
		for(idex=0;idex<tempNum;idex+=1)
			exceptionFamilyList +=  num2str(kdex)+";"
		endfor
		totalNumExceptions+=tempNum
	endfor
	
End


//1.14E
Function HR_plot_TSMSMatriciesFGrp(Wave2PlotList, waveNameSuffix, specTypeInitial, NewPlotName) 
string Wave2PlotList, waveNameSuffix, specTypeInitial, NewPlotName

	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3 = root:HR_panel:HR_checkConvertTougm3
	nvar HR_checkCalcHRErrors = root:HR_panel:HR_checkCalcHRErrors

	string destStr, t_base
	variable idex, num

	t_base=sq_tbase()	// we calc again... not ideal... it was calced once already in the HR_MS_concentration function

	num = itemsinlist(Wave2PlotList)
	if(HRResults_graphOutputType!=4)

		// get the x axis wave
		if(strlen(t_base)>0)
			wave x_wave=$("root:"+t_base)
		else
			wave x_wave=root:index:t_series
		endif

		// bring graph to front (for multiple graphs do nothing for now)
		if (HRResults_graphOutputType==3)
			DoWindow/F $NewPlotName
		endif

		for(idex=0;idex<num;idex+=1)
			destStr = stringfromlist(idex,Wave2PlotList,";")
			wave specitem=$("root:"+destStr)
			if((HRResults_graphOutputType==1 && idex==0) || HRResults_graphOutputType==2)
				NewPlotName = "TseriesHRGr_"+destStr[0,min(15, strlen(destStr)-1)]
				DoWindow/K $NewPlotName
				display/N=$NewPlotName as NewPlotName
			endif
			appendtograph/W=$NewPlotName specitem vs x_wave
			if (HR_checkCalcHRErrors)
				wave erritem=$("root:"+destStr+"_err")
				ErrorBars/W=$NewPlotName $NameofWave(specitem) Y,wave=(erritem,erritem)
			endif
		endfor

		if (HR_checkConvertTougm3)
			Label left "g/m3"
		else
			Label left "signal, Hz"
		endif
		
	 	kbcolorizetraces(.5,1,0)			// 6.03 fix
		Legend/W=$NewPlotName
		PK_graphTweaks()		
	endif	// mess with graph 

End


//1.20M  no longer used
//1.44E
//Function PK_Kill_HR_ms_mats()
//
//	string df = GetDataFolder(1)
//	SetDataFolder root:HR_ms_mats
//	Killwaves/z/a
//	SetDataFolder $df
//
//End


// HR CE ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Function taken from A.M. Middlebrook, R. Bahreini, J.L. Jimenez, and M.R. Canagaratna. 
// Evaluation of Composition-Dependent Collection Efficiencies for the Aerodyne Aerosol 
// Mass Spectrometer using Field Data. Aerosol Science and Technology, 46, 258271, 2012
// DOI:10.1080/02786826.2011.620041 PDF (March 1, 2012) 
// Donna S cleaned up and altered slightly October 2011
//
// Creates the following waves and puts them in the root folder
// PredHRNH4_CE1 = predicted NH4 with a collection efficiency of 1
// NH4_MeasToPredict = ratio of NH4 measured to predicted (anion and cation balance)
// ANMF = ammonium nitrate mass fraction
// CE_dry = collection efficiency of theoretically dry particles
// HRCE_fPhase = collection efficiency as a function of its phase, or composition, i.e. H2SO4 droplets vs pure dry HNO3

static constant Mass_NH4=18.03437414
static constant Mass_SO4=95.95172922
static constant Mass_NO3=61.98781787
static constant Mass_Chl=35.45
static constant Mass_NH4NO3=80.02219201

//1.52
// Creates the phase dependent CE panel
Function PK_CreatePhaseDepCE() 

	DoWindow/F HR_CE_panel
	if (V_flag)
		return 0
	endif
	
	NewDataFolder/o root:CE_HR
	sq_initializeGlobalSVar("root:CE_HR:CEStatsStr", "")
	
	NewPanel/N=HR_CE_panel /W=(166,108,867,475) as "HR_CE_panel"
	ModifyPanel fixedSize=1		//1.57L

	SetDrawLayer UserBack
	SetDrawEnv fsize= 14
	DrawText 8,38,"ver. 1.0.1"
	DrawText 7,59,"*Only applicable to ambient data*"
	SetDrawEnv fsize= 10
	DrawText 7,92,"Step 0. Finalize your HRNH4 RIE."
	SetDrawEnv fsize= 10
	DrawText 27,210,"units=g/m3, with CE=1, with AB correction"
	SetDrawEnv fsize= 16,fstyle= 1
	DrawText 5,22,"HR Composition Dependent CE"
	SetDrawEnv fsize= 10
	DrawText 5,359,"Step 7. (Opt.) Enter HRCE_fphase in Batch table."
	SetDrawEnv fsize= 10
	DrawText 5,240,"Step 3. (Optional)"
	SetDrawEnv fsize= 10
	DrawText 5,279,"Step 5. (Optional)"
	SetDrawEnv fsize= 10
	DrawText 2,220,"if HRNH4 < min level, default CE (step 4) will be used"

	Button buttonUrlMiddlebrook,pos={135,21},size={120,20},fsize=10,proc=sq_URLButton,title="Middlebrook et al. pdf"
	Button ceHelp,pos={205,43},size={50,20},fsize=10,proc=sq_URLButton,title="help"
	Button ceReviewNH4RIE,pos={190,99},size={65,20},fsize=10,proc=pk_butt_reviewNH4RIE,title="HR Batch"
	Button pk_butt_CENH4AcidityGraph,pos={190,75},size={65,20},fsize=10,proc=pk_butt_CENH4AcidityGr,title="UMR Graph"
	
	GroupBox groupParams,pos={1,166},size={255,156},title="CDCE user parameters"
	GroupBox groupParams,fColor=(1,1,1)
	GroupBox groupOptionalPrelim,pos={1,62},size={255,78},fsize=10,title="Preliminary calculations using CE=1"
	GroupBox groupOptionalPrelim,fColor=(1,1,1)

	SetVariable CE4LowNH4,pos={5,243},size={245,16},fsize=10,title="Step 4. Set default CE (when comp. indep.)"
	SetVariable CE4LowNH4,format="%1.2f",limits={0,10,0},value= _NUM:0.5
	SetVariable NH4DetLim,pos={5,182},size={245,16},fsize=10,title="Step 2. Set min. NH4 level to use in calcs"
	SetVariable NH4DetLim,format="%1.3f",limits={0,1,0},value= _NUM:0.02
	CheckBox checkUseRH,pos={105,264},size={145,14},fsize=10,title="Use RH of sampling line, %"
	CheckBox checkUseRH,value= 0
	CheckBox checkUseSmooth,pos={105,225},size={112,14},fsize=10,title="Num. pts. to smooth"
	CheckBox checkUseSmooth,value= 1
	SetVariable Num2SmoothVar,pos={218,226},size={35,16},fsize=10,value= _NUM:20
	SetVariable setvarRH,pos={23,281},size={230,16},fsize=10,title="RH wave of AMS sampling line, in root"
	SetVariable setvarRH,value= _STR:""
	Button buttonCalcCE,pos={5,322},size={240,20},fsize=10,proc=pk_butt_Calc_CDCE,title="Step 6. Calculate composition dependent CE"
	Button buttonCalcCE,fColor=(65280,43520,0)
	Button buttonCalcTSforCE,pos={5,143},size={210,20},fsize=10,proc=pk_butt_CalcTS_CDCE,title="Step 1. Calc aerosol TS with CE=1 for todo"
	Button buttonCalcTSforCE,fColor=(65280,43520,0)
	Button CEis1_TSGraph,pos={217,143},size={40,20},fsize=10,proc=pk_create_CEis1_TSgraph,title="Graph"
	Button ceSetInflectionPoints,pos={3,299},size={220,18},fsize=10,proc=pk_butt_CEAdvPanel,title="Advanced users only - Set inflection points"
	Button ceSetInflectionPoints,fSize=10

	TabControl tabCE,pos={258,0},size={445,330},proc=pk_CETabProc
	TabControl tabCE,tabLabel(0)="HR CE Hist",tabLabel(1)="CE Stats"
	TabControl tabCE,tabLabel(2)="HRNH4",tabLabel(3)="HRNO3",tabLabel(4)="HRSO4"
	TabControl tabCE,tabLabel(5)="HROrg",tabLabel(6)="HRChl",value=0
	TitleBox titleCEStats,pos={262,42},size={201,78},frame=0
	TitleBox titleCEStats,fsize=10,variable= root:CE_HR:CEstatsStr
	TitleBox titleTSLegend,pos={495,60},size={100,52},fsize=10,frame=0
	TitleBox titleTSLegendStats,pos={490,25},size={139,26},frame=0
	PopupMenu ams_todolist_pop,pos={7,94},size={148,21},bodyWidth=120,proc=sq_pop_toDoList,title="Todo"
	PopupMenu ams_todolist_pop,fSize=10
	PopupMenu ams_todolist_pop,mode=1,popvalue="Get List",value= #"root:panel:sq_toDoList+\"Get List;\"\t"
	Button pk_but_pk_CECorrGraph,pos={492,121},size={40,20},fsize=10,disable=1,proc=sq_butt_popThis,title="<- Pop"
	Button pk_but_pk_CETSGraph,pos={574,121},size={40,20},fsize=10,proc=sq_butt_popThis,title="Popv"
	Button pk_but_pk_CEHistGraph,pos={472,120},size={40,20},fsize=10,proc=sq_butt_popThis,title="Pop^"
	Button pk_but_pk_AcidityHistGraph,pos={566,140},size={40,20},fsize=10,disable=1,proc=sq_butt_popThis,title="^Pop"
	Button pk_but_pk_ANMFOrgMFHistGraph,pos={307,140},size={40,20},fsize=10,disable=1,proc=sq_butt_popThis,title="Popv"
	Button pk_but_pk_RelHumHistGraph,pos={521,140},size={40,20},fsize=10,fsize=10,disable=1,proc=sq_butt_popThis,title="Popv"
	Button pk_but_pk_NH4DetLimHistGraph,pos={262,140},size={40,20},fsize=10,disable=1,proc=sq_butt_popThis,title="Pop^"
	Button pk_but_pk_CEfphaseTable,pos={393,140},size={120,20},fsize=10,disable=1,proc=sq_butt_popThis,title="HRCE_fphase Table"
	Button pk_but_CETypeFlagLegend,pos={264,124},size={130,20},fsize=10,proc=pk_butt_CETypeFlagLegend,title="Pop CETypeFlag Legend"
	PopupMenu HRResults_pop_dataSet,pos={7,118},size={111,21},fsize=10,proc=HR_pop_getStickDataSet,title="Data"
	PopupMenu HRResults_pop_dataSet,help={"Source data to use."},fSize=10
	PopupMenu HRResults_pop_dataSet,mode=1,popvalue="Get List",value= #"root:HR_panel:HR_StickList+\"Get List;\""  //1.21G

	// get paramters from last time this was calculated.
	wave/z ANMF_hist = root:CE_HR:ANMF_hist		// any one of several waves could do to check values.
	if (WaveExists(ANMF_hist))		// things were calculated before.  Try to find the last values.
		wave/z HRCE_fphase = root:HRCE_fphase		// any one of several waves could do to check values.
		if (WaveExists(HRCE_fphase) && strlen(Note(HRCE_fphase))>0)		// assume that nothing has been tampered with
			string CEnote = Note(HRCE_fphase)
//			print CEnote
			SetWindow HR_CE_panel userdata(defaultCE)=StringByKey("defaultCE",CEnote)
			SetWindow HR_CE_panel userdata(NH4DetLim)=StringByKey("NH4DetLim",CEnote)
			SetWindow HR_CE_panel userdata(todo)=StringByKey("todo",CEnote)
			SetWindow HR_CE_panel userdata(UseRH)=StringByKey("UseRH",CEnote)
			SetWindow HR_CE_panel userdata(RHwave)=StringByKey("RHwave",CEnote)
			SetWindow HR_CE_panel userdata(UseSmooth)=StringByKey("UseSmooth",CEnote)
			SetWindow HR_CE_panel userdata(num2smooth)=StringByKey("num2smooth",CEnote)

			SetVariable CE4LowNH4,value = _NUM:(str2num(StringByKey("defaultCE",CEnote)))
			SetVariable NH4DetLim,value= _NUM:(str2num(StringByKey("NH4DetLim",CEnote)))
			CheckBox checkUseRH,value= str2num(StringByKey("UseRH",CEnote))
			SetVariable setvarRH,value= _STR:(StringByKey("RHwave",CEnote))					
			CheckBox checkUseSmooth,value=str2num(StringByKey("UseSmooth",CEnote))
			SetVariable Num2SmoothVar,value= _NUM:(str2num(StringByKey("num2smooth",CEnote)))
		endif			
	endif

	pk_CETabProc("tabCE",0)  // update graphs by simulating  selecting the Total tab

End
 

// This function generates time series of NH4, SO4, NO3, Chl, Org using a CE of 1 and then calls CalcCE_fPhase.
// The units of the time series waves is ug/m3 
// Can be used with or without the AB correction, no AB is used here.
//1.52
Function PK_butt_CalcTS_CDCE(ctrlName) : ButtonControl
	String ctrlName

	wave/t HR_spec_list  = root:HR_frag:HR_spec_list
	wave HR_specCEFac_list  = root:HR_frag:HR_specCEFac_list
	wave/t HR_speccorr_list  = root:HR_frag:HR_speccorr_list
	wave/t/z HR_CEWave_list  = root:HR_frag:HR_CEWave_list
	wave t_series  = root:index:t_series

	if (!WaveExists(HR_CEWave_list))
		make/t/o/n=(numpnts(HR_specCEFac_list)) root:HR_frag:HR_CEWave_list /wave=HR_CEWave_list
		HR_CEWave_list=""
	endif
	
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm	
	ControlInfo /w=HR_CE_panel ams_todolist_pop
	if (!stringmatch(S_Value,sq_toDoWvNm ))
		abort "Please reselect the todo wave."
	endif	
	wave todowave = $"root:"+sq_toDoWvNm

// Manjula wanted folks to automatically use all or allV
//	nvar VWSwitching = root:diagnostics:VWSwitching
//	if (VWSwitching)
//		wave todowave = root:allV
//		sq_toDoWvNm = "allV"
//	else
//		wave todowave = root:all
//		sq_toDoWvNm = "all"
//	endif	
//	pk_pop_toDoList("ams_todolist_pop",0,sq_toDoWvNm) 
	
	nvar HR_checkCalcHRErrors=root:HR_panel:HR_checkCalcHRErrors	
	nvar HR_checkAskForSuffix=root:HR_panel:HR_checkAskForSuffix
	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	nvar HRResults_graphOutputType=root:HR_panel:HRResults_graphOutputType
//	nvar HRResults_dataType=root:HR_panel:HRResults_dataType
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3	// ug/m3
	nvar HR_checkUseAB=root:HR_panel:HR_checkUseAB

	// we do not use the AB correction by default because we look at ratios and these ratios should be unaffected

	nvar ams_time_saved=root:panel:ams_time_saved	// don't do any time averaging

	variable NH4Row, SO4Row, NO3Row, ChlRow, OrgRow
	variable NH4_CEVal, SO4_CEVal, NO3_CEVal, Chl_CEVal, Org_CEVal
	variable killFlag, numTSeries, UseRH=0, detectorFlag
	string NH4_CorrStr, SO4_CorrStr, NO3_CorrStr, Chl_CorrStr, Org_CorrStr
	string NH4_CECorrStr, SO4_CECorrStr, NO3_CECorrStr, Chl_CECorrStr, Org_CECorrStr
	string RHWaveStr	, CEnote
	variable temp_HRResults_graphOutputType

	string specTypeInitial, spectraType			//1.15Q
 	ControlInfo/W=HR_CE_panel HRResults_pop_dataSet
	if (stringMatch(S_Value, "Initialize"))
		abort "Please select the data type from the drop down menu."
	else
		spectraType=S_Value
	endif

	if ( strsearch(spectraType, "OMinusC", 0)   >=0	)
		specTypeInitial="M"/// m for Open minus closed
	else 
		specTypeInitial=spectraType[2]		//i.e. HROpenStick
	endif

	temp_HRResults_graphOutputType=HRResults_graphOutputType
	wave/z corr_fact = root:diagnostics:corr_fact
	if (!WaveExists(corr_fact))
		abort "You must first generate an airbeam correction factor before proceeding. aborting from pk_CalcCompDepCE_ButtonProc"
	endif
	
	detectorFlag=sq_TodoWaveHasOnlyOneDetType(todowave)
	if (detectorFlag>=0)
		DoAlert, 2, "The chosen todo wave has runs from different detection schemes (i.e. V and W mode).  To proceed, press Yes, to abort, press Cancel, to see which run had problems,   press No."
		if (V_flag==2)
			edit root:diagnostics:detector_num, root:index:rn_series
			ModifyTable topLeftCell=(detectorFlag,0)	
		elseif(V_flag==3)
			Abort "The user has chosen to abort"
		endif
	endif
	
	// we do alot of preparations
	// first find the species in the batch table
	NH4Row = sq_findStr(HR_spec_list,"HRNH4",1)
	SO4Row = sq_findStr(HR_spec_list,"HRSO4",1)
	NO3Row = sq_findStr(HR_spec_list,"HRNO3",1)
	ChlRow = sq_findStr(HR_spec_list,"HRChl",1)
	OrgRow = sq_findStr(HR_spec_list,"HROrg",1)

	if (NH4Row==-1 || SO4Row==-1 || NO3Row==-1 || ChlRow==-1 || OrgRow==-1 )
		abort "Cannot find one of the species NH4, NO3, SO4, Chl, or Org in root:HR_frag:HR_spec_list - cannot proceed."
	endif
	
	wave todowave = $"root:"+sq_toDoWvNm
	if (numpnts(todowave) < numTSeries/4)		// numTSeries/4 is an estimate.  We really don't care what todo wave is chosen, but ideally it would be one that encompassed all the data
		DoAlert 1,  "The todo wave you have chosen, "+sq_toDoWvNm+" should encompass all data, but doesn't have to.  Press yes to continue using this todo wave."
		if (V_flag==2)
			return 0		// User chose to quit
		endif
	endif
	
	// CalcCE_fPhase relies on the CE being 1 (or at least identical) for its calculations so save the old values and replace them when we are done.
	//  Jose suggested that we don't change the CE values in the batch table, in case something goes wrong. 
	NH4_CEVal = HR_specCEFac_list[NH4Row]
	SO4_CEVal = HR_specCEFac_list[SO4Row]
	NO3_CEVal = HR_specCEFac_list[NO3Row]
	Chl_CEVal = HR_specCEFac_list[ChlRow]
	Org_CEVal = HR_specCEFac_list[OrgRow]

	//  Check to see that the values are empty (is default)
	NH4_CorrStr = HR_speccorr_list[NH4Row]
	SO4_CorrStr = HR_speccorr_list[SO4Row]
	NO3_CorrStr = HR_speccorr_list[NO3Row]
	Chl_CorrStr = HR_speccorr_list[ChlRow]
	Org_CorrStr = HR_speccorr_list[OrgRow]
	
	//  Check to see that the values are empty (is default)
	NH4_CECorrStr = HR_CEWave_list[NH4Row]
	SO4_CECorrStr = HR_CEWave_list[SO4Row]
	NO3_CECorrStr = HR_CEWave_list[NO3Row]
	Chl_CECorrStr = HR_CEWave_list[ChlRow]
	Org_CECorrStr = HR_CEWave_list[OrgRow]

	if (Strlen(NH4_CorrStr)!=0 || Strlen(SO4_CorrStr)!=0 || Strlen(NO3_CorrStr)!=0 || Strlen(Chl_CorrStr)!=0 || Strlen(Org_CorrStr)!=0  )
		// we shouldn't overwrite the values in the spec corr list UNLESS all values are the old calculated CE_fPhase.
		// The user will have to decide to enter/modify the values in HR_speccorr_list wave him/herself if they want to retain their HR_speccorr_list waves
		DoAlert 1, "In the HR_speccorr_list wave in the batch table there was a non blank entry for one of the species: NH4, SO4, NO3, Chl, or Org. Press yes to continue without using this speccorr value."
		if (V_flag==2)
			return 0		// User chose to quit
		endif
 	endif

	// prepare global variables in squirrel panel in anticipation of calling CalcCE_fPhase  by default CE and RIE will be 1
	HR_checkUseAB=1
	HR_checkCalcHRErrors=0
	HR_checkConvertTougm3=1
	HR_checkAskForSuffix = 1
	HRResults_ionList="HRNH4,HRSO4,HRNO3,HRChl,HROrg"
	HRResults_graphOutputType = 5 // = do nothing	
// 	HRResults_dataType = 4 // = OMinusC
	sq_timebase_check("ams_time_saved",1) 
	HR_checkUseAB=1		// use AB correction

	// 1.15Q
	HR_CalcPlot_MSVsTime("CE1", "", spectraType, specTypeInitial,"nanTo0_flag:0;negTo0_flag:0;corr_op:0;ug_op:1;t_base:;timeweight_op:3;PToFFlag:0;","")
//	sq_MSCalcPlot_TSeries("CE1", "")		// calculate the time series of the 5 species with a CE of 1 
	// If there are waves in the HR_speccorr_list They are applied!!
	//  because we don't want to interfere with the get parameter function we manually undo any values that are in the batch table
  	
	HRResults_graphOutputType=temp_HRResults_graphOutputType	// set this back to original value

	wave HRNH4_CE1 = root:HRNH4_M_CE1	// the suffix we give these waves is CE1
	wave HRSO4_CE1 = root:HRSO4_M_CE1
 	wave HRNO3_CE1 = root:HRNO3_M_CE1
  	wave HRChl_CE1 = root:HRChl_M_CE1
 	wave HROrg_CE1 = root:HROrg_M_CE1

	// in pk_MSConc we divide by CE so now we multiply
	HRNH4_CE1 *= NH4_CEVal	
	HRSO4_CE1 *= SO4_CEVal
	HRNO3_CE1 *= NO3_CEVal
	HRChl_CE1 *= Chl_CEVal
	HROrg_CE1 *= Org_CEVal

	wave/z NH4_CECorrWave = $NH4_CECorrStr
	if (WaveExists(NH4_CECorrWave))
		HRNH4_CE1*=	NH4_CECorrWave
	endif
	wave/z SO4_CECorrWave = $SO4_CECorrStr
	if (WaveExists(SO4_CECorrWave))
		HRSO4_CE1*=	SO4_CECorrWave
	endif
	wave/z NO3_CECorrWave = $NO3_CECorrStr
	if (WaveExists(NO3_CECorrWave))
		HRNO3_CE1*=	NO3_CECorrWave
	endif
	wave/z Org_CECorrWave = $Org_CECorrStr
	if (WaveExists(Org_CECorrWave))
		HROrg_CE1*=	Org_CECorrWave
	endif
	wave/z Chl_CECorrWave = $Chl_CECorrStr
	if (WaveExists(Chl_CECorrWave))
		HRChl_CE1*=	Chl_CECorrWave
	endif

	// in pk_MSConc we use Spec Corr so now we undo it
//	NH4_CorrStr = HR_speccorr_list[NH4Row]
//	SO4_CorrStr = HR_speccorr_list[SO4Row]
//	NO3_CorrStr = HR_speccorr_list[NO3Row]
//	Chl_CorrStr = HR_speccorr_list[ChlRow]
//	Org_CorrStr = HR_speccorr_list[OrgRow]
//
//	wave/z NH4_CorrWave = $"root:"+NH4_CorrStr
//	if (strlen(NH4_CorrStr)>0 && WaveExists(NH4_CorrWave))
//		HRNH4_CE1 *= NH4_CorrWave		// in pk_MSConc we divide by CE so now we multiply
//	endif
//	wave/z SO4_CorrWave = $"root:"+SO4_CorrStr
//	if (strlen(SO4_CorrStr)>0 && WaveExists(SO4_CorrWave))
//		HRSO4_CE1 *= SO4_CEVal
//	endif
//	wave/z NO3_CorrWave = $"root:"+NO3_CorrStr
//	if (strlen(NO3_CorrStr)>0 && WaveExists(NO3_CorrWave))
//		HRNO3_CE1 *= NO3_CEVal
//	endif
//	wave/z Chl_CorrWave = $"root:"+Chl_CorrStr
//	if (strlen(Chl_CorrStr)>0 && WaveExists(Chl_CorrWave))
//		HRChl_CE1 *= Chl_CEVal
//	endif
//	wave/z Org_CorrWave = $"root:"+Org_CorrStr
//	if (strlen(Org_CorrStr)>0 && WaveExists(Org_CorrWave))
//		HROrg_CE1 *= Org_CEVal
//	endif

	duplicate/o HROrg_CE1 root:CE_HR:HRTotal_CE1/wave=HRTotal_CE1
 	HRTotal_CE1 = HRNH4_CE1+HRSO4_CE1+HRNO3_CE1+HRChl_CE1+HROrg_CE1

	Note HRTotal_CE1, "Data set: "+spectraType		//1.15Q  We could use any wave to attach this note to.

	//put results into CE folder.
	newDataFolder/o root:CE_HR
	duplicate/o HRNH4_CE1 root:CE_HR:HRNH4_CE1
	duplicate/o HRSO4_CE1 root:CE_HR:HRSO4_CE1
	duplicate/o HRNO3_CE1 root:CE_HR:HRNO3_CE1
	duplicate/o HRChl_CE1 root:CE_HR:HRChl_CE1
	duplicate/o HROrg_CE1 root:CE_HR:HROrg_CE1
	
	killwaves/z HRNH4_CE1, HRSO4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1
	SetWindow HR_CE_panel userdata(todo)= sq_toDoWvNm
	
	pk_create_CEis1_TSgraph("") 

End


//1.52
// In CDCE panel show Acidity plot in FragChecks Panel
Function PK_butt_CENH4AcidityGr(ctrlName) : ButtonControl
	String ctrlName

	wave/z NH4_predict = root:quantifChecks:NH4_predict
	if (WaveExists(NH4_predict))
		sq_butt_popThis("button_FC_NH4MeasPredGraph")
	else	
		abort "You must first do the Frag table correction checks before doing the composition dependent CE   aborting from pk_butt_CENH4AcidityGr"
	endif
End


//1.52
// After generating time series waves of 5 aerosol species with CE=1, find the time dependent CE
Function PK_butt_Calc_CDCE(ctrlName) : ButtonControl
	String ctrlName

	variable numTSeries, UseRH, NH4_DetLimit, varCE_lowNH4, SmoothVar, SmoothTypeVar, UseSmooth=0
	string RHWaveStr, CENote
	 	
	wave HRNH4_CE1 = root:CE_HR:HRNH4_CE1
	wave HRSO4_CE1 = root:CE_HR:HRSO4_CE1
 	wave HRNO3_CE1 = root:CE_HR:HRNO3_CE1
  	wave HRChl_CE1 = root:CE_HR:HRChl_CE1
 	wave HROrg_CE1 = root:CE_HR:HROrg_CE1
 	wave HRTotal_CE1 = root:CE_HR:HRTotal_CE1

	DoWindow/F HR_CE_panel
	
	string spectraType = Note(HRTotal_CE1)		//1.15Q  We could use any wave to attach this note to.

	numTSeries = numpnts(HRNH4_CE1)		// can use any species

	SmoothTypeVar=nan
	SmoothVar=nan
	RHWaveStr=""

	// get user input and do sanity checks
	ControlInfo/w=HR_CE_panel NH4DetLim
	NH4_DetLimit=V_value
	if ( !(NH4_DetLimit>0))
		abort "The NH4 detection limit must be > 0.  Aborting from pk_CalcCompDepCE_ButtonProc"
	endif
	
	ControlInfo/w=HR_CE_panel CE4LowNH4
	varCE_lowNH4=V_value
	if ( varCE_lowNH4<0.001  || varCE_lowNH4>10 || numtype(varCE_lowNH4)!=0)
		abort "The CE for low NH4 must be > 0.001 and less than 10.  Aborting from pk_CalcCompDepCE_ButtonProc"
	endif

	ControlInfo/w=HR_CE_panel checkUseSmooth 
	if (V_value)
		controlinfo/w=ams_panel misc_smooth
		SmoothTypeVar=v_value
		ControlInfo Num2SmoothVar; SmoothVar=V_value 
		if (!(SmoothVar>=1))
			abort "The number of points to smoothe must be >=1.  Aborting from pk_CalcCompDepCE_ButtonProc"
		endif
		UseSmooth=1
	endif
	
	ControlInfo/w=HR_CE_panel checkUseRH
	if (V_value)
		wave/z RHSampleLineWave = gen_returnSelectedWave("setVarRH", DFstr="root:", num=numTSeries, minVal=0, maxVal=110, nansOK=0)
		if (!WaveExists(RHSampleLineWave) )
			abort "Something was wrong with the chosen RH wave. aborting from pk_CalcCompDepCE_ButtonProc"
		endif
		RHWaveStr=nameofWave(RHSampleLineWave)
		UseRH=1
	endif

 	//  finally, call the function to calculate CE_fPhase
 	if (WaveExists(RHSampleLineWave))
 		if (SmoothVar>=1)
 			pk_CalcHRCE_fPhase(NH4_DetLimit,varCE_lowNH4, HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1, RH_SampLine= RHSampleLineWave, SmoothVariable=SmoothVar, SmoothTypeVariable=SmoothTypeVar)
 		else
  			pk_CalcHRCE_fPhase(NH4_DetLimit,varCE_lowNH4, HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1, RH_SampLine= RHSampleLineWave)
		endif
 	else
 		if (SmoothVar>=1)
 			pk_CalcHRCE_fPhase(NH4_DetLimit,varCE_lowNH4, HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1, SmoothVariable=SmoothVar, SmoothTypeVariable=SmoothTypeVar)
 		else
	   		pk_CalcHRCE_fPhase(NH4_DetLimit,varCE_lowNH4, HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1)
   		endif
 	endif
 	
	// the result!!		// note that CD_fphase has to be retained in the root folder if it is used in the HR_speccorr_list column
	wave HRCE_fPhase = root:HRCE_fPhase
	
	duplicate/o HRNH4_CE1 root:CE_HR:HRNH4_CDCE/wave=HRNH4_CDCE
	duplicate/o HRSO4_CE1 root:CE_HR:HRSO4_CDCE/wave=HRSO4_CDCE
	duplicate/o HRNO3_CE1 root:CE_HR:HRNO3_CDCE/wave=HRNO3_CDCE
	duplicate/o HRChl_CE1 root:CE_HR:HRChl_CDCE/wave=HRChl_CDCE
	duplicate/o HROrg_CE1 root:CE_HR:HROrg_CDCE/wave=HROrg_CDCE

	HRNH4_CDCE/=HRCE_fPhase
	HRSO4_CDCE/=HRCE_fPhase
	HRNO3_CDCE/=HRCE_fPhase
	HRChl_CDCE/=HRCE_fPhase
	HROrg_CDCE/=HRCE_fPhase

	duplicate/o HROrg_CDCE root:CE_HR:HRTotal_CDCE/wave=HRTotal_CDCE
 	HRTotal_CDCE = HRNH4_CDCE+HRSO4_CDCE+HRNO3_CDCE+HRChl_CDCE+HROrg_CDCE
 	
	SetWindow HR_CE_panel userdata(defaultCE)=num2str(varCE_lowNH4)
	SetWindow HR_CE_panel userdata(NH4DetLim)= num2str(NH4_DetLimit)
	SetWindow HR_CE_panel userdata(UseRH)= num2str(UseRH)
	SetWindow HR_CE_panel userdata(RHwave)=RHWaveStr
	SetWindow HR_CE_panel userdata(UseSmooth)=num2str(UseSmooth)
	SetWindow HR_CE_panel userdata(num2smooth)=num2str(SmoothVar)

	// create a wave note for root:HRCE_fPhase that has all the pertinant info
	CEnote = spectraType+";"
	CEnote += "defaultCE:"+num2str(varCE_lowNH4)+";"
	CEnote += "NH4DetLim:"+num2str(NH4_DetLimit)+";"
	CEnote += "todo:"+ GetUserData("HR_CE_panel", "", "todo")+";"
	CEnote += "UseRH:"+num2str(UseRH)+";"
	CEnote += "RHwave:"+RHWaveStr+";"
	CEnote += "UseSmooth:"+num2str(UseSmooth)+";"
	CEnote += "num2smooth:"+num2str(SmoothVar)+";"
	
	DoWindow/F AdvUserCEPanel
	if (V_flag) 
		ControlInfo checkUseTheseInflPts
		if (V_value)		// User wants to set their own inflection points.  We use varCE_lowNH4 as the default CE for all cases
			// sanity checks
			ControlInfo Acidity_inflectionPt
			CEnote += "AcidicCutoff:"+num2str(V_Value)+";"
			ControlInfo ANMF_inflectionPt
			CEnote += "ANMFcutoff:"+num2str(V_Value)+";"
			ControlInfo Humidity_inflectionPt
			CEnote += "Humiditycutoff:"+num2str(V_Value)+";"
		endif		// we use user settable inflection points
	endif
	
	Note/K HRCE_fPhase CEnote

	if (UseRH)
		pk_calcCDCE_extras(UseRH, RHWave =RHSampleLineWave )
	else
		pk_calcCDCE_extras(UseRH)
	endif
	
	ControlInfo/w=HR_CE_panel tabCE
	pk_plotCEGrs(V_Value)		// update plots

End


//1.52
// does the work of calculating the phase dependent CE
Function PK_CalcHRCE_fPhase(NH4_DetLimit,varCE_lowNH4, HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1, [RH_SampLine, SmoothVariable, SmoothTypeVariable])
	variable NH4_DetLimit,varCE_lowNH4, SmoothVariable, SmoothTypeVariable
	wave HRSO4_CE1, HRNH4_CE1, HRNO3_CE1, HRChl_CE1, HROrg_CE1, RH_SampLine
	// NH4_DL = ammonium detection limit
	// varCE_lowNH4 = CE for points where ammonium is below its detection limit
	// SO4, NH4, NO3, Chl, Org are all calculated using a CE of 1 (and an anticipated HR_speccorr_list value being blank)
	// RH_SampLine = t_series length wave or sampling line RH in % 
	// SmoothVariable = number of points to smooth.  In Middlebrook et al paper data is gaussian smoothed with number of points = 1
	// SmoothTypeVariable is 1=gaussian or 2=boxcar smoothing and is determined by the popup menu in the squirrel misc tab setting
	
	//  all variables below are from Ann's paper.  Use these unless user sets their own inflection points
	variable Eq4_slope = 0.9167		// ANMF equation   if ANMF=.4546 then CE = 0.0833+0.9167*(.4546) = .5
	variable Eq4_intercept = 0.0833	// ANMF equation  Inflection point is .4546
	variable ANMFcutoff =0.4546	// NOT USED IN EQUATIONS but is already determined by Eq 4 slope and intercept

	variable Eq6_slope = -0.73		// acidity equation       if NH4Meas/NH4Predict=.75 then CE = 1 - 0.73*(.75 ) = .4546
	variable Eq6_intercept = 1		// acidity equation
	variable AcidicCutoff = 0.75
//	For Reference:
//	Acidity CE by Quinn et al 2006:
//	CE_Acidity_dry = NH4_MeasToPredict[p]>=0.5 ? varCE_lowNH4 : 1.0-1.1*NH4_MeasToPredict[p])
// 	(5CEdry -4)+((1-CEdry)/20)RH)
	variable Eq7_slopeA = 5		// humidity equation
	variable Eq7_interceptA = -4	// humidity equation
	variable Eq7_slopeB = -1		// humidity equation
	variable Eq7_interceptB = 1	// humidity equation
	variable Eq7_slopeC = 20		// humidity equation
	variable humidityCutoff = 80		// 80 %  we need rel hum to be in percent
	 	
	DoWindow/F AdvUserCEPanel
	if (V_flag)		// window exists
		ControlInfo checkUseTheseInflPts
		if (V_value)		// User wants to set their own inflection points.  We use varCE_lowNH4 as the default CE for all cases
			// sanity checks
			ControlInfo Acidity_inflectionPt
			if ( ! (V_value > 0 && V_Value < 1) )
				abort "The acidity inflection point must be between 0 and 1. aborting from pk_CalcCE_fPhase"
			endif			
			AcidicCutoff  = V_Value
			Eq6_intercept = 1		// acidity equation... this is retained.  We have two points (0,1) and (defaultCE, AcidicCutoff)
			Eq6_slope = (1-varCE_lowNH4)	/(0-AcidicCutoff)// acidity equation   slope = deltay/deltax
			
			ControlInfo ANMF_inflectionPt
			if ( ! (V_value > 0 && V_Value < 1) )
				abort "The ANMF inflection point must be between 0 and 1. aborting from pk_CalcCE_fPhase"
			endif
			ANMFcutoff = V_Value 	// ANMF equation... this is retained.  We have two points (1,1) and (defaultCE, ANMFcutoff)
			Eq4_slope = (1-varCE_lowNH4)/(1-ANMFcutoff)	
			Eq4_intercept =1-Eq4_slope  // if ANMF=.4546 then CE = 0.0833+0.9167*(.4546) = .5
						
			ControlInfo Humidity_inflectionPt
			if ( ! (V_value > 0 && V_Value < 100 && !ParamisDefault(RH_SampLine) ) )
				abort "The relative humidity inflection point must be between 0 and 1. aborting from pk_CalcCE_fPhase"
			endif			
			humidityCutoff=V_Value	// RH equation We have two points (100,1) and (defaultCE, humidityCutoff) 
			//  (5CEdry-4)+(1-CEdry)/((20)RH) 
			//  (100-humidityCutoff/100)/(100-humidityCutoff)   +(1-CEdry)/((100-humidityCutoff)RH) 
			Eq7_slopeA = 100/(100-humidityCutoff) 	//5
			Eq7_interceptA = - humidityCutoff/(100-humidityCutoff) 	// -4
			Eq7_slopeB = -1		// 
			Eq7_interceptB = 1	// 
			Eq7_slopeC = (100-humidityCutoff) 	// 20	
		
		endif
	endif
	DoWindow/F HR_CE_panel
	
	// Create waves of each species to smooth for the calculations.  
	// These waves will be killed automatically when the function is completed.
	duplicate/o HRSO4_CE1 root:CE_HR:HRSO4_CE1_smooth	/wave=HRSO4_CE1_smooth	// the suffix _CE1 indicates that the values were calculated with a CE of 1
	duplicate/o HRNH4_CE1 root:CE_HR:HRNH4_CE1_smooth/wave=HRNH4_CE1_smooth
	duplicate/o HRNO3_CE1 root:CE_HR:HRNO3_CE1_smooth/wave=HRNO3_CE1_smooth
	duplicate/o HRChl_CE1 root:CE_HR:HRChl_CE1_smooth/wave=HRChl_CE1_smooth
	duplicate/o HROrg_CE1 root:CE_HR:HROrg_CE1_smooth/wave=HROrg_CE1_smooth

	// first smooth if applicable	
	if ( !ParamIsDefault(SmoothVariable) && !ParamIsDefault(SmoothTypeVariable) && SmoothVariable>0)
		// interpolate across time   If we don't interpolate we get extra nans where we might not want them
		gen_InterpolateAcrossTime(root:index:t_series,HRSO4_CE1_smooth)	
		gen_InterpolateAcrossTime(root:index:t_series,HRNH4_CE1_smooth)	
		gen_InterpolateAcrossTime(root:index:t_series,HRNO3_CE1_smooth)	
		gen_InterpolateAcrossTime(root:index:t_series,HROrg_CE1_smooth)	
		gen_InterpolateAcrossTime(root:index:t_series,HRChl_CE1_smooth)	
		if (SmoothVariable ==2)		// boxcar smoothing
			Smooth/B=(SmoothVariable), SmoothVariable, HRSO4_CE1_smooth,HRNH4_CE1_smooth,HRNO3_CE1_smooth,HRChl_CE1_smooth, HROrg_CE1_smooth		//1.57J	
		else
			Smooth SmoothVariable, HRSO4_CE1_smooth,HRNH4_CE1_smooth,HRNO3_CE1_smooth,HRChl_CE1_smooth, HROrg_CE1_smooth	
		endif
		HRNH4_CE1_smooth = numtype(HRNH4_CE1[p])==0 ? HRNH4_CE1_smooth[p] : nan
		HRSO4_CE1_smooth = numtype(HRSO4_CE1[p])==0 ? HRSO4_CE1_smooth[p] : nan
		HRNO3_CE1_smooth = numtype(HRNO3_CE1[p])==0 ? HRNO3_CE1_smooth[p] : nan
		HRChl_CE1_smooth = numtype(HRChl_CE1[p])==0 ? HRChl_CE1_smooth[p] : nan
		HROrg_CE1_smooth = numtype(HROrg_CE1[p])==0 ? HROrg_CE1_smooth[p] : nan		
	endif
	
	variable idex, tempCE, num = numpnts(HRSO4_CE1)		// can use any wave to get the number of points of waves created below

	SetDataFolder root:CE_HR
	make/o/n=(num)/free PredHRNH4_CE1
	make/o/n=(num) ANMF, CE_dry, NH4_MeasToPredict		// waves that will be retained in root upon completion of function 
	make/o/n=(num) CE_Acidity, CE_ANMF, CE_Humidity, CETypeFlag
	SetDataFolder root:
	
	make/o/n=(num) root:HRCE_fPhase/wave=HRCE_fPhase=nan

	// Get all the parts we need for the CE formulation:  ANMF & NH4_MeasToPredict
	PredHRNH4_CE1=Mass_NH4*(2*HRSO4_CE1_smooth/Mass_SO4+HRNO3_CE1_smooth/Mass_NO3+HRChl_CE1_smooth/Mass_Chl)	// presume Org doesn't contribute to acidity 
	  
	NH4_MeasToPredict = HRNH4_CE1_smooth/PredHRNH4_CE1
	
	// replace values < 0 with nans
	NH4_MeasToPredict = ( HRNH4_CE1_smooth[p]<0 || PredHRNH4_CE1[p]<0 ) ? nan : NH4_MeasToPredict[p] 
	
	ANMF=(Mass_NH4NO3/Mass_NO3)*HRNO3_CE1_smooth/(HRNO3_CE1_smooth+HRSO4_CE1_smooth+HRNH4_CE1_smooth+HROrg_CE1_smooth+HRChl_CE1_smooth)	
	
	// replace values < 0 and > 1  with nans
	ANMF =  (ANMF[p]<0 ||  ANMF[p]> 1 || HRNO3_CE1_smooth[p]<0) ? nan : ANMF[p] 

	// Calculate the dry collection efficiency, CE_dry	
	// estimate CE_dry via the measured to predicted.  If >= .75 use  0.0833+0.9167*ANMF[idex]
	// Middlebrook et al describes that when ANMF is high, we typically don't have high acidity and visa versa
	// so that we typically don't have both, competing effects (high ANMF AND high acidity) 
	
//	CETypeFlag=8 means NH4 below detection limit
//	CETypeFlag=3 means NH4 ~= predicted.  Not very acidic
//	CETypeFlag=10 means NH4 < predicted.  Acidic
//	CETypeFlag=12 means no data
//	CETypeFlag =1 means we use the relative humidity in the calculations
	
	CETypeFlag=0
	for (idex=0;idex<num;idex+=1)

		if(numtype(PredHRNH4_CE1[idex])!=0) 		// typo caught by Will, was PredHRNH4_CE1[p]
			CE_dry[idex] = nan
			CETypeFlag[idex]=12
		
		elseif (PredHRNH4_CE1[idex]<NH4_DetLimit)		// we are below NH4 det limit, use default value

			CE_dry[idex]=varCE_lowNH4	// note that in ann's paper this value is nanned
			CETypeFlag[idex]=8		

		elseif(NH4_MeasToPredict[idex]>=AcidicCutoff)		//   not acidic AcidicCutoff = .75, use ANMF equation.
			// note that if ANMF is *small* CE_dry will be < user default CE = varCE_lowNH4
			// ANMF inflection point is built into Eq4_intercept and Eq4_slope
			//  So a CETypeflag of 3 can either mean use default OR use the equation.
			tempCE=Eq4_intercept+ Eq4_slope*ANMF[idex]
			if (tempCE>varCE_lowNH4)
				CE_dry[idex]=tempCE
				CETypeFlag[idex]=3	// Use ANMF
			else
				CE_dry[idex]=varCE_lowNH4
				CETypeFlag[idex]=4 // Use default
			endif
			
		elseif(NH4_MeasToPredict[idex] <AcidicCutoff)	//   AcidicCutoff = .75
			// if NH4_MeasToPredict is *small* CE_dry will be close to 1
			// Any point in between < AcidicCutoff
			CE_dry[idex]=Eq6_intercept+ Eq6_slope*NH4_MeasToPredict[idex]	
			CETypeFlag[idex]=10

		else 	
			// by default NH4 meas/NH4 precit will always be either >= or < AcidicCutoff
			// so this case just defined where we have nans in time series. 
			CE_dry[idex] = nan
			CETypeFlag[idex]=12
		endif
	endfor
	
	// line below does 2 things.  sets the min CE to varCE_lowNH4 and the max CE to 1
	CE_dry = min(1, (max(varCE_lowNH4,CE_dry)))		// replaced 0.45 with varCE_lowNH4    // retains nans & maximizes values to 1
		
//	For Reference:
//	CE_ANMF by Crosier et al 2007:
//	CE_ANMF = 0.393 + 0.582*ANMF  // where ANMF is calculated ignoring both Org and Chl
//	CE_ANMF by Matthew et al 2008 for pure ANMF:
//	CE_ANMF = ANMF[p]>=0.55 ? 0.24 : 1.0-1.1*ANMF[p])
//	CE_ANMF by Nemitz et al 2011 for EUCAARI :
//	CE_ANMF = ANMF[p]>=0.35 ? 0.5 : need from Eiko Nemtiz (manuscript under preparation)
//	CE_ANMF by Middlebrook et al 2012:
//	CE_ANMF =  ANMF[p]>=0.4 ? 0.45 : 0.0833+0.9167*ANMF[p] identical to max(0.45,0.0833+0.9167*ANMF[p])
			
	if (!ParamIsDefault(RH_SampLine)==1)
		// Apply Equation 7
		HRCE_fPhase=  (Eq7_slopeA*CE_dry + Eq7_interceptA) + ((Eq7_interceptB + Eq7_slopeB*CE_dry)/Eq7_slopeC )*RH_SampLine		// calculate for all values
//		HRCE_fPhase= (  (5*CE_dry -4) + (1  -CE_dry)/20) *RH_SampLine		// calculate for all values
//		HRCE_fPhase= (  (CE_dry -) + (1  -CE_dry)/20) *RH_SampLine		// calculate for all values

		for (idex=0;idex<num;idex+=1)
			if (RH_SampLine[idex]<humidityCutoff || numtype(RH_SampLine[idex]!=0 )	  )	// if dry or we don't have an RH value
				HRCE_fPhase[idex]=CE_dry[idex]
			elseif(numtype(CE_dry[idex])==0)	// aerosol is wet, keep the CEfPhase formulation
				CETypeFlag[idex]=1		//  keep track of when we use the RH correction
			endif
		endfor
	else
		HRCE_fPhase=CE_dry
	endIf
	
End
 
 
//1.52
// Calcs stats and other waves for CDCE panel
Function PK_calcCDCE_extras(UseRH, [RHWave])	// Manjula wanted these plots.  Fig 1 (&2,3) in the supplemental part of middlebrook paper 
variable UseRH
wave RHWave
	
	svar CEStatsStr = root:CE_HR:CEStatsStr
	wave CETypeFlag = root:CE_HR:CETypeFlag
	wave HRCE_fphase = root:HRCE_fphase
	wave ANMF = root:CE_HR:ANMF
	wave NH4_MeasToPredict = root:CE_HR:NH4_MeasToPredict
	wave HRTotal_CE1 = root:CE_HR:HRTotal_CE1

	wave HRChl_CE1 = root:CE_HR:HRChl_CE1
	wave HROrg_CE1 = root:CE_HR:HROrg_CE1
	wave HRNO3_CE1 = root:CE_HR:HRNO3_CE1
	wave HRNH4_CE1 = root:CE_HR:HRNH4_CE1
	wave HRSO4_CE1 = root:CE_HR:HRSO4_CE1
	wave HRChl_CDCE = root:CE_HR:HRChl_CDCE
	wave HROrg_CDCE = root:CE_HR:HROrg_CDCE
	wave HRNO3_CDCE = root:CE_HR:HRNO3_CDCE
	wave HRNH4_CDCE = root:CE_HR:HRNH4_CDCE
	wave HRSO4_CDCE = root:CE_HR:HRSO4_CDCE
	
	make/o/n=(6,2) root:CE_HR:SpeciesStats/wave=SpeciesStats 
	variable var1, numNonNans, lowNH4Val, num, defaultCEvar, delta,startHist
	string tempStr, tempColorStr
	
	WaveStats/q/m=0 HROrg_CE1		// could use any species wave
	numNonNans = V_npnts
	num = numpnts(HROrg_CE1)
	
	defaultCEvar=str2num(getuserdata("HR_CE_panel","","defaultCE") )// number	

	// rows are just like tabs: NH4=0, NO3=1, SO4 = 2, Org = 3, Chl = 4
	//avgCE1=SpeciesStats[tabNum-2][0]
	//avgCDCE=SpeciesStats[tabNum-2][1]

	WaveStats/q/m=0 HRNH4_CE1
	SpeciesStats[0][0]=V_avg/defaultCEvar
	WaveStats/q/m=0 HRNH4_CDCE
	SpeciesStats[0][1]=V_avg
	
	WaveStats/q/m=0 HRNO3_CE1
	SpeciesStats[1][0]=V_avg/defaultCEvar
	WaveStats/q/m=0 HRNO3_CDCE
	SpeciesStats[1][1]=V_avg

	WaveStats/q/m=0 HRSO4_CE1
	SpeciesStats[2][0]=V_avg/defaultCEvar
	WaveStats/q/m=0 HRSO4_CDCE
	SpeciesStats[2][1]=V_avg

	WaveStats/q/m=0 HROrg_CE1
	SpeciesStats[3][0]=V_avg/defaultCEvar
	WaveStats/q/m=0 HROrg_CDCE
	SpeciesStats[3][1]=V_avg

	WaveStats/q/m=0 HRChl_CE1
	SpeciesStats[4][0]=V_avg/defaultCEvar
	WaveStats/q/m=0 HRChl_CDCE
	SpeciesStats[4][1]=V_avg
		
	duplicate/o HRTotal_CE1 root:CE_HR:Org_MassFraction/wave=Org_MassFraction
	Org_MassFraction=HROrg_CE1/HRTotal_CE1
	
	duplicate/o HRTotal_CE1 root:CE_HR:SO4_MassFraction/wave=SO4_MassFraction
	SO4_MassFraction=HRSO4_CE1/HRTotal_CE1

	setDataFolder root:CE_HR
	Make/N=20/O ANMF_Hist, OrgMF_Hist, SO4MF_Hist, Acidity_Hist, Humidity_Hist, NH4_hist, CE_hist

	// ANMF ranges from 0 to 1
	Histogram/B={0,0.05,20} ANMF,ANMF_Hist
	ANMF_Hist/=numNonNans	//  Sum(y)=1
	ANMF_Hist/=0.05		// resulting in Sum(y)*deltax=1     1.52 E James email regarding units
		
	// Org_MassFraction ranges from 0 to 1
	Histogram/B={0,0.05,20} Org_MassFraction,OrgMF_Hist
	OrgMF_Hist/=numNonNans// resulting in Sum(y)=1
	OrgMF_Hist/=0.05		// resulting in Sum(y)*deltax=1     1.52 E James email regarding units
	
	// SO4_MassFraction ranges from 0 to 1
	Histogram/B={0,0.05,20} SO4_MassFraction,SO4MF_Hist	
	SO4MF_Hist/=numNonNans
	SO4MF_Hist/=0.05		// resulting in Sum(y)*deltax=1     1.52 E James email regarding units
		
	// NH4_MeasToPredict can range from 0 to 2 (in theory could be more)
	Histogram/B={0,0.05,40} NH4_MeasToPredict,Acidity_Hist	
	Acidity_Hist/=numNonNans
	Acidity_Hist/=0.05		// resulting in Sum(y)*deltax=1     1.52 E James email regarding units

	// we do CE histogram at the end, after we interpolate
	// HRCE_fphase ranges from user default to 1.  Because HRCE_fphase has been interpolated to all points, we need to divide by numpnts
//	Histogram/B={0.5,0.025,20} HRCE_fphase, CE_hist
//	CE_hist/=num

	lowNH4Val=str2num(getuserdata("HR_CE_panel","","NH4DetLim") )	
	var1 = ceil(Wavemax(HRNH4_CE1))
	var1 = min(var1, num)
	delta =  ceil(var1/(min(0.1,lowNH4Val))  )		// minimum delta is .1 or user set-able lowNH4Val
	startHist=0
	if (WaveMin(HRNH4_CE1)<0)
		delta+=1
		startHist=-lowNH4Val
	endif
	Make/N=(delta)/O NH4_hist
	Histogram/B={startHist,lowNH4Val,delta} HRNH4_CE1,NH4_hist
	NH4_hist/=numNonNans
	NH4_hist/=lowNH4Val  	// resulting in Sum(y)*deltax=1     1.52 E James email regarding units
	
	if (UseRH)		
		// RHWave can range from 0 to 100 (in theory could be more)
		Histogram/B={0,5,20} RHWave,Humidity_Hist
		wavestats/q/m=1 RHWave
		Humidity_Hist/=V_npnts	
		Humidity_Hist/=5  	// resulting in Sum(y)*deltax=1     1.52 E James email regarding units
	else
		Humidity_Hist=nan
	endif
	
	// calculate stats string
	Make/N=14/O root:CE_HR:CETypeFlag_Hist/wave=CETypeFlag_Hist
	Histogram/B={0,1,15} root:CE_HR:CETypeFlag,CETypeFlag_Hist  // not normalized... just get counts of each

	SetDataFolder root:
	ColorTab2Wave dBZ14		// generates M_colors
	wave M_colors = root:M_colors
	
	CEStatsStr=""
	
	CEStatsStr=stringFromList(0,Note(HRTotal_CE1) )	+"\r"	//1.15Q  We could use any wave to attach this note to.

// number values are mostly arbitrary.  They reflect colors we want to use in  dBZ14 to correspond to NO3, etc
//	CETypeFlag=8 means NH4 below detection limit
//	CETypeFlag=3 means NH4 ~= predicted.  Not acidic and ANMF is bigish
//	CETypeFlag=4 means NH4 ~= predicted.  ANMF is small, use default
//	CETypeFlag=13 means NH4 < predicted.  Acidic
//	CETypeFlag=12 means no data
//	CETypeFlag =1 means we use the relative humidity in the calculations

	sprintf tempStr, "%2.1f", 100*CETypeFlag_Hist[8]/numNonNans		// had 8s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[8-1][0])+","+num2str(M_colors[8-1][1])+","+num2str(M_colors[8-1][2])+") "
	CEStatsStr+=tempColorStr+"CETypeFlag=8, "+ "\\K(1,1,1)"+ "Below Min NH4:\t"+tempStr+"%\r"	
	
	sprintf tempStr, "%2.1f", 100*CETypeFlag_Hist[4]/numNonNans		// had 3s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[4-1][0])+","+num2str(M_colors[4-1][1])+","+num2str(M_colors[4-1][2])+") "
	CEStatsStr+= tempColorStr+"CETypeFlag=4, "+"\\K(1,1,1)"+"neutral, low ANMF:\t"+tempStr+"%\r"	

	sprintf tempStr, "%2.1f", 100*CETypeFlag_Hist[3]/numNonNans		// had 3s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[3-1][0])+","+num2str(M_colors[3-1][1])+","+num2str(M_colors[3-1][2])+") "
	CEStatsStr+= tempColorStr+"CETypeFlag=3, "+"\\K(1,1,1)"+"Used ANMF:\t"+tempStr+"%\r"	
	
	sprintf tempStr, "%2.1f", 100*CETypeFlag_Hist[10]/numNonNans		// had 10s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[10-1][0])+","+num2str(M_colors[10-1][1])+","+num2str(M_colors[10-1][2])+") "
	CEStatsStr+= tempColorStr+"CETypeFlag=10, "+"\\K(1,1,1)"+"Acidic:\t"+tempStr+"%\r"
	
	sprintf tempStr, "%2.1f", 100*CETypeFlag_Hist[1]/numNonNans		// had 1s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[1-1][0])+","+num2str(M_colors[1-1][1])+","+num2str(M_colors[1-1][2])+") "
	CEStatsStr+= tempColorStr+"CETypeFlag=1, "+"\\K(1,1,1)"+"RH high:"+tempStr+"%\r"	

	sprintf tempStr, "%d", CETypeFlag_Hist[12]	// had 12s in CETypeFlag
	tempColorStr = "\\K("+num2str(M_colors[12-1][0])+","+num2str(M_colors[12-1][1])+","+num2str(M_colors[12-1][2])+") "
	CEStatsStr+=tempColorStr+"CETypeFlag=12, "+"\\K(1,1,1)"+ "nan pt after step 1."  ///   \\:\r\t\t"+tempStr

	killwaves/z M_colors
	
	// make wave for plotting
	duplicate/o ANMF  root:CE_HR:CEdefault/wave=CEdefault
	CEdefault = str2num(GetUserData("HR_CE_panel", "", "defaultCE" ) )

	// interpolate across time  The values in CETypeFlag can tell you if point was interpolated or not
	wave t_series = root:index:t_series
	gen_InterpolateAcrossTime(t_series,root:HRCE_fphase)	

	Histogram/B={0.5,0.025,20} HRCE_fphase, CE_hist
	CE_hist/=num
	CE_hist/=0.025  // resulting in Sum(y)*deltax=1     1.52 E James email regarding units

	setDataFolder root:

End 


//1.52
// Advanced users panel for setting inflection points for CDCE panel
Function PK_butt_CEAdvPanel(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F AdvUserCEPanel
	if (V_flag)
		return 0
	endif

	NewPanel/N=AdvUserCEPanel /W=(1100,62,1464,400) as "AdvUserCEPanel"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 18,fstyle= 1
	DrawText 26,20,"Advanced Users CE Panel"
	DrawText 4,40,"To correctly set values in this panel, users must be able"
	DrawText 4,54,"to use external measurements of aerosol mass loadings"
	DrawText 4,69,"and to generate plots similar to the non-supplemental"
	DrawText 4,84,"figures in Middlebrook et al."
	SetDrawEnv fsize= 10
	DrawText 10,146,"The inflection point at which aerosol is deemed acidic."
	SetDrawEnv fsize= 10
	DrawText 10,158,"For each point if NH4meas/NH4predict < inflection point acidity correction"
	SetDrawEnv fsize= 10
	DrawText 10,218,"The inflection point at which aerosol is deemed mostly AN."
	SetDrawEnv fsize= 10
	DrawText 10,171,"is applied. Else user defined default CE (Step 4.) is used."
	SetDrawEnv fsize= 10
	DrawText 10,231,"For each point if ANMF > inflection point ANMF correction"
	SetDrawEnv fsize= 10
	DrawText 10,245,"is applied. Else user defined default CE (Step 4.) is used."
	SetDrawEnv fsize= 10
	DrawText 10,287,"The inflection point at which aerosol is deemed to be 'wet'."
	SetDrawEnv fsize= 10
	DrawText 10,300,"For each point if RH > inflection point RH correction is applied."
	SetDrawEnv fsize= 10
	DrawText 10,314,"Else previoulsy calculated CE (CE_dry) is used."
	SetVariable Humidity_inflectionPt,pos={5,257},size={320,16},bodyWidth=50, title="Relative Humidity Inflection Point, %, Default = 80"
	SetVariable Humidity_inflectionPt,value= _NUM:80
	SetVariable Acidity_inflectionPt,pos={5,116},size={320,16},bodyWidth=50, title="Acidity Inflection Point, unitless, Default = 0.75"
	SetVariable Acidity_inflectionPt,value= _NUM:0.75
	SetVariable ANMF_inflectionPt,pos={5,186},size={320,16},bodyWidth=50, title="ANMF Inflection Point, unitless, Default = 0.4545"
	SetVariable ANMF_inflectionPt,value= _NUM:0.4545
	CheckBox checkUseTheseInflPts,pos={5,91},size={341,14},title="Use inflection points below (this panel must remain open)"
	CheckBox checkUseTheseInflPts,fStyle=1,value= 0

	AutoPositionWindow
	
End


// 1.52
// Creates the time series graph of 5 aerosol species with CE = 1 after step 1 is calculated.
Function PK_create_CEis1_TSgraph(ctrlName) : ButtonControl
	String ctrlName
	
	DoWindow/F CEis1_TSgraph
	if (V_flag)
		return 0
	endif
	PauseUpdate; Silent 1	
	Display /W=(35.25,42.5,429.75,251)/N=CEis1_TSgraph as "CEis1_TSgraph"
	AppendToGraph root:CE_HR:HROrg_CE1 vs :index:t_series
	AppendToGraph root:CE_HR:HRNO3_CE1 vs :index:t_series
	AppendToGraph root:CE_HR:HRSO4_CE1 vs :index:t_series
	AppendToGraph root:CE_HR:HRNH4_CE1 vs :index:t_series
	AppendToGraph root:CE_HR:HRChl_CE1 vs :index:t_series
	ModifyGraph lSize=2
	ModifyGraph rgb(HROrg_CE1)=(0,52224,0),rgb(HRNO3_CE1)=(0,0,65535)
	ModifyGraph rgb(HRNH4_CE1)=(65535,43690,0),rgb(HRChl_CE1)=(65280,0,52224)
	ModifyGraph gaps=0
	ModifyGraph zero(left)=1
	ModifyGraph nticks(bottom)=9
	ModifyGraph minor(bottom)=1
	ModifyGraph dateInfo(bottom)={0,1,0}
	Label left "g/m3, CE=1"
	Label bottom " "
	SetAxis/A/E=3 left
End


//1.52
// Link to Middlebrook CDCE paper
//Function pk_CEpaperURL_buttonProc(ctrlName) : ButtonControl
//	String ctrlName
//
//	browseurl /z "http://cires.colorado.edu/jimenez/Papers/2011_AST_Middlebrook_CE.pdf"
//
//End


//1.52
Function PK_CETabProc(ctrlName,tabNum) : TabControl
	String ctrlName
	Variable tabNum

	// don't display anything if we didn't press the calc CD composition button yet.
	wave/z HRNO3_CDCE = root:CE_HR:HRNO3_CDCE		// assume that if this wave exists, all others exist
	if (WaveExists(HRNO3_CDCE) )
		pk_plotCEGrs(tabNum)
	else
//		DoAlert, 1, "You must first calculate the CDCE before viewing graphs."
	endif

End


//1.52
Function PK_plotCEGrs(tabNum)
variable tabNum
		
	variable useRH, avgCE1, avgCDCE
	String SpecStr, tempStr, CE1str, CDCEstr
		
 	SetActiveSubwindow HR_CE_panel
 	
 	useRH = str2num( GetUserData("HR_CE_panel", "", "UseRH" ))
 	gen_Killsubwindows("HR_CE_panel")
 	if ( tabNum>=2 )		// individual species
 		SetActiveSubwindow HR_CE_panel
		
		Display/W=(265,145,692,325)/HOST=HR_CE_panel
		RenameWindow HR_CE_panel#G0, pk_CETSGraph
		pk_populate_CETSGraph()
		SetActiveSubwindow HR_CE_panel
		
		Display/W=(265,20,485,140)/HOST=HR_CE_panel
		RenameWindow  HR_CE_panel#G0,pk_CECorrGraph
		pk_populate_CECorrGraph()
		SetActiveSubwindow HR_CE_panel
		
		wave SpeciesStats = root:CE_HR:SpeciesStats
		// rows are just like tabs: NH4=0, NO3=1, SO4 = 2, Org = 3, Chl = 4
		SpecStr=StringfromList(tabNum-2, "HRNH4;HRNO3;HRSO4;HROrg;HRChl;")
		avgCE1=SpeciesStats[tabNum-2][0]
		avgCDCE=SpeciesStats[tabNum-2][1]
		sprintf CE1str, "%1.2f",avgCE1
		sprintf CDCEstr, "%1.2f",avgCDCE
		tempStr="Def. CE: "+SpecStr+"  Avg = "+CE1str+"\r"
		tempStr+="CDCE: "+SpecStr+"  Avg = "+CDCEstr
		Titlebox titleTSLegendStats title =tempStr
		TitleBox titleTSLegend, title="Gray:CE=user default\r(via mult. offset)\rColors indicate which\rfactor controls CE", disable=0

 	elseif ( tabNum==1 )		// CE stats
 	
		SetActiveSubwindow HR_CE_panel
		
		Display/W=(475,20,610,115)/HOST=HR_CE_panel 
		RenameWindow HR_CE_panel#G0, pk_CEHistGraph
		pk_populate_CEHistGraph()
		SetActiveSubwindow HR_CE_panel

		Display/W=(265,145,615,325)/HOST=HR_CE_panel
		RenameWindow HR_CE_panel#G0,pk_CETSGraph
		pk_populate_CETSGraph()
		SetActiveSubwindow HR_CE_panel

		Titlebox titleTSLegendStats title =""
		wave SpeciesStats = root:CE_HR:SpeciesStats
		tempStr = ""
		TitleBox titleTSLegend, title=tempStr
		
	else		// CE parts histograms
	
		Display/W=(265,25,435,140)/HOST=HR_CE_panel
		RenameWindow HR_CE_panel#G0,NH4DetLimHist		// bottom left
		pk_populate_NH4DetLimHistGraph()
		SetActiveSubwindow HR_CE_panel
	
		Display/W=(440,25,610,140)/HOST=HR_CE_panel
		RenameWindow HR_CE_panel#G0,AcidityHist		// top left
		pk_populate_AcidityHistGraph()
		SetActiveSubwindow HR_CE_panel
	
		Display/W=(265,162,435,287)/HOST=HR_CE_panel
		RenameWindow HR_CE_panel#G0,ANMFOrgMFHist	// top right
		pk_populate_ANMFOrgMFHistGraph()
		SetActiveSubwindow HR_CE_panel
		
		if (UseRH)
			Display/W=(440,162,610,287)/HOST=HR_CE_panel
			RenameWindow HR_CE_panel#G0,RelHumHist		// bottom right
			pk_populate_RelHumHistGraph()
			SetActiveSubwindow HR_CE_panel
		endif
		Titlebox titleTSLegendStats title =""
		TitleBox titleTSLegend, title=""
	endif
			
	Button pk_but_pk_CEHistGraph disable = !( tabNum==1)
	Button pk_but_CETypeFlagLegend disable = !( tabNum==1)

	Titlebox titleCEStats disable = !( tabNum==1)
//	Titlebox titleTSLegend disable = ( tabNum==1)
	Titlebox titleTSLegendStats disable = !( tabNum>=1)

	button pk_but_pk_CECorrGraph disable = !( tabNum>1)
	
	button pk_but_pk_CETSGraph disable = !( tabNum>=1)
	
	Button pk_but_pk_AcidityHistGraph, disable =  tabNum>=1		// top left
	Button pk_but_pk_ANMFOrgMFHistGraph, disable =  tabNum>=1	// top right
	Button pk_but_pk_NH4DetLimHistGraph, disable =  tabNum>=1	// bottom left
	Button pk_but_pk_RelHumHistGraph, disable =  tabNum>=1	// bottom right
	Button pk_but_pk_CEfphaseTable, disable =  tabNum>=1

	if (!useRH)
		Button pk_but_pk_RelHumHistGraph disable=1
	endif
	
	wave/z ANMF_hist = root:CE_HR:ANMF_hist		// any one of several waves could do to check values.
	if (!WaveExists(ANMF_hist))
		button pk_but_pk_CECorrGraph disable =1
		button pk_but_pk_CETSGraph disable = 1
		Titlebox titleTSLegend disable =1
		Titlebox titleTSLegendStats disable =1
		
		Button pk_but_pk_AcidityHistGraph, disable =1	// top left
		Button pk_but_pk_ANMFOrgMFHistGraph, disable =1// top right
		Button pk_but_pk_NH4DetLimHistGraph, disable = 1	// bottom left
		Button pk_but_pk_RelHumHistGraph, disable =1	// bottom right
		Button pk_but_pk_CEfphaseTable, disable = 1	
	endif
	
End


// t series 
Function PK_populate_CETSGraph()

	wave t_series = root:index:t_series

	string species, specColorList

	doWindow/f HR_CE_panel
 	ControlInfo/W=HR_CE_panel tabCE
	Species= S_value

	if (stringmatch("CE Stats", species))  // CE tab.... show CE1 and CDCE
		wave/z Spec_CE1 =$"root:CE_HR:CEdefault"
		wave/z Spec_CDCE = $"root:HRCE_fPhase"
	elseif(stringmatch("Total", species))		// 
		wave/z Spec_CE1 =$"root:CE_HR:ToTal_CE1"
		wave/z Spec_CDCE =$"root:CE_HR:Total_CDCE"
	else
		wave/z Spec_CE1 =$"root:CE_HR:"+species+"_CE1"
		wave/z Spec_CDCE = $"root:CE_HR:"+species+"_CDCE"
	endif
	
	if (!WaveExists(Spec_CE1) || !WaveExists(Spec_CDCE) )
		return 0
		// abort "Perhaps you have changed your todo wave.  Could not find waves "+nameofWave(Spec_CE1) +" or "+nameofWave(Spec_CDCE) +"  aborting from pk_populate_CETSGraph"
	endif
	
	SpecColorList = pk_getColorListSpecies(Species)

	AppendToGraph Spec_CE1 vs t_series
	AppendToGraph Spec_CDCE vs t_series
	
	ModifyGraph lSize($NameofWave(Spec_CE1))=2
	ModifyGraph rgb($NameOfWave(Spec_CE1))=(34816,34816,34816)
	ModifyGraph rgb($NameofWave(Spec_CDCE))=(str2num(stringFromList(0, SpecColorList)) ,str2num(stringFromList(1, SpecColorList)),str2num(stringFromList(2, SpecColorList)))
	
	SetAxis/A/E=1 left
	ModifyGraph gaps=0
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	ModifyGraph zero(left)=1
	ModifyGraph nticks=9
	ModifyGraph minor=1
	ModifyGraph mode=4,marker=19,msize=1,lsize=1
	ModifyGraph dateInfo(bottom)={0,1,0}
	Label left "g/m3,"+Species
	Label bottom " "

	variable defaultCE = str2num(GetUserData("HR_CE_panel", "", "defaultCE" ) )
	if (stringmatch(Species, "CE Stats"))
		SetAxis/A/W=HR_CE_panel#pk_CETSGRAPH left  defaultCE*.9,1
	else
		ModifyGraph offset={0,0},muloffset($NameofWave(Spec_CE1))={0,1/defaultCE}
		SetAxis/A/E=1/W=HR_CE_panel#pk_CETSGRAPH left
	endif
	ModifyGraph 	zColor($NameofWave(Spec_CDCE))={root:CE_HR:CETypeFlag,1,15,dBZ14,0}
 
 End


//  t series correlation
Function PK_populate_CECorrGraph()

	variable minTemp, maxTemp
	string SpecColorList, Species
	
	doWindow/f HR_CE_panel
 	ControlInfo/W=HR_CE_panel tabCE
	Species = S_value

	if (stringmatch("CE", species))  // CE tab.... show CE1 and CDCE
		wave/z Spec_CE1 =$"root:CE_HR:CEdefault"
		wave/z Spec_CDCE = $"root:HRCE_fPhase"
	elseif(stringmatch("Tot", species))		// renamed tab Tot instead of Total to save space
		wave/z Spec_CE1 =$"root:CE_HR:ToTal_CE1"
		wave/z Spec_CDCE =$"root:CE_HR:Total_CDCE"
	else		// CE tab.... show CE1 and CDCE
		wave/z Spec_CE1 =$"root:CE_HR:"+species+"_CE1"
		wave/z Spec_CDCE = $"root:CE_HR:"+species+"_CDCE"
	endif
	
	//1.09A
	if (!WaveExists(Spec_CE1) || !WaveExists(Spec_CDCE) )
		return 0
		// abort "Perhaps you have changed your todo wave.  Could not find waves "+nameofWave(Spec_CE1) +" or "+nameofWave(Spec_CDCE) +"  aborting from pk_populate_CETSGraph"
	endif

	wave/z One2one = root:HR_panel:One2one		//1.07A
	if (!WaveExists(One2One))
		make/o/n=2 root:HR_panel:One2One = {0,1}
		wave One2one = root:HR_panel:One2one		//1.07A
	endif
	
	SpecColorList = pk_getColorListSpecies(Species)

	if (WhichListItem("one2one", TraceNameList(WinName(1, 1), ";", 1 ))<0 )
		AppendToGraph one2one vs one2one
	endif
	AppendToGraph Spec_CDCE vs Spec_CE1
	
	ModifyGraph mode($NameofWave(Spec_CDCE))=2
	ModifyGraph lSize($NameofWave(Spec_CDCE))=2
	ModifyGraph rgb($NameofWave(Spec_CDCE))=(str2num(stringFromList(0, SpecColorList)) ,str2num(stringFromList(1, SpecColorList)),str2num(stringFromList(2, SpecColorList)))
	
	ModifyGraph rgb($NameOfWave(one2one))=(0,0,0)
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	ModifyGraph nticks=9
	ModifyGraph minor=1
	Label bottom "g/m3, CE=user default, "+Species		// +", g/m3"
	Label left "g/m3, CE=CD,  "+Species		// +", g/m3"

	waveStats/q Spec_CDCE
	minTemp = V_min
	maxTemp = V_max 
	waveStats/q Spec_CE1
	minTemp = min(0, min( V_min, minTemp))
	maxTemp = max(V_max, maxTemp)

	if (!stringmatch(Species, "CE Stats"))
		variable defaultCE = str2num(GetUserData("HR_CE_panel", "", "defaultCE" ) )
		ModifyGraph offset={0,0},muloffset(One2One)={maxTemp,(1/defaultCE)*maxTemp}
	endif

	ModifyGraph 	zColor($NameofWave(Spec_CDCE))={root:CE_HR:CETypeFlag,1,14,dBZ14,0}
	
	SetAxis left minTemp,maxTemp
	SetAxis bottom minTemp, maxTemp

End


//1.52
Function PK_populate_CEHistGraph()
	AppendtoGraph root:CE_HR:CE_hist
	ModifyGraph mode=6
	ModifyGraph rgb=(65280,16384,35840)
	Label left "normalized frequency"
	Label bottom "HRCE_fphase"
	ModifyGraph grid=2,gridRGB=(34816,34816,34816)
End


//1.52
Function PK_CE_ButtonProc(ctrlName) : ButtonControl
	String ctrlName

	pk_CreatePhaseDepCE() 		// do the calculations for CDCE

End


//1.52
//Function pk_CEHelpButtonProc(ctrlName) : ButtonControl
//	String ctrlName
//	
//	browseurl /z "http://cires.colorado.edu/jimenez-group/wiki/index.php/ToF-AMS_Analysis_Software#Composition_Dependent_Collection_Efficiency_.28HR_CE_panel.29"
//
//End


//1.52
// Button on CDCE panel for batch table NH4 RIE
Function PK_butt_reviewNH4RIE(ControlName) : ButtonControl
	string controlname

	sq_butt_reviewBatch(ControlName) 
	ModifyTable/W=ReviewBatchTable selection=(5 , 3, 5 , 3, 5,3), topLeftCell=(0,0)

End


//1.52
Function PK_populate_CEfphaseTable() 
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave NH4_MeasToPredict,HRNH4_CE1,CE_dry, CETypeFlag,ANMF
	wave HRCE_fPhase = root:HRCE_fPhase
	
	AppendtoTable CETypeFlag,HRCE_fPhase,ANMF,NH4_MeasToPredict,HRNH4_CE1,CE_dry
	ModifyTable format(Point)=1,width(Point)=51,width(CETypeFlag)=239,title(CETypeFlag)="8=belowMinNH4;3=ANMF;10=acidic;1=UseRH;12=nan"
	ModifyTable sigDigits(HRCE_fPhase)=3,width(HRCE_fPhase)=60,sigDigits(ANMF)=3,width(ANMF)=50
	ModifyTable sigDigits(NH4_MeasToPredict)=3,width(NH4_MeasToPredict)=48,sigDigits(HRNH4_CE1)=3
	ModifyTable width(HRNH4_CE1)=53,sigDigits(CE_dry)=3,width(CE_dry)=51
	SetDataFolder fldrSav0

	variable useRH = str2num( GetUserData("HR_CE_panel", "", "UseRH" ))
	if (useRH)
		string RHWaveStr = GetUserData("HR_CE_panel", "", "RHwave" )
		wave RHwave = $"root:"+RHWaveStr
		AppendToTable RHwave
//		ModifyTable width($NameofWave(RHwave))=44, sigDigits($NameofWave(RHwave))=3
	endif

End


//1.52
Function PK_populate_AcidityHistGraph()

	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave Acidity_Hist
	
	AppendToGraph Acidity_Hist
	variable mymax =WaveMax(acidity_hist)
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	Label left "Normalized Frequency"
	Label bottom "NH4 meas/NH4 predict"
	SetDrawLayer UserBack
	SetDrawEnv xcoord= bottom,ycoord= left,linefgc= (65280,65280,32768),fillpat= 34,fillfgc= (65280,65280,32768),fillbgc= (65280,65280,16384)
	DrawRect 0,0,0.75,mymax		// instead of using .75 perhaps we should attach to humidityCutoff parameter in HRCE_fphase function
	DrawText 0.2,0.2,"is acidic"
End


Function PK_populate_ANMFHistGraph() 		// in Ann's paper but now combined into pk_populate_ANMFOrgMF_hist_graph
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave ANMF_Hist 
	AppendToGraph ANMF_Hist
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	Label left "normalized frequency"
	Label bottom "ANMF"
End


Function PK_populate_OrgMFHistGraph()	// in Ann's paper but now combined into pk_populate_ANMFOrgMF_hist_graph

	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave OrgMF_Hist
	AppendToGraph OrgMF_Hist
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	Label left "normalized frequency"
	Label bottom "Org MF"
End


Function PK_populate_ANMFOrgMFHistGraph() 

	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave ANMF_Hist, OrgMF_Hist, SO4MF_Hist
	AppendToGraph ANMF_Hist, OrgMF_Hist, SO4MF_Hist
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	Label left "normalized frequency"
	Label bottom "ANMF, OrgMF SO4MF"
	ModifyGraph rgb(ANMF_Hist)=(24576,24576,65280),rgb(OrgMF_Hist)=(0,39168,0), rgb(SO4MF_Hist)=(65280,0,0)
End


Function PK_populate_RelHumHistGraph()

	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave Humidity_Hist
	AppendToGraph Humidity_Hist
	variable mymax=WaveMax(humidity_hist)
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	Label left "normalized frequency"
	Label bottom "RH, %"
	SetAxis/A/E=1 left
	SetDrawLayer UserBack
	SetDrawEnv xcoord= bottom,ycoord= left,linefgc= (65280,65280,32768),fillpat= 34,fillfgc= (65280,65280,32768),fillbgc= (65280,65280,16384)
	DrawRect 80,0,100,mymax		// instead of using 80 perhaps we should attach to humidityCutoff parameter in HRCE_fphase function
	DrawText 0.594736842105263,0.160087719298246,"is wet"
End


Function PK_populate_NH4DetLimHistGraph()
	
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:CE_HR:
	wave NH4_hist
	Appendtograph NH4_hist
	SetDataFolder fldrSav0
	ModifyGraph mode=6
	Label left "normalized frequency"
	Label bottom "NH4, CE=1, g/m3"
	ModifyGraph grid=2
	ModifyGraph gridRGB=(34816,34816,34816)
	ModifyGraph rgb=(52224,34816,0)
	variable lowNH4Val=str2num(getuserdata("HR_CE_panel","","NH4DetLim") )	
	lowNH4Val = numtype(lowNH4Val)==0 ? lowNH4Val : 0
	SetDrawLayer UserBack
	SetDrawEnv/W=HR_CE_panel#NH4DetLimHist xcoord= bottom,ycoord= left,linefgc= (65280,65280,32768),fillpat= 34,fillfgc= (65280,65280,32768),fillbgc= (65280,65280,16384)
	DrawRect pnt2x(root:CE_HR:NH4_hist, 0 ),0,lowNH4Val,Wavemax(root:CE_HR:NH4_hist)
	SetAxis/A/E=1 left
	DrawText 0.2,0.2,"<NH4 Min"
	ModifyGraph zero(bottom)=1
	ModifyGraph nticks=9

End


//1.52
// Generates small panel with CDCE flag legend
Function PK_butt_CETypeFlagLegend(ctrlName) : ButtonControl
	String ctrlName

	DoWindow/F CETypeFlag_Legend
	if (V_flag)
		return 0
	endif
	NewPanel/N=CETypeFlag_Legend/W=(150,77,371,166) as "CETypeFlag_Legend"
	TitleBox title0 variable=:CE:CEStatsStr, frame=0,pos={1,1}
	
End


// HR CE end ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


Function PK_butt_HRionTableThis(ctrlName) : ButtonControl
	String ctrlName

//	ctrlName should look like "button_frag_CO2_44"
	string hrion = stringFromList(2, ctrlName, "_")
	variable pos
	wave/t ExactMassText_All = root:HR:ExactMassText_All
	FindValue/text = hrion/txop = 4 ExactMassText_All
	if (V_Value<0)
		abort "Could not find the HR ion entry corresponding to "+hrion +" aborting from pk_butt_fragTableThis"
	endif

	ModifyTable/W=HR_AllMassesTable selection=(V_Value , 5, V_Value , 5, V_Value,5 ), topLeftCell=(V_Value,0)

End


// Function HR_ck_OneSpectraMSorPToF(ctrlName,checked) : CheckBoxControl
//	String ctrlName
//	Variable checked
//

//	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
//	nvar FitEveryPToFGroup = root:HR_panel:FitEveryPToFGroup		//1.14G
//
////	nvar HR_CalcManyRunsOpenClosed = root:HR_panel:HR_CalcManyRunsOpenClosed
//
//	if (stringMatch("HRFit_ck_MS",ctrlName) || stringMatch("HRFit_ck_PToF",ctrlName))
//		HR_singleSpectraMSorPToF = stringMatch("HRFit_ck_MS",ctrlName)

//	endif
//	
////	if (stringMatch("HRTodoFit_ck_ManyRunsOpenClosed", ctrlName) && checked)		//1.14G
////		FitEveryPToFGroup=0 	//1.14G
////	endif
////
////	if (stringMatch("HRTodoFit_ck_EveryPToF", ctrlName) && checked)
////		HR_CalcManyRunsOpenClosed=0 	//1.14G
////	endif
//	
//	string openStr
//	
//	Checkbox HRFit_ck_MS value = HR_singleSpectraMSorPToF==1
//	Checkbox HRFit_ck_PToF value = HR_singleSpectraMSorPToF==0
//	Checkbox HRFit_ck_ePToF value = HR_singleSpectraMSorPToF==2
//	
//	if (HR_singleSpectraMSorPToF==1)
//		Titlebox HRTodoFit_title_Step6MSorPToF title="MS"
//	elseif (HR_singleSpectraMSorPToF==0)		  // PTOF				//1.14G
////		if (HR_CalcManyRunsOpenClosed)
////			ControlInfo HRFit_popup_PToFOpen
////			openStr = S_value
////			ControlInfo HRFit_popup_PToFClosed
////			Titlebox HRTodoFit_title_Step6MSorPToF title="PToF "+openStr+","+S_value 
////		else
//		if(FitEveryPToFGroup)
//			Titlebox HRTodoFit_title_Step6MSorPToF title="Each PToF group"		
//		else
//			ControlInfo HRFit_popup_PToFOpen
//			openStr = S_value
//			Titlebox HRTodoFit_title_Step6MSorPToF title="PToF_"+openStr
//		endif
////		else
////			ControlInfo HRFit_popup_PToFOpen
////			openStr = S_value
////			Titlebox HRTodoFit_title_Step6MSorPToF title="PToF "+openStr
////		endif
//	elseif (HR_singleSpectraMSorPToF==2)		  // ePTOFSum				//1.14G
//		Titlebox HRTodoFit_title_Step6MSorPToF title="ePToFSum"
//	endif
//	
//End


//1.14M


Function PK_PWPH_Table() 
	PauseUpdate; Silent 1		// building window...

	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_sticks:
	Edit/W=(41.25,280.25,669,502.25)/N=PWPH_Diagnostic_tb  as "PWPH_Diagnostic_tb"
	wave PWPHPairNameC,PWPHPairMzC,PWPH_PairDeltaC,PWPHPairRatioC, PWPHPairRatioO,PWPHPairSqrtLargerC,PWPHPairSqrtLargerO
	AppendToTable PWPHPairNameC,PWPHPairMzC,PWPH_PairDeltaC,PWPHPairRatioC
	AppendToTable PWPHPairRatioO,PWPHPairSqrtLargerC,PWPHPairSqrtLargerO
	SetDataFolder fldrSav0
	ModifyTable format(Point)=1,width(Point)=38,title(PWPHPairNameC)="HR ion pair",width(PWPHPairMzC)=57
	ModifyTable title(PWPHPairMzC)="Unit mz",title(PWPH_PairDeltaC)="Peak widths",style(PWPHPairRatioC)=1
	ModifyTable format(PWPHPairRatioC)=3,width(PWPHPairRatioC)=80,title(PWPHPairRatioC)="PH Ratio Closed"
	ModifyTable rgb(PWPHPairRatioC)=(26112,17408,0),style(PWPHPairRatioO)=1,format(PWPHPairRatioO)=3
	ModifyTable width(PWPHPairRatioO)=80,title(PWPHPairRatioO)="PH Ratio Open",rgb(PWPHPairRatioO)=(65280,43520,0)
	ModifyTable format(PWPHPairSqrtLargerC)=3,digits(PWPHPairSqrtLargerC)=1,width(PWPHPairSqrtLargerC)=93
	ModifyTable title(PWPHPairSqrtLargerC)="sqrt(PH) Closed",format(PWPHPairSqrtLargerO)=3
	ModifyTable digits(PWPHPairSqrtLargerO)=1,title(PWPHPairSqrtLargerO)="sqrt(PH) Open"
End


Function PK_PWPH_graph()
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:HR_PeakShape:
	Display /W=(480.75,77.75,830.25,398)/N= PWPH_Diagnostic_gr as "PWPH_Diagnostic_gr"
	wave PerfectGaussY, PerfectGaussX, FinalPeakShape

	wave PWPHPairRatioC =root:HR_sticks:PWPHPairRatioC
	wave PWPH_PairDeltaC =root:HR_sticks:PWPH_PairDeltaC
	wave PWPHPairRatioO =root:HR_sticks:PWPHPairRatioO
	wave PWPH_PairDeltaO =root:HR_sticks:PWPH_PairDeltaO
	wave PWPH_PairDeltaO =root:HR_sticks:PWPH_PairDeltaO
	wave PWPHPairSqrtLargerO =root:HR_sticks:PWPHPairSqrtLargerO
	wave PWPHPairSqrtLargerC =root:HR_sticks:PWPHPairSqrtLargerC

	AppendToGraph PerfectGaussY vs PerfectGaussX 
	AppendToGraph FinalPeakShape
	AppendToGraph FinalPeakShape		// #1
	AppendToGraph FinalPeakShape		// #2
	
	AppendToGraph PWPHPairRatioC vs PWPH_PairDeltaC
	AppendToGraph PWPHPairRatioO vs PWPH_PairDeltaO
	SetDataFolder fldrSav0

	ModifyGraph muloffset(FinalPeakShape#1)={0,0.125},muloffset(FinalPeakShape#2)={0,0.033333}
	ModifyGraph lStyle(FinalPeakShape#1)=2,lStyle(FinalPeakShape#2)=2
	ModifyGraph rgb(FinalPeakShape#2)=(65280,0,0), rgb(FinalPeakShape#1)=(39168,0,0)		// red, brown
	ModifyGraph lsize(FinalPeakShape#1)=2,lsize(FinalPeakShape#2)=2
	ModifyGraph mode(PerfectGaussY)=0,mode(PWPHPairRatioC)=3,mode(PWPHPairRatioO)=3
	ModifyGraph marker(PWPHPairRatioC)=28,marker(PWPHPairRatioO)=25
	ModifyGraph lSize(PerfectGaussY)=3,lSize(FinalPeakShape)=2
	ModifyGraph lStyle(PerfectGaussY)=1
	ModifyGraph rgb(PerfectGaussY)=(47872,47872,47872),rgb(FinalPeakShape)=(0,0,0)
	ModifyGraph msize(PWPHPairRatioC)=3,msize(PWPHPairRatioO)=4
	ModifyGraph zColor(PWPHPairRatioO)={PWPHPairSqrtLargerO,0.1,10,Rainbow, 1}
	ModifyGraph zColor(PWPHPairRatioC)={PWPHPairSqrtLargerC,0.1,10,Rainbow, 1}
	ModifyGraph grid(left)=1,grid(bottom)=2
	ModifyGraph log(left)=1
	ModifyGraph gridRGB=(52224,52224,52224)
	Label left "Declared, normalized peak shape"
	Label bottom "(t - t0)/peak width"
	SetAxis left min(WaveMin(PWPHPairRatioC),WaveMin(PWPHPairRatioO)), 1.05
	SetAxis bottom min(WaveMin(PWPH_PairDeltaO),-4), max(WaveMax(PWPH_PairDeltaO), +4)
	SetAxis left 1e-005,1.05

	ColorScale/C/N=text0/A=RT/X=-5/Y=20 trace=PWPHPairRatioC
	AppendText "sqrt(larger signal)"
	Legend/C/N=text1/J/X=26.76/Y=72.39 "\\s(PWPHPairRatioC) Closed\r\\s(PWPHPairRatioO) Open\r\\s(FinalPeakShape#1) 25% error\r\\s(FinalPeakShape#2) 100% error"

	ShowInfo
End


Function PK_butt_PWPH_diagGraph(ctrlName) : ButtonControl
	String ctrlName

	wave OneRunPeakHeightOpen = root:HR_Sticks:OneRunPeakHeightOpen
	wave OneRunPeakHeightClosed = root:HR_Sticks:OneRunPeakHeightClosed
	
	wave OneRunSqBkStickOpen = root:HR_Sticks:OneRunSqBkStickOpen
	wave OneRunSqBkStickClosed = root:HR_Sticks:OneRunSqBkStickClosed

	PK_CreatePHPW_Diagnostic("O", OneRunPeakHeightOpen, OneRunSqBkStickOpen)
	PK_CreatePHPW_Diagnostic("C", OneRunPeakHeightClosed, OneRunSqBkStickClosed)

	doWindow/F PWPH_Diagnostic_gr
	if (!V_flag)
		PK_PWPH_graph()
	endif
	doWindow/F PWPH_Diagnostic_tb
	if (!V_flag)
		PK_PWPH_Table()
	endif
	
End


//1.15A  Right now we assume that
Function PK_CreatePHPW_Diagnostic(suffix, peakHeight, PeakHeightBaseline)
string suffix
wave peakHeight, PeakHeightBaseline

	wave ExactMassWave = root:HR_Sticks:ExactMassWave
	wave/T ExactMassText = root:HR_Sticks:ExactMassText

 	wave UnitSigma = root:HR_Sticks:UnitSigma
 	wave UnitMass = root:HR_Sticks:UnitMass
 	wave numOfPeaks = root:HR_Sticks:numOfPeaks

	wave rn_series = root:index:rn_series
	nvar HR_RunVar  = root:HR_panel:HR_RunVar
	variable currentRunIndex =sq_FindRun(rn_series, HR_RunVar)
	wave mz_FitIntercept = root:mzFitting:mz_FitIntercept
	wave mz_FitSlope = root:mzFitting:mz_FitSlope
	wave mz_FitPower = root:mzFitting:mz_FitPower
	variable slope, intercept, power
	slope = mz_FitSlope[currentRunIndex]
	intercept = mz_FitIntercept[currentRunIndex]
	power = mz_FitPower[currentRunIndex]

	// waves to hold results
	make/o/n=0  $"root:HR_Sticks:PWPH_PairDelta"+suffix/wave = PWPH_PairDelta
	make/o/n=0   $"root:HR_Sticks:PWPHPairRatio"+suffix/wave = PWPHPairRatio
	make/o/n=0/t  $"root:HR_Sticks:PWPHPairName"+suffix/wave = PWPHPairName
	make/o/n=0   $"root:HR_Sticks:PWPHPairMz"+suffix/wave = PWPHPairMz
	make/o/n=0   $"root:HR_Sticks:PWPHPairSqrtLarger"+suffix/wave = PWPHPairSqrtLarger

	variable idex, minM, maxM, pos, numConsidered, mz, sigma

	minM = round(wavemin(ExactMassWave))
	maxM = round(wavemax(ExactMassWave))

	make/free/o/n=(numpnts(ExactMassWave)) MassTime = intercept + slope*(ExactMassWave[p])^power

	variable prevNumHRConsidered = Sum(numOfPeaks, 0, pos-1)
	for (mz=minM;mz<=maxM;mz+=1)
		pos = mz - UnitMass[0]
 		sigma = UnitSigma[pos]
 		numConsidered = numOfPeaks[pos]
		prevNumHRConsidered = mz==minM ? 0 : Sum(numOfPeaks, 0, pos-1)
		
		make/o/n=(numConsidered) UMRMassTime = MassTime[prevNumHRConsidered+p]
		make/o/n=(numConsidered) UMRPeakHeight = peakHeight[prevNumHRConsidered+p]+abs(PeakHeightBaseline[prevNumHRConsidered+p])  // should flag when baselines < 0 ?
		make/o/n=(numConsidered) UMRMassWave = ExactMassWave[prevNumHRConsidered+p]
		make/t/o/n=(numConsidered) UMRMassText = ExactMassText[prevNumHRConsidered+p]
		make/o/n=(numConsidered) UMRMassUMR = mz

		for (idex=numConsidered-1;idex>=0;idex-=1)
			if (strsearch(UMRMassText[idex], "j", 0)>=0)
				deletepoints idex, 1, UMRMassTime, UMRPeakHeight, UMRMassWave, UMRMassText, UMRMassUMR
			endif
		endfor
	
//		UMRPeakHeight = max(UMRPeakHeight, 1e-6)			// we don't want to divide by zero  // we added the baselines so values should always be >0

		if (numpnts(UMRMassUMR)>1)
			PK_GetLeftRightPairs(sigma, UMRMassText, UMRPeakHeight, UMRMassTime, UMRMassUMR, PWPH_PairDelta, PWPHPairName, PWPHPairRatio,  PWPHPairMz, PWPHPairSqrtLarger )
		endif
	endfor

	killwaves/z UMRMassTime, UMRPeakHeight, UMRMassWave, UMRMassText, UMRMassUMR
End


Function PK_GetLeftRightPairs(peakWidthVal, PeakName, PeakHeight, PeakCenters, PeakUMR, PWPH_PairDelta, PWPHPairName, PWPHPairRatio,  PWPHPairMz, PWPHPairSqrtLarger)
variable peakWidthVal
wave/t PeakName
wave PeakHeight, PeakCenters, PeakUMR
wave  &PWPHPairMz,  &PWPHPairRatio, &PWPHPairSqrtLarger, &PWPH_PairDelta
wave/t &PWPHPairName

	string LeftHR
	variable idex, kdex, numSet, numPairs, ratioVal
	numSet = numpnts(PeakName)
	numPairs = numpnts(PWPH_PairDelta)

	if (numSet<=1)
		return 0
	endif
	LeftHR = PeakName[0]

	insertpoints numPairs, numSet-1, PWPH_PairDelta, PWPHPairName, PWPHPairRatio,  PWPHPairMz, PWPHPairSqrtLarger
	for (idex=0;idex<numSet-1;idex+=1)
		ratioVal = PeakHeight[idex]/ PeakHeight[idex+1]
		if (ratioVal>1)  // the left peak is > right peak
			ratioVal = PeakHeight[idex+1]/PeakHeight[idex]
			PWPH_PairDelta[numPairs+idex] = (PeakCenters[idex+1] - PeakCenters[idex])/peakWidthVal  // x axis value should be negative
			PWPHPairRatio[numPairs+idex] = ratioVal
			PWPHPairName[numPairs+idex] = PeakName[idex] +"_" +PeakName[idex+1]			
			PWPHPairSqrtLarger[numPairs+idex] = sqrt(PeakHeight[idex])
		else  // the right peak is > left peak
			PWPH_PairDelta[numPairs+idex] = (PeakCenters[idex] - PeakCenters[idex+1])/peakWidthVal 
			PWPHPairRatio[numPairs+idex] = ratioVal
			PWPHPairName[numPairs+idex] =  PeakName[idex] +"_" +PeakName[idex+1]				
			PWPHPairSqrtLarger[numPairs+idex] = sqrt(PeakHeight[idex+1])
		endif
		PWPHPairMz[numPairs+idex] =  PeakUMR[idex]
	endfor

End


Function HR_ck_PToFManyGroupFit(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
 	PK_PToFUpdateTitleBox()
	wave/z PToFTodoFit = root:PToF:PToFTodoFit
	if (!checked)
		PToFTodoFit=0
	endif
End


Function/s HR_GetListOfSelPToFGroups()
		
	string idexStr="", str=""
	wave PToFTodoFit = root:PToF:PToFTodoFit
	wave/t PToFDataSetNames = root:PToF:PToFDataSetNames
	variable idex
	for (idex=0;idex<numpnts(PToFDataSetNames);idex+=1)	
		if (PToFTodoFit[idex])
			str +=PToFDataSetNames[idex] + ";"
			idexStr+=num2istr(idex)+ ";"
		endif
	endfor
	return Str+"/"+idexStr

End


Function HRPToF_dataSetListBox(ctrlName,row,col,event) : ListBoxControl
	String ctrlName
	Variable row
	Variable col
	Variable event	//1=mouse down, 2=up, 3=dbl click, 4=cell select with mouse or keys

	nvar FItEveryPToFGroup = root:HR_panel:FItEveryPToFGroup
 	HR_ck_PToFManyGroupFit("",FItEveryPToFGroup)
 	PK_PToFUpdateTitleBox()
  
End


Function PK_PToFUpdateTitleBox()

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
	nvar FitEveryPToFGroup = root:HR_panel:FitEveryPToFGroup		//1.14G
	
	string str
	if (HR_singleSpectraMSorPToF==1)		// fitting MS
		Titlebox HRTodoFit_title_Step6MSorPToF title=""
	elseif (HR_singleSpectraMSorPToF==0)	  	// fitting PToF				//1.16C

		if(FitEveryPToFGroup)
			wave PToFTodoFit = root:PToF:PToFTodoFit
			str= stringFromLIst(0, HR_GetListOfSelPToFGroups(), "/")
			if (strlen(str)>30)
				str = num2str(sum(PToFTodoFit)) +" many PToF data sets"
			endif
			
			Titlebox HRTodoFit_title_Step6MSorPToF title=str
		else
			ControlInfo HRFit_popup_PToFOpen
			if (stringmatch("Get List", S_value))
				FitEveryPToFGroup = 0
				abort "You must select a PToF data set for the analog of the MS Open aborting from PK_PToFUpdateTitleBox"
			endif
			
			Titlebox HRTodoFit_title_Step6MSorPToF title=S_value
		endif
	elseif (HR_singleSpectraMSorPToF==2)	  	// fitting ePToF					//1.16C
		Titlebox HRTodoFit_title_Step6MSorPToF title="ePToFSum"
	endif
End


// new in 1.1E5
Function HR_checkClosenessAdjacentIons()

	wave ExactMassWave = root:HR_sticks:ExactMassWave
	wave/t ExactMassText = root:HR_Sticks:ExactMassText
	wave/t ExactMassText_all = root:HR:ExactMassText_all

	variable idex,num, flag = 0
	string str
	
	variable minMzDistance = 1e-5
	num =numpnts(ExactMassWave)

	duplicate/o/FREE ExactMassWave ExactMassWaveDIFF
	// check for duplicate masses	//1.07C		
	ExactMassWaveDIFF[1,]=ExactMassWave[p]  - ExactMassWave[p-1]		//1.58G
	ExactMassWaveDIFF[0]=1		// any non zero
	do
		wavestats/q/m=1 ExactMassWaveDIFF
		if (V_min< minMzDistance)			// an arbitrarily low value
			flag = 1
			if (strsearch(ExactMassText[V_MinLoc] , "j", 0) >=0 ) 
				ExactMassWaveDIFF[V_MinLoc]=1
				flag = 0
			endif
			if (strsearch(ExactMassText[V_MinLoc-1] , "j", 0) >=0 ) 
				ExactMassWaveDIFF[V_MinLoc]=1
				flag = 0
			endif
						
		endif
	while (V_min< minMzDistance && flag == 0)

	if (flag)			// an arbitrarily low value
		FindValue/TEXT=(ExactMassText[V_MinLoc])/TXOP=7 ExactMassText_all
		
		sq_butt_popThis("HRGrps_HR_AllMassesTable")		
		
		ModifyTable/W=HR_AllMassesTable selection=(V_Value-1, 0 , V_Value-1, 0 , V_Value-1, 0 ), topLeftCell=(V_Value-1 , 0)
		DoAlert 1, "You selected to fit adjacent HR ions that are very close in m/z space to each other near "+ExactMassText[V_MinLoc]+", row "+num2str(V_Value) + " - This can result in Nan values for your HR fits.  Proceed?"
		if (V_flag==2)
			abort "The user chose to abort.  Aborting from HR_checkClosenessAdjacentIons"
		endif
	endif
End


Function HR_UseImprovedAmbientCheckProc(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	nvar HR_elementalImprovedCal = root:HR_panel:HR_elementalImprovedCal

	Button HRResultsE_HROrgCheckPanel disable = !HR_elementalImprovedCal
//	Button HRResultsE_button_oldVsNew disable = !HR_elementalImprovedCal
//	Checkbox HRResultsE_EAAddition  disable = !HR_elementalImprovedCal
	Button HRResultsE_button_EARatios disable = HR_elementalImprovedCal
	Button HRResultsE_button_EARatioDiurn disable = HR_elementalImprovedCal
End


Function HR_ck_OneSpectraMSorPToF(ctrlName,checked) : CheckBoxControl			//1.16z
	String ctrlName
	Variable checked

	nvar HR_singleSpectraMSorPToF = root:HR_panel:HR_singleSpectraMSorPToF
//	nvar FitEveryPToFGroup = root:HR_panel:FitEveryPToFGroup		//1.14G

	strSwitch (ctrlName)
	case "HRFit_ck_MS":
		HR_singleSpectraMSorPToF=1
		break
	case "HRFit_ck_PToF":
		HR_singleSpectraMSorPToF=0
		break
	case "HRFit_ck_ePToFSum":
		HR_singleSpectraMSorPToF=2
		break
	endswitch
		
	Checkbox HRFit_ck_MS value = HR_singleSpectraMSorPToF == 1
	Checkbox HRFit_ck_PToF value = HR_singleSpectraMSorPToF ==0
	Checkbox HRFit_ck_ePToFSum value = HR_singleSpectraMSorPToF ==2
		
	PK_PToFUpdateTitleBox()
End


Function PK_gr_HorizontalGrids()			//1.16z
//	string specStr 		// = "Open", "Closed", or "Diff"
	
	dfref  df=GetDataFolderDFR( )
	SetDataFolder root:HR_Sticks:

	wave OneRunDisplayHRRegion, OneRunRawDiffMz, ExactMassWave, OneRunDisplayVertGrid
	// vertical grids
	AppendToGraph/R OneRunDisplayHRRegion vs OneRunRawDiffMz
	AppendToGraph/R OneRunDisplayVertGrid vs ExactMassWave
	// vertical grid tweaks
	ModifyGraph mode(OneRunDisplayHRRegion)=7
	ModifyGraph rgb(OneRunDisplayHRRegion)=(56576,56576,56576)
	ModifyGraph hbFill(OneRunDisplayHRRegion)=4

	ModifyGraph mode(OneRunDisplayVertGrid)=1
	ModifyGraph rgb(OneRunDisplayVertGrid)=(34816,34816,34816)

	ModifyGraph nticks(right)=0,noLabel(right)=2
	SetAxis right 0,1e-8

	SetDataFolder df

End


Function PK_gr_ResidualTraces() // 1.16
	
	dfref  df=GetDataFolderDFR( )
	SetDataFolder root:HR_Sticks:
	// display raw residuals to residuals axis
	wave OneRunResidSpectraOpen, OneRunResidSpectraDiff, OneRunResidSpectraClosed
	wave OneRunResidPerSpectraOpen, OneRunResidPerSpectraClosed, OneRunResidPerSpectraDiff
	wave OneRunRawDiffMz, OneRunRawOpenMz, OneRunRawClosedMz
	
	AppendToGraph/L=ResidualAxis OneRunResidSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=ResidualAxis OneRunResidSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=ResidualAxis OneRunResidSpectraDiff vs OneRunRawDiffMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraOpen vs OneRunRawOpenMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraClosed vs OneRunRawClosedMz
	AppendToGraph/L=ResidualAxis OneRunResidPerSpectraDiff vs OneRunRawDiffMz
	
	ModifyGraph mode(OneRunResidPerSpectraOpen)=4,msize(OneRunResidPerSpectraOpen)=1
	ModifyGraph mode(OneRunResidPerSpectraClosed)=4, msize(OneRunResidPerSpectraClosed)=1
	ModifyGraph mode(OneRunResidPerSpectraDiff)=4,msize(OneRunResidPerSpectraDiff)=1
	ModifyGraph rgb(OneRunResidPerSpectraDiff)=(65280,0,0)
	ModifyGraph rgb(OneRunResidPerSpectraOpen)=(65280,43520,0)
	ModifyGraph rgb(OneRunResidPerSpectraClosed)=(29168,26112,0)

	ModifyGraph mode(OneRunResidSpectraOpen#1)=4,msize(OneRunResidSpectraOpen#1)=1
	ModifyGraph mode(OneRunResidSpectraClosed#1)=4, msize(OneRunResidSpectraClosed#1)=1
	ModifyGraph mode(OneRunResidSpectraDiff#1)=4,msize(OneRunResidSpectraDiff#1)=1
	ModifyGraph rgb(OneRunResidSpectraDiff#1)=(65280,0,0)
	ModifyGraph rgb(OneRunResidSpectraOpen#1)=(65280,43520,0)
	ModifyGraph rgb(OneRunResidSpectraClosed#1)=(29168,26112,0)

	ModifyGraph zero(ResidualAxis)=1, lblPos(ResidualAxis)=78
	Label ResidualAxis "Resid"
	ModifyGraph axisEnab(ResidualAxis)={0.88,1},freePos(ResidualAxis)={0,bottom}
	ModifyGraph grid(ResidualAxis)=2,gridRGB(ResidualAxis)=(34816,34816,34816),  tick(ResidualAxis)=2

End


Function PK_gr_OneSpecType(specStr)  //1.16Z
	string specStr 		// = "Open", "Closed", or "Diff"
	
	dfref  df=GetDataFolderDFR( )
	SetDataFolder root:HR_Sticks:

	nvar HR_MaxNumGausFits = root:HR_Sticks:HR_MaxNumGausFits
	string axisStr = specStr+"Axis"
	string specL = specStr[0]
	variable idex, specIdex = WhichListItem(specStr, "Diff;Open;Closed")
	variable colorR , colorG, colorB
	string ColorList = "65280,0,0;65280,43520,0;29168,26112,0"
	string ColorStr = stringFromList(specIdex,ColorList)
	variable red=str2num(stringFromList(0,ColorStr, ",")) , green=str2num(stringFromList(1,ColorStr, ",")), blue=str2num(stringFromList(2,ColorStr, ","))
	
	wave OneRunRawXMz = $"OneRunRaw"+specStr+"Mz"
	wave OneRunRawSpectraXBkFt = $"OneRunRawSpectra"+specStr+"BkFt"
	wave OneRunResidSpectraX = $"OneRunResidSpectra"+specStr
	wave OneRunPeakHeightX = $"OneRunPeakHeight"+specStr
	wave OneRunSqBkStickX = $"OneRunSqBkStick"+specStr
	wave OneRunRawSpectraXp = $"OneRunRawSpectra"+specStr+"p"
	wave OneRunSqBkStickX = $"OneRunSqBkStick"+specStr
	wave gridMarks01,gridMarks1,gridMarks10,gridMarks100, gridMarksX
	wave ExactMassWave, GausFit_X

	AppendToGraph/L=$axisStr gridMarks01,gridMarks1,gridMarks10,gridMarks100, vs gridMarksX			// horizontal grids
	Appendtograph/L=$axisStr OneRunRawSpectraXBkFt vs OneRunRawXMz							//squirrel baselines
	AppendToGraph/L=$axisStr OneRunResidSpectraX vs OneRunRawXMz								// display raw residuals to raw axes
	AppendToGraph/L=$axisStr OneRunPeakHeightX vs ExactMassWave									// display peak heights
	AppendtoGraph/l=$axisStr OneRunSqBkStickX vs ExactMassWave									// display squirrel baseline sticks
	AppendToGraph/L=$axisStr OneRunRawSpectraXp vs OneRunRawXMz

	AppendtoGraph/l=$axisStr OneRunSqBkStickX vs ExactMassWave					// handle open minus closed.  need to reappend the squirrel baseline stick values.
	// gaussian shapes diff
	for(idex = 0;idex <HR_MaxNumGausFits; idex+=1)
		AppendToGraph/L=$axisStr $"GausFit_"+specL+"_Y"[][idex] vs GausFit_X
		ModifyGraph rgb($"GausFit_"+specL+"_Y#"+num2str(idex))=(red,green,blue)
	endfor 
	AppendToGraph/L=$axisStr $"GausFit_"+specL+"_Sum_Y" vs GausFit_X; ModifyGraph rgb($"GausFit_"+specL+"_Sum_Y")=(24576,24576,65280)		//blue
	ModifyGraph lstyle($"GausFit_"+specL+"_Sum_Y")=0, lsize($"GausFit_"+specL+"_Sum_Y")=2

	ModifyGraph rgb(gridMarks01)=(34816,34816,34816), rgb(gridMarks1)=(34816,34816,34816),rgb(gridMarks10)=(34816,34816,34816),rgb(gridMarks100)=(34816,34816,34816)
	ModifyGraph lstyle(gridMarks01)=8,lstyle(gridMarks1)=7,lstyle(gridMarks10)=2
	ModifyGraph zero($axisStr)=1,lblPos($axisStr)=78, freePos($axisStr)=0,lblLatPos($axisStr)=0

	ModifyGraph rgb($NameOfWave(OneRunRawSpectraXp))=(0,0,0), mode($NameOfWave(OneRunRawSpectraXp))=4
	ModifyGraph marker($NameOfWave(OneRunRawSpectraXp))=19,  msize($NameOfWave(OneRunRawSpectraXp))=3
//	ModifyGraph mode($NameOfWave(OneRunResidSpectraX))=4, msize($NameOfWave(OneRunResidSpectraX))=1,rgb($NameOfWave(OneRunResidSpectraX))=(65280,0,0)
	ModifyGraph mode($NameOfWave(OneRunResidSpectraX))=4, msize($NameOfWave(OneRunResidSpectraX))=1, rgb($NameOfWave(OneRunResidSpectraX))=(0,0,0)
	ModifyGraph lsize($NameOfWave(OneRunRawSpectraXBkFt))=2,rgb($NameOfWave(OneRunRawSpectraXBkFt))=(red, green, blue)
	ModifyGraph mode($NameofWave(OneRunPeakHeightX))=1,lSize($NameofWave(OneRunPeakHeightX))=3, rgb($NameofWave(OneRunPeakHeightX))=(red, green, blue)
	ModifyGraph rgb($NameofWave(OneRunSqBkStickX))=(red, green, blue), mode($NameofWave(OneRunSqBkStickX))=1,  lsize($NameofWave(OneRunSqBkStickX))=1
//	ModifyGraph rgb(OneRunSqBkStickDiff#1)=(65280,0,0), mode(OneRunSqBkStickDiff#1)=1, lsize(OneRunSqBkStickDiff#1)=1
	ModifyGraph zColor($NameofWave(OneRunPeakHeightX))={root:HR_Sticks:ExactMassColorTable,*,*,directRGB,0}
	ModifyGraph toMode($NameofWave(OneRunPeakHeightX))=3		// make the peak height sticks sit above the baselines

	ModifyGraph msize($NameofWave(OneRunResidSpectraX))=2,mode($NameofWave(OneRunResidSpectraX))=4
	ModifyGraph useMrkStrokeRGB($NameofWave(OneRunResidSpectraX))=1, mrkThick($NameofWave(OneRunResidSpectraX))=2 
	ModifyGraph  mrkStrokeRGB($NameofWave(OneRunResidSpectraX))=(red,green,blue)
	ModifyGraph rgb($NameofWave(OneRunResidSpectraX))=(0,0,0)

	Label $axisStr "\\K("+num2str(red)+","+num2str(green)+","+num2str(blue)+")"+specStr+", Hz/ns"

	SetDataFolder df

End

	
Function PK_gr_OMinusC()		// 1.16Z


	dfref  df=GetDataFolderDFR( )
	SetDataFolder root:HR_Sticks:
	
	wave OneRunPeakHeightOpenMClosed, ExactMassWave
	// OpenMClosed points and error bars
	AppendToGraph/L=DiffAxis OneRunPeakHeightOpenMClosed vs ExactMassWave		// handle open minus closed.  need to reappend the squirrel baseline stick values.
	ModifyGraph toMode(OneRunPeakHeightOpenMClosed)=3
	ModifyGraph mode(OneRunPeakHeightOpenMClosed)=8
	ModifyGraph rgb(OneRunPeakHeightOpenMClosed)=(65280,0,52224)
	ModifyGraph marker(OneRunPeakHeightOpenMClosed)=11
	ErrorBars/T=2/Y=9 OneRunPeakHeightOpenMClosed Y,wave=(root:HR_Sticks:OneRunDiffCountingError,root:HR_Sticks:OneRunDiffCountingError)
	
	SetDataFolder df
End	


Function PK_gr_AllOnePlot()//1.16z
	// axis colors, positions 
	
	ModifyGraph axisEnab(right)={0,0.86}
	ModifyGraph minor(bottom)=1
	ModifyGraph axisEnab(OpenAxis)={0.61,0.86}
	ModifyGraph axisEnab(ClosedAxis)={0.33,0.59}
	ModifyGraph  axisEnab(DiffAxis)={0.05,0.31}
	ModifyGraph margin(left)=50,margin(bottom)=43,margin(top)=7,margin(right)=15,width=432
	ModifyGraph height=396	//1.09H
End


Function PK_gr_AdjustTags()

	nvar HR_ShowAllTags = root:HR_Sticks:HR_ShowAllTags
	SticksGr_AppendChosenMassTags()	
	HR_ShowAllTags=1
	SticksGr_check_ShowAllTags("",1)	

	sq_initializeGlobalNVar("root:HR_sticks:HR_IsoTagsTiny",1)			// plot sticks or rawpopmenu choice
	sq_initializeGlobalNVar("root:HR_sticks:HR_IsoTagsUp",1)			// plot sticks or rawpopmenu choice
	sq_initializeGlobalNVar("root:HR_sticks:HR_FitTagsUp",1)			// plot sticks or rawpopmenu choice
	nvar HR_IsoTagsTiny=root:HR_sticks:HR_IsoTagsTiny
	nvar HR_IsoTagsUp=root:HR_sticks:HR_IsoTagsUp
	nvar HR_FitTagsUp=root:HR_sticks:HR_FitTagsUp
	SticksGr_check_IsoTagsTiny("",HR_IsoTagsTiny)
	SticksGr_check_IsoTagsUp("",HR_IsoTagsUp)
	SticksGr_check_FitTagsUp("",HR_FitTagsUp)
End


Function HR_PeakHeights_gr_Spec(specStr) //1.16z
	string specStr
	
	DoWindow/F $"HR_PeakHeights_gr"+specStr
	if (V_flag)
		return 0
	endif
	
	Display/N=$("HR_PeakHeights_gr"+specStr)  /W=(69.6,51.2,675,532.4) as "HR_PeakHeights_gr"+specStr
	Pk_gr_HorizontalGrids()
	Pk_gr_OneSpecType(specStr)

	nvar HR_DisplayMz = root:HR_Sticks:HR_DisplayMz
	nvar HR_StickGr_amuWidth = root:HR_Sticks:HR_StickGr_amuWidth
	HR_reCenterAmu(HR_DisplayMz,HR_StickGr_amuWidth, specStr=specStr)
//	HR_calcGausFitWaves(HR_DisplayMz)

	nvar HR_ShowLinesBetweenRaw = root:HR_Sticks:HR_ShowLinesBetweenRaw
	wave OneRunRawSpectraXp = $"root:HR_Sticks:OneRunRawSpectra"+specStr+"p"
	ModifyGraph mode($NameofWave(OneRunRawSpectraXp))=3+HR_ShowLinesBetweenRaw

	Pk_gr_AdjustTags()

	if (stringmatch(specStr, "Diff"))
		Pk_gr_OMinusC()
		HR_adjustDiffLabel()	
	endif

End


//1.19E
// returns the row number of the data set if it is within the root:PToF:PToFDataSetNames system,
// that is if it was a data set created via the first step within pika.
// This also means that it is not a PToF difference data set.
Function PK_returnHRPToFInfo(spectraType,HRPToFInfo)
string spectraType			// the data set the user selected from the drop down menu in Pika
wave HRPToFInfo

	if (stringmatch(spectraType[0,1], "HR") )
		return nan // HRPToFInfo
	endif	
	
	variable rowPos, APos, BPos
	wave/t PToFDataSetTodo = root:PToF:PToFDataSetTodo
	wave/t PToFDataSetNames = root:PToF:PToFDataSetNames 
	wave PToFDataSetStartPt = root:PToF:PToFDataSetStartPt 
	wave PToFDataSetStopPt = root:PToF:PToFDataSetStopPt 
	wave/z/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag	
	if (!WaveExists(PToFDataSetMatrixFlag))
		PToF_DataSet_globals()
		wave/i PToFDataSetMatrixFlag= root:PToF:PToFDataSetMatrixFlag
	endif
	
	string Str1,str2,baseStr, rootStr = ReplaceString("PTOF", ReplaceString("Stick", spectraType, ""), "")

	string paramList = "RowPos;startBin;stopBin;MatrixFlag;IsSub;SubRowA;SubRowB;Todo;"
	redimension/n=(ItemsInList(paramList)) HRPToFInfo
	gen_SetDimLabels(HRPToFInfo, 0, paramList)
	HRPToFInfo=nan
		
	FindValue/Text=rootStr/TXOP=4 PToFDataSetNames  //1.21G

	if (V_value<0)		// it could be a PToF data set that had been subtracted
		baseStr = StringFromList(0, rootStr, "_")
		FindValue/Text=baseStr/TXOP=4 PToFDataSetNames
	endif
	
	if (V_value>=0)		// it could be a PToF data set that had been subtracted
		HRPToFInfo[%RowPos] = V_value
		HRPToFInfo[%startBin] = PToFDataSetStartPt[V_value]
		HRPToFInfo[%stopBin] = PToFDataSetStopPt[V_value]
		HRPToFInfo[%MatrixFlag] = PToFDataSetMatrixFlag[V_value]
		Note HRPToFInfo, PToFDataSetTodo[V_value]
		
		if (strsearch(rootStr, "_", 0)>0 )
			Str1 = StringFromList(0,rootStr, "_")
			Str2 = StringFromList(1,rootStr, "_")
			FindValue/Text=Str1/TXOP=4 PToFDataSetNames
			if (V_value<0)		// it could be a PToF data set that had been subtracted
				abort "Could not find the PToF HR data set "+Str1+"from "+rootStr+" Aborting from pk_returnHRPToFInfo"	
			endif
			APos=V_Value
			FindValue/Text=Str2/TXOP=4 PToFDataSetNames
			if (V_value<0)		// it could be a PToF data set that had been subtracted
				abort "Could not find the PToF HR data set "+Str2+" from "+rootStr+" Aborting from pk_returnHRPToFInfo"	
			endif
			BPos=V_Value
			HRPToFInfo[%IsSub] =1 
			HRPToFInfo[%SubRowA] =APos
			HRPToFInfo[%SubRowB] =BPos
		endif
	endif

End


//1.19E
Function PK_Returndtdlogdp(StartBin, StopBin, runPos)
variable StartBin, StopBin,runPos

	nvar cor3_chamber = root:panel:cor3_chamber		 	
	make/free DVa_wave
	sq_GetPToFParams(DVa_wave, runPos)
	return sq_dtdlogdp(cor3_chamber,DVa_wave[%vl],DVa_wave[%vg],DVa_wave[%b],DVa_wave[%t0]+DVa_wave[%step]*(startBin+stopBin)/2)
	
end


Function/s pk_dbase(spectraType, HRPToFInfo, runPos, DiamFlag)		// similar to sq_dbase
string spectraType
wave HRPToFInfo
variable runPos, DiamFlag

	wave/t PToFDataSetNames = root:PToF:PToFDataSetNames
	wave/wave HR_PToFAxes = HR_MakeHRPToFMxXaxis(HRPToFInfo, runPos, "root:PToF")  // HR_PToFDataSetDvaWaves(spectraType,HRPToFInfo, runPos)
	wave myXaxis =HR_PToFAxes[%d_XaxisEdges]
	string name = PToFDataSetNames[HRPToFInfo[%rowPos]]
	name = selectString(DiamFlag,"n", "t" )+name
	duplicate/o myXaxis $"root:" +name  
	return name
End



Function HR_calcplot_PToFSizeDist(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial,  HRPToFMxXaxis)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis

	string Wave2PlotList

	nvar tof1_datatype=root:panel:tof1_datatype
	variable DvaAxis = tof1_datatype==1
	string dwaveStr = "root:"+selectString(DvaAxis, "t","d")+ "_"+StringByKey("spectraType",paramStrPartial)
	nvar tof1_norm=root:panel:tof1_norm
	nvar tof_stats=root:panel:tof_stats
	
	Wave2PlotList = HR_calc_PTOFSizeDist(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis) //[%tCenters], deltaLogDiamCenters_op=HRPToFMxXaxis[%deltalogdEdges] ) 
	
	if (DvaAxis)
		duplicate/o HRPToFMxXaxis[%dCenters], $dwaveStr
	else
		duplicate/o HRPToFMxXaxis[%tCenters], $dwaveStr
	endif
	
	sq_plot_ptof1_av(Wave2PlotList,$dwaveStr, nan, $"",  HRflag=1, specType=spectraType)	

End	
	
		
Function/s HR_calc_PTOFSizeDist(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,HRPToFMxXaxis) // t_PToFCenters, [deltaLogDiamCenters_op])
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis // t_PToFCenters, deltaLogDiamCenters_op

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	nvar tof1_norm=root:panel:tof1_norm
	nvar tof_stats=root:panel:tof_stats
	nvar tof1_datatype=root:panel:tof1_datatype
	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	wave/z todo=$(sq_toDoWvNm)

	variable idex,logop, datatype,baseval, runPos
	variable lowcut, noMSRunsFlag=0	, hiCut
	string deststr="",speclist,prefix="",suffix="",nonSpecNormStr="", SpecNormStr=""
	string d_base, t_base, legendStr="", statsList="", HRSpecDestList
	string MSWavList="", PToFAreaList="",nonSpecParamStr="",	SpecParamStr="", nonHRSpec,nonHRSpecDestList,HRSpec,destList,returnList=""

	variable numSpec

	wave rn_series = root:index:rn_series
	wave/z/i todo=$"root:"+sq_toDoWvNm

	sq_checkPToFparamsSameTodo(todo)

	d_base=stringbykey("d_base",paramStrPartial)
	t_base=stringbykey("t_base",paramStrPartial)
	
	if (tof1_norm && tof1_datatype==2)
		Abort "You cannot normalize to MS data if the diamter axis is X vs PToF - Aborting from Pk_butt_ToFConc"		//1.59D
	endif

	// Check if todo wave has >0 PToF spectra.  We possibly reduce the selected todo wave to run that have PToF (todo = tempTodo)
	wave/z allPToF = root:allPToF	
	if (WaveExists(allPToF))
		sq_create_todo(sq_toDoWvNm+" and allPTOF","TempPToF")
		wave todo = root:TempPToF
		if (numpnts(todo)==0)
			killwaves/z root:tempTodo
			abort "There are no PToF runs in "+sq_toDoWvNm+".  Aborting from Pk_butt_ToFConc"
		endif
	endif
	
	runPos=sq_findrun(rn_series,todo[0])

	if(HR_checkConvertTougm3==1)
		prefix="ug_"
	else
		prefix="sig_"
	endif
	if(tof1_datatype==1)		// ToF time or dXdlogDa vs logDa, NOT PToF
		logop=1
		prefix+="log_"
	endif

	paramStrPartial+= "product_Type:4;" // 5 for image, 6 for avg mass spec
	if(tof1_datatype==1)
		paramStrPartial+="dlog_op:1;t_PToFCenters:"+GetWavesDataFolder(HRPToFMxXaxis[%tCenters],2)+";"  // t_PToFCenters
	endif
	nonSpecParamStr=""
	SpecParamStr=""
	nonHRSpecDestList="";HRSpecDestList=""
	returnList=""

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
	 	HR_getParamStr(nonSpecParamStr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", nonSpecParamStr) 		// slightly confusing notation. HR ions are 'species' in this context 	
		sq_dataDestStr(nonHRSpecDestList,prefix,"av_"+waveNameSuffix,nonHRSpec,0)
		nonHRSpecDestList=ReplaceString("family", nonHRSpecDestList, "fam")	
		returnList=nonHRSpecDestList
		nonSpecParamStr+="specList:"+specList + ";"
		nonSpecParamStr+="destList:"+nonHRSpecDestList + ";"
		nonSpecParamStr+="HRSpec_flag:0;"
		squirrel_fetch(todo,PK_MS_concentration, 	nonSpecParamStr+paramStrPartial, spectraType)
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
	 	HR_getParamStr(SpecParamStr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", SpecParamStr) 	 	
		sq_dataDestStr(HRSpecDestList,prefix,"av_"+waveNameSuffix,HRSpec,0)
		returnList +=HRSpecDestList
		SpecParamStr += "specList:"+specList + ";"
		SpecParamStr += "destList:"+HRSpecDestList+";"		
		SpecParamStr += "HRSpec_flag:1;"
		squirrel_fetch(todo,PK_MS_concentration, SpecParamStr +paramStrPartial, spectraType)
	endif

	if (tof1_norm)	  // is size Dist or image	// section significantly redone in 1.51N
		wave MStodo = sq_getMSWaveForPToFNorm(todo, tof1_norm, noMSRunsFlag)	
		paramStrPartial=replacestringbykey("timeweight_op",paramStrPartial,num2str(3))		//1.51M  timeweight_op 3 is for open + closed time	
		paramStrPartial=replacestringbykey("product_type",paramStrPartial,"0")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial=replacestringbykey("spectraType",paramStrPartial,"HROMinusC")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial=replacestringbykey("PToFFlag",paramStrPartial,"0")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial=replacestringbykey("dlog_op",paramStrPartial,"0")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial=replacestringbykey("dlog_op",paramStrPartial,"0")		// product type 0 is a single value	// 1.51 Change.		// product type 1 is a regular time series  
		paramStrPartial+=pk_ModifyParam4Norm()
		
		if (noMSRunsFlag)
			make/FREE /o/n=(numpnts(rn_series)) PToFtodoMask_temp
			sq_makeMaskFromTodofindRun(PToFtodoMask_temp,todo)					
			PToFtodoMask_temp = numtype(PToFtodoMask_temp[p])==0 ? PToFtodoMask_temp[p] : 0 			
		endif

		if (strlen(nonHRSpec)>0)
			sq_dataDeststr(nonSpecNormStr,"TempNormFactor_","",nonHRSpec,1)			//1.51I    waves will be killed at the end
			nonSpecParamStr=replacestringbykey("destlist",nonSpecParamStr,nonSpecNormStr)
//			print nonSpecParamStr+paramStrPartial
			squirrel_fetch(MStodo,PK_MS_concentration,nonSpecParamStr+paramStrPartial,"HROminusCStick")
			specList = StringByKey("specList", nonSpecParamStr) 	 	
		endif
		if (strlen(HRSpec)>0)
			sq_dataDeststr(SpecNormStr,"TempNormFactor_","",HRSpec,1)			//1.51I    waves will be killed at the end
			SpecParamStr=replacestringbykey("destlist",SpecParamStr,SpecNormStr)
//			print SpecParamStr+paramStrPartial
			squirrel_fetch(MStodo,PK_MS_concentration,SpecParamStr+paramStrPartial,"HROminusCStick")
			specList += StringByKey("specList", SpecParamStr) 
		endif				

		specList = replaceString("/", specList, "")
		nonSpecParamStr+="specList:"+specList + ";"
		sq_PTOFnormTraces(returnList, nonSpecNormStr+SpecNormStr, nonHRSpec+HRSpec, noMSRunsFlag, t_base, d_base, waveNameSuffix, 4, HRPToFMxXaxis[%deltalogdEdges], sq_toDoWvNm, MSWavList, PToFAreaList)
	endif
	
	if (tof_stats && tof1_datatype==1)// Step 7 do PToF stats		 we do this AFTER normalization so that stats will reflect what the user sees
		legendStr=""
		for(idex=0;idex<itemsinlist(returnList,"/");idex+=1)		// for each species
			wave destwav=$stringfromlist(idex,returnList,"/")		// Size distrib or image of one species 
			duplicate/o destwav TempDestWave
			Redimension/n=(1,numpnts(TempDestWave)) TempDestWave		// redimension so that the call to sq_calc_PTOFimage_stats_ln is always passed a 2D wave.
			wave destwav=TempDestWave
			statsList += sq_calc_PTOFimage_stats(destwav, HRPToFMxXaxis[%dEdges], HRPToFMxXaxis[%logdEdges], HRPToFMxXaxis[%deltalogdEdges], sq_toDoWvNm, stringfromlist(idex,speclist,","), updateFlag=(HRResults_graphOutputType==4) ) +"/"   //1.60T	  HRResults_graphOutputType
		endfor		// for each species
		for(idex=0;idex<itemsinlist(statsList);idex+=1)		
			wave statsWave = $stringfromlist(idex,statsList, "/")
			legendStr += stringfromlist(idex,returnList,"/")+ "  Integr. Area: "+num2str(statsWave[0][0]) + "   Mode Diam.: "+num2str(statsWave[0][1]) 
			legendStr += "   Geom. Mean Diam.: "+num2str(statsWave[0][2]) + "   Geom. Std. Dev. : "+num2str(statsWave[0][3]) 
			legendStr += "  \r"
			Killwaves/z statsWave
		endfor
		print legendStr
	endif

	if (strlen(nonHRSpec)==0 && strlen(HRSpec)==0 )
		abort "You must select one or more HR species.  Aborting from HR_calc_PTOFSizeDist"
	endif

//	numSpec=ItemsINList(nonHRSpec+HRSpec, ",")
	
	returnList = replaceString(";", returnList, "")
		
	return returnList

End
				

//1.22A
Function/s pk_ModifyParam4Norm()

	variable numHR = PK_WavesForHRResultsDataSet("HROMinusCStick")		//1.08G	get correct list of HR ions  		//  changed in 1.10C to now also recalculate family designations
	if (numHR>0)
		return "min_cl:0;max_cl:"+num2str(numHR-1)+";"		
	endif
end

		
Function HR_calcplot_PTOFImage(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis

	string ReturnStr, Wave2PlotList, MSWavList, PToFAreaList, statsList
	ReturnStr= HR_calc_PToFImage(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,HRPToFMxXaxis) 
	Wave2PlotList = StringByKey("Wave2PlotList",ReturnStr )
	MSWavList = StringByKey("MSWavList",ReturnStr)
	PToFAreaList = StringByKey("PToFAreaList",ReturnStr)
	statsList = StringByKey("statsList",ReturnStr)

	nvar tof_stats=root:panel:tof_stats
	nvar tof1_norm=root:panel:tof1_norm
	nvar tof1_datatype=root:panel:tof1_datatype
	variable DvaAxis = tof1_datatype==1
	string dwaveStr =ReplaceString("Stick", ReplaceString("PTOF",StringByKey("spectraType",paramStrPartial), ""),"")
	dwaveStr = "root:"+selectString(DvaAxis, "t","d")+ "_"+dwaveStr+"edg"
	
	if (DvaAxis)
		duplicate/o HRPToFMxXaxis[%dEdges], $dwaveStr/wave=dwave
	else
		duplicate/o HRPToFMxXaxis[%tEdges], $dwaveStr/wave=dwave
	endif
	string t_base = StringByKey("t_base",paramStrPartial)	
	if (strlen(t_base)==0)
		wave t_baseWave =root:index:imt_series
		wave/d Centertwave =root:index:t_series
	else
		wave t_baseWave=$("root:"+t_base) // i.e. tmin_10 or custom
		make/d/o/n=(numpnts(t_baseWave)-1) $("root:"+t_base+"C")/wave=Centertwave
		Centertwave = (t_baseWave[P+1]+t_baseWave[P])/2			
	endif
	sq_ValidateImageAxisWave(dwave)
	
	if (tof1_norm)
		sq_plot_ptof1_im(Wave2PlotList,dwave,t_baseWave,SelectString(tof_stats && tof1_datatype,"", statsList), Centertwave=Centertwave, MSNormWaveList=MSWavList, PToFNormWaveList=PToFAreaList, HRflag=1)
	else
		sq_plot_ptof1_im(Wave2PlotList,dwave,t_baseWave,SelectString(tof_stats && tof1_datatype,"", statsList), HRflag=1)
	endif

	nvar HRResults_graphOutputType = root:HR_panel:HRResults_graphOutputType
	variable idex
	string str1
	if (tof_stats && strlen(statsList)>0 && HRResults_graphOutputType!=4)		// PTOF imand and not update
		for(idex=0;idex<itemsinlist(statsList,"/");idex+=1)	// for each	
			str1= CleanUpName("HRPToFStats_"+stringfromlist(idex,Wave2PlotList, "/") ,0 )
			str1 = str1[0, min(strlen(str1)-1, 30)] 
			DoWindow/F $str1
			if (V_flag==0)
				Edit/N=$str1 as str1
				wave statsWave = $stringfromlist(idex,statsList, "/")
				appendtoTable statsWave
				ModifyTable horizontalIndex=2
			endif				
		endfor
	endif
				
End			


// 1.04J, an HR version of the squirrel function
Function HR_pop_getVariable(controlName,popNum,popStr) : PopUpMenuControl
	string controlName
	variable popNum
	string popStr
	
	nvar var=root:HR_panel:$ReplaceString("pop_", controlName, "")
	var=popnum
	popupmenu $controlName mode = popNum		//1.14J  is this necessary?  Pedro was having problems.
			
End


// added in 1.20T
Function/wave HR_RetrievePToFMxVals(MxName)
string MxName

	variable row, idex, numNewbins, numDelta,numOrigBins

	wave/t PToFDataSetNames = root:PToF:PToFDataSetNames
	wave PToFDataSetMatrixFlag = root:PToF:PToFDataSetMatrixFlag
	wave PToFDataSetStartPt = root:PToF:PToFDataSetStartPt
	wave PToFDataSetStopPt = root:PToF:PToFDataSetStopPt
	wave PToFDataSetMaxmz = root:PToF:PToFDataSetMaxmz
	
	FindValue/text=MxName/Txop=4 PToFDataSetNames
	
	if (V_Value<0)
		return $""	
	endif
	row = V_Value
	
	make/n=500/o Mxinfo
	SetDimLabel 0, 0, PToF_DSRow, Mxinfo
	SetDimLabel 0, 1, PToF_DSMxFlag, Mxinfo
	SetDimLabel 0, 2, PToF_DSstartPt, Mxinfo
	SetDimLabel 0, 3, PToF_DSstopPt, Mxinfo
	SetDimLabel 0, 4, PToF_DSMaxMz, Mxinfo
	SetDimLabel 0, 5, PToF_DSnumDelta, Mxinfo
	SetDimLabel 0, 6, PToF_DSnumNewBins, Mxinfo
	SetDimLabel 0, 10, PToF_DSBinNumEdges, Mxinfo
	Mxinfo[%PToF_DSRow]=row
	Mxinfo[%PToF_DSMxFlag] = PToFDataSetMatrixFlag[row]
	Mxinfo[%PToF_DSMaxMz] = PToFDataSetMaxmz[row]
	Mxinfo[%PToF_DSstartPt] = PToFDataSetStartPt[row]
	Mxinfo[%PToF_DSstopPt] = PToFDataSetStopPt[row]
	
	if (PToFDataSetMatrixFlag[row]>0)
		// see gen_GetRedimAvg3D
		numNewbins = PToFDataSetMatrixFlag[row]
		numOrigBins = PToFDataSetStopPt[row] - PToFDataSetStartPt[row]+1
		Mxinfo[%PToF_DSnumNewBins]=numNewbins
		numDelta = floor( numOrigBins/numNewbins)+1
		Mxinfo[%PToF_DSnumDelta] =numDelta
		Mxinfo[10,10+numNewbins-1] = PToFDataSetStartPt[row]+numDelta*(p-10) 
		Mxinfo[10+numNewbins] = PToFDataSetStopPt[row]+1
		// note that if things don't divide nicely the last new bin may be larger than the rest.
		 
	endif
	
	deletepoints 10+numNewbins+1, 500, Mxinfo 
	
	return MxInfo

End


Function pk_butt_mainPikaPanel(ctrlName) : ButtonControl
	String ctrlName
	HR_getHRWin()
End


//  returns a list of waves in the data folder that match the search string
//  if dfstr is the empty string it uses the current data folder 
Function/s gen_GetWaveListInDF(dfStr, searchStr)
string dfStr, searchStr

	dfref df = GetDataFolderDFR( )
	variable validDF = strlen(dfStr)>0 && DataFolderExists(dfStr)
	if (validDF)
		SetDataFolder $dfStr
	endif
	string list = WaveList(searchStr, ";", "")
	SetDataFolder df
	return list
End


// returns a list of text comprising all elements of the list of text waves
Function/s gen_CombineTextWaves2List(textWaveList, [dfStr])
string textWaveList, dfStr

	dfref df = GetDataFolderDFR( )
	variable validDF = !ParamIsDefault(dfStr) && strlen(dfStr)>0 && DataFolderExists(dfStr)
	if (validDF)
		SetDataFolder $dfStr
	endif

	variable idex, num = itemsInList(textWaveList)
	string list = ""
	for(idex=0;idex<num;idex+=1)
		wave/t/z textwave = $StringFromList(idex, textWaveList)
		if (WaveExists(textwave))
			list+=sq_textwave2List(textwave)
		endif
	endfor

	SetDataFolder df
	return list

End


// returns the name of the text wave which has the string Str in it
Function/s gen_FindStrInTextWavesList(Str, textWaveList, [dfStr])
string Str, textWaveList, dfStr

	dfref df = GetDataFolderDFR( )
	variable validDF = !ParamIsDefault(dfStr) && strlen(dfStr)>0 && DataFolderExists(dfStr)
	if (validDF)
		SetDataFolder $dfStr
	endif

	variable idex, num = itemsInList(textWaveList)
	string list = ""
	for(idex=0;idex<num;idex+=1)
		wave/t/z textwave = $StringFromList(idex, textWaveList)
		if (WaveExists(textwave))
			FindValue/Text=str/TXOP=4 textwave
			if (V_Value>=0)
				return StringFromList(idex, textWaveList)
				break
			endif
		endif
	endfor

	SetDataFolder df
	return list

End



Function/s gen_removeListFromList(dups, BigList)
string dups, BigList

	variable idex, num = itemsInLIst(dups)
	for (idex=0;idex<num;idex+=1)
		BigList = RemoveFromList(stringFromList(idex, dups), BigList)
	endfor
	return BigList
End


Function/s gen_sortRemoveDups(List, MassWave)
string &List
wave &MassWave

	variable idex
	make/t/free/n=(itemsInLIst(List)) HRwave = stringFromList(p, List)
	Sort MassWave, MassWave, HRwave
#if(IgorVersion()>7)
	FindDuplicates/INDX=indexWave HRwave
#else
	wave indexWave = gen_findDuplicatesT(HRwave, "myindex")
#endif
	for(idex=numpnts(indexWave)-1;idex>=0;idex-=1)
		DeletePoints indexWave[idex], 1, HRwave, MassWave 
	endfor
	return sq_textwave2List(HRwave)
End


Function/wave gen_findDuplicatesT(twave, indexWaveStr)
wave/t twave
string indexWaveStr

	variable idex, counter=0, num = numpnts(twave)
	string str
	duplicate/t/o/free twave twaveDUP
	make/o/u/n=(num) $indexWaveStr/wave=indexWave
	for(idex=0;idex<num;idex+=1)
		str = twaveDUP[idex]
		if (strlen(str)>0 && idex+1<num)
			do
				FindValue/S=(idex+1)/text=(str)/txop=7 twaveDUP
				if (V_Value>0)
					indexWave[counter]=V_value ; counter+=1
					twaveDUP[V_value]=""
				endif		
			while(V_Value>0)
		endif
	endfor
	deletepoints counter, num, indexWave
	sort indexWave indexWave
	return indexWave
End


Function/s gen_removeEmptiesFromList(List, delim)
string List, delim

	variable idex, num = itemsInList(List, delim)
	for (idex=num-1;idex>=0;idex-=1)
		if (strlen(stringFromList(idex, list, delim))==0)
			list = RemoveListItem(idex, list, delim) 
		endif	
	endfor
	return List
End


Function pk_VerifyMzRange(currentRundex)
variable currentRundex

	wave UnitMass = root:HR_Sticks:UnitMass		// for now we don't know which run we are going to use.... 		//1.11A
	wave mStart = root:diagnostics:mStart		// for now we don't know which run we are going to use.... 		//1.11A
	wave mFinish = root:diagnostics:mFinish		// for now we don't know which run we are going to use.... 		//1.11A
	variable pt, minmax = mFinish[currentRundex]
	if (minmax < UnitMass[numpnts(UnitMass)-1] )		// we deal with PToF and Use Open params
//		abort "Some HR ions that you selected have a m/z value of "+num2str(mFinish[currentRunIndex])+", which is higher than the maximum mz range in the raw spectra."
		DoAlert 1, "Some HR ions that you selected have a nominal m/z value of "+num2str(UnitMass[numpnts(UnitMass)-1])+", which is higher than the maximum mz range in the raw spectra, "+num2str(minmax)+" . Select yes to fit only HR ions in the data range, no to abort."
		if (V_flag==1)		// user pressed yes
			wave/d ExactMassWave_All = root:HR:ExactMassWave_All
 			pt = BinarySearchInterp(ExactMassWave_All, minmax+ 0.5)
			wave/d Mask_Stick_Integration = root:HR:Mask_Stick_Integration
			Mask_Stick_Integration[pt,]=0
			HR_butt_MakeExactMassWaves("")
		else
			Abort
		endif
	endif
	minmax = mStart[currentRundex]
	if (minmax > UnitMass[0] ) //1.19E
		DoAlert 1, "Some HR ions that you selected have a nominal m/z value of "+num2str(UnitMass[0])+", which is less than than the minimum mz range in the raw spectra, "+num2str(minmax)+". Select yes to fit only HR ions in the data range, no to abort."
		if (V_flag==1)		// user pressed yes
			wave/d ExactMassWave_All = root:HR:ExactMassWave_All
 			pt = BinarySearchInterp(ExactMassWave_All, minmax- 0.5)
			wave/d Mask_Stick_Integration = root:HR:Mask_Stick_Integration
			Mask_Stick_Integration[,pt]=0
			HR_butt_MakeExactMassWaves("")
		else
			Abort
		endif
	endif
End

Function HRResults_TabProc(ctrlName,tabNum) : TabControl
	String ctrlName
	Variable tabNum

	string cont_list, cont_item
	variable num, idex, cont_disp
	
	cont_list=ControlNameList("", ";", "HRResults*")
	num=itemsinlist(cont_list)
	for (idex=0;idex<num;idex+=1)
		cont_item=stringfromlist(idex,cont_list)
		strswitch (cont_item[9])
			case "D": 	// Diagnostics
				cont_disp= tabNum!=0
				break
			case "T":	// Time Series
				cont_disp= tabNum!=1
				break
			case "M":	// Average MS
				cont_disp= tabNum!=2
				break
			case "E":	// Elemental Analysis
				cont_disp= tabNum!=3
				break
			case "2":	// 2-D time series
				cont_disp= tabNum!=4
				break
			case "P":	// HR PToF
				cont_disp= tabNum!=5
				break
//			case "D":	// HR CDCE
//				cont_disp= tabNum!=5
//				break
//			case "X":	// HR Export
//				cont_disp= tabNum!=5 // 6
//				break
//			case "P":	// HR PToF
//				cont_disp= tabNum!=6 // 7
//				break
			default:
				cont_disp=-1				
		endswitch
		controlinfo $cont_item
		if (cont_disp>=0 )
			switch (abs(v_flag))
				case 1:
					button $cont_item disable=cont_disp
					break
				case 2:
					checkbox  $cont_item disable=cont_disp
					break
				case 3:
					popupmenu $cont_item disable=cont_disp
					break
				case 4:
					valdisplay $cont_item disable=cont_disp
					break
				case 5:
					setvariable $cont_item disable=cont_disp
					break
				case 9:
					groupbox $cont_item disable=cont_disp
					break
				case 10:
					titlebox $cont_item disable=cont_disp
					break
			endswitch
		endif
	endfor
	if ( tabNum==3 )
		HR_UseImprovedAmbientCheckProc("", 1)
	endif

	return 0
End


Function HR_calcplot_PTOFExport(waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial, HRPToFMxXaxis)
string waveNameSuffix, myPlotName, spectraType, specTypeInitial, paramStrPartial
wave/wave HRPToFMxXaxis

	string Wave2ExportList
	Wave2ExportList = HR_calc_PTOFExport(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial,HRPToFMxXaxis[%tEdges]) 
		
// export Dva
	nvar tof1_datatype=root:panel:tof1_datatype
	variable DvaAxis = tof1_datatype==1
	string dwaveStr =ReplaceString("Stick", ReplaceString("PTOF",StringByKey("spectraType",paramStrPartial), ""),"")
	dwaveStr = "root:"+selectString(DvaAxis-1, "t","d")+ "_"+dwaveStr+"edg"
	if (DvaAxis)
		duplicate/o HRPToFMxXaxis[%dEdges], $dwaveStr/wave=dwave
	else
		duplicate/o HRPToFMxXaxis[%tEdges], $dwaveStr/wave=dwave
	endif

	string t_base = StringByKey("t_base",paramStrPartial)	
	if (strlen(t_base)==0)
		wave t_baseWave =root:index:imt_series
	else
		wave t_baseWave=$("root:"+t_base) // i.e. tmin_10 or custom
	endif

	print "// The following matricies were created from the HR PToF matrix "+dwaveStr+"and placed in the root data folder: "+Wave2ExportList[0, strlen(Wave2ExportList)-2]
	print "// and have the dimensions: time x mass spec x PToF size"
	print "// with run time edges in the wave "+GetWavesDataFolder(t_baseWave,2)+" and the PToF edges in the wave "+GetWavesDataFolder(HRPToFMxXaxis[%tEdges],2)

End			


Function/s HR_calc_PTOFExport(waveNameSuffix, spectraType, specTypeInitial, paramStrPartial, t_PToFCenters)
string waveNameSuffix, spectraType, specTypeInitial, paramStrPartial
wave t_PToFCenters

	svar HRResults_ionList=root:HR_panel:HRResults_ionList
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	nvar tof1_norm=root:panel:tof1_norm
	nvar tof1_datatype=root:panel:tof1_datatype
	nvar HR_checkConvertTougm3=root:HR_panel:HR_checkConvertTougm3
	wave/z todo=$(sq_toDoWvNm)

	variable idex,datatype,logop,ndex,baseval, runPos
	variable lowcut, noMSRunsFlag=0	, hiCut  //1.59D//1.51N
	string paramstr="", deststr="",speclist,prefix="",suffix,normstr=""
	string d_base, t_base, legendStr="", str1, str2, mywinName, statsList=""
	string MSWavList="", PToFAreaList="",nonSpecParamStr="",	SpecParamStr="", nonHRSpec,nonHRSpecDestList,HRSpecDestList,HRSpec,destList,returnList

	variable pos, hasPToF, hasEPToF, num,numSpec

	if(tof1_datatype==1)		// ToF time or dXdlogDa vs logDa, NOT PToF
		logop=1
		prefix="log_"
	else
		prefix="dS_"
	endif

	// Step 2C. Prep for the sq_conc function
	suffix="_3d"
	if(strlen(d_base)>0)
		suffix+="_d"
	endif

	paramStrPartial+= "product_Type:7;"  // 5 for image, 6 for avg mass spec
	paramstr=""
	nonSpecParamStr=""
	SpecParamStr=""; nonHRSpecDestList="";HRSpecDestList=""
	returnList=""

//	for families
	nonHRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 3)		// get list for HR masses and families, not for individual spectra
	if (strlen(nonHRSpec)>0)
	 	HR_getParamStr(nonSpecParamStr,nonHRSpec, 0, 0)		//1.06E
		specList=StringByKey("specList", nonSpecParamStr) 		// slightly confusing notation. HR ions are 'species' in this context 	
		sq_dataDestStr(nonHRSpecDestList,prefix,suffix,nonHRSpec,0)
		nonSpecParamStr+="specList:"+specList + ";"
		nonSpecParamStr+="destList:"+nonHRSpecDestList + ";"
		nonSpecParamStr+="HRSpec_flag:0;"
		nonSpecParamStr+=paramStrPartial
		returnList=nonHRSpecDestList
		squirrel_fetch(todo,PK_MS_concentration, nonSpecParamStr, spectraType)
	endif
 	
	// for HRspecies
	HRSpec = HR_CheckListForHRSpecies(HRResults_ionList, 4)		// get list for HR masses and families, not for individual spectra
	if (strlen(HRSpec)>0)
	 	HR_getParamStr(SpecParamStr,HRSpec, 1, 0)			//1.11G bug, we want to set the MS flag to 1 not zero.	//1.06E
		specList = StringByKey("specList", SpecParamStr) 	 	
		sq_dataDestStr(HRSpecDestList,prefix,suffix,HRSpec,0)
		SpecParamStr += "HRSpec_flag:1;"
		SpecParamStr += "specList:"+specList + ";"
		SpecParamStr += "destList:"+HRSpecDestList+";"		
		SpecParamStr += paramStrPartial
		returnList+=HRSpecDestList
		squirrel_fetch(todo,PK_MS_concentration, SpecParamStr, spectraType)
	endif

	if (strlen(nonHRSpec)==0 && strlen(HRSpec)==0 )
		abort "You must select one or more HR species.  Aborting from HR_calc_PTOFSizeDist"
	endif

	numSpec=ItemsINList(nonHRSpecDestList +HRSpecDestList)
	
	returnList =RemoveFromList(";", returnList, "/")
	
	return returnList

End
